package com.xxh.cloud.healthy.doctor.crm.controller;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.tree.TreeUtils;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorCompanyDeptVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorCompanyVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorDeptVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorCompanyDeptService;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.dev33.satoken.annotation.SaCheckPermission;
import cn.hutool.core.collection.CollUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;

@SaCheckLogin
@Slf4j
@RestController
@RequestMapping("/sys/doctor/crm/dept")
@Api(tags = "医生科室管理")
public class DoctorDeptController {
    
    @Autowired
    private DoctorCompanyDeptService doctorCompanyDeptService;

    @PostMapping("/company2deptTree")
    @ApiOperation("(公司+部门)树")
    // @SaCheckPermission("sys:user:dept:company2deptTree")
    public Result<List<DoctorCompanyDeptVO>> company2deptTree() {
        List<DoctorCompanyDeptVO> list=new ArrayList<>();
        List<DoctorCompanyVO> companyList= doctorCompanyDeptService.doctorCompanyList();
        List<DoctorDeptVO> deptList= doctorCompanyDeptService.doctorDeptList();
        if(CollUtil.isNotEmpty(companyList)){
            companyList.forEach(company->{
                list.add(new DoctorCompanyDeptVO(company.getId(),company.getName(),company.getSort(),company.getPid()));
            });
        }
        if(CollUtil.isNotEmpty(deptList)){
            deptList.forEach(dept->{
                if("0".equals(dept.getPid())){
                    list.add(
                            new DoctorCompanyDeptVO(dept.getId(),dept.getCompanyNo(),dept.getName(),dept.getSort(),dept.getCompanyNo())
                    );
                }else {
                    list.add(
                            new DoctorCompanyDeptVO(dept.getId(),dept.getCompanyNo(),dept.getName(),dept.getSort(),dept.getPid())
                    );
                }
            });
        }

        List<DoctorCompanyDeptVO> data= TreeUtils.build(list);
        return new Result<List<DoctorCompanyDeptVO>>().ok(data);
    }

}
