package com.xxh.cloud.healthy.doctor.crm.client.api.constant;

public class DoctorBehaviorConstant {
    
    // 行为操作一级关联对象类型
    public enum RelOneType {

        Default("default", "默认类型"),
        
        Status_Mark("status_mark", "医生患者状态标记(加入个案管理/忽略)"), // 对应relOneId为crm_doctor_patient_status_mark_info
        
        Task("task", "医生任务"), // 对应relOneId为医生任务id
        
        /**
         * 医生操作标签下用户行为
         */
        Label_Patient("label_patient", "医生操作标签下用户行为"), // 对应id为患者id

        ;
        private String code;
        private String msg;
        private RelOneType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
        
    }

    // 行为操作二级关联对象类型
    public enum RelTwoType {
        
        Track("track", "医生患者跟踪记录(医生给加入个案管理的患者的备注)"), // 对应id为crm_doctor_patient_track_info
        Tel("tel", "打电话通知"), // TODO

        /**
         * 标签下用户列表行为
         */
        Label("label", "标签"), // 对应id为标签id

        ;
        private String code;
        private String msg;
        private RelTwoType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
        
    }
}
