package com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生行为操作信息表
 * </p>
 */
@Data
@TableName("crm_doctor_behavior_info")
public class DoctorBehaviorInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 操作类型
     */
     @ApiModelProperty(value = "操作类型")
      private String operatedType;

    /**
     * 操作一级关联对象类型
     */
     @ApiModelProperty(value = "操作一级关联对象类型")
      private String relOneType;

    /**
     * 操作一级关联对象id
     */
     @ApiModelProperty(value = "操作一级关联对象id")
      private String relOneId;

    /**
     * 操作二级关联对象类型
     */
     @ApiModelProperty(value = "操作二级关联对象类型")
      private String relTwoType;

    /**
     * 操作二级关联对象id
     */
     @ApiModelProperty(value = "操作二级关联对象id")
      private String relTwoId;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容")
      private String operatedContent;

    /**
     * ip
     */
     @ApiModelProperty(value = "ip")
      private String ip;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 创建者
     */
     @ApiModelProperty(value = "创建者")
      private String creator;

    /**
     * 创建时间
     */
     @ApiModelProperty(value = "创建时间")
      private Date createDate;

}
