package com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者备注信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_doctor_patient_remark_info")
public class DoctorPatientRemarkInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 操作一级关联对象类型
     */
     @ApiModelProperty(value = "操作一级关联对象类型")
      private String relOneType;

    /**
     * 操作一级关联对象id
     */
     @ApiModelProperty(value = "操作一级关联对象id")
      private String relOneId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
