package com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者状态标记历史信息表
 * </p>
 */
@Data
@TableName("crm_doctor_patient_status_mark_his_info")
public class DoctorPatientStatusMarkHisInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 医生患者标记ID
     */
     @ApiModelProperty(value = "医生患者标记ID")
      private String doctorPatientMarkId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 目标
     */
     @ApiModelProperty(value = "目标")
      private String targetId;

    /**
     * 目标（旧）
     */
     @ApiModelProperty(value = "目标（旧）")
      private String target;

    /**
     * 新增时间
     */
     @ApiModelProperty(value = "新增时间")
      private Date addTime;

    /**
     * 数据来源分类
     */
     @ApiModelProperty(value = "数据来源分类")
      private String sourceType;

    /**
     * 数据来源ID
     */
     @ApiModelProperty(value = "数据来源ID")
      private String sourceId;

    /**
     * 更新时间
     */
     @ApiModelProperty(value = "更新时间")
      private Date opTime;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUserId;

    /**
     * 操作分类
     */
     @ApiModelProperty(value = "操作分类")
      private String opType;
  
    /**
     * 个案类型，字典定义
     */
     @ApiModelProperty(value = "个案类型，字典定义")
      private String type;

    /**
     * 目标编号
     */
     @ApiModelProperty(value = "目标编号")
      private String targetCode;

    /**
     * 目标执行科室列表
     */
     @ApiModelProperty(value = "目标执行科室列表")
      private String targetExeDeptIds;

    /**
     * 目标执行最大天数
     */
     @ApiModelProperty(value = "目标执行最大天数")
      private Integer targetExeMaxDay;

    /**
     * 目标执行状态
     */
     @ApiModelProperty(value = "目标执行状态")
      private String targetExeStatus;

}
