package com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者状态标记信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_doctor_patient_status_mark_info")
public class DoctorPatientStatusMarkInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 目标
     */
     @ApiModelProperty(value = "目标")
      private String targetId;

    /**
     * 目标（旧）
     */
     @ApiModelProperty(value = "目标（旧）")
      private String target;

    /**
     * 目标的更新时间（进行中/完成/过期）
     */
     @ApiModelProperty(value = "目标的更新时间（进行中/完成/过期）")
      private Date opTime;

    /**
     * 目标的新增时间
     */
     @ApiModelProperty(value = "目标的新增时间")
      private Date addTime;

    /**
     * 数据来源分类
     */
     @ApiModelProperty(value = "数据来源分类")
      private String sourceType;

    /**
     * 数据来源ID
     */
     @ApiModelProperty(value = "数据来源ID")
      private String sourceId;

    /**
     * 重点关注
     */
     @ApiModelProperty(value = "重点关注")
      private String focus;

    /**
     * 个案类型，字典定义
     */
     @ApiModelProperty(value = "个案类型，字典定义")
      private String type;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 目标编号
     */
     @ApiModelProperty(value = "目标编号")
      private String targetCode;

    /**
     * 目标执行科室列表
     */
     @ApiModelProperty(value = "目标执行科室列表")
      private String targetExeDeptIds;

    /**
     * 目标执行最大天数
     */
     @ApiModelProperty(value = "目标执行最大天数")
      private Integer targetExeMaxDay;

    /**
     * 目标执行状态
     */
     @ApiModelProperty(value = "目标执行状态")
      private String targetExeStatus;

}
