package com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生目标配置表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_doctor_target_config_info")
public class DoctorTargetConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 目标编号
     */
     @ApiModelProperty(value = "目标编号")
      private String code;

    /**
     * 目标名称
     */
     @ApiModelProperty(value = "目标名称")
      private String name;

    /**
     * 阶段类型
     */
     @ApiModelProperty(value = "阶段类型")
      private String type;

    /**
     * 目标备注
     */
     @ApiModelProperty(value = "目标备注")
      private String remark;

    /**
     * 目标所属科室
     */
     @ApiModelProperty(value = "目标所属科室")
      private String deptId;

    /**
     * 目标所属病种
     */
     @ApiModelProperty(value = "目标所属病种")
      private String diseaseId;

    /**
     * 规则_目标执行科室列表
     */
     @ApiModelProperty(value = "规则_目标执行科室列表")
      private String exeDeptIds;

    /**
     * 规则_目标执行最大天数
     */
     @ApiModelProperty(value = "规则_目标执行最大天数")
      private Integer exeMaxDay;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
