package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto;

import javax.validation.constraints.NotEmpty;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorBehaviorAddDTO {

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 操作类型
     */
     @ApiModelProperty(value = "操作类型", required = true)
     @NotEmpty(message = "操作类型[operatedType]不能为空")
      private String operatedType;

    /**
     * 操作一级关联对象类型
     */
     @ApiModelProperty(value = "操作一级关联对象类型[DoctorBehaviorConstant.RelOneType]")
      private String relOneType;

    /**
     * 操作一级关联对象id
     */
     @ApiModelProperty(value = "操作一级关联对象id")
      private String relOneId;

    /**
     * 操作二级关联对象类型
     */
     @ApiModelProperty(value = "操作二级关联对象类型[DoctorBehaviorConstant.RelTwoType]")
      private String relTwoType;

    /**
     * 操作二级关联对象id
     */
     @ApiModelProperty(value = "操作二级关联对象id")
      private String relTwoId;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容[前端上报的行为内容，例如更改目标或阶段上传具体的变更内容]")
      private String operatedContent;

    /**
     * ip
     */
     @ApiModelProperty(value = "ip")
      private String ip;

}
