package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorPatientRemarkAddDTO {

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID", required = true)
    @NotEmpty(message = "医生ID[doctorId]不能为空")
    private String doctorId;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号", required = true)
    @NotEmpty(message = "患者编号[patientId]不能为空")
    private String patientId;

    /**
     * 操作一级关联对象类型
     */
    @ApiModelProperty(value = "操作一级关联对象类型[DoctorRemarkConstant.RelOneType]", required = true)
    @NotEmpty(message = "操作一级关联对象类型[relOneType]不能为空")
    private String relOneType;

    /**
     * 操作一级关联对象id
     */
    @ApiModelProperty(value = "操作一级关联对象id", required = true)
    @NotEmpty(message = "操作一级关联对象id[relOneId]不能为空")
    private String relOneId;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注", required = true)
    @NotEmpty(message = "备注[remark]不能为空")
    private String remark;

}
