package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorPatientStatusMarkAddDTO {

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号", required = true)
     @NotEmpty(message = "患者编号[patientId]不能为空")
      private String patientId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID", required = true)
     @NotEmpty(message = "病种ID[diseaseId]不能为空")
      private String diseaseId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID", required = true)
     @NotEmpty(message = "医生ID[doctorId]不能为空")
      private String doctorId;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态", required = true)
     @NotEmpty(message = "状态[status]不能为空")
      private String status;

    /**
     * 目标
     */
     @ApiModelProperty(value = "目标")
      private String targetId;

    /**
     * 目标（旧）
     */
     @ApiModelProperty(value = "目标（旧）")
      private String target;

    /**
     * 数据来源分类
     */
     @ApiModelProperty(value = "数据来源分类")
      private String sourceType;

    /**
     * 数据来源ID
     */
     @ApiModelProperty(value = "数据来源ID")
      private String sourceId;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opUserId;

    /**
     * 个案类型，字典定义
     */
     @ApiModelProperty(value = "个案类型，字典定义")
      private String type;

    /**
     * 目标的新增时间
     */
     @ApiModelProperty(value = "目标的新增时间")
      private Date addTime;

}
