package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.List;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生目标配置表
 * </p>
 */
@Getter
@Setter
public class DoctorTargetConfigUpdateDTO {

    /**
     * id
     */
     @ApiModelProperty(value = "id", required = true)
    @NotEmpty(message = "id[id]不能为空")
      private String id;

    /**
     * 目标编号
     */
     @ApiModelProperty(value = "目标编号")
      private String code;

    /**
     * 阶段类型
     */
    @ApiModelProperty(value = "阶段类型")
    private String type;

    /**
     * 目标名称
     */
     @ApiModelProperty(value = "目标名称")
      private String name;

    /**
     * 目标备注
     */
     @ApiModelProperty(value = "目标备注")
      private String remark;

    /**
     * 目标所属科室
     */
     @ApiModelProperty(value = "目标所属科室")
      private String deptId;

    /**
     * 目标所属病种
     */
     @ApiModelProperty(value = "目标所属病种")
      private String diseaseId;

    /**
     * 规则_目标执行科室列表
     */
     @ApiModelProperty(value = "规则_目标执行科室列表")
      private List<String> exeDeptIds;

    /**
     * 规则_目标执行最大天数
     */
     @ApiModelProperty(value = "规则_目标执行最大天数")
      private Integer exeMaxDay;

}
