package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos;

import java.util.Date;

import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorPatientStatusMarkHisVO {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 医生患者标记ID
     */
    @ApiModelProperty(value = "医生患者标记ID")
    private String doctorPatientMarkId;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 病种ID
     */
    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 目标
     */
    @ApiModelProperty(value = "目标")
    private String targetId;

    /**
     * 目标（旧）
     */
     @ApiModelProperty(value = "目标（旧）")
      private String target;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date opTime;

    /**
     * 新增时间
     */
    @ApiModelProperty(value = "新增时间")
    private Date addTime;

    /**
     * 数据来源分类
     */
    @ApiModelProperty(value = "数据来源分类")
    private String sourceType;

    /**
     * 数据来源ID
     */
    @ApiModelProperty(value = "数据来源ID")
    private String sourceId;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opUserId;

    /**
     * 操作分类
     */
    @ApiModelProperty(value = "操作分类")
    private String opType;

    /**
     * 个案类型，字典定义
     */
    @ApiModelProperty(value = "个案类型，字典定义")
    private String type;

    /**
     * 目标编号
     */
    @ApiModelProperty(value = "目标编号")
    private String targetCode;

    /**
     * 目标名称
     */
    @ApiModelProperty(value = "目标名称")
    private String targetName;

    /**
     * 目标执行科室列表
     */
    @ApiModelProperty(value = "目标执行科室列表")
    private String targetExeDeptIds;

    /**
     * 目标执行最大天数
     */
    @ApiModelProperty(value = "目标执行最大天数")
    private Integer targetExeMaxDay;

    /**
     * 目标执行状态
     */
    @ApiModelProperty(value = "目标执行状态")
    private String targetExeStatus;


    @ApiModelProperty(value = "患者信息")
    private PatientClientBO patientInfo;

    @ApiModelProperty(value = "病种信息")
    private StandardDiseaseBO diseaseInfo;

    @ApiModelProperty(value = "医生信息")
    private AdminUserBO doctorInfo;

    @ApiModelProperty(value = "部门信息")
    private DeptBO deptInfo;

}
