package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos;

import java.util.List;
import java.util.Map;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生目标配置表
 * </p>
 */
@Getter
@Setter
public class DoctorTargetConfigVO extends BaseEntity {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 目标编号
     */
    @ApiModelProperty(value = "目标编号")
    private String code;

    /**
     * 目标名称
     */
    @ApiModelProperty(value = "目标名称")
    private String name;

    /**
     * 阶段类型
     */
    @ApiModelProperty(value = "阶段类型")
    private String type;

    /**
     * 目标备注
     */
    @ApiModelProperty(value = "目标备注")
    private String remark;

    /**
     * 目标所属科室
     */
    @ApiModelProperty(value = "目标所属科室")
    private String deptId;

    @ApiModelProperty(value = "目标所属科室名称")
    private String deptName;

    /**
     * 目标所属病种
     */
    @ApiModelProperty(value = "目标所属病种")
    private String diseaseId;

    @ApiModelProperty(value = "目标所属病种名称")
    private String diseaseName;

    /**
     * 规则_目标执行科室列表
     */
    @ApiModelProperty(value = "规则_目标执行科室列表")
    private List<String> exeDeptIdList;

    /**
     * 规则_目标执行最大天数
     */
    @ApiModelProperty(value = "规则_目标执行最大天数")
    private Integer exeMaxDay;

    /**
     * 规则_目标执行科室列表
     */
    @ApiModelProperty(value = "规则_目标执行科室列表")
    private List<Map<String, String>> exeDeptList;

}
