package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class ManageDoctorPatientStatusMarkVO extends BaseEntity {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 病种ID
     */
    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 目标
     */
    @ApiModelProperty(value = "目标")
    private String targetId;

    /**
     * 目标（旧）
     */
    @ApiModelProperty(value = "目标（旧）")
    private String target;

    /**
     * 目标的更新时间（进行中/完成/过期）
     */
    @ApiModelProperty(value = "目标的更新时间（进行中/完成/过期）")
    private Date opTime;

    /**
     * 目标的新增时间
     */
    @ApiModelProperty(value = "目标的新增时间")
    private Date addTime;

    /**
     * 数据来源分类
     */
    @ApiModelProperty(value = "数据来源分类")
    private String sourceType;

    /**
     * 数据来源ID
     */
    @ApiModelProperty(value = "数据来源ID")
    private String sourceId;

    /**
     * 重点关注
     */
    @ApiModelProperty(value = "重点关注")
    private String focus;

    /**
     * 个案类型，字典定义
     */
    @ApiModelProperty(value = "个案类型，字典定义")
    private String type;

    /**
     * 目标编号
     */
    @ApiModelProperty(value = "目标编号")
    private String targetCode;

    /**
     * 目标名称
     */
    @ApiModelProperty(value = "目标名称")
    private String targetName;

    /**
     * 目标执行科室列表
     */
    @ApiModelProperty(value = "目标执行科室列表")
    private String targetExeDeptIds;

    /**
     * 目标执行最大天数
     */
    @ApiModelProperty(value = "目标执行最大天数")
    private Integer targetExeMaxDay;

    /**
     * 目标执行状态
     */
    @ApiModelProperty(value = "目标执行状态")
    private String targetExeStatus;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "患者年龄")
    private String patientAge;

    @ApiModelProperty(value = "患者性别")
    private String patientSex;

    @ApiModelProperty(value = "患者最新数据信息")
    private DataDwsPatientDataLastDateBO patientDataLastDateInfo;

    @ApiModelProperty(value = "病种信息")
    private String diseaseName;

    @ApiModelProperty(value = "医生信息")
    private String doctorName;

    @ApiModelProperty(value = "部门信息")
    private String deptName;

    /**
     * 目标完成的依据
     */
    @ApiModelProperty(value = "患者挂号信息")
    private List<Map<String, Object>> registerDataList;
    
    @ApiModelProperty(value = "患者就诊信息")
    private List<Map<String, Object>> visitDataList;
    
    @ApiModelProperty(value = "患者住院信息")
    private List<Map<String, Object>> inHospitalDataList;
    
    @ApiModelProperty(value = "患者出院信息")
    private List<Map<String, Object>> outHospitalDataList;
    
    @ApiModelProperty(value = "患者手术信息")
    private List<Map<String, Object>> operationDataList;
    
    @ApiModelProperty(value = "患者检查信息")
    private List<Map<String, Object>> examineDataList;
    
    @ApiModelProperty(value = "患者检验信息")
    private List<Map<String, Object>> laboratoryDataList;
}
