package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.helper;

import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorBehaviorBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorPatientStatusMarkBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorTargetConfigBO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorBehaviorInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientRemarkInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkHisInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientTrackInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorTargetConfigInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorBehaviorVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientRemarkVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientStatusMarkHisVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientStatusMarkVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientTrackVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetConfigVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.ManageDoctorPatientStatusMarkHisVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.ManageDoctorPatientStatusMarkVO;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

public class DoctorPatientHelper {

    public static String getDoctorPatientStatusMarkInfo(){
        return StrUtil.format("DPSM{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorPatientStatusMarkHisInfo(){
        return StrUtil.format("DPSMH{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorPatientTrackInfo(){
        return StrUtil.format("DPT{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorBehaviorInfo(){
        return StrUtil.format("DB{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorPatientRemarkInfo(){
        return StrUtil.format("DPR{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorTargetConfigInfo(){
        return StrUtil.format("DTC{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static DoctorPatientStatusMarkVO getDoctorPatientStatusMarkVO(DoctorPatientStatusMarkInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorPatientStatusMarkVO vo = new DoctorPatientStatusMarkVO();
        vo.setId(entity.getId());
        vo.setPatientId(entity.getPatientId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setTargetId(entity.getTargetId());
        vo.setTarget(entity.getTarget()); // （旧）
        vo.setStatus(entity.getStatus());
        vo.setAddTime(entity.getAddTime());
        vo.setSourceType(entity.getSourceType());
        vo.setSourceId(entity.getSourceId());
        vo.setOpTime(entity.getOpTime());
        vo.setFocus(entity.getFocus());
        vo.setType(entity.getType());
        vo.setTargetCode(entity.getTargetCode());
        vo.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        vo.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        vo.setTargetExeStatus(entity.getTargetExeStatus());

        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static DoctorPatientStatusMarkHisVO getDoctorPatientStatusMarkHisVO(DoctorPatientStatusMarkHisInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorPatientStatusMarkHisVO vo = new DoctorPatientStatusMarkHisVO();
        vo.setId(entity.getId());
        vo.setDoctorPatientMarkId(entity.getDoctorPatientMarkId());
        vo.setPatientId(entity.getPatientId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setTargetId(entity.getTargetId());
        vo.setTarget(entity.getTarget()); // （旧）
        vo.setStatus(entity.getStatus());
        vo.setAddTime(entity.getAddTime());
        vo.setSourceType(entity.getSourceType());
        vo.setSourceId(entity.getSourceId());
        vo.setOpTime(entity.getOpTime());
        vo.setOpUserId(entity.getOpUserId());
        vo.setType(entity.getType());

        vo.setTargetCode(entity.getTargetCode());
        vo.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        vo.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        vo.setTargetExeStatus(entity.getTargetExeStatus());
        return vo;
    }

    public static DoctorPatientStatusMarkBO getDoctorPatientStatusMarkBO(DoctorPatientStatusMarkVO vo) {
        if (null == vo) {
            return null;
        }
        DoctorPatientStatusMarkBO bo = new DoctorPatientStatusMarkBO();
        bo.setId(vo.getId());
        bo.setPatientId(vo.getPatientId());
        bo.setDoctorId(vo.getDoctorId());
        bo.setDiseaseId(vo.getDiseaseId());
        bo.setTargetId(vo.getTargetId());
        bo.setTarget(vo.getTarget()); // （旧）
        bo.setStatus(vo.getStatus());
        bo.setAddTime(vo.getAddTime());
        bo.setSourceType(vo.getSourceType());
        bo.setSourceId(vo.getSourceId());
        bo.setOpTime(vo.getOpTime());
        bo.setFocus(vo.getFocus());
        bo.setType(vo.getType());

        bo.setTargetCode(vo.getTargetCode());
        bo.setTargetExeDeptIds(vo.getTargetExeDeptIds());
        bo.setTargetExeMaxDay(vo.getTargetExeMaxDay());
        bo.setTargetExeStatus(vo.getTargetExeStatus());
        return bo;
    }

    public static DoctorPatientTrackVO getDoctorPatientTrackVO(DoctorPatientTrackInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorPatientTrackVO vo = new DoctorPatientTrackVO();
        vo.setId(entity.getId());
        vo.setPatientId(entity.getPatientId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setDoctorPatientMarkId(entity.getDoctorPatientMarkId());
        vo.setContent(entity.getContent());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static DoctorBehaviorVO getDoctorBehaviorVO(DoctorBehaviorInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorBehaviorVO vo = new DoctorBehaviorVO();
        vo.setId(entity.getId());
        vo.setOperatedType(entity.getOperatedType());
        vo.setOperatedContent(entity.getOperatedContent());
        vo.setDoctorId(entity.getDoctorId());
        vo.setRelOneType(entity.getRelOneType());
        vo.setRelOneId(entity.getRelOneId());
        vo.setRelTwoType(entity.getRelTwoType());
        vo.setRelTwoId(entity.getRelTwoId());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        return vo;
    }

    public static DoctorPatientRemarkVO getDoctorPatientRemarkVO(DoctorPatientRemarkInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorPatientRemarkVO vo = new DoctorPatientRemarkVO();
        vo.setId(entity.getId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setPatientId(entity.getPatientId());
        vo.setRelOneType(entity.getRelOneType());
        vo.setRelOneId(entity.getRelOneId());
        vo.setRemark(entity.getRemark());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static DoctorTargetConfigVO getDoctorTargetConfigVO(DoctorTargetConfigInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorTargetConfigVO vo = new DoctorTargetConfigVO();
        vo.setId(entity.getId());
        vo.setCode(entity.getCode());
        vo.setName(entity.getName());
        vo.setType(entity.getType());
        vo.setRemark(entity.getRemark());
        vo.setDeptId(entity.getDeptId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setExeMaxDay(entity.getExeMaxDay());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        
        String exeDeptIds = entity.getExeDeptIds();
        if (StrUtil.isNotBlank(exeDeptIds)) {
            vo.setExeDeptIdList(StrJoinSplitUtils.split2List(exeDeptIds));
        }
        return vo;
    }

    public static DoctorTargetConfigBO getDoctorTargetConfigBO(DoctorTargetConfigVO vo) {
        if (null == vo) {
            return null;
        }
        DoctorTargetConfigBO bo = new DoctorTargetConfigBO();
        bo.setId(vo.getId());
        bo.setCode(vo.getCode());
        bo.setName(vo.getName());
        bo.setType(vo.getType());
        bo.setRemark(vo.getRemark());
        bo.setDeptId(vo.getDeptId());
        bo.setDiseaseId(vo.getDiseaseId());
        bo.setExeMaxDay(vo.getExeMaxDay());
        bo.setExeDeptIdList(vo.getExeDeptIdList());
        return bo;
    }

    public static ManageDoctorPatientStatusMarkVO getManageDoctorPatientStatusMarkVO(DoctorPatientStatusMarkInfo entity) {
        if (null == entity) {
            return null;
        }
        ManageDoctorPatientStatusMarkVO vo = new ManageDoctorPatientStatusMarkVO();
        vo.setId(entity.getId());
        vo.setPatientId(entity.getPatientId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setTargetId(entity.getTargetId());
        vo.setTarget(entity.getTarget()); // （旧）
        vo.setStatus(entity.getStatus());
        vo.setAddTime(entity.getAddTime());
        vo.setSourceType(entity.getSourceType());
        vo.setSourceId(entity.getSourceId());
        vo.setOpTime(entity.getOpTime());
        vo.setFocus(entity.getFocus());
        vo.setType(entity.getType());
        vo.setTargetCode(entity.getTargetCode());
        vo.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        vo.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        vo.setTargetExeStatus(entity.getTargetExeStatus());

        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static ManageDoctorPatientStatusMarkHisVO getManageDoctorPatientStatusMarkHisVO(DoctorPatientStatusMarkHisInfo entity) {
        if (null == entity) {
            return null;
        }
        ManageDoctorPatientStatusMarkHisVO vo = new ManageDoctorPatientStatusMarkHisVO();
        vo.setId(entity.getId());
        vo.setDoctorPatientMarkId(entity.getDoctorPatientMarkId());
        vo.setPatientId(entity.getPatientId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setTargetId(entity.getTargetId());
        vo.setTarget(entity.getTarget()); // （旧）
        vo.setStatus(entity.getStatus());
        vo.setAddTime(entity.getAddTime());
        vo.setSourceType(entity.getSourceType());
        vo.setSourceId(entity.getSourceId());
        vo.setOpTime(entity.getOpTime());
        vo.setOpUserId(entity.getOpUserId());
        vo.setType(entity.getType());

        vo.setTargetCode(entity.getTargetCode());
        vo.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        vo.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        vo.setTargetExeStatus(entity.getTargetExeStatus());
        return vo;
    }

    public static DoctorBehaviorBO getDoctorBehaviorBO(DoctorBehaviorVO vo) {
        if (null == vo) {
            return null;
        }
        DoctorBehaviorBO bo = new DoctorBehaviorBO();
        bo.setId(vo.getId());
        bo.setDoctorId(vo.getDoctorId());
        bo.setOperatedType(vo.getOperatedType());
        bo.setRelOneType(vo.getRelOneType());
        bo.setRelOneId(vo.getRelOneId());
        bo.setRelTwoType(vo.getRelTwoType());
        bo.setRelTwoId(vo.getRelTwoId());
        bo.setOperatedContent(vo.getOperatedContent());
        bo.setIp(vo.getIp());
        bo.setCreator(vo.getCreator());
        bo.setCreateDate(vo.getCreateDate());
        return bo;
    }

}
