package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorBehaviorInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorBehaviorDataCountVO;

public interface DoctorBehaviorDataBizMapper {
    
    /**
     * 分组查询医生id信息
     * 
     * type为空统计所有数量，type不为空统计operated_type=type的数量
     */
    
    @Select(" SELECT a.doctor_id AS doctorId, COUNT(IF(#{type} = '' OR operated_type = #{type},'1',NULL)) count " + 
            " FROM crm_doctor_behavior_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id " +
            " ORDER BY count ${order} ")
    IPage<Map<String, Object>> getDoctorPage(Page<DoctorBehaviorInfo> page, @Param(Constants.WRAPPER) Wrapper<DoctorBehaviorInfo> wrapper, @Param("type") String type, @Param("order") String order);


    /**
     * 根据行为类型分组查询医生行为数量信息
     */
    @Select(" SELECT a.doctor_id AS doctorId, a.operated_type AS type, COUNT(1) count " + 
            " FROM crm_doctor_behavior_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.operated_type ")
    List<DoctorBehaviorDataCountVO> getDoctorBehaviorDataCount(@Param(Constants.WRAPPER) Wrapper<DoctorBehaviorInfo> wrapper);

    /**
     * 根据行为类型、关联对象分组查询医生行为数量信息
     */
    @Select(" SELECT a.doctor_id AS doctorId, a.rel_one_type AS relOneType, a.rel_one_id AS relOneId, a.operated_type AS type, COUNT(1) count " + 
            " FROM crm_doctor_behavior_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.rel_one_type, a.rel_one_id, a.operated_type ")
    List<DoctorBehaviorDataCountVO> getDoctorPatientBehaviorDataCount(@Param(Constants.WRAPPER) Wrapper<DoctorBehaviorInfo> wrapper);

    /**
     * 第一次行为信息及时间
     */
    @Select(" SELECT a.doctor_id, a.rel_one_id, a.rel_two_id, MIN(a.create_date) createDate " + 
            " FROM crm_doctor_behavior_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.rel_one_id, a.rel_two_id ")
    DoctorBehaviorInfo firstSimple(@Param(Constants.WRAPPER) Wrapper<DoctorBehaviorInfo> wrapper);

    @Select(" SELECT a.doctor_id, a.rel_one_id, a.rel_two_id, MIN(a.create_date) createDate " + 
            " FROM crm_doctor_behavior_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.rel_one_id, a.rel_two_id ")
    List<DoctorBehaviorInfo> firstSimpleList(@Param(Constants.WRAPPER) Wrapper<DoctorBehaviorInfo> wrapper);

}