package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkHisInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientStatusMarkTargetCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountTrendVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountWithDoctorVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetTotalCountVO;

public interface DoctorStatusMarkDataBizMapper {
    
    @Select(" SELECT a.doctor_id AS doctorId, a.target AS target, COUNT(1) count " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.target ")
    List<DoctorPatientStatusMarkTargetCountVO> getTargetCountListV1(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT a.doctor_id AS doctorId, a.target_id AS targetId, COUNT(1) count " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id, a.target_id ")
    List<DoctorPatientStatusMarkTargetCountVO> getTargetCountList(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT a.target_id AS targetId, a.target_code AS targetCode, b.name AS targetName, COUNT(1) count " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.target_id, a.target_code, b.name ")
    List<DoctorTargetCountVO> getTargetCount(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT a.target_id AS targetId, a.target_code AS targetCode, b.name AS targetName, COUNT(1) count " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.target_id, a.target_code, b.name ")
    List<DoctorTargetCountVO> getTargetHisCount(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkHisInfo> wrapper);

    @Select(" SELECT COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " ${ew.customSqlSegment} ")
    DoctorTargetTotalCountVO getTargetCountNoGroup(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " ${ew.customSqlSegment} ")
    DoctorTargetTotalCountVO getTargetHisCountNoGroup(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkHisInfo> wrapper);

    @Select(" SELECT a.doctor_id AS doctorId, COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id ")
    List<DoctorTargetCountWithDoctorVO> getTargetCountByDoctor(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT a.doctor_id AS doctorId, COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id ")
    List<DoctorTargetCountWithDoctorVO> getTargetHisCountByDoctor(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkHisInfo> wrapper);

    @Select(" SELECT COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} ")
    DoctorTargetTotalCountVO getTargetCountWithStageType(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT COUNT(1) totalCount, COUNT(IF(status = 'normal' AND target_exe_status = 'done',1,null)) doneCount, COUNT(IF(status = 'normal' AND target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(status = 'normal' AND target_exe_status = 'expire',1,null)) expireCount, COUNT(IF(status = 'abandon',1,null)) ignoreCount  " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} ")
    DoctorTargetTotalCountVO getTargetHisCountWithStageType(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkHisInfo> wrapper);

    @Select(" SELECT DATE_FORMAT(a.op_time, '%Y-%m') `date`, COUNT(1) totalCount, COUNT(IF(target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(target_exe_status = 'done',1,null)) doneCount, COUNT(IF(target_exe_status = 'expire',1,null)) expireCount " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY `date` ")
    List<DoctorTargetCountTrendVO> getTargetCountTrendMonth(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT DATE_FORMAT(a.op_time, '%Y-%m-%d') `date`, COUNT(1) totalCount, COUNT(IF(target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(target_exe_status = 'done',1,null)) doneCount, COUNT(IF(target_exe_status = 'expire',1,null)) expireCount " + 
            " FROM crm_doctor_patient_status_mark_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY `date` ")
    List<DoctorTargetCountTrendVO> getTargetCountTrendDay(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT DATE_FORMAT(a.op_time, '%Y-%m') `date`, COUNT(1) totalCount, COUNT(IF(target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(target_exe_status = 'done',1,null)) doneCount, COUNT(IF(target_exe_status = 'expire',1,null)) expireCount " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY `date` ")
    List<DoctorTargetCountTrendVO> getTargetHisCountTrendMonth(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

    @Select(" SELECT DATE_FORMAT(a.op_time, '%Y-%m-%d') `date`, COUNT(1) totalCount, COUNT(IF(target_exe_status = 'doing',1,null)) doingCount, COUNT(IF(target_exe_status = 'done',1,null)) doneCount, COUNT(IF(target_exe_status = 'expire',1,null)) expireCount " + 
            " FROM crm_doctor_patient_status_mark_his_info a " +
            " INNER JOIN crm_doctor_target_config_info b ON a.target_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY `date` ")
    List<DoctorTargetCountTrendVO> getTargetHisCountTrendDay(@Param(Constants.WRAPPER) Wrapper<DoctorPatientStatusMarkInfo> wrapper);

}