package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTaskCountWithDoctorVO;

public interface DoctorTaskDataBizMapper {
    
    /**
     * 医生任务数量查询
     */
    @Select(" SELECT doctor_ids doctorIds, not_doctor_ids notDoctorIds, yes_doctor_ids yesDoctorIds " + 
            " FROM h_doctor_task_info " +
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> getDoctorTaskCountList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    /**
     * 医生任务数量查询
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM h_doctor_task_exe_info " +
            " ${ew.customSqlSegment} ")
    Long getDoctorTaskExeCount(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    /**
     * 医生任务数量查询
     */
    @Select(" SELECT a.doctor_id AS doctorId, COUNT(1) totalCount, COUNT(IF(a.status = 'todo',1,null)) todoCount, COUNT(IF(a.status = 'send',1,null)) sendCount, COUNT(IF(a.status = 'ignore',1,null)) ignoreCount " + 
            " FROM h_doctor_task_exe_info a " +
            " INNER JOIN h_doctor_task_info b ON a.doctor_task_id = b.id " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.doctor_id ")
    List<DoctorTaskCountWithDoctorVO> getTaskCountByDoctor(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

}