package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DwdDoctorComeQueryDTO;

/**
 * dwd数据
 */
public interface DwdDoctorDataBizMapper {

    /**
     * 患者挂号信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_register_record_info " + 
            " ${ew.customSqlSegment} ")
    Integer registerCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_register_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer registerCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_register_record_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> registerDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.patient_name, a.card_type_raw, a.card_type_standard, a.card_no, a.visit_id, a.visit_card_no, a.company_name, a.company_code, a.department_name_raw, " + 
//             "   a.department_name_standard, a.department_code_raw, a.department_code_standard, a.doctor_code, a.doctor_name, a.reg_level_code_raw, a.reg_level_name_raw, a.reg_level_code_standard, " + 
//             "   a.reg_way_raw, a.reg_way_standard, a.reg_date, a.first_sub_type, a.reserve_date, a.reserve_way_raw, a.reserve_way_standard, a.scene_type_raw, a.scene_type_standard, a.visit_status_raw, " + 
//             "   a.visit_status_standard, a.visit_date, a.status_raw, a.status_standard, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_register_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> registerDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


    /**
     * 患者就诊信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_visit_record_info " + 
            " ${ew.customSqlSegment} ")
    Integer visitCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_visit_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer visitCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_visit_record_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> visitDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.register_id, a.patient_name, a.card_type_raw, a.card_type_standard, a.card_no, a.patient_gender_raw, a.patient_gender_standard, a.patient_age, a.company_name, " + 
//             "   a.company_code, a.department_name_raw, a.department_name_standard, a.department_code_raw, a.department_code_standard, a.doctor_code, a.doctor_name, a.visit_date, a.visit_type_raw, a.visit_type_standard, " + 
//             "   a.visit_way_raw, a.visit_way_standard, a.scene_type_raw, a.scene_type_standard, a.status_raw, a.status_standard, a.status_name_raw, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_visit_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> visitDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    
    /**
     * 患者住院信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_inpatient_record_info " + 
            " ${ew.customSqlSegment} ")
    Integer inHospitalCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_inpatient_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer inHospitalCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_inpatient_record_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> inHospitalDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.visit_id, a.patient_name, a.in_patient_no, a.company_name, a.diagnosis_raw, a.diagnosis_standard, a.diagnosis_code_standard, a.inpatient_ward, a.bed_number, " + 
//             "   a.company_code, a.admit_department_name_raw, a.admit_department_name_standard, a.admit_department_code_raw, a.admit_department_code_standard, a.doctor_code, a.doctor_name, a.inpatient_date, " + 
//             "   a.enter_way_raw, a.enter_way_standard, a.book_date, a.status_raw, a.status_standard, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_inpatient_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> inHospitalDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


    /**
     * 患者出院信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_discharge_record_info " + 
            " ${ew.customSqlSegment} ")
    Integer outHospitalCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_discharge_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer outHospitalCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_discharge_record_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> outHospitalDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.visit_id, a.patient_name, a.in_patient_no, a.company_name, a.company_code, a.diagnosis_raw, a.diagnosis_standard, a.diagnosis_code_standard, " + 
//             "   a.admit_department_name_raw, a.admit_department_name_standard, a.admit_department_code_raw, a.admit_department_code_standard, a.out_department_name_raw, a.out_department_name_standard, a.out_department_code_raw, a.out_department_code_standard, " + 
//             "   a.leave_date, a.icu_days, a.leave_way_raw, a.leave_way_name_raw, a.leave_way_standard, a.emergency_treatment_days, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_discharge_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> outHospitalDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


    /**
     * 患者手术信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_operation_record_info " + 
            " ${ew.customSqlSegment} ")
    Integer operationCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_operation_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer operationCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_operation_record_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> operationDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.visit_id, a.recipe_id, a.patient_name, a.in_patient_no, a.doctor_code, a.doctor_name, a.description, " + 
//             "   a.department_name_raw, a.department_name_standard, a.department_code_raw, a.department_code_standard, a.pre_diagnosis_standard, a.final_diagnosis_code_standard, a.final_diagnosis_raw, a.final_diagnosis_standard, a.content_raw, a.content_standard, " + 
//             "   a.pay_time, a.apply_time, a.scene_type_raw, a.scene_type_standard, a.pre_diagnosis_code_standard, a.pre_diagnosis_raw, a.status_code_raw, a.status_standard, a.status_name_raw, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_operation_record_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> operationDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


    /**
     * 患者检查信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_examine_report_info " + 
            " ${ew.customSqlSegment} ")
    Integer examineCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_examine_report_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer examineCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_examine_report_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> examineDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.visit_id, a.apply_id, a.recipe_id, a.in_patient_no, a.patient_name, a.patient_phone, a.patient_gender_raw, a.patient_gender_standard, a.patient_card_no, a.patient_age, " +
//             "   a.doctor_code, a.doctor_name, a.department_name_raw, a.department_name_standard, a.department_code_raw, a.department_code_standard, a.reports_time, a.apply_time, a.inspect_time, a.scene_type_raw, " + 
//             "   a.scene_type_standard, a.apply_doctor_code, a.apply_doctor_name, a.examine_type_raw, a.examine_type_standard, a.report_name_raw, a.report_name_standard, a.body_part_name_raw, a.body_part_name_standard, a.body_part_code_raw, " + 
//             "   a.body_part_code_standard, a.report_description_raw, a.report_description_standard, a.report_result_raw, a.report_result_standard, a.report_path, a.report_no, a.data_update_date, a.op_data_user, a.op_date, a.activity_no " + 
//             " FROM dwd_examine_report_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> examineDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


    /**
     * 患者检验信息
     */
    @Select(" SELECT COUNT(1) " + 
            " FROM dwd_laboratory_report_info " + 
            " ${ew.customSqlSegment} ")
    Integer laboratoryCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT COUNT(1) " + 
//             " FROM dwd_laboratory_report_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     Integer laboratoryCount(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);

    @Select(" SELECT * " + 
            " FROM dwd_laboratory_report_info " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> laboratoryDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);
//     @Select(" SELECT b.main_person_id patient_id, a.id, a.apply_id, a.visit_id, a.recipe_id, a.in_patient_no, a.patient_name, a.department_name_raw, a.department_name_standard, a.department_code_raw, a.department_code_standard, " +
//             "   a.reports_time, a.check_time, a.apply_time, a.inspect_time, a.scene_type_raw, a.scene_type_standard, a.apply_doctor_code, a.apply_doctor_name, a.doctor_code, a.doctor_name, a.sample_type_raw, a.sample_type_standard, " + 
//             "   a.report_name, a.description_raw, a.description_standard, a.conclusion_raw, a.conclusion_standard, a.status_raw, a.status_standard, a.activity_no, a.data_update_date, a.op_data_user, a.op_date " + 
//             " FROM dwd_laboratory_report_info a " + 
//             " INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, Object>> laboratoryDataList(@Param(Constants.WRAPPER) Wrapper<DwdDoctorComeQueryDTO> wrapper);


}
