package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.client.api.constant.DoctorStatusMarkConstant;
import com.xxh.cloud.healthy.doctor.crm.client.api.constant.DoctorTargetConstant;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkHisInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.service.DoctorPatientStatusMarkHisInfoService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.service.DoctorPatientStatusMarkInfoService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkAddDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkGetDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkHisAddDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkTargetCountQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkUpdateFocusDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkUpdateStatusDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkUpdateTargetDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkUpdateTargetExeStatusDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientStatusMarkUpdateTypeDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTargetConfigGetDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTargetConfigQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DwdDoctorComeQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientStatusMarkTargetCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientStatusMarkVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetConfigVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.ManageDoctorPatientStatusMarkVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.helper.DoctorPatientHelper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper.DoctorStatusMarkDataBizMapper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorPatientStatusMarkHisService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorPatientStatusMarkService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorTargetConfigService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DwdDoctorDataBizService;
import com.xxh.cloud.metadata.client.api.StandardDiseaseClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.DeptBizClientService;
import com.xxh.cloud.user.client.api.DeptClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class DoctorPatientStatusMarkServiceImpl implements DoctorPatientStatusMarkService {

    @Autowired
    private DoctorPatientStatusMarkInfoService doctorPatientStatusMarkInfoService;
    @Autowired
    private DoctorPatientStatusMarkHisService doctorPatientStatusMarkHisService;
    @Autowired
    private PatientClientService patientClientService;
    @Autowired
    private StandardDiseaseClientService standardDiseaseClientService;
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private DeptClientService deptClientService;
    @Autowired
    private DeptBizClientService deptBizClientService;
    @Autowired
    private DoctorStatusMarkDataBizMapper doctorStatusMarkDataBizMapper;
    @Autowired
    private DoctorTargetConfigService doctorTargetConfigService;
    @Autowired
    private DoctorPatientStatusMarkHisInfoService doctorPatientStatusMarkHisInfoService;
    @Autowired
    private DwdDoctorDataBizService dwdDoctorDataBizService;
    
    /**
     * 保存个案管理，并记录历史
     * 
     * 不存在个案则生成个案，目标由任务传递过来
     * 存在个案则更新个案，目标由任务传递过来
     * 
     * 查询目标是否已完成，来确定任务状态
     */
    // @Transactional(rollbackFor = Exception.class) // 多数据源不能设置事务
    @Override
    public DoctorPatientStatusMarkVO add(DoctorPatientStatusMarkAddDTO params) {
        ValidatorUtils.validateEntity(params);
        // 根据患者id，医生id，病种id查询是否存在个案管理
        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getOne(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq("doctor_id", params.getDoctorId())
                .eq("patient_id", params.getPatientId())
                .eq("disease_id", params.getDiseaseId())
        );

        DateTime now = DateUtil.date();

        // 查询目标数据
        DoctorTargetConfigVO doctorTargetConfigVO = null;
        if (StrUtil.isNotBlank(params.getTargetId()) || (null != entity && StrUtil.isNotBlank(entity.getTargetId()))) {
            DoctorTargetConfigGetDTO doctorTargetConfigGetDTO = new DoctorTargetConfigGetDTO();
            if (StrUtil.isNotBlank(params.getTargetId())) {
                doctorTargetConfigGetDTO.setId(params.getTargetId());
            } else {
                doctorTargetConfigGetDTO.setId(entity.getTargetId());
            }
            doctorTargetConfigVO = doctorTargetConfigService.detail(doctorTargetConfigGetDTO);
        }

        if (null == entity) { // 如果不存在则新增并返回；如果存在不操作直接返回
            log.info("1.保存数据 >>>>>> ");
            entity = new DoctorPatientStatusMarkInfo();
            
            entity.setId(DoctorPatientHelper.getDoctorPatientStatusMarkInfo());
            entity.setPatientId(params.getPatientId());
            entity.setDoctorId(params.getDoctorId());
            entity.setDiseaseId(params.getDiseaseId());
            entity.setSourceType(params.getSourceType());
            entity.setSourceId(params.getSourceId());
            entity.setType(params.getType());
            entity.setAddTime(params.getAddTime());
            entity.setOpTime(now);
            if (null != params.getAddTime()) {
                entity.setAddTime(params.getAddTime());
                entity.setOpTime(params.getAddTime());
            }
            
            entity.setTargetId("-1"); // 初始个案管理目标
            if (null != doctorTargetConfigVO) {
                entity.setTargetId(params.getTargetId());
                entity.setTargetCode(doctorTargetConfigVO.getCode());
                entity.setTargetExeDeptIds(StrJoinSplitUtils.joinPrefix(doctorTargetConfigVO.getExeDeptIdList()));
                entity.setTargetExeMaxDay(doctorTargetConfigVO.getExeMaxDay());
            }
            // dwd查询目标是否完成
            String targetExeStatus = this.getTargetExeStatus(entity);
            entity.setTargetExeStatus(targetExeStatus);

            entity.setStatus(params.getStatus());
            if (DoctorStatusMarkConstant.Status.Normal.getCode().equals(params.getStatus())) {
                entity.setStatus(DoctorStatusMarkConstant.Status.Normal.getCode()); // 加入个案管理
            } else {
                entity.setStatus(DoctorStatusMarkConstant.Status.Ignore.getCode()); // 忽略
            }
            entity.setFocus(YN.NO.getCode());
            entity.setRowsStatus(YN.YES.getCode());
            
            doctorPatientStatusMarkInfoService.save(entity);
        } else {
            log.info("1.更新数据 >>>>>> ");
            entity.setStatus(DoctorStatusMarkConstant.Status.Normal.getCode());
            entity.setSourceType(params.getSourceType());
            entity.setSourceId(params.getSourceId());
            // entity.setAddTime(now);
            entity.setOpTime(now);
            if (null != params.getAddTime()) {
                entity.setAddTime(params.getAddTime());
                entity.setOpTime(params.getAddTime());
            }
            
            if (null != doctorTargetConfigVO) {
                entity.setTargetId(params.getTargetId());
                entity.setTargetCode(doctorTargetConfigVO.getCode());
                entity.setTargetExeDeptIds(StrJoinSplitUtils.joinPrefix(doctorTargetConfigVO.getExeDeptIdList()));
                entity.setTargetExeMaxDay(doctorTargetConfigVO.getExeMaxDay());
            }
            // dwd查询目标是否完成
            String targetExeStatus = this.getTargetExeStatus(entity);
            entity.setTargetExeStatus(targetExeStatus);

            doctorPatientStatusMarkInfoService.updateById(entity);
        }

        // 保存历史记录
        log.info("2.保存历史 >>>>>> ");
        DoctorPatientStatusMarkHisAddDTO hisAddDTO = new DoctorPatientStatusMarkHisAddDTO();
        hisAddDTO.setDoctorPatientMarkId(entity.getId());
        hisAddDTO.setDoctorId(entity.getDoctorId());
        hisAddDTO.setPatientId(entity.getPatientId());
        hisAddDTO.setDiseaseId(entity.getDiseaseId());
        hisAddDTO.setSourceType(entity.getSourceType());
        hisAddDTO.setSourceId(entity.getSourceId());
        hisAddDTO.setStatus(entity.getStatus());
        hisAddDTO.setAddTime(entity.getAddTime());
        hisAddDTO.setOpTime(entity.getOpTime());
        hisAddDTO.setTargetId(entity.getTargetId());
        hisAddDTO.setOpUserId(params.getOpUserId());
        hisAddDTO.setOpType(OpTypeEnum.Create.getCode());
        hisAddDTO.setType(entity.getType());
        hisAddDTO.setTargetCode(entity.getTargetCode());
        hisAddDTO.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        hisAddDTO.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        doctorPatientStatusMarkHisService.add(hisAddDTO);

        return DoctorPatientHelper.getDoctorPatientStatusMarkVO(entity);
    }

    private String getTargetExeStatus(DoctorPatientStatusMarkInfo entity) {
        String status = DoctorStatusMarkConstant.TargetExeStatus.DOING.getCode();

        String targetCode = entity.getTargetCode();
        Integer maxDay = entity.getTargetExeMaxDay();

        // 旧数据该字段没有值，暂不处理该字段
        if (null == maxDay) {
            return status;
        }

        Date startDate = entity.getAddTime(); // 目标开始时间
        Date endDate = DateUtil.offsetDay(startDate, maxDay); // 目标结束时间

        DwdDoctorComeQueryDTO dwdDoctorComeQueryDTO = new DwdDoctorComeQueryDTO();
        dwdDoctorComeQueryDTO.setPatientId(entity.getPatientId());
        dwdDoctorComeQueryDTO.setStartDate(startDate);
        dwdDoctorComeQueryDTO.setEndDate(endDate);
        if (StrUtil.isNotBlank(entity.getTargetExeDeptIds())) {
            dwdDoctorComeQueryDTO.setDeptIds(StrJoinSplitUtils.split2List((entity.getTargetExeDeptIds())));
        }

        // 查询dwd确定更新的目标状态
        Integer count = 0;

        // 挂号
        if (DoctorTargetConstant.Target.TARGET_REG.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.registerCount(dwdDoctorComeQueryDTO);
        }
        // 就诊
        else if (DoctorTargetConstant.Target.TARGET_VISIT.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.visitCount(dwdDoctorComeQueryDTO);
        }
        // 住院
        else if (DoctorTargetConstant.Target.TARGET_IN.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.inHospitalCount(dwdDoctorComeQueryDTO);
        }
        // 出院
        else if (DoctorTargetConstant.Target.TARGET_OUT.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.outHospitalCount(dwdDoctorComeQueryDTO);
        }
        // 手术
        else if (DoctorTargetConstant.Target.TARGET_OPERATION.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.operationCount(dwdDoctorComeQueryDTO);
        }
        // 检查
        else if (DoctorTargetConstant.Target.TARGET_EXAMS.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.examineCount(dwdDoctorComeQueryDTO);
        }
        // 检验
        else if (DoctorTargetConstant.Target.TARGET_LABS.getCode().equals(targetCode)) {
            count = dwdDoctorDataBizService.laboratoryCount(dwdDoctorComeQueryDTO);
        }

        if (null != count && count > 0) {
            status = DoctorStatusMarkConstant.TargetExeStatus.DONE.getCode();
        } else {
            Date now = DateUtil.date(); // 当前时间
            
            if (now.compareTo(endDate) > 0) {
                status = DoctorStatusMarkConstant.TargetExeStatus.EXPIRE.getCode();
            }

        }

        return status;
     }

    /**
     * 更新目标，同时保存历史
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateTarget(DoctorPatientStatusMarkUpdateTargetDTO params) {
        ValidatorUtils.validateEntity(params);

        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        // 更新状态必须为normal才能更新目标
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) 
            // || !DoctorStatusMarkConstant.Status.Normal.getCode().equals(entity.getStatus()) 
            || !entity.getDoctorId().equals(params.getDoctorId())
            || entity.getTargetId().equals(params.getTargetId())
        ) {
            return;
        }

        DateTime now = DateUtil.date();

        DoctorTargetConfigGetDTO doctorTargetConfigGetDTO = new DoctorTargetConfigGetDTO();
        doctorTargetConfigGetDTO.setId(params.getTargetId());
        DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigService.detail(doctorTargetConfigGetDTO);
        if (null == doctorTargetConfigVO) {
            throw new BusinessException("未查询到个案目标数据") ;
        }
        entity.setAddTime(now);
        entity.setOpTime(now);

        entity.setTargetId(params.getTargetId());
        entity.setTargetCode(doctorTargetConfigVO.getCode());
        entity.setTargetExeDeptIds(StrJoinSplitUtils.joinPrefix(doctorTargetConfigVO.getExeDeptIdList()));
        entity.setTargetExeMaxDay(doctorTargetConfigVO.getExeMaxDay());
        // dwd查询目标是否完成
        String targetExeStatus = this.getTargetExeStatus(entity);
        entity.setTargetExeStatus(targetExeStatus);

        doctorPatientStatusMarkInfoService.updateById(entity);

        // 保存历史记录
        log.info("2.保存历史 >>>>>> ");
        DoctorPatientStatusMarkHisAddDTO hisAddDTO = new DoctorPatientStatusMarkHisAddDTO();
        hisAddDTO.setDoctorPatientMarkId(entity.getId());
        hisAddDTO.setDoctorId(entity.getDoctorId());
        hisAddDTO.setPatientId(entity.getPatientId());
        hisAddDTO.setDiseaseId(entity.getDiseaseId());
        hisAddDTO.setSourceType(entity.getSourceType());
        hisAddDTO.setSourceId(entity.getSourceId());
        hisAddDTO.setStatus(entity.getStatus());
        hisAddDTO.setAddTime(entity.getAddTime());
        hisAddDTO.setOpTime(entity.getOpTime());
        hisAddDTO.setTargetId(entity.getTargetId());
        hisAddDTO.setOpUserId(params.getOpUserId());
        // hisAddDTO.setOpType(OpTypeEnum.Update.getCode());
        hisAddDTO.setOpType(OpTypeEnum.Create.getCode()); // 新的目标相当于新的数据（方便查询历史目标）
        hisAddDTO.setType(entity.getType());
        hisAddDTO.setTargetCode(entity.getTargetCode());
        hisAddDTO.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        hisAddDTO.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        doctorPatientStatusMarkHisService.add(hisAddDTO);
    }

    /**
     * 更新目标，同时保存历史
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateTargetExeStatus(DoctorPatientStatusMarkUpdateTargetExeStatusDTO params) {
        ValidatorUtils.validateEntity(params);

        log.info("1.查询当前数据 >>>>>> ");
        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        // 更新状态必须为normal才能更新目标
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) 
            || !DoctorStatusMarkConstant.Status.Normal.getCode().equals(entity.getStatus())
        ) {
            return;
        }

        entity.setTargetExeStatus(params.getTargetExeStatus());
        if (null != params.getOpTime()) {
            entity.setOpTime(params.getOpTime());
        }
        doctorPatientStatusMarkInfoService.updateById(entity);

        // 更新历史记录
        log.info("2.更新历史数据 >>>>>> ");
        doctorPatientStatusMarkHisInfoService.update(new UpdateWrapper<DoctorPatientStatusMarkHisInfo>()
            .set("target_exe_status", params.getTargetExeStatus())
            .set(null != params.getOpTime(), "op_time", entity.getOpTime())
            .eq("op_time", OpTypeEnum.Create.getCode())
            .eq("doctor_patient_mark_id", entity.getId())
            .eq("add_time", entity.getAddTime())
            .eq("target_id", entity.getTargetId())
        );
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateTargetExeStatusBatch(List<DoctorPatientStatusMarkUpdateTargetExeStatusDTO> params) {
        
        Map<String, DoctorPatientStatusMarkUpdateTargetExeStatusDTO> updateMap = new HashMap<>();
        List<String> ids = new ArrayList<>();
        params.forEach(i -> {
            ids.add(i.getId());
            updateMap.put(i.getId(), i);
        });

        log.info("1.查询当前数据 >>>>>> ");
        // 更新状态必须为normal才能更新目标
        List<DoctorPatientStatusMarkInfo> entityList = doctorPatientStatusMarkInfoService.list(new QueryWrapper<DoctorPatientStatusMarkInfo>()
            .eq("rows_status", YN.YES.getCode())
            .eq("status", DoctorStatusMarkConstant.Status.Normal.getCode())
            .in("id", ids)
        );

        entityList.forEach(i -> {
            DoctorPatientStatusMarkUpdateTargetExeStatusDTO updateDTO = updateMap.get(i.getId());
            if (null != updateDTO) {
                i.setTargetExeStatus(updateDTO.getTargetExeStatus());
                if (null != updateDTO.getOpTime()) {
                    i.setOpTime(updateDTO.getOpTime());
                }
            }
        });

        doctorPatientStatusMarkInfoService.updateBatchById(entityList);

        // 更新历史记录
        log.info("2.批量更新历史数据 >>>>>> ");
        entityList.forEach(i -> {
            doctorPatientStatusMarkHisInfoService.update(new UpdateWrapper<DoctorPatientStatusMarkHisInfo>()
                .set("target_exe_status", i.getTargetExeStatus())
                .set(null != i.getOpTime(), "op_time", i.getOpTime())
                .eq("op_type", OpTypeEnum.Create.getCode())
                .eq("doctor_patient_mark_id", i.getId())
                .eq("add_time", i.getAddTime())
                .eq("target_id", i.getTargetId())
            );
        });
    }

    /**
     * 更新状态，同时保存历史
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateStatus(DoctorPatientStatusMarkUpdateStatusDTO params) {
        ValidatorUtils.validateEntity(params);

        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        // 更新状态必须为normal或abandon才能更新目标
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) || DoctorStatusMarkConstant.Status.Ignore.getCode().equals(entity.getStatus()) || !entity.getDoctorId().equals(params.getDoctorId()) || entity.getStatus().equals(params.getStatus())) {
            return;
        }
        
        entity.setStatus(params.getStatus());
        doctorPatientStatusMarkInfoService.updateById(entity);

        // 保存历史记录
        log.info("2.保存历史 >>>>>> ");
        DoctorPatientStatusMarkHisAddDTO hisAddDTO = new DoctorPatientStatusMarkHisAddDTO();
        hisAddDTO.setDoctorPatientMarkId(entity.getId());
        hisAddDTO.setDoctorId(entity.getDoctorId());
        hisAddDTO.setPatientId(entity.getPatientId());
        hisAddDTO.setDiseaseId(entity.getDiseaseId());
        hisAddDTO.setSourceType(entity.getSourceType());
        hisAddDTO.setSourceId(entity.getSourceId());
        hisAddDTO.setStatus(entity.getStatus());
        hisAddDTO.setAddTime(entity.getAddTime());
        hisAddDTO.setOpTime(entity.getOpTime());
        hisAddDTO.setTargetId(entity.getTargetId());
        hisAddDTO.setOpUserId(params.getOpUserId());
        hisAddDTO.setOpType(OpTypeEnum.Update.getCode());
        hisAddDTO.setType(entity.getType());
        hisAddDTO.setTargetCode(entity.getTargetCode());
        hisAddDTO.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        hisAddDTO.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        doctorPatientStatusMarkHisService.add(hisAddDTO);
    }

    /**
     * 关注/取消关注
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateFocus(DoctorPatientStatusMarkUpdateFocusDTO params) {
        ValidatorUtils.validateEntity(params);

        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        // 更新状态必须为normal才能更新目标
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) || !DoctorStatusMarkConstant.Status.Normal.getCode().equals(entity.getStatus()) || !entity.getDoctorId().equals(params.getDoctorId())) {
            return;
        }

        if (YN.YES.getCode().equals(entity.getFocus())) {
            entity.setFocus(YN.NO.getCode());
        } else {
            entity.setFocus(YN.YES.getCode());
        }
        
        doctorPatientStatusMarkInfoService.updateById(entity);
    }

    /**
     * 更新个案类型
     * 
     * 由医生任务配置中指定
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateType(DoctorPatientStatusMarkUpdateTypeDTO params) {
        ValidatorUtils.validateEntity(params);

        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        // 更新状态必须为normal才能更新目标
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) || !DoctorStatusMarkConstant.Status.Normal.getCode().equals(entity.getStatus()) || !entity.getDoctorId().equals(params.getDoctorId())) {
            return;
        }

        entity.setType(params.getType());
        doctorPatientStatusMarkInfoService.updateById(entity);

        // 保存历史记录
        log.info("2.保存历史 >>>>>> ");
        DoctorPatientStatusMarkHisAddDTO hisAddDTO = new DoctorPatientStatusMarkHisAddDTO();
        hisAddDTO.setDoctorPatientMarkId(entity.getId());
        hisAddDTO.setDoctorId(entity.getDoctorId());
        hisAddDTO.setPatientId(entity.getPatientId());
        hisAddDTO.setDiseaseId(entity.getDiseaseId());
        hisAddDTO.setSourceType(entity.getSourceType());
        hisAddDTO.setSourceId(entity.getSourceId());
        hisAddDTO.setStatus(entity.getStatus());
        hisAddDTO.setAddTime(entity.getAddTime());
        hisAddDTO.setOpTime(entity.getOpTime());
        hisAddDTO.setTargetId(entity.getTargetId());
        hisAddDTO.setOpUserId(params.getOpUserId());
        hisAddDTO.setOpType(OpTypeEnum.Update.getCode());
        hisAddDTO.setType(entity.getType());
        hisAddDTO.setTargetCode(entity.getTargetCode());
        hisAddDTO.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        hisAddDTO.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        doctorPatientStatusMarkHisService.add(hisAddDTO);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void remove(DoctorPatientStatusMarkGetDTO params) {
        ValidatorUtils.validateEntity(params);

        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) || !entity.getDoctorId().equals(params.getDoctorId())) {
            return;
        }

        entity.setRowsStatus(YN.NO.getCode());
        doctorPatientStatusMarkInfoService.updateById(entity);

        // 保存历史记录
        log.info("1.保存历史 >>>>>> ");
        DoctorPatientStatusMarkHisAddDTO hisAddDTO = new DoctorPatientStatusMarkHisAddDTO();
        hisAddDTO.setDoctorPatientMarkId(entity.getId());
        hisAddDTO.setDoctorId(entity.getDoctorId());
        hisAddDTO.setPatientId(entity.getPatientId());
        hisAddDTO.setDiseaseId(entity.getDiseaseId());
        hisAddDTO.setSourceType(entity.getSourceType());
        hisAddDTO.setSourceId(entity.getSourceId());
        hisAddDTO.setStatus(entity.getStatus());
        hisAddDTO.setAddTime(entity.getAddTime());
        hisAddDTO.setOpTime(entity.getOpTime());
        hisAddDTO.setTargetId(entity.getTargetId());
        hisAddDTO.setOpUserId(params.getDoctorId());
        hisAddDTO.setOpType(OpTypeEnum.DEL.getCode());
        hisAddDTO.setType(entity.getType());
        hisAddDTO.setTargetCode(entity.getTargetCode());
        hisAddDTO.setTargetExeDeptIds(entity.getTargetExeDeptIds());
        hisAddDTO.setTargetExeMaxDay(entity.getTargetExeMaxDay());
        hisAddDTO.setTargetExeStatus(entity.getTargetExeStatus());
        doctorPatientStatusMarkHisService.add(hisAddDTO);
    }

    @Override
    public PageData<DoctorPatientStatusMarkVO> query(DoctorPatientStatusMarkQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new PageData<>(null, 0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new PageData<>(null, 0);
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> patientIds = new ArrayList<>();
        // 若按照患者名称筛选则先查询患者信息
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        IPage<DoctorPatientStatusMarkInfo> page = doctorPatientStatusMarkInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(patientIds), "patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getTargetId()), "target_id", params.getTargetId())
                .in(CollectionUtil.isNotEmpty(params.getTargetIds()), "target_id", params.getTargetIds())
                .eq(StrUtil.isNotBlank(params.getFocus()), "focus", YN.YES.getCode())
                .ge(null != params.getStartDate(), "op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "op_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .eq(StrUtil.isNotBlank(params.getTargetExeStatus()), "target_exe_status", params.getTargetExeStatus())
                .orderByDesc("focus", "op_time")
        );
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        // 查询患者及病种信息
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        Map<String, DeptBO> deptMap = new HashMap<>();
        Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap = new HashMap<>();
        Map<String, DoctorTargetConfigVO> doctorTargetConfigVOMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(page.getRecords())) {
            List<String> diseaseIds = new ArrayList<>();
            List<String> doctorIds = new ArrayList<>();
            List<String> targetIds = new ArrayList<>();
            page.getRecords().forEach(i -> {
                patientIds.add(i.getPatientId());
                diseaseIds.add(i.getDiseaseId());
                doctorIds.add(i.getDoctorId());
                targetIds.add(i.getTargetId());
            });

            // 医生
            List<String> deptIds = new ArrayList<>();
            List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
            doctorList.forEach(i -> {
                doctorMap.put(i.getId(), i);
                deptIds.add(i.getDeptId());
            });

            // 查询部门信息
            if (CollectionUtil.isNotEmpty(deptIds)) {
                List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
                deptList.forEach(i -> deptMap.put(i.getId(), i));
            }

            // 患者
            if (CollectionUtil.isEmpty(patientMap)) {
                PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
                patientQueryDTO.setPatientIds(patientIds);
                List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
                patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
            }

            // 病种
            List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
            diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));

            // 查询患者最新数据信息
            List<DataDwsPatientDataLastDateBO> patientDataLastDateList = dwdDataPatientClientService.listPatientDataLastDateInfo(patientIds);
            patientDataLastDateList.forEach(i -> patientDataLastDateMap.put(i.getPatientId(), i));
            
            // 查询目标配置
            DoctorTargetConfigQueryDTO doctorTargetConfigQueryDTO = new DoctorTargetConfigQueryDTO();
            doctorTargetConfigQueryDTO.setIds(targetIds);
            List<DoctorTargetConfigVO> doctorTargetConfigVOList = doctorTargetConfigService.list(doctorTargetConfigQueryDTO);
            doctorTargetConfigVOList.forEach(i -> doctorTargetConfigVOMap.put(i.getId(), i));
        }

        PageData<DoctorPatientStatusMarkVO> data =  new PageConverter<DoctorPatientStatusMarkInfo, DoctorPatientStatusMarkVO>() {
            @Override
            public DoctorPatientStatusMarkVO converter(DoctorPatientStatusMarkInfo entity) {
                DoctorPatientStatusMarkVO vo = DoctorPatientHelper.getDoctorPatientStatusMarkVO(entity);
                vo.setPatientInfo(patientMap.get(vo.getPatientId()));
                vo.setDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));
                vo.setPatientDataLastDateInfo(patientDataLastDateMap.get(vo.getPatientId()));

                AdminUserBO doctor = doctorMap.get(vo.getDoctorId());
                if (null != doctor) {
                    vo.setDoctorInfo(doctor);
                    vo.setDeptInfo(deptMap.get(doctor.getDeptId()));
                }
                
                DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigVOMap.get(vo.getTargetId());
                if (null != doctorTargetConfigVO) {
                    vo.setTargetName(doctorTargetConfigVO.getName());
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<DoctorPatientStatusMarkVO> list(DoctorPatientStatusMarkQueryDTO params) {
        List<DoctorPatientStatusMarkInfo> list = doctorPatientStatusMarkInfoService.list(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getTargetId()), "target_id", params.getTargetId())
                .in(CollectionUtil.isNotEmpty(params.getTargetIds()), "target_id", params.getTargetIds())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .orderByDesc("op_time")
                .last(" limit 1000 ")
        );

        // 查询患者及病种信息
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        Map<String, DoctorTargetConfigVO> doctorTargetConfigVOMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(list)) {
            List<String> patientIds = new ArrayList<>();
            List<String> diseaseIds = new ArrayList<>();
            List<String> targetIds = new ArrayList<>();
            list.forEach(i -> {
                patientIds.add(i.getPatientId());
                diseaseIds.add(i.getDiseaseId());
                targetIds.add(i.getTargetId());
            });

            // 患者
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            patientList.forEach(i -> patientMap.put(i.getPatientId(), i));

            // 病种
            List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
            diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
            
            // 查询目标配置
            DoctorTargetConfigQueryDTO doctorTargetConfigQueryDTO = new DoctorTargetConfigQueryDTO();
            doctorTargetConfigQueryDTO.setIds(targetIds);
            List<DoctorTargetConfigVO> doctorTargetConfigVOList = doctorTargetConfigService.list(doctorTargetConfigQueryDTO);
            doctorTargetConfigVOList.forEach(i -> doctorTargetConfigVOMap.put(i.getId(), i));
        }

        return list.stream().map(i -> {
            DoctorPatientStatusMarkVO vo = DoctorPatientHelper.getDoctorPatientStatusMarkVO(i);
            vo.setPatientInfo(patientMap.get(vo.getPatientId()));
            vo.setDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));
            
            DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigVOMap.get(vo.getTargetId());
            if (null != doctorTargetConfigVO) {
                vo.setTargetName(doctorTargetConfigVO.getName());
            }

            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public DoctorPatientStatusMarkVO detail(DoctorPatientStatusMarkGetDTO params) {
        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus()) || !entity.getDoctorId().equals(params.getDoctorId())) {
            return null;
        }

        // 用户信息
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientId(entity.getPatientId());
        PatientClientBO patient = patientClientService.getOneSimple(patientQueryDTO);

        // 病种信息
        StandardDiseaseBO disease = standardDiseaseClientService.getById(entity.getDiseaseId());

        // 医生信息
        AdminUserBO doctor = adminUserClientService.getUserById(entity.getDoctorId());

        // 部门信息
        DeptBO dept = null;
        if (null != doctor) {
            dept = deptClientService.getDeptById(doctor.getDeptId());
        }
        
        // 目标
        DoctorTargetConfigGetDTO doctorTargetConfigGetDTO = new DoctorTargetConfigGetDTO();
        doctorTargetConfigGetDTO.setId(entity.getTargetId());
        DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigService.detail(doctorTargetConfigGetDTO);

        DoctorPatientStatusMarkVO vo =  DoctorPatientHelper.getDoctorPatientStatusMarkVO(entity);
        vo.setPatientInfo(patient);
        vo.setDiseaseInfo(disease);
        vo.setDoctorInfo(doctor);
        vo.setDeptInfo(dept);

        if (null != doctorTargetConfigVO) {
            vo.setTargetName(doctorTargetConfigVO.getName());
        }

        return vo;
    }

    @Override
    public List<DoctorPatientStatusMarkTargetCountVO> getTargetCount(DoctorPatientStatusMarkTargetCountQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

         return doctorStatusMarkDataBizMapper.getTargetCountList(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .in(CollectionUtil.isNotEmpty(params.getStatuses()), "status", params.getStatuses())
                .eq(StrUtil.isNotBlank(params.getTargetId()), "target_id", params.getTargetId())
                .in(CollectionUtil.isNotEmpty(params.getTargetIds()), "target_id", params.getTargetIds())
                .ge(null != params.getStartDate(), "op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        );
    }

    @Override
    public PageData<ManageDoctorPatientStatusMarkVO> manageQuery(DoctorPatientStatusMarkQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new PageData<>(null, 0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new PageData<>(null, 0);
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> patientIds = new ArrayList<>();
        // 若按照患者名称筛选则先查询患者信息
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        IPage<DoctorPatientStatusMarkInfo> page = doctorPatientStatusMarkInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(patientIds), "patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getTargetId()), "target_id", params.getTargetId())
                .in(CollectionUtil.isNotEmpty(params.getTargetIds()), "target_id", params.getTargetIds())
                .eq(StrUtil.isNotBlank(params.getFocus()), "focus", YN.YES.getCode())
                .ge(null != params.getStartDate(), "op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "op_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .eq(StrUtil.isNotBlank(params.getTargetExeStatus()), "target_exe_status", params.getTargetExeStatus())
                .orderByDesc("focus", "op_time")
        );
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        // 查询患者及病种信息
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        Map<String, DeptBO> deptMap = new HashMap<>();
        Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap = new HashMap<>();
        Map<String, DoctorTargetConfigVO> doctorTargetConfigVOMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(page.getRecords())) {
            List<String> diseaseIds = new ArrayList<>();
            List<String> doctorIds = new ArrayList<>();
            List<String> targetIds = new ArrayList<>();
            page.getRecords().forEach(i -> {
                patientIds.add(i.getPatientId());
                diseaseIds.add(i.getDiseaseId());
                doctorIds.add(i.getDoctorId());
                targetIds.add(i.getTargetId());
            });

            // 医生
            List<String> deptIds = new ArrayList<>();
            List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
            doctorList.forEach(i -> {
                doctorMap.put(i.getId(), i);
                deptIds.add(i.getDeptId());
            });

            // 查询部门信息
            if (CollectionUtil.isNotEmpty(deptIds)) {
                List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
                deptList.forEach(i -> deptMap.put(i.getId(), i));
            }

            // 患者
            if (CollectionUtil.isEmpty(patientMap)) {
                PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
                patientQueryDTO.setPatientIds(patientIds);
                List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
                patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
            }

            // 病种
            List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
            diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));

            // 查询患者最新数据信息
            // List<DataDwsPatientDataLastDateBO> patientDataLastDateList = dwdDataPatientClientService.listPatientDataLastDateInfo(patientIds);
            // patientDataLastDateList.forEach(i -> patientDataLastDateMap.put(i.getPatientId(), i));

            // 查询目标配置
            DoctorTargetConfigQueryDTO doctorTargetConfigQueryDTO = new DoctorTargetConfigQueryDTO();
            doctorTargetConfigQueryDTO.setIds(targetIds);
            List<DoctorTargetConfigVO> doctorTargetConfigVOList = doctorTargetConfigService.list(doctorTargetConfigQueryDTO);
            doctorTargetConfigVOList.forEach(i -> doctorTargetConfigVOMap.put(i.getId(), i));
        }

        PageData<ManageDoctorPatientStatusMarkVO> data =  new PageConverter<DoctorPatientStatusMarkInfo, ManageDoctorPatientStatusMarkVO>() {
            @Override
            public ManageDoctorPatientStatusMarkVO converter(DoctorPatientStatusMarkInfo entity) {
                ManageDoctorPatientStatusMarkVO vo = DoctorPatientHelper.getManageDoctorPatientStatusMarkVO(entity);
                vo.setPatientDataLastDateInfo(patientDataLastDateMap.get(vo.getPatientId()));

                PatientClientBO patient = patientMap.get(vo.getPatientId());
                if (null != patient) {
                    vo.setPatientName(patient.getPatientName());
                    vo.setPatientSex(patient.getPatientGenderStandard());
                    vo.setPatientAge(patient.getAge());
                }

                StandardDiseaseBO disease = diseaseMap.get(vo.getDiseaseId());
                if (null != disease) {
                    vo.setDiseaseName(disease.getName());
                }

                AdminUserBO doctor = doctorMap.get(vo.getDoctorId());
                if (null != doctor) {
                    vo.setDoctorName(doctor.getRealName());

                    DeptBO dept = deptMap.get(doctor.getDeptId());
                    if (null != dept) {
                        vo.setDeptName(dept.getName());
                    }
                }

                DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigVOMap.get(vo.getTargetId());
                if (null != doctorTargetConfigVO) {
                    vo.setTargetName(doctorTargetConfigVO.getName());
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public ManageDoctorPatientStatusMarkVO manageDetail(DoctorPatientStatusMarkGetDTO params) {
        ValidatorUtils.validateEntity(params);
        DoctorPatientStatusMarkInfo entity = doctorPatientStatusMarkInfoService.getOne(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
        );

        if (null == entity) {
            return null;
        }
        ManageDoctorPatientStatusMarkVO vo = DoctorPatientHelper.getManageDoctorPatientStatusMarkVO(entity);

        
        // 医生
        AdminUserBO doctor = adminUserClientService.getUserById(vo.getDoctorId());
        if (null != doctor) {
            vo.setDoctorName(doctor.getRealName());

            // 查询部门信息
            DeptBO dept = deptClientService.getDeptById(doctor.getDeptId());
            if (null != dept) {
                vo.setDeptName(dept.getName());
            }
        }

        // 患者
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientId(vo.getPatientId());
        PatientClientBO patient = patientClientService.getOneSimple(patientQueryDTO);
        if (null != patient) {
            vo.setPatientName(patient.getPatientName());
            vo.setPatientSex(patient.getPatientGenderStandard());
            vo.setPatientAge(patient.getAge());
        }

        // 病种
        StandardDiseaseBO disease = standardDiseaseClientService.getById(vo.getDiseaseId());
        if (null != disease) {
            vo.setDiseaseName(disease.getName());
        }

        // 查询患者最新数据信息
        // List<DataDwsPatientDataLastDateBO> patientDataLastDateList = dwdDataPatientClientService.listPatientDataLastDateInfo(patientIds);
        // patientDataLastDateList.forEach(i -> patientDataLastDateMap.put(i.getPatientId(), i));

        // 查询目标配置
        DoctorTargetConfigGetDTO doctorTargetConfigGetDTO = new DoctorTargetConfigGetDTO();
        doctorTargetConfigGetDTO.setId(vo.getTargetId());
        DoctorTargetConfigVO doctorTargetConfigVO = doctorTargetConfigService.detail(doctorTargetConfigGetDTO);
        if (null != doctorTargetConfigVO) {
            vo.setTargetName(doctorTargetConfigVO.getName());
        }

        // 目标数据依据
        String targetCode = entity.getTargetCode();
        Integer maxDay = entity.getTargetExeMaxDay();
        if (null != maxDay) {
            Date startDate = entity.getAddTime(); // 目标开始时间
            Date endDate = DateUtil.offsetDay(startDate, maxDay); // 目标结束时间

            DwdDoctorComeQueryDTO dwdDoctorComeQueryDTO = new DwdDoctorComeQueryDTO();
            dwdDoctorComeQueryDTO.setStartDate(startDate);
            dwdDoctorComeQueryDTO.setEndDate(endDate);
            if (StrUtil.isNotBlank(entity.getTargetExeDeptIds())) {
                dwdDoctorComeQueryDTO.setDeptIds(StrJoinSplitUtils.split2List((entity.getTargetExeDeptIds())));
            }

            // 挂号
            if (DoctorTargetConstant.Target.TARGET_REG.getCode().equals(targetCode)) {
                List<Map<String, Object>> registerDataList = dwdDoctorDataBizService.registerDataList(dwdDoctorComeQueryDTO);
                vo.setRegisterDataList(registerDataList);
            }
            // 就诊
            else if (DoctorTargetConstant.Target.TARGET_VISIT.getCode().equals(targetCode)) {
                List<Map<String, Object>> visitDataList = dwdDoctorDataBizService.visitDataList(dwdDoctorComeQueryDTO);
                vo.setVisitDataList(visitDataList);
            }
            // 住院
            else if (DoctorTargetConstant.Target.TARGET_IN.getCode().equals(targetCode)) {
                List<Map<String, Object>> inHospitalDataList = dwdDoctorDataBizService.inHospitalDataList(dwdDoctorComeQueryDTO);
                vo.setInHospitalDataList(inHospitalDataList);
            }
            // 出院
            else if (DoctorTargetConstant.Target.TARGET_OUT.getCode().equals(targetCode)) {
                List<Map<String, Object>> outHospitalDataList = dwdDoctorDataBizService.outHospitalDataList(dwdDoctorComeQueryDTO);
                vo.setOutHospitalDataList(outHospitalDataList);
            }
            // 手术
            else if (DoctorTargetConstant.Target.TARGET_OPERATION.getCode().equals(targetCode)) {
                List<Map<String, Object>> operationDataList = dwdDoctorDataBizService.operationDataList(dwdDoctorComeQueryDTO);
                vo.setOperationDataList(operationDataList);
            }
            // 检查
            else if (DoctorTargetConstant.Target.TARGET_EXAMS.getCode().equals(targetCode)) {
                List<Map<String, Object>> examineDataList = dwdDoctorDataBizService.examineDataList(dwdDoctorComeQueryDTO);
                vo.setExamineDataList(examineDataList);
            }
            // 检验
            else if (DoctorTargetConstant.Target.TARGET_LABS.getCode().equals(targetCode)) {
                List<Map<String, Object>> laboratoryDataList = dwdDoctorDataBizService.laboratoryDataList(dwdDoctorComeQueryDTO);
                vo.setLaboratoryDataList(laboratoryDataList);
            }
        }

        return vo;
    }

}
