package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.impl;

import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DwdDoctorComeQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper.DwdDoctorDataBizMapper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DwdDoctorDataBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson2.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import lombok.extern.slf4j.Slf4j;

@DS("wd")
@Slf4j
@Service
public class DwdDoctorDataBizServiceImpl implements DwdDoctorDataBizService {
    
    @Autowired
    private DwdDoctorDataBizMapper dwdPatientDataBizMapper;

    @Override
    public Integer registerCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.registerCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.registerCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reg_date", params.getStartDate())
                .lt(null != params.getEndDate(), "reg_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.registerCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reg_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reg_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> registerDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.registerDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.registerDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reg_date", params.getStartDate())
                .lt(null != params.getEndDate(), "reg_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.registerDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reg_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reg_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer visitCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.visitCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.visitCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "visit_date", params.getStartDate())
                .lt(null != params.getEndDate(), "visit_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.visitCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.visit_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.visit_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> visitDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.visitDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.visitDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "visit_date", params.getStartDate())
                .lt(null != params.getEndDate(), "visit_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.visitDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.visit_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.visit_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer inHospitalCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.inHospitalCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.inHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "inpatient_date", params.getStartDate())
                .lt(null != params.getEndDate(), "inpatient_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.inHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.inpatient_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.inpatient_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> inHospitalDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.inHospitalDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.inHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "inpatient_date", params.getStartDate())
                .lt(null != params.getEndDate(), "inpatient_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.inHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.inpatient_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.inpatient_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer outHospitalCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.outHospitalCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.outHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "leave_date", params.getStartDate())
                .lt(null != params.getEndDate(), "leave_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.outHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.leave_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.leave_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> outHospitalDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.outHospitalDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.outHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "leave_date", params.getStartDate())
                .lt(null != params.getEndDate(), "leave_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.outHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.leave_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.leave_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer operationCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.operationCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.operationCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.operationCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.apply_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.apply_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> operationDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.operationDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.operationDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.operationDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.apply_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.apply_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer examineCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.examineCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.examineCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.examineCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> examineDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.examineDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.examineDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.examineDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer laboratoryCount(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.laboratoryCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.laboratoryCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.laboratoryCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> laboratoryDataList(DwdDoctorComeQueryDTO params) {
        log.info("DwdDoctorDataBizServiceImpl.laboratoryDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.laboratoryDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.laboratoryDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

}
