package com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.doctor.crm.client.api.constant.DoctorStatusMarkConstant;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkHisInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.entity.DoctorPatientStatusMarkInfo;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.service.DoctorPatientStatusMarkHisInfoService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.base.service.DoctorPatientStatusMarkInfoService;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTargetCountQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTargetTotalCountQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTargetTotalCountTrendQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorTaskTotalCountQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountTrendVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetCountWithDoctorVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTargetTotalCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTaskCountWithDoctorVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorTaskTotalCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper.DoctorStatusMarkDataBizMapper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.mapper.DoctorTaskDataBizMapper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.ManageDoctorStatisticBizService;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.DeptBizClientService;
import com.xxh.cloud.user.client.api.DeptClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class ManageDoctorStatisticBizServiceImpl implements ManageDoctorStatisticBizService {

    @Autowired
    private DoctorTaskDataBizMapper doctorTaskDataBizMapper;
    @Autowired
    private DoctorStatusMarkDataBizMapper doctorStatusMarkDataBizMapper;
    @Autowired
    private DoctorPatientStatusMarkInfoService doctorPatientStatusMarkInfoService;
    @Autowired
    private DoctorPatientStatusMarkHisInfoService doctorPatientStatusMarkHisInfoService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private DeptClientService deptClientService;
    @Autowired
    private DeptBizClientService deptBizClientService;

    /**
     * 任务数量实际指的是：一个任务分配给几个医生算几个任务
     */
    // @Override
    // public DoctorTaskTotalCountVO taskTotalCount(DoctorTaskTotalCountQueryDTO params) {

    //     DoctorTaskTotalCountVO vo = new DoctorTaskTotalCountVO();
    //     // 总任务数量/待执行任务数量
    //     List<Map<String, Object>> totalCountList = doctorTaskDataBizMapper.getDoctorTaskCountList(new QueryWrapper<Void>()
    //             .isNotNull("doctor_ids")
    //             .ne("doctor_ids", "")
    //     );

    //     if (CollectionUtil.isNotEmpty(totalCountList)) {
    //         totalCountList.forEach(i -> {
    //             Object doctorIdsStr = i.get("doctorIds");
    //             Object notDoctorIdsStr = i.get("notDoctorIds");
    //             Object yesDoctorIdsStr = i.get("yesDoctorIds");

    //             // 总任务数量
    //             if (null != doctorIdsStr) {
    //                 List<String> doctorIds = StrJoinSplitUtils.split2List(String.valueOf(doctorIdsStr));
    //                 vo.setTotal(vo.getTotal() + doctorIds.size());
    //             }
                
    //             // 总待执行任务数量
    //             if (null != notDoctorIdsStr) {
    //                 List<String> notDoctorIds = StrJoinSplitUtils.split2List(String.valueOf(notDoctorIdsStr));
    //                 vo.setTodo(vo.getTodo() + notDoctorIds.size());
    //             }

    //             // 总执行任务数量
    //             if (null != yesDoctorIdsStr) {
    //                 List<String> yesDoctorIds = StrJoinSplitUtils.split2List(String.valueOf(yesDoctorIdsStr));
    //                 vo.setDone(vo.getDone() + yesDoctorIds.size());
    //             }
    //         });
    //     }

    //     // 发送任务数量
    //     Long sendCount = doctorTaskDataBizMapper.getDoctorTaskExeCount(new QueryWrapper<Void>()
    //             .eq("status", "send")
    //     );
    //     vo.setSend(sendCount);
        
    //     // 忽略任务数量
    //     Long ingoreCount = doctorTaskDataBizMapper.getDoctorTaskExeCount(new QueryWrapper<Void>()
    //             .eq("status", "ignore")
    //     );
    //     vo.setIgnore(ingoreCount);

    //     return vo;
    // }
    @Override
    public DoctorTaskTotalCountVO taskTotalCount(DoctorTaskTotalCountQueryDTO params) {

        DoctorTaskTotalCountVO vo = new DoctorTaskTotalCountVO();

        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return vo;
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return vo;
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        // 总任务数量/待执行任务数量
        List<DoctorTaskCountWithDoctorVO> totalCountList = doctorTaskDataBizMapper.getTaskCountByDoctor(new QueryWrapper<Void>()
                .eq("a.rows_status", YN.YES.getCode())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "doctor_id", queryDoctorIds)
        );

        if (CollectionUtil.isNotEmpty(totalCountList)) {
            totalCountList.forEach(i -> {
                // 总任务数量
                vo.setTotal(vo.getTotal() + i.getTotalCount());
                // 总待执行任务数量
                vo.setTodo(vo.getTodo() + i.getTodoCount());
                // 总执行任务数量
                vo.setDone(vo.getDone() + i.getSendCount() + i.getIgnoreCount());
                // 发送任务数量
                vo.setSend(vo.getSend() + i.getSendCount());
                // 忽略任务数量
                vo.setIgnore(vo.getIgnore() + i.getIgnoreCount());
            });
        }

        return vo;
    }

    @Override
    public List<DoctorTaskCountWithDoctorVO> taskCountByDoctor() {
        List<DoctorTaskCountWithDoctorVO> list = doctorTaskDataBizMapper.getTaskCountByDoctor(new QueryWrapper<Void>()
            .eq("a.rows_status", YN.YES.getCode())
        );
        
        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>();
        }

        // 查询医生及科室信息
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        Map<String, DeptBO> deptMap = new HashMap<>();

        List<String> doctorIds = new ArrayList<>();
        list.forEach(i -> doctorIds.add(i.getDoctorId()));

        // 医生
        List<String> deptIds = new ArrayList<>();
        List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
        doctorList.forEach(i -> {
            doctorMap.put(i.getId(), i);
            deptIds.add(i.getDeptId());
        });

        // 查询部门信息
        if (CollectionUtil.isNotEmpty(deptIds)) {
            List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
            deptList.forEach(i -> deptMap.put(i.getId(), i));
        }

        list.forEach(i -> {
            AdminUserBO doctor = doctorMap.get(i.getDoctorId());
            if (null != doctor) {
                i.setDoctorName(doctor.getRealName());

                DeptBO dept = deptMap.get(doctor.getDeptId());
                if (null != dept) {
                    i.setDeptName(dept.getName());
                }
            }
        });

        return list;
    }

    @Override
    public DoctorTargetTotalCountVO targetTotalCount(DoctorTargetTotalCountQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        DoctorTargetTotalCountVO vo = new DoctorTargetTotalCountVO();

        // Long doneCount = doctorPatientStatusMarkInfoService.count(new QueryWrapper<DoctorPatientStatusMarkInfo>()
        //     .eq("rows_status", YN.YES.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.DONE.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setDoneCount(doneCount);

        // Long doingCount = doctorPatientStatusMarkInfoService.count(new QueryWrapper<DoctorPatientStatusMarkInfo>()
        //     .eq("rows_status", YN.YES.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.DOING.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setDoingCount(doingCount);

        // Long expireCount = doctorPatientStatusMarkInfoService.count(new QueryWrapper<DoctorPatientStatusMarkInfo>()
        //     .eq("rows_status", YN.YES.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.EXPIRE.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setExpireCount(expireCount);

        // Long abandonCount = doctorPatientStatusMarkInfoService.count(new QueryWrapper<DoctorPatientStatusMarkInfo>()
        //     .eq("rows_status", YN.YES.getCode())
        //     .eq("status", DoctorStatusMarkConstant.Status.Abandon.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setAbandonCount(abandonCount);

        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return vo;
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return vo;
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        if (StrUtil.isBlank(params.getStageType())) {
            vo = doctorStatusMarkDataBizMapper.getTargetCountNoGroup(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "a.doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
            );
        } else {
            vo = doctorStatusMarkDataBizMapper.getTargetCountWithStageType(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "a.doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
            );
        }

        return vo;
    }

    @Override
    public DoctorTargetTotalCountVO targetHisTotalCount(DoctorTargetTotalCountQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        DoctorTargetTotalCountVO vo = new DoctorTargetTotalCountVO();

        // Long totalCount = doctorPatientStatusMarkHisInfoService.count(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
        //     .eq("op_type", OpTypeEnum.Create.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setTotalCount(totalCount);

        // Long doneCount = doctorPatientStatusMarkHisInfoService.count(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
        //     .eq("op_type", OpTypeEnum.Create.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.DONE.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setDoneCount(doneCount);

        // Long doingCount = doctorPatientStatusMarkHisInfoService.count(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
        //     .eq("op_type", OpTypeEnum.Create.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.DOING.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setDoingCount(doingCount);

        // Long expireCount = doctorPatientStatusMarkHisInfoService.count(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
        //     .eq("op_type", OpTypeEnum.Create.getCode())
        //     .eq("target_exe_status", DoctorStatusMarkConstant.TargetExeStatus.EXPIRE.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setExpireCount(expireCount);

        // Long abandonCount = doctorPatientStatusMarkHisInfoService.count(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
        //     .eq("op_type", OpTypeEnum.Create.getCode())
        //     .eq("status", DoctorStatusMarkConstant.Status.Abandon.getCode())
        //     .eq(StrUtil.isNotBlank(params.getTargetCode()), "target_code", params.getTargetCode())
        //     .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "target_code", params.getTargetCodes())
        //     .ge(null != params.getStartDate(), "op_time", params.getStartDate())
        //     .lt(null != params.getEndDate(), "op_time", params.getEndDate())
        // );
        // vo.setAbandonCount(abandonCount);

        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return vo;
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return vo;
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        if (StrUtil.isBlank(params.getStageType())) {
            vo = doctorStatusMarkDataBizMapper.getTargetHisCountNoGroup(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
                .eq("a.op_type", OpTypeEnum.Create.getCode())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "a.doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
            );
        } else {
            vo = doctorStatusMarkDataBizMapper.getTargetHisCountWithStageType(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
                .eq("a.op_type", OpTypeEnum.Create.getCode())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "a.doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
                .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
            );
        }

        return vo;
    }

    @Override
    public List<DoctorTargetCountVO> targetCount(DoctorTargetCountQueryDTO params) {
        return doctorStatusMarkDataBizMapper.getTargetCount(new QueryWrapper<DoctorPatientStatusMarkInfo>()
            .eq("a.rows_status", YN.YES.getCode())
            .eq(StrUtil.isNotBlank(params.getStatus()), "a.status", params.getStatus())
            .eq(StrUtil.isNotBlank(params.getTargetExeStatus()), "a.target_exe_status", params.getTargetExeStatus())
        );
    }

    @Override
    public List<DoctorTargetCountVO> targetHisCount(DoctorTargetCountQueryDTO params) {
        return doctorStatusMarkDataBizMapper.getTargetHisCount(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getStatus()), "a.status", params.getStatus())
            .eq(StrUtil.isNotBlank(params.getTargetExeStatus()), "a.target_exe_status", params.getTargetExeStatus())
        );
    }

    @Override
    public List<DoctorTargetCountWithDoctorVO> targetCountByDoctor() {
        List<DoctorTargetCountWithDoctorVO> list = doctorStatusMarkDataBizMapper.getTargetCountByDoctor(new QueryWrapper<DoctorPatientStatusMarkInfo>()
            .eq("a.rows_status", YN.YES.getCode())
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>();
        }

        // 查询医生及科室信息
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        Map<String, DeptBO> deptMap = new HashMap<>();

        List<String> doctorIds = new ArrayList<>();
        list.forEach(i -> doctorIds.add(i.getDoctorId()));

        // 医生
        List<String> deptIds = new ArrayList<>();
        List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
        doctorList.forEach(i -> {
            doctorMap.put(i.getId(), i);
            deptIds.add(i.getDeptId());
        });

        // 查询部门信息
        if (CollectionUtil.isNotEmpty(deptIds)) {
            List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
            deptList.forEach(i -> deptMap.put(i.getId(), i));
        }

        list.forEach(i -> {
            AdminUserBO doctor = doctorMap.get(i.getDoctorId());
            if (null != doctor) {
                i.setDoctorName(doctor.getRealName());

                DeptBO dept = deptMap.get(doctor.getDeptId());
                if (null != dept) {
                    i.setDeptName(dept.getName());
                }
            }
        });

        return list;
    }

    @Override
    public List<DoctorTargetCountWithDoctorVO> targetHisCountByDoctor() {
        List<DoctorTargetCountWithDoctorVO> list = doctorStatusMarkDataBizMapper.getTargetHisCountByDoctor(new QueryWrapper<DoctorPatientStatusMarkHisInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
        );
        
        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>();
        }

        // 查询医生及科室信息
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        Map<String, DeptBO> deptMap = new HashMap<>();

        List<String> doctorIds = new ArrayList<>();
        list.forEach(i -> doctorIds.add(i.getDoctorId()));

        // 医生
        List<String> deptIds = new ArrayList<>();
        List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
        doctorList.forEach(i -> {
            doctorMap.put(i.getId(), i);
            deptIds.add(i.getDeptId());
        });

        // 查询部门信息
        if (CollectionUtil.isNotEmpty(deptIds)) {
            List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
            deptList.forEach(i -> deptMap.put(i.getId(), i));
        }

        list.forEach(i -> {
            AdminUserBO doctor = doctorMap.get(i.getDoctorId());
            if (null != doctor) {
                i.setDoctorName(doctor.getRealName());

                DeptBO dept = deptMap.get(doctor.getDeptId());
                if (null != dept) {
                    i.setDeptName(dept.getName());
                }
            }
        });

        return list;
    }

    @Override
    public List<DoctorTargetCountTrendVO> targetCountTrend(DoctorTargetTotalCountTrendQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        if ("year".equals(params.getDateType())) {
            return doctorStatusMarkDataBizMapper.getTargetCountTrendMonth(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
            );
        }

        return doctorStatusMarkDataBizMapper.getTargetCountTrendDay(new QueryWrapper<DoctorPatientStatusMarkInfo>()
            .eq("a.rows_status", YN.YES.getCode())
            .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
            .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
            .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
            .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
            .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
        );
    }

    @Override
    public List<DoctorTargetCountTrendVO> targetHisCountTrend(DoctorTargetTotalCountTrendQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        if ("year".equals(params.getDateType())) {
            return doctorStatusMarkDataBizMapper.getTargetHisCountTrendMonth(new QueryWrapper<DoctorPatientStatusMarkInfo>()
                .eq("a.op_type", OpTypeEnum.Create.getCode())
                .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
                .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
                .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
            );
        }

        return doctorStatusMarkDataBizMapper.getTargetHisCountTrendDay(new QueryWrapper<DoctorPatientStatusMarkInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getTargetCode()), "a.target_code", params.getTargetCode())
            .in(CollectionUtil.isNotEmpty(params.getTargetCodes()), "a.target_code", params.getTargetCodes())
            .ge(null != params.getStartDate(), "a.op_time", params.getStartDate())
            .lt(null != params.getEndDate(), "a.op_time", params.getEndDate())
            .eq(StrUtil.isNotBlank(params.getStageType()), "b.type", params.getStageType())
        );
    }

}
