package com.xxh.cloud.healthy.doctor.crm.framework.modules.client;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.doctor.crm.client.api.DoctorBehaviorClientService;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorBehaviorBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorBehaviorDataCountBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.dto.DoctorBehaviorDataCountQueryClientDTO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.dto.DoctorBehaviorQueryClientDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorBehaviorDataCountQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorBehaviorQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorBehaviorDataCountVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorBehaviorVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.helper.DoctorPatientHelper;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorBehaviorService;

@Service
public class DoctorBehaviorClientServiceImpl implements DoctorBehaviorClientService {

    @Autowired
    private DoctorBehaviorService doctorBehaviorService;

    @Override
    public List<DoctorBehaviorDataCountBO> getBehaviorDataCount(DoctorBehaviorDataCountQueryClientDTO params) {
        
        DoctorBehaviorDataCountQueryDTO dataCountQueryDTO = new DoctorBehaviorDataCountQueryDTO();
        dataCountQueryDTO.setDoctorId(params.getDoctorId());
        dataCountQueryDTO.setOperatedType(params.getOperatedType());
        dataCountQueryDTO.setOperatedTypes(params.getOperatedTypes());
        dataCountQueryDTO.setRelOneType(params.getRelOneType());
        dataCountQueryDTO.setRelOneTypes(params.getRelOneTypes());
        dataCountQueryDTO.setRelOneId(params.getRelOneId());
        dataCountQueryDTO.setRelOneIds(params.getRelOneIds());
        dataCountQueryDTO.setRelTwoType(params.getRelTwoType());
        dataCountQueryDTO.setRelTwoTypes(params.getRelTwoTypes());
        dataCountQueryDTO.setRelTwoId(params.getRelTwoId());
        dataCountQueryDTO.setRelTwoIds(params.getRelTwoIds());
        dataCountQueryDTO.setStartDate(params.getStartDate());
        dataCountQueryDTO.setEndDate(params.getEndDate());
        List<DoctorBehaviorDataCountVO> list = doctorBehaviorService.getBehaviorDataCount(dataCountQueryDTO);

        return list.stream().map(i -> {
            DoctorBehaviorDataCountBO bo = new DoctorBehaviorDataCountBO();
            bo.setDoctorId(i.getDoctorId());
            bo.setRelOneType(i.getRelOneType());
            bo.setRelOneId(i.getRelOneId());
            bo.setType(i.getType());
            bo.setCount(i.getCount());
            return bo;
        }).collect(Collectors.toList());
    }

    @Override
    public DoctorBehaviorBO getFirstBehaviorData(DoctorBehaviorQueryClientDTO params) {
        
        DoctorBehaviorQueryDTO dataCountQueryDTO = new DoctorBehaviorQueryDTO();
        dataCountQueryDTO.setDoctorId(params.getDoctorId());
        dataCountQueryDTO.setOperatedType(params.getOperatedType());
        dataCountQueryDTO.setOperatedTypes(params.getOperatedTypes());
        dataCountQueryDTO.setRelOneType(params.getRelOneType());
        dataCountQueryDTO.setRelOneTypes(params.getRelOneTypes());
        dataCountQueryDTO.setRelOneId(params.getRelOneId());
        dataCountQueryDTO.setRelTwoType(params.getRelTwoType());
        dataCountQueryDTO.setRelTwoTypes(params.getRelTwoTypes());
        dataCountQueryDTO.setRelTwoId(params.getRelTwoId());
        dataCountQueryDTO.setStartDate(params.getStartDate());
        dataCountQueryDTO.setEndDate(params.getEndDate());
        DoctorBehaviorVO vo = doctorBehaviorService.firstSimple(dataCountQueryDTO);

        return DoctorPatientHelper.getDoctorBehaviorBO(vo);
    }
    
    @Override
    public List<DoctorBehaviorBO> listFirstBehaviorData(DoctorBehaviorQueryClientDTO params) {
        
        DoctorBehaviorQueryDTO dataCountQueryDTO = new DoctorBehaviorQueryDTO();
        dataCountQueryDTO.setDoctorId(params.getDoctorId());
        dataCountQueryDTO.setOperatedType(params.getOperatedType());
        dataCountQueryDTO.setOperatedTypes(params.getOperatedTypes());
        dataCountQueryDTO.setRelOneType(params.getRelOneType());
        dataCountQueryDTO.setRelOneTypes(params.getRelOneTypes());
        dataCountQueryDTO.setRelOneId(params.getRelOneId());
        dataCountQueryDTO.setRelTwoType(params.getRelTwoType());
        dataCountQueryDTO.setRelTwoTypes(params.getRelTwoTypes());
        dataCountQueryDTO.setRelTwoId(params.getRelTwoId());
        dataCountQueryDTO.setStartDate(params.getStartDate());
        dataCountQueryDTO.setEndDate(params.getEndDate());
        List<DoctorBehaviorVO> list = doctorBehaviorService.firstSimpleList(dataCountQueryDTO);

        return list.stream().map(DoctorPatientHelper::getDoctorBehaviorBO).collect(Collectors.toList());
    }
    
}
