package com.xxh.cloud.healthy.doctor.crm.framework.modules.client;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.doctor.crm.client.api.DoctorPatientRemarkClientService;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorPatientRemarkBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.dto.DoctorPatientRemarkQueryClientDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.dto.DoctorPatientRemarkQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.bean.vos.DoctorPatientRemarkVO;
import com.xxh.cloud.healthy.doctor.crm.framework.modules.biz.service.DoctorPatientRemarkService;

@Service
public class DoctorPatientRemarkClientServiceImpl implements DoctorPatientRemarkClientService {

    @Autowired
    private DoctorPatientRemarkService doctorPatientRemarkService;

    @Override
    public List<DoctorPatientRemarkBO> list(DoctorPatientRemarkQueryClientDTO params) {
        
        DoctorPatientRemarkQueryDTO queryDTO = new DoctorPatientRemarkQueryDTO();
        queryDTO.setDoctorId(params.getDoctorId());
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setRelOneType(params.getRelOneType());
        queryDTO.setRelOneId(params.getRelOneId());
        queryDTO.setStartDate(params.getStartDate());
        queryDTO.setEndDate(params.getEndDate());
        queryDTO.setQueryParams(params.getQueryParams());
        List<DoctorPatientRemarkVO> list = doctorPatientRemarkService.list(queryDTO);

        return list.stream().map(i -> {
            DoctorPatientRemarkBO bo = new DoctorPatientRemarkBO();
            bo.setId(i.getId());
            bo.setDoctorId(i.getDoctorId());
            bo.setPatientId(i.getPatientId());
            bo.setRelOneType(i.getRelOneType());
            bo.setRelOneId(i.getRelOneId());
            bo.setRemark(i.getRemark());
            bo.setCreateDate(i.getCreateDate());
            bo.setUpdateDate(i.getUpdateDate());
            return bo;
        }).collect(Collectors.toList());
    }
}
