package com.xxh.cloud.healthy.basic.framework.modules.article.bean.vos;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.healthy.basic.article.client.api.bean.bos.ArticleCategoryBO;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class ArticleVO {




    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "标题")
    private String title;


    @ApiModelProperty(value = "推送内容")
    private String messasgeConent;


    @ApiModelProperty(value = "概要")
    private String summary;


    @ApiModelProperty(value = "缩略图")
    private String thumbnail;


    @ApiModelProperty(value = "文章分类(多)")
    private List<String> articleCategoryIds;

    @ApiModelProperty(value = "所属科室(多)")
    private  List<String>  deptIds;

    @ApiModelProperty(value = "疾病ID(多)")
    private  List<String>  diseaseIds;

    @ApiModelProperty(value = "标签(多)")
    private List<String> labelIds;


    @ApiModelProperty(value = "文章业务分类")
    private String articleBizType;


    @ApiModelProperty(value = "作者")
    private String author;


    @ApiModelProperty(value = "来源")
    private String source;


    @ApiModelProperty(value = "内容")
    private String content;


    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "评论状态")
    private String commentStatus;


    @ApiModelProperty(value = "草稿箱状态")
    private String draftStatus;


    @ApiModelProperty(value = "关联业务ID分类")
    private String relIdType;


    @ApiModelProperty(value = "关联业务ID")
    private String relId;



    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;

    //===========================================

    @ApiModelProperty(value = "文章分类(多)")
    private List<ArticleCategoryBO> articleCategoryList;

    @ApiModelProperty(value = "所属科室(多)")
    private  List<DeptBO>  deptList;

    @ApiModelProperty(value = "标签(多)")
    private List<LabelBO> labelList;

    @ApiModelProperty(value = "疾病(多)")
    private List<StandardDiseaseBO> diseaseList;

    @ApiModelProperty("创建者")
    private String creatorName;

    @ApiModelProperty("更新者")
    private String updaterName;


    @ApiModelProperty(value = "文章分类名称(多)")
    private String articleCategoryNames;

    @ApiModelProperty(value = "所属科室名称(多)")
    private  String  deptNames;

    @ApiModelProperty(value = "标签名称(多)")
    private String labelNames;

    @ApiModelProperty(value = "疾病名称(多)")
    private String diseaseNames;

    public void addArticleCategory(ArticleCategoryBO item){
        if(this.articleCategoryList==null){
            this.articleCategoryList=new ArrayList<>();
        }
        if(item!=null){
            this.articleCategoryList.add(item);
        }
    }

    public void addDept(DeptBO item){
        if(this.deptList==null){
            this.deptList=new ArrayList<>();
        }
        if(item!=null){
            this.deptList.add(item);
        }
    }

    public void addLabel(LabelBO item){
        if(this.labelList==null){
            this.labelList=new ArrayList<>();
        }
        if(item!=null){
            this.labelList.add(item);
        }
    }

    public void addDisease(StandardDiseaseBO item){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }
        if(item!=null){
            this.diseaseList.add(item);
        }
    }


}
