package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 文章信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_article_info")
public class ArticleInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 标题
     */
     @ApiModelProperty(value = "标题")
      private String title;

    /**
     * 推送内容
     */
     @ApiModelProperty(value = "推送内容")
      private String messasgeConent;

    /**
     * 概要
     */
     @ApiModelProperty(value = "概要")
      private String summary;

    /**
     * 缩略图
     */
     @ApiModelProperty(value = "缩略图")
      private String thumbnail;

    /**
     * 文章分类(多)
     */
     @ApiModelProperty(value = "文章分类(多)")
      private String articleCategoryIds;

    /**
     * 所属科室(多)
     */
     @ApiModelProperty(value = "所属科室(多)")
      private String deptIds;

    /**
     * 文章业务分类
     */
     @ApiModelProperty(value = "文章业务分类")
      private String articleBizType;

    /**
     * 作者
     */
     @ApiModelProperty(value = "作者")
      private String author;

    /**
     * 来源
     */
     @ApiModelProperty(value = "来源")
      private String source;

    /**
     * 标签(多)
     */
     @ApiModelProperty(value = "标签(多)")
      private String labelIds;

    @ApiModelProperty(value = "病种ID(多)")
     private String diseaseIds;

    /**
     * 内容
     */
     @ApiModelProperty(value = "内容")
      private String content;

    /**
     * 顺序
     */
     @ApiModelProperty(value = "顺序")
      private Integer orders;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 评论状态
     */
     @ApiModelProperty(value = "评论状态")
      private String commentStatus;

    /**
     * 草稿箱状态
     */
     @ApiModelProperty(value = "草稿箱状态")
      private String draftStatus;

    /**
     * 关联业务ID分类
     */
     @ApiModelProperty(value = "关联业务ID分类")
      private String relIdType;

    /**
     * 关联业务ID
     */
     @ApiModelProperty(value = "关联业务ID")
      private String relId;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;


}
