package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.article.client.api.ArticleCategoryClientService;
import com.xxh.cloud.healthy.basic.article.client.api.bean.bos.ArticleCategoryBO;
import com.xxh.cloud.healthy.basic.framework.modules.article.bean.vos.ArticleCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.ArticleCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.client.helper.ArticleBOConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class ArticleCategoryClientServiceImpl implements ArticleCategoryClientService {

    @Autowired
    private ArticleCategoryCacheService articleCategoryCacheService;

    @Override
    public ArticleCategoryBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        ArticleCategoryVO entity = articleCategoryCacheService.getById(id);
        return ArticleBOConvert.getArticleCategoryBO(entity);
    }

    @Override
    public List<ArticleCategoryBO> getListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<ArticleCategoryVO> list = articleCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(ArticleBOConvert::getArticleCategoryBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, ArticleCategoryBO> getMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<ArticleCategoryVO> list = articleCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(ArticleCategoryVO::getId, ArticleBOConvert::getArticleCategoryBO)));
    }
}
