package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.HealthyBasicCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.FoodCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.dos.FoodInfo;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodVO;
import com.xxh.cloud.healthy.basic.framework.modules.food.helper.FoodHelper;
import com.xxh.cloud.healthy.basic.framework.modules.food.service.FoodInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class FoodCacheServiceImpl extends BasicCacheServiceImpl<FoodVO> implements FoodCacheService {

    @Autowired
    private FoodInfoService foodInfoService;

    @Override
    public String getCacheKey(String id) {
        return HealthyBasicCacheKeysHelper.getFoodKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return HealthyBasicCacheKeysHelper.getFoodMainKey();
    }

    @Override
    public Class<FoodVO> getJsonClazz() {
        return FoodVO.class;
    }

    @Override
    public String getId(FoodVO entity) {
        return entity.getId();
    }

    @Override
    public FoodVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        FoodInfo entity= foodInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return FoodHelper.getFoodVO(entity);
    }

    @Override
    public List<FoodVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<FoodVO> data=new ArrayList<>();
        List<FoodInfo> list = foodInfoService.list(new QueryWrapper<FoodInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)

        );
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            data.add(FoodHelper.getFoodVO(item));
        });
        return data;
    }

}
