package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.HealthyBasicCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.FoodCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.dos.FoodCategoryInfo;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.food.helper.FoodCategoryHelper;
import com.xxh.cloud.healthy.basic.framework.modules.food.service.FoodCategoryInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class FoodCategoryCacheServiceImpl extends BasicCacheServiceImpl<FoodCategoryVO> implements FoodCategoryCacheService {


    @Autowired
    private FoodCategoryInfoService foodCategoryInfoService;



    @Override
    public String getCacheKey(String id) {
        return HealthyBasicCacheKeysHelper.getFoodCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return HealthyBasicCacheKeysHelper.getFoodCategoryMainKey();
    }

    @Override
    public Class<FoodCategoryVO> getJsonClazz() {
        return FoodCategoryVO.class;
    }

    @Override
    public String getId(FoodCategoryVO entity) {
        return entity.getId();
    }

    @Override
    public FoodCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        FoodCategoryInfo entity= foodCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return FoodCategoryHelper.getFoodCategoryVO(entity);

    }

    @Override
    public List<FoodCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<FoodCategoryInfo> list= foodCategoryInfoService.list(new QueryWrapper<FoodCategoryInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );

        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<FoodCategoryVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(FoodCategoryHelper.getFoodCategoryVO(item));
        });
        return data;
    }



}
