package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.HealthyBasicCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.RiskCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.vos.RiskVO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.service.RiskInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

@Service
public class RiskCacheServiceImpl   extends BasicCacheServiceImpl<RiskVO>  implements RiskCacheService {

    @Autowired
    public RiskInfoService riskInfoService;

    @Override
    public String getCacheKey(String id) {
        return HealthyBasicCacheKeysHelper.getRiskKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return HealthyBasicCacheKeysHelper.getRiskMainKey();
    }

    @Override
    public Class<RiskVO> getJsonClazz() {
        return RiskVO.class;
    }

    @Override
    public String getId(RiskVO entity) {
        return entity.getId();
    }

    @Override
    public RiskVO getById2DB(String id) {
        return riskInfoService.info2NullById(id);
    }

    @Override
    public List<RiskVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        return riskInfoService.list2NullById(ids);
    }
}
