package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.HealthyBasicCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.SportCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dos.SportInfo;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportVO;
import com.xxh.cloud.healthy.basic.framework.modules.sport.helper.SportHelper;
import com.xxh.cloud.healthy.basic.framework.modules.sport.service.SportInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class SportCacheServiceImpl  extends BasicCacheServiceImpl<SportVO> implements SportCacheService {

    @Autowired
    private SportInfoService sportInfoService;



    @Override
    public String getCacheKey(String id) {
        return HealthyBasicCacheKeysHelper.getSportKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return HealthyBasicCacheKeysHelper.getSportMainKey();
    }

    @Override
    public Class<SportVO> getJsonClazz() {
        return SportVO.class;
    }

    @Override
    public String getId(SportVO entity) {
        return entity.getId();
    }

    @Override
    public SportVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        SportInfo entity= sportInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return SportHelper.getSportVO(entity);
    }

    @Override
    public List<SportVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<SportInfo> list = sportInfoService.list(new QueryWrapper<SportInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );

        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<SportVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(SportHelper.getSportVO(item));
        });
        return data;
    }


}
