package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.HealthyBasicCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.SportCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dos.SportCategoryInfo;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.sport.helper.SportCategoryHelper;
import com.xxh.cloud.healthy.basic.framework.modules.sport.service.SportCategoryInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class SportCategoryCacheServiceImpl extends BasicCacheServiceImpl<SportCategoryVO> implements SportCategoryCacheService {

    @Autowired
    private SportCategoryInfoService sportCategoryInfoService;

    @Override
    public String getCacheKey(String id) {
        return HealthyBasicCacheKeysHelper.getSportCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return HealthyBasicCacheKeysHelper.getSportCategoryMainKey();
    }

    @Override
    public Class<SportCategoryVO> getJsonClazz() {
        return SportCategoryVO.class;
    }

    @Override
    public String getId(SportCategoryVO entity) {
        return entity.getId();
    }

    @Override
    public SportCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        SportCategoryInfo entity= sportCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return SportCategoryHelper.getSportCategoryVO(entity);
    }

    @Override
    public List<SportCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<SportCategoryInfo> list = sportCategoryInfoService.list(new QueryWrapper<SportCategoryInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<SportCategoryVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(SportCategoryHelper.getSportCategoryVO(item));
        });
        return data;
    }

}
