package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.client.api.SportCategoryClientService;
import com.xxh.cloud.healthy.basic.client.api.bean.bos.SportCategoryBO;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.SportCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.client.helper.SportBOConvert;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportCategoryVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class SportCategoryClientServiceImpl implements SportCategoryClientService {

    @Autowired
    private SportCategoryCacheService sportCategoryCacheService;


    @Override
    public SportCategoryBO getSportCategoryById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        SportCategoryVO disease = sportCategoryCacheService.getById(id);
        return SportBOConvert.getSportCategoryBO(disease);
    }

    @Override
    public List<SportCategoryBO> getSportCategoryListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<SportCategoryVO> list = sportCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(SportBOConvert::getSportCategoryBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, SportCategoryBO> getSportCategoryMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<SportCategoryVO> list = sportCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(SportCategoryVO::getId, SportBOConvert::getSportCategoryBO)));
    }
}
