package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.client.api.SportClientService;
import com.xxh.cloud.healthy.basic.client.api.bean.bos.SportBO;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.SportCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.client.helper.SportBOConvert;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class SportClientServiceImpl implements SportClientService {

    @Autowired
    private SportCacheService sportCacheService;


    @Override
    public SportBO getSportById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        SportVO disease = sportCacheService.getById(id);
        return SportBOConvert.getSportBO(disease);
    }

    @Override
    public List<SportBO> getSportListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<SportVO> list = sportCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(SportBOConvert::getSportBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, SportBO> getSportMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<SportVO> list = sportCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }
        return new HashMap<>(list.stream().collect(Collectors.toMap(SportVO::getId, SportBOConvert::getSportBO)));
    }

}
