package com.xxh.cloud.healthy.basic.framework.modules.disease.client;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.basic.client.api.EntityDiseaseConfigClientService;
import com.xxh.cloud.healthy.basic.client.api.bean.dto.EntityDiseaseConfigListClientDTO;
import com.xxh.cloud.healthy.basic.client.api.bean.dto.EntityDiseaseConfigSaveClientDTO;
import com.xxh.cloud.healthy.basic.framework.modules.disease.biz.bean.dto.EntityDiseaseConfigListDTO;
import com.xxh.cloud.healthy.basic.framework.modules.disease.biz.bean.dto.EntityDiseaseConfigSaveDTO;
import com.xxh.cloud.healthy.basic.framework.modules.disease.biz.service.EntityDiseaseConfigBizService;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;

@Service
public class EntityDiseaseConfigClientServiceImpl implements EntityDiseaseConfigClientService {

    @Autowired
    private EntityDiseaseConfigBizService entityDiseaseConfigBizService;

    @Override
    public List<String> getDiseaseByEntityId(String entityId) {
        if (StrUtil.isBlank(entityId)) {
            return new ArrayList<>(0);
        }
        return entityDiseaseConfigBizService.getDiseaseByEntityId(entityId);
    }

    @Override
    public Map<String, List<String>> listDiseaseMap(EntityDiseaseConfigListClientDTO params) {
        EntityDiseaseConfigListDTO query = new EntityDiseaseConfigListDTO();
        query.setEntityType(params.getEntityType());
        query.setEntityId(params.getEntityId());
        query.setEntityIds(params.getEntityIds());
        return entityDiseaseConfigBizService.listDiseaseMap(query);
    }
    
    @Override
    public void saveDiseaseByEntityId(EntityDiseaseConfigSaveClientDTO params) {
        EntityDiseaseConfigSaveDTO save = new EntityDiseaseConfigSaveDTO();
        save.setEntityType(params.getEntityType());
        save.setEntityId(params.getEntityId());
        save.setDiseaseIds(params.getDiseaseIds());
        entityDiseaseConfigBizService.saveDiseaseByEntityId(save);
    }

    @Override
    public void saveDisease(List<EntityDiseaseConfigSaveClientDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }
        List<EntityDiseaseConfigSaveDTO> saveList = new ArrayList<>();
        saveList.forEach(i -> {
            EntityDiseaseConfigSaveDTO save = new EntityDiseaseConfigSaveDTO();
            save.setEntityType(i.getEntityType());
            save.setEntityId(i.getEntityId());
            save.setDiseaseIds(i.getDiseaseIds());
            saveList.add(save);
        });
        entityDiseaseConfigBizService.saveDisease(saveList);
    }

}
