package com.xxh.cloud.healthy.basic.framework.modules.food.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * 饮食配置信息
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_food_info")
public class FoodInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 分类ID
     */
     @ApiModelProperty(value = "分类ID")
      private String categoryId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 缩略图
     */
     @ApiModelProperty(value = "缩略图")
      private String thumbnail;

    /**
     * 重量(克)
     */
     @ApiModelProperty(value = "重量(克)")
      private Integer weight;

    /**
     * 消耗卡路里
     */
     @ApiModelProperty(value = "消耗卡路里")
      private Integer calorie;

    /**
     * 消耗单位
     */
     @ApiModelProperty(value = "消耗单位")
      private String unit;

    /**
     * 视频路径
     */
     @ApiModelProperty(value = "视频路径")
      private String videoPath;

    /**
     * 营养功能配比
     */
     @ApiModelProperty(value = "营养功能配比")
      private String nutritionRatio;

    /**
     * 成分配比
     */
     @ApiModelProperty(value = "成分配比")
      private String componentRatio;

    /**
     * 料理方法
     */
     @ApiModelProperty(value = "料理方法")
      private String cookingMethod;

    /**
     * 禁忌条件
     */
     @ApiModelProperty(value = "禁忌条件")
      private String taboo;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;



    /**
     * 菜单分类
     */
     @ApiModelProperty(value = "菜单分类")
      private String type;


}
