package com.xxh.cloud.healthy.basic.framework.modules.food.entity.dto;

import com.xxh.cloud.healthy.basic.framework.modules.food.entity.enums.FoodTypeEnum;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodComponentRatio;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodNutritionRatio;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.TabooConditionModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
public class FoodInfoSaveParam {



    @ApiModelProperty(value = "分类(FoodTypeEnum)",required = true)
    private String type= FoodTypeEnum.Food.getCode();


    @ApiModelProperty(value = "名称",required = true)
    private String name;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "病种ID")
    private String diseaseId;


    @ApiModelProperty(value = "缩略图")
    private String thumbnail;


    @ApiModelProperty(value = "重量(克)")
    private Integer weight;


    @ApiModelProperty(value = "消耗卡路里")
    private Integer calorie;


    @ApiModelProperty(value = "消耗单位")
    private String unit;


    @ApiModelProperty(value = "视频路径")
    private String videoPath;


    @ApiModelProperty(value = "成分配比")
    private List<FoodComponentRatio> componentRatio;


    @ApiModelProperty(value = "营养配比")
    private List<FoodNutritionRatio> nutritionRatio;


    @ApiModelProperty(value = "料理方法")
    private String cookingMethod;


    @ApiModelProperty(value = "禁忌条件")
    private List<TabooConditionModel> taboo;


    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "状态(YN)",required = true)
    private String status;

}
