package com.xxh.cloud.healthy.basic.framework.modules.food.entity.dto;

import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodComponentRatio;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodNutritionRatio;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.TabooConditionModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class FoodInfoUpdateParam {

    @ApiModelProperty(value = "id",required = true)
    @NotEmpty(message = "ID不能为空")
    private String id;


    @ApiModelProperty(value = "分类(FoodConfigTypeEnum)")
    private String type;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "病种ID")
    private String diseaseId;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "缩略图")
    private String thumbnail;


    @ApiModelProperty(value = "重量(克)")
    private Integer weight;


    @ApiModelProperty(value = "消耗卡路里")
    private Integer calorie;


    @ApiModelProperty(value = "消耗单位")
    private String unit;


    @ApiModelProperty(value = "视频路径")
    private String videoPath;


    @ApiModelProperty(value = "成分配比")
    private List<FoodComponentRatio> componentRatio;


    @ApiModelProperty(value = "营养配比")
    private List<FoodNutritionRatio> nutritionRatio;


    @ApiModelProperty(value = "料理方法")
    private String cookingMethod;


    @ApiModelProperty(value = "禁忌条件")
    private List<TabooConditionModel> taboo;


    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "状态(YN)")
    private String status;

}
