package com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

@Getter
@Setter
public class FoodVO {




    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "菜谱分类")
    private String type;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "缩略图")
    private String thumbnail;


    @ApiModelProperty(value = "重量(克)")
    private Integer weight;


    @ApiModelProperty(value = "消耗卡路里")
    private Integer calorie;


    @ApiModelProperty(value = "消耗单位")
    private String unit;


    @ApiModelProperty(value = "视频路径")
    private String videoPath;



    @ApiModelProperty(value = "料理方法")
    private String cookingMethod;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "创建者")
    private String creator;


    @ApiModelProperty(value = "创建时间")
    private Date createDate;


    @ApiModelProperty(value = "更新者")
    private String updater;


    @ApiModelProperty(value = "更新时间")
    private Date updateDate;




    @ApiModelProperty(value = "营养配比")
    private List<FoodNutritionRatio> nutritionRatio;

    @ApiModelProperty(value = "成分配比")
    private List<FoodComponentRatio> componentRatio;

    @ApiModelProperty(value = "禁忌条件")
    private List<TabooConditionModel> taboo;


    //========================================



    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;


    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;


    @ApiModelProperty(value = "分类名称")
    private String categoryName;


    @ApiModelProperty(value = "病种名称")
    private String diseaseName;


}
