package com.xxh.cloud.healthy.basic.framework.modules.food.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.dos.FoodInfo;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.*;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class FoodHelper {

    /**
     *  食品ID
     * */
    public static String getFoodId(){
        return StrUtil.format("F{}", IdUtil.getSnowflake(5,2).nextIdStr());
    }


    public static FoodVO getFoodVO(FoodInfo entity){
        if(entity==null){
            return null;
        }
        FoodVO data=new FoodVO();
        BeanUtil.copyProperties(entity,data,"nutritionRatio","componentRatio","taboo");
        if(StrUtil.isNotEmpty(entity.getNutritionRatio())){
            data.setNutritionRatio(JSON.parseArray(entity.getNutritionRatio(), FoodNutritionRatio.class));
        }
        if(StrUtil.isNotEmpty(entity.getComponentRatio())){
            data.setComponentRatio(JSON.parseArray(entity.getComponentRatio(), FoodComponentRatio.class));
        }
        if(StrUtil.isNotEmpty(entity.getTaboo())){
            data.setTaboo(JSON.parseArray(entity.getTaboo(), TabooConditionModel.class));
        }

        return data;
    }


    public static FoodVO getFoodVO(FoodInfo entity, Map<String, AdminUserBO> userMap,
                                   Map<String, FoodCategoryVO> foodCategoryMap){
        FoodVO data=getFoodVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }

            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

//        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
//            DiseaseBO disease = diseaseMap.get(data.getDiseaseId());
//            if(disease!=null){
//                data.setDiseaseName(disease.getName());
//            }
//        }

        if(MapUtil.isNotEmpty(foodCategoryMap) && StrUtil.isNotEmpty(data.getCategoryId())){
            FoodCategoryVO foodCategory = foodCategoryMap.get(data.getCategoryId());
            if(foodCategory!=null){
                data.setCategoryName(foodCategory.getName());
            }
        }

        return data;
    }




}
