package com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 风险信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_risk_info")
public class RiskInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 等级
     */
     @ApiModelProperty(value = "等级")
      private String grade;

    /**
     * 疾病ID
     */
     @ApiModelProperty(value = "疾病ID")
      private String diseaseId;

    /**
     * 危害(疾病ID)
     */
     @ApiModelProperty(value = "危害(疾病ID)")
      private String harm;

    /**
     * 关联标签编号
     */
     @ApiModelProperty(value = "关联标签编号")
      private String labelIds;

    /**
     * 风险疾病简介
     */
     @ApiModelProperty(value = "风险疾病简介")
      private String remark;

    /**
     * 风险预防要点
     */
     @ApiModelProperty(value = "风险预防要点")
      private String prevention;

    /**
     * 未来发展描述
     */
     @ApiModelProperty(value = "未来发展描述")
      private String futureMemo;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 简介1
     */
     @ApiModelProperty(value = "简介1")
      private String memo;

    /**
     * 症状1
     */
     @ApiModelProperty(value = "症状1")
      private String symptom;

    /**
     * 病因1
     */
     @ApiModelProperty(value = "病因1")
      private String pathogeny;

    /**
     * 并发症1
     */
     @ApiModelProperty(value = "并发症1")
      private String complication;

    /**
     * 预防鉴别1
     */
     @ApiModelProperty(value = "预防鉴别1")
      private String preventionIdentification;

    /**
     * 治疗1
     */
     @ApiModelProperty(value = "治疗1")
      private String treatment;

    /**
     * 就诊1
     */
     @ApiModelProperty(value = "就诊1")
      private String seekMedicalAdvice;

    /**
     * 检查1
     */
     @ApiModelProperty(value = "检查1")
      private String inspect;

    /**
     * 护理1
     */
     @ApiModelProperty(value = "护理1")
      private String nursing;

    /**
     * 饮食1
     */
     @ApiModelProperty(value = "饮食1")
      private String diet;

    /**
     * 数据来源
     */
     @ApiModelProperty(value = "数据来源")
      private String source;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;


}
