package com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class RiskSaveDTO {


    @ApiModelProperty(value = "名称",required = true)
    @NotEmpty(message = "名称不能为空")
    private String name;


    @ApiModelProperty(value = "等级")
    private String grade;


    @ApiModelProperty(value = "疾病ID")
    private String diseaseId;

    @ApiModelProperty(value = "危害(疾病ID)")
    private String harm;

    @ApiModelProperty(value = "关联标签编号")
    private List<String> labelIds;

    @ApiModelProperty(value = "风险疾病简介")
    private String remark;

    @ApiModelProperty(value = "风险预防要点")
    private String prevention;

    @ApiModelProperty(value = "未来发展描述")
    private String futureMemo;

//    @ApiModelProperty(value = "状态")
//    private String status;

    @ApiModelProperty(value = "简介1")
    private String memo;

    @ApiModelProperty(value = "症状")
    private String symptom;

    @ApiModelProperty(value = "病因")
    private String pathogeny;

    @ApiModelProperty(value = "并发症")
    private String complication;

    @ApiModelProperty(value = "预防鉴别")
    private String preventionIdentification;

    @ApiModelProperty(value = "治疗")
    private String treatment;

    @ApiModelProperty(value = "就诊")
    private String seekMedicalAdvice;

    @ApiModelProperty(value = "检查")
    private String inspect;

    @ApiModelProperty(value = "护理")
    private String nursing;

    @ApiModelProperty(value = "饮食")
    private String diet;


    @ApiModelProperty(value = "数据来源")
    private String source;

    @ApiModelProperty(value = "风险因素")
    private List<RiskFactorOpDTO> factor;



}
