package com.xxh.cloud.healthy.basic.framework.modules.risk.entity.vos;

import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto.RiskFactorOpDTO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class RiskVO {



    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "等级")
    private String grade;


    @ApiModelProperty(value = "疾病ID")
    private String diseaseId;


    @ApiModelProperty(value = "危害(疾病ID)")
    private String harm;


    @ApiModelProperty(value = "关联标签编号")
    private String labelIds;


    @ApiModelProperty(value = "风险疾病简介")
    private String remark;


    @ApiModelProperty(value = "风险预防要点")
    private String prevention;


    @ApiModelProperty(value = "未来发展描述")
    private String futureMemo;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "简介1")
    private String memo;


    @ApiModelProperty(value = "症状1")
    private String symptom;


    @ApiModelProperty(value = "病因1")
    private String pathogeny;


    @ApiModelProperty(value = "并发症1")
    private String complication;


    @ApiModelProperty(value = "预防鉴别1")
    private String preventionIdentification;


    @ApiModelProperty(value = "治疗1")
    private String treatment;


    @ApiModelProperty(value = "就诊1")
    private String seekMedicalAdvice;


    @ApiModelProperty(value = "检查1")
    private String inspect;


    @ApiModelProperty(value = "护理1")
    private String nursing;


    @ApiModelProperty(value = "饮食1")
    private String diet;


    @ApiModelProperty(value = "数据来源")
    private String source;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;

    //================================

    @ApiModelProperty(value = "风险因素")
    private List<RiskFactorVO> factor;

    @ApiModelProperty(value = "疾病名称")
    private String diseaseName;

    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;

    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;

    public void addFactor(RiskFactorVO item){
        if(this.factor==null){
            this.factor=new ArrayList<>();
        }
        if(item!=null){
            this.factor.add(item);
        }
    }

}
