package com.xxh.cloud.healthy.basic.framework.modules.risk.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dos.RiskFactorInfo;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dos.RiskInfo;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.vos.RiskFactorVO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.vos.RiskVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.List;
import java.util.Map;

public class RiskHelper {


    /**
     * RiskInfo id
     * */
    public static String getRiskId(){
        return IdUtil.getSnowflake(5,8).nextIdStr();
    }

    /**
     * RiskFactorInfo id
     * */
    public static String getRiskFactorId(){
        return IdUtil.getSnowflake(5,9).nextIdStr();
    }

    public static RiskVO  getRiskVO(RiskInfo entity){
        RiskVO data=new RiskVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static RiskVO  getRiskVO(RiskInfo entity,Map<String, AdminUserBO> userMap){
        RiskVO data=new RiskVO();



        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user=userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }

            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user=userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        return data;
    }


    public static RiskVO  getRiskVO(RiskInfo entity, List<RiskFactorInfo> factorList , Map<String, AdminUserBO> userMap){
        RiskVO data=getRiskVO(entity,userMap);
        if(CollUtil.isNotEmpty(factorList)){
            factorList.forEach(item->{
                if(data.getId().equals(item.getRiskId())){
                    data.addFactor(getRiskFactorVO(item));
                }
            });
        }
        return data;
    }

    public static RiskFactorVO getRiskFactorVO(RiskFactorInfo entity){
        RiskFactorVO data=new RiskFactorVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

}
