package com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.dos.HealthyServiceInfo;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.vos.*;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class HealthyServiceHelper {


    /**
     * ID
     * */
    public static String getHealthyServiceId(){
        return StrUtil.format("S{}", IdUtil.getSnowflake(5,11).nextIdStr());
    }

    /**
     *
     * */
    public static HealthyServiceVO getHealthyServiceVO(HealthyServiceInfo entity){
        if(entity==null){
            return null;
        }
        HealthyServiceVO data=new HealthyServiceVO();
        BeanUtil.copyProperties(entity,data,"sendCondition","sendStrategy","content");
        if(StrUtil.isNotEmpty(entity.getSendCondition())){
            data.setSendCondition(JSON.parseObject(entity.getSendCondition(), HealthyServiceSendCondtionBean.class));
        }
        if(StrUtil.isNotEmpty(entity.getSendStrategy())){
            data.setSendStrategy(JSON.parseObject(entity.getSendStrategy(), HealthyServiceSendStrategyBean.class));
        }
        if(StrUtil.isNotEmpty(entity.getContent())){
            data.setContent(JSON.parseArray(entity.getContent(), HealthyServiceContentBean.class));
        }

        return data;
    }


    public static HealthyServiceVO getHealthyServiceVO(HealthyServiceInfo entity,
                                                          Map<String, HealthyServiceTargetVO> serviceGroupMap,
                                                          Map<String, AdminUserBO>  userMap){
        HealthyServiceVO data= HealthyServiceHelper.getHealthyServiceVO(entity);
        if(data==null){
            return data;
        }

//        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
//            DiseaseBO disease = diseaseMap.get(data.getDiseaseId());
//            if(disease!=null){
//                data.setDiseaseName(disease.getName());
//            }
//        }

        if(MapUtil.isNotEmpty(serviceGroupMap)){
            if(StrUtil.isNotEmpty(data.getServiceTargetId())){
                HealthyServiceTargetVO hsgm = serviceGroupMap.get(data.getServiceTargetId());
                data.setServiceTargetName(hsgm==null?null:hsgm.getName());
            }
        }

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

        return data;
    }




//    public static HealthyServiceModel getHealthyServiceBean2Model(HealthyServiceBean bean){
//        HealthyServiceModel data=new HealthyServiceModel();
//        data.setId(bean.getId());
//        data.setName(bean.getName());
//        data.setServiceTargetId(bean.getServiceTargetId());
//        data.setContentType(bean.getContentType());
//        data.setContent(bean.getContent());
//        data.setRemindTemplate(bean.getRemindTemplate());
//        data.setSendCondition(bean.getSendCondition());
//        data.setSendStrategy(bean.getSendStrategy());
//        data.setContentSuggest(bean.getContentSuggest());
//        return data;
//    }


}
