package com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.dos.HealthyServiceTargetInfo;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.vos.HealthyServeGroupTargetModel;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.vos.HealthyServiceTargetVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class HealthyServiceTargetHelper {


    /**
     * ID
     * */
    public static String getHealthyServiceTargetId(){
        return StrUtil.format("ST{}", IdUtil.getSnowflake(5,10).nextIdStr());
    }

    public static HealthyServiceTargetVO getHealthyServiceTargetVO(HealthyServiceTargetInfo entity){
        if(entity==null){
            return null;
        }
        HealthyServiceTargetVO data=new HealthyServiceTargetVO();
        BeanUtil.copyProperties(entity,data,"targetConfig");
        if(StrUtil.isNotEmpty(entity.getTargetConfig())){
            data.setTargetConfig(JSON.parseArray(entity.getTargetConfig(), HealthyServeGroupTargetModel.class));
        }
        return data;
    }


    public static HealthyServiceTargetVO getHealthyServiceTargetVO(HealthyServiceTargetInfo entity,
                                                                   Map<String, AdminUserBO> userMap){
        HealthyServiceTargetVO data=getHealthyServiceTargetVO(entity);


//        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
//            DiseaseBO disease = diseaseMap.get(data.getDiseaseId());
//            if(disease!=null){
//                data.setDiseaseName(disease.getName());
//            }
//        }

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        return data;
    }


}
