package com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * 运动信息
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_sport_info")
public class SportInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 分类
     */
     @ApiModelProperty(value = "分类")
      private String categoryId;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 缩略图
     */
     @ApiModelProperty(value = "缩略图")
      private String thumbnail;

    /**
     * 消耗卡路里
     */
     @ApiModelProperty(value = "消耗卡路里")
      private Integer calorie;

    /**
     * 消耗单位
     */
     @ApiModelProperty(value = "消耗单位")
      private String unit;

    /**
     * 运动视频路径
     */
     @ApiModelProperty(value = "运动视频路径")
      private String videoPath;

    /**
     * 运动说明
     */
     @ApiModelProperty(value = "运动说明")
      private String memo;

    /**
     * 禁忌条件
     */
     @ApiModelProperty(value = "禁忌条件")
      private String taboo;

    /**
     * MET值
     */
     @ApiModelProperty(value = "MET值")
      private String metVal;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;



}
