package com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dto;

import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.TabooConditionModel;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportMemo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class SportInfoUpdateDTO {


    @ApiModelProperty(value = "id",required = true)
    @NotEmpty(message = "ID不能为空")
    private String id;


    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "分类")
    private String categoryId;

    @ApiModelProperty(value = "名称" )
    private String name;


    @ApiModelProperty(value = "缩略图")
    private String thumbnail;


    @ApiModelProperty(value = "消耗卡路里")
    private Integer calorie;


    @ApiModelProperty(value = "消耗单位")
    private String unit;


    @ApiModelProperty(value = "运动视频路径")
    private String videoPath;


    @ApiModelProperty(value = "运动说明")
    private List<SportMemo> memo;


    @ApiModelProperty(value = "禁忌条件")
    private List<TabooConditionModel> taboo;


    @ApiModelProperty(value = "MET值")
    private String metVal;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态(YN)")
    private String status;

}
