package com.xxh.cloud.healthy.basic.framework.modules.sport.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dos.SportCategoryInfo;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportCategoryVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class SportCategoryHelper {


    /**
     * ID
     * */
    public static String getSportCategoryId(){
        return StrUtil.format("SC{}", IdUtil.getSnowflake(5,12).nextIdStr());
    }
    public static SportCategoryVO getSportCategoryVO(SportCategoryInfo entity){
        SportCategoryVO data=new SportCategoryVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static SportCategoryVO getSportCategoryVO(SportCategoryInfo entity, Map<String, AdminUserBO> userMap){
        SportCategoryVO data=SportCategoryHelper.getSportCategoryVO(entity);
        if(data==null){
            return null;
        }
//        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
//            DiseaseBO disease = diseaseMap.get(data.getDiseaseId());
//            if(disease!=null){
//                data.setDiseaseName(disease.getName());
//            }
//        }

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

        return data;
    }



}
