package com.xxh.cloud.healthy.basic.framework.modules.sport.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.TabooConditionModel;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dos.SportInfo;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportMemo;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;


public class SportHelper {


    /**
     * sport id
     * */
    public static String getSportId(){
        return StrUtil.format("S{}", IdUtil.getSnowflake(5,5).nextIdStr());
    }



    public static SportVO getSportVO(SportInfo entity){
        if(entity==null){
            return null;
        }
        SportVO data=new SportVO();
        BeanUtil.copyProperties(entity,data,"memo","taboo");
        if(StrUtil.isNotEmpty(entity.getMemo())){
            data.setMemo(JSON.parseArray(entity.getMemo(), SportMemo.class));
        }
        if(StrUtil.isNotEmpty(entity.getTaboo())){
            data.setTaboo(JSON.parseArray(entity.getTaboo(), TabooConditionModel.class));
        }
        return data;
    }

    public static SportVO getSportVO(SportInfo entity,
                                     Map<String, AdminUserBO> userMap,
                                     Map<String, SportCategoryVO> categoryMap){
        SportVO data=getSportVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }



        if(MapUtil.isNotEmpty(categoryMap) && StrUtil.isNotEmpty(data.getCategoryId())){
            SportCategoryVO category=categoryMap.get(data.getCategoryId());
            if(category!=null){
                data.setCategoryName(category.getName());
            }
        }
        return data;
    }


}
