package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 标准标签信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_label_info")
public class StandardLabelInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "编号")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "病种ID")
    private String diseaseIds;

    @ApiModelProperty(value = "业务分类")
    private String bizType;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "统计维度分类")
    private String statDimensionType;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "版本号")
    private String versionCode;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "状态")
    private String status;


    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


    @ApiModelProperty(value = "二级业务分类[是否早筛活动]")
    private String bizTwoType;

    @ApiModelProperty(value = "三级业务分类[活动类型]")
    private String bizThreeType;

    /**
     * 自动会诊提醒标记(YN)
     */
    @ApiModelProperty(value = "自动会诊提醒标记(YN)")
    private String consultationRemindStatus;

    /**
     * 会诊部门ID列表
     */
    @ApiModelProperty(value = "会诊部门ID列表")
    private String consultationDeptIds;

    /**
     * 会诊学科名称
     */
    @ApiModelProperty(value = "会诊学科名称")
    private String consultationSubjectName;

    /**
     * 会诊备注
     */
    @ApiModelProperty(value = "会诊备注")
    private String consultationRemark;

    /**
     * 会诊随访基准时间类型
     */
    @ApiModelProperty(value = "会诊随访基准时间类型")
    private String consultationFollowUpBaseDateType;

    /**
     * 潜在患者类型
     */
    @ApiModelProperty(value = "潜在患者类型")
    private String potentialType;

    /**
     * 是否患者画像
     */
    @ApiModelProperty(value = "是否患者画像")
    private String isPortrait;

    /**
     * 会诊负责人
     */
    @ApiModelProperty(value = "会诊负责人")
    private String consultationManager;

    /**
     * 会诊消息
     */
    @ApiModelProperty(value = "会诊消息")
    private String consultationMessage;

    /**
     * 提醒病种负责人标记(YN)
     */
    @ApiModelProperty(value = "提醒病种负责人标记(YN)")
    private String labelRemindStatus;

    /**
     * 标签病种负责人
     */
    @ApiModelProperty(value = "标签病种负责人")
    private String labelManager;

    /**
     * 标签病种运营助理
     */
    @ApiModelProperty(value = "标签病种运营助理")
    private String labelAssistant;

    /**
     * 标签部门负责人
     */
    @ApiModelProperty(value = "标签部门负责人")
    private String labelDeptManager;

    /**
     * 是否管理员标签
     */
    @ApiModelProperty(value = "是否管理员标签")
    private String adminLabel;
}
