package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.base.entity.StandardLabelInfo;
import com.xxh.cloud.healthy.basic.framework.modules.base.service.StandardLabelInfoService;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.LabelCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.StandardLabelCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.label.bean.vos.StandardLabelVO;
import com.xxh.cloud.healthy.basic.framework.modules.label.helper.StandardLabelHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class StandardLabelCacheServiceImpl extends BasicCacheServiceImpl<StandardLabelVO>  implements StandardLabelCacheService {


    @Autowired
    private StandardLabelInfoService standardLabelInfoService;


    @Override
    public String getCacheKey(String id) {
        return LabelCacheKeysHelper.getLabelKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return LabelCacheKeysHelper.getLabelMainKey();
    }

    @Override
    public Class<StandardLabelVO> getJsonClazz() {
        return StandardLabelVO.class;
    }

    @Override
    public String getId(StandardLabelVO entity) {
        return entity.getId();
    }

    @Override
    public StandardLabelVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLabelInfo entity= standardLabelInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        StandardLabelVO data= StandardLabelHelper.getHealthyLabelVO(entity);
        return data;
    }

    @Override
    public List<StandardLabelVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardLabelInfo> list = standardLabelInfoService.list(
                new QueryWrapper<StandardLabelInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );

        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardLabelVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardLabelHelper.getHealthyLabelVO(item));
        });
        return data;
    }
}
