package com.xxh.cloud.healthy.basic.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.basic.framework.modules.base.entity.StandardLabelCategoryInfo;
import com.xxh.cloud.healthy.basic.framework.modules.base.service.StandardLabelCategoryInfoService;
import com.xxh.cloud.healthy.basic.framework.modules.cache.helper.LabelCacheKeysHelper;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.StandardLabelCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.label.bean.vos.StandardLabelCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.label.helper.StandardLabelCategoryHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class StandardLabelCategoryCacheServiceImpl extends BasicCacheServiceImpl<StandardLabelCategoryVO>  implements StandardLabelCategoryCacheService {

    @Autowired
   private StandardLabelCategoryInfoService standardLabelCategoryInfoService;

    @Override
    public String getCacheKey(String id) {
        return LabelCacheKeysHelper.getLabelCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return LabelCacheKeysHelper.getLabelCategoryMainKey();
    }

    @Override
    public Class<StandardLabelCategoryVO> getJsonClazz() {
        return StandardLabelCategoryVO.class;
    }

    @Override
    public String getId(StandardLabelCategoryVO standardLabelCategoryVO) {
        return standardLabelCategoryVO.getId();
    }

    @Override
    public StandardLabelCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLabelCategoryInfo entity= standardLabelCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return StandardLabelCategoryHelper.getHealthyLabelCategoryModel(entity);
    }

    @Override
    public List<StandardLabelCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<StandardLabelCategoryInfo> list= standardLabelCategoryInfoService.list(new QueryWrapper<StandardLabelCategoryInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }
        List<StandardLabelCategoryVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(StandardLabelCategoryHelper.getHealthyLabelCategoryModel(item));
        });
        return data;
    }
}
