package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.framework.modules.cache.service.StandardLabelCategoryCacheService;
import com.xxh.cloud.healthy.basic.framework.modules.client.helper.LabelBOConvert;
import com.xxh.cloud.healthy.basic.framework.modules.label.bean.vos.StandardLabelCategoryVO;
import com.xxh.cloud.healthy.basic.label.client.api.LabelCategoryClientService;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelCategoryBO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class LabelCategoryClientServiceImpl implements LabelCategoryClientService {

    @Autowired
    private StandardLabelCategoryCacheService standardLabelCategoryCacheService;



    @Override
    public LabelCategoryBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        StandardLabelCategoryVO entity = standardLabelCategoryCacheService.getById(id);
        return LabelBOConvert.getLabelCategoryBO(entity);
    }

    @Override
    public List<LabelCategoryBO> getListByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new ArrayList<>();
        }
        List<StandardLabelCategoryVO> list = standardLabelCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        return list.stream().map(LabelBOConvert::getLabelCategoryBO).collect(Collectors.toList());
    }

    @Override
    public Map<String, LabelCategoryBO> getMapByIds(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return new HashMap<>();
        }
        List<StandardLabelCategoryVO> list = standardLabelCategoryCacheService.getListByIds(ids);
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>();
        }

        Map<String, LabelCategoryBO> labelCategoryBOMap = new HashMap<>();
        list.forEach(i -> labelCategoryBOMap.put(i.getId(), LabelBOConvert.getLabelCategoryBO(i)));
        return labelCategoryBOMap;
    }
}
