package com.xxh.cloud.healthy.basic.framework.modules.label.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Collection;
import java.util.List;

@Getter
@Setter
public class StandardLabelInfoListParam {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "ids")
    private Collection<String> ids;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "状态(YN)")
    private String status;

    @ApiModelProperty(value = "所属标签分类")
    private String categoryId;


    @ApiModelProperty(value = "所属标签分类")
    private List<String> categoryIds;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    @ApiModelProperty(value = "业务分类")
    private String bizType;

    @ApiModelProperty(value = "统计维度分类")
    private String statDimensionType;

    @ApiModelProperty(value = "统计维度分类列表")
    private List<String> statDimensionTypes;

    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    // zs20231017
    @ApiModelProperty(value = "病种ID列表")
    private List<String> diseaseIds;
    @ApiModelProperty(value = "病种查询模式[or、and][ModeEnum.QueryModeEnum]")
    private String diseaseQueryMode;
    @ApiModelProperty(value = "业务分类列表")
    private List<String> bizTypes;

    @ApiModelProperty(value = "模式[doctor][ModeEnum.RequestModeEnum]")
    private String requestMode;
    
    @ApiModelProperty(value = "二级业务分类")
    private String bizTwoType;

    @ApiModelProperty(value = "二级业务分类列表")
    private List<String> bizTwoTypes;
    
    @ApiModelProperty(value = "三级业务分类[活动类型]")
    private String bizThreeType;

    @ApiModelProperty(value = "三级业务分类[活动类型]列表")
    private List<String> bizThreeTypes;

    /**
     * 自动会诊提醒标记(YN)
     */
    @ApiModelProperty(value = "自动会诊提醒标记(YN)")
    private String consultationRemindStatus;

    /**
     * 潜在患者类型
     */
    @ApiModelProperty(value = "潜在患者类型")
    private String potentialType;

    @ApiModelProperty(value = "是否潜在患者类型")
    private String isPotentialType;

    /**
     * 是否患者画像
     */
    @ApiModelProperty(value = "是否患者画像")
    private String isPortrait;

    /**
     * 会诊随访基准时间类型
     */
    @ApiModelProperty(value = "会诊随访基准时间类型")
    private String consultationFollowUpBaseDateType;

    @ApiModelProperty(value = "是否管理员标签")
    private String adminLabel;
}
