package com.xxh.cloud.healthy.basic.framework.modules.label.bean.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class StandardLabelInfoSaveParam {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "名称",required = true)
    @NotEmpty(message = "不能为空")
    private String name;


    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "所属标签分类")
    private String categoryId;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "业务分类")
    private String bizType;

    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "统计维度分类[LabelStatDimensionTypeEnum]")
    private String statDimensionType;

    @ApiModelProperty(value = "二级业务分类")
    private String bizTwoType;

    @ApiModelProperty(value = "三级业务分类")
    private String bizThreeType;


    /**
     * 自动会诊提醒标记(YN)
     */
    @ApiModelProperty(value = "自动会诊提醒标记(YN)")
    private String consultationRemindStatus;

    /**
     * 会诊部门ID列表
     */
    @ApiModelProperty(value = "会诊部门ID列表")
    private List<String> consultationDeptIds;

    /**
     * 会诊负责人
     */
    @ApiModelProperty(value = "会诊负责人")
    private String consultationManager;

    /**
     * 会诊消息
     */
    @ApiModelProperty(value = "会诊消息")
    private String consultationMessage;

    /**
     * 会诊学科名称
     */
    @ApiModelProperty(value = "会诊学科名称")
    private String consultationSubjectName;

    /**
     * 会诊备注
     */
    @ApiModelProperty(value = "会诊备注")
    private String consultationRemark;

    /**
     * 潜在患者类型
     */
    @ApiModelProperty(value = "潜在患者类型")
    private String potentialType;

    /**
     * 是否患者画像
     */
    @ApiModelProperty(value = "是否患者画像")
    private String isPortrait;

    /**
     * 会诊随访基准时间类型
     */
    @ApiModelProperty(value = "会诊随访基准时间类型")
    private String consultationFollowUpBaseDateType;

    @ApiModelProperty(value = "提醒病种负责人标记(YN)")
    private String labelRemindStatus;

    @ApiModelProperty(value = "标签病种负责人")
    private String labelManager;

    @ApiModelProperty(value = "标签病种运营助理")
    private String labelAssistant;

    @ApiModelProperty(value = "标签部门负责人")
    private String labelDeptManager;

    @ApiModelProperty(value = "是否管理员标签")
    private String adminLabel;
}
