package com.xxh.cloud.healthy.basic.framework.modules.label.bean.vos;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

@Getter
@Setter
public class StandardLabelVO {



    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "ids")
    private List<String> ids;



    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "版本号")
    private String versionCode;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "所属标签分类")
    private String categoryId;


    @ApiModelProperty(value = "状态")
    private String status;

    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "创建者")
    private String creator;


    @ApiModelProperty(value = "创建时间")
    private Date createDate;


    @ApiModelProperty(value = "更新者")
    private String updater;


    @ApiModelProperty(value = "更新时间")
    private Date updateDate;


    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "统计维度分类")
    private String statDimensionType;

    @ApiModelProperty(value = "统计维度分类列表")
    private List<String> statDimensionTypes;

    @ApiModelProperty(value = "业务分类")
    private String bizType;

    @ApiModelProperty(value = "业务分类列表")
    private List<String> bizTypes;

    @ApiModelProperty(value = "二级业务分类")
    private String bizTwoType;

    @ApiModelProperty(value = "三级业务分类[活动类型]")
    private String bizThreeType;

    /**
     * 自动会诊提醒标记(YN)
     */
    @ApiModelProperty(value = "自动会诊提醒标记(YN)")
    private String consultationRemindStatus;

    /**
     * 会诊部门ID列表
     */
    @ApiModelProperty(value = "会诊部门ID列表")
    private List<String> consultationDeptIds;

    /**
     * 会诊负责人
     */
    @ApiModelProperty(value = "会诊负责人")
    private String consultationManager;

    /**
     * 会诊消息
     */
    @ApiModelProperty(value = "会诊消息")
    private String consultationMessage;

    /**
     * 会诊学科名称
     */
    @ApiModelProperty(value = "会诊学科名称")
    private String consultationSubjectName;

    /**
     * 会诊备注
     */
    @ApiModelProperty(value = "会诊备注")
    private String consultationRemark;

    /**
     * 会诊随访基准时间
     */
    @ApiModelProperty(value = "会诊随访基准时间")
    private String consultationFollowUpBaseDateType;


    /**
     * 会诊部门列表
     */
    @ApiModelProperty(value = "会诊部门列表")
    private List<DeptBO> consultationDeptList;

    @ApiModelProperty(value = "提醒病种负责人标记(YN)")
    private String labelRemindStatus;

    @ApiModelProperty(value = "标签病种负责人")
    private String labelManager;

    @ApiModelProperty(value = "标签病种运营助理")
    private String labelAssistant;

    @ApiModelProperty(value = "标签部门负责人")
    private String labelDeptManager;

    @ApiModelProperty(value = "是否管理员标签")
    private String adminLabel;

    //============================================

    @ApiModelProperty(value = "所属标签分类")
    private String categoryName;


    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;


    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;


    @ApiModelProperty(value = "病种名称")
    private String diseaseNames;

    @ApiModelProperty(value = "病种")
    private List<Map<String,String>> diseaseList;

    /**
     * 潜在患者类型
     */
    @ApiModelProperty(value = "潜在患者类型")
    private String potentialType;

    /**
     * 是否患者画像
     */
    @ApiModelProperty(value = "是否患者画像")
    private String isPortrait;

    public void addDisease(String id ,String name){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }

        Map<String,String> entity=new HashMap<>();
        entity.put("id",id);
        entity.put("name",name);
        this.diseaseList.add(entity);
    }

}
