package com.xxh.cloud.healthy.basic.framework.modules.label.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.basic.framework.modules.base.entity.StandardLabelCategoryInfo;
import com.xxh.cloud.healthy.basic.framework.modules.label.bean.vos.StandardLabelCategoryVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class StandardLabelCategoryHelper {

    public static String getHealthyLabelCategoryId(){
        return StrUtil.format("HLC{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }


    /**
     * 标签分类
     * */
    public static StandardLabelCategoryVO getHealthyLabelCategoryModel(StandardLabelCategoryInfo entity){
        if(entity==null){
            return null;
        }
        StandardLabelCategoryVO data=new StandardLabelCategoryVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }


    public static StandardLabelCategoryVO getHealthyLabelCategoryModel(StandardLabelCategoryInfo entity, Map<String, AdminUserBO> userMap){
        StandardLabelCategoryVO data=getHealthyLabelCategoryModel(entity);
        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user=userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }

            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user=userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        return data;
    }


}
