package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 推送服务配置表
 * </p>
 *
 * @author anros
 * @since 2023-09-18
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_push_serve_config_info")
public class PushServeConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 服务名称
     */
    @ApiModelProperty(value = "服务名称")
    private String name;

    /**
     * 内部名称
     */
    @ApiModelProperty(value = "内部名称")
    private String title;

    /**
     * 媒体名称（推送内容标题）
     */
    @ApiModelProperty(value = "服务分类")
    private String type;

    /**
     * 媒体类型(文章-量表)
     */
    @ApiModelProperty(value = "媒体类型(文章-量表)")
    private String mediaType;

    /**
     * 媒体编号
     */
    @ApiModelProperty(value = "媒体编号")
    private String mediaId;

    /**
     * 推送内容标题
     */
    @ApiModelProperty(value = "推送内容标题")
    private String mediaName;

    /**
     * 推送应用图标
     */
    @ApiModelProperty(value = "推送应用图标")
    private String mediaImg;

    /**
     * 推送标题
     */
    @ApiModelProperty(value = "推送标题")
    private String mediaTitle;

    /**
     * 推送描述
     */
    @ApiModelProperty(value = "推送描述")
    private String mediaRemark;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 推送方式（微信推送、短信、ai电话）
     */
    @ApiModelProperty(value = "推送方式")
    private String pushWay;

    /**
     * 推送配置（触发时间/基准时间）
     */
    @ApiModelProperty(value = "推送配置")
    private String pushConfig;

    /**
     * 提醒方式
     */
    @ApiModelProperty(value = "提醒方式")
    private String remindWay;

    /**
     * 基准日期分类
     */
    @ApiModelProperty(value = "基准日期分类")
    private String benchmarkDate;

    /**
     * 发送时间分类
     */
    @ApiModelProperty(value = "发送时间分类")
    private String earlyDelayType;

    /**
     * 发送时间偏差量(天)
     */
    @ApiModelProperty(value = "发送时间偏差量(天)")
    private Integer earlyDelayNum;

    /**
     * 当天提醒的时间(hh:mm)
     */
    @ApiModelProperty(value = "当天提醒的时间(hh:mm)")
    private String remindDayTime;

    /**
     * 是否循环
     */
    @ApiModelProperty(value = "是否循环")
    private String loopModel;

    /**
     * 循环间隔(天)
     */
    @ApiModelProperty(value = "循环间隔(天)")
    private Integer loopInterval;

    /**
     * 循环最大次数
     */
    @ApiModelProperty(value = "循环最大次数")
    private Integer loopMaxNum;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    @ApiModelProperty(value = "推送服务配置快照KEY")
    private String snapshotKey;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


    @ApiModelProperty(value = "病种ID")
    private String diseaseIds;

    @ApiModelProperty(value = "推送目标[PushServeTargetEnum]")
    private String pushTarget;

    @ApiModelProperty(value = "基准日期类型分类")
    private String benchmarkDateType;



    
    @ApiModelProperty(value = "扩展1")
    private String extend1;

    @ApiModelProperty(value = "扩展2")
    private String extend2;

    @ApiModelProperty(value = "扩展3")
    private String extend3;

    // 测试标记，用于生成验证数据(YN)
    @ApiModelProperty(value = "扩展4")
    private String extend4;

    @ApiModelProperty(value = "扩展5")
    private String extend5;
}
