package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.dto.PushServeConfigListDTO;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.vos.PushServeConfigVO;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.convert.PushServeConfigConvert;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.service.PushServeConfigBizService;
import com.xxh.cloud.healthy.basic.pushserve.client.api.PushServeConfigClientService;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.dto.PushServeConfigClientQueryDTO;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class PushServeConfigClientServiceImpl implements PushServeConfigClientService {

    @Autowired
    private PushServeConfigBizService pushServeConfigBizService;

    @Override
    public List<PushServeConfigBO> list(PushServeConfigClientQueryDTO params) {

        PushServeConfigListDTO pushServeConfigListDTO = new PushServeConfigListDTO();
        pushServeConfigListDTO.setId(params.getId());
        pushServeConfigListDTO.setIds(params.getIds());
        pushServeConfigListDTO.setType(params.getType());
        pushServeConfigListDTO.setTypes(params.getTypes());
        pushServeConfigListDTO.setDiseaseId(params.getDiseaseId());
        pushServeConfigListDTO.setStatus(params.getStatus());
        List<PushServeConfigVO> list = pushServeConfigBizService.list(pushServeConfigListDTO);
        
        return list.stream().map(PushServeConfigConvert::getPushServeConfigBO).collect(Collectors.toList());
    }

    @Override
    public PushServeConfigBO getById(String id) {
        PushServeConfigVO vo = pushServeConfigBizService.getById(id);
        if (null == vo) {
            return null;
        }
        return PushServeConfigConvert.getPushServeConfigBO(vo);
    }

}
