package com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.dto;

import javax.validation.constraints.NotEmpty;

import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
public class PushServeConfigSaveDTO {

    @ApiModelProperty(value = "服务名称", required = true)
    @NotEmpty(message = "服务名称[name]不能为空")
    private String name;

    @ApiModelProperty(value = "运营标题", required = true)
    @NotEmpty(message = "运营标题[title]不能为空")
    private String title;

    @ApiModelProperty(value = "服务分类[字典定义]", required = true)
    @NotEmpty(message = "服务分类[type]不能为空")
    private String type;

    /**
     * 媒体类型(文章 量表)
     */
    @ApiModelProperty(value = "媒体类型(文章 量表)[PuseServeMediaTypeEnum]", required = true)
    @NotEmpty(message = "媒体类型[mediaType]不能为空")
    private String mediaType;

    @ApiModelProperty(value = "媒体编号[外链]", required = true)
    @NotEmpty(message = "媒体编号[mediaId]不能为空")
    private String mediaId;

    @ApiModelProperty(value = "媒体名称[推送内容标题]", required = true)
    @NotEmpty(message = "媒体名称[mediaName]不能为空")
    private String mediaName;

    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "推送方式[微信推送、短信、ai电话][PushWayEnum]")
    private String pushWay;


    @ApiModelProperty(value = "推送配置[具体推送方式的配置]")
    private ServPushConfigModel pushConfig;


    @ApiModelProperty(value = "推送基准日期[BenchmarkDateEnum]", required = true)
    @NotEmpty(message = "推送基准日期[benchmarkDate]不能为空")
    private String benchmarkDate;


    @ApiModelProperty(value = "推送时间分类[立即/提早/延迟][RemindEarlyDelayTypeEnum]", required = true)
    @NotEmpty(message = "推送时间分类[earlyDelayType]不能为空")
    private String earlyDelayType;

    @ApiModelProperty(value = "推送时间偏差量(天)")
    private Integer earlyDelayNum;


    @ApiModelProperty(value = "当天推送的时间(hh:mm)")
    private String remindDayTime;


    @ApiModelProperty(value = "是否循环[YN]")
    private String loopModel;


    @ApiModelProperty(value = "循环间隔(天)")
    private Integer loopInterval;


    @ApiModelProperty(value = "循环最大次数")
    private Integer loopMaxNum;



    // @ApiModelProperty(value = "状态(YN)")
    // private String status;


    // zs:2023-09-18
    @ApiModelProperty(value = "N-应用图标")
    private String mediaImg;

    @ApiModelProperty(value = "N-推送标题")
    private String mediaTitle;

    @ApiModelProperty(value = "N-推送描述")
    private String mediaRemark;

    @ApiModelProperty(value = "N-提醒方式[只提醒/只加入日程/加入日程并提醒][RemindWayEnum]")
    private String remindWay;

    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "推送目标[PushServeTargetEnum]")
    private String pushTarget;

    @ApiModelProperty(value = "基准日期类型分类")
    private String benchmarkDateType;



    
    @ApiModelProperty(value = "扩展1")
    private String extend1;

    @ApiModelProperty(value = "扩展2")
    private String extend2;

    @ApiModelProperty(value = "扩展3")
    private String extend3;

    // 测试标记，用于生成验证数据(YN)
    @ApiModelProperty(value = "扩展4")
    private String extend4;

    @ApiModelProperty(value = "扩展5")
    private String extend5;
}
