package com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.vos;

import com.xxh.cloud.healthy.basic.article.client.api.bean.bos.ArticleBO;
import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleConfigBO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

@Getter
@Setter
public class PushServeConfigVO {

    
    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "服务名称")
    private String name;


    @ApiModelProperty(value = "媒体编号[外链]")
    private String mediaId;


    @ApiModelProperty(value = "媒体名称")
    private String mediaName;


    @ApiModelProperty(value = "媒体类型(文章 量表)")
    private String mediaType;


    @ApiModelProperty(value = "运营标题")
    private String title;


    @ApiModelProperty(value = "服务分类")
    private String type;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "推送方式")
    private String pushWay;


    @ApiModelProperty(value = "推送配置")
    private ServPushConfigModel pushConfig;



    @ApiModelProperty(value = "推送基准日期")
    private String benchmarkDate;


    @ApiModelProperty(value = "推送时间分类(提早延迟)")
    private String earlyDelayType;


    @ApiModelProperty(value = "推送时间偏差量(天)")
    private Integer earlyDelayNum;


    @ApiModelProperty(value = "当天推送的时间(hh:mm)")
    private String remindDayTime;


    @ApiModelProperty(value = "是否循环")
    private String loopModel;


    @ApiModelProperty(value = "循环间隔(天)")
    private Integer loopInterval;


    @ApiModelProperty(value = "循环最大次数")
    private Integer loopMaxNum;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;


    //=============================

    @ApiModelProperty("创建者[姓名]")
    private String creatorName;


    @ApiModelProperty("更新者[姓名]")
    private String updaterName;


    // zs:2023-09-18
    @ApiModelProperty(value = "N-应用图标")
    private String mediaImg;

    @ApiModelProperty(value = "N-推送标题")
    private String mediaTitle;

    @ApiModelProperty(value = "N-推送描述")
    private String mediaRemark;

    @ApiModelProperty(value = "N-提醒方式[提醒/只加入日程不提醒]")
    private String remindWay;

    // zs:20230919
    @ApiModelProperty(value = "推送服务配置快照KEY")
    private String snapshotKey;

    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "病种ID")
    private List<Map<String,String>> diseaseList;

    public void addDisease(String id ,String name){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }
        Map<String,String> entity=new HashMap<>();
        entity.put("id",id);
        entity.put("name",name);
        this.diseaseList.add(entity);
    }

    @ApiModelProperty(value = "推送目标[PushServeTargetEnum]")
    private String pushTarget;

    @ApiModelProperty(value = "基准日期类型分类")
    private String benchmarkDateType;


    
    @ApiModelProperty(value = "扩展1")
    private String extend1;

    @ApiModelProperty(value = "扩展2")
    private String extend2;

    @ApiModelProperty(value = "扩展3")
    private String extend3;

    // 测试标记，用于生成验证数据(YN)
    @ApiModelProperty(value = "扩展4")
    private String extend4;

    @ApiModelProperty(value = "扩展5")
    private String extend5;


    
    @ApiModelProperty(value = "服务推送次数")
    private String pushCount;
    
    
    @ApiModelProperty(value = "文章信息")
    private ArticleBO articleInfo;
    
    @ApiModelProperty(value = "量表信息")
    private ScaleConfigBO scaleInfo;
}
