package com.xxh.cloud.healthy.basic.framework.modules.pushServe.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.basic.framework.modules.base.entity.PushServeConfigInfo;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.vos.PushServeConfigVO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.ServPushConfigBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class PushServeConfigConvert {

    public static PushServeConfigVO getPushServeConfigVO(PushServeConfigInfo entity){
        PushServeConfigVO data=new PushServeConfigVO();
        BeanUtil.copyProperties(entity,data,"pushConfig","diseaseIds");
        if(StrUtil.isNotEmpty(entity.getPushConfig())){
            data.setPushConfig(JSON.parseObject(entity.getPushConfig(), ServPushConfigModel.class));
        }
        data.setDiseaseIds(StrJoinSplitUtils.split2List(entity.getDiseaseIds()));
        return data;
    }


    public static PushServeConfigVO getPushServeConfigVO(PushServeConfigInfo entity,
                                                         Map<String, AdminUserBO> userMap,
                                                         Map<String, StandardDiseaseBO> diseaseMap){
        PushServeConfigVO data=getPushServeConfigVO(entity);
        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(entity.getCreator())){
                AdminUserBO user=userMap.get(entity.getCreator());
                if(user!=null){
                    data.setCreatorName(user.getUserName());
                }
            }

            if(StrUtil.isNotEmpty(entity.getUpdater())){
                AdminUserBO user=userMap.get(entity.getUpdater());
                if(user!=null){
                    data.setUpdaterName(user.getUserName());
                }
            }
        }

        if(MapUtil.isNotEmpty(diseaseMap) && CollUtil.isNotEmpty(data.getDiseaseIds())){
            data.getDiseaseIds().forEach(id->{
                StandardDiseaseBO disease = diseaseMap.get(id);
                if(disease!=null){
                    data.addDisease(disease.getId(),disease.getName());
                }
            });
        }

        return data;
    }

    public static PushServeConfigBO getPushServeConfigBO(PushServeConfigVO vo) {
        if (null == vo) {
            return null;
        }
        PushServeConfigBO data = new PushServeConfigBO();
        BeanUtil.copyProperties(vo, data, "pushConfig");
        if (null != vo.getPushConfig()) {
            ServPushConfigBO servPushConfigBO = new ServPushConfigBO();
            BeanUtil.copyProperties(vo.getPushConfig(), servPushConfigBO);
            data.setPushConfig(servPushConfigBO);
        }
        return data;
    }

}
