package com.xxh.cloud.healthy.basic.framework.modules.util;

import com.xxh.cloud.healthy.basic.framework.modules.base.entity.PushServeConfigInfo;

import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.DigestUtil;

public class PushServeUtil {

    public static String getPushServeSnapshotKey(PushServeConfigInfo entity) {

        if (null == entity) {
            return null;
        }

        StringBuilder sb = new StringBuilder();
        sb.append(StrUtil.isNotBlank(entity.getId()) ? entity.getId() : "#");
        sb.append(StrUtil.isNotBlank(entity.getName()) ? entity.getName() : "#");
        sb.append(StrUtil.isNotBlank(entity.getTitle()) ? entity.getTitle() : "#");
        sb.append(StrUtil.isNotBlank(entity.getType()) ? entity.getType() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaType()) ? entity.getMediaType() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaId()) ? entity.getMediaId() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaName()) ? entity.getMediaName() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaImg()) ? entity.getMediaImg() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaTitle()) ? entity.getMediaTitle() : "#");
        sb.append(StrUtil.isNotBlank(entity.getMediaRemark()) ? entity.getMediaRemark() : "#");
        sb.append(StrUtil.isNotBlank(entity.getRemark()) ? entity.getRemark() : "#");
        sb.append(StrUtil.isNotBlank(entity.getPushWay()) ? entity.getPushWay() : "#");
        sb.append(StrUtil.isNotBlank(entity.getPushConfig()) ? entity.getPushConfig() : "#");
        sb.append(StrUtil.isNotBlank(entity.getRemindWay()) ? entity.getRemindWay() : "#");

        sb.append(StrUtil.isNotBlank(entity.getBenchmarkDate()) ? entity.getBenchmarkDate() : "#");
        sb.append(StrUtil.isNotBlank(entity.getBenchmarkDateType()) ? entity.getBenchmarkDateType() : "#");
        sb.append(StrUtil.isNotBlank(entity.getEarlyDelayType()) ? entity.getEarlyDelayType() : "#");
        sb.append(entity.getEarlyDelayNum() != null ? entity.getEarlyDelayNum() : "#");
        sb.append(StrUtil.isNotBlank(entity.getRemindDayTime()) ? entity.getRemindDayTime() : "#");
        sb.append(StrUtil.isNotBlank(entity.getLoopModel()) ? entity.getLoopModel() : "#");
        sb.append(entity.getLoopInterval() != null ? entity.getLoopInterval() : "#");
        sb.append(entity.getLoopMaxNum() != null ? entity.getLoopMaxNum() : "#");
        sb.append(entity.getStatus() != null ? entity.getStatus() : "#");
        sb.append(entity.getRowsStatus() != null ? entity.getRowsStatus() : "#");
        sb.append(entity.getDiseaseIds() != null ? entity.getDiseaseIds() : "#");

        sb.append(StrUtil.isNotBlank(entity.getPushTarget()) ? entity.getPushTarget() : "#");

        // zs20240321
        sb.append(StrUtil.isNotBlank(entity.getExtend1()) ? entity.getExtend1() : "#");
        sb.append(StrUtil.isNotBlank(entity.getExtend2()) ? entity.getExtend2() : "#");
        sb.append(StrUtil.isNotBlank(entity.getExtend3()) ? entity.getExtend3() : "#");
        sb.append(StrUtil.isNotBlank(entity.getExtend4()) ? entity.getExtend4() : "#");
        sb.append(StrUtil.isNotBlank(entity.getExtend5()) ? entity.getExtend5() : "#");

        return DigestUtil.md5Hex(sb.toString()).toUpperCase();
    }
}
