package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 推送任务配置表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_push_task_config_info")
public class PushTaskConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 任务名称
     */
    @ApiModelProperty(value = "任务名称")
    private String name;

    /**
     * 任务类型
     */
    @ApiModelProperty(value = "任务类型")
    private String type;

    /**
     * 任务备注
     */
    @ApiModelProperty(value = "任务备注")
    private String remark;

    /**
     * 任务紧急等级
     */
    @ApiModelProperty(value = "任务紧急等级")
    private String urgentLevel;

    /**
     * 任务提醒标题
     */
    @ApiModelProperty(value = "任务提醒标题")
    private String remindTitle;

    /**
     * 任务提醒描述
     */
    @ApiModelProperty(value = "任务提醒描述")
    private String remindDescribe;

    /**
     * 任务处理按钮
     */
    @ApiModelProperty(value = "任务处理按钮")
    private String handleButtons;

    /**
     * 是否限制执行时间
     */
    @ApiModelProperty(value = "是否限制执行时间")
    private String isLimitExeDate;

    /**
     * 限制执行时间单位
     */
    @ApiModelProperty(value = "限制执行时间单位")
    private String limitExeDateUnit;

    /**
     * 限制执行时间数值
     */
    @ApiModelProperty(value = "限制执行时间数值")
    private Integer limitExeDateNum;

    /**
     * 任务是否提醒
     */
    @ApiModelProperty(value = "任务是否提醒")
    private String isTaskPush;

    /**
     * 提醒推送方式
     */
    @ApiModelProperty(value = "提醒推送方式")
    private String taskPushWay;

    /**
     * 提醒推送配置
     */
    @ApiModelProperty(value = "提醒推送配置")
    private String taskPushConfig;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


    @ApiModelProperty(value = "病种ID")
    private String diseaseIds;

    @ApiModelProperty(value = "操作分类[PushTaskConstant.OpType]")
    private String opType;

    @ApiModelProperty(value = "个案管理的目标id")
    private String targetId;

    @ApiModelProperty(value = "个案管理类型，字典定义")
    private String manageType;

    @ApiModelProperty(value = "任务自定义类型")
    private String customType;

}
