package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.dto.PushTaskConfigListDTO;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.vos.PushTaskConfigVO;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.convert.PushTaskConfigConvert;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.service.PushTaskConfigBizService;
import com.xxh.cloud.healthy.basic.pushtask.client.api.PushTaskConfigClientService;
import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.bos.PushTaskConfigBO;
import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.dto.PushTaskConfigClientQueryDTO;

import cn.hutool.core.collection.CollectionUtil;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class PushTaskConfigClientServiceImpl implements PushTaskConfigClientService {

    @Autowired
    private PushTaskConfigBizService pushTaskConfigBizService;

    public PushTaskConfigBO getById(String id) {
        PushTaskConfigVO vo = pushTaskConfigBizService.getById(id);
        return PushTaskConfigConvert.getPushTaskConfigBO(vo);
    }

    @Override
    public Map<String, PushTaskConfigBO> getByIds(List<String> ids) {
        if (CollectionUtil.isEmpty(ids)) {
            return new HashMap<>();
        }

        PushTaskConfigListDTO pushTaskConfigListDTO = new PushTaskConfigListDTO();
        pushTaskConfigListDTO.setIds(ids);
        List<PushTaskConfigVO> list = pushTaskConfigBizService.list(pushTaskConfigListDTO);
        if (CollectionUtil.isEmpty(list)) {
            return new HashMap<>(0);
        }

        Map<String, PushTaskConfigBO> pushTaskConfigBOMap = new HashMap<>();
        list.forEach(i -> pushTaskConfigBOMap.put(i.getId(), PushTaskConfigConvert.getPushTaskConfigBO(i)));
        return pushTaskConfigBOMap;
    }

    @Override
    public Map<String, PushTaskConfigBO> getMap(PushTaskConfigClientQueryDTO params) {
        PushTaskConfigListDTO pushTaskConfigListDTO = new PushTaskConfigListDTO();
        pushTaskConfigListDTO.setId(params.getId());
        pushTaskConfigListDTO.setIds(params.getIds());
        pushTaskConfigListDTO.setDiseaseId(params.getDiseaseId());
        List<PushTaskConfigVO> list = pushTaskConfigBizService.list(pushTaskConfigListDTO);
        if (CollectionUtil.isEmpty(list)) {
            return new HashMap<>(0);
        }

        Map<String, PushTaskConfigBO> pushTaskConfigBOMap = new HashMap<>();
        list.forEach(i -> pushTaskConfigBOMap.put(i.getId(), PushTaskConfigConvert.getPushTaskConfigBO(i)));
        return pushTaskConfigBOMap;
    }

}
