package com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.dto;

import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.vos.PushTaskActionConfigVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class PushTaskConfigSaveDTO {

    @ApiModelProperty(value = "任务名称",required = true)
    @NotEmpty(message = "任务名称不能为空")
    private String name;


    @ApiModelProperty(value = "任务类型[字典定义]")
    private String type;


    @ApiModelProperty(value = "任务备注")
    private String remark;


    @ApiModelProperty(value = "任务紧急等级[字典定义]")
    private String urgentLevel;


    @ApiModelProperty(value = "任务处理按钮[]")
    private List<String> handleButtons;


    @ApiModelProperty(value = "是否限制执行时间(YN)",required = true)
    @NotEmpty(message = "是否限制执行时间不能为空")
    private String isLimitExeDate;


    @ApiModelProperty(value = "限制执行时间单位")
    private String limitExeDateUnit;


    @ApiModelProperty(value = "限制执行时间数值")
    private Integer limitExeDateNum;


    @ApiModelProperty(value = "任务是否提醒(YN)",required = true)
    @NotEmpty(message = "任务是否提醒不能为空")
    private String isTaskPush;

    @ApiModelProperty(value = "任务提醒标题")
    private String remindTitle;

    @ApiModelProperty(value = "任务提醒描述")
    private String remindDescribe;


    @ApiModelProperty(value = "提醒推送方式[PushWayEnum]")
    private String taskPushWay;


    @ApiModelProperty(value = "提醒推送配置")
    private ServPushConfigModel taskPushConfig;

    @ApiModelProperty(value = "状态(YN)")
    private String status;

    @ApiModelProperty(value = "建议措施列表")
    private List<PushTaskActionConfigVO>  actionList;

    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "操作分类")
    private String opType;

    @ApiModelProperty(value = "个案管理的目标id")
    private String targetId;

    @ApiModelProperty(value = "个案管理类型，字典定义")
    private String manageType;

    @ApiModelProperty(value = "任务自定义类型")
    private String customType;

}
