package com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.vos;

import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

@Getter
@Setter
public class PushTaskConfigVO {

    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "任务名称")
    private String name;


    @ApiModelProperty(value = "任务类型")
    private String type;


    @ApiModelProperty(value = "任务备注")
    private String remark;


    @ApiModelProperty(value = "任务紧急等级")
    private String urgentLevel;


    @ApiModelProperty(value = "任务提醒标题")
    private String remindTitle;


    @ApiModelProperty(value = "任务提醒描述")
    private String remindDescribe;


    @ApiModelProperty(value = "任务处理按钮")
    private List<String> handleButtons;


    @ApiModelProperty(value = "是否限制执行时间")
    private String isLimitExeDate;


    @ApiModelProperty(value = "限制执行时间单位")
    private String limitExeDateUnit;


    @ApiModelProperty(value = "限制执行时间数值")
    private Integer limitExeDateNum;


    @ApiModelProperty(value = "任务是否提醒")
    private String isTaskPush;


    @ApiModelProperty(value = "提醒推送方式")
    private String taskPushWay;


    @ApiModelProperty(value = "提醒推送配置")
    private ServPushConfigModel taskPushConfig;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;


    @ApiModelProperty(value = "建议措施列表")
    private List<PushTaskActionConfigVO>  actionList;

    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "操作分类")
    private String opType;

    @ApiModelProperty(value = "个案管理的目标id")
    private String targetId;

    @ApiModelProperty(value = "个案管理的目标code")
    private String targetCode;

    @ApiModelProperty(value = "个案管理的目标名称")
    private String targetName;

    @ApiModelProperty(value = "个案管理类型，字典定义")
    private String manageType;

    @ApiModelProperty(value = "任务自定义类型")
    private String customType;

    //=============================

    @ApiModelProperty("创建者[姓名]")
    private String creatorName;


    @ApiModelProperty("更新者[姓名]")
    private String updaterName;

    @ApiModelProperty(value = "病种列表")
    private List<Map<String,String>> diseaseList;

    @ApiModelProperty(value = "任务自定义类型名称")
    private String customTypeName;


    public void addActionList(PushTaskActionConfigVO item){
        if(this.actionList==null){
            this.actionList=new ArrayList<>();
        }
        if(item!=null){
            this.actionList.add(item);
        }
    }

    public void addDisease(String id,String name){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }
        Map<String,String> entity=new HashMap<>();
        entity.put("id",id);
        entity.put("name",name);
        this.diseaseList.add(entity);
    }


}
