package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 提醒配置表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_remind_config")
public class RemindConfig extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 提醒名称
     */
     @ApiModelProperty(value = "提醒名称")
      private String name;

    /**
     * 提醒分类
     */
    @ApiModelProperty(value = "提醒分类")
     private String type;


    /**
     * 提醒内容
     */
     @ApiModelProperty(value = "提醒内容")
      private String content;

    /**
     * 等级
     */
     @ApiModelProperty(value = "等级")
      private String level;

    /**
     * 提醒对象分类
     */
     @ApiModelProperty(value = "提醒对象分类")
      private String targetObjectType;

    /**
     * 基准日期
     */
     @ApiModelProperty(value = "基准日期")
      private String benchmarkDate;

    /**
     * 发送时间分类(提早延迟)
     */
     @ApiModelProperty(value = "发送时间分类(提早延迟)")
      private String earlyDelayType;

    /**
     * 发送时间偏差量(天)
     */
     @ApiModelProperty(value = "发送时间偏差量(天)")
      private Integer earlyDelayNum;

    /**
     * 当天提醒的时间(hh:mm)
     */
     @ApiModelProperty(value = "当天提醒的时间(hh:mm)")
      private String remindDayTime;

    /**
     * 是否循环
     */
     @ApiModelProperty(value = "是否循环")
      private String loopModel;

    /**
     * 循环间隔(天)
     */
     @ApiModelProperty(value = "循环间隔(天)")
      private Integer loopInterval;

    /**
     * 循环最大次数
     */
     @ApiModelProperty(value = "循环最大次数")
      private Integer loopMaxNum;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;




}
