package com.xxh.cloud.healthy.basic.framework.modules.remind.bean.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.constant.YN;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

@Getter
@Setter
public class RemindConfigSaveDTO {




    @ApiModelProperty(value = "名称",required = true)
    @NotEmpty(message = "名称不能为空")
    private String name;


    @ApiModelProperty(value = "内容")
    private String content;

    @ApiModelProperty(value = "提醒分类")
    private String type;

    @ApiModelProperty(value = "等级[RemindLevelEnum]")
    private String level;


    @ApiModelProperty(value = "提醒对象分类[RemindTargetObjectTypeEnum]")
    private String targetObjectType;


    @ApiModelProperty(value = "基准日期")
    private String benchmarkDate;


    @ApiModelProperty(value = "发送时间分类(提早延迟)[RemindEarlyDelayTypeEnum]")
    private String earlyDelayType;


    @ApiModelProperty(value = "发送时间偏差量(天)")
    private Integer earlyDelayNum=0;


    @ApiModelProperty(value = "当天提醒的时间(hh:mm)")
    private String remindDayTime;


    @ApiModelProperty(value = "是否循环(YN)")
    private String loopModel= YN.NO.getCode();


    @ApiModelProperty(value = "循环间隔(天)")
    private Integer loopInterval;


    @ApiModelProperty(value = "循环最大次数")
    private Integer loopMaxNum;


    @ApiModelProperty(value = "状态(YN)",required = true)
    @NotEmpty(message = "状态不能为空")
    private String status =YN.NO.getCode();


}
