package com.xxh.cloud.healthy.basic.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 风险配置表
 * </p>
 *
 * @author anros
 * @since 2023-11-01
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_risk_config_info")
public class RiskConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseIds;

    /**
     * 系统ID
     */
     @ApiModelProperty(value = "系统ID")
      private String sysId;

    /**
     * 类型
     */
     @ApiModelProperty(value = "类型")
      private String type;

    /**
     * 等级
     */
     @ApiModelProperty(value = "等级")
      private String level;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 关联分类
     */
     @ApiModelProperty(value = "关联分类")
      private String relType;

    /**
     * 关联ID
     */
     @ApiModelProperty(value = "关联ID")
      private String relId;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
