package com.xxh.cloud.healthy.basic.framework.modules.client.service;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;

import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.dto.RiskConfigAddDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.dto.RiskConfigDelDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.dto.RiskConfigGetDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.dto.RiskConfigQueryDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.dto.RiskConfigUpdateDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.vos.RiskConfigVO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.convert.RiskConfigConvert;
import com.xxh.cloud.healthy.basic.framework.modules.risk.service.RiskConfigBizService;
import com.xxh.cloud.healthy.basic.risk.client.api.RiskConfigClientService;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.bo.RiskConfigBO;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.dto.RiskConfigAddClientDTO;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.dto.RiskConfigDelClientDTO;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.dto.RiskConfigQueryClientDTO;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.dto.RiskConfigUpdateClientDTO;
import org.springframework.stereotype.Service;


@Service
public class RiskConfigClientServiceImpl implements RiskConfigClientService {

    @Autowired
    private RiskConfigBizService riskConfigBizService;

    @Override
    public List<RiskConfigBO> list(RiskConfigQueryClientDTO params) {
        RiskConfigQueryDTO riskConfigQueryDTO = new RiskConfigQueryDTO();
        riskConfigQueryDTO.setId(params.getId());
        riskConfigQueryDTO.setIds(params.getIds());
        riskConfigQueryDTO.setName(params.getName());
        riskConfigQueryDTO.setLevel(params.getLevel());
        riskConfigQueryDTO.setDiseaseId(params.getDiseaseId());
        riskConfigQueryDTO.setRelId(params.getRelId());
        riskConfigQueryDTO.setRelType(params.getRelType());
        riskConfigQueryDTO.setStatus(params.getStatus());
        riskConfigQueryDTO.setSysId(params.getSysId());
        riskConfigQueryDTO.setType(params.getType());
        List<RiskConfigVO> vos = riskConfigBizService.list(riskConfigQueryDTO);
        return vos.stream().map(RiskConfigConvert::getRiskConfigBO).collect(Collectors.toList());
    }

    @Override
    public RiskConfigBO getById(String id) {
        RiskConfigGetDTO riskConfigGetDTO = new RiskConfigGetDTO();
        riskConfigGetDTO.setId(id);
        RiskConfigVO vo = riskConfigBizService.info(riskConfigGetDTO);
        return RiskConfigConvert.getRiskConfigBO(vo);
    }

    @Override
    public RiskConfigBO add(RiskConfigAddClientDTO params) {
        RiskConfigAddDTO riskConfigAddDTO = new RiskConfigAddDTO();
        riskConfigAddDTO.setName(params.getName());
        riskConfigAddDTO.setLevel(params.getLevel());
        riskConfigAddDTO.setDiseaseIds(params.getDiseaseIds());
        riskConfigAddDTO.setRelId(params.getRelId());
        riskConfigAddDTO.setRelType(params.getRelType());
        riskConfigAddDTO.setStatus(params.getStatus());
        riskConfigAddDTO.setSysId(params.getSysId());
        riskConfigAddDTO.setType(params.getType());
        riskConfigAddDTO.setRemark(params.getRemark());
        RiskConfigVO vo = riskConfigBizService.add(riskConfigAddDTO);
        return RiskConfigConvert.getRiskConfigBO(vo);
    }

    @Override
    public RiskConfigBO update(RiskConfigUpdateClientDTO params) {
        RiskConfigUpdateDTO riskConfigUpdateDTO = new RiskConfigUpdateDTO();
        riskConfigUpdateDTO.setId(params.getId());
        riskConfigUpdateDTO.setName(params.getName());
        riskConfigUpdateDTO.setLevel(params.getLevel());
        riskConfigUpdateDTO.setDiseaseIds(params.getDiseaseIds());
        riskConfigUpdateDTO.setRelId(params.getRelId());
        riskConfigUpdateDTO.setRelType(params.getRelType());
        riskConfigUpdateDTO.setStatus(params.getStatus());
        riskConfigUpdateDTO.setSysId(params.getSysId());
        riskConfigUpdateDTO.setType(params.getType());
        riskConfigUpdateDTO.setRemark(params.getRemark());
        RiskConfigVO vo = riskConfigBizService.edit(riskConfigUpdateDTO);
        return RiskConfigConvert.getRiskConfigBO(vo);
    }

    @Override
    public void delete(RiskConfigDelClientDTO params) {
        RiskConfigDelDTO riskConfigUpdateDTO = new RiskConfigDelDTO();
        riskConfigUpdateDTO.setId(params.getId());
        riskConfigUpdateDTO.setIds(params.getIds());
        riskConfigBizService.remove(riskConfigUpdateDTO);
    }

}
