package com.xxh.cloud.healthy.basic.framework.modules.risk.convert;

import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.framework.modules.base.entity.RiskConfigInfo;
import com.xxh.cloud.healthy.basic.framework.modules.risk.bean.vos.RiskConfigVO;
import com.xxh.cloud.healthy.basic.risk.client.api.bean.bo.RiskConfigBO;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

public class RiskConfigConvert {

    public static String getRiskConfigInfoId(){
        return StrUtil.format("RCI{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static RiskConfigVO getRiskConfigVO(RiskConfigInfo entity){
        if(entity == null){
            return null;
        }
        RiskConfigVO vo = new RiskConfigVO();
        BeanUtil.copyProperties(entity,vo,"diseaseIds");
        vo.setDiseaseIds(StrJoinSplitUtils.split2List(entity.getDiseaseIds()));
        return vo;
    }

    public static RiskConfigBO getRiskConfigBO(RiskConfigVO vo){
        if(vo == null){
            return null;
        }
        RiskConfigBO bo = new RiskConfigBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

}
