package com.xxh.cloud.healthy.basic.sys.app.controller;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.dev33.satoken.annotation.SaIgnore;

import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.dto.PushServeConfigGetDTO;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.bean.vos.PushServeConfigVO;
import com.xxh.cloud.healthy.basic.framework.modules.pushServe.service.PushServeConfigBizService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@SaCheckLogin
@Log4j2
@RestController
@RequestMapping("/app/healthy/pushServie")
@Api(tags = "患者端,服务信息")
public class PushServeConfigAppController {

    @Autowired
    private PushServeConfigBizService pushServeConfigBizService;

    // 非登录获取推送服务信息
    @SaIgnore
    @PostMapping("/config/info")
    @ApiOperation(value = "推送服务获取", response = PushServeConfigVO.class)
    public Result<PushServeConfigVO> info(@RequestBody PushServeConfigGetDTO params) {
        ValidatorUtils.validateEntity(params);
        PushServeConfigVO data= pushServeConfigBizService.getFullById(params.getId());
        return new Result<PushServeConfigVO>().ok(data);
    }

}
