package com.xxh.cloud.healthy.basic.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.food.biz.FoodCategoryBizService;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodCategoryVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Deprecated
//@SaCheckPermission("sys:healthy:basic:foodCategory")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/foodCategory")
@Api(tags = "运营端,菜谱分类管理")
public class FoodCategoryManagerController {


    @Autowired
    private FoodCategoryBizService foodCategoryBizService;


    @SaCheckPermission("sys:healthy:basic:foodCategory:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = FoodCategoryVO.class)
    public Result<PageData<FoodCategoryVO>> query(@RequestBody FoodCategoryQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<FoodCategoryVO> data= foodCategoryBizService.query(params);
        return new Result<PageData<FoodCategoryVO>>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:foodCategory:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = FoodCategoryVO.class)
    public Result<List<FoodCategoryVO>> list(@RequestBody FoodCategoryListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<FoodCategoryVO> data= foodCategoryBizService.list(params);
        return new Result<List<FoodCategoryVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:foodCategory:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = FoodCategoryVO.class)
    public Result<FoodCategoryVO> save(@RequestBody FoodCategorySaveDTO params) {
        ValidatorUtils.validateEntity(params);
        FoodCategoryVO data= foodCategoryBizService.save(params);
        return new Result<FoodCategoryVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:foodCategory:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = FoodCategoryVO.class)
    public Result<FoodCategoryVO> update(@RequestBody FoodCategoryUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        FoodCategoryVO data=foodCategoryBizService.update(params);
        return new Result<FoodCategoryVO>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:foodCategory:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody FoodCategoryInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        foodCategoryBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @SaCheckPermission("sys:healthy:basic:foodCategory:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = FoodCategoryVO.class)
    public  Result<FoodCategoryVO>  info(@RequestBody FoodCategoryInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        FoodCategoryVO data= foodCategoryBizService.infoById(params.getId());
        return new Result<FoodCategoryVO>().ok(data);
    }





}
