package com.xxh.cloud.healthy.basic.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.food.biz.FoodBizService;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.food.entity.vos.FoodVO;
import com.xxh.cloud.healthy.basic.framework.modules.food.service.FoodInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@Deprecated
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/foodInfo")
@Api(tags = "运营端,菜谱管理")
public class FoodManagerController {

    @Autowired
    private FoodBizService foodBizService;

    @SaCheckPermission("sys:healthy:basic:foodInfo:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = FoodVO.class)
    public Result<PageData<FoodVO>> query(@RequestBody FoodInfoQueryParam params) {
        ValidatorUtils.validateEntity(params);
        PageData<FoodVO> data= foodBizService.query(params);
        return new Result<PageData<FoodVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:foodInfo:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = FoodVO.class)
    public Result<FoodVO> save(@RequestBody FoodInfoSaveParam params) {
        ValidatorUtils.validateEntity(params);
        FoodVO data= foodBizService.save(params);
        return new Result<FoodVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:foodInfo:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = FoodVO.class)
    public Result<FoodVO> update(@RequestBody FoodInfoUpdateParam params) {
        ValidatorUtils.validateEntity(params);
        FoodVO data= foodBizService.update(params);
        return new Result<FoodVO>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:foodInfo:updateState")
    @PostMapping("/updateState")
    @ApiOperation(value = "修改状态", response = FoodVO.class)
    public Result<FoodVO> updateState(@RequestBody FoodInfoUpdateStatusParam params) {
        ValidatorUtils.validateEntity(params);
        FoodVO data= foodBizService.updateState(params);
        return new Result<FoodVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:foodInfo:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody FoodInfoByIdParam params) {
        ValidatorUtils.validateEntity(params);
        foodBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }


    @SaCheckPermission("sys:healthy:basic:foodInfo:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = FoodVO.class)
    public Result<FoodVO> info(@RequestBody FoodInfoByIdParam params) {
        ValidatorUtils.validateEntity(params);
        FoodVO data= foodBizService.infoById(params.getId());
        return new Result<FoodVO>().ok(data);
    }




}
