package com.xxh.cloud.healthy.basic.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.biz.HealthyServiceBizService;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.vos.HealthyServiceVO;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.service.HealthyServiceInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@Deprecated
//@SaCheckPermission("sys:healthy:basic:serviceInfo")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/serviceInfo")
@Api(tags = "运营端,服务管理")
public class HealthyServiceManagerController {

    @Autowired
    private HealthyServiceBizService healthyServiceBizService;


    @SaCheckPermission("sys:healthy:basic:serviceInfo:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = HealthyServiceVO.class)
    public Result<PageData<HealthyServiceVO>> query(@RequestBody HealthyServiceInfoQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<HealthyServiceVO> data=healthyServiceBizService.query(params);
        return new Result<PageData<HealthyServiceVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceInfo:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = HealthyServiceVO.class)
    public Result<HealthyServiceVO> save(@RequestBody HealthyServiceInfoSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceVO data= healthyServiceBizService.save(params);
        return new Result<HealthyServiceVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceInfo:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = HealthyServiceVO.class)
    public Result<HealthyServiceVO> update(@RequestBody HealthyServiceInfoUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceVO data=healthyServiceBizService.update(params);
        return new Result<HealthyServiceVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceInfo:updateStatus")
    @PostMapping("/updateState")
    @ApiOperation(value = "修改状态", response = HealthyServiceVO.class)
    public Result<HealthyServiceVO> updateStatus(@RequestBody HealthyServiceInfoUpdateStatusDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceVO data=healthyServiceBizService.updateState(params);
        return new Result<HealthyServiceVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceInfo:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody HealthyServiceInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        healthyServiceBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @SaCheckPermission("sys:healthy:basic:serviceInfo:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = HealthyServiceVO.class)
    public Result<HealthyServiceVO> info(@RequestBody HealthyServiceInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceVO data= healthyServiceBizService.infoById(params.getId());
        return new Result<HealthyServiceVO>().ok(data);
    }




}
