package com.xxh.cloud.healthy.basic.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.biz.HealthyServiceTargetBizService;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.entity.vos.HealthyServiceTargetVO;
import com.xxh.cloud.healthy.basic.framework.modules.serviceTarget.service.HealthyServiceTargetInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Deprecated
//@SaCheckPermission("sys:healthy:basic:serviceTarget")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/serviceTarget")
@Api(tags = "运营端,服务目标管理")
public class HealthyServiceTargetManagerController {

    @Autowired
    private HealthyServiceTargetBizService healthyServiceTargetBizService;

    @SaCheckPermission("sys:healthy:basic:serviceTarget:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = HealthyServiceTargetVO.class)
    public Result<PageData<HealthyServiceTargetVO>> query(@RequestBody HealthyServiceGroupQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<HealthyServiceTargetVO> data= healthyServiceTargetBizService.query(params);
        return new Result<PageData<HealthyServiceTargetVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceTarget:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = HealthyServiceTargetVO.class)
    public Result<List<HealthyServiceTargetVO>> list(@RequestBody HealthyServiceGroupListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<HealthyServiceTargetVO> data= healthyServiceTargetBizService.list(params);
        return new Result<List<HealthyServiceTargetVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceTarget:save")
    @PostMapping("/save")
    @ApiOperation(value = "保存", response = HealthyServiceTargetVO.class)
    public Result<HealthyServiceTargetVO>  save(@RequestBody HealthyServiceGroupSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceTargetVO data= healthyServiceTargetBizService.save(params);
        return new Result<HealthyServiceTargetVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceTarget:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = HealthyServiceTargetVO.class)
    public Result<HealthyServiceTargetVO> update(@RequestBody HealthyServiceGroupUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceTargetVO data= healthyServiceTargetBizService.update(params);
        return new Result<HealthyServiceTargetVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:serviceTarget:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = HealthyServiceTargetVO.class)
    public Result<HealthyServiceTargetVO> info(@RequestBody HealthyServiceGroupByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        HealthyServiceTargetVO data= healthyServiceTargetBizService.infoById(params.getId());
        return new Result<HealthyServiceTargetVO>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:serviceTarget:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody HealthyServiceGroupByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        healthyServiceTargetBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }



}
