package com.xxh.cloud.healthy.basic.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.vos.PushTaskConfigVO;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.service.PushTaskConfigBizService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/healthybasic/pushTaskConfig")
@Api(tags = "运营端,推送任务配置管理")
public class PushTaskConfigManagerController {

    @Autowired
    private PushTaskConfigBizService pushTaskConfigBizService;




    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = PushTaskConfigVO.class)
    public Result<PageData<PushTaskConfigVO>> query(@RequestBody PushTaskConfigQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<PushTaskConfigVO> data= pushTaskConfigBizService.query(params);
        return new Result<PageData<PushTaskConfigVO>>().ok(data);
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = PushTaskConfigVO.class)
    public Result<List<PushTaskConfigVO>> list(@RequestBody PushTaskConfigListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<PushTaskConfigVO> data= pushTaskConfigBizService.list(params);
        return new Result<List<PushTaskConfigVO>>().ok(data);
    }


    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = PushTaskConfigVO.class)
    public  Result<PushTaskConfigVO> save(@RequestBody PushTaskConfigSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskConfigVO data= pushTaskConfigBizService.save(params);
        return new Result<PushTaskConfigVO>().ok(data);
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = PushTaskConfigVO.class)
    public Result<PushTaskConfigVO> update(@RequestBody PushTaskConfigUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskConfigVO data= pushTaskConfigBizService.update(params);
        return new Result<PushTaskConfigVO>().ok(data);
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:updateStatus")
    @PostMapping("/updateStatus")
    @ApiOperation(value = "修改状态", response = PushTaskConfigVO.class)
    public Result<PushTaskConfigVO> updateStatus(@RequestBody PushTaskConfigUpdateStatusDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskConfigVO data= pushTaskConfigBizService.updateStatus(params);
        return new Result<PushTaskConfigVO>().ok(data);
    }


    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody PushTaskConfigGetDTO params) {
        ValidatorUtils.validateEntity(params);
        pushTaskConfigBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = PushTaskConfigVO.class)
    public Result<PushTaskConfigVO> info(@RequestBody PushTaskConfigGetDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskConfigVO data= pushTaskConfigBizService.getById(params.getId());
        return new Result<PushTaskConfigVO>().ok(data);
    }


}
