package com.xxh.cloud.healthy.basic.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.bean.vos.PushTaskCustomTypeVO;
import com.xxh.cloud.healthy.basic.framework.modules.pushTask.service.PushTaskCustomTypeBizService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/healthybasic/pushTaskCustomType")
@Api(tags = "运营端,推送任务自定义类型管理")
public class PushTaskCustomTypeManagerController {

    @Autowired
    private PushTaskCustomTypeBizService pushTaskCustomTypeBizService;

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = PushTaskCustomTypeVO.class)
    public Result<List<PushTaskCustomTypeVO>> list(@RequestBody PushTaskCustomTypeQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        List<PushTaskCustomTypeVO> data= pushTaskCustomTypeBizService.list(params);
        return new Result<List<PushTaskCustomTypeVO>>().ok(data);
    }


    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = PushTaskCustomTypeVO.class)
    public  Result<PushTaskCustomTypeVO> save(@RequestBody PushTaskCustomTypeSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskCustomTypeVO data= pushTaskCustomTypeBizService.save(params);
        return new Result<PushTaskCustomTypeVO>().ok(data);
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = Void.class)
    public Result<Void> update(@RequestBody PushTaskCustomTypeUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        pushTaskCustomTypeBizService.update(params);
        return new Result<Void>().success();
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody PushTaskCustomTypeGetDTO params) {
        ValidatorUtils.validateEntity(params);
        pushTaskCustomTypeBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    // @SaCheckPermission("sys:healthybasic:pushTaskConfig:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = PushTaskCustomTypeVO.class)
    public Result<PushTaskCustomTypeVO> info(@RequestBody PushTaskCustomTypeQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PushTaskCustomTypeVO data= pushTaskCustomTypeBizService.getOne(params);
        return new Result<PushTaskCustomTypeVO>().ok(data);
    }


}
