package com.xxh.cloud.healthy.basic.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto.RiskInfoDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto.RiskQueryDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto.RiskSaveDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.dto.RiskUpdateDTO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.entity.vos.RiskVO;
import com.xxh.cloud.healthy.basic.framework.modules.risk.service.RiskInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@Deprecated
//@SaCheckPermission("sys:healthy:basic:knowledge")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/risk")
@Api(tags = "运营端,风险管理")
public class RiskManagerController {


    @Autowired
    private RiskInfoService riskInfoService;


    @SaCheckPermission("sys:healthy:basic:risk:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = RiskVO.class)
    public Result<PageData<RiskVO>> query(@RequestBody RiskQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<RiskVO> data= riskInfoService.query(params);
        return new Result<PageData<RiskVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:risk:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = RiskVO.class)
    public Result<RiskVO> save(@RequestBody RiskSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        RiskVO data= riskInfoService.save(params);
        return new Result<RiskVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:risk:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = RiskVO.class)
    public Result<RiskVO> update(@RequestBody RiskUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        RiskVO data= riskInfoService.update(params);
        return new Result<RiskVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:risk:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody RiskInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        riskInfoService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @SaCheckPermission("sys:healthy:basic:risk:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = RiskVO.class)
    public Result<RiskVO> info(@RequestBody RiskInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        RiskVO data= riskInfoService.infoById(params.getId());
        return new Result<RiskVO>().ok(data);
    }



}
