package com.xxh.cloud.healthy.basic.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.sport.biz.SportCategoryBizService;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportCategoryVO;
import com.xxh.cloud.healthy.basic.framework.modules.sport.service.SportCategoryInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
@Deprecated
//@SaCheckPermission("sys:healthy:basic:sportCategory")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/sportCategory")
@Api(tags="健康管理端,运动分类管理")
public class SportCategoryManagerController {


    @Autowired
    private SportCategoryBizService sportCategoryBizService;


    @SaCheckPermission("sys:healthy:basic:sportCategory:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = SportCategoryVO.class)
    public Result<PageData<SportCategoryVO>> query(@RequestBody SportCategoryQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<SportCategoryVO> data= sportCategoryBizService.query(params);
        return new Result<PageData<SportCategoryVO>>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:sportCategory:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = SportCategoryVO.class)
    public Result<List<SportCategoryVO>> list(@RequestBody SportCategoryListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<SportCategoryVO> data= sportCategoryBizService.list(params);
        return new Result<List<SportCategoryVO>>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:sportCategory:save")
    @PostMapping("/save")
    @ApiOperation(value = "新增", response = SportCategoryVO.class)
    public Result<SportCategoryVO> save(@RequestBody SportCategorySaveDTO params) {
        ValidatorUtils.validateEntity(params);
        SportCategoryVO data= sportCategoryBizService.save(params);
        return new Result<SportCategoryVO>().ok(data);
    }

    @SaCheckPermission("sys:healthy:basic:sportCategory:update")
    @PostMapping("/update")
    @ApiOperation(value = "修改", response = SportCategoryVO.class)
    public Result<SportCategoryVO> update(@RequestBody SportCategoryUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        SportCategoryVO data=sportCategoryBizService.update(params);
        return new Result<SportCategoryVO>().ok(data);
    }


    @SaCheckPermission("sys:healthy:basic:sportCategory:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody SportCategoryInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        sportCategoryBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @SaCheckPermission("sys:healthy:basic:sportCategory:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = SportCategoryVO.class)
    public  Result<SportCategoryVO>  info(@RequestBody SportCategoryInfoDTO params) {
        ValidatorUtils.validateEntity(params);
        SportCategoryVO data= sportCategoryBizService.infoById(params.getId());
        return new Result<SportCategoryVO>().ok(data);
    }



}
