package com.xxh.cloud.healthy.basic.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.framework.modules.sport.biz.SportBizService;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.dto.*;
import com.xxh.cloud.healthy.basic.framework.modules.sport.entity.vos.SportVO;
import com.xxh.cloud.healthy.basic.framework.modules.sport.service.SportInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Deprecated
//@SaCheckPermission("sys:healthy:basic:sportInfo")
@Log4j2
@RestController
@RequestMapping("/sys/healthy/basic/sportInfo")
@Api(tags = "H_M_运动管理")
public class SportManagerController {

    @Autowired
    private SportBizService sportBizService;

    @SaCheckPermission("sys:healthy:basic:sportInfo:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = SportVO.class)
    public Result<PageData<SportVO>> query(@RequestBody SportInfoQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<SportVO> data= sportBizService.query(params);
        return new Result<PageData<SportVO>>().ok(data);
    }

    @PostMapping("/save")
    @ApiOperation(value = "新增", response = SportVO.class)
    public Result<SportVO> save(@RequestBody SportInfoSaveDTO params) {
        ValidatorUtils.validateEntity(params);
        SportVO data= sportBizService.save(params);
        return new Result<SportVO>().ok(data);
    }

    @PostMapping("/update")
    @ApiOperation(value = "修改", response = SportVO.class)
    public Result<SportVO> update(@RequestBody SportInfoUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        SportVO data= sportBizService.update(params);
        return new Result<SportVO>().ok(data);
    }

    @PostMapping("/updateState")
    @ApiOperation(value = "修改状态", response = SportVO.class)
    public Result<SportVO> updateState(@RequestBody SportInfoUpdateStateDTO params) {
        ValidatorUtils.validateEntity(params);
        SportVO data= sportBizService.updateState(params);
        return new Result<SportVO>().ok(data);
    }

    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody SportInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        sportBizService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @PostMapping("/info")
    @ApiOperation(value = "获取", response = SportVO.class)
    public Result<SportVO> info(@RequestBody SportInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        SportVO data= sportBizService.infoById(params.getId());
        return new Result<SportVO>().ok(data);
    }



}
