package com.xxh.cloud.common.mq.bean;

import cn.hutool.core.date.DateUtil;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * MQ:事件信息
 * */
public class MQPatientEventBean {


    /**
     * 患者编号
     * */
    private String patientId;

    /**
     * 事件分类
     * */
    private String eventType;

    /**
     * 事件时间
     * */
    private String eventDate;

    /**
     * 关联数据分类
     * */
    private String objType;

    /**
     * 关联数据ID
     * */
    private String objId;

    /**
     * 事件数据
     * */
    private Map<String, Object> eventData;


    public void addEventData(String key,Object val){
        if(this.eventData==null){
            this.eventData=new HashMap<>();
        }
        if(key!=null && !"".equals(key) && val!=null){
            this.eventData.put(key,val);
        }
    }


    public void addEventDate(Date eventDate){
        if(eventDate==null){
            return;
        }
        this.eventDate= DateUtil.formatDateTime(eventDate);
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getEventType() {
        return eventType;
    }

    public void setEventType(String eventType) {
        this.eventType = eventType;
    }

    public String getEventDate() {
        return eventDate;
    }

    public void setEventDate(String eventDate) {
        this.eventDate = eventDate;
    }

    public Map<String, Object> getEventData() {
        return eventData;
    }

    public void setEventData(Map<String, Object> eventData) {
        this.eventData = eventData;
    }

    public String getObjType() {
        return objType;
    }

    public void setObjType(String objType) {
        this.objType = objType;
    }

    public String getObjId() {
        return objId;
    }

    public void setObjId(String objId) {
        this.objId = objId;
    }
}
