package com.xxh.cloud.common.util;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.common.mq.constant.HMQQueueName2RuleExe;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

public class DataUtil {
    
    public static String getAge(String idcard, String birthday) {


//        HMQQueueName2RuleExe
        String age = null;
        if (StrUtil.isNotBlank(birthday)) {
            try {
                age = String.valueOf(DateUtil.betweenYear(DateUtil.parseDate(birthday), DateUtil.date(), false));
            } catch (Exception e) {
                System.out.println("解析出生年月转年龄错误");
                e.printStackTrace();
            }
            // 0岁的用月来表示年龄
            if (StrUtil.isNotBlank(age) && "0".equals(age)) {
                age = String.valueOf(DateUtil.betweenMonth(DateUtil.parseDate(birthday), DateUtil.date(), false) + 1) + "个月";
            }
        }
        if (null == age && StrUtil.isNotBlank(idcard)) {
            try {
                age = String.valueOf(IdcardUtil.getAgeByIdCard(idcard));
            } catch (Exception e) {
                System.out.println("解析身份证号转年龄错误");
                e.printStackTrace();
            }
            // 0岁的用月来表示年龄
            if (StrUtil.isNotBlank(age) && "0".equals(age)) {
                age = String.valueOf(DateUtil.betweenMonth(IdcardUtil.getBirthDate(idcard), DateUtil.date(), false) + 1) + "个月";
            }
        }
        return age;
    }

    public static String getBirthdayByAge(Integer age) {
        if (null == age) {
            return "";
        }
        LocalDate ld = LocalDate.now().minusYears(age);
        return ld.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
    }

}
