package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 病种阶段目标表
 * </p>
 *
 * @author anros
 * @since 2024-07-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_disease_phase_target_config_info")
public class DiseasePhaseTargetConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 所属阶段ID
     */
     @ApiModelProperty(value = "所属阶段ID")
      private String phaseId;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String state;

    /**
     * 条件配置分类
     */
     @ApiModelProperty(value = "条件配置分类")
      private String conditionType;

    /**
     * 条件配置内容
     */
     @ApiModelProperty(value = "条件配置内容")
      private String conditionContent;

    /**
     * 目标执行科室
     */
    @ApiModelProperty(value = "目标执行科室")
    private String targetExeDeptIds;

    /**
     * 目标执行期限(天)
     */
    @ApiModelProperty(value = "目标执行期限(天)")
    private Integer completionLimit;

    /**
     * 数据状态
     */
     @ApiModelProperty(value = "数据状态")
      private String rowsState;



}
