package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者变更日志表
 * </p>
 *
 * @author anros
 * @since 2024-07-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_patient_doctor_relation_change_info")
public class PatientDoctorRelationChangeInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 关系ID
     */
     @ApiModelProperty(value = "关系ID")
      private String relationId;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 变更业务分类
     */
     @ApiModelProperty(value = "变更业务分类")
      private String changeType;

    /**
     * 原医生ID
     */
     @ApiModelProperty(value = "原医生ID")
      private String oldDoctorId;

    /**
     * 新医生ID
     */
     @ApiModelProperty(value = "新医生ID")
      private String newDoctorId;

    /**
     * 原所属阶段ID
     */
     @ApiModelProperty(value = "原所属阶段ID")
      private String oldPhaseId;

    /**
     * 新所属阶段ID
     */
     @ApiModelProperty(value = "新所属阶段ID")
      private String newPhaseId;

    /**
     * 原所属目标ID
     */
     @ApiModelProperty(value = "原所属目标ID")
      private String oldPhaseTargetIds;

    /**
     * 新所属目标ID
     */
     @ApiModelProperty(value = "新所属目标ID")
      private String newPhaseTargetIds;

    /**
     * 变更方式
     */
     @ApiModelProperty(value = "变更方式")
      private String changeWay;

    /**
     * 变更人
     */
     @ApiModelProperty(value = "变更人")
      private String changeUserId;

    /**
     * 变更备注
     */
     @ApiModelProperty(value = "变更备注")
      private String changeRemark;

    @ApiModelProperty(value = "原批次号")
    private Integer oldBatchNo;

    @ApiModelProperty(value = "新批次号")
    private Integer newBatchNo;


}
