package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者服务关系历史表
 * </p>
 *
 * @author anros
 * @since 2024-07-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_patient_doctor_relation_his_info")
public class PatientDoctorRelationHisInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 关系ID
     */
     @ApiModelProperty(value = "关系ID")
      private String relationId;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 所属阶段ID
     */
     @ApiModelProperty(value = "所属阶段ID")
      private String phaseId;

    /**
     * 批次编号
     */
    @ApiModelProperty(value = "批次编号")
    private Integer batchNo;

	/**
     * 关系类型
     */
     @ApiModelProperty(value = "关系类型")
      private String relType;
	  
    /**
     * 关系开始时间
     */
     @ApiModelProperty(value = "关系开始时间")
      private Date startDt;

    /**
     * 关系截止时间
     */
     @ApiModelProperty(value = "关系截止时间")
      private Date endDt;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

}
