package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者服务关系表
 * </p>
 *
 * @author anros
 * @since 2024-07-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_patient_doctor_relation_info")
public class PatientDoctorRelationInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String addRemark;

    /**
     * 新增方式
     */
     @ApiModelProperty(value = "新增方式")
      private String addWay;

    /**
     * 新增人ID
     */
     @ApiModelProperty(value = "新增人ID")
      private String addUserId;

    /**
     * 所属阶段ID
     */
     @ApiModelProperty(value = "所属阶段ID")
      private String phaseId;

    /**
     * 批次编号
     */
    @ApiModelProperty(value = "批次编号")
    private Integer batchNo;

    /**
     * 关系类型
     */
     @ApiModelProperty(value = "关系类型")
      private String relType;


    /**
     * 来源分类
     */
     @ApiModelProperty(value = "来源分类")
      private String sourceType;

    /**
     * 来源关联对象ID
     */
     @ApiModelProperty(value = "来源关联对象ID")
      private String sourceObjId;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String state;

    /**
     * 数据状态
     */
     @ApiModelProperty(value = "数据状态")
      private String rowsState;




}
