package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者服务关系目标信息表
 * </p>
 *
 * @author anros
 * @since 2024-07-03
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_patient_doctor_relation_target_info")
public class PatientDoctorRelationTargetInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 关系ID
     */
     @ApiModelProperty(value = "关系ID")
      private String relationId;

    /**
     * 阶段ID
     */
     @ApiModelProperty(value = "阶段ID")
      private String phaseId;

    /**
     * 批次编号
     */
    @ApiModelProperty(value = "批次编号")
    private Integer batchNo;

    /**
     * 目标ID
     */
     @ApiModelProperty(value = "目标ID")
      private String targetId;

    /**
     * 开始时间
     */
     @ApiModelProperty(value = "开始时间")
      private Date startDt;

    /**
     * 结束时间
     */
     @ApiModelProperty(value = "结束时间")
      private Date endDt;

    /**
     * 执行结果状态
     */
     @ApiModelProperty(value = "执行结果状态")
      private String resultState;

    /**
     * 执行结果时间
     */
     @ApiModelProperty(value = "执行结果时间")
      private Date resultDt;

    /**
     * 数据
     */
     @ApiModelProperty(value = "数据")
      private String rowsState;

    /**
     * 截止时间
     */
    @ApiModelProperty(value = "截止时间")
    private Date limitDt;


}
