package com.xxh.cloud.healthy.crm.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生患者服务记录表
 * </p>
 *
 * @author anros
 * @since 2024-07-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("crm_patient_service_record_info")
public class PatientServiceRecordInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 服务关系ID
     */
     @ApiModelProperty(value = "服务关系ID")
      private String relationId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 阶段ID
     */
     @ApiModelProperty(value = "阶段ID")
      private String phaseId;

    /**
     * 批次编号
     */
    @ApiModelProperty(value = "批次编号")
    private Integer batchNo;

    /**
     * 记录业务分类
     */
     @ApiModelProperty(value = "记录业务分类")
      private String bizType;

    /**
     * 记录内容
     */
     @ApiModelProperty(value = "记录内容")
      private String content;

    /**
     * 记录时间
     */
     @ApiModelProperty(value = "记录时间")
      private Date addDt;

    /**
     * 数据状态
     */
     @ApiModelProperty(value = "数据状态")
      private String rowsState;




}
