package com.xxh.cloud.healthy.crm.framework.modules.biz.bean.dto.config;

import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.ConditionContentBO;
import com.xxh.cloud.healthy.crm.framework.modules.constant.DiseasePhaseConfigStateEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class DiseaseTargetPhaseConfigAddDTO {


    @ApiModelProperty(value = "所属阶段ID" ,required = true)
    @NotEmpty(message = "所属阶段不能为空")
    private String phaseId;

    @ApiModelProperty(value = "名称",required = true)
    @NotEmpty(message = "名称不能为空")
    private String name;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态[DiseasePhaseConfigStateEnum]",required = true)
    @NotEmpty(message = "状态不能为空")
    private String state= DiseasePhaseConfigStateEnum.DPCS_Normal.getCode();


    @ApiModelProperty(value = "条件配置分类[DiseaseTargetPhaseTypeEnum]",required = true)
    @NotEmpty(message = "目标分类不能为空")
    private String conditionType;

    @ApiModelProperty(value = "目标执行期限(天)")
    private int completionLimit;

    @ApiModelProperty(value = "目标执行科室")
    private List<String> targetExeDeptIds;

}
