package com.xxh.cloud.healthy.crm.framework.modules.biz.bean.dto.rel;

import com.xxh.cloud.healthy.crm.framework.modules.constant.PatientDoctorRelationAddWayEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.Date;
import java.util.Set;

@Getter
@Setter
public class PatientDoctorRelationTransferDTO {

    @ApiModelProperty(value = "id",required = true)
    @NotEmpty(message = "ID不能为空")
    private String id;


    @ApiModelProperty(value = "原因说明")
    private String remark;

    @ApiModelProperty(value = "医生ID",required = true)
    @NotEmpty(message = "医生ID不能为空")
    private String doctorId;

    @ApiModelProperty(value = "病种ID",required = true)
    @NotEmpty(message = "病种ID不能为空")
    private String diseaseId;

    @ApiModelProperty(value = "所属阶段ID")
    private String phaseId;

    @ApiModelProperty(value = "所属目标ID")
    private Set<String> phaseTargetIds;

    @ApiModelProperty(value = "任务截至时间")
    private Date limitDt;

    @ApiModelProperty(value = "是否加入随访计划 Y/N (只对随访目标有效)")
    private String addFollowUp;

    @ApiModelProperty(value = "来源分类(PatientDoctorRelationSourceTypeEnum)")
    private String sourceType;


    @ApiModelProperty(value = "来源关联对象ID")
    private String sourceObjId;


    @ApiModelProperty(value = "新增方式(PatientDoctorRelationAddWayEnum)")
    private String addWay= PatientDoctorRelationAddWayEnum.PDR_Way_Human.getCode();


    @ApiModelProperty(value = "新增人ID")
    private String opUserId;




}
