package com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos;


import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class DiseasePhaseConfigVO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "是否默认")
    private String isDef;

    @ApiModelProperty(value = "状态")
    private String state;

    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;

    @ApiModelProperty(value = "病种名称")
    private String diseaseName;

    @ApiModelProperty("创建者-姓名")
    private String creatorName;

    @ApiModelProperty("更新者-姓名")
    private String updaterName;

    @ApiModelProperty("病种阶段目标表")
    private List<DiseasePhaseTargetConfigVO> targets = new ArrayList<>();

    public void addTargets(List<DiseasePhaseTargetConfigVO> targets){
        this.targets.addAll(targets);
        this.targets.forEach(target->{
            target.setDiseaseId(this.diseaseId);
        });
    }

}
