package com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos;


import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.PhaseTargetBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.RelationTargetBO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

/** 个案变更记录 **/
@Getter
@Setter
public class PatientDoctorRelationChangeVO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "关系ID")
    private String relationId;

    @ApiModelProperty(value = "患者ID")
    private String patientId;

    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "变更业务分类")
    private String changeType;

    @ApiModelProperty(value = "原医生ID")
    private String oldDoctorId;

    @ApiModelProperty(value = "新医生ID")
    private String newDoctorId;

    @ApiModelProperty(value = "原所属阶段ID")
    private String oldPhaseId;

    @ApiModelProperty(value = "新所属阶段ID")
    private String newPhaseId;

    @ApiModelProperty(value = "变更方式")
    private String changeWay;

    @ApiModelProperty(value = "变更备注")
    private String changeRemark;

    //===============================

    @ApiModelProperty(value = "患者名称")
    private String patientName;

    @ApiModelProperty(value = "患者性别")
    private String patientGender;

    @ApiModelProperty(value = "患者年龄")
    private String patientAge;

    @ApiModelProperty(value = "原所属阶段名称")
    private String oldPhaseName;

    @ApiModelProperty(value = "新所属阶段名称")
    private String newPhaseName;

    @ApiModelProperty(value = "病种名称")
    private String diseaseName;

    @ApiModelProperty(value = "原医生名称")
    private String oldDoctorName;

    @ApiModelProperty(value = "新医生名称")
    private String newDoctorName;

    // 目标=============================
    @ApiModelProperty(value = "关系所属目标列表")
    private List<RelationTargetBO> relationTargetList = new ArrayList<>();

}
