package com.xxh.cloud.healthy.crm.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.DiseasePhaseConfigInfo;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.DiseasePhaseConfigVO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class DiseasePhaseConfigConvert {

    public static DiseasePhaseConfigVO getDiseasePhaseConfigVO(DiseasePhaseConfigInfo entity){
        DiseasePhaseConfigVO data=new DiseasePhaseConfigVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }


    public static DiseasePhaseConfigVO getDiseasePhaseConfigVO(DiseasePhaseConfigInfo entity, Map<String, AdminUserBO> userMap,Map<String, StandardDiseaseBO> diseaseMap){
        DiseasePhaseConfigVO data=DiseasePhaseConfigConvert.getDiseasePhaseConfigVO(entity);
        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user = userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getRealName());
            }

            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user = userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getRealName());
            }
        }

        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
            StandardDiseaseBO disease=diseaseMap.get(data.getDiseaseId());
            data.setDiseaseName(disease==null?null:disease.getName());
        }
        return data;
    }

}
