package com.xxh.cloud.healthy.crm.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.DiseasePhaseTargetConfigInfo;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.DiseasePhaseTargetConfigVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class DiseasePhaseTargetConfigConvert {

    public static  DiseasePhaseTargetConfigVO getDiseasePhaseTargetConfigVO(DiseasePhaseTargetConfigInfo entity){
        DiseasePhaseTargetConfigVO data=new DiseasePhaseTargetConfigVO();
        BeanUtil.copyProperties(entity,data,"targetExeDeptIds");
        if (StrUtil.isNotEmpty(entity.getTargetExeDeptIds())) {
            data.setTargetExeDeptIds(StrJoinSplitUtils.split2List(entity.getTargetExeDeptIds()));
        }
        return data;
    }

    public static  DiseasePhaseTargetConfigVO getDiseasePhaseTargetConfigVO(DiseasePhaseTargetConfigInfo entity, Map<String, AdminUserBO> userMap){
        DiseasePhaseTargetConfigVO data=DiseasePhaseTargetConfigConvert.getDiseasePhaseTargetConfigVO(entity);
        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user = userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getRealName());
            }

            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user = userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getRealName());
            }
        }

        return data;
    }



}
