package com.xxh.cloud.healthy.crm.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.crm.client.api.bean.bo.PatientDoctorRelationBO;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.*;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.PatientDoctorRelationPhaseBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.PhaseTargetBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.RelationTargetBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientDoctorRelationChangeVO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientDoctorRelationFullVO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientDoctorRelationVO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import io.swagger.annotations.ApiModelProperty;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

public class PatientDoctorRelationChangeConvert {


    public static PatientDoctorRelationChangeVO getPatientDoctorRelationChangeVO(PatientDoctorRelationChangeInfo entity){
        PatientDoctorRelationChangeVO data = new PatientDoctorRelationChangeVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static PatientDoctorRelationChangeVO getPatientDoctorRelationChangeVO(PatientDoctorRelationChangeInfo entity,
                                                                                 Map<String, AdminUserBO> userMap,
                                                                                 Map<String, StandardDiseaseBO> diseaseMap,
                                                                                 Map<String, DiseasePhaseConfigInfo> phaseMap,
                                                                                 Map<String, PatientClientBO> patientMap,
                                                                                 Map<String, List<PatientDoctorRelationTargetInfo>> targetMap,
                                                                                 Map<String, DiseasePhaseTargetConfigInfo> targetConfigMap){
        PatientDoctorRelationChangeVO data= getPatientDoctorRelationChangeVO(entity);
        // 原医生
        if(MapUtil.isNotEmpty(userMap) && userMap.containsKey(data.getOldDoctorId())){
            data.setOldDoctorName(userMap.get(data.getOldDoctorId()).getRealName());
        }
        // 新医生
        if(MapUtil.isNotEmpty(userMap) && userMap.containsKey(data.getNewDoctorId())){
            data.setNewDoctorName(userMap.get(data.getNewDoctorId()).getRealName());
        }
        // 病种
        if(MapUtil.isNotEmpty(diseaseMap) && diseaseMap.containsKey(data.getDiseaseId())){
            data.setDiseaseName(diseaseMap.get(data.getDiseaseId()).getName());
        }
        // 原阶段
        if(MapUtil.isNotEmpty(phaseMap) && phaseMap.containsKey(data.getNewPhaseId())){
            data.setNewPhaseName(phaseMap.get(data.getNewPhaseId()).getName());
        }
        // 新阶段
        if(MapUtil.isNotEmpty(phaseMap) && phaseMap.containsKey(data.getOldPhaseId())){
            data.setNewPhaseName(phaseMap.get(data.getOldPhaseId()).getName());
        }
        // 患者
        if(MapUtil.isNotEmpty(patientMap) && patientMap.containsKey(data.getPatientId())) {
            PatientClientBO patientClient = patientMap.get(data.getPatientId());
            data.setPatientName(patientClient.getPatientName());
            data.setPatientGender(patientClient.getPatientGenderStandard());
            data.setPatientAge(patientClient.getAge());
        }

        // 关联目标
        if(MapUtil.isNotEmpty(targetMap) && targetMap.containsKey(data.getRelationId())){
            List<PatientDoctorRelationTargetInfo> targets = targetMap.get(data.getRelationId());
            data.getRelationTargetList().addAll(targets.stream().map(
                    item-> PatientDoctorRelationConvert.getRelationTargetBO(item, targetConfigMap)).collect(Collectors.toList()));
        }
        return data;
    }


}
