package com.xxh.cloud.healthy.crm.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.crm.client.api.bean.bo.PatientDoctorRelationBO;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.DiseasePhaseConfigInfo;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.DiseasePhaseTargetConfigInfo;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.PatientDoctorRelationInfo;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.PatientDoctorRelationTargetInfo;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.PatientDoctorRelationPhaseBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.PhaseTargetBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.bos.RelationTargetBO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientDoctorRelationFullVO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientDoctorRelationVO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.common.util.DataUtil;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class PatientDoctorRelationConvert {


    public static PatientDoctorRelationVO getPatientDoctorRelationVO(PatientDoctorRelationInfo entity){
        PatientDoctorRelationVO data=new PatientDoctorRelationVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }


    public static PatientDoctorRelationVO getPatientDoctorRelationVO(PatientDoctorRelationInfo entity,
                                                                     Map<String, AdminUserBO> userMap,
                                                                     Map<String, StandardDiseaseBO> diseaseMap,
                                                                     Map<String, DiseasePhaseConfigInfo> phaseMap){
        PatientDoctorRelationVO data=PatientDoctorRelationConvert.getPatientDoctorRelationVO(entity);


        //患者名称
        //patientName

        //所属阶段名称
        if(MapUtil.isNotEmpty(phaseMap) && StrUtil.isNotEmpty(data.getPhaseId())){
            DiseasePhaseConfigInfo phase=phaseMap.get(data.getPhaseId());
            data.setPhaseName(phase==null?null:phase.getName());
        }

        //病种名称
        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
            StandardDiseaseBO disease=diseaseMap.get(data.getDiseaseId());
            data.setDiseaseName(disease==null?null:disease.getName());
        }


        if(MapUtil.isNotEmpty(userMap)){
            //创建者-姓名
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user = userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getRealName());
            }
            //更新者-姓名
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user = userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getRealName());
            }
            //医生名称
            if(StrUtil.isNotEmpty(data.getDoctorId())){
                AdminUserBO user = userMap.get(data.getDoctorId());
                data.setDoctorName(user==null?null:user.getRealName());
            }
            //新增人名称
            if(StrUtil.isNotEmpty(data.getAddUserId())){
                AdminUserBO user = userMap.get(data.getAddUserId());
                data.setAddUserName(user==null?null:user.getRealName());
            }
        }


        return data;
    }


    //======================================================================================================
    public static PatientDoctorRelationFullVO getPatientDoctorRelationFullVO(PatientDoctorRelationInfo entity,
                                                                             Map<String, AdminUserBO> userMap,
                                                                             Map<String, StandardDiseaseBO> diseaseMap,
                                                                             Map<String,DiseasePhaseConfigInfo> phaseMap,
                                                                             Map<String, PatientClientBO> patientMap,
                                                                             Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap,
                                                                             Map<String, String> followMap){
        PatientDoctorRelationFullVO data=new PatientDoctorRelationFullVO();
        BeanUtil.copyProperties(entity,data);


        //病种名称
        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
            StandardDiseaseBO disease=diseaseMap.get(data.getDiseaseId());
            data.setDiseaseName(disease==null?null:disease.getName());
        }


        if(MapUtil.isNotEmpty(userMap)){
            //创建者-姓名
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user = userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getRealName());
            }
            //更新者-姓名
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user = userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getRealName());
            }
            //医生名称
            if(StrUtil.isNotEmpty(data.getDoctorId())){
                AdminUserBO user = userMap.get(data.getDoctorId());
                data.setDoctorName(user==null?null:user.getRealName());
            }
            //新增人名称
            if(StrUtil.isNotEmpty(data.getAddUserId())){
                AdminUserBO user = userMap.get(data.getAddUserId());
                data.setAddUserName(user==null?null:user.getRealName());
            }
        }

        if(MapUtil.isNotEmpty(phaseMap) && StrUtil.isNotEmpty(data.getPhaseId())){
            DiseasePhaseConfigInfo phase=phaseMap.get(data.getPhaseId());
            data.setPhaseName(phase==null?null:phase.getName());
        }

        // 患者信息
        if (MapUtil.isNotEmpty(patientMap) && patientMap.containsKey(data.getPatientId())) {
            PatientClientBO patient = patientMap.get(data.getPatientId());
            data.setPatientName(patient.getPatientName());
            data.setPatientGender(patient.getPatientGenderStandard());
            data.setPatientAge(patient.getAge());
            data.setPhone(patient.getPhone());
            data.setSparePhone(patient.getSparePhone());
        }
        // 患者最新数据
        if (MapUtil.isNotEmpty(patientDataLastDateMap) && patientDataLastDateMap.containsKey(data.getPatientId())) {
            data.setPatientDataLast(patientDataLastDateMap.get(data.getPatientId()));
        }

        // 关注信息
        if (MapUtil.isNotEmpty(followMap) && followMap.containsKey(data.getPatientId())) {
            data.setFollowStatus(followMap.get(data.getPatientId()));
        }


        return data;
    }



    public static PatientDoctorRelationFullVO getPatientDoctorRelationFullVO(PatientDoctorRelationInfo entity,
                                                                             List<DiseasePhaseConfigInfo> phaseList,
                                                                             List<PatientDoctorRelationTargetInfo> targetList,
                                                                             Map<String, DiseasePhaseTargetConfigInfo> targetConfigMap,
                                                                             Map<String, AdminUserBO> userMap,
                                                                             Map<String, StandardDiseaseBO> diseaseMap,
                                                                             Map<String,DiseasePhaseConfigInfo> phaseMap,
                                                                             Map<String, PatientClientBO> patientMap,
                                                                             Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap,
                                                                             Map<String, String> followMap){


        PatientDoctorRelationFullVO data=PatientDoctorRelationConvert.getPatientDoctorRelationFullVO(entity,userMap,diseaseMap,phaseMap,patientMap,patientDataLastDateMap,followMap);

        if(CollUtil.isNotEmpty(phaseList)){
            for(DiseasePhaseConfigInfo dpcInfo:phaseList){
                data.addPhase(PatientDoctorRelationConvert.getPatientDoctorRelationPhaseBO(data.getPhaseId(),dpcInfo,targetList,targetConfigMap));
            }
        }

        return data;
    }


    /**
     * 关系阶段
     * */
    public static PatientDoctorRelationPhaseBO getPatientDoctorRelationPhaseBO(String relationPhaseId,
                                                                               DiseasePhaseConfigInfo entity,
                                                                               List<PatientDoctorRelationTargetInfo> relationTargetList,
                                                                               Map<String, DiseasePhaseTargetConfigInfo> targetConfigMap){
        PatientDoctorRelationPhaseBO data=new PatientDoctorRelationPhaseBO();

        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setOrders(entity.getOrders());
        data.setRemark(entity.getRemark());
        data.setIsDef(entity.getIsDef());
        data.setState(entity.getState());
        data.setCurrentFlag(YN.NO.getCode());
        if(StrUtil.isNotEmpty(relationPhaseId) && relationPhaseId.equals(entity.getId())){
            data.setCurrentFlag(YN.YES.getCode());
        }

        Set<String> relationTargetIds=new HashSet<>();
        if(CollUtil.isNotEmpty(relationTargetList)){
            relationTargetList.forEach(target->{
                relationTargetIds.add(target.getTargetId());
                if(entity.getId().equals(target.getPhaseId())){
                    data.addRelationTarget(PatientDoctorRelationConvert.getRelationTargetBO(target,targetConfigMap));
                }
            });
        }

        if(MapUtil.isNotEmpty(targetConfigMap)){
            targetConfigMap.forEach((id,item)->{
                if(entity.getId().equals(item.getPhaseId())){
                    data.addPhaseTarget(PatientDoctorRelationConvert.getPhaseTargetBO(item,relationTargetIds));
                }
            });
        }



        return data;
    }



    /**
     * 关系目标
     * */
    public static RelationTargetBO getRelationTargetBO(PatientDoctorRelationTargetInfo entity,Map<String, DiseasePhaseTargetConfigInfo> targetConfigMap){
        RelationTargetBO data=new RelationTargetBO();
        BeanUtil.copyProperties(entity,data);
        if(CollUtil.isNotEmpty(targetConfigMap) && targetConfigMap.containsKey(data.getTargetId())){
            data.setTargetName(targetConfigMap.get(data.getTargetId()).getName());
        }
        return data;
    }


    /**
     * 阶段目标
     * */
    public static PhaseTargetBO getPhaseTargetBO(DiseasePhaseTargetConfigInfo entity,Set<String> relationTargetIds){
        PhaseTargetBO data=new  PhaseTargetBO();
        BeanUtil.copyProperties(entity,data);
        data.setSelectFlag(YN.NO.getCode());
        if(CollUtil.isNotEmpty(relationTargetIds)){
            if(relationTargetIds.contains(data.getId())){
                data.setSelectFlag(YN.YES.getCode());
            }
        }
        return data;
    }

    public static PatientDoctorRelationBO getPatientDoctorRelationBO(PatientDoctorRelationInfo entity){
        PatientDoctorRelationBO bo = new  PatientDoctorRelationBO();
        BeanUtil.copyProperties(entity, bo);
        return bo;
    }


}
