package com.xxh.cloud.healthy.crm.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.PatientServiceRecordInfo;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.vos.PatientServiceRecordVO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDeptBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import java.util.Map;

public class PatientServiceRecordConvert {

    public static PatientServiceRecordVO getPatientServiceRecordVO(PatientServiceRecordInfo entity){
        PatientServiceRecordVO data=new PatientServiceRecordVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static PatientServiceRecordVO getPatientServiceRecordVO(PatientServiceRecordInfo entity,
                                                                   Map<String, AdminUserBO> userMap,
                                                                   Map<String, StandardDiseaseBO> diseaseMap,
                                                                   Map<String, DeptBO> deptMaps
    ){
        PatientServiceRecordVO data=PatientServiceRecordConvert.getPatientServiceRecordVO(entity);



        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user = userMap.get(data.getCreator());
                data.setCreatorName(user==null?null:user.getRealName());
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user = userMap.get(data.getUpdater());
                data.setUpdaterName(user==null?null:user.getRealName());
            }
            if(StrUtil.isNotEmpty(data.getDoctorId())){
                AdminUserBO user = userMap.get(data.getDoctorId());
                data.setDoctorName(user==null?null:user.getRealName());
                if (user!=null && StrUtil.isNotEmpty(user.getDeptId()) &&
                    deptMaps != null && deptMaps.containsKey(user.getDeptId())) {
                    data.setDeptId(deptMaps.get(user.getDeptId()).getId());
                    data.setDeptName(deptMaps.get(user.getDeptId()).getName());
                }
            }
        }

        if(MapUtil.isNotEmpty(diseaseMap) && StrUtil.isNotEmpty(data.getDiseaseId())){
            StandardDiseaseBO disease=diseaseMap.get(data.getDiseaseId());
            data.setDiseaseName(disease==null?null:disease.getName());
        }

        return data;
    }


}
