package com.xxh.cloud.healthy.crm.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;

public interface PatientComeDataBizMapper {

    // 查询会诊信息
    @Select(" SELECT COUNT(1) " + 
            " FROM mdt_consultation_info a " +
            " INNER JOIN mdt_his_consultation_advice_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    Integer consultationCount(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 查询随访信息
    @Select(" SELECT COUNT(1) FROM h_doctor_follow_up_info " +
            " ${ew.customSqlSegment} ")
    Integer followUpCount(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 医生所属部门管理的病种列表
    @Select(" select disease_ids from sys_dept where id in (select dept_id from sys_user where id = #{doctorId}) ")
    List<String> getDiseaseByDoctor(@Param("doctorId") String doctorId);

    // 病种所属的部门列表
    @Select(" select id from sys_dept " +
            " ${ew.customSqlSegment} ")
    List<String> getDeptByDiseaseId(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

}
