package com.xxh.cloud.healthy.crm.framework.modules.biz.service.impl;

import cn.hutool.core.date.DateUtil;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.dto.config.DwdPatientChangeQueryDTO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.dto.config.DwdPatientComeQueryDTO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.mapper.DwdPatientComeDataBizMapper;
import com.xxh.cloud.healthy.crm.framework.modules.biz.service.DwdPatientComeDataBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson2.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import lombok.extern.slf4j.Slf4j;

@DS("wd")
@Slf4j
@Service
public class DwdPatientComeDataBizServiceImpl implements DwdPatientComeDataBizService {
    
    @Autowired
    private DwdPatientComeDataBizMapper dwdPatientDataBizMapper;

    @Override
    public Integer registerCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.registerCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.registerCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reg_date", params.getStartDate())
                .lt(null != params.getEndDate(), "reg_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.registerCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reg_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reg_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> registerDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.registerDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.registerDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reg_date", params.getStartDate())
                .lt(null != params.getEndDate(), "reg_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.registerDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reg_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reg_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer visitCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.visitCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.visitCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "visit_date", params.getStartDate())
                .lt(null != params.getEndDate(), "visit_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.visitCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.visit_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.visit_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> visitDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.visitDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.visitDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "visit_date", params.getStartDate())
                .lt(null != params.getEndDate(), "visit_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.visitDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.visit_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.visit_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer inHospitalCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.inHospitalCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.inHospitalCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "inpatient_date", params.getStartDate())
                .lt(null != params.getEndDate(), "inpatient_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.inHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.inpatient_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.inpatient_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> inHospitalDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.inHospitalDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.inHospitalDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "inpatient_date", params.getStartDate())
                .lt(null != params.getEndDate(), "inpatient_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.inHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.inpatient_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.inpatient_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer inpatientChangeCount(DwdPatientChangeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.inpatientChangeCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.inpatientChangeCount(new QueryWrapper<DwdPatientChangeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getChangeType()), "change_type", params.getChangeType())
                .ge(null != params.getStartDate(), "change_time", DateUtil.formatDate(params.getStartDate()))
                .lt(null != params.getEndDate(), "change_time", DateUtil.formatDate(params.getEndDate()))
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "code", params.getDeptIds())
        );

        return count;
    }

    @Override
    public List<Map<String, Object>> inpatientChangeDataList(DwdPatientChangeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.inpatientChangeDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.inpatientChangeDataList(new QueryWrapper<DwdPatientChangeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getChangeType()), "change_type", params.getChangeType())
                .ge(null != params.getStartDate(), "change_time", DateUtil.formatDate(params.getStartDate()))
                .lt(null != params.getEndDate(), "change_time", DateUtil.formatDate(params.getEndDate()))
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "code", params.getDeptIds())
        );
    }

    @Override
    public Integer outHospitalCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.outHospitalCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.outHospitalCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "leave_date", params.getStartDate())
                .lt(null != params.getEndDate(), "leave_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.outHospitalCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.leave_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.leave_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> outHospitalDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.outHospitalDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.outHospitalDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "leave_date", params.getStartDate())
                .lt(null != params.getEndDate(), "leave_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "admit_department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.outHospitalDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.leave_date", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.leave_date", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.admit_department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer operationCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.operationCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.operationCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.operationCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.apply_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.apply_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> operationDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.operationDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.operationDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.operationDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.apply_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.apply_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer examineCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.examineCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.examineCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.examineCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> examineDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.examineDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.examineDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.examineDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

    @Override
    public Integer laboratoryCount(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.laboratoryCount:params:>>>>>> {} ", JSON.toJSONString(params));
        Integer count = dwdPatientDataBizMapper.laboratoryCount(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // Integer count = dwdPatientDataBizMapper.laboratoryCount(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
        return count;
    }

    @Override
    public List<Map<String, Object>> laboratoryDataList(DwdPatientComeQueryDTO params) {
        log.info("DwdPatientComeDataBizServiceImpl.laboratoryDataList:params:>>>>>> {} ", JSON.toJSONString(params));
        return dwdPatientDataBizMapper.laboratoryDataList(new QueryWrapper<DwdPatientComeQueryDTO>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "reports_time", params.getStartDate())
                .lt(null != params.getEndDate(), "reports_time", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "department_code_standard", params.getDeptIds())
        );
        // return dwdPatientDataBizMapper.laboratoryDataList(new QueryWrapper<DwdDoctorComeQueryDTO>()
        //         .eq(StrUtil.isNotBlank(params.getPatientId()), "b.main_person_id", params.getPatientId())
        //         .ge(null != params.getStartDate(), "a.reports_time", params.getStartDate())
        //         .lt(null != params.getEndDate(), "a.reports_time", params.getEndDate())
        //         .in(CollectionUtil.isNotEmpty(params.getDeptIds()), "a.department_code_standard", params.getDeptIds())
        // );
    }

}
