package com.xxh.cloud.healthy.crm.framework.modules.biz.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.healthy.crm.framework.modules.base.entity.PatientDoctorRelationInfo;
import com.xxh.cloud.healthy.crm.framework.modules.base.service.PatientDoctorRelationInfoService;
import com.xxh.cloud.healthy.crm.framework.modules.base.service.PatientDoctorRelationTargetInfoService;
import com.xxh.cloud.healthy.crm.framework.modules.biz.bean.dto.rel.PatientDoctorRelationSearchDTO;
import com.xxh.cloud.healthy.crm.framework.modules.biz.service.PatientDoctorRelationStatisticsBizService;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class PatientDoctorRelationStatisticsBizServiceImpl implements PatientDoctorRelationStatisticsBizService {

    @Autowired
    private PatientDoctorRelationInfoService patientDoctorRelationInfoService;

    @Override
    public List<String> relationSearch(PatientDoctorRelationSearchDTO params) {
        List<PatientDoctorRelationInfo> list = patientDoctorRelationInfoService.list(new QueryWrapper<PatientDoctorRelationInfo>()
                .eq("patient_id", params.getPatientId())
                .eq("doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotEmpty(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .in(CollUtil.isNotEmpty(params.getDiseaseIds()),"disease_id", params.getDiseaseIds())
        );
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>();
        }

        return list.stream().map(PatientDoctorRelationInfo::getId).collect(Collectors.toList());
    }
}
