package com.xxh.cloud.healthy.crm.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.crm.framework.modules.task.service.PatientDoctorRelationTargetTaskService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
public class PatientDoctorRelationTargetTask {

    @Autowired
    private PatientDoctorRelationTargetTaskService patientDoctorRelationTargetTaskService;

    /**
     * 更新个案目标状态
     */
    @XxlJob("updatePhaseTargetStatusTask")
    public void updatePhaseTargetStatusTask() throws Exception {
        log.info("更新个案目标状态开始 >>>>>> ");
        XxlJobHelper.log("更新个案目标状态开始 >>>>>> ");

        patientDoctorRelationTargetTaskService.updateTargetStatusTask();

        XxlJobHelper.log("更新个案目标状态结束 <<<<<< ");
        log.info("更新个案目标状态结束 <<<<<< ");
    }

    /**
     * 更新个案阶段状态
     */
    @XxlJob("updatePhaseStatusTask")
    public void updatePhaseStatusTask() throws Exception {
        log.info("更新个案阶段状态开始 >>>>>> ");
        XxlJobHelper.log("更新个案阶段状态开始 >>>>>> ");

        patientDoctorRelationTargetTaskService.updatePhaseStatusTask();

        XxlJobHelper.log("更新个案阶段状态结束 <<<<<< ");
        log.info("更新个案阶段状态结束 <<<<<< ");
    }

}
