package com.xxh.cloud.healthy.service.com.manager.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DwdPatientDataInitBizService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

@Log4j2
@RestController
@RequestMapping("/sys/healthy/patient/init")
@Api(tags = "dwd部门（科室）患者初始化数据")
public class DwdDataPatientInitController {
    
    @Autowired
    private DwdPatientDataInitBizService dwdPatientDataInitBizService;

    @PostMapping("/initPatientInfo")
    @ApiOperation(value = "从dwd初始化患者信息", response = Void.class)
    public Result<Void> initPatientInfo() {
        log.info("/sys/healthy/patient/init/patient 初始化同步患者信息开始 >>>>>>");
        dwdPatientDataInitBizService.initPatientInfo();
        log.info("/sys/healthy/patient/init/patient 初始化同步患者信息结束 <<<<<<");
        return new Result<Void>().success();
    }


    @PostMapping("/initDeptPatientInfo")
    @ApiOperation(value = "从dwd初始化患者部门绑定关系", response = Void.class)
    public Result<Void> initDeptPatientInfo() {
        log.info("/sys/healthy/patient/init/registerMid 初始化同步部门患者信息结束 >>>");
        dwdPatientDataInitBizService.initDeptPatientInfo();
        log.info("/sys/healthy/patient/init/registerMid 初始化同步部门患者信息结束 <<<<<<");
        return new Result<Void>().success();
    }

}
