package com.xxh.cloud.healthy.service.com.manager.controller;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import com.xxh.cloud.framework.common.user.LoginUser;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.*;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DoctorDwdPatientDataBizService;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.PatientEstimateDateBizService;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.PushServeDataQueryBizService;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.TaskPatientQueryBizService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@SaCheckLogin
@Log4j2
@RestController
@RequestMapping("/sys/healthy/doctor/patient")
@Api(tags = "患者疾病评估")
public class PatientEstimateController {
    
    @Autowired
    private PatientEstimateDateBizService patientEstimateDateBizService;

    @PostMapping("/queryDiagnosis")
    @ApiOperation(value = "查询关联报告", response = PatientDiagnosisDataVO.class)
    public Result<List<PatientDiagnosisDataVO>> queryDiagnosis(@RequestBody PatientEstimateDTO params) {
        log.info("/sys/healthy/doctor/patient/query >>> {}", JSON.toJSONString(params));
        if (StrUtil.isEmpty(params.getPatientId())) {
            throw new BusinessException("患者编号不能为空");
        }
        List<PatientDiagnosisDataVO> data = patientEstimateDateBizService.getPatientDiagnosis(params.getPatientId());
        return new Result<List<PatientDiagnosisDataVO>>().ok(data);
    }

    @PostMapping("/queryDiagnosis2")
    @ApiOperation(value = "查询关联报告(关联IDC表)", response = PatientDiagnosisDataVO.class)
    public Result<List<PatientDiagnosisDataVO>> queryDiagnosis2(@RequestBody PatientEstimateDTO params) {
        log.info("/sys/healthy/doctor/patient/query >>> {}", JSON.toJSONString(params));
        if (StrUtil.isEmpty(params.getPatientId())) {
            throw new BusinessException("患者编号不能为空");
        }
        List<PatientDiagnosisDataVO> data = patientEstimateDateBizService.getPatientDiagnosis2(params);
        return new Result<List<PatientDiagnosisDataVO>>().ok(data);
    }

}
