package com.xxh.cloud.healthy.service.com.manager.controller;

import cn.dev33.satoken.annotation.SaIgnore;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.UploadTempFileBizService;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardDiseaseInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

/**
 * 上传病种信息
 */
@Log4j2
@SaIgnore
@RestController
@RequestMapping("/sys/standard/disease/upload")
@Api(tags = "上传模板文件信息")
public class StandardDiseaseUploadController {

    @Autowired
    private UploadTempFileBizService uploadTempFileBizService;

    @PostMapping("/uploadTemp")
    @ApiOperation(value="上传病种信息")
    public Result<String> userInfoUpload(@RequestPart("files") MultipartFile files) {
        log.info("----------上传病种信息---------------");
        uploadTempFileBizService.diseaseTemp(files);
        return new Result<String>().ok("ok");
    }

}
