package com.xxh.cloud.healthy.service.com.manager.controller;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.healthy.data.framework.modules.third.DrugThirdHttpUtil;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugApiReq;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugApiResp;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugDetailApiReq;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugDetailApiResp;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.dev33.satoken.annotation.SaIgnore;

/**
 * 药品信息
 */
// @SaCheckLogin
@SaIgnore
@RestController
@RequestMapping("/sys/drug/third/drug")
public class ThirdDrugController {

    @PostMapping("/list")
    public Result<Object> list(@RequestBody DrugApiReq req) {
        DrugApiResp resp = DrugThirdHttpUtil.getDrugDataHttpApi(req);
        if (null == resp || null == resp.getResult()) {
            new Result<Object>().success();
        }
        return new Result<Object>().ok(resp.getResult());
    }

    @PostMapping("/detail")
    public Result<DrugDetailApiResp> detail(@RequestBody DrugDetailApiReq req) {
        DrugDetailApiResp resp = DrugThirdHttpUtil.getDrugDetailDataHttpApi(req.getCode());
        if (null == resp) {
            new Result<Object>().success();
        }
        return new Result<DrugDetailApiResp>().ok(resp);
    }

}
