package com.xxh.cloud.healthy.data.client.api;

import java.util.List;
import java.util.Map;

import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorDwdPatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDiagnosisReportClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientExamineReportClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientChangeClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientLaboratoryReportClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientRecipeMedicineClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DataDwdPatientQueryClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientDataClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientDiagnosisDataClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientExamineAndLaboratoryReportClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientLastDataQueryDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientRecipeMedicineClientDTO;

public interface DwdDataPatientClientService {

    DataDwsPatientDataLastDateBO getPatientDataLastDateInfo(String patientId);

    List<DataDwsPatientDataLastDateBO> listPatientDataLastDateInfo(List<String> patientIds);

    // 最新数据信息
    Map<String, DataDwsPatientDataLastDateBO> mapPatientDataLastDateInfo(List<String> patientIds);

    // 住院信息
    List<PatientInpatientRecordClientBO> listPatientInpatient(PatientDataClientDTO params);
    
    // 最新住院信息
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateInfo(PatientLastDataQueryDTO params);
    Map<String, PatientInpatientRecordClientBO> mapPatientInpatientLastDateInfo(PatientLastDataQueryDTO params);

    // 最新住院但未出院信息
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateAndNotOut(PatientLastDataQueryDTO params);
    Map<String, PatientInpatientRecordClientBO> mapPatientInpatientLastDateAndNotOut(PatientLastDataQueryDTO params);

    // 最新住院且出院信息
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateAndOut(PatientLastDataQueryDTO params);
    Map<String, PatientInpatientRecordClientBO> mapPatientInpatientLastDateAndOut(PatientLastDataQueryDTO params);

    // 最新出院信息
    List<PatientDischargeRecordClientBO> listPatientOutpatientLastDateInfo(PatientLastDataQueryDTO params);
    Map<String, PatientDischargeRecordClientBO> mapPatientOutpatientLastDateInfo(List<String> patientIds);
    // 最新有随访时间的出院信息
    List<PatientDischargeRecordClientBO> listPatientOutpatientLastDateWitiSFSJInfo(PatientLastDataQueryDTO params);

    // 最新就诊信息
    List<PatientVisitRecordClientBO> listPatientVisitLastDateInfo(PatientDataClientDTO params);
    Map<String, PatientVisitRecordClientBO> mapPatientVisitLastDateInfo(List<String> patientIds);


    // 查询检查报告
    List<PatientExamineReportClientBO> listExamineReportInfo(PatientExamineAndLaboratoryReportClientDTO params);

    // 查询检验报告
    List<PatientLaboratoryReportClientBO> listLaboratoryReportInfo(PatientExamineAndLaboratoryReportClientDTO params);

    // 查询医嘱用药
    List<PatientRecipeMedicineClientBO> listRecipeMedicineInfo(PatientRecipeMedicineClientDTO params);

    // 患者信息
    List<DoctorDwdPatientBO> queryPatientList(List<String> patientId);

    // 患者信息
    DoctorDwdPatientBO getOnePatient(String patientId);

    // 诊断
    List<PatientDiagnosisReportClientBO> listPatientDiagnosisReportInfo(PatientDiagnosisDataClientDTO params);


    // 患者就诊信息
    List<PatientVisitRecordClientBO> patientVisitList(DataDwdPatientQueryClientDTO params);

    // 患者住院信息
    List<PatientInpatientRecordClientBO> patientInHospitalList(DataDwdPatientQueryClientDTO params);
    
    // 患者住院变更信息
    List<PatientInpatientChangeClientBO> patientInHospitalChangeList(DataDwdPatientQueryClientDTO params);
    
}
