package com.xxh.cloud.healthy.data.client.api.bean.bo;

import java.util.Date;

// 诊断信息表
public class PatientDiagnosisReportClientBO {

    /**
     * 患者编号
     */
    private String patientId;

    /**
     * id
     */
    private String id;

    /**
     * 就诊记录号
     */
    private String visitId;

    /**
     * 住院号
     */
    private String inPatientNo;

    /**
     * 关联处方id
     */
    private String recipeId;

    /**
     * 患者姓名
     */
    private String patientName;

    /**
     * 下诊断科室名称(原始)
     */
    private String departmentNameRaw;

    /**
     * 下诊断科室名称(标准)
     */
    private String departmentNameStandard;

    /**
     * 下诊断科室编码(原始)
     */
    private String departmentCodeRaw;

    /**
     * 下诊断科室编码(标准)
     */
    private String departmentCodeStandard;

    /**
     * 下诊断医生编号
     */
    private String doctorCode;

    /**
     * 下诊断医生姓名
     */
    private String doctorName;

    /**
     * 诊断时间
     */
    private Date diagnosisTime;

    /**
     * 场景分类(原始)
     */
    private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
    private String sceneTypeStandard;

    /**
     * 诊断业务分类
     */
    private String relType;

    private String relId;

    /**
     * 备注
     */
    private String description;

    /**
     * 诊断编码(原始)
     */
    private String diagnosisCodeRaw;

    /**
     * 诊断编码(标准)
     */
    private String diagnosisCodeStandard;

    /**
     * 诊断内容(原始)
     */
    private String diagnosisNameRaw;

    /**
     * 诊断内容(标准)
     */
    private String diagnosisNameStandard;

    /**
     * 是否主诊断
     */
    private String mainFlag;

    /**
     * 是否确诊
     */
    private String confirmFlag;

    /**
     * 诊断排序
     */
    private Integer sortIdx;

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getVisitId() {
        return visitId;
    }

    public void setVisitId(String visitId) {
        this.visitId = visitId;
    }

    public String getInPatientNo() {
        return inPatientNo;
    }

    public void setInPatientNo(String inPatientNo) {
        this.inPatientNo = inPatientNo;
    }

    public String getRecipeId() {
        return recipeId;
    }

    public void setRecipeId(String recipeId) {
        this.recipeId = recipeId;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getDepartmentNameRaw() {
        return departmentNameRaw;
    }

    public void setDepartmentNameRaw(String departmentNameRaw) {
        this.departmentNameRaw = departmentNameRaw;
    }

    public String getDepartmentNameStandard() {
        return departmentNameStandard;
    }

    public void setDepartmentNameStandard(String departmentNameStandard) {
        this.departmentNameStandard = departmentNameStandard;
    }

    public String getDepartmentCodeRaw() {
        return departmentCodeRaw;
    }

    public void setDepartmentCodeRaw(String departmentCodeRaw) {
        this.departmentCodeRaw = departmentCodeRaw;
    }

    public String getDepartmentCodeStandard() {
        return departmentCodeStandard;
    }

    public void setDepartmentCodeStandard(String departmentCodeStandard) {
        this.departmentCodeStandard = departmentCodeStandard;
    }

    public String getDoctorCode() {
        return doctorCode;
    }

    public void setDoctorCode(String doctorCode) {
        this.doctorCode = doctorCode;
    }

    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public Date getDiagnosisTime() {
        return diagnosisTime;
    }

    public void setDiagnosisTime(Date diagnosisTime) {
        this.diagnosisTime = diagnosisTime;
    }

    public String getSceneTypeRaw() {
        return sceneTypeRaw;
    }

    public void setSceneTypeRaw(String sceneTypeRaw) {
        this.sceneTypeRaw = sceneTypeRaw;
    }

    public String getSceneTypeStandard() {
        return sceneTypeStandard;
    }

    public void setSceneTypeStandard(String sceneTypeStandard) {
        this.sceneTypeStandard = sceneTypeStandard;
    }

    public String getRelType() {
        return relType;
    }

    public void setRelType(String relType) {
        this.relType = relType;
    }

    public String getRelId() {
        return relId;
    }

    public void setRelId(String relId) {
        this.relId = relId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDiagnosisCodeRaw() {
        return diagnosisCodeRaw;
    }

    public void setDiagnosisCodeRaw(String diagnosisCodeRaw) {
        this.diagnosisCodeRaw = diagnosisCodeRaw;
    }

    public String getDiagnosisCodeStandard() {
        return diagnosisCodeStandard;
    }

    public void setDiagnosisCodeStandard(String diagnosisCodeStandard) {
        this.diagnosisCodeStandard = diagnosisCodeStandard;
    }

    public String getDiagnosisNameRaw() {
        return diagnosisNameRaw;
    }

    public void setDiagnosisNameRaw(String diagnosisNameRaw) {
        this.diagnosisNameRaw = diagnosisNameRaw;
    }

    public String getDiagnosisNameStandard() {
        return diagnosisNameStandard;
    }

    public void setDiagnosisNameStandard(String diagnosisNameStandard) {
        this.diagnosisNameStandard = diagnosisNameStandard;
    }

    public String getMainFlag() {
        return mainFlag;
    }

    public void setMainFlag(String mainFlag) {
        this.mainFlag = mainFlag;
    }

    public String getConfirmFlag() {
        return confirmFlag;
    }

    public void setConfirmFlag(String confirmFlag) {
        this.confirmFlag = confirmFlag;
    }

    public Integer getSortIdx() {
        return sortIdx;
    }

    public void setSortIdx(Integer sortIdx) {
        this.sortIdx = sortIdx;
    }

}
