package com.xxh.cloud.healthy.data.client.api.bean.bo;

import java.util.Date;

// 出院信息表
public class PatientDischargeRecordClientBO {

    /**
     * 患者编号
     */
    private String patientId;

    /**
     * id
     */
    private String id;

    /**
     * 就诊记录号
     */
    private String visitId;

    /**
     * 关联住院号
     */
    private String inPatientNo;

    /**
     * 患者姓名
     */
    private String patientName;

    /**
     * 医院编号
     */
    private String companyCode;

    /**
     * 医院名称
     */
    private String companyName;

    /**
     * 入住科室名称(原始)
     */
    private String admitDepartmentNameRaw;

    /**
     * 入住科室名称(标准)
     */
    private String admitDepartmentNameStandard;

    /**
     * 入住科室编码(原始)
     */
    private String admitDepartmentCodeRaw;

    /**
     * 入住科室编码(标准)
     */
    private String admitDepartmentCodeStandard;


    private String outDepartmentNameRaw;

    private String outDepartmentNameStandard;


    private String outDepartmentCodeRaw;

    private String outDepartmentCodeStandard;


    /**
     * 出院时间
     */
    private Date leaveDate;

    /**
     * icu天数
     */
    private Integer icuDays;

    /**
     * 出院方式(原始)
     */
    private String leaveWayRaw;

    /**
     * 出院方式名称(原始)
     */
    private String leaveWayNameRaw;

    /**
     * 出院方式(标准)
     */
    private String leaveWayStandard;

    /**
     * 病情危重天数
     */
    private Integer emergencyTreatmentDays;

    /**
     * 诊断内容(原始)
     */
    private String diagnosisRaw;

    /**
     * 诊断内容(标准)
     */
    private String diagnosisStandard;

    /**
     * 诊断编码(标准)
     */
    private String diagnosisCodeStandard;

    /**
     * 数据更新时间(原始)
     */
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    private String opDataUser;

    /**
     * 数据操作时间
     */
    private Date opDate;
    
    private PatientDischargeContentClientBO content;

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getVisitId() {
        return visitId;
    }

    public void setVisitId(String visitId) {
        this.visitId = visitId;
    }

    public String getInPatientNo() {
        return inPatientNo;
    }

    public void setInPatientNo(String inPatientNo) {
        this.inPatientNo = inPatientNo;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getCompanyCode() {
        return companyCode;
    }

    public void setCompanyCode(String companyCode) {
        this.companyCode = companyCode;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getAdmitDepartmentNameRaw() {
        return admitDepartmentNameRaw;
    }

    public void setAdmitDepartmentNameRaw(String admitDepartmentNameRaw) {
        this.admitDepartmentNameRaw = admitDepartmentNameRaw;
    }

    public String getAdmitDepartmentNameStandard() {
        return admitDepartmentNameStandard;
    }

    public void setAdmitDepartmentNameStandard(String admitDepartmentNameStandard) {
        this.admitDepartmentNameStandard = admitDepartmentNameStandard;
    }

    public String getAdmitDepartmentCodeRaw() {
        return admitDepartmentCodeRaw;
    }

    public void setAdmitDepartmentCodeRaw(String admitDepartmentCodeRaw) {
        this.admitDepartmentCodeRaw = admitDepartmentCodeRaw;
    }

    public String getAdmitDepartmentCodeStandard() {
        return admitDepartmentCodeStandard;
    }

    public void setAdmitDepartmentCodeStandard(String admitDepartmentCodeStandard) {
        this.admitDepartmentCodeStandard = admitDepartmentCodeStandard;
    }

    public String getOutDepartmentNameRaw() {
        return outDepartmentNameRaw;
    }

    public void setOutDepartmentNameRaw(String outDepartmentNameRaw) {
        this.outDepartmentNameRaw = outDepartmentNameRaw;
    }

    public String getOutDepartmentNameStandard() {
        return outDepartmentNameStandard;
    }

    public void setOutDepartmentNameStandard(String outDepartmentNameStandard) {
        this.outDepartmentNameStandard = outDepartmentNameStandard;
    }

    public String getOutDepartmentCodeRaw() {
        return outDepartmentCodeRaw;
    }

    public void setOutDepartmentCodeRaw(String outDepartmentCodeRaw) {
        this.outDepartmentCodeRaw = outDepartmentCodeRaw;
    }

    public String getOutDepartmentCodeStandard() {
        return outDepartmentCodeStandard;
    }

    public void setOutDepartmentCodeStandard(String outDepartmentCodeStandard) {
        this.outDepartmentCodeStandard = outDepartmentCodeStandard;
    }

    public Date getLeaveDate() {
        return leaveDate;
    }

    public void setLeaveDate(Date leaveDate) {
        this.leaveDate = leaveDate;
    }

    public Integer getIcuDays() {
        return icuDays;
    }

    public void setIcuDays(Integer icuDays) {
        this.icuDays = icuDays;
    }

    public String getLeaveWayRaw() {
        return leaveWayRaw;
    }

    public void setLeaveWayRaw(String leaveWayRaw) {
        this.leaveWayRaw = leaveWayRaw;
    }

    public String getLeaveWayNameRaw() {
        return leaveWayNameRaw;
    }

    public void setLeaveWayNameRaw(String leaveWayNameRaw) {
        this.leaveWayNameRaw = leaveWayNameRaw;
    }

    public String getLeaveWayStandard() {
        return leaveWayStandard;
    }

    public void setLeaveWayStandard(String leaveWayStandard) {
        this.leaveWayStandard = leaveWayStandard;
    }

    public Integer getEmergencyTreatmentDays() {
        return emergencyTreatmentDays;
    }

    public void setEmergencyTreatmentDays(Integer emergencyTreatmentDays) {
        this.emergencyTreatmentDays = emergencyTreatmentDays;
    }

    public String getDiagnosisRaw() {
        return diagnosisRaw;
    }

    public void setDiagnosisRaw(String diagnosisRaw) {
        this.diagnosisRaw = diagnosisRaw;
    }

    public String getDiagnosisStandard() {
        return diagnosisStandard;
    }

    public void setDiagnosisStandard(String diagnosisStandard) {
        this.diagnosisStandard = diagnosisStandard;
    }

    public String getDiagnosisCodeStandard() {
        return diagnosisCodeStandard;
    }

    public void setDiagnosisCodeStandard(String diagnosisCodeStandard) {
        this.diagnosisCodeStandard = diagnosisCodeStandard;
    }

    public Date getDataUpdateDate() {
        return dataUpdateDate;
    }

    public void setDataUpdateDate(Date dataUpdateDate) {
        this.dataUpdateDate = dataUpdateDate;
    }

    public String getOpDataUser() {
        return opDataUser;
    }

    public void setOpDataUser(String opDataUser) {
        this.opDataUser = opDataUser;
    }

    public Date getOpDate() {
        return opDate;
    }

    public void setOpDate(Date opDate) {
        this.opDate = opDate;
    }

    public PatientDischargeContentClientBO getContent() {
        return content;
    }

    public void setContent(PatientDischargeContentClientBO content) {
        this.content = content;
    }

}
