package com.xxh.cloud.healthy.data.client.api.bean.bo;

import java.util.Date;
import java.util.List;

// 医嘱用药数据表
public class PatientRecipeMedicineClientBO {

    /**
     * 患者编号
     */
    private String patientId;

    /**
     * ID
     */
    private String id;

    /**
     * 就诊记录号
     */
    private String visitId;

    /**
     * 关联处方id
     */
    private String recipeId;

    /**
     * 住院号
     */
    private String inPatientNo;

    /**
     * 患者姓名
     */
    private String patientName;

    /**
     * 申请科室名称(原始)
     */
    private String departmentNameRaw;

    /**
     * 申请科室名称(标准)
     */
    private String departmentNameStandard;

    /**
     * 申请科室编码(原始)
     */
    private String departmentCodeRaw;

    /**
     * 申请科室编码(标准)
     */
    private String departmentCodeStandard;

    /**
     * 付费时间
     */
    private Date payTime;

    /**
     * 处方时间
     */
    private Date recipeTime;

    /**
     * 场景分类(原始)
     */
    private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
    private String sceneTypeStandard;

    /**
     * 申请医生编号
     */
    private String doctorCode;

    /**
     * 申请医生姓名
     */
    private String doctorName;

    /**
     * 备注
     */
    private String description;

    /**
     * 诊断编码(标准)
     */
    private String diagnosisCodeStandard;

    /**
     * 诊断内容(原始)
     */
    private String diagnosisRaw;

    /**
     * 诊断内容(标准)
     */
    private String diagnosisStandard;

    /**
     * 医嘱用药明细
     */
    private List<PatientRecipeMedicineItemClientBO> patientRecipeMedicineItemList;

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getVisitId() {
        return visitId;
    }

    public void setVisitId(String visitId) {
        this.visitId = visitId;
    }

    public String getRecipeId() {
        return recipeId;
    }

    public void setRecipeId(String recipeId) {
        this.recipeId = recipeId;
    }

    public String getInPatientNo() {
        return inPatientNo;
    }

    public void setInPatientNo(String inPatientNo) {
        this.inPatientNo = inPatientNo;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getDepartmentNameRaw() {
        return departmentNameRaw;
    }

    public void setDepartmentNameRaw(String departmentNameRaw) {
        this.departmentNameRaw = departmentNameRaw;
    }

    public String getDepartmentNameStandard() {
        return departmentNameStandard;
    }

    public void setDepartmentNameStandard(String departmentNameStandard) {
        this.departmentNameStandard = departmentNameStandard;
    }

    public String getDepartmentCodeRaw() {
        return departmentCodeRaw;
    }

    public void setDepartmentCodeRaw(String departmentCodeRaw) {
        this.departmentCodeRaw = departmentCodeRaw;
    }

    public String getDepartmentCodeStandard() {
        return departmentCodeStandard;
    }

    public void setDepartmentCodeStandard(String departmentCodeStandard) {
        this.departmentCodeStandard = departmentCodeStandard;
    }

    public Date getPayTime() {
        return payTime;
    }

    public void setPayTime(Date payTime) {
        this.payTime = payTime;
    }

    public Date getRecipeTime() {
        return recipeTime;
    }

    public void setRecipeTime(Date recipeTime) {
        this.recipeTime = recipeTime;
    }

    public String getSceneTypeRaw() {
        return sceneTypeRaw;
    }

    public void setSceneTypeRaw(String sceneTypeRaw) {
        this.sceneTypeRaw = sceneTypeRaw;
    }

    public String getSceneTypeStandard() {
        return sceneTypeStandard;
    }

    public void setSceneTypeStandard(String sceneTypeStandard) {
        this.sceneTypeStandard = sceneTypeStandard;
    }

    public String getDoctorCode() {
        return doctorCode;
    }

    public void setDoctorCode(String doctorCode) {
        this.doctorCode = doctorCode;
    }

    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDiagnosisCodeStandard() {
        return diagnosisCodeStandard;
    }

    public void setDiagnosisCodeStandard(String diagnosisCodeStandard) {
        this.diagnosisCodeStandard = diagnosisCodeStandard;
    }

    public String getDiagnosisRaw() {
        return diagnosisRaw;
    }

    public void setDiagnosisRaw(String diagnosisRaw) {
        this.diagnosisRaw = diagnosisRaw;
    }

    public String getDiagnosisStandard() {
        return diagnosisStandard;
    }

    public void setDiagnosisStandard(String diagnosisStandard) {
        this.diagnosisStandard = diagnosisStandard;
    }

    public List<PatientRecipeMedicineItemClientBO> getPatientRecipeMedicineItemList() {
        return patientRecipeMedicineItemList;
    }

    public void setPatientRecipeMedicineItemList(
            List<PatientRecipeMedicineItemClientBO> patientRecipeMedicineItemList) {
        this.patientRecipeMedicineItemList = patientRecipeMedicineItemList;
    }

}
