package com.xxh.cloud.healthy.data.client.api.bean.bo;

import java.util.Date;

// 医嘱用药明细数据表
public class PatientRecipeMedicineItemClientBO {

  /**
   * 患者编号
   */
  private String patientId;

  /**
   * 医嘱用药数据ID
   */
  private String recipeMedicineId;

  /**
   * id
   */
  private String id;

  /**
   * 就诊记录号
   */
  private String visitId;

  /**
   * 住院号
   */
  private String inPatientNo;

  /**
   * 关联处方id
   */
  private String recipeId;

  /**
   * 申请科室名称(原始)
   */
  private String departmentNameRaw;

  /**
   * 申请科室编码(原始)
   */
  private String departmentCodeRaw;

  /**
   * 申请科室名称(标准)
   */
  private String departmentNameStandard;

  /**
   * 申请科室编码(标准)
   */
  private String departmentCodeStandard;

  /**
   * 付费时间
   */
  private Date payTime;

  /**
   * 处方时间
   */
  private Date recipeTime;

  /**
   * 药品名称(原始)
   */
  private String nameRaw;

  /**
   * 药品名称(标准)
   */
  private String nameStandard;

  /**
   * 药品编码(原始)
   */
  private String codeRaw;

  /**
   * 药品编码(标准)
   */
  private String codeStandard;

  /**
   * 药物分类(原始)
   */
  private String medicineClassRaw;

  /**
   * 药物分类(标准)
   */
  private String medicineClassStandard;

  /**
   * 药品规格
   */
  private String medicineSpec;

  /**
   * 单次用药单位(原始)
   */
  private String doseUnitRaw;

  /**
   * 单次用药单位(标准)
   */
  private String doseUnitStandard;

  /**
   * 单次用药数量
   */
  private String eachQuantity;

  /**
   * 用药天数
   */
  private String inspectResult;

  /**
   * 用药频次代码(原始)
   */
  private String frequencyCodeRaw;

  /**
   * 用药频次代码(标准)
   */
  private String frequencyCodeStandard;

  /**
   * 用药频次名称(原始)
   */
  private String frequencyNameRaw;

  /**
   * 用药频次名称(标准)
   */
  private String frequencyNameStandard;

  /**
   * 带药(发药)总数
   */
  private String medicationAmount;

  /**
   * 带药(发药)总数单位
   */
  private String medicationAmountUnit;

  /**
   * 包装规格
   */
  private String packingSpecNum;

  /**
   * 包装单位(原始)
   */
  private String packingSpecUnitRaw;

  /**
   * 包装单位(标准)
   */
  private String packingSpecUnitStandard;

  /**
   * 用法用量
   */
  private String usage;

  /**
   * 用药建议
   */
  private String usageAdvic;

  /**
   * 用药方式编码(原始)
   */
  private String usageCodeRaw;

  /**
   * 用药方式编码(标准)
   */
  private String usageCodeStandard;

  /**
   * 用药方式名称(原始)
   */
  private String usageContentRaw;

  /**
   * 用药方式名称(标准)
   */
  private String usageContentStandard;

  public String getPatientId() {
    return patientId;
  }

  public void setPatientId(String patientId) {
    this.patientId = patientId;
  }

  public String getRecipeMedicineId() {
    return recipeMedicineId;
  }

  public void setRecipeMedicineId(String recipeMedicineId) {
    this.recipeMedicineId = recipeMedicineId;
  }

  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public String getVisitId() {
    return visitId;
  }

  public void setVisitId(String visitId) {
    this.visitId = visitId;
  }

  public String getInPatientNo() {
    return inPatientNo;
  }

  public void setInPatientNo(String inPatientNo) {
    this.inPatientNo = inPatientNo;
  }

  public String getRecipeId() {
    return recipeId;
  }

  public void setRecipeId(String recipeId) {
    this.recipeId = recipeId;
  }

  public String getDepartmentNameRaw() {
    return departmentNameRaw;
  }

  public void setDepartmentNameRaw(String departmentNameRaw) {
    this.departmentNameRaw = departmentNameRaw;
  }

  public String getDepartmentCodeRaw() {
    return departmentCodeRaw;
  }

  public void setDepartmentCodeRaw(String departmentCodeRaw) {
    this.departmentCodeRaw = departmentCodeRaw;
  }

  public String getDepartmentNameStandard() {
    return departmentNameStandard;
  }

  public void setDepartmentNameStandard(String departmentNameStandard) {
    this.departmentNameStandard = departmentNameStandard;
  }

  public String getDepartmentCodeStandard() {
    return departmentCodeStandard;
  }

  public void setDepartmentCodeStandard(String departmentCodeStandard) {
    this.departmentCodeStandard = departmentCodeStandard;
  }

  public Date getPayTime() {
    return payTime;
  }

  public void setPayTime(Date payTime) {
    this.payTime = payTime;
  }

  public Date getRecipeTime() {
    return recipeTime;
  }

  public void setRecipeTime(Date recipeTime) {
    this.recipeTime = recipeTime;
  }

  public String getNameRaw() {
    return nameRaw;
  }

  public void setNameRaw(String nameRaw) {
    this.nameRaw = nameRaw;
  }

  public String getNameStandard() {
    return nameStandard;
  }

  public void setNameStandard(String nameStandard) {
    this.nameStandard = nameStandard;
  }

  public String getCodeRaw() {
    return codeRaw;
  }

  public void setCodeRaw(String codeRaw) {
    this.codeRaw = codeRaw;
  }

  public String getCodeStandard() {
    return codeStandard;
  }

  public void setCodeStandard(String codeStandard) {
    this.codeStandard = codeStandard;
  }

  public String getMedicineClassRaw() {
    return medicineClassRaw;
  }

  public void setMedicineClassRaw(String medicineClassRaw) {
    this.medicineClassRaw = medicineClassRaw;
  }

  public String getMedicineClassStandard() {
    return medicineClassStandard;
  }

  public void setMedicineClassStandard(String medicineClassStandard) {
    this.medicineClassStandard = medicineClassStandard;
  }

  public String getMedicineSpec() {
    return medicineSpec;
  }

  public void setMedicineSpec(String medicineSpec) {
    this.medicineSpec = medicineSpec;
  }

  public String getDoseUnitRaw() {
    return doseUnitRaw;
  }

  public void setDoseUnitRaw(String doseUnitRaw) {
    this.doseUnitRaw = doseUnitRaw;
  }

  public String getDoseUnitStandard() {
    return doseUnitStandard;
  }

  public void setDoseUnitStandard(String doseUnitStandard) {
    this.doseUnitStandard = doseUnitStandard;
  }

  public String getEachQuantity() {
    return eachQuantity;
  }

  public void setEachQuantity(String eachQuantity) {
    this.eachQuantity = eachQuantity;
  }

  public String getInspectResult() {
    return inspectResult;
  }

  public void setInspectResult(String inspectResult) {
    this.inspectResult = inspectResult;
  }

  public String getFrequencyCodeRaw() {
    return frequencyCodeRaw;
  }

  public void setFrequencyCodeRaw(String frequencyCodeRaw) {
    this.frequencyCodeRaw = frequencyCodeRaw;
  }

  public String getFrequencyCodeStandard() {
    return frequencyCodeStandard;
  }

  public void setFrequencyCodeStandard(String frequencyCodeStandard) {
    this.frequencyCodeStandard = frequencyCodeStandard;
  }

  public String getFrequencyNameRaw() {
    return frequencyNameRaw;
  }

  public void setFrequencyNameRaw(String frequencyNameRaw) {
    this.frequencyNameRaw = frequencyNameRaw;
  }

  public String getFrequencyNameStandard() {
    return frequencyNameStandard;
  }

  public void setFrequencyNameStandard(String frequencyNameStandard) {
    this.frequencyNameStandard = frequencyNameStandard;
  }

  public String getMedicationAmount() {
    return medicationAmount;
  }

  public void setMedicationAmount(String medicationAmount) {
    this.medicationAmount = medicationAmount;
  }

  public String getPackingSpecNum() {
    return packingSpecNum;
  }

  public void setPackingSpecNum(String packingSpecNum) {
    this.packingSpecNum = packingSpecNum;
  }

  public String getPackingSpecUnitRaw() {
    return packingSpecUnitRaw;
  }

  public void setPackingSpecUnitRaw(String packingSpecUnitRaw) {
    this.packingSpecUnitRaw = packingSpecUnitRaw;
  }

  public String getPackingSpecUnitStandard() {
    return packingSpecUnitStandard;
  }

  public void setPackingSpecUnitStandard(String packingSpecUnitStandard) {
    this.packingSpecUnitStandard = packingSpecUnitStandard;
  }

  public String getUsage() {
    return usage;
  }

  public void setUsage(String usage) {
    this.usage = usage;
  }

  public String getUsageAdvic() {
    return usageAdvic;
  }

  public void setUsageAdvic(String usageAdvic) {
    this.usageAdvic = usageAdvic;
  }

  public String getUsageCodeRaw() {
    return usageCodeRaw;
  }

  public void setUsageCodeRaw(String usageCodeRaw) {
    this.usageCodeRaw = usageCodeRaw;
  }

  public String getUsageCodeStandard() {
    return usageCodeStandard;
  }

  public void setUsageCodeStandard(String usageCodeStandard) {
    this.usageCodeStandard = usageCodeStandard;
  }

  public String getUsageContentRaw() {
    return usageContentRaw;
  }

  public void setUsageContentRaw(String usageContentRaw) {
    this.usageContentRaw = usageContentRaw;
  }

  public String getUsageContentStandard() {
    return usageContentStandard;
  }

  public void setUsageContentStandard(String usageContentStandard) {
    this.usageContentStandard = usageContentStandard;
  }

  public String getMedicationAmountUnit() {
    return medicationAmountUnit;
  }

  public void setMedicationAmountUnit(String medicationAmountUnit) {
    this.medicationAmountUnit = medicationAmountUnit;
  }

}
