package com.xxh.cloud.healthy.data.client.api.constant;

/**
 * 部门与患者关系类型
 * 1.挂号后永久绑定不能解绑
 * 2.部门标签与患者标签有重叠就进行绑定，通过移除标签可以解绑，可以通过挂号升级为挂号类型
 */
public enum DeptPatientTypeEnum {

    Register ("register","挂号"),
    Label("label","标签"),
    ;

    private String code;
    private String msg;
    private DeptPatientTypeEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }
    public String getCode() {
        return code;
    }
    public String getMsg() {
        return msg;
    }

}
