package com.xxh.cloud.healthy.data.client.api.constant;

/**
 * 患者日数据统计维度枚举
 * */
public enum PatientDataDimensionTypeEnum {

    //诊前
    LSD_Pre_Not_Visit("pre_notVisit","发现潜在患者/未就诊"),
    LSD_Pre_Visited("pre_visited","发现潜在患者/已就诊"),
    LSD_Pre_Confirmed("pre_confirmed","发现潜在患者/已确诊"),
    //诊中
    LSD_During_Register("during_register","挂号流失患者"),
    LSD_During_InHospital("during_inHospital","住院流失患者"),
    LSD_During_Operation("during_operation","手术流失患者"),
    LSD_During_Lost("during_lost", "流失比率"),
    //诊后
    LSD_After_Service("after_service", "疾病管理服务次数"),
    LSD_After_Accept("after_accept", "服务接受率"),
    LSD_After_Consultation("after_consultation", "复诊率"),
    LSD_After_Lost ("after_lost","失访患者人数"),


    // 其他
    Not_Following_Push_Fail("not_follow_push_fail", "未关注推送失败"),
    Push_Fail("push_fail", "推送失败"),

    Potential_Patient("potential_patient", "潜在患者"),
    Total_Patient("total_patient", "患者总数量"),

    ;

    private String code;
    private String msg;
    private PatientDataDimensionTypeEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }
    public String getCode() {
        return code;
    }
    public String getMsg() {
        return msg;
    }

}

