package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 运营助理统计标签下患者数据表
 * </p>
 */
@Data
// @EqualsAndHashCode(callSuper = true)
@TableName("hd_doctor_label_patient_data_info")
public class DoctorLabelPatientDataInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 日期(天)
     */
     @ApiModelProperty(value = "统计日期(天)")
      private String bizDay;

    /**
     * 运营助理id
     */
     @ApiModelProperty(value = "运营助理id")
      private String doctorId;

    /**
     * 标签id
     */
     @ApiModelProperty(value = "标签id")
      private String labelId;

    /**
     * 患者标签
     */
     @ApiModelProperty(value = "患者标签")
      private String patientLabelIds;

    /**
     * 排除数据
     */
     @ApiModelProperty(value = "排除数据")
      private String excludePatientIds;

    /**
     * 纳入数据
     */
     @ApiModelProperty(value = "纳入数据")
      private String joinPatientIds;

    /**
     * 会诊数据
     */
     @ApiModelProperty(value = "会诊数据")
      private String consultationIds;

    /**
     * 随访数据
     */
     @ApiModelProperty(value = "随访数据")
      private String followUpIds;

    /**
     * 场景[门诊、住院、出院]
     */
     @ApiModelProperty(value = "场景[门诊、住院、出院]")
      private String scene;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
