package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表(运营助理对患者进行排除/加入/个案管理/随访操作)
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("hd_doctor_manage_patient_info")
public class DoctorManagePatientInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 患者标签id
     */
     @ApiModelProperty(value = "患者标签id")
      private String labelId;

    /**
     * 标签时间
     */
     @ApiModelProperty(value = "标签时间")
      private Date labelDate;

    /**
     * 操作场景
     */
     @ApiModelProperty(value = "操作场景")
      private String opScene;

    /**
     * 操作类型（排除/纳入）
     */
     @ApiModelProperty(value = "操作类型")
      private String opType;

    /**
     * 操作子类型
     */
     @ApiModelProperty(value = "操作子类型")
      private String opSubType;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容")
      private String opContent;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
