package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 药品信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_drug_info")
public class DrugInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 药品编号
     */
     @ApiModelProperty(value = "药品编号")
      private String drugCode;

    /**
     * 药品名称
     */
     @ApiModelProperty(value = "药品名称")
      private String drugName;

    /**
     * 常用名称
     */
     @ApiModelProperty(value = "常用名称")
      private String regularName;

    /**
     * 正式名称
     */
     @ApiModelProperty(value = "正式名称")
      private String formalName;

    /**
     * 批准信息
     */
     @ApiModelProperty(value = "批准信息")
      private String approveInfo;

    /**
     * 警告
     */
     @ApiModelProperty(value = "警告")
      private String caution;

    /**
     * 有效状态
     */
     @ApiModelProperty(value = "有效状态")
      private String validState;

    /**
     * 同步标记
     */
     @ApiModelProperty(value = "同步标记")
      private String syncFlag;

    /**
     * 同步更新时间
     */
     @ApiModelProperty(value = "同步更新时间")
      private Date syncDate;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
