package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 药品说明信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_drug_item_info")
public class DrugItemInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 药品表id
     */
     @ApiModelProperty(value = "药品表id")
      private String drugId;

    /**
     * 药品编号
     */
     @ApiModelProperty(value = "药品编号")
      private String drugCode;

    /**
     * 序号
     */
     @ApiModelProperty(value = "序号")
      private Integer idx;

    /**
     * 说明编号
     */
     @ApiModelProperty(value = "说明编号")
      private String section;

    /**
     * 说明名称
     */
     @ApiModelProperty(value = "说明名称")
      private String name;

    /**
     * 说明标题
     */
     @ApiModelProperty(value = "说明标题")
      private String title;

    /**
     * 说明内容
     */
     @ApiModelProperty(value = "说明内容")
      private String content;

    /**
     * 同步更新时间
     */
     @ApiModelProperty(value = "同步更新时间")
      private Date syncDate;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
