package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者日统计数据表
 * </p>
 *
 * @author anros
 * @since 2023-09-27
 */
@Data
//@EqualsAndHashCode(callSuper = true)
@TableName("hd_patient_data_one_day_info")
public class PatientDataOneDayInfo{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 日期(天)
     */
     @ApiModelProperty(value = "日期(天)")
      private String bizDay;

    /**
     * 部门ID
     */
     @ApiModelProperty(value = "部门ID")
      private String deptId;

    /**
     * 标签维度分类
     */
     @ApiModelProperty(value = "标签维度分类")
      private String dataDimension;

    /**
     * 累计人数
     */
     @ApiModelProperty(value = "累计人数")
      private Integer num;

    /**
     * 昨日新增人数
     */
     @ApiModelProperty(value = "昨日新增人数")
      private Integer addNum;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
