package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者流失表
 * </p>
 */
@Data
// @EqualsAndHashCode(callSuper = true)
@TableName("hd_patient_loss_info")
public class PatientLossInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 标准科室编号
     */
     @ApiModelProperty(value = "标准科室编号")
      private String deptId;

    /**
     * 原始科室编号
     */
     @ApiModelProperty(value = "原始科室编号")
      private String sourceDeptId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 流失类型
     */
     @ApiModelProperty(value = "流失类型[住院/挂号/就诊]")
      private String type;

    /**
     * 流失来源id
     */
     @ApiModelProperty(value = "流失来源id[住院申请id/挂号id/就诊id]")
      private String dataSourceId;

    /**
     * 流失来源时间
     */
     @ApiModelProperty(value = "流失来源时间")
      private Date dataSourceDate;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 备注时间
     */
     @ApiModelProperty(value = "备注时间")
      private Date remarkDate;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 数据更新时间
     */
     @ApiModelProperty(value = "数据更新时间")
      private Date dataUpdateDate;

}
