package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者待流失标记日志表
 * </p>
 *
 * @author wing
 * @since 2023-10-31
 */
@Data
//@EqualsAndHashCode(callSuper = true)
@TableName("hd_patient_lost_label_log")
public class PatientLostLabelLog{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 科室(部门)ID
     */
     @ApiModelProperty(value = "科室(部门)ID")
      private String deptId;

    /**
     * 科室(部门)名称
     */
     @ApiModelProperty(value = "科室(部门)名称")
      private String deptName;

    /**
     * 待流失类型
     */
     @ApiModelProperty(value = "待流失类型[LabelStatDimensionTypeEnum]")
      private String lostType;

    /**
     * 挂号/住院申请/手术申请等数据时间
     */
     @ApiModelProperty(value = "挂号/住院申请/手术申请等数据时间")
      private Date dataDt;


}
