package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者推送服务日统计数据表
 * </p>
 *
 * @author wing
 * @since 2023-10-15
 */
@Data
//@EqualsAndHashCode(callSuper = true)
@TableName("hd_patient_push_service_data_one_day_info")
public class PatientPushServeDataOneDayInfo{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 日期(天)
     */
     @ApiModelProperty(value = "日期(天)")
      private String bizDay;

    /**
     * 部门ID
     */
     @ApiModelProperty(value = "部门ID")
      private String deptId;

    /**
     * 一级分类[诊前、诊中、诊后]
     */
     @ApiModelProperty(value = "一级分类[诊前、诊中、诊后]")
      private String oneType;

    /**
     * 二级分类[服务分类]
     */
     @ApiModelProperty(value = "二级分类[服务分类]")
      private String twoType;

    /**
     * 病种id列表
     */
     @ApiModelProperty(value = "病种id列表")
      private String diseaseIds;

    /**
     * 推送服务id
     */
     @ApiModelProperty(value = "推送服务id")
      private String pushServeId;

    /**
     * 服务次数
     */
     @ApiModelProperty(value = "服务次数")
      private Integer serveNum;

    /**
     * 点击行动埋点次数
     */
     @ApiModelProperty(value = "点击行动埋点次数")
      private Integer clickNum;

    /**
     * 阅读次数
     */
     @ApiModelProperty(value = "阅读次数")
      private Integer readNum;

    /**
     * 阅读人数
     */
     @ApiModelProperty(value = "阅读人数")
      private Integer readUserNum;

    /**
     * 服务后就诊人数
     */
     @ApiModelProperty(value = "服务后就诊人数")
      private Integer comeNum;

    /**
     * 总阅读时间
     */
     @ApiModelProperty(value = "总阅读时间")
      private Integer readTotalTime;

    /**
     * 未关注人数发送失败
     */
     @ApiModelProperty(value = "未关注人数发送失败")
      private Integer notFollowingPushFailNum;

    /**
     * 发送失败次数
     */
     @ApiModelProperty(value = "发送失败次数")
      private Integer pushFailNum;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
