package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 检验检查项目标准表
 * </p>
 *
 * @author limengjie
 * @since 2025-01-16
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("s_md_standard_exam_lab_item")
public class StandardExamLabItem extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 项目代码
     */
     @ApiModelProperty(value = "项目代码")
    @TableId(value = "item_code", type = IdType.INPUT)
      private String itemCode;

    /**
     * 项目名称
     */
     @ApiModelProperty(value = "项目名称")
      private String itemName;

    /**
     * 单位
     */
     @ApiModelProperty(value = "单位")
      private String unit;

    /**
     * 规格
     */
     @ApiModelProperty(value = "规格")
      private String specs;

    /**
     * 执行科室
     */
     @ApiModelProperty(value = "执行科室")
      private String excCode;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String mark;

    /**
     * 项目明细时间
     */
     @ApiModelProperty(value = "项目明细时间")
      private String updateTime;

    /**
     * 疾病分类(开立检验项目时使用)
     */
     @ApiModelProperty(value = "疾病分类(开立检验项目时使用)")
      private String diseaseClass;

    /**
     * 适用范围 0 全部  1 门诊 2住院
     */
     @ApiModelProperty(value = "适用范围 0 全部  1 门诊 2住院")
      private String areaType;

    /**
     * 0明细 1组套
     */
     @ApiModelProperty(value = "0明细 1组套")
      private String unitFlag;

    /**
     * 是否需要预约 1 需要 0 不需要
     */
     @ApiModelProperty(value = "是否需要预约 1 需要 0 不需要")
      private String needbespeak;

    /**
     * 病史及检查(开立检查申请单时使用)
     */
     @ApiModelProperty(value = "病史及检查(开立检查申请单时使用)")
      private String illnessHistory;

    /**
     * 检查要求(开立检查申请单时使用)
     */
     @ApiModelProperty(value = "检查要求(开立检查申请单时使用)")
      private String requirement;

    /**
     * 注意事项(开立检查申请单时使用)
     */
     @ApiModelProperty(value = "注意事项(开立检查申请单时使用)")
      private String precautions;

    /**
     * 检查申请单名称
     */
     @ApiModelProperty(value = "检查申请单名称")
      private String examApplyName;

    /**
     * 组套数量
     */
     @ApiModelProperty(value = "组套数量")
      private String qty;

    /**
     * 数据状态
     */
     @ApiModelProperty(value = "数据状态")
      private String rowsStatus;

}
