package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 科室患者(挂号)关系表
 * </p>
 *
 * @author anros
 * @since 2023-10-09
 */
@Data
//@EqualsAndHashCode(callSuper = true)
@TableName("hd_task_dept_patient_relation_info")
public class TaskDeptPatientRelationInfo{

    private static final long serialVersionUID = 1L;

    /**
     * 科室(部门)ID
     */
     @ApiModelProperty(value = "科室(部门)ID")
//    @TableId(value = "dept_id", type = IdType.INPUT)
      private String deptId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 挂号时间
     */
     @ApiModelProperty(value = "挂号时间")
      private Date registerDt;

    /**
     * 绑定类型
     */
     @ApiModelProperty(value = "绑定类型[DeptPatientTypeEnum]")
      private String type;


}
