package com.xxh.cloud.healthy.data.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("hd_task_patient_info")
public class TaskPatientInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 身份证号
     */
     @ApiModelProperty(value = "身份证号")
      private String idCardNo;

    /**
     * 性别
     */
     @ApiModelProperty(value = "性别")
      private String patientGender;

    /**
     * 标准性别
     */
     @ApiModelProperty(value = "标准性别")
      private String patientGenderStandard;

    /**
     * 生日
     */
     @ApiModelProperty(value = "生日")
      private String birthday;

    /**
     * 电话号码
     */
     @ApiModelProperty(value = "电话号码")
      private String phone;

    /**
     * 备注信息
     */
     @ApiModelProperty(value = "备注信息")
      private String remark;

    /**
     * 数据更新时间
     */
     @ApiModelProperty(value = "数据更新时间")
      private Date dataUpdateDate;

    /**
     * 主患者编号
     */
     @ApiModelProperty(value = "主患者编号")
      private String mainPersonId;

    /**
     * 工作电话号码
     */
     @ApiModelProperty(value = "工作电话号码")
      private String workPhone;

    /**
     * 联系电话号码
     */
     @ApiModelProperty(value = "联系电话号码")
      private String linkPhone;

    /**
     * 家庭电话号码
     */
     @ApiModelProperty(value = "家庭电话号码")
      private String homePhone;

}
