package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import javax.validation.constraints.NotEmpty;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DataDwdLaboratoryQueryDTO {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号", required = true)
    @NotEmpty(message = "患者编号[patientId]不能为空")
    private String patientId;

    /**
     * 检验项目编码(原始)
     */
    @ApiModelProperty(value = "检验项目编码(原始)")
    private String projectIdRaw;

    /**
     * 检验项目编码列表(原始)
     */
    @ApiModelProperty(value = "检验项目编码列表(原始)")
    private List<String> projectIdRaws;

    /**
     * 检验项目编码(标准)
     */
    @ApiModelProperty(value = "检验项目编码(标准)")
    private String projectIdStandard;

    /**
     * 检验项目编码列表(标准)
     */
    @ApiModelProperty(value = "检验项目编码列表(标准)")
    private List<String> projectIdStandards;


    @ApiModelProperty(value = "查询开始时间")
    private Date startDate;

    @ApiModelProperty(value = "查询结束时间")
    private Date endDate;

}
