package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;
import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生关注患者表
 * </p>
 */
@Getter
@Setter
public class DoctorFollowPatientQueryDTO extends BasePageDTO {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

      @ApiModelProperty(value = "患者编号列表")
      private List<String> patientIds;

      @ApiModelProperty(value = "患者名称")
      private String patientName;
  
    /**
     * 关注状态
     */
     @ApiModelProperty(value = "关注状态")
      private String status;

    /**
     * 数据更新类型
     */
     @ApiModelProperty(value = "数据更新类型")
      private String dataUpdateType;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    /**
     * 结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date endDate;

}
