package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表
 * </p>
 */
@Getter
@Setter
public class DoctorManagePatientAddDTO {

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号", required = true)
     @NotEmpty(message = "患者编号不能为空")
      private String patientId;

    /**
     * 患者标签id
     */
     @ApiModelProperty(value = "患者标签id", required = true)
     @NotEmpty(message = "患者标签id不能为空")
      private String labelId;

    /**
     * 操作场景
     */
     @ApiModelProperty(value = "操作场景", required = true)
     @NotEmpty(message = "操作场景不能为空")
      private String opScene;

    /**
     * 操作类型（排除/纳入/加入个案）
     */
     @ApiModelProperty(value = "操作类型", required = true)
     @NotEmpty(message = "操作类型不能为空")
      private String opType;

    /**
     * 操作子类型（由字典定义）
     */
     @ApiModelProperty(value = "操作子类型")
      private String opSubType;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容")
      private String opContent;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

}
