package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表
 * </p>
 */
@Getter
@Setter
public class DoctorManagePatientDetailDTO {

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号", required = true)
     @NotEmpty(message = "患者编号不能为空")
      private String patientId;

    /**
     * 患者标签id
     */
     @ApiModelProperty(value = "患者标签id", required = true)
     @NotEmpty(message = "患者标签id不能为空")
      private String labelId;

}
