package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表
 * </p>
 */
@Getter
@Setter
public class DoctorManagePatientQueryDTO extends BasePageDTO {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

      @ApiModelProperty(value = "id列表")
      private List<String> ids;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

     @ApiModelProperty(value = "医生ID列表")
      private List<String> doctorIds;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

     @ApiModelProperty(value = "患者编号列表")
      private List<String> patientIds;
  
    /**
     * 患者标签id
     */
     @ApiModelProperty(value = "患者标签id")
      private String labelId;

    /**
     * 操作场景
     */
     @ApiModelProperty(value = "操作场景")
      private String opScene;

    /**
     * 操作类型（排除/纳入/加入个案）
     */
     @ApiModelProperty(value = "操作类型")
      private String opType;

    /**
     * 操作子类型（由字典定义）
     */
     @ApiModelProperty(value = "操作子类型")
      private String opSubType;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    /**
     * 结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date endDate;

}
