package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import javax.validation.constraints.NotEmpty;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表
 * </p>
 */
@Getter
@Setter
public class DoctorManagePatientUpdateDTO {

    /**
     * id
     */
     @ApiModelProperty(value = "id", required = true)
     @NotEmpty(message = "id不能为空")
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 操作场景
     */
     @ApiModelProperty(value = "操作场景")
      private String opScene;

    /**
     * 操作类型（排除/纳入/加入个案）
     */
     @ApiModelProperty(value = "操作类型")
      private String opType;

    /**
     * 操作子类型（由字典定义）
     */
     @ApiModelProperty(value = "操作子类型")
      private String opSubType;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容")
      private String opContent;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

}
