package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class DoctorPatientLabelQueryDTO extends BasePageDTO {
    
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "患者编号列表")
    private List<String> patientIds;

    @ApiModelProperty(value = "标签id")
    private String labelId;

    @ApiModelProperty(value = "标签id列表")
    private List<String> labelIds;

    @ApiModelProperty(value = "操作动作分类")
    private String opType;

    @ApiModelProperty(value = "是否过期")
    private Boolean isExpire;

    // zs202311131408
    @ApiModelProperty(value = "业务分类")
    private String bizType;
    @ApiModelProperty(value = "业务分类列表")
    private List<String> bizTypes;
    @ApiModelProperty(value = "统计维度分类")
    private String statDimensionType;
    @ApiModelProperty(value = "统计维度分类列表")
    private List<String> statDimensionTypes;
    @ApiModelProperty(value = "病种编号")
    private String diseaseId;
    @ApiModelProperty(value = "病种ID列表")
    private List<String> diseaseIds;
    @ApiModelProperty(value = "病种查询模式[or、and][ModeEnum.QueryModeEnum]")
    private String diseaseQueryMode;


    @ApiModelProperty(value = "查询参数列表")
    private List<String> queryParams;

    
    @ApiModelProperty(value = "查询开始时间")
    private Date startDate;

    @ApiModelProperty(value = "查询结束时间")
    private Date endDate;


    @ApiModelProperty(value = "患者名称")
    private String patientName;

    @ApiModelProperty(value = "医生id")
    private String doctorId;

    @ApiModelProperty(value = "患者数据时间")
    private Date dataDt;


    @ApiModelProperty(value = "二级业务分类")
    private String bizTwoType;
    @ApiModelProperty(value = "二级业务分类列表")
    private List<String> bizTwoTypes;

    @ApiModelProperty(value = "三级业务分类")
    private String bizThreeType;
    @ApiModelProperty(value = "三级业务分类列表")
    private List<String> bizThreeTypes;

    @ApiModelProperty(value = "标签名称")
    private String labelName;

    // 潜在患者类型
    @ApiModelProperty(value = "潜在患者类型")
    private String potentialType;

    /**
     * 是否患者画像
     */
    @ApiModelProperty(value = "是否患者画像")
    private String isPortrait;

    // 是否潜在患者类型
    @ApiModelProperty(value = "是否潜在患者类型")
    private String isPotentialType;

    // 是否是管理员,管理员查看所有病种信息
    private String isAdmin;

    @ApiModelProperty(value = "是否管理员标签")
    private String adminLabel;
}
