package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.MD5;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientDiseaseStatisticQueryDTO {
    
    @ApiModelProperty(value = "部门ID")
    @NotEmpty(message = "部门ID[deptId]不能为空")
    private String deptId;
    
    @ApiModelProperty(value = "病种id")
    @NotEmpty(message = "病种id[diseaseId]不能为空")
    private String diseaseId;
    
    @ApiModelProperty(value = "开始时间")
    private String startDate;
    
    @ApiModelProperty(value = "结束时间")
    private String endDate;
    
    public String md5() {
        StringBuilder sb = new StringBuilder();
        if (StrUtil.isNotBlank(deptId)) {
            sb.append(deptId);
        }
        if (StrUtil.isNotBlank(diseaseId)) {
            sb.append(diseaseId);
        }
        if (StrUtil.isNotBlank(startDate)) {
            sb.append(startDate);
        }
        
        if (StrUtil.isNotBlank(endDate)) {
            sb.append(endDate);
        }

        String str = StrUtil.isBlank(sb.toString()) ? "-" : sb.toString();
        
        return MD5.create().digestHex(str);
    }

}
