package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者流失表
 * </p>
 */
@Getter
@Setter
public class PatientLossAddDTO {

    /**
     * 标准科室编号
     */
     @ApiModelProperty(value = "标准科室编号")
      private String deptId;

    /**
     * 原始科室编号
     */
     @ApiModelProperty(value = "原始科室编号")
      private String sourceDeptId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 流失类型
     */
     @ApiModelProperty(value = "流失类型[住院/挂号/就诊]")
      private String type;

    /**
     * 流失来源id
     */
     @ApiModelProperty(value = "流失来源id[住院申请id/挂号id/就诊id]")
      private String dataSourceId;

    /**
     * 流失来源时间
     */
     @ApiModelProperty(value = "流失来源时间")
      private Date dataSourceDate;

}
