package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientManageDetailQueryDTO extends BasePageDTO {

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID", required = true)
     @NotEmpty(message = "医生ID不能为空")
      private String doctorId;

    /**
     * 开始时间
     */
     @ApiModelProperty(value = "开始时间", required = true)
     @NotNull(message = "开始时间不能为空")
      private Date startDate;

    /**
     * 结束时间
     */
     @ApiModelProperty(value = "结束时间", required = true)
     @NotNull(message = "结束时间不能为空")
      private Date endDate;

}
