package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientPushServeQueryDTO extends BasePageDTO {

    @ApiModelProperty(value = "部门id")
    private String deptId;

    @ApiModelProperty(value = "推送服务id")
    @NotEmpty(message = "推送服务id[pushServeId]不能为空")
    private String pushServeId;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "用户姓名")
    private String userName;

    @ApiModelProperty(value = "身份证号")
    private String idCardNo;

    @ApiModelProperty(value = "性别")
    private String patientGender;

    @ApiModelProperty(value = "标准性别")
    private String patientGenderStandard;

    @ApiModelProperty(value = "电话号码")
    private String phone;

    @ApiModelProperty(value = "开始年龄")
    private Integer startAge;

    @ApiModelProperty(value = "结束年龄")
    private Integer endAge;

}
