package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.MD5;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PushServiceStatisticGetDTO {

    @ApiModelProperty(value = "推送服务id")
    @NotEmpty(message = "推送服务id[pushServiceId]不能为空")
    private String pushServiceId;

    @ApiModelProperty(value = "部门ID")
    private String deptId;

    @ApiModelProperty(value = "开始时间")
    private String startDate;

    @ApiModelProperty(value = "结束时间")
    private String endDate;

    public String md5() {
        StringBuilder sb = new StringBuilder();
        if (StrUtil.isNotBlank(pushServiceId)) {
            sb.append(pushServiceId);
        }
        if (StrUtil.isNotBlank(deptId)) {
            sb.append(deptId);
        }
        if (StrUtil.isNotBlank(startDate)) {
            sb.append(startDate);
        }
        
        if (StrUtil.isNotBlank(endDate)) {
            sb.append(endDate);
        }

        String str = StrUtil.isBlank(sb.toString()) ? "-" : sb.toString();

        return MD5.create().digestHex(str);
    }

}
