package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;
import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.digest.MD5;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PushServiceStatisticQueryDTO {

    @ApiModelProperty(value = "一级分类[诊前、诊中、诊后]")
    private String oneType;

    @ApiModelProperty(value = "二级分类")
    private String twoType;

    @ApiModelProperty(value = "推送服务id")
    private String pushServeId;

    @ApiModelProperty(value = "部门ID")
    private String deptId;

    @ApiModelProperty(value = "病种id")
    private String diseaseId;

    @ApiModelProperty(value = "开始时间")
    private String startDate;

    @ApiModelProperty(value = "结束时间")
    private String endDate;

    public String md5() {
        StringBuilder sb = new StringBuilder();
        if (StrUtil.isNotBlank(oneType)) {
            sb.append(oneType);
        }
        if (StrUtil.isNotBlank(twoType)) {
            sb.append(twoType);
        }
        if (StrUtil.isNotBlank(pushServeId)) {
            sb.append(pushServeId);
        }
        if (StrUtil.isNotBlank(deptId)) {
            sb.append(deptId);
        }
        if (StrUtil.isNotBlank(diseaseId)) {
            sb.append(diseaseId);
        }
        if (StrUtil.isNotBlank(startDate)) {
            sb.append(startDate);
        }
        
        if (StrUtil.isNotBlank(endDate)) {
            sb.append(endDate);
        }

        String str = StrUtil.isBlank(sb.toString()) ? "-" : sb.toString();

        return MD5.create().digestHex(str);
    }

}
