package com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto;

import java.util.Date;

import javax.validation.constraints.NotEmpty;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class TaskPatientAddDTO extends BaseEntity {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号", required = true)
    @NotEmpty(message = "患者编号[patientId]不能为空")
    private String patientId;

    /**
     * 主患者编号
     */
    @ApiModelProperty(value = "主患者编号")
    private String mainPersonId;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idCardNo;

    /**
     * 性别
     */
    @ApiModelProperty(value = "性别")
    private String patientGender;

    /**
     * 标准性别
     */
    @ApiModelProperty(value = "标准性别")
    private String patientGenderStandard;

    /**
     * 生日
     */
    @ApiModelProperty(value = "生日")
    private String birthday;

    /**
     * 电话号码
     */
    @ApiModelProperty(value = "电话号码")
    private String phone;

    /**
     * 备注信息
     */
    @ApiModelProperty(value = "备注信息")
    private String remark;

    /**
     * 数据更新时间
     */
    @ApiModelProperty(value = "数据更新时间")
    private Date dataUpdateDate;

    /**
     * 工作电话号码
     */
    @ApiModelProperty(value = "工作电话号码")
    private String workPhone;

    /**
     * 联系电话号码
     */
    @ApiModelProperty(value = "联系电话号码")
    private String linkPhone;

    /**
     * 家庭电话号码
     */
    @ApiModelProperty(value = "家庭电话号码")
    private String homePhone;

}
