package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.math.BigDecimal;
import java.util.Date;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD检验报告单明细信息表
@Getter
@Setter
public class DataDwdLaboratoryReportItemVO {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 检验报告单ID
     */
    @ApiModelProperty(value = "检验报告单ID")
    private String laboratoryReportId;

    /**
     * ID
     */
    @ApiModelProperty(value = "ID")
    private String id;


    @ApiModelProperty(value = "样本类别(原始)")
    private String sampleTypeRaw;

    @ApiModelProperty(value = "样本类别(标准)")
    private String sampleTypeStandard;


    /**
     * 检验组套编码(原始)
     */
    @ApiModelProperty(value = "检验组套编码(原始)")
    private String projectGroupCodeRaw;

    /**
     * 检验组套编码(标准)
     */
    @ApiModelProperty(value = "检验组套编码(标准)")
    private String projectGroupCodeStandard;

    /**
     * 检验组套名称(原始)
     */
    @ApiModelProperty(value = "检验组套名称(原始)")
    private String projectGroupNameRaw;

    /**
     * 检验组套名称(标准)
     */
    @ApiModelProperty(value = "检验组套名称(标准)")
    private String projectGroupNameStandard;

    /**
     * 检验项目编码(原始)
     */
    @ApiModelProperty(value = "检验项目编码(原始)")
    private String projectIdRaw;

    /**
     * 检验项目编码(标准)
     */
    @ApiModelProperty(value = "检验项目编码(标准)")
    private String projectIdStandard;

    /**
     * 检验项目名称(原始)
     */
    @ApiModelProperty(value = "检验项目名称(原始)")
    private String nameRaw;

    /**
     * 检验项目名称(标准)
     */
    @ApiModelProperty(value = "检验项目名称(标准)")
    private String nameStandard;

    /**
     * 检验项目缩写(原始)
     */
    @ApiModelProperty(value = "检验项目缩写(原始)")
    private String codeRaw;

    /**
     * 检验项目缩写(标准)
     */
    @ApiModelProperty(value = "检验项目缩写(标准)")
    private String codeStandard;

    /**
     * 是否异常(原始)
     */
    @ApiModelProperty(value = "是否异常(原始)")
    private String abnormal;

    /**
     * 结果状态异常标记(原始)
     */
    @ApiModelProperty(value = "结果状态异常标记(原始)")
    private String abnormalIndicator;

    /**
     * 单位(原始)
     */
    @ApiModelProperty(value = "单位(原始)")
    private String unitRaw;

    /**
     * 单位(标准)
     */
    @ApiModelProperty(value = "单位(标准)")
    private String unitStandard;

    /**
     * 参考范围(原始)
     */
    @ApiModelProperty(value = "参考范围(原始)")
    private String referenceRaw;

    /**
     * 参考范围(标准)
     */
    @ApiModelProperty(value = "参考范围(标准)")
    private String referenceStandard;

    /**
     * 结果(原始)
     */
    @ApiModelProperty(value = "结果(原始)")
    private String inspectResultRaw;

    /**
     * 结果分类(标准)
     */
    @ApiModelProperty(value = "结果分类(标准)")
    private String resultType;

    /**
     * 二分类结果(标准)
     */
    @ApiModelProperty(value = "二分类结果(标准)")
    private String resultTwoCategoryCode;

    @ApiModelProperty(value = "二分类结果(标准)")
    private String resultTwoCategoryName;


    /**
     * 叙述结果(标准)
     */
    @ApiModelProperty(value = "叙述结果(标准)")
    private String resultNarrate;

    /**
     * 结果值(标准)
     */
    @ApiModelProperty(value = "结果值(标准)")
    private BigDecimal resultValue;

    /**
     * 结果值标记(标准)
     */
    @ApiModelProperty(value = "结果值标记(标准)")
    private String resultValueFlag;

    /**
     * 结果值标记比例(标准)
     */
    @ApiModelProperty(value = "结果值标记比例(标准)")
    private BigDecimal resultValueRate;


    @ApiModelProperty(value = "结果值参考范围(标准)")
    private String resultValueReference;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 数据操作时间
     */
    @ApiModelProperty(value = "数据操作时间")
    private Date opDate;

    /**
     * 报告时间
     */
    @ApiModelProperty(value = "报告时间")
    private Date reportsTime;


}
