package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;

import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;

import io.swagger.annotations.ApiModelProperty;

// 患者信息
@Getter
@Setter
public class DoctorDwdPatientVO {

  /**
   * 患者编号
   */
  @ApiModelProperty(value = "患者编号")
  private String patientId;

  /**
   * 患者姓名
   */
  @ApiModelProperty(value = "患者姓名")
  private String patientName;

  /**
   * 性别(标准)
   */
  @ApiModelProperty(value = "性别(标准)")
  private String patientGenderStandard;

  /**
   * 生日
   */
  @ApiModelProperty(value = "生日")
  private String birthday;

  /**
   * 电话号码
   */
  @ApiModelProperty(value = "电话号码")
  private String phone;

  /**
   * 证件号
   */
  @ApiModelProperty(value = "证件号")
  private String cardNo;

  /**
   * 证件类型(标准)
   */
  @ApiModelProperty(value = "证件类型(标准)")
  private String cardNoTypeStandard;

  @ApiModelProperty(value = "患者年龄")
  private String patientAge;

  // H5中的患者信息
  @ApiModelProperty(value = "用户绑定并选择的患者信息")
  private MemberFamilyBO memberFamilyBO;

  /**
   * 主患者id
   */
  @ApiModelProperty(value = "主患者id")
  private String mainPersonId;

  /**
   * 死亡状态(Y生 N死)
   */
  @ApiModelProperty(value = "死亡状态(Y生 N死)")
  private String deathStatus;

  /**
   * 死亡时间
   */
  @ApiModelProperty(value = "死亡时间")
  private String deathTime;

}
