package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.util.Date;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生关注患者表
 * </p>
 */
@Getter
@Setter
public class DoctorFollowPatientVO extends BaseEntity {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 关注状态
     */
     @ApiModelProperty(value = "关注状态")
      private String status;

    /**
     * 数据更新类型
     */
     @ApiModelProperty(value = "数据更新类型[PatientDataUpdateTypeEnum]")
      private String dataUpdateType;

    /**
     * 数据更新时间
     */
     @ApiModelProperty(value = "数据更新时间")
      private Date dataUpdateDate;

    /**
     * 患者信息
     */
     @ApiModelProperty(value = "患者信息")
      private PatientClientBO patientInfo;

    /**
     * 就诊信息
     */
     @ApiModelProperty(value = "就诊信息")
      private PatientVisitRecordClientBO visitRecordInfo;

    /**
     * 住院信息
     */
     @ApiModelProperty(value = "住院信息")
      private PatientInpatientRecordClientBO inpatientRecordInfo;

}
