package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorLabelPatientDataVO {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 日期(天)
     */
     @ApiModelProperty(value = "统计日期(天)")
      private String bizDay;

    /**
     * 运营助理id
     */
     @ApiModelProperty(value = "运营助理id")
      private String doctorId;

    /**
     * 标签id
     */
     @ApiModelProperty(value = "标签id")
      private String labelId;

    /**
     * 标签名称
     */
     @ApiModelProperty(value = "标签名称")
      private String labelName;

    /**
     * 患者标签
     */
     @ApiModelProperty(value = "患者标签")
      private List<String> patientLabelIdList;

    /**
     * 排除数据
     */
     @ApiModelProperty(value = "排除数据")
      private List<String> excludePatientIdList;

    /**
     * 纳入数据
     */
     @ApiModelProperty(value = "纳入数据")
      private List<String> joinPatientIdList;

    /**
     * 会诊数据
     */
     @ApiModelProperty(value = "会诊数据")
      private List<String> consultationIdList;

    /**
     * 随访数据
     */
     @ApiModelProperty(value = "随访数据")
      private List<String> followUpIdList;

    /**
     * 场景[门诊、住院、出院]
     */
     @ApiModelProperty(value = "场景[门诊、住院、出院]")
      private String scene;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


    /**
     * 助理信息
     */
     @ApiModelProperty(value = "助理信息")
      private AdminUserBO doctorInfo;

    /**
     * 助理部门信息
     */
     @ApiModelProperty(value = "助理部门信息")
      private DeptBO deptInfo;

    /**
     * 排除数据
     */
     @ApiModelProperty(value = "排除数据")
      private List<DoctorManagePatientVO> excludeInfoList;

    /**
     * 纳入数据
     */
     @ApiModelProperty(value = "纳入数据")
      private List<DoctorManagePatientVO> joinInfoList;

    /**
     * 会诊申请数据
     */
     @ApiModelProperty(value = "会诊申请数据")
      private List<DoctorConsultationLaunchApplyDataVO> consultationList;

}
