package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;
import com.xxh.cloud.healthy.crm.client.api.bean.bo.PatientDoctorRelationBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class DoctorLabelPatientFullVO {

    /**
     * 患者标签编号
     */
    @ApiModelProperty(value = "患者标签编号")
    private String patientLabelId;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 主患者编号
     */
    @ApiModelProperty(value = "主患者编号")
    private String mainPersonId;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idCardNo;

    /**
     * 性别
     */
    @ApiModelProperty(value = "性别")
    private String patientGender;

    /**
     * 标准性别
     */
    @ApiModelProperty(value = "标准性别")
    private String patientGenderStandard;

    /**
     * 生日
     */
    @ApiModelProperty(value = "生日")
    private String birthday;

    /**
     * 电话号码
     */
    @ApiModelProperty(value = "电话号码")
    private String phone;

    /**
     * 扩展电话号码
     */
    @ApiModelProperty(value = "扩展电话号码")
    private String sparePhone;

    /**
     * 联系人电话号码
     */
    @ApiModelProperty(value = "联系人电话号码")
    private String linkPhone;

    /**
     * 家庭电话号码
     */
    @ApiModelProperty(value = "家庭电话号码")
    private String homePhone;

    /**
     * 工作电话号码
     */
    @ApiModelProperty(value = "工作电话号码")
    private String workPhone;

    /**
     * 年龄
     */
    @ApiModelProperty(value = "年龄")
    private String age;

    /**
     * 备注信息
     */
    @ApiModelProperty(value = "备注信息")
    private String remark;

    // 标签id
    @ApiModelProperty(value = "标签id")
    private String labelId;

    // 标签时间
    @ApiModelProperty(value = "标签时间")
    private String dataDt;

    // 死亡状态(Y生 N死)
    @ApiModelProperty(value = "死亡状态(Y生 N死)")
    private String deathStatus;

    // 死亡时间
    @ApiModelProperty(value = "死亡时间")
    private String deathTime;

    @ApiModelProperty(value = "家庭成员信息")
    private List<MemberFamilyBO> memberFamilyList;

    @ApiModelProperty(value = "患者标签信息列表")
    private List<PatientLabelDataVO> patientLabelInfoList;

    // 最新变动数据
    @ApiModelProperty(value = "最新变动数据")
    private DataDwsPatientDataLastDateVO lastDataInfo;

    // 最新就诊数据
    @ApiModelProperty(value = "最新就诊数据")
    private PatientVisitRecordClientBO lastVisitInfo;

    // 最新住院数据
    @ApiModelProperty(value = "最新住院数据")
    private PatientInpatientRecordClientBO lastInpatientInfo;

    // 最新出院数据
    @ApiModelProperty(value = "最新出院数据")
    private PatientDischargeRecordClientBO lastDischargeInfo;

    // 住院状态
    @ApiModelProperty(value = "住院状态")
    private String inpatientStatus;

    // 就诊时间
    @ApiModelProperty(value = "就诊时间")
    private Date visitDate;

    // 就诊医生ID
    @ApiModelProperty(value = "就诊医生ID")
    private String visitDoctorId;

    // 就诊医生姓名
    @ApiModelProperty(value = "就诊医生姓名")
    private String visitDoctorName;

    // 就诊科室ID
    @ApiModelProperty(value = "就诊科室ID")
    private String visitDeptId;

    // 就诊科室名称
    @ApiModelProperty(value = "就诊科室名称")
    private String visitDeptName;

    // 关注状态
    @ApiModelProperty(value = "是否关注")
    private String followStatus;

    // 排除/加入患者管理

    // 个案管理
    @ApiModelProperty(value = "个案管理信息")
    private PatientDoctorRelationBO crmInfo;

    // 是否加入个案
    @ApiModelProperty(value = "是否加入个案")
    private String crmStatus;

}
