package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.util.List;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * 运营助理统计标签下患者数据
 */
@Getter
@Setter
public class DoctorLabelPatientStatisticVO {

    @ApiModelProperty(value = "标签id")
    private String labelId;

    @ApiModelProperty(value = "标签名称")
    private String labelName;

    @ApiModelProperty(value = "推送次数")
    private Integer labelNum;

    @ApiModelProperty(value = "科室id")
    private String deptId;

    @ApiModelProperty(value = "科室名称")
    private String deptName;

    @ApiModelProperty(value = "运营助理ID")
    private String doctorId;

    @ApiModelProperty(value = "运营助理")
    private String doctorName;

    @ApiModelProperty(value = "导流场景")
    private String scene;

    @ApiModelProperty(value = "纳入数量")
    private Integer joinCount;

    @ApiModelProperty(value = "排除数量")
    private Integer excludeCount;

    @ApiModelProperty(value = "邀请会诊数量")
    private Integer consultationCount;

    @ApiModelProperty(value = "等待会诊数量")
    private Integer todoConsultationCount;

    @ApiModelProperty(value = "完成会诊数量")
    private Integer doneConsultationCount;

    @ApiModelProperty(value = "统计时间")
    private String statisticDate;

    @ApiModelProperty(value = "纳入")
    private List<DoctorManagePatientVO> joinList;

    @ApiModelProperty(value = "排除")
    private List<DoctorManagePatientVO> excludeList;

    @ApiModelProperty(value = "排除原因")
    private List<DoctorLabelPatientExcludeStatisticVO> excludeStatisticVOList;
    
    @ApiModelProperty(value = "会诊申请数据")
    private List<DoctorConsultationLaunchApplyDataVO> consultationList;

}
