package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import java.util.Date;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生管理患者表
 * </p>
 */
@Getter
@Setter
public class DoctorManagePatientVO extends BaseEntity {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 患者标签id
     */
     @ApiModelProperty(value = "患者标签id")
      private String labelId;

    /**
     * 标签时间
     */
     @ApiModelProperty(value = "标签时间")
      private Date labelDate;

    /**
     * 操作场景
     */
     @ApiModelProperty(value = "操作场景")
      private String opScene;

    /**
     * 操作类型（排除/纳入）
     */
     @ApiModelProperty(value = "操作类型")
      private String opType;

    /**
     * 操作子类型（由字典定义）
     */
     @ApiModelProperty(value = "操作子类型")
      private String opSubType;

    /**
     * 操作内容
     */
     @ApiModelProperty(value = "操作内容")
      private String opContent;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;

    /**
     * 医生信息
     */
     @ApiModelProperty(value = "医生信息")
      private AdminUserBO doctorInfo;

    /**
     * 部门信息
     */
     @ApiModelProperty(value = "部门信息")
      private DeptBO deptInfo;

    /**
     * 患者信息
     */
     @ApiModelProperty(value = "患者信息")
      private TaskPatientVO patientInfo;

    /**
     * 第一次查看时间
     */
     @ApiModelProperty(value = "第一次查看时间")
      private Date firstVisitDate;

    /**
     * 标签数据
     */
     @ApiModelProperty(value = "标签数据")
      private LabelBO labelBO;

}
