package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DiseaseDiagnosisRelBO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 患者诊断信息
 * */
@Getter
@Setter
public class PatientDiagnosisDataVO {

    @ApiModelProperty(value = "患者ID")
    private String patientId;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "诊断编码(标准)")
    private String diagnosisCodeStandard;

    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "病种名称")
    private String diseaseName;

    @ApiModelProperty(value = "病种系统ID")
    private String diseaseSystemId;

    @ApiModelProperty(value = "病种系统名称")
    private String diseaseSystemName;

    @ApiModelProperty(value = "疾病系统别名")
    private String diseaseSystemAliasName;

    @ApiModelProperty(value = "疾病系统名称英文")
    private String diseaseSystemEnName;

    @ApiModelProperty(value = "疾病系统名称缩写")
    private String diseaseSystemAbbrName;

    @ApiModelProperty(value = "诊断关联")
    private Map<String, List<DiseaseDiagnosisRelBO>> diagnosisRel = new HashMap<>();
}
