package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// 诊中：优化诊疗过程
@Getter
@Setter
public class PatientDuringStatisticVO {

    // 挂号流失患者（已挂号未就诊）
    @ApiModelProperty(value = "历史所有挂号流失患者(根据历史标签查询)")
    private Long historyRegisterCount;
    @ApiModelProperty(value = "当前所有挂号流失患者(根据当前标签查询)")
    private Long nowRegisterCount;
    @ApiModelProperty(value = "昨日新增挂号流失患者(根据昨日时间查询历史标签)")
    private Long newRegisterCountYesterday;

    // 住院流失患者（已申请未住院）
    @ApiModelProperty(value = "历史所有住院流失患者(根据历史标签查询)")
    private Long historyInHospitalCount;
    @ApiModelProperty(value = "当前所有住院流失患者(根据当前标签查询)")
    private Long nowInHospitalCount;
    @ApiModelProperty(value = "昨日新增住院流失患者(根据昨日时间查询历史标签)")
    private Long newInHospitalCountYesterday;

    // 住院流失患者（人工打流失标签）
    @ApiModelProperty(value = "历史所有住院流失患者(根据历史标签查询)")
    private Long otherHistoryInHospitalCount;
    @ApiModelProperty(value = "当前所有住院流失患者(根据当前标签查询)")
    private Long otherNowInHospitalCount;
    @ApiModelProperty(value = "昨日新增住院流失患者(根据昨日时间查询历史标签)")
    private Long otherNewInHospitalCountYesterday;

    // 手术流失患者（已申请未手术）
    @ApiModelProperty(value = "历史所有手术流失患者(根据历史标签查询)")
    private Long historyOperationCount;
    @ApiModelProperty(value = "当前所有手术流失患者(根据当前标签查询)")
    private Long nowOperationCount;
    @ApiModelProperty(value = "昨日新增手术流失患者(根据昨日时间查询历史标签)")
    private Long newOperationCountYesterday;

    // 流失比例
    @ApiModelProperty(value = "流失比例")
    private String historyLostRatio;
    // 昨日流失人数
    @ApiModelProperty(value = "昨日流失人数")
    private Long newLostYesterday;

}
