package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import java.util.Date;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者流失表
 * </p>
 */
@Getter
@Setter
public class PatientLossVO {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 标准科室编号
     */
    @ApiModelProperty(value = "标准科室编号")
    private String deptId;

    /**
     * 原始科室编号
     */
    @ApiModelProperty(value = "原始科室编号")
    private String sourceDeptId;

    /**
     * 科室名称
     */
    @ApiModelProperty(value = "科室名称")
    private String deptName;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 流失类型
     */
    @ApiModelProperty(value = "流失类型[住院/挂号/就诊]")
    private String type;

    /**
     * 流失来源id
     */
    @ApiModelProperty(value = "流失来源id[住院申请id/挂号id/就诊id]")
    private String dataSourceId;

    /**
     * 流失来源时间
     */
    @ApiModelProperty(value = "流失来源时间")
    private Date dataSourceDate;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 备注时间
     */
    @ApiModelProperty(value = "备注时间")
    private String remarkDate;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 数据更新时间
     */
    @ApiModelProperty(value = "数据更新时间")
    private Date dataUpdateDate;


    
    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 性别
     */
    @ApiModelProperty(value = "性别")
    private String patientGender;

    /**
     * 标准性别
     */
    @ApiModelProperty(value = "标准性别")
    private String patientGenderStandard;

    /**
     * 生日
     */
    @ApiModelProperty(value = "生日")
    private String birthday;

    /**
     * 电话号码
     */
    @ApiModelProperty(value = "电话号码")
    private String phone;

    /**
     * 备用电话号码
     */
    @ApiModelProperty(value = "备用电话号码")
    private String sparePhone;

    /**
     * 工作电话号码
     */
    @ApiModelProperty(value = "工作电话号码")
    private String workPhone;

    /**
     * 联系电话号码
     */
    @ApiModelProperty(value = "联系电话号码")
    private String linkPhone;

    /**
     * 家庭电话号码
     */
    @ApiModelProperty(value = "家庭电话号码")
    private String homePhone;

    /**
     * 年龄
     */
    @ApiModelProperty(value = "年龄")
    private String age;

}
