package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientPreStatisticVO {

    // 本科室就诊患者 （门诊、急诊、登记住院）的患者总数量 （根据userid 去重复）
    @ApiModelProperty(value = "总患者数量")
    private Long patientTotalCount;
    
    // 统计本科室对应所有疾病对应的标签为含有“发现潜在患者/未就诊” + “发现潜在患者/已就诊” 的患者总数量。根据userid 去重复
    // 用户的当前标签
    @ApiModelProperty(value = "潜在患者数量")
    private Long potentialPatientCount;
    

    // 诊前：发现潜在患者
    // 发现潜在患者/未就诊
    @ApiModelProperty(value = "历史所有发现潜在患者/未就诊(根据历史标签查询)")
    private Long historyNotVisitCount;
    @ApiModelProperty(value = "当前所有发现潜在患者数量/未就诊(根据当前标签查询)")
    private Long nowNotVisitCount;
    // 昨日新增发现潜在患者/未就诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/未就诊(根据昨日时间查询历史标签)")
    private Long newNotVisitCountYesterday;

    // 发现潜在患者/已就诊
    @ApiModelProperty(value = "历史所有发现潜在患者/已就诊(根据历史标签查询)")
    private Long historyVisitedCount;
    @ApiModelProperty(value = "当前所有发现潜在患者/已就诊(根据当前标签查询)")
    private Long nowVisitedCount;
    // 昨日新增发现潜在患者/已就诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/已就诊(根据昨日时间查询历史标签)")
    private Long newVisitedCountYesterday;

    // 发现潜在患者/已确诊
    @ApiModelProperty(value = "历史所有发现潜在患者/已确诊(根据历史标签查询)")
    private Long historyConfirmedCount;
    @ApiModelProperty(value = "当前所有发现潜在患者/已确诊(根据当前标签查询)")
    private Long nowConfirmedCount;
    // 昨日新增发现潜在患者/已确诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/已确诊(根据昨日时间查询历史标签)")
    private Long newConfirmedCountYesterday;

    // 就诊转化率
    @ApiModelProperty(value = "就诊转化率")
    private String transformRatio;
    // 近30天就诊转化率
    @ApiModelProperty(value = "近30天就诊转化率")
    private String transformRatio30;

    @ApiModelProperty(value = "最近更新时间")
    private String updateDate;
}
