package com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientStatisticVO {

    // 本科室就诊患者 （门诊、急诊、登记住院）的患者总数量 （根据userid 去重复）
    @ApiModelProperty(value = "总患者数量")
    private Integer patientTotalCount;
    
    // 统计本科室对应所有疾病对应的标签为含有“发现潜在患者/未就诊” + “发现潜在患者/已就诊” 的患者总数量。根据userid 去重复
    // 用户的当前标签
    @ApiModelProperty(value = "潜在患者数量")
    private Integer potentialPatientCount;
    

    // 诊前：发现潜在患者
    // 发现潜在患者/未就诊；根据历史标签查询
    @ApiModelProperty(value = "发现潜在患者/未就诊")
    private Integer notVisitCount;
    // 昨日新增发现潜在患者/未就诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/未就诊")
    private Integer notVisitCountYesterday;
    // 发现潜在患者/已就诊
    @ApiModelProperty(value = "发现潜在患者/已就诊")
    private Integer visitedCount;
    // 昨日新增发现潜在患者/已就诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/已就诊")
    private Integer visitedCountYesterday;
    // 发现潜在患者/已确诊
    @ApiModelProperty(value = "发现潜在患者/已确诊")
    private Integer confirmedCount;
    // 昨日新增发现潜在患者/已确诊
    @ApiModelProperty(value = "昨日新增发现潜在患者/已确诊")
    private Integer confirmedCountYesterday;
    // 就诊转化率
    @ApiModelProperty(value = "就诊转化率")
    private String transformRatio;
    // 近30天就诊转化率
    @ApiModelProperty(value = "近30天就诊转化率")
    private String transformRatio30;


    // 诊中：优化诊疗过程
    // 挂号流失患者
    @ApiModelProperty(value = "挂号流失患者")
    private Integer registerCount;
    // 昨日新增挂号流失患者
    @ApiModelProperty(value = "昨日新增挂号流失患者")
    private Integer registerCountYesterday;
    // 住院流失患者
    @ApiModelProperty(value = "住院流失患者")
    private Integer inHospitalCount;
    // 昨日新增住院流失患者
    @ApiModelProperty(value = "昨日新增住院流失患者")
    private Integer inHospitalCountYesterday;
    // 手术流失患者
    @ApiModelProperty(value = "手术流失患者")
    private Integer operationCount;
    // 昨日新增手术流失患者
    @ApiModelProperty(value = "昨日新增手术流失患者")
    private Integer operationCountYesterday;
    // 流失比例
    @ApiModelProperty(value = "流失比例")
    private String lostRatio;
    // 昨日流失比例
    @ApiModelProperty(value = "昨日流失人数")
    private Integer lostRatioYesterday;


    // 诊后：服务确诊患者
    // 疾病管理服务次数
    @ApiModelProperty(value = "疾病管理服务次数")
    private Integer serviceCount;
    // 昨日新增疾病管理服务次数
    @ApiModelProperty(value = "昨日新增疾病管理服务次数")
    private Integer serviceCountYesterday;
    // 服务接受率
    @ApiModelProperty(value = "服务接受率")
    private String serviceRatio;
    // 昨日服务接受率
    @ApiModelProperty(value = "昨日服务接受率")
    private String serviceRatioYesterday;
    // 复诊率
    @ApiModelProperty(value = "复诊率")
    private String consultationRatio;
    // 昨日复诊率
    @ApiModelProperty(value = "昨日复诊率")
    private String consultationRatioYesterday;
    // 失访人数
    @ApiModelProperty(value = "失访人数")
    private Integer lostCount;
    // 昨日失访人数
    @ApiModelProperty(value = "昨日失访人数")
    private Integer lostCountYesterday;
}
