package com.xxh.cloud.healthy.data.framework.modules.biz.helper;

import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorManagePatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.TaskDeptLabelRelationBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.TaskDeptPatientRelationBO;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.DoctorFollowPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.DoctorLabelPatientDataInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.DoctorManagePatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.PatientLossInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.PatientManageDetailInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.PatientPushServeDataOneDayInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskDeptLabelRelationInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskDeptPatientRelationInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServePatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorFollowPatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorLabelPatientDataVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorManagePatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientLossVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientManageDetailVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServeDataOneDayVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskDeptLabelRelationVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskDeptPatientRelationVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;
import com.xxh.cloud.common.util.DataUtil;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

public class DoctorDataHelper {

    public static String getPatientDataOneDayInfoId(){
        return StrUtil.format("PD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientDiseaseDataOneDayInfoId(){
        return StrUtil.format("PDD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientPushServeDataOneDayInfoId(){
        return StrUtil.format("PPSD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientLostLabelLogId(){
        return StrUtil.format("PLLL{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorFollowPatientId(){
        return StrUtil.format("DFP{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorManagePatientId(){
        return StrUtil.format("DMP{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorLabelPatientDataId(){
        return StrUtil.format("DLPD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDrugInfoId(){
        return StrUtil.format("DI{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDrugItemInfoId(){
        return StrUtil.format("DII{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static TaskDeptLabelRelationVO getTaskDeptLabelRelationVO(TaskDeptLabelRelationInfo entity) {
        TaskDeptLabelRelationVO vo = new TaskDeptLabelRelationVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static TaskDeptLabelRelationBO getTaskDeptLabelRelationBO(TaskDeptLabelRelationVO vo) {
        TaskDeptLabelRelationBO bo = new TaskDeptLabelRelationBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

    public static TaskDeptPatientRelationVO getTaskDeptPatientRelationVO(TaskDeptPatientRelationInfo entity) {
        TaskDeptPatientRelationVO vo = new TaskDeptPatientRelationVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static TaskDeptPatientRelationBO getTaskDeptPatientRelationBO(TaskDeptPatientRelationVO vo) {
        TaskDeptPatientRelationBO bo = new TaskDeptPatientRelationBO();
        BeanUtil.copyProperties(vo, vo);
        return bo;
    }

    public static TaskPatientVO getTaskPatientVO(TaskPatientInfo entity) {
        if (null == entity) {
            return null;
        }
        TaskPatientVO vo = new TaskPatientVO();
        BeanUtil.copyProperties(entity, vo);

        vo.setAge(DataUtil.getAge(vo.getIdCardNo(), vo.getBirthday()));
        vo.setIdCardNo(null);

        // 处理备用电话
        if (StrUtil.isBlank(vo.getPhone())) {
            if (StrUtil.isNotBlank(vo.getLinkPhone())) {
                vo.setPhone(vo.getLinkPhone());
            } else if (StrUtil.isNotBlank(vo.getHomePhone())) {
                vo.setPhone(vo.getHomePhone());
            } else if (StrUtil.isNotBlank(vo.getWorkPhone())) {
                vo.setPhone(vo.getWorkPhone());
            }
        }
        if (StrUtil.isNotBlank(vo.getPhone())) {
            if (StrUtil.isNotBlank(vo.getLinkPhone()) && !vo.getPhone().equals(vo.getLinkPhone())) {
                vo.setSparePhone(vo.getLinkPhone());
            } else if (StrUtil.isNotBlank(vo.getHomePhone()) && !vo.getPhone().equals(vo.getHomePhone())) {
                vo.setSparePhone(vo.getHomePhone());
            } else if (StrUtil.isNotBlank(vo.getWorkPhone()) && !vo.getPhone().equals(vo.getWorkPhone())) {
                vo.setSparePhone(vo.getWorkPhone());
            }
        }

        return vo;
    }

    public static PushServePatientVO getPushServePatientVO(TaskPatientInfo entity) {
        PushServePatientVO vo = new PushServePatientVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static PushServeDataOneDayVO getPushServiceDataOneDayVO(PatientPushServeDataOneDayInfo entity) {
        PushServeDataOneDayVO vo = new PushServeDataOneDayVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorFollowPatientVO getDoctorFollowPatientVO(DoctorFollowPatientInfo entity) {
        DoctorFollowPatientVO vo = new DoctorFollowPatientVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorManagePatientVO getDoctorManagePatientVO(DoctorManagePatientInfo entity) {
        DoctorManagePatientVO vo = new DoctorManagePatientVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorLabelPatientDataVO getDoctorLabelPatientDataVO(DoctorLabelPatientDataInfo entity) {
        DoctorLabelPatientDataVO vo = new DoctorLabelPatientDataVO();
        BeanUtil.copyProperties(entity, vo, "patientLabelIds", "excludePatientIds", "joinPatientIds", "consultationIds", "followUpIds");
        if (StrUtil.isNotBlank(entity.getPatientLabelIds())) {
            vo.setPatientLabelIdList(StrJoinSplitUtils.split2List(entity.getPatientLabelIds()));
        }
        if (StrUtil.isNotBlank(entity.getExcludePatientIds())) {
            vo.setExcludePatientIdList(StrJoinSplitUtils.split2List(entity.getExcludePatientIds()));
        }
        if (StrUtil.isNotBlank(entity.getJoinPatientIds())) {
            vo.setJoinPatientIdList(StrJoinSplitUtils.split2List(entity.getJoinPatientIds()));
        }
        if (StrUtil.isNotBlank(entity.getConsultationIds())) {
            vo.setConsultationIdList(StrJoinSplitUtils.split2List(entity.getConsultationIds()));
        }
        if (StrUtil.isNotBlank(entity.getFollowUpIds())) {
            vo.setFollowUpIdList(StrJoinSplitUtils.split2List(entity.getFollowUpIds()));
        }
        return vo;
    }

    public static DoctorManagePatientBO getDoctorManagePatientBO(DoctorManagePatientVO vo) {
        DoctorManagePatientBO bo = new DoctorManagePatientBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

    public static PatientLossVO getPatientLossVO(PatientLossInfo vo) {
        PatientLossVO bo = new PatientLossVO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

    public static PatientManageDetailVO getPatientManageDetailVO(PatientManageDetailInfo vo) {
        PatientManageDetailVO bo = new PatientManageDetailVO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

}
