package com.xxh.cloud.healthy.data.framework.modules.biz.helper;

import cn.hutool.core.map.MapUtil;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDiagnosisReportClientBO;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DiseaseDiagnosisRelBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DiseaseSystemBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.TaskPatientAddDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientDiagnosisDataVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;

import cn.hutool.core.bean.BeanUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class TaskPatientHelper {

    public static TaskPatientInfo getTaskPatientInfo(TaskPatientAddDTO params) {
        TaskPatientInfo entity = new TaskPatientInfo();
        entity.setPatientId(params.getPatientId());
        return getTaskPatientInfo(entity, params);
    }

    public static TaskPatientInfo getTaskPatientInfo(TaskPatientInfo entity, TaskPatientAddDTO params) {
        entity.setPatientName(params.getPatientName());
        entity.setIdCardNo(params.getIdCardNo());
        entity.setPatientGender(params.getPatientGender());
        entity.setPatientGenderStandard(params.getPatientGenderStandard());
        entity.setBirthday(params.getBirthday());
        entity.setPhone(params.getPhone());
        entity.setWorkPhone(params.getWorkPhone());
        entity.setLinkPhone(params.getLinkPhone());
        entity.setHomePhone(params.getHomePhone());
        entity.setDataUpdateDate(params.getDataUpdateDate());
        entity.setMainPersonId(params.getMainPersonId());
        return entity;
    }

    public static PatientClientBO getPatientClientBO(TaskPatientVO vo) {
        PatientClientBO bo = new PatientClientBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

    public static PatientDiagnosisDataVO getPatientClientBO(PatientDiagnosisReportClientBO clientBO,
                                                            Map<String, DiseaseSystemBO> diseaseSystemBOMap,
                                                            Map<String, List<DiseaseDiagnosisRelBO>> diseaseDiagnosisRelMap) {
        PatientDiagnosisDataVO vo = new PatientDiagnosisDataVO();
        BeanUtil.copyProperties(clientBO, vo);
        // 系统关联
        if (MapUtil.isNotEmpty(diseaseSystemBOMap) && diseaseSystemBOMap.containsKey(vo.getDiagnosisCodeStandard())) {
            DiseaseSystemBO diseaseSystemBO = diseaseSystemBOMap.get(vo.getDiagnosisCodeStandard());
            vo.setDiseaseId(diseaseSystemBO.getDiseaseId());
            vo.setDiseaseName(diseaseSystemBO.getDiseaseName());
            vo.setDiseaseSystemId(diseaseSystemBO.getDiseaseSystemId());
            vo.setDiseaseSystemName(diseaseSystemBO.getDiseaseSystemName());
            vo.setDiseaseSystemAliasName(diseaseSystemBO.getDiseaseSystemAliasName());
            vo.setDiseaseSystemEnName(diseaseSystemBO.getDiseaseSystemEnName());
            vo.setDiseaseSystemAbbrName(diseaseSystemBO.getDiseaseSystemAbbrName());


        }
        // 诊断关联
        if (MapUtil.isNotEmpty(diseaseDiagnosisRelMap) && diseaseDiagnosisRelMap.containsKey(vo.getDiagnosisCodeStandard())) {
            List<DiseaseDiagnosisRelBO> relBOS = diseaseDiagnosisRelMap.get(vo.getDiagnosisCodeStandard());
            relBOS.forEach(rel->{
                List<DiseaseDiagnosisRelBO> bos;
                if (vo.getDiagnosisRel().containsKey(rel.getObjType())) {
                    bos = vo.getDiagnosisRel().get(rel.getObjType());
                } else {
                    bos = new ArrayList<>();
                }
                bos.add(rel);
                vo.getDiagnosisRel().put(rel.getObjType(), bos);
            });


        }
        return vo;
    }


    public static PatientDiagnosisDataVO getPatientClientBO(DiseaseSystemBO diseaseSystemBO,
                                                            Map<String, List<DiseaseDiagnosisRelBO>> diseaseDiagnosisRelMap) {
        PatientDiagnosisDataVO vo = new PatientDiagnosisDataVO();
        BeanUtil.copyProperties(diseaseSystemBO, vo);
        // 诊断关联
        if (MapUtil.isNotEmpty(diseaseDiagnosisRelMap) && diseaseDiagnosisRelMap.containsKey(vo.getDiseaseId())) {
            List<DiseaseDiagnosisRelBO> relBOS = diseaseDiagnosisRelMap.get(vo.getDiseaseId());
            relBOS.forEach(rel->{
                List<DiseaseDiagnosisRelBO> bos;
                if (vo.getDiagnosisRel().containsKey(rel.getObjType())) {
                    bos = vo.getDiagnosisRel().get(rel.getObjType());
                } else {
                    bos = new ArrayList<>();
                }
                bos.add(rel);
                vo.getDiagnosisRel().put(rel.getObjType(), bos);
            });
        }
        return vo;
    }
}
