package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServePatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServeTargetVO;

/**
 * 20231012
 */
public interface DeptPatientQueryBizMapper {
    
    /**
     * 查询部门下的患者
     */
    @Select("  SELECT * " + 
            "  FROM hd_task_patient_info " +
            "  WHERE patient_id IN ( " +
            "    SELECT a.patient_id " +
            "    FROM hd_task_patient_info a " +
            "    INNER JOIN hd_task_dept_patient_relation_info e ON a.patient_id = e.patient_id " +
            "    ${ew.customSqlSegment} " +
            "  ) " +
            " ${ew2.customSqlSegment} ")
    IPage<TaskPatientInfo> queryDeptAllPatient(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper, @Param("ew2") Wrapper<TaskPatientInfo> wrapper2);

    @Select("  SELECT * " + 
            "  FROM hd_task_patient_info " +
            "  WHERE patient_id IN ( " +
            "    SELECT a.patient_id " +
            "    FROM hd_task_patient_info a " +
            "    INNER JOIN hd_task_dept_patient_relation_info e ON a.patient_id = e.patient_id " +
            "    INNER JOIN h_patient_label_history_info b ON a.patient_id = b.patient_id AND b.op_type = '1' " + 
            "    INNER JOIN s_md_standard_label_info c ON b.label_id = c.id " +
            "    ${ew.customSqlSegment} " +
            "  ) " +
            " ${ew2.customSqlSegment} ")
    IPage<TaskPatientInfo> queryDeptPatient(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper, @Param("ew2") Wrapper<TaskPatientInfo> wrapper2);

    @Select("SELECT DISTINCT a.patient_id " + 
            "    FROM hd_task_dept_patient_relation_info a " +
            "    ${ew.customSqlSegment} ")
    List<TaskPatientInfo> listDeptAllPatient(@Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    @Select(" SELECT COUNT(1) " +
            " FROM ( SELECT DISTINCT a.patient_id " + 
            "    FROM hd_task_dept_patient_relation_info a " +
            "    ${ew.customSqlSegment} " + 
            " ) a ")
    Long deptAllPatientCount(@Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    @Select("SELECT DISTINCT a.patient_id " + 
            "    FROM hd_task_dept_patient_relation_info a " +
            "    INNER JOIN h_patient_label_history_info b ON a.patient_id = b.patient_id AND b.op_type = '1' " + 
            "    INNER JOIN s_md_standard_label_info c ON b.label_id = c.id " +
            "    ${ew.customSqlSegment} ")
    List<TaskPatientInfo> listDeptPatient(@Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    @Select("SELECT DISTINCT a.patient_id " + 
            "    FROM hd_task_dept_patient_relation_info a " +
            "    ${ew.customSqlSegment} ")
    TaskPatientInfo getDeptPatient(@Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);



    @Deprecated
    @Select("SELECT b.push_serve_id, b.op_date createDate, c.first_send_dt pushServeDate, c.send_status pushServeStatus, c.error_code, " + 
            " c.error_msg, a.patient_id " + 
            "    FROM hd_task_dept_patient_relation_info a " +
            "    INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.patient_id = b.patient_id " + 
            "    LEFT JOIN hp_push_weixin_log c ON c.rows_status = 'Y' AND a.patient_id = c.user_id AND b.patient_push_serve_id = c.biz_id " + 
            "    ${ew.customSqlSegment} ")
    IPage<PushServePatientVO> queryDeptPatientByPushServeId(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    @Select(" SELECT a.push_serve_id pushServeId, a.patient_push_serve_id patientPushServeId, a.patient_id patientId, a.op_date opDate, b.id scheduleId, " + 
            "  b.schedule_date scheduleDate, b.user_id userId, c.`name` userName, c.gender userGender, c.relation_name relationName, c.patient_type_name patientTypeName " + 
            "    FROM h_patient_push_serve_history_info a " +
            "    LEFT JOIN h_patient_schedule_info b ON b.biz_id = a.patient_push_serve_id AND b.rows_status = 'Y' " + 
            "    LEFT JOIN cust_customer_family_member_info c ON c.user_id = b.user_id AND c.pat_his_no = b.patient_id " + 
        //     "    LEFT JOIN cust_customer_family_member_info c ON c.user_id = b.user_id AND c.main_person_id = b.patient_id " + 
            "    ${ew.customSqlSegment} ")
    IPage<PushServeTargetVO> queryUsersByPushServeId(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    @Select(" SELECT a.push_serve_id pushServeId, a.patient_push_serve_id patientPushServeId, a.patient_id patientId, a.op_date opDate, b.send_date scheduleDate " + 
            "    FROM h_patient_push_serve_history_info a " +
            "    INNER JOIN h_patient_push_serve_date_info b ON b.patient_push_serve_id = a.patient_push_serve_id " + 
            "    ${ew.customSqlSegment} ")
    IPage<PushServeTargetVO> queryUsersByPushServeId2(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);

    /**
     * 简单查询用户信息
     */
    @Select("  SELECT * " + 
            "  FROM hd_task_patient_info " +
            "  WHERE patient_id IN ( " +
            "    SELECT a.patient_id " +
            "    FROM hd_task_patient_info a " +
            "    INNER JOIN hd_task_dept_patient_relation_info e ON a.patient_id = e.patient_id " +
            "    INNER JOIN h_patient_label_history_info b ON a.patient_id = b.patient_id AND b.op_type = '1' " + 
            "    INNER JOIN s_md_standard_label_info c ON b.label_id = c.id " +
            "    ${ew.customSqlSegment} " +
            "  ) " +
            " ${ew2.customSqlSegment} ")
    IPage<TaskPatientInfo> simplePage(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper, @Param("ew2") Wrapper<TaskPatientInfo> wrapper2);

    @Select("SELECT doctor_id " + 
            "    FROM h_doctor_relation_info " +
            "    GROUP BY doctor_id ")
    List<String> listAssistantId();

    @Select("SELECT id, dept_id " + 
            "    FROM sys_user " +
            "    ${ew.customSqlSegment} ")
    List<Map<String, String>> listAllAdminUser(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

}