package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;

import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DeptPatientRelationAddDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.TaskPatientAddDTO;

/**
 * 部门患者关联同步中间表
 */
public interface DeptPatientRelationMapper {

    // 插入到患者信息中间表
    @Insert({
        "<script>",
        "INSERT INTO hd_task_patient_info_mid (patient_id, main_person_id, patient_name, patient_gender_standard, birthday, patient_gender, id_card_no, phone) VALUES ",
        "<foreach collection='dataList' item='item' index='index' separator=','>",
        "(#{item.patientId}, #{item.mainPersonId}, #{item.patientName}, #{item.patientGenderStandard}, #{item.birthday}, #{item.patientGender}, #{item.idCardNo}, #{item.phone})",
        "</foreach>",
        "</script>"
    })
    Long savePatientMidBatch(@Param("dataList") List<TaskPatientAddDTO> dataList);

    // 从患者信息中间表插入到目标表
    @Insert({
        "<script>",
        "INSERT INTO hd_task_patient_info (patient_id, main_person_id, patient_name, patient_gender_standard, birthday, patient_gender, id_card_no, phone, data_update_date) ",
        "SELECT patient_id, main_person_id, patient_name, patient_gender_standard, birthday, patient_gender, id_card_no, phone, NOW() ",
        "FROM hd_task_patient_info_mid ",
        "GROUP BY patient_id, main_person_id, patient_name, patient_gender_standard, birthday, patient_gender, id_card_no, phone ",
        "</script>"
    })
    Long savePatientBatch();
    
    // 插入到部门患者中间表
    @Insert({
        "<script>",
        "INSERT INTO hd_task_dept_patient_relation_info_mid (dept_id, patient_id, register_dt, type) VALUES ",
        "<foreach collection='dataList' item='item' index='index' separator=','>",
        "(#{item.deptId}, #{item.patientId}, #{item.registerDt}, #{item.type})",
        "</foreach>",
        "</script>"
    })
    Long saveDeptPatientMidBatch(@Param("dataList") List<DeptPatientRelationAddDTO> dataList);

    // 从部门患者中间表插入到目标表
    @Insert({
        "<script>",
        "INSERT INTO hd_task_dept_patient_relation_info (dept_id, patient_id, register_dt, type) ",
        "SELECT dept_id, patient_id, MAX(register_dt) register_dt, type ",
        "FROM hd_task_dept_patient_relation_info_mid ",
        "GROUP BY dept_id, patient_id, type ",
        "</script>"
    })
    Long saveDeptPatientBatch();
}