package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDiagnosisReportClientBO;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DiseaseDiagnosisRelBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DiseaseSystemBO;
import io.swagger.annotations.ApiModelProperty;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

public interface DiseaseDiagnosisQueryMapper {

    /**
     * 查询病种关联的系统
     */
    @Select(" SELECT a.id as disease_id, a.name as disease_name, b.id as disease_system_id, b.name as disease_system_name, " +
            " b.alias_name as disease_system_alias_name, b.en_name as disease_system_en_name, b.abbr_name as disease_system_abbr_name" +
            " FROM s_md_standard_disease_info a " +
            " LEFT JOIN s_md_standard_disease_system_info b on a.system_id = b.id " +
            " ${ew.customSqlSegment} ")
    List<DiseaseSystemBO> queryDiseaseSystemBO(@Param(Constants.WRAPPER) Wrapper<DiseaseSystemBO> wrapper);

    /**
     * 查询病种关联的系统
     */
    @Select(" SELECT disease_id FROM s_md_standard_disease_icd_rel " +
            " ${ew.customSqlSegment} ")
    List<String> queryIcdRel(@Param(Constants.WRAPPER) Wrapper<DiseaseSystemBO> wrapper);

    /**
     * 查询病种关联诊断依据
     */
    @Select(" SELECT * FROM s_md_standard_disease_diagnosis_rel " +
            " ${ew.customSqlSegment} ")
    List<DiseaseDiagnosisRelBO> queryDiseaseDiagnosisRelBO(@Param(Constants.WRAPPER) Wrapper<DiseaseDiagnosisRelBO> wrapper);

}
