package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.DoctorLabelPatientDataInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorConsultationLaunchApplyDataVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorLabelPatientDiseaseDataVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorLabelPatientExcludeStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorRelationStatisticVO;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface DoctorLabelPatientStatisticBizQueryMapper {

    // 查询患者标签历史表关联病种表
    @Select(" SELECT a.id, a.patient_id as patientId, a.label_id as labelId, a.data_dt as dataDt, b.name as labelName, b.disease_ids as diseaseIds " + 
            " FROM h_patient_label_history_info a " + 
            " INNER JOIN s_md_standard_label_info b on ( a.label_id =b.id) " + 
            " ${ew.customSqlSegment} ")
    List<DoctorLabelPatientDiseaseDataVO> queryPatientLabelDiseaseList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 查询运营助理部门病种关联 // h_doctor_relation_info 这个表只用于随访
//     @Select(" SELECT a.doctor_id as doctorId , a.type, a.relation_id as relationId, b.disease_ids as diseaseIds " + 
//             " FROM h_doctor_relation_info a " + 
//             " LEFT JOIN sys_dept b on ( a.type = 'dept' and a.relation_id = b.id) " + 
//             " ${ew.customSqlSegment} ")
//     public List<DoctorRelationStatisticVO> queryDoctorRelationList(@Param(Constants.WRAPPER) Wrapper<DoctorRelationStatisticVO> wrapper);
    // 查询运营助理部门病种关联
    @Select(" SELECT a.id as doctorId , 'dept' as type, b.id as relationId, b.disease_ids as diseaseIds " + 
            " FROM sys_user a " + 
            " INNER JOIN sys_dept b on ( a.dept_id = b.id) " + 
            " ${ew.customSqlSegment} ")
    List<DoctorRelationStatisticVO> queryDoctorRelationList(@Param(Constants.WRAPPER) Wrapper<DoctorRelationStatisticVO> wrapper);

    // 查询运营助理发起的会诊申请
    @Select(" SELECT * " + 
            " FROM mdt_consultation_launch_apply_info" + 
            " ${ew.customSqlSegment} ")
    List<DoctorConsultationLaunchApplyDataVO> queryDoctorConsultatioLaunchApplyList(@Param(Constants.WRAPPER) Wrapper<DoctorConsultationLaunchApplyDataVO> wrapper);

    // 查询运营助理合并场景的统计数据
    @Select(" SELECT biz_day as bizDay, doctor_id as doctorId, label_id as labelId " + 
            " FROM hd_doctor_label_patient_data_info  " + 
            " ${ew.customSqlSegment}  " + 
            " GROUP BY biz_day, doctor_id, label_id " +
            " ORDER BY biz_day DESC ")
    IPage<DoctorLabelPatientDataInfo> queryDoctorDataStatisticList(Page<DoctorLabelPatientDataInfo> page, @Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientDataInfo> wrapper);

    // 查询运营助理合并场景的统计数据
    @Select(" SELECT id as labelId, name as labelName " + 
            " FROM s_md_standard_label_info  " + 
            " ${ew.customSqlSegment}  ")
    List<DoctorLabelPatientDiseaseDataVO> queryLabelList(@Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientDiseaseDataVO> wrapper);

    // 查询医生id
    @Select(" SELECT id " + 
            " FROM sys_user  " + 
            " ${ew.customSqlSegment}  ")
    List<String> queryDoctorList(@Param(Constants.WRAPPER) Wrapper<String> wrapper);

    // 统计排除原因查询
//     @Select(" SELECT remark as excludeReason, COUNT(1) as excludeCount " + 
//             " FROM hd_doctor_manage_patient_info " + 
//             " ${ew.customSqlSegment} " + 
//             " GROUP BY remark ")
//     List<DoctorLabelPatientExcludeStatisticVO> queryManagePatientList(@Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientExcludeStatisticVO> wrapper);

}
