package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.LabelRecordBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorLabelPatientFullVO;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

public interface LabelBizQueryMapper {

    /**
     * wjj:
     * */
    @Select(" SELECT a.id as id,a.patient_id as patientId ,b.name as labelName ,a.label_id as labelId ," +
            " a.op_date as opDate FROM h_patient_label_history_info  a   INNER JOIN s_md_standard_label_info b " +
            " on ( a.label_id =b.id)  ${ew.customSqlSegment} ")
    public List<LabelRecordBO> queryLabelList(@Param(Constants.WRAPPER) Wrapper<LabelRecordBO> wrapper);

    /**
     * 患者当前标签信息分页
     */
    @Select(" SELECT b.id as patientLabelId, a.patient_id as patientId, a.patient_name as patientName, a.id_card_no as idCardNo, a.patient_gender_standard as patientGenderStandard, " + 
            " a.birthday, a.phone, a.link_phone, a.home_phone, a.work_phone, b.label_id as labelId, b.data_dt as dataDt " +
            " FROM h_patient_label_info b  " + 
            " INNER JOIN hd_task_patient_info a ON (a.patient_id = b.patient_id) " +
            " ${ew.customSqlSegment} ")
    public IPage<DoctorLabelPatientFullVO> pageLabelPatient(Page<DoctorLabelPatientFullVO> page, @Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientFullVO> wrapper);

    /**
     * 患者当前标签信息列表
     */
    @Select(" SELECT a.id as patientLabelId, a.patient_id as patientId, a.patient_name as patientName, a.id_card_no as idCardNo, a.patient_gender_standard as patientGenderStandard, " + 
            " a.birthday, a.phone, b.label_id as labelId, b.data_dt as dataDt " +
            " FROM h_patient_label_info b " + 
            " INNER JOIN hd_task_patient_info a ON (a.patient_id = b.patient_id) " +
            " ${ew.customSqlSegment} ")
    public List<DoctorLabelPatientFullVO> listLabelPatient(@Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientFullVO> wrapper);

    /**
     * 患者历史标签信息分页
     */
    @Select(" SELECT b.id as patientLabelId, a.patient_id as patientId, a.patient_name as patientName, a.id_card_no as idCardNo, a.patient_gender_standard as patientGenderStandard, " + 
            " a.birthday, a.phone, b.label_id as labelId, b.data_dt as dataDt " +
            " FROM h_patient_label_history_info b  " + 
            " INNER JOIN hd_task_patient_info a ON (a.patient_id = b.patient_id) " +
            " ${ew.customSqlSegment} ")
    public IPage<DoctorLabelPatientFullVO> pageHistoryLabelPatient(Page<DoctorLabelPatientFullVO> page, @Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientFullVO> wrapper);

    /**
     * 患者历史标签信息列表
     */
    @Select(" SELECT a.id as patientLabelId, a.patient_id as patientId, a.patient_name as patientName, a.id_card_no as idCardNo, a.patient_gender_standard as patientGenderStandard, " + 
            " a.birthday, a.phone, b.label_id as labelId, b.data_dt as dataDt " +
            " FROM h_patient_label_history_info b " + 
            " INNER JOIN hd_task_patient_info a ON (a.patient_id = b.patient_id) " +
            " ${ew.customSqlSegment} ")
    public List<DoctorLabelPatientFullVO> listHistoryLabelPatient(@Param(Constants.WRAPPER) Wrapper<DoctorLabelPatientFullVO> wrapper);

    @Select(" SELECT a.label_id as labelId, COUNT(1) as patientNum " +
            " FROM h_patient_label_info  a " + 
            " ${ew.customSqlSegment} " + 
            " GROUP BY a.label_id ")
    public List<Map<String, Object>> listLabelPatientNum(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    @Select(" SELECT label_id as labelId, COUNT(1) as patientNum " +
            " FROM h_patient_label_history_info " + 
            " ${ew.customSqlSegment} ")
    public List<Map<String, String>> listHistoryLabelPatientStat(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

}
