package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.PatientDiseaseDataOneDayInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;

/**
 * 20231012
 */
public interface PatientDiseaseDataQueryBizMapper {
    
    /**
     * 统计某病种下标签用户数量
     * 本统计数据在某病种下以患者历史标签为主进行统计
     */
    // @Select("select e.dept_id deptId, e.disease_id, COUNT(e.dept_id) `num` " + 
    //         " FROM " +
    //         "        (SELECT DISTINCT a.patient_id, f.id disease_id, b.dept_id " +
    //         "            FROM h_patient_label_history_info a " +
    //         "            INNER JOIN hd_task_dept_patient_relation_info b ON a.patient_id = b.patient_id " +
    //         "            INNER JOIN s_md_standard_label_info d ON a.label_id = d.id " +
    //         "            LEFT JOIN s_md_standard_disease_info f ON d.disease_ids LIKE CONCAT('%,', f.id, ',%') " +
    //         "            ${ew.customSqlSegment} " +
    //         "        ) e " +
    //         " GROUP BY e.dept_id, e.disease_id ")
    // List<PatientDiseaseDataOneDayInfo> patientDiseaseStatistic(@Param(Constants.WRAPPER) Wrapper<PatientDiseaseDataOneDayInfo> wrapper);

    /**
     * 统计标签下用户数量
     */
    @Select("SELECT COUNT(a.patient_id) `num` " + 
            " FROM h_patient_label_history_info a  " +
            " ${ew.customSqlSegment} ")
    PatientDiseaseDataOneDayInfo patientLabelStatistic(@Param(Constants.WRAPPER) Wrapper<PatientDiseaseDataOneDayInfo> wrapper);

    /**
     * 统计标签下用户列表
     */
    // @Select("SELECT DISTINCT b.* " + 
    //         " FROM h_patient_label_history_info a  " +
    //         " INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id " +
    //         " ${ew.customSqlSegment} ")
    // IPage<TaskPatientInfo> patientLabelStatisticList(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);
    @Select("SELECT DISTINCT a.patient_id " + 
            " FROM h_patient_label_history_info a  " +
            " ${ew.customSqlSegment} ")
    IPage<TaskPatientInfo> patientLabelStatisticList(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<TaskPatientInfo> wrapper);


    /**
     * 统计某病种下服务推送的次数
     * 本统计数据在某病种下以患者日程为主进行统计
     * 
     * 患者与医生部门有两种绑定关系：
     * 1. 部门患者关系表，此表数据来源于就诊
     * 2. 部门标签关系表，此部门标签如果与患者标签对应则该部门也可以查看该患者信息
     */
    // @Select("select e.dept_id deptId, e.disease_id, COUNT(e.dept_id) `num` " + 
    //         " FROM " +
    //         "        (SELECT DISTINCT a.id, f.id disease_id, IF(b.dept_id IS NULL, c.dept_id, b.dept_id) dept_id " +
    //         "            FROM h_patient_schedule_info a " +
    //         "            INNER JOIN h_patient_label_history_info d ON a.patient_id = d.patient_id " +
    //         "            LEFT JOIN hd_task_dept_patient_relation_info b ON a.patient_id = b.patient_id " +
    //         "            LEFT JOIN hd_task_dept_label_relation_info c ON a.label_id = c.label_id " +
    //         "            LEFT JOIN s_md_standard_disease_info f ON d.disease_ids LIKE CONCAT('%,', f.id, ',%') " +
    //         "            ${ew.customSqlSegment} " +
    //         "        ) e " +
    //         " GROUP BY e.dept_id, e.disease_id")
    // List<PatientDiseaseDataOneDayInfo> patientPushServeStatistic(@Param(Constants.WRAPPER) Wrapper<PatientDiseaseDataOneDayInfo> wrapper);

}
