package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DeptPushServeVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientBehaviorDataVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServeUserVO;

/**
 * 20231016
 */
public interface PatientPushServeDataQueryBizMapper {
    
    /**
     * 查询部门服务
     * 
     * 注意：
     * 服务与部门没有绑定关系
     * 当服务病种与部门病种有交叉则认为部门绑定了该服务
     */
    @Select(" SELECT DISTINCT c.id dept_id, a.id push_serve_id, a.name, a.media_id, a.media_name, a.media_type, a.type, a.title, a.status, a.disease_ids " +
                "  FROM h_push_serve_config_info a " +
                "  INNER JOIN s_md_standard_disease_info b ON a.rows_status = 'Y' AND b.rows_status = 'Y' AND a.disease_ids LIKE CONCAT('%,', b.id, ',%') " +
                "  INNER JOIN sys_dept c ON c.disease_ids LIKE CONCAT('%,', b.id, ',%')")
    List<DeptPushServeVO> deptPushServeList(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 分组统计服务人次
     */
    // @Select(" SELECT b.push_serve_id pushServeId, COUNT(1) count " + 
    //             "  FROM h_patient_schedule_info a " +
    //             "  INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id AND a.patient_id = b.patient_id " +
    //             "  ${ew.customSqlSegment} " + 
    //             "  GROUP BY b.push_serve_id ")
    // List<Map<String, Object>> deptPushServeCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    // 从提醒表中统计服务人次
    @Select(" SELECT b.push_serve_id pushServeId, COUNT(1) count " + 
                "  FROM h_patient_remind_info a " +
                "  INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.biz_id = b.patient_push_serve_id " +
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY b.push_serve_id ")
    List<Map<String, Object>> deptPushServeRemindCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    // 从日程表中统计当前时间之前的服务人次
    @Select(" SELECT b.push_serve_id pushServeId, COUNT(1) count " + 
                "  FROM h_patient_schedule_info a " +
                "  INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.biz_id = b.patient_push_serve_id " +
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY b.push_serve_id ")
    List<Map<String, Object>> deptPushServeScheduleCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    // 从行为表中的日程浏览数据统计服务人次
    @Select(" SELECT a.source_three_id pushServeId, COUNT(1) count " + 
                "  FROM ( " +
                "    SELECT a.source_three_id, a.user_id, a.source_one_id " +
                "    FROM hb_patient_behavior_info a " +
                "    INNER JOIN h_patient_schedule_info b ON a.source_one_id = b.id  " +
                "    ${ew.customSqlSegment} " +
                "    GROUP BY a.source_three_id, a.user_id, a.source_one_id " +
                "  ) a " + 
                "  GROUP BY a.source_three_id ")
    List<Map<String, Object>> deptPushServeScheduleVisitCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);// 从行为表中的日程浏览数据统计服务人次
    // @Select(" SELECT b.push_serve_id pushServeId, COUNT(1) count " + 
    //             "  FROM hb_patient_behavior_info a " +
    //             "  INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.source_two_id = b.patient_push_serve_id " +
    //             "  ${ew.customSqlSegment} " + 
    //             "  GROUP BY b.push_serve_id ")
    // List<Map<String, Object>> deptPushServeBehaviorCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    @Select(" SELECT a.source_three_id pushServeId, COUNT(1) count " + 
                "  FROM hb_patient_behavior_info a " +
                // "  INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.source_two_id = b.patient_push_serve_id " +
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.source_three_id ")
    List<Map<String, Object>> deptPushServeBehaviorCountMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);


    
    /**
     * 分组统计未关注人数发送失败
     */
    // @Select("SELECT c.push_serve_id pushServeId, COUNT(1) `count`  " + 
    //             "  FROM ( " + 
    //             "    SELECT DISTINCT b.push_serve_id, a.user_id " + 
    //             "    FROM hp_push_weixin_log a  " + 
    //             "    INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id AND a.user_id = b.patient_id AND a.biz_one_type = 'patient_push_serve' " +
    //             "    ${ew.customSqlSegment} " + 
    //             "  ) c " + 
    //             "  GROUP BY c.push_serve_id")
    // List<Map<String, Object>> notFollowingPushFailNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    @Select("SELECT b.push_serve_id pushServeId, COUNT(1) `count`  " + 
                "  FROM h_patient_remind_info a  " + 
                "  INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id " +
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY b.push_serve_id")
    List<Map<String, Object>> notFollowingPushFailNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);

    // 统计未关注发送失败用户 
    @Select("SELECT c.id, c.relation_name as relationName, c.pat_his_no as patientId, c.name as patientName, c.mobile, c.gender as patientGenderStandard, c.mobile as phone, c.birthday, c.card_no as idCardNo " + 
                "  FROM h_patient_remind_info a  " + 
                "  INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id " +
                "  INNER JOIN cust_customer_family_member_info c ON a.user_id = c.user_id AND a.patient_id = c.pat_his_no " +
                "  ${ew.customSqlSegment} ")
    IPage<PushServeUserVO> notFollowingPushFailUserList(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 分组统计发送失败次数
     */
    // @Select("SELECT c.push_serve_id pushServeId, COUNT(1) `count`  " + 
    //             "  FROM ( " + 
    //             "    SELECT b.push_serve_id, a.user_id " + 
    //             "    FROM hp_push_weixin_log a  " + 
    //             "    INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id AND a.user_id = b.patient_id AND a.biz_one_type = 'patient_push_serve' " +
    //             "    ${ew.customSqlSegment} " + 
    //             "  ) c " + 
    //             "  GROUP BY c.push_serve_id")
    // List<Map<String, Object>> pushFailNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    @Select("SELECT b.push_serve_id pushServeId, COUNT(1) `count`  " + 
                "  FROM h_patient_remind_info a  " + 
                "  INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id " +
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY b.push_serve_id")
    List<Map<String, Object>> pushFailNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);

    // 统计发送失败用户
    @Select("SELECT c.id, c.relation_name as relationName, c.pat_his_no as patientId, c.name as patientName, c.mobile, c.gender as patientGenderStandard, c.mobile as phone, c.birthday, c.card_no as idCardNo  " + 
                "  FROM h_patient_remind_info a  " + 
                "  INNER JOIN h_patient_push_serve_history_info b ON a.biz_id = b.patient_push_serve_id " +
                "  INNER JOIN cust_customer_family_member_info c ON a.user_id = c.user_id AND a.patient_id = c.pat_his_no " +
                "  ${ew.customSqlSegment} ")
    IPage<PushServeUserVO> pushFailUserList(Page<TaskPatientInfo> page, @Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 分组统计点击行动埋点次数
     */
    // @Select("SELECT b.source_three_id pushServeId, COUNT(1) `count`  " + 
    //             "  FROM ( " + 
    //             "    SELECT a.source_three_id " + 
    //             "    FROM hb_patient_behavior_info a  " + 
    //             "    ${ew.customSqlSegment} " + 
    //             "  ) b " + 
    //             "  GROUP BY b.source_three_id")
    // List<Map<String, Object>> behaviorNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    @Select("SELECT a.source_three_id pushServeId, COUNT(1) `count`  " + 
                "  FROM hb_patient_behavior_info a  " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.source_three_id")
    List<Map<String, Object>> behaviorNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 分组统计阅读时间时长
     */
    @Select("SELECT a.source_three_id pushServeId, SUM(a.operated_duration) `sum`  " + 
                "  FROM hb_patient_behavior_info a  " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.source_three_id")
    List<Map<String, Object>> browseDurationMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 行为人数
     */
    @Select("SELECT a.source_three_id pushServeId, COUNT(1) `count`  " + 
                "  FROM (  " + 
                    "  SELECT a.source_three_id, a.user_id userId  " + 
                    "  FROM hb_patient_behavior_info a  " + 
                    "  ${ew.customSqlSegment} " + 
                    "  GROUP BY a.source_three_id, a.user_id " + 
                "  ) a GROUP BY a.source_three_id")
    List<Map<String, Object>> behaviorUserNumMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);

    /**
     * 查询用户阅读行为记录
     */
    @Select("SELECT a.patient_id patientId, a.source_three_id pushServeId, a.operated_start_date operatedDate " + 
                "  FROM hb_patient_behavior_info a " + 
                "  INNER JOIN ( " + 
                "      SELECT b.user_id, b.source_three_id, MIN(b.operated_start_date) operated_start_date " + 
                "      FROM hb_patient_behavior_info b " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY b.user_id, b.source_three_id " + 
                // "  ) c ON a.patient_id = c.patient_id AND a.source_three_id = c.source_three_id AND c.operated_start_date = a.operated_start_date")
                "  ) c ON a.user_id = c.user_id AND a.source_three_id = c.source_three_id AND c.operated_start_date = a.operated_start_date")
    List<Map<String, Object>> patientBrowseMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 查询用户阅读行为记录2
     */
    @Select("SELECT a.patient_id patientId, a.source_one_id sourceOneId, a.operated_start_date operatedDate " + 
                "  FROM hb_patient_behavior_info a " + 
                "  INNER JOIN ( " + 
                "      SELECT b.user_id, b.source_one_id, MIN(b.operated_start_date) operated_start_date " + 
                "      FROM hb_patient_behavior_info b " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY b.user_id, b.source_one_id " + 
                "  ) c ON a.user_id = c.user_id AND a.source_one_id = c.source_one_id AND c.operated_start_date = a.operated_start_date")
    List<Map<String, Object>> patientBrowseMap2(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 查询用户感兴趣行为记录
     */
    @Select("SELECT a.source_three_id pushServeId, a.user_id userId " + 
                "  FROM hb_patient_behavior_info a " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.user_id, a.source_three_id ") 
    List<Map<String, Object>> patientInterestedMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 按天进行行为分析
     */
    @Select("SELECT DATE_FORMAT(a.operated_start_date, '%Y-%m-%d') `date`, count(1) `count` " + 
                "  FROM hb_patient_behavior_info a " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY DATE_FORMAT(a.operated_start_date, '%Y-%m-%d') ")
    List<PatientBehaviorDataVO> behaviorCountByDayMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 统计某病种下标签用户数量
     * 本统计数据在某病种下以患者历史标签为主进行统计
     */
//     @Select("select e.dept_id deptId, e.disease_id, COUNT(e.dept_id) `num` " + 
//             " FROM " +
//             "        (SELECT DISTINCT a.patient_id, f.id disease_id, b.dept_id " +
//             "            FROM h_patient_label_history_info a " +
//             "            INNER JOIN hd_task_dept_patient_relation_info b ON a.patient_id = b.patient_id " +
//             "            INNER JOIN s_md_standard_label_info d ON a.label_id = d.id " +
//             "            LEFT JOIN s_md_standard_disease_info f ON f.rows_status = 'Y' AND d.disease_ids LIKE CONCAT('%,', f.id, ',%') " +
//             "            ${ew.customSqlSegment} " +
//             "        ) e " +
//             " GROUP BY e.dept_id, e.disease_id ")
//     List<PatientPushServeDataOneDayInfo> patientPushServeStatistic(@Param(Constants.WRAPPER) Wrapper<PatientPushServeDataOneDayInfo> wrapper);

    /**
     * 查询用户阅读行为记录
     */
    @Select(" SELECT a.user_id userId, a.source_one_id sourceOneId, MIN(a.operated_start_date) operatedDate " + 
                "      FROM hb_patient_behavior_info a " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY a.user_id, a.source_one_id ")
    List<Map<String, Object>> userBrowseMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 查询用户感兴趣行为记录
     */
    @Select("SELECT a.source_one_id sourceOneId, a.user_id userId " + 
                "  FROM hb_patient_behavior_info a " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.user_id, a.source_one_id ") 
    List<Map<String, Object>> userInterestedMap(@Param(Constants.WRAPPER) Wrapper<DeptPushServeVO> wrapper);
    
    /**
     * 查询用户感兴趣行为记录
     */
    @Select("SELECT a.biz_day " + 
                "  FROM hd_patient_push_service_data_one_day_info a " + 
                "  ORDER BY a.biz_day DESC " + 
                "  LIMIT 1 ") 
    String lastPatientPushServiceDataOneDayDate();
    
}
