package com.xxh.cloud.healthy.data.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;

public interface PatientRuleTaskMapper {

    // 患者待执行事件列表
    @Delete(" DELETE FROM xe_patient_event_rule_ing_info ${ew.customSqlSegment} ")
    public Integer deleteXePatientEventRuleIngInfo(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 患者待执行规则列表
    @Delete(" DELETE FROM xe_patient_flow_rule_ing_info ${ew.customSqlSegment} ")
    public Integer deleteXePatientFlowRuleIngInfo(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 患者历史数据标签规则待执行列表
    @Delete(" DELETE FROM xe_patient_his_tag_rule_ing_info ${ew.customSqlSegment} ")
    public Integer deleteXePatientHisTagRuleIngInfo(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 
    @Insert({
        "<script>",
        "INSERT INTO xe_patient_flow_rule_ing_info (id, patient_id, add_time, op_status, op_num, op_time, op_type, scene_type, data_time) VALUES ",
        "<foreach collection='dataList' item='item' index='index' separator=','>",
        "(#{item.id}, #{item.patientId}, #{item.dataDay}, 'none', 0, #{item.dataDay}, 'history', 'register', #{item.dataDay})",
        "</foreach>",
        "</script>"
    })
    public Integer saveXePatientFlowRuleIngInfo(@Param("dataList") List<Map<String, String>> dataList);

}
