package com.xxh.cloud.healthy.data.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.LabelPatientStatDimensionTypeClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.LabelPatientStatisticClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientGetDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DoctorPatientLabelQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorLabelPatientFullVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DiseaseLabelStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;

// 医生数据查询：病种数据、标签数据（根据病种关联出标签）、患者数据（根据标签关联出患者）
public interface DoctorDataQueryService {

    ////// 病种

    /**
     * 医生管理的病种列表
     */
    List<StandardDiseaseBO> diseaseList(String deptId);

    ////// 标签

    /**
     * 医生管理的标签分页
     */
    PageData<LabelBO> labelPage(DoctorPatientLabelQueryDTO params, String deptId);

    /**
     * 医生管理的标签列表
     */
    List<LabelBO> labelList(DoctorPatientLabelQueryDTO params, String deptId);

    /**
     * 病种标签列表
     */
    List<DiseaseLabelStatisticVO> diseaseLabelStatisticList(DoctorPatientLabelQueryDTO params, String deptId);

    ////// 患者

    /**
     * 医生管理的患者分页
     */
    PageData<DoctorLabelPatientFullVO> patientPage(PatientQueryDTO params, String deptId);

    /**
     * 医生管理的患者列表
     */
    List<DoctorLabelPatientFullVO> patientList(PatientQueryDTO params, String deptId);

    /**
     * 医生管理的患者列表
     */
    TaskPatientVO patientDetail(PatientGetDTO params, String deptId);

    ////// 标签患者统计

    /**
     * 医生管理的标签下患者数量列表
     */
    List<LabelPatientStatisticClientBO> labelPatientCountList(DoctorPatientLabelQueryDTO params, String deptId);

    /**
     * 医生管理的标签下患者数量列表
     */
    List<LabelPatientStatDimensionTypeClientBO> statLabelPatientCountList(DoctorPatientLabelQueryDTO params, String deptId);

}
