package com.xxh.cloud.healthy.data.framework.modules.biz.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.data.client.api.bean.bo.*;
import com.xxh.cloud.healthy.data.client.api.bean.dto.*;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DoctorDwdInRecordBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.DoctorDwdInReserveBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.PatientFeeRecordBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.*;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface DoctorDwdPatientDataBizService {

    // 患者信息
    List<DataDwdPatientVO> patientList(DataDwdPatientQueryDTO params);
    
    // 患者挂号信息
    List<DataDwdPatientRegisterVO> patientRegisterList(DataDwdPatientQueryDTO params);
    
    // 患者就诊信息
    List<PatientVisitRecordClientBO> patientVisitList(DataDwdPatientQueryDTO params);

    // 患者住院信息
    List<DataDwdPatientInHospitalVO> patientInHospitalList(DataDwdPatientQueryDTO params);
    
    // 患者住院信息
    List<PatientInpatientRecordClientBO> patientInHospitalClientList(DataDwdPatientQueryDTO params);
    
    // 患者住院申请信息
    List<DataDwdPatientInHospitalApplyVO> patientInHospitalApplyList(DataDwdPatientQueryDTO params);
    
    // 患者住院变更信息
    List<PatientInpatientChangeClientBO> patientInHospitalChangeList(DataDwdPatientQueryDTO params);
    
    

    // 同步患者列表
    List<DataDwdPatientVO> patientSyncList(DataDwdPatientQueryDTO params);

    // 同步挂号患者列表
    List<DataDwdPatientRegisterVO> patientRegisterSyncList(DataDwdPatientQueryDTO params);
    
    // 同步住院患者列表
    List<DataDwdPatientInHospitalVO> patientInHospitalSyncList(DataDwdPatientQueryDTO params);
    
    // 同步住院申请患者列表
    List<DataDwdPatientInHospitalApplyVO> patientInHospitalApplySyncList(DataDwdPatientQueryDTO params);
    



    // 挂号患者
    List<DoctorDwdRegisterRecordVO> queryRegisterList(Date startDate, Date endDate);

    // 住院申请患者
//    List<DoctorDwdInpatientReserveVO> queryInHospitalApplyList(Date startDate, Date endDate);

    /**
     * 查询一天的住院申请信息列表
     * */
    public List<DoctorDwdInReserveBO> queryInApplyList(String date);

    /**
     * 查询一段时间的住院记录信息列表
     * */
    public List<DoctorDwdInRecordBO> queryInRecordList(Date startDate,Date endDate, Set<String> pids);






    
    // 手术申请患者
    List<DoctorDwdOperationApplyVO> queryOperationApplyList(Date startDate, Date endDate);



    // 查询门诊/急诊/住院患者(去重)
    List<String> queryVisitPatientCount(String deptId);

    // 查询挂号/住院/手术申请
    Long queryApplyCount(String deptId);


    List<DoctorDwdPatientVO> queryPatientList(DoctorDwdPatientQueryDTO params);
    DoctorDwdPatientVO getOnePatient(DoctorDwdPatientGetDTO params);

    //todo:del wjj
//    // 住院信息
//    List<DataDwdPatientInHospitalVO> queryInHospitalList(List<String> deptIds, Date startDate, Date endDate);


    Map<String, List<DataDwdLaboratoryReportItemVO>> laboratoryTrend(DataDwdLaboratoryQueryDTO params);





    DataDwsPatientDataLastDateVO getPatientDataLastDateInfo(String patientId);

    List<DataDwsPatientDataLastDateVO> listPatientDataLastDateInfo(List<String> patientIds);

    Map<String, DataDwsPatientDataLastDateVO> mapPatientDataLastDateInfo(List<String> patientIds);



    // 获取患者检查报告
    List<PatientExamineReportClientBO> listExamineReportInfo(PatientExamineAndLaboratoryReportClientDTO params);

    // 获取患者检验报告
    List<PatientLaboratoryReportClientBO> listLaboratoryReportInfo(PatientExamineAndLaboratoryReportClientDTO params);

    // 获取患者用药信息
    List<PatientRecipeMedicineClientBO> listRecipeMedicineInfo(PatientRecipeMedicineClientDTO params);

    // 住院
    List<PatientInpatientRecordClientBO> listPatientInpatient(PatientDataClientDTO params);
    
    // 最新住院
    List<PatientInpatientRecordClientBO> listPatientInpatientInfo(PatientDataClientDTO params);
    
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateInfo(PatientLastDataQueryDTO params);
    
    PatientInpatientRecordClientBO getOnePatientInpatientLastDateInfo(String patientId);

    // 最新住院但未出院
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateAndNotOut(PatientLastDataQueryDTO params);

    // 最新住院且出院
    List<PatientInpatientRecordClientBO> listPatientInpatientLastDateAndOut(PatientLastDataQueryDTO params);

    // 最新出院
    List<PatientDischargeRecordClientBO> listPatientOutpatientInfo(PatientDataClientDTO params);
    
    List<PatientDischargeRecordClientBO> listPatientOutpatientLastDateInfo(PatientLastDataQueryDTO params);
    List<PatientDischargeRecordClientBO> listPatientOutpatientLastDateInfo(List<String> patientIds);
    // 最新有随访时间的出院信息
    List<PatientDischargeRecordClientBO> listPatientOutpatientLastDateWitiSFSJInfo(PatientLastDataQueryDTO params);

    PatientDischargeRecordClientBO getOnePatientOutpatientLastDateInfo(String patientId);

    // 最新就诊
    List<PatientVisitRecordClientBO> listPatientVisitInfo(PatientDataClientDTO params);

    List<PatientVisitRecordClientBO> listPatientVisitLastDateInfo(List<String> patientIds);

    PatientVisitRecordClientBO getOnePatientVisitLastDateInfo(String patientId);


    // 查询每日患者变化数据表
    IPage<String> pagePatientChangeDateInfo(Page<Void> page, String startDate, String endDate);
    IPage<Map<String, String>> pagePatientChangeDateMapInfo(Page<Void> page, String startDate, String endDate);
    
    
    // 诊断
    List<PatientDiagnosisReportClientBO> listPatientDiagnosisReportInfo(PatientDiagnosisDataClientDTO params);

    // 诊断
    List<PatientDiagnosisReportClientBO> listPatientDiagnosisReportDistinct(PatientDiagnosisDataClientDTO params);

    // 患者费用数据分页
    PageData<PatientFeeRecordBO> pagePatientFeeRecord(PatientFeeQueryDTO params);

    // 患者费用数据列表
    List<PatientFeeRecordBO> listPatientFeeRecord(PatientFeeQueryDTO params);

    
    // 挂号流失患者
    List<DoctorDwdRegisterRecordVO> queryRegisterLossList(Date startDate, Date endDate);

    // 挂号就诊患者患者，同部门当天有就诊，则不算流失
    List<DoctorDwdRegisterRecordVO> queryRegisterVisitList(Set<String> patientIds, Date startDate, Date endDate);

    // 就诊流失患者
    List<PatientVisitRecordClientBO> queryVisitLossList(Date startDate, Date endDate);

    // 住院流失患者
    List<PatientInpatientReserveClientBO> queryInpatientLossList(Date startDate, Date endDate, Integer inHospitalLostDay);

}
