package com.xxh.cloud.healthy.data.framework.modules.biz.service;

import java.util.List;
import java.util.Map;
import java.util.concurrent.Future;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.PatientDataOneDayInfo;
import com.xxh.cloud.healthy.data.framework.modules.base.entity.TaskPatientInfo;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DeptPushServeVO;

/**
 * 患者数据异步统计
 */
public interface PatientDataQueryAsyncBizService {
    
    Future<Long> deptAllPatientCount(QueryWrapper<TaskPatientInfo> queryWrapper);

    Future<Long> patientLabelCount(QueryWrapper<PatientDataOneDayInfo> queryWrapper);
    
    Future<Long> patientHistoryLabelCount(QueryWrapper<PatientDataOneDayInfo> queryWrapper);
    
    Future<Map<String, Long>> patientHistoryLabelCountV2(QueryWrapper<PatientDataOneDayInfo> queryWrapper);

    Future<Map<String, Long>> patientLabelCountV2(QueryWrapper<PatientDataOneDayInfo> queryWrapper);

    Future<List<Map<String, Object>>> deptPushServeRemindCountMap(QueryWrapper<DeptPushServeVO> queryWrapper);

    Future<List<Map<String, Object>>> deptPushServeScheduleCountMap(QueryWrapper<DeptPushServeVO> queryWrapper);

    Future<List<Map<String, Object>>> deptPushServeBehaviorCountMap(QueryWrapper<DeptPushServeVO> queryWrapper);

}
