package com.xxh.cloud.healthy.data.framework.modules.biz.service;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.PatientStatisticPatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.PatientStatisticQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.PatientStatisticUserQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientAfterStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientDuringStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientPreStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientStatisticVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PushServeUserVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;

/**
 * 患者数据统计
 */
public interface PatientDataQueryBizService {
    
    // 患者数据统计
    PatientStatisticVO patientStatistic(PatientStatisticQueryDTO params);

    // 患者数据统计
    PageData<TaskPatientVO> patientLabelStatisticPatientList(PatientStatisticPatientQueryDTO params);

    // 患者数据统计
    PageData<PushServeUserVO> patientLabelStatisticUserList(PatientStatisticUserQueryDTO params);




    // 根据部门，实时统计患者数据
    PatientPreStatisticVO patientPreStatisticByDeptId(PatientStatisticQueryDTO params); // 诊前
    PatientDuringStatisticVO patientDuringStatisticByDeptId(PatientStatisticQueryDTO params); // 诊中
    PatientAfterStatisticVO patientAfterStatisticByDeptId(PatientStatisticQueryDTO params); // 诊后

    PatientPreStatisticVO patientPreStatisticByDeptIdV2(PatientStatisticQueryDTO params); // 诊前
    PatientDuringStatisticVO patientDuringStatisticByDeptIdV2(PatientStatisticQueryDTO params); // 诊中
    PatientAfterStatisticVO patientAfterStatisticByDeptIdV2(PatientStatisticQueryDTO params); // 诊后

}
