package com.xxh.cloud.healthy.data.framework.modules.biz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.basic.label.client.api.bean.constant.LabelStatDimensionTypeEnum;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.bo.LabelRecordBO;
import com.xxh.cloud.healthy.data.framework.modules.biz.mapper.LabelBizQueryMapper;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.LabelBizQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class LabelBizQueryServiceImpl implements LabelBizQueryService {

    @Autowired
    private LabelBizQueryMapper labelBizQueryMapper;

    @Override
    public List<LabelRecordBO> queryLabel(String date) {
        List<LabelRecordBO> list= labelBizQueryMapper.queryLabelList(
                new QueryWrapper<LabelRecordBO>()
                        .eq("DATE_FORMAT(a.op_date,'%Y-%m-%d')",date)
                        .eq("a.op_type", OpTypeEnum.Create.getCode())
                        .eq("b.rows_status", YN.YES.getCode())
                        .eq("b.stat_dimension_type", LabelStatDimensionTypeEnum.LSD_During_InHospital.getCode())
        );
        return list;
    }


}
