package com.xxh.cloud.healthy.data.framework.modules.biz.service.impl;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdLaboratoryReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdPatientDataQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdLaboratoryReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdPatientArchiveDataVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdPatientDataVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdLaboratoryReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.PatientDwdDataBizService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.data.client.api.constant.PatientDataOperatedTypeEnum;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DataArticleExamineQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.TaskPatientGetDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DeptPushServeVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.PatientArchivesVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.mapper.PatientPushServeDataQueryBizMapper;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.PatientArchivesQueryBizService;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.TaskPatientQueryBizService;
import com.xxh.cloud.healthy.mdt.api.ConsultationClientService;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.mdt.api.bean.dto.ConsultationQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.PatientPushServeClientService;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientPushServeClientBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientRemindBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientPushServeQueryClientDTO;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class PatientArchivesQueryBizServiceImpl implements PatientArchivesQueryBizService {

    @Autowired
    private PatientDwdDataBizService patientDwdDataBizService;
    @Autowired
    private PatientPushServeClientService patientPushServeClientService;
    @Autowired
    private PatientPushServeDataQueryBizMapper patientPushServeDataQueryBizMapper;
    @Autowired
    private TaskPatientQueryBizService taskPatientQueryBizService;
    @Autowired
    private ConsultationClientService consultationClientService;
    @Autowired
    private DwdExamineReportBizService dwdExamineReportBizService;
    @Autowired
    private DwdLaboratoryReportBizService dwdLaboratoryReportBizService;

    @Deprecated
    @Override
    public PatientArchivesVO patientArchives(DwdPatientDataQueryDTO params) {
        if (StrUtil.isBlank(params.getPatientId())) {
            return null;
        }
        if (StrUtil.isBlank(params.getQueryDate()) && StrUtil.isNotBlank(params.getEndDate())) {
            params.setQueryDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }
        String patientId = params.getPatientId(); // 防止之后params中的patientId变为null
        
        PatientArchivesVO vo = new PatientArchivesVO();

        log.info("1.档案查询参数>>>>>> params={}", JSON.toJSONString(params));
        List<DwdPatientDataVO> data = patientDwdDataBizService.list(params);

        params.setPatientId(patientId);

        // // 查询患者的服务信息
        // if (CollectionUtil.isNotEmpty(data)) {
        //     // 获取本次查询的档案的开始时间于结束时间
        //     Date startDate = null;
        //     Date endDate = null;
        //     if (StrUtil.isNotBlank(params.getQueryDate())) {
        //         endDate = DateUtil.parseDate(params.getQueryDate());
        //     }

        //     DwdPatientDataVO lastVO = data.get(data.size() - 1);
        //     if (null != lastVO.getDwdVisitRecordVO()) {
        //         startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
        //     } else if (null != lastVO.getDwdInpatientRecordVO()) {
        //         startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
        //     }

        //     List<PatientPushServeClientBO> patientPushServeClientBOs = new ArrayList<>();

        //     // 查询服务推送日期
        //     PatientPushServeDateQueryClientDTO patientPushServeDateQueryClientDTO = new PatientPushServeDateQueryClientDTO();
        //     patientPushServeDateQueryClientDTO.setPatientId(params.getPatientId());
        //     patientPushServeDateQueryClientDTO.setStartDate(startDate);
        //     patientPushServeDateQueryClientDTO.setEndDate(endDate);
        //     List<PatientPushServeDateClientBO> pushServeDateList = patientPushServeClientService.pushServeDateList(patientPushServeDateQueryClientDTO);

        //     List<String> patientPushServeIds = new ArrayList<>();
        //     pushServeDateList.forEach(i -> i.getPatientPushServeId());

        //     PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
        //     patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
        //     patientPushServeQueryClientDTO.setPatientPushServeIds(patientPushServeIds);
        //     log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
        //     List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

        //     if (CollectionUtil.isNotEmpty(patientPushServeList)) {
        //         Map<String, PatientPushServeClientBO> patientPushServeClientBOMap = new HashMap<>();
        //         patientPushServeList.forEach(i -> {
        //             patientPushServeClientBOMap.put(i.getId(), i);
        //         });

        //         // 一个服务可以推送多次，推送几次就返回几条服务
        //         pushServeDateList.forEach(i -> {
        //             PatientPushServeClientBO bo = patientPushServeClientBOMap.get(i.getPatientPushServeId());
        //             PatientPushServeClientBO clientBO = new PatientPushServeClientBO();
        //             BeanUtil.copyProperties(bo, clientBO);
        //             clientBO.setSendDate(DateUtil.format(i.getSendDate(), "yyyy-MM-dd HH:mm:ss"));
        //             patientPushServeClientBOs.add(clientBO);
        //         });

        //         // 查询推送服务是否被阅读过
        //         Map<String, String> patientBrowseMap = new HashMap<>();

        //         List<String> patientPushServeIdAndSendDate = new ArrayList<>();
        //         patientPushServeClientBOs.forEach(i -> patientPushServeIdAndSendDate.add(i.getId() + "-" + i.getSendDate()));

        //         // 查询日程
        //         Map<String, String> scheduleDateMap = new HashMap<>();

        //         PatientScheduleQueryClientDTO scheduleQueryClientDTO = new PatientScheduleQueryClientDTO();
        //         scheduleQueryClientDTO.setBizIdAndScheduleDate(patientPushServeIdAndSendDate);
        //         List<PatientScheduleBO> scheduleBOList = patientPushServeClientService.patientScheduleBOList(scheduleQueryClientDTO);
        //         if (CollectionUtil.isNotEmpty(scheduleBOList)) { 
        //             List<String> scheduleIds = new ArrayList<>();
        //             scheduleBOList.forEach(i -> {
        //                 scheduleDateMap.put(i.getBizId(), DateUtil.format(i.getScheduleDate(), "yyyy-MM-dd HH:mm:ss"));
        //                 scheduleIds.add(i.getId());
        //             });
        //             // 根据日程查询
        //             List<Map<String, Object>> schedulePatientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap2(new QueryWrapper<DeptPushServeVO>()
        //                     .in(CollectionUtil.isNotEmpty(scheduleIds), "b.source_one_id", scheduleIds)
        //                     .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
        //                     .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
        //             );
        //             if (CollectionUtil.isNotEmpty(schedulePatientBrowseList)) {
        //                 schedulePatientBrowseList.forEach(i -> {
        //                     String scheduleId = i.get("sourceOneId").toString();
        //                     // String patientId = i.get("patientId").toString();

        //                     String operatedDate = null;
        //                     Object date = i.get("operatedDate");
        //                     if (null != date) {
        //                         if (date instanceof LocalDateTime) {
        //                             LocalDateTime ldt = (LocalDateTime) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        //                         } else if (date instanceof LocalDate) {
        //                             LocalDate ldt = (LocalDate) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        //                         }
        //                     }

        //                     String scheduleDate = scheduleDateMap.get(scheduleId);
        //                     if (StrUtil.isNotBlank(scheduleDate)) {
        //                         String opDate = patientBrowseMap.get(scheduleId + "-" + scheduleDate);
        //                         if (opDate == null || opDate.compareTo(operatedDate) > 0) {
        //                             patientBrowseMap.put(scheduleId + "-" + scheduleDate, operatedDate);
        //                         }
        //                     }
        //                 });
        //             }
        //         }

        //         // 查询提醒
        //         Map<String, String> remindDateMap = new HashMap<>();

        //         PatientRemindQueryClientDTO remindQueryClientDTO = new PatientRemindQueryClientDTO();
        //         remindQueryClientDTO.setBizIdAndPushDate(patientPushServeIdAndSendDate);
        //         List<PatientRemindBO> remindBOList = patientPushServeClientService.patientRemindBOList(remindQueryClientDTO);
        //         if (CollectionUtil.isNotEmpty(remindBOList)) {
        //             List<String> remindIds = new ArrayList<>();
        //             remindBOList.forEach(i -> {
        //                 remindDateMap.put(i.getBizId(), DateUtil.format(i.getPushDate(), "yyyy-MM-dd HH:mm:ss"));
        //                 remindIds.add(i.getId());
        //             });
        //             // 根据提醒查询
        //             List<Map<String, Object>> remindPatientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap2(new QueryWrapper<DeptPushServeVO>()
        //                     .in(CollectionUtil.isNotEmpty(remindIds), "b.source_one_id", remindIds)
        //                     .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
        //                     .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
        //             );
        //             if (CollectionUtil.isNotEmpty(remindPatientBrowseList)) {
        //                 remindPatientBrowseList.forEach(i -> {
        //                     String remindId = i.get("sourceOneId").toString();
        //                     // String patientId = i.get("patientId").toString();

        //                     String operatedDate = null;
        //                     Object date = i.get("operatedDate");
        //                     if (null != date) {
        //                         if (date instanceof LocalDateTime) {
        //                             LocalDateTime ldt = (LocalDateTime) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        //                         } else if (date instanceof LocalDate) {
        //                             LocalDate ldt = (LocalDate) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        //                         }
        //                     }

        //                     String remindDate = remindDateMap.get(remindId);
        //                     if (StrUtil.isNotBlank(remindDate)) {
        //                         String opDate = patientBrowseMap.get(remindId + "-" + remindDate);
        //                         if (opDate == null || opDate.compareTo(operatedDate) > 0) {
        //                             patientBrowseMap.put(remindId + "-" + remindDate, operatedDate);
        //                         }
        //                     }
        //                 });
        //             }
        //         }

        //         patientPushServeClientBOs.forEach(i -> {
        //             String operatedDate = patientBrowseMap.get(i.getId() + "-" + i.getSendDate());
        //             if (StrUtil.isNotBlank(operatedDate)) {
        //                 i.setReadDate(DateUtil.parseDateTime(operatedDate));
        //                 i.setRead(YN.YES.getCode());
        //             }

        //             if (StrUtil.isNotBlank(i.getSendDate())) {
        //                 i.setCreateDate(DateUtil.parseDateTime(i.getSendDate()));
        //             }
        //         });
        //     }

        //     vo.setPatientPushServeList(patientPushServeClientBOs);
        
        // 查询患者的服务信息
        if (CollectionUtil.isNotEmpty(data)) {
            // 获取本次查询的档案的开始时间于结束时间
            Date startDate = null;
            Date endDate = null;
            if (StrUtil.isNotBlank(params.getQueryDate())) {
                endDate = DateUtil.parseDate(params.getQueryDate());
            }

            DwdPatientDataVO lastVO = data.get(data.size() - 1);
            if (null != lastVO.getDwdVisitRecordVO()) {
                startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
            } else if (null != lastVO.getDwdInpatientRecordVO()) {
                startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
            }

            PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
            patientPushServeQueryClientDTO.setPatientId(params.getPatientId());
            patientPushServeQueryClientDTO.setStartDate(startDate);
            patientPushServeQueryClientDTO.setEndDate(endDate);
            patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
            log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
            List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

            // 查询推送服务是否被阅读过
            if (CollectionUtil.isNotEmpty(patientPushServeList)) {
                List<String> pushServeIds = new ArrayList<>();
                patientPushServeList.forEach(i -> {
                    pushServeIds.add(i.getPushServeId());
                });

                List<Map<String, Object>> patientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
                        .in(CollectionUtil.isNotEmpty(pushServeIds), "b.source_three_id", pushServeIds)
                        .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                        .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
                );
                Map<String, String> patientBrowseMap = new HashMap<>();
                if (CollectionUtil.isNotEmpty(patientBrowseList)) {
                    patientBrowseList.forEach(i -> {
                        String patientPushServeId = i.get("patientId").toString() + "-" + i.get("pushServeId").toString();

                        String operatedDate = null;
                        Object date = i.get("operatedDate");
                        if (null != date) {
                            if (date instanceof LocalDateTime) {
                                LocalDateTime ldt = (LocalDateTime) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                            } else if (date instanceof LocalDate) {
                                LocalDate ldt = (LocalDate) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
                            }
                        }

                        patientBrowseMap.put(patientPushServeId, operatedDate);
                    });
                }

                patientPushServeList.forEach(i -> {
                    String operatedDate = patientBrowseMap.get(i.getPatientId() + "-" + i.getPushServeId());
                    if (StrUtil.isNotBlank(operatedDate)) {
                        i.setReadDate(DateUtil.parseDateTime(operatedDate));
                        i.setRead(YN.YES.getCode());
                    }
                });
            }

            vo.setPatientPushServeList(patientPushServeList);
        }

        vo.setDwdPatientDataList(data);
        return vo;
    }

    @Override
    public PatientArchivesVO patientArchivesV2(DwdPatientDataQueryDTO params) {
        if (StrUtil.isBlank(params.getPatientId())) {
            return null;
        }
        if (StrUtil.isBlank(params.getQueryDate()) && StrUtil.isNotBlank(params.getEndDate())) {
            params.setQueryDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        // 查询主患者id，用于查询患者体检信息
        TaskPatientGetDTO taskPatientGetDTO = new TaskPatientGetDTO();
        taskPatientGetDTO.setPatientId(params.getPatientId());
        TaskPatientVO patient = taskPatientQueryBizService.getOneSimple(taskPatientGetDTO);
        if (null == patient) {
            return null;
        }
        params.setMainPersonId(patient.getMainPersonId());

        PatientArchivesVO vo = new PatientArchivesVO();

        log.info("1.档案查询参数>>>>>> params={}", JSON.toJSONString(params));
        List<DwdPatientDataVO> data = patientDwdDataBizService.listV2(params);

        // // 查询患者的服务信息
        // if (CollectionUtil.isNotEmpty(data)) {
        //     // 获取本次查询的档案的开始时间于结束时间
        //     Date startDate = null;
        //     Date endDate = null;
        //     if (StrUtil.isNotBlank(params.getQueryDate())) {
        //         endDate = DateUtil.parseDate(params.getQueryDate());
        //     }

        //     DwdPatientDataVO lastVO = data.get(data.size() - 1);
        //     if (null != lastVO.getDwdVisitRecordVO()) {
        //         startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
        //     } else if (null != lastVO.getDwdInpatientRecordVO()) {
        //         startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
        //     }

        //     List<PatientPushServeClientBO> patientPushServeClientBOs = new ArrayList<>();

        //     // 查询服务推送日期
        //     PatientPushServeDateQueryClientDTO patientPushServeDateQueryClientDTO = new PatientPushServeDateQueryClientDTO();
        //     patientPushServeDateQueryClientDTO.setPatientId(params.getPatientId());
        //     patientPushServeDateQueryClientDTO.setStartDate(startDate);
        //     patientPushServeDateQueryClientDTO.setEndDate(endDate);
        //     List<PatientPushServeDateClientBO> pushServeDateList = patientPushServeClientService.pushServeDateList(patientPushServeDateQueryClientDTO);

        //     List<String> patientPushServeIds = new ArrayList<>();
        //     pushServeDateList.forEach(i -> i.getPatientPushServeId());

        //     PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
        //     patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
        //     patientPushServeQueryClientDTO.setPatientPushServeIds(patientPushServeIds);
        //     log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
        //     List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

        //     if (CollectionUtil.isNotEmpty(patientPushServeList)) {
        //         Map<String, PatientPushServeClientBO> patientPushServeClientBOMap = new HashMap<>();
        //         patientPushServeList.forEach(i -> {
        //             patientPushServeClientBOMap.put(i.getId(), i);
        //         });

        //         // 一个服务可以推送多次，推送几次就返回几条服务
        //         pushServeDateList.forEach(i -> {
        //             PatientPushServeClientBO bo = patientPushServeClientBOMap.get(i.getPatientPushServeId());
        //             PatientPushServeClientBO clientBO = new PatientPushServeClientBO();
        //             BeanUtil.copyProperties(bo, clientBO);
        //             clientBO.setSendDate(DateUtil.format(i.getSendDate(), "yyyy-MM-dd HH:mm:ss"));
        //             patientPushServeClientBOs.add(clientBO);
        //         });

        //         // 查询推送服务是否被阅读过
        //         Map<String, String> patientBrowseMap = new HashMap<>();

        //         List<String> patientPushServeIdAndSendDate = new ArrayList<>();
        //         patientPushServeClientBOs.forEach(i -> patientPushServeIdAndSendDate.add(i.getId() + "-" + i.getSendDate()));

        //         // 查询日程
        //         Map<String, String> scheduleDateMap = new HashMap<>();

        //         PatientScheduleQueryClientDTO scheduleQueryClientDTO = new PatientScheduleQueryClientDTO();
        //         scheduleQueryClientDTO.setBizIdAndScheduleDate(patientPushServeIdAndSendDate);
        //         List<PatientScheduleBO> scheduleBOList = patientPushServeClientService.patientScheduleBOList(scheduleQueryClientDTO);
        //         if (CollectionUtil.isNotEmpty(scheduleBOList)) { 
        //             List<String> scheduleIds = new ArrayList<>();
        //             scheduleBOList.forEach(i -> {
        //                 scheduleDateMap.put(i.getBizId(), DateUtil.format(i.getScheduleDate(), "yyyy-MM-dd HH:mm:ss"));
        //                 scheduleIds.add(i.getId());
        //             });
        //             // 根据日程查询
        //             List<Map<String, Object>> schedulePatientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
        //                     .in(CollectionUtil.isNotEmpty(scheduleIds), "b.source_one_id", scheduleIds)
        //                     .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
        //                     .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
        //             );
        //             if (CollectionUtil.isNotEmpty(schedulePatientBrowseList)) {
        //                 schedulePatientBrowseList.forEach(i -> {
        //                     String scheduleId = i.get("sourceOneId").toString();
        //                     String patientPushServeId = i.get("patientPushServeId").toString();

        //                     String operatedDate = null;
        //                     Object date = i.get("operatedDate");
        //                     if (null != date) {
        //                         if (date instanceof LocalDateTime) {
        //                             LocalDateTime ldt = (LocalDateTime) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        //                         } else if (date instanceof LocalDate) {
        //                             LocalDate ldt = (LocalDate) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        //                         }
        //                     }

        //                     String scheduleDate = scheduleDateMap.get(scheduleId);
        //                     if (StrUtil.isNotBlank(scheduleDate)) {
        //                         String opDate = patientBrowseMap.get(patientPushServeId + "-" + scheduleDate);
        //                         if (opDate == null || opDate.compareTo(operatedDate) > 0) {
        //                             patientBrowseMap.put(patientPushServeId + "-" + scheduleDate, operatedDate);
        //                         }
        //                     }
        //                 });
        //             }
        //         }

        //         // 查询提醒
        //         Map<String, String> remindDateMap = new HashMap<>();

        //         PatientRemindQueryClientDTO remindQueryClientDTO = new PatientRemindQueryClientDTO();
        //         remindQueryClientDTO.setBizIdAndPushDate(patientPushServeIdAndSendDate);
        //         List<PatientRemindBO> remindBOList = patientPushServeClientService.patientRemindBOList(remindQueryClientDTO);
        //         if (CollectionUtil.isNotEmpty(remindBOList)) {
        //             List<String> remindIds = new ArrayList<>();
        //             remindBOList.forEach(i -> {
        //                 remindDateMap.put(i.getBizId(), DateUtil.format(i.getPushDate(), "yyyy-MM-dd HH:mm:ss"));
        //                 remindIds.add(i.getId());
        //             });
        //             // 根据提醒查询
        //             List<Map<String, Object>> remindPatientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
        //                     .in(CollectionUtil.isNotEmpty(remindIds), "b.source_one_id", remindIds)
        //                     .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
        //                     .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
        //             );
        //             if (CollectionUtil.isNotEmpty(remindPatientBrowseList)) {
        //                 remindPatientBrowseList.forEach(i -> {
        //                     String remindId = i.get("sourceOneId").toString();
        //                     // String patientId = i.get("patientId").toString();

        //                     String operatedDate = null;
        //                     Object date = i.get("operatedDate");
        //                     if (null != date) {
        //                         if (date instanceof LocalDateTime) {
        //                             LocalDateTime ldt = (LocalDateTime) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        //                         } else if (date instanceof LocalDate) {
        //                             LocalDate ldt = (LocalDate) date;
        //                             operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        //                         }
        //                     }

        //                     String remindDate = remindDateMap.get(remindId);
        //                     if (StrUtil.isNotBlank(remindDate)) {
        //                         String opDate = patientBrowseMap.get(remindId + "-" + remindDate);
        //                         if (opDate == null || opDate.compareTo(operatedDate) > 0) {
        //                             patientBrowseMap.put(remindId + "-" + remindDate, operatedDate);
        //                         }
        //                     }
        //                 });
        //             }
        //         }

        //         patientPushServeClientBOs.forEach(i -> {
        //             String operatedDate = patientBrowseMap.get(i.getId() + "-" + i.getSendDate());
        //             if (StrUtil.isNotBlank(operatedDate)) {
        //                 i.setReadDate(DateUtil.parseDateTime(operatedDate));
        //                 i.setRead(YN.YES.getCode());
        //             }

        //             if (StrUtil.isNotBlank(i.getSendDate())) {
        //                 i.setCreateDate(DateUtil.parseDateTime(i.getSendDate()));
        //             }
        //         });
        //     }

        //     vo.setPatientPushServeList(patientPushServeClientBOs);
        
        // 查询患者的服务信息
        if (CollectionUtil.isNotEmpty(data)) {
            // 获取本次查询的档案的开始时间于结束时间
            Date startDate = null;
            Date endDate = null;
            if (StrUtil.isNotBlank(params.getQueryDate())) {
                endDate = DateUtil.parseDate(params.getQueryDate());
            }

            DwdPatientDataVO lastVO = data.get(data.size() - 1);
            if (null != lastVO.getDwdVisitRecordVO()) {
                startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
            } else if (null != lastVO.getDwdInpatientRecordVO()) {
                startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
            } else if (null != lastVO.getDwdExaminationPatientVO().getDataCreateDate()) {
                startDate = lastVO.getDwdExaminationPatientVO().getDataCreateDate();
            }

            PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
            patientPushServeQueryClientDTO.setPatientId(params.getPatientId());
            patientPushServeQueryClientDTO.setStartDate(startDate);
            patientPushServeQueryClientDTO.setEndDate(endDate);
            patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
            log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
            List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

            // 查询推送服务是否被阅读过
            if (CollectionUtil.isNotEmpty(patientPushServeList)) {
                List<String> pushServeIds = new ArrayList<>();
                patientPushServeList.forEach(i -> {
                    pushServeIds.add(i.getPushServeId());
                });

                List<Map<String, Object>> patientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
                        .in(CollectionUtil.isNotEmpty(pushServeIds), "b.source_three_id", pushServeIds)
                        .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                        .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
                );
                Map<String, String> patientBrowseMap = new HashMap<>();
                if (CollectionUtil.isNotEmpty(patientBrowseList)) {
                    patientBrowseList.forEach(i -> {
                        String patientPushServeId = i.get("patientId").toString() + "-" + i.get("pushServeId").toString();

                        String operatedDate = null;
                        Object date = i.get("operatedDate");
                        if (null != date) {
                            if (date instanceof LocalDateTime) {
                                LocalDateTime ldt = (LocalDateTime) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                            } else if (date instanceof LocalDate) {
                                LocalDate ldt = (LocalDate) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
                            }
                        }

                        patientBrowseMap.put(patientPushServeId, operatedDate);
                    });
                }

                patientPushServeList.forEach(i -> {
                    String operatedDate = patientBrowseMap.get(i.getPatientId() + "-" + i.getPushServeId());
                    if (StrUtil.isNotBlank(operatedDate)) {
                        i.setReadDate(DateUtil.parseDateTime(operatedDate));
                        i.setRead(YN.YES.getCode());
                    }
                });
            }
            vo.setPatientPushServeList(patientPushServeList);
            
            // 会诊（mdt会诊、普通会诊）
            ConsultationQueryClientDTO consultationQueryClientDTO = new ConsultationQueryClientDTO();
            consultationQueryClientDTO.setPatientId(params.getPatientId());
            consultationQueryClientDTO.setStartDate(startDate);
            consultationQueryClientDTO.setEndDate(endDate);
            List<ConsultationBO> mdtList = consultationClientService.list(consultationQueryClientDTO);
            vo.setMdtConsultationList(mdtList);
        }

        vo.setDwdPatientDataList(data);
        return vo;
    }

    
    @Override
    public PatientArchivesVO patientMergeArchives(DwdPatientDataQueryDTO params) {
        if (StrUtil.isBlank(params.getQueryDate()) && StrUtil.isNotBlank(params.getEndDate())) {
            params.setQueryDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        PatientArchivesVO vo = new PatientArchivesVO();

        log.info("1.档案查询参数>>>>>> params={}", JSON.toJSONString(params));
        DwdPatientArchiveDataVO patientArchiveData = patientDwdDataBizService.patientDataMerge(params);
        if (null == patientArchiveData) {
            return vo;
        }

        List<DwdPatientDataVO> data = patientArchiveData.getDwdPatientDataVOList();

        params.setPatientIds(patientArchiveData.getPatientIds());
        
        if (CollectionUtil.isNotEmpty(data)) {
            // 获取本次查询的档案的开始时间于结束时间
            Date startDate = null;
            Date endDate = null;
            if (StrUtil.isNotBlank(params.getQueryDate())) {
                endDate = DateUtil.parseDate(params.getQueryDate());
            }

            DwdPatientDataVO lastVO = data.get(data.size() - 1);
            if (null != lastVO.getDwdVisitRecordVO()) {
                startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
            } else if (null != lastVO.getDwdInpatientRecordVO()) {
                startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
            } else if (null != lastVO.getDwdExaminationPatientVO().getDataCreateDate()) {
                startDate = lastVO.getDwdExaminationPatientVO().getDataCreateDate();
            }

            // 查询患者的服务信息
            PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
            patientPushServeQueryClientDTO.setPatientId(params.getPatientId());
            patientPushServeQueryClientDTO.setPatientIds(params.getPatientIds());
            patientPushServeQueryClientDTO.setStartDate(startDate);
            patientPushServeQueryClientDTO.setEndDate(endDate);
            patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
            log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
            List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

            // 查询推送服务是否被阅读过
            if (CollectionUtil.isNotEmpty(patientPushServeList)) {
                List<String> pushServeIds = new ArrayList<>();
                patientPushServeList.forEach(i -> {
                    pushServeIds.add(i.getPushServeId());
                });

                List<Map<String, Object>> patientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
                        .in(CollectionUtil.isNotEmpty(pushServeIds), "b.source_three_id", pushServeIds)
                        .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                        .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "b.patient_id", params.getPatientIds())
                        .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
                );
                Map<String, String> patientBrowseMap = new HashMap<>();
                if (CollectionUtil.isNotEmpty(patientBrowseList)) {
                    patientBrowseList.forEach(i -> {
                        String patientPushServeId = i.get("patientId").toString() + "-" + i.get("pushServeId").toString();

                        String operatedDate = null;
                        Object date = i.get("operatedDate");
                        if (null != date) {
                            if (date instanceof LocalDateTime) {
                                LocalDateTime ldt = (LocalDateTime) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                            } else if (date instanceof LocalDate) {
                                LocalDate ldt = (LocalDate) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
                            }
                        }

                        patientBrowseMap.put(patientPushServeId, operatedDate);
                    });
                }

                patientPushServeList.forEach(i -> {
                    String operatedDate = patientBrowseMap.get(i.getPatientId() + "-" + i.getPushServeId());
                    if (StrUtil.isNotBlank(operatedDate)) {
                        i.setReadDate(DateUtil.parseDateTime(operatedDate));
                        i.setRead(YN.YES.getCode());
                    }
                });
            }
            vo.setPatientPushServeList(patientPushServeList);

            // 会诊（mdt会诊、普通会诊）
            ConsultationQueryClientDTO consultationQueryClientDTO = new ConsultationQueryClientDTO();
            consultationQueryClientDTO.setPatientId(params.getPatientId());
            consultationQueryClientDTO.setStartDate(startDate);
            consultationQueryClientDTO.setEndDate(endDate);
            List<ConsultationBO> mdtList = consultationClientService.list(consultationQueryClientDTO);
            vo.setMdtConsultationList(mdtList);
        }

        vo.setDwdPatientDataList(data);
        return vo;
    }

    @Override
    public PatientArchivesVO patientArchivesV3(DwdPatientDataQueryDTO params) {
        if (StrUtil.isBlank(params.getPatientId())) {
            return null;
        }
        if (StrUtil.isBlank(params.getQueryDate()) && StrUtil.isNotBlank(params.getEndDate())) {
            params.setQueryDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        // 查询主患者id，用于查询患者体检信息
        TaskPatientGetDTO taskPatientGetDTO = new TaskPatientGetDTO();
        taskPatientGetDTO.setPatientId(params.getPatientId());
        TaskPatientVO patient = taskPatientQueryBizService.getOneSimple(taskPatientGetDTO);
        if (null == patient) {
            return null;
        }
        params.setMainPersonId(patient.getMainPersonId());

        PatientArchivesVO vo = new PatientArchivesVO();

        log.info("1.档案查询参数>>>>>> params={}", JSON.toJSONString(params));
        List<DwdPatientDataVO> data = patientDwdDataBizService.listV3(params);

        // 获取本次查询的档案的开始时间于结束时间
        Date startDate = null;
        Date endDate = null;
        if (StrUtil.isNotBlank(params.getQueryDate())) {
            endDate = DateUtil.parseDate(params.getQueryDate());
        }
        
        if (CollectionUtil.isNotEmpty(data)) {
            DwdPatientDataVO lastVO = data.get(data.size() - 1);
            if (null != lastVO.getDwdVisitRecordVO()) {
                startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
            } else if (null != lastVO.getDwdInpatientRecordVO()) {
                startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
            } else if (null != lastVO.getDwdExaminationPatientVO().getDataCreateDate()) {
                startDate = lastVO.getDwdExaminationPatientVO().getDataCreateDate();
            }
        }
        
        // 查询患者的服务信息
        PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
        patientPushServeQueryClientDTO.setPatientId(params.getPatientId());
        patientPushServeQueryClientDTO.setStartDate(startDate);
        patientPushServeQueryClientDTO.setEndDate(endDate);
        patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
        log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
        List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

        // 查询推送服务是否被阅读过
        if (CollectionUtil.isNotEmpty(patientPushServeList)) {
            List<String> pushServeIds = new ArrayList<>();
            patientPushServeList.forEach(i -> {
                pushServeIds.add(i.getPushServeId());
            });

            List<Map<String, Object>> patientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
                    .in(CollectionUtil.isNotEmpty(pushServeIds), "b.source_three_id", pushServeIds)
                    .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                    .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
            );
            Map<String, String> patientBrowseMap = new HashMap<>();
            if (CollectionUtil.isNotEmpty(patientBrowseList)) {
                patientBrowseList.forEach(i -> {
                    String patientPushServeId = i.get("patientId").toString() + "-" + i.get("pushServeId").toString();

                    String operatedDate = null;
                    Object date = i.get("operatedDate");
                    if (null != date) {
                        if (date instanceof LocalDateTime) {
                            LocalDateTime ldt = (LocalDateTime) date;
                            operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                        } else if (date instanceof LocalDate) {
                            LocalDate ldt = (LocalDate) date;
                            operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
                        }
                    }

                    patientBrowseMap.put(patientPushServeId, operatedDate);
                });
            }

            patientPushServeList.forEach(i -> {
                String operatedDate = patientBrowseMap.get(i.getPatientId() + "-" + i.getPushServeId());
                if (StrUtil.isNotBlank(operatedDate)) {
                    i.setReadDate(DateUtil.parseDateTime(operatedDate));
                    i.setRead(YN.YES.getCode());
                }
            });
        }
        vo.setPatientPushServeList(patientPushServeList);

        // 会诊（mdt会诊、普通会诊）
        ConsultationQueryClientDTO consultationQueryClientDTO = new ConsultationQueryClientDTO();
        consultationQueryClientDTO.setPatientId(params.getPatientId());
        consultationQueryClientDTO.setStartDate(startDate);
        consultationQueryClientDTO.setEndDate(endDate);
        List<ConsultationBO> mdtList = consultationClientService.list(consultationQueryClientDTO);
        vo.setMdtConsultationList(mdtList);
            
        vo.setDwdPatientDataList(data);
        return vo;
    }

    @Override
    public PatientArchivesVO patientMergeArchivesV3(DwdPatientDataQueryDTO params) {
        if (StrUtil.isBlank(params.getQueryDate()) && StrUtil.isNotBlank(params.getEndDate())) {
            params.setQueryDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        PatientArchivesVO vo = new PatientArchivesVO();

        log.info("1.档案查询参数>>>>>> params={}", JSON.toJSONString(params));
        DwdPatientArchiveDataVO patientArchiveData = patientDwdDataBizService.patientDataMergeV3(params);
        if (null == patientArchiveData) {
            return vo;
        }

        List<DwdPatientDataVO> data = patientArchiveData.getDwdPatientDataVOList();

        params.setPatientIds(patientArchiveData.getPatientIds());
        
        // 查询患者的服务信息
        if (CollectionUtil.isNotEmpty(data)) {
            // 获取本次查询的档案的开始时间于结束时间
            Date startDate = null;
            Date endDate = null;
            if (StrUtil.isNotBlank(params.getQueryDate())) {
                endDate = DateUtil.parseDate(params.getQueryDate());
            }

            DwdPatientDataVO lastVO = data.get(data.size() - 1);
            if (null != lastVO.getDwdVisitRecordVO()) {
                startDate = lastVO.getDwdVisitRecordVO().getVisitDate();
            } else if (null != lastVO.getDwdInpatientRecordVO()) {
                startDate = lastVO.getDwdInpatientRecordVO().getInpatientDate();
            } else if (null != lastVO.getDwdExaminationPatientVO().getDataCreateDate()) {
                startDate = lastVO.getDwdExaminationPatientVO().getDataCreateDate();
            }

            PatientPushServeQueryClientDTO patientPushServeQueryClientDTO = new PatientPushServeQueryClientDTO();
            patientPushServeQueryClientDTO.setPatientId(params.getPatientId());
            patientPushServeQueryClientDTO.setPatientIds(params.getPatientIds());
            patientPushServeQueryClientDTO.setStartDate(startDate);
            patientPushServeQueryClientDTO.setEndDate(endDate);
            patientPushServeQueryClientDTO.setOpType(OpTypeEnum.Create.getCode());
            log.info("2.服务查询参数>>>>>> params={}", JSON.toJSONString(patientPushServeQueryClientDTO));
            List<PatientPushServeClientBO> patientPushServeList = patientPushServeClientService.getPatientPushServeList(patientPushServeQueryClientDTO);

            // 查询推送服务是否被阅读过
            if (CollectionUtil.isNotEmpty(patientPushServeList)) {
                List<String> pushServeIds = new ArrayList<>();
                patientPushServeList.forEach(i -> {
                    pushServeIds.add(i.getPushServeId());
                });

                List<Map<String, Object>> patientBrowseList = patientPushServeDataQueryBizMapper.patientBrowseMap(new QueryWrapper<DeptPushServeVO>()
                        .in(CollectionUtil.isNotEmpty(pushServeIds), "b.source_three_id", pushServeIds)
                        .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                        .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "b.patient_id", params.getPatientIds())
                        .eq("b.operated_type", PatientDataOperatedTypeEnum.Browse.getCode())
                );
                Map<String, String> patientBrowseMap = new HashMap<>();
                if (CollectionUtil.isNotEmpty(patientBrowseList)) {
                    patientBrowseList.forEach(i -> {
                        String patientPushServeId = i.get("patientId").toString() + "-" + i.get("pushServeId").toString();

                        String operatedDate = null;
                        Object date = i.get("operatedDate");
                        if (null != date) {
                            if (date instanceof LocalDateTime) {
                                LocalDateTime ldt = (LocalDateTime) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                            } else if (date instanceof LocalDate) {
                                LocalDate ldt = (LocalDate) date;
                                operatedDate = ldt.format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
                            }
                        }

                        patientBrowseMap.put(patientPushServeId, operatedDate);
                    });
                }

                patientPushServeList.forEach(i -> {
                    String operatedDate = patientBrowseMap.get(i.getPatientId() + "-" + i.getPushServeId());
                    if (StrUtil.isNotBlank(operatedDate)) {
                        i.setReadDate(DateUtil.parseDateTime(operatedDate));
                        i.setRead(YN.YES.getCode());
                    }
                });
            }
            vo.setPatientPushServeList(patientPushServeList);
            
            // 会诊（mdt会诊、普通会诊）
            ConsultationQueryClientDTO consultationQueryClientDTO = new ConsultationQueryClientDTO();
            consultationQueryClientDTO.setPatientId(params.getPatientId());
            consultationQueryClientDTO.setPatientIds(params.getPatientIds());
            consultationQueryClientDTO.setStartDate(startDate);
            consultationQueryClientDTO.setEndDate(endDate);
            List<ConsultationBO> mdtList = consultationClientService.list(consultationQueryClientDTO);
            vo.setMdtConsultationList(mdtList);
        }

        vo.setDwdPatientDataList(data);
        return vo;
    }

    @Override
    public List<Map<String, String>> examineReportList(DataArticleExamineQueryDTO params) {

        if (StrUtil.isBlank(params.getKey())) {
            return new ArrayList<>();
        }

        String[] keyArray = params.getKey().split("-");

        if (keyArray.length != 2) {
            return new ArrayList<>();
        }

        if (params.getTimeDuring() > 15) {
            params.setTimeDuring(15);
        }

        String patientId = "";
        Date pushDate = null;

        if ("remind".equals(keyArray[0]) && StrUtil.isNotBlank(keyArray[1])) {
            PatientRemindBO patientRemindBO = patientPushServeClientService.getPatientRemindBO(keyArray[1]);
            if (null != patientRemindBO) {
                patientId = patientRemindBO.getPatientId();
                pushDate = patientRemindBO.getPushDate();
            }
        }

        List<Map<String, String>> resultMapList = new ArrayList<>();

        if (StrUtil.isNotBlank(patientId) && null != pushDate) {
            DwdExamineReportQueryDTO dwdExamineReportQueryDTO = new DwdExamineReportQueryDTO();
            dwdExamineReportQueryDTO.setPatientId(patientId);
            // dwdExamineReportQueryDTO.setExamineTypeStandard();
            dwdExamineReportQueryDTO.setStartDate(DateUtil.offsetDay(pushDate, -params.getTimeDuring()));
            dwdExamineReportQueryDTO.setEndDate(pushDate);
            List<DwdExamineReportVO> examineList = dwdExamineReportBizService.list(dwdExamineReportQueryDTO);
            if (CollUtil.isNotEmpty(examineList)) {
                examineList.forEach(i -> {
                    Map<String, String> resultMap = new HashMap<>();
                    resultMap.put("id", i.getId());
                    resultMap.put("name", i.getReportNameStandard());

                    resultMapList.add(resultMap);
                });
            }
        }

        return resultMapList;
    }

    @Override
    public List<Map<String, String>> laboratoryReportList(DataArticleExamineQueryDTO params) {

        if (StrUtil.isBlank(params.getKey())) {
            return new ArrayList<>();
        }

        String[] keyArray = params.getKey().split("-");

        if (keyArray.length != 2) {
            return new ArrayList<>();
        }

        if (params.getTimeDuring() > 15) {
            params.setTimeDuring(15);
        }

        String patientId = "";
        Date pushDate = null;

        if ("remind".equals(keyArray[0]) && StrUtil.isNotBlank(keyArray[1])) {
            PatientRemindBO patientRemindBO = patientPushServeClientService.getPatientRemindBO(keyArray[1]);
            if (null != patientRemindBO) {
                patientId = patientRemindBO.getPatientId();
                pushDate = patientRemindBO.getPushDate();
            }
        }

        List<Map<String, String>> resultMapList = new ArrayList<>();

        if (StrUtil.isNotBlank(patientId) && null != pushDate) {
            DwdLaboratoryReportQueryDTO dwdLaboratoryReportQueryDTO = new DwdLaboratoryReportQueryDTO();
            dwdLaboratoryReportQueryDTO.setPatientId(patientId);
            // dwdLaboratoryReportQueryDTO.setExamineTypeStandard();
            dwdLaboratoryReportQueryDTO.setStartDate(DateUtil.offsetDay(pushDate, -params.getTimeDuring()));
            dwdLaboratoryReportQueryDTO.setEndDate(pushDate);
            List<DwdLaboratoryReportVO> laboratoryList = dwdLaboratoryReportBizService.list(dwdLaboratoryReportQueryDTO);
            if (CollUtil.isNotEmpty(laboratoryList)) {
                laboratoryList.forEach(i -> {
                    Map<String, String> resultMap = new HashMap<>();
                    resultMap.put("id", i.getId());
                    resultMap.put("name", i.getReportName());
                    
                    resultMapList.add(resultMap);
                });
            }
        }

        return resultMapList;
    }

}
