package com.xxh.cloud.healthy.data.framework.modules.biz.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.alibaba.fastjson2.JSONArray;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.UploadTempFileBizService;
import com.xxh.cloud.metadata.framework.modules.standard.entity.StandardDiseaseInfo;
import com.xxh.cloud.metadata.framework.modules.standard.service.StandardDiseaseInfoService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
public class UploadTempFileBizServiceImpl implements UploadTempFileBizService {

    @Autowired
    private StandardDiseaseInfoService standardDiseaseInfoService;

    @Override
    public void diseaseTemp(MultipartFile files) {
        List<String> failDevIds = new ArrayList<>();
        String readLine = "";
        InputStream inputStream;
        try {
            inputStream = files.getInputStream();
            //2.应用HUtool ExcelUtil获取ExcelReader指定输入流和sheet
            ExcelReader excelReader = ExcelUtil.getReader(inputStream);
            //可以加上表头验证
            //3.读取第二行到最后一行数据
            List<List<Object>> read = excelReader.read(1, excelReader.getRowCount());
            for (List<Object> objects : read) {
                readLine = JSONArray.toJSONString(objects);
                if (objects.size() < 3 || StrUtil.isEmpty(Convert.toStr(objects.get(2)))) {
                    continue;
                }
                log.info("excel数据:{}" ,readLine);
                StandardDiseaseInfo diseaseInfo = new StandardDiseaseInfo();
                diseaseInfo.setId(Convert.toStr(objects.get(0)));
                diseaseInfo.setName(Convert.toStr(objects.get(1)));
                diseaseInfo.setIcd10Code(Convert.toStr(objects.get(2)));
                diseaseInfo.setSystemId(Convert.toStr(objects.get(4)));
                diseaseInfo.setPid("0");
                diseaseInfo.setRemark("WB");
                diseaseInfo.setRowsStatus(YN.YES.getCode());
                standardDiseaseInfoService.saveOrUpdate(diseaseInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.info("报错的信息{}", readLine);
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR, "上传文件失败");
        }
        log.info("未录入的设备_{}", JSONArray.toJSONString(failDevIds));
    }
}
