package com.xxh.cloud.healthy.data.framework.modules.client.service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.data.client.api.DoctorFollowPatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorFollowPatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DoctorFollowPatientListClientDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DoctorFollowPatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.DoctorFollowPatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DoctorFollowPatientBizService;

import cn.hutool.core.collection.CollUtil;

@Service
public class DoctorFollowPatientClientServiceImpl implements DoctorFollowPatientClientService {

    @Autowired
    private DoctorFollowPatientBizService doctorFollowPatientBizService;

    @Override
    public List<DoctorFollowPatientBO> simpleList(DoctorFollowPatientListClientDTO params) {
        DoctorFollowPatientQueryDTO queryDTO = new DoctorFollowPatientQueryDTO();
        queryDTO.setId(params.getId());
        queryDTO.setDoctorId(params.getDoctorId());
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        List<DoctorFollowPatientVO> list = doctorFollowPatientBizService.simpleList(queryDTO);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(i -> {
            DoctorFollowPatientBO bo = new DoctorFollowPatientBO();
            bo.setId(i.getId());
            bo.setPatientId(i.getPatientId());
            bo.setDoctorId(i.getDoctorId());
            bo.setStatus(i.getStatus());
            bo.setDataUpdateType(i.getDataUpdateType());
            bo.setDataUpdateDate(i.getDataUpdateDate());
            return bo;
        }).collect(Collectors.toList());
    }
    
}
