package com.xxh.cloud.healthy.data.framework.modules.client.service;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.TaskPatientGetDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.TaskPatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskPatientVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.helper.TaskPatientHelper;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.TaskPatientQueryBizService;

@Service
public class PatientClientServiceImpl implements PatientClientService {
    
    @Autowired
    private TaskPatientQueryBizService taskPatientQueryBizService;

    @Override
    public List<PatientClientBO> queryPatientList(PatientQueryDTO params) {
        TaskPatientQueryDTO taskPatientQueryDTO = new TaskPatientQueryDTO();
        taskPatientQueryDTO.setPatientId(params.getPatientId());
        taskPatientQueryDTO.setPatientIds(params.getPatientIds());
        taskPatientQueryDTO.setPatientName(params.getPatientName());
        taskPatientQueryDTO.setPatientGenderStandard(params.getPatientGenderStandard());
        taskPatientQueryDTO.setStartAge(params.getStartAge());
        taskPatientQueryDTO.setEndAge(params.getEndAge());
        List<TaskPatientVO> patientList = taskPatientQueryBizService.list(taskPatientQueryDTO);

        return patientList.stream().map(TaskPatientHelper::getPatientClientBO).collect(Collectors.toList());
    }

    @Override
    public List<PatientClientBO> simpleList(PatientQueryDTO params) {
        TaskPatientQueryDTO taskPatientQueryDTO = new TaskPatientQueryDTO();
        taskPatientQueryDTO.setPatientId(params.getPatientId());
        taskPatientQueryDTO.setPatientIds(params.getPatientIds());
        taskPatientQueryDTO.setPatientName(params.getPatientName());
        taskPatientQueryDTO.setPatientGenderStandard(params.getPatientGenderStandard());
        taskPatientQueryDTO.setStartAge(params.getStartAge());
        taskPatientQueryDTO.setEndAge(params.getEndAge());
        taskPatientQueryDTO.setMainPersonId(params.getMainPersonId());
        List<TaskPatientVO> list = taskPatientQueryBizService.simpleList(taskPatientQueryDTO);
        return list.stream().map(TaskPatientHelper::getPatientClientBO).collect(Collectors.toList());
    }

    @Override
    public PatientClientBO getOneSimple(PatientQueryDTO params) {
        TaskPatientGetDTO taskPatientQueryDTO = new TaskPatientGetDTO();
        taskPatientQueryDTO.setPatientId(params.getPatientId());
        TaskPatientVO vo = taskPatientQueryBizService.getOneSimple(taskPatientQueryDTO);
        return TaskPatientHelper.getPatientClientBO(vo);
    }
    
}
