package com.xxh.cloud.healthy.data.framework.modules.client.service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.healthy.data.client.api.bean.bo.TaskDeptPatientRelationBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DeptPatientQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DeptPatientRelationQueryDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskDeptPatientRelationVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.helper.DoctorDataHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.data.client.api.TaskDeptPatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DeptPatientAddDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DeptPatientDelDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DeptPatientRelationAddDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DeptPatientRelationDelDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DeptPatientRelationBizService;

import cn.hutool.core.collection.CollectionUtil;

@Service
public class TaskDeptPatientClientServiceImpl implements TaskDeptPatientClientService {

    @Autowired
    private DeptPatientRelationBizService deptPatientRelationBizService;

    @Override
    public void add(DeptPatientAddDTO params) {
        if (null == params) {
            return;
        }
        DeptPatientRelationAddDTO addDTO = new DeptPatientRelationAddDTO();
        addDTO.setDeptId(params.getDeptId());
        addDTO.setPatientId(params.getPatientId());
        addDTO.setType(params.getType());
        deptPatientRelationBizService.add(addDTO);
    }

    @Override
    public void addBatch(List<DeptPatientAddDTO> params) {
        if (CollectionUtil.isEmpty(params)) {
            return;
        }
        List<DeptPatientRelationAddDTO> addDTOs = params.stream().map(i -> {
            DeptPatientRelationAddDTO addDTO = new DeptPatientRelationAddDTO();
            addDTO.setDeptId(i.getDeptId());
            addDTO.setPatientId(i.getPatientId());
            addDTO.setType(i.getType());
            return addDTO;
        }).collect(Collectors.toList());
        deptPatientRelationBizService.addBatch(addDTOs);
    }

    @Override
    public void del(DeptPatientDelDTO params) {
        if (null == params) {
            return;
        }
        DeptPatientRelationDelDTO delDTO = new DeptPatientRelationDelDTO();
        delDTO.setDeptId(params.getDeptId());
        delDTO.setPatientId(params.getPatientId());
        deptPatientRelationBizService.del(delDTO);
    }

    @Override
    public void delBatch(List<DeptPatientDelDTO> params) {
        if (CollectionUtil.isEmpty(params)) {
            return;
        }
        List<DeptPatientRelationDelDTO> delDTOs = params.stream().map(i -> {
            DeptPatientRelationDelDTO delDTO = new DeptPatientRelationDelDTO();
            delDTO.setDeptId(i.getDeptId());
            delDTO.setPatientId(i.getPatientId());
            return delDTO;
        }).collect(Collectors.toList());
        deptPatientRelationBizService.delBatch(delDTOs);
    }

    @Override
    public List<TaskDeptPatientRelationBO> query(DeptPatientQueryDTO params) {
        DeptPatientRelationQueryDTO dto = new DeptPatientRelationQueryDTO();
        dto.setDeptId(params.getDeptId());
        dto.setPatientId(params.getPatientId());
        dto.setType(params.getType());
        List<TaskDeptPatientRelationVO> vos = deptPatientRelationBizService.query(dto);
        List<TaskDeptPatientRelationBO> bos = new ArrayList<>();
        if (CollUtil.isNotEmpty(vos)) {
            bos.addAll(vos.stream().map(DoctorDataHelper::getTaskDeptPatientRelationBO).collect(Collectors.toList()));
        }
        return bos;
    }

}
