package com.xxh.cloud.healthy.data.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.data.framework.modules.task.service.DoctorFollowPatientTaskService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
// @ConditionalOnProperty(name = "task.enable", havingValue = "true")
public class DoctorFollowPatientTask {

    @Autowired
    private DoctorFollowPatientTaskService doctorFollowPatientTaskService;
    
    // 扫描患者就诊和住院信息并更新关注数据更新时间信息
    @XxlJob("doctorFollowPatientTaskJobHandler")
    public void doctorFollowPatientTaskJobHandler() throws Exception {
        log.info("扫描患者就诊和住院信息并更新关注数据更新时间信息数据开始 >>>>>> ");
        XxlJobHelper.log("扫描患者就诊和住院信息并更新关注数据更新时间信息数据开始 >>>>>> ");

        doctorFollowPatientTaskService.updateFollowPatientDataDateTaskExecute();

        XxlJobHelper.log("扫描患者就诊和住院信息并更新关注数据更新时间信息数据结束 <<<<<< ");
        log.info("扫描患者就诊和住院信息并更新关注数据更新时间信息数据结束 <<<<<< ");
    }

}
