package com.xxh.cloud.healthy.data.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.data.framework.modules.task.service.DoctorLabelPatientDataTaskService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
// @ConditionalOnProperty(name = "task.enable", havingValue = "true")
public class DoctorLabelPatientDataTask {

    @Autowired
    private DoctorLabelPatientDataTaskService doctorLabelPatientDataTaskService;
    
    // 统计运营助理数据任务
    @XxlJob("doctorManagePatientStatisticJobHandler")
    public void doctorManagePatientStatisticJobHandler() throws Exception {
        log.info("统计运营助理数据任务开始 >>>>>> ");
        XxlJobHelper.log("统计运营助理数据任务开始 >>>>>> ");

        // String jobParam = "2024-05-02,2024-05-21";
        String jobParam = XxlJobHelper.getJobParam();


        String startDate = DateUtil.date().toDateStr();
        String endDate = null;
        if (StrUtil.isNotBlank(jobParam)) {
            String[] dateArray = jobParam.split(",");
            startDate = dateArray[0].trim();
            if (dateArray.length == 2) {
                endDate = dateArray[1].trim();
            }
        }
        
        if (null != endDate) {
            endDate = DateUtil.offsetDay(DateUtil.parseDate(endDate), 1).toDateStr();
        }

        doctorLabelPatientDataTaskService.doctorManagePatientStatisticTaskExecute(startDate, endDate);

        XxlJobHelper.log("统计运营助理数据任务结束 <<<<<< ");
        log.info("统计运营助理数据任务结束 <<<<<< ");
    }

}
