package com.xxh.cloud.healthy.data.framework.modules.task.schedule;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.data.framework.modules.task.service.DoctorManagePatientTaskService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
// @ConditionalOnProperty(name = "task.enable", havingValue = "true")
public class DoctorManagePatientTask {

    @Autowired
    private DoctorManagePatientTaskService doctorManagePatientTaskService;
    
    @XxlJob("doctorManagePatientDetailTask")
    public void doctorManagePatientDetailTask() throws Exception {
        log.info("管理患者统计详情开始 >>>>>> ");
        XxlJobHelper.log("管理患者统计详情开始 >>>>>> ");

        // 2024-11-01,2024-11-10
        String jobParam = XxlJobHelper.getJobParam();

        Date startDate = null;
        Date endDate = null;
        if (StrUtil.isNotBlank(jobParam)) {
            String[] jobParamArray = jobParam.split(",");
            startDate = DateUtil.parseDate(jobParamArray[0].trim());
            if (jobParamArray.length == 2) {
                endDate = DateUtil.parseDate(jobParamArray[1].trim());
            }
        }

        doctorManagePatientTaskService.doctorManagePatientDetailTask(startDate, endDate);

        XxlJobHelper.log("管理患者统计详情结束 <<<<<< ");
        log.info("管理患者统计详情结束 <<<<<< ");
    }

    @XxlJob("doctorManagePatientDayStatTask")
    public void doctorManagePatientDayStatTask() throws Exception {
        log.info("管理患者日统计开始 >>>>>> ");
        XxlJobHelper.log("管理患者日统计开始 >>>>>> ");

        // 2024-11-01,2024-11-10
        String jobParam = XxlJobHelper.getJobParam();

        Date startDate = null;
        Date endDate = null;
        if (StrUtil.isNotBlank(jobParam)) {
            String[] jobParamArray = jobParam.split(",");
            startDate = DateUtil.parseDate(jobParamArray[0].trim());
            if (jobParamArray.length == 2) {
                endDate = DateUtil.parseDate(jobParamArray[1].trim());
            }
        }

        doctorManagePatientTaskService.doctorManagePatientDayStatTask(startDate, endDate);

        XxlJobHelper.log("管理患者日统计结束 <<<<<< ");
        log.info("管理患者日统计结束 <<<<<< ");
    }

    @XxlJob("doctorManagePatientDiversionDayStatTask")
    public void doctorManagePatientDiversionDayStatTask() throws Exception {
        log.info("患者导流日统计开始 >>>>>> ");
        XxlJobHelper.log("患者导流日统计开始 >>>>>> ");

        // 2024-11-01,2024-11-10
        String jobParam = XxlJobHelper.getJobParam();

        Date startDate = null;
        Date endDate = null;
        if (StrUtil.isNotBlank(jobParam)) {
            String[] jobParamArray = jobParam.split(",");
            startDate = DateUtil.parseDate(jobParamArray[0].trim());
            if (jobParamArray.length == 2) {
                endDate = DateUtil.parseDate(jobParamArray[1].trim());
            }
        }

        doctorManagePatientTaskService.doctorManagePatientDiversionDayStatTask(startDate, endDate);

        XxlJobHelper.log("患者导流日统计结束 <<<<<< ");
        log.info("患者导流日统计结束 <<<<<< ");
    }

}
