package com.xxh.cloud.healthy.data.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.data.framework.modules.task.service.PatientDataStatisticService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
// @ConditionalOnProperty(name = "task.enable", havingValue = "true")
public class PatientDataStatisticTask {

    @Autowired
    private PatientDataStatisticService patientDataStatisticService;
    
    // 运营端首页统计数据
    // 扫描患者数据进行统计
    // @Scheduled(cron = "0 0/60 * * * ?") // 每10分钟执行一次
    @Deprecated
    @XxlJob("patientDataTaskJobHandler")
    public void patientDataTaskJobHandler() throws Exception {
        log.info("统计患者数据开始 >>>>>> ");
        XxlJobHelper.log("统计患者数据开始 >>>>>> ");

        // 按部门日统计
        patientDataStatisticService.patientDataStatisticTaskExecute();

        XxlJobHelper.log("统计患者数据结束 <<<<<< ");
        log.info("统计患者数据结束 <<<<<< ");
    }




    // 病种运营下的服务统计数据
    // 扫描患者病种数据进行统计
    // @Scheduled(cron = "0 0/60 * * * ?")
    @Deprecated
    @XxlJob("patientDiseaseDataTaskJobHandler")
    public void patientDiseaseDataTaskJobHandler() throws Exception {
        log.info("统计患者病种数据开始 >>>>>> ");
        XxlJobHelper.log("统计患者病种数据开始 >>>>>> ");

        // 按病种部门日统计
        patientDataStatisticService.patientDiseaseDataStatisticTaskExecute();

        XxlJobHelper.log("统计患者病种数据结束 <<<<<< ");
        log.info("统计患者病种数据结束 <<<<<< ");
    }




    /**
     * 病种运营下的服务统计详情数据
     * 扫描患者推送服务数据进行统计
     */
    // @Scheduled(cron = "0 0/60 * * * ?")
    @XxlJob("patientPushServeDataTaskJobHandler")
    public void patientPushServeDataTaskJobHandler() throws Exception {
        log.info("统计患者推送服务数据开始 >>>>>> ");
        XxlJobHelper.log("统计患者推送服务数据开始 >>>>>> ");

        // 按部门日统计
        patientDataStatisticService.patientPushServeDataStatisticTask();

        XxlJobHelper.log("统计患者推送服务数据结束 <<<<<< ");
        log.info("统计患者推送服务数据结束 <<<<<< ");
    }





    // 扫描数仓中数据给患者打标签：挂号流失患者、住院流失患者、手术流失患者、流失比例
    // @Scheduled(cron = "0 0/60 * * * ?")
    @Deprecated
    @XxlJob("patientLabelingJobHandler")
    public void patientLabelingJobHandler() throws Exception {
        log.info("扫描数仓数据给患者打流失标签开始 >>>>>> ");
        XxlJobHelper.log("扫描数仓数据给患者打流失标签开始 >>>>>> ");

        patientDataStatisticService.patientLabelingTaskExecute();

        XxlJobHelper.log("扫描数仓数据给患者打流失标签结束 <<<<<< ");
        log.info("扫描数仓数据给患者打流失标签结束 <<<<<< ");
    }

    // 扫描数仓中数据给患者打住院流失标签
    @Deprecated
    @XxlJob("patientInpatientLabelingJobHandler")
    public void patientInpatientLabelingJobHandler() throws Exception {
        log.info("扫描数仓数据给患者打住院流失标签开始 >>>>>> ");
        XxlJobHelper.log("扫描数仓数据给患者打住院流失标签开始 >>>>>> ");

        patientDataStatisticService.patientInpatientLabelingTaskExecute();

        XxlJobHelper.log("扫描数仓数据给患者打住院流失标签结束 <<<<<< ");
        log.info("扫描数仓数据给患者打住院流失标签结束 <<<<<< ");
    }

    
    // 扫描患者信息表中没有主患者id的数据，并从数仓中同步过来
    @XxlJob("patientMainPersonIdJobHandler")
    public void patientMainPersonIdJobHandler() throws Exception {
        log.info("扫描患者信息表中没有主患者id的数据，并从数仓中同步过来开始 >>>>>> ");
        XxlJobHelper.log("扫描患者信息表中没有主患者id的数据，并从数仓中同步过来开始 >>>>>> ");

        patientDataStatisticService.patientMainPersonIdTaskExecute();

        XxlJobHelper.log("扫描患者信息表中没有主患者id的数据，并从数仓中同步过来结束 <<<<<< ");
        log.info("扫描患者信息表中没有主患者id的数据，并从数仓中同步过来结束 <<<<<< ");
    }

}
