package com.xxh.cloud.healthy.data.framework.modules.task.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.data.framework.modules.biz.mapper.PatientRuleTaskMapper;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DoctorDwdPatientDataBizService;
import com.xxh.cloud.healthy.data.framework.modules.task.service.PatientRuleTaskService;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

@Service
public class PatientRuleTaskServiceImpl implements PatientRuleTaskService {

    @Autowired
    private PatientRuleTaskMapper patientRuleTaskMapper;
    @Autowired
    private DoctorDwdPatientDataBizService doctorDwdPatientDataBizService;

    @Override
    public void removeXePatientRuleIngTaskExecute() {
        String opTime = DateUtil.formatDate(DateUtil.offsetDay(DateUtil.date(), -1));
        QueryWrapper<Void> queryWrapper = new QueryWrapper<Void>().eq("op_status", "ing").lt("op_time", opTime);
        // 删除患者待执行事件
        patientRuleTaskMapper.deleteXePatientEventRuleIngInfo(queryWrapper);
        // 删除患者待执行规则列表
        patientRuleTaskMapper.deleteXePatientFlowRuleIngInfo(queryWrapper);
        // 删除患者历史数据标签规则待执行列表
        patientRuleTaskMapper.deleteXePatientHisTagRuleIngInfo(queryWrapper);
    }

    // 按患者聚合分页查询患者每日数据变化统计表查询患者id
    @Override
    public void exeXePatientRuleIngTaskExecute(String startDate, String endDate) {
        Integer page = 1;
        // while (true) {
        //     IPage<String> pageData = doctorDwdPatientDataBizService.pagePatientChangeDateInfo(new Page<>(page, 5000), startDate, endDate);
        //     if (null == pageData || CollUtil.isEmpty(pageData.getRecords())) {
        //         break;
        //     }
        //     List<Map<String, String>> dataList = new ArrayList<>();
        //     pageData.getRecords().forEach(i -> {
        //         Map<String, String> map = new HashMap<>();
        //         map.put("id", IdUtil.getSnowflake(0,1).nextIdStr());
        //         map.put("patientId", i);
        //         dataList.add(map);
        //     });
            
        //     patientRuleTaskMapper.saveXePatientFlowRuleIngInfo(dataList);

        //     page = page + 1;
        // }

        String nowTimeStr = DateUtil.date().toTimeStr();
        while (true) {
            IPage<Map<String, String>> pageData = doctorDwdPatientDataBizService.pagePatientChangeDateMapInfo(new Page<>(page, 5000), startDate, endDate);
            if (null == pageData || CollUtil.isEmpty(pageData.getRecords())) {
                break;
            }
            List<Map<String, String>> dataList = new ArrayList<>();

            Map<String, List<String>> dayDataMap = new HashMap<>();
            pageData.getRecords().forEach(i -> {
                String dataDay = i.get("dataDay");
                if (StrUtil.isNotBlank(dataDay)) {
                    String date = DateUtil.parse(dataDay, "yyyyMMdd").toDateStr() + " " + nowTimeStr;
                    
                    List<String> dayDataList = dayDataMap.get(date);
                    if (null == dayDataList) {
                        dayDataList = new ArrayList<>();
                        dayDataMap.put(date, dayDataList);
                    }
                    dayDataList.add(i.get("patientId"));
                }
            });

            dayDataMap.forEach((k, v) -> {
                if (CollUtil.isNotEmpty(v)) {
                    v.forEach(i -> {
                        Map<String, String> map = new HashMap<>();
                        map.put("id", IdUtil.getSnowflake(0,1).nextIdStr());
                        map.put("dataDay", k);
                        map.put("patientId", i);
                        dataList.add(map);
                    });
                }
            });
            
            patientRuleTaskMapper.saveXePatientFlowRuleIngInfo(dataList);

            page = page + 1;
        }
    }
}
