package com.xxh.cloud.healthy.data.framework.modules.task.service.impl;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.basic.label.client.api.LabelClientService;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.basic.label.client.api.bean.dto.LabelQueryPageDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.dto.DeptLabelRelationAddDTO;
import com.xxh.cloud.healthy.data.framework.modules.biz.bean.vos.TaskDeptLabelRelationVO;
import com.xxh.cloud.healthy.data.framework.modules.biz.service.DeptLabelRelationBizService;
import com.xxh.cloud.healthy.data.framework.modules.task.service.TaskDeptLabelRelationTaskService;
import com.xxh.cloud.user.client.api.DeptClientService;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;
import com.xxh.cloud.user.client.api.bean.dto.DeptQueryDTO;

import cn.hutool.core.collection.CollectionUtil;

@Service
public class TaskDeptLabelRelationTaskServiceImpl implements TaskDeptLabelRelationTaskService {

    @Autowired
    private DeptClientService deptClientService;
    @Autowired
    private LabelClientService labelClientService;
    @Autowired
    private DeptLabelRelationBizService deptLabelRelationBizService;

    @Override
    public void deptLabelRelationTask() {
        // 查询科室列表；查询标签；循环科室与标签判断科室与标签中病种是否对应，对应则保存科室标签信息
        List<DeptBO> deptBOs = deptClientService.getDeptList(new DeptQueryDTO());

        List<LabelBO> labelBOs = labelClientService.queryList(new LabelQueryPageDTO());
        
        Map<String, DeptLabelRelationAddDTO> map = new HashMap<>();

        deptBOs.forEach(dept -> {
            List<String> deptDiseaseIds = dept.getDiseaseIds();
            labelBOs.forEach(label -> {
                List<String> labelDiseaseIds = label.getDiseaseIds();

                Collection<String> intersection = CollectionUtil.intersection(deptDiseaseIds, labelDiseaseIds); // 交集
                if (CollectionUtil.isNotEmpty(intersection)) {
                    DeptLabelRelationAddDTO deptLabel = map.get(dept.getId() + "-" + label.getId());
                    if (null == deptLabel) {
                        deptLabel = new DeptLabelRelationAddDTO();
                        deptLabel.setDeptId(dept.getId());
                        deptLabel.setLabelId(label.getId());
                    }
                }
            });
        });

        if (CollectionUtil.isNotEmpty(map)) {

            Set<String> deptLabelIds = map.keySet();
            // 查询数据库中是否存在数据，不存在才新增
            List<TaskDeptLabelRelationVO> deptLabelRelationVOs = deptLabelRelationBizService.getByDeptLabelIds(deptLabelIds);
            deptLabelRelationVOs.forEach(i -> map.remove(i.getDeptId() + "-" + i.getLabelId()));

            List<DeptLabelRelationAddDTO> list = map.entrySet().stream().map(i -> i.getValue()).collect(Collectors.toList());

            deptLabelRelationBizService.addBatch(list);
        }

    }

}
