package com.xxh.cloud.healthy.data.framework.modules.third;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpUtil;

import java.util.List;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.TypeReference;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugApiReq;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugApiResp;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugApiResultResp;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugDetailApiResp;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.DrugDetailApiResultResp;

public class DrugThirdHttpUtil {

    public static DrugApiResp getDrugDataHttpApi(DrugApiReq req){

        String result=null;
        try {
            result= HttpUtil.post(DrugThirdUrls.getDrugUrl(), JSON.toJSONString(req), 1000*120);
        }catch (Exception e){
            e.printStackTrace();
            return new DrugApiResp(-1,"API",e.getMessage());
        }

        if(StrUtil.isEmpty(result)){
            return new DrugApiResp(-1,"API","调用药品接口错误!");
        }

        JSONObject jsonObject = JSON.parseObject(result);
        int code = jsonObject.getIntValue("code");
        String type = jsonObject.getString("type");
        String message = jsonObject.getString("message");
        List<DrugApiResultResp> content = jsonObject.getObject("result", new TypeReference<List<DrugApiResultResp>>() {});
        return new DrugApiResp(code, type, message, content);
    }

    public static DrugDetailApiResp getDrugDetailDataHttpApi(String drugCode){

        String result=null;
        try {
            result= HttpUtil.get(StrUtil.format(DrugThirdUrls.getDrugDetailUrl(), drugCode), 1000*120);
        }catch (Exception e){
            e.printStackTrace();
            return new DrugDetailApiResp(-1, e.getMessage());
        }

        if(StrUtil.isEmpty(result)){
            return new DrugDetailApiResp(-1, "调用药品详情接口错误!");
        }

        JSONObject jsonObject = JSON.parseObject(result);
        int code = jsonObject.getIntValue("code");
        String name = jsonObject.getString("name");
        List<DrugDetailApiResultResp> sections = jsonObject.getObject("sections", new TypeReference<List<DrugDetailApiResultResp>>() {});
        return new DrugDetailApiResp(code, name, sections);
    }

}
