package com.xxh.cloud.healthy.data.framework.modules.third;


import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.ViewUndrugztinfoResp;
import com.xxh.cloud.healthy.data.framework.modules.third.bean.ViewUndrugztinfoResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 同步组套内容
 * **/
@Slf4j
@Component
public class ViewUndrugztinfoApiHelper {

    /** 同步组套内容 */
    public static List<ViewUndrugztinfoResp> viewUndrugztinfo(String startTime, String endTime) {
        DrugThirdUrls urls=new DrugThirdUrls();
        Map<String, String> map = new HashMap<>();
        map.put("startTime", startTime);
        map.put("endTime", endTime);
        String bodyJson = JSONObject.toJSONString(map);
        log.info(StrUtil.format("同步组套内容:{}", bodyJson));
        String result = HttpRequest.post(urls.getViewUndrugztinfo())
                .body(bodyJson)
                .execute().body();
//        log.info(StrUtil.format("同步组套内容:{}", result));
        return getResp(result);
    }

    private static List<ViewUndrugztinfoResp> getResp(String result) {
        ViewUndrugztinfoResult resultJson = JSONObject.parseObject(result, ViewUndrugztinfoResult.class);
        if (resultJson.getCode() == 200) {
            return resultJson.getResult();
        } else {
            return new ArrayList<>();
        }
    }
}
