package com.xxh.cloud.healthy.drug.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 药品提醒配置信息表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_drug_notity_config_info")
public class DrugNotityConfigInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 标准药品ID
     */
     @ApiModelProperty(value = "标准药品ID")
      private String medicantId;

    /**
     * 标准药品编号(准字)
     */
     @ApiModelProperty(value = "标准药品编号(准字)")
      private String medicantCode;

    /**
     * 快照ID
     */
     @ApiModelProperty(value = "快照ID")
      private String snapshotId;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 提醒状态
     */
     @ApiModelProperty(value = "提醒状态")
      private String status;

    /**
     * 提醒生效时间
     */
     @ApiModelProperty(value = "提醒生效时间")
      private String effectiveTime;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opTime;

    /**
     * 操作备注
     */
     @ApiModelProperty(value = "操作备注")
      private String opRemark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
