package com.xxh.cloud.healthy.drug.framework.modules.biz.bean.dto;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 药品提醒配置信息表
 */
@Getter
@Setter
public class DrugNotityConfigAddDTO {

    /**
     * 标准药品ID
     */
    @ApiModelProperty(value = "标准药品ID", required = true)
    @NotEmpty(message = "标准药品ID[medicantId]不能为空")
    private String medicantId;

    /**
     * 标准药品编号(准字)
     */
    @ApiModelProperty(value = "标准药品编号(准字)")
    private String medicantCode;

    /**
     * 项目编号
     */
    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    /**
     * 提醒状态
     */
    @ApiModelProperty(value = "提醒状态")
    private String status;

    /**
     * 提醒生效时间
     */
    @ApiModelProperty(value = "提醒生效时间")
    private String effectiveTime;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opUser;

    /**
     * 操作备注
     */
    @ApiModelProperty(value = "操作备注")
    private String opRemark;

}
