package com.xxh.cloud.healthy.drug.framework.modules.biz.helper;

import com.xxh.cloud.healthy.drug.framework.modules.base.entity.DrugNotityConfigInfo;
import com.xxh.cloud.healthy.drug.framework.modules.base.entity.DrugNotityConfigLogInfo;
import com.xxh.cloud.healthy.drug.framework.modules.base.entity.DrugNotityConfigSnapshotInfo;
import com.xxh.cloud.healthy.drug.framework.modules.biz.bean.vo.DrugNotityConfigLogVO;
import com.xxh.cloud.healthy.drug.framework.modules.biz.bean.vo.DrugNotityConfigSnapshotVO;
import com.xxh.cloud.healthy.drug.framework.modules.biz.bean.vo.DrugNotityConfigVO;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

public class DrugNotityHelper {

    public static String getDrugNotityConfigInfoId(){
        return StrUtil.format("DNC{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDrugNotityConfigSnapshotInfoId(){
        return StrUtil.format("DNCS{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDrugNotityConfigLogInfoId(){
        return StrUtil.format("DNCL{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static DrugNotityConfigVO getDrugNotityConfigVO(DrugNotityConfigInfo entity) {
        if (null == entity) {
            return null;
        }
        DrugNotityConfigVO vo = new DrugNotityConfigVO();
        vo.setId(entity.getId());
        vo.setMedicantId(entity.getMedicantId());
        vo.setMedicantCode(entity.getMedicantCode());
        vo.setSnapshotId(entity.getSnapshotId());
        vo.setProjectCode(entity.getProjectCode());
        vo.setStatus(entity.getStatus());
        vo.setEffectiveTime(entity.getEffectiveTime());
        vo.setOpUser(entity.getOpUser());
        vo.setOpTime(entity.getOpTime());
        vo.setOpRemark(entity.getOpRemark());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static DrugNotityConfigSnapshotVO getDrugNotityConfigSnapshotVO(DrugNotityConfigSnapshotInfo entity) {
        if (null == entity) {
            return null;
        }
        DrugNotityConfigSnapshotVO vo = new DrugNotityConfigSnapshotVO();
        vo.setId(entity.getId());
        vo.setConfigId(entity.getConfigId());
        vo.setMedicantId(entity.getMedicantId());
        vo.setMedicantCode(entity.getMedicantCode());
        vo.setProjectCode(entity.getProjectCode());
        vo.setStatus(entity.getStatus());
        vo.setEffectiveTime(entity.getEffectiveTime());
        vo.setOpUser(entity.getOpUser());
        vo.setOpTime(entity.getOpTime());
        vo.setOpRemark(entity.getOpRemark());
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        return vo;
    }

    public static DrugNotityConfigLogVO getDrugNotityConfigLogVO(DrugNotityConfigLogInfo entity) {
        if (null == entity) {
            return null;
        }
        DrugNotityConfigLogVO vo = new DrugNotityConfigLogVO();
        vo.setId(entity.getId());
        vo.setConfigId(entity.getConfigId());
        vo.setMedicantId(entity.getMedicantId());
        vo.setMedicantCode(entity.getMedicantCode());
        vo.setProjectCode(entity.getProjectCode());
        vo.setOpStatus(entity.getOpStatus());
        vo.setOpActType(entity.getOpActType());
        vo.setOpEffectiveTime(entity.getOpEffectiveTime());
        vo.setOpUser(entity.getOpUser());
        vo.setOpTime(entity.getOpTime());
        vo.setOpRemark(entity.getOpRemark());
        return vo;
    }

}
