package com.xxh.cloud.healthy.drug.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.drug.framework.modules.task.service.DrugNotityTaskService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
public class DrugNotityTask {

    @Autowired
    private DrugNotityTaskService drugNotityTaskService;
    
    // 扫描dwd当天的患者医嘱服药信息生成日程
    @XxlJob("recipeMedicineScheduleJobHandler")
    public void recipeMedicineScheduleJobHandler() throws Exception {
        log.info("扫描dwd当天的患者医嘱服药信息生成日程开始 >>>>>> ");
        XxlJobHelper.log("扫描dwd当天的患者医嘱服药信息生成日程开始 >>>>>> ");

        drugNotityTaskService.recipeMedicineScheduleJobHandler();

        XxlJobHelper.log("扫描dwd当天的患者医嘱服药信息生成日程结束 <<<<<< ");
        log.info("扫描dwd当天的患者医嘱服药信息生成日程结束 <<<<<< ");
    }

    // 扫描dwd当天的患者医嘱服药日程生成提醒并发送
    @XxlJob("recipeMedicineRemindJobHandler")
    public void recipeMedicineRemindJobHandler() throws Exception {
        log.info("扫描dwd当天的患者医嘱服药日程生成提醒并发送开始 >>>>>> ");
        XxlJobHelper.log("扫描dwd当天的患者医嘱服药日程生成提醒并发送开始 >>>>>> ");

        drugNotityTaskService.recipeMedicineRemindJobHandler();

        XxlJobHelper.log("扫描dwd当天的患者医嘱服药日程生成提醒并发送结束 <<<<<< ");
        log.info("扫描dwd当天的患者医嘱服药日程生成提醒并发送结束 <<<<<< ");
    }

}
