package com.xxh.cloud.healthy.mdt.controller;

import cn.dev33.satoken.annotation.SaCheckLogin;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import com.xxh.cloud.framework.common.user.LoginUser;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationNotifyVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationLaunchApplyBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationNotifyInfoBizService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@SaCheckLogin
@Slf4j
@RestController
@RequestMapping("/sys/doctor/mdt/notify")
@Api(tags = "会诊通知管理")
public class ConsultationNotifyBizController {
    
    @Autowired
    private ConsultationNotifyInfoBizService consultationNotifyInfoBizService;

    @PostMapping("/query")
    @ApiOperation(value = "查询我的会诊通知", response = ConsultationNotifyVO.class)
    public Result<PageData<ConsultationNotifyVO>> query(@RequestBody ConsultationNotifyQueryDTO params) {
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        params.setDoctorId(user.getId());
        PageData<ConsultationNotifyVO> data = consultationNotifyInfoBizService.query(params);
        return new Result<PageData<ConsultationNotifyVO>>().ok(data);
    }

    // 我发起的会诊
    @PostMapping("/myApply")
    @ApiOperation(value = "查询我发起的申请", response = ConsultationNotifyVO.class)
    public Result<PageData<ConsultationNotifyVO>> myApply(@RequestBody ConsultationNotifyQueryDTO params) {
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        params.setApplyDoctorId(user.getId());
        PageData<ConsultationNotifyVO> data = consultationNotifyInfoBizService.query(params);
        return new Result<PageData<ConsultationNotifyVO>>().ok(data);
    }


}
