package com.xxh.cloud.healthy.mdt.api.bean.bo;

import java.util.Date;
import java.util.List;

public class ConsultationBO {

    /**
     * id
     */
    private String id;

    /**
     * 会诊单名称
     */
    private String name;

    /**
     * 申请单详细内容
     */
    private String remark;

    /**
     * 患者编号
     */
    private String patientId;

    /**
     * 住院号
     */
    private String inpatientId;

    /**
     * 门诊号
     */
    private String visitId;

    /**
     * 相关疾病ID
     */
    private String diseaseId;

    /**
     * 申请时间
     */
    private Date applyTime;

    /**
     * 申请负责医生ID
     */
    private String applyDoctorId;

    /**
     * 申请医生姓名
     */
    private String applyDoctorName;

    /**
     * 申请科室编号
     */
    private String applyDeptId;

    /**
     * 申请科室名称
     */
    private String applyDeptName;

    /**
     * 提交时间
     */
    private Date submitTime;

    /**
     * 提交医生ID
     */
    private String submitDoctorId;

    /**
     * 提交医生姓名
     */
    private String submitDoctorName;

    /**
     * 所在科室ID
     */
    private String submitDeptId;

    /**
     * 所在科室名称
     */
    private String submitDeptName;

    /**
     * 所在护士站[病房]ID
     */
    private String wardCode;

    /**
     * 所在护士站[病房]名称
     */
    private String wardName;

    /**
     * 过期时间
     */
    private Date overdueTime;

    /**
     * 会诊时间
     */
    private Date consultationTime;

    /**
     * 会诊地点
     */
    private String consultationVenue;

    /**
     * 总结内容
     */
    private String summary;

    /**
     * 总结时间
     */
    private Date summaryTime;

    /**
     * 总结人
     */
    private String summaryUserId;

    /**
     * 会诊图片列表
     */
    private List<String> images;

    /**
     * 状态
     */
    private String status;

    /**
     * 患者姓名
     */
    private String patientName;

    /**
     * 患者性别
     */
    private String patientSex;

    /**
     * 患者年龄
     */
    private Integer patientAge;

    /**
     * 病种名称
     */
    private String diseaseName;

    // 医生
    private List<ConsultationDoctorBO> consultationDoctorList;

    // 结论
    private List<HisConsultationAdviceBO> hisConsultationAdviceList;

    /**
     * 会诊类型
     */
    private String applyType;

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getPatientSex() {
        return patientSex;
    }

    public void setPatientSex(String patientSex) {
        this.patientSex = patientSex;
    }

    public Integer getPatientAge() {
        return patientAge;
    }

    public void setPatientAge(Integer patientAge) {
        this.patientAge = patientAge;
    }

    public String getDiseaseName() {
        return diseaseName;
    }

    public void setDiseaseName(String diseaseName) {
        this.diseaseName = diseaseName;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getInpatientId() {
        return inpatientId;
    }

    public void setInpatientId(String inpatientId) {
        this.inpatientId = inpatientId;
    }

    public String getVisitId() {
        return visitId;
    }

    public void setVisitId(String visitId) {
        this.visitId = visitId;
    }

    public String getDiseaseId() {
        return diseaseId;
    }

    public void setDiseaseId(String diseaseId) {
        this.diseaseId = diseaseId;
    }

    public Date getApplyTime() {
        return applyTime;
    }

    public void setApplyTime(Date applyTime) {
        this.applyTime = applyTime;
    }

    public String getApplyDoctorId() {
        return applyDoctorId;
    }

    public void setApplyDoctorId(String applyDoctorId) {
        this.applyDoctorId = applyDoctorId;
    }

    public String getApplyDoctorName() {
        return applyDoctorName;
    }

    public void setApplyDoctorName(String applyDoctorName) {
        this.applyDoctorName = applyDoctorName;
    }

    public String getApplyDeptId() {
        return applyDeptId;
    }

    public void setApplyDeptId(String applyDeptId) {
        this.applyDeptId = applyDeptId;
    }

    public String getApplyDeptName() {
        return applyDeptName;
    }

    public void setApplyDeptName(String applyDeptName) {
        this.applyDeptName = applyDeptName;
    }

    public Date getSubmitTime() {
        return submitTime;
    }

    public void setSubmitTime(Date submitTime) {
        this.submitTime = submitTime;
    }

    public String getSubmitDoctorId() {
        return submitDoctorId;
    }

    public void setSubmitDoctorId(String submitDoctorId) {
        this.submitDoctorId = submitDoctorId;
    }

    public String getSubmitDoctorName() {
        return submitDoctorName;
    }

    public void setSubmitDoctorName(String submitDoctorName) {
        this.submitDoctorName = submitDoctorName;
    }

    public String getSubmitDeptId() {
        return submitDeptId;
    }

    public void setSubmitDeptId(String submitDeptId) {
        this.submitDeptId = submitDeptId;
    }

    public String getSubmitDeptName() {
        return submitDeptName;
    }

    public void setSubmitDeptName(String submitDeptName) {
        this.submitDeptName = submitDeptName;
    }

    public String getWardCode() {
        return wardCode;
    }

    public void setWardCode(String wardCode) {
        this.wardCode = wardCode;
    }

    public String getWardName() {
        return wardName;
    }

    public void setWardName(String wardName) {
        this.wardName = wardName;
    }

    public Date getOverdueTime() {
        return overdueTime;
    }

    public void setOverdueTime(Date overdueTime) {
        this.overdueTime = overdueTime;
    }

    public Date getConsultationTime() {
        return consultationTime;
    }

    public void setConsultationTime(Date consultationTime) {
        this.consultationTime = consultationTime;
    }

    public String getConsultationVenue() {
        return consultationVenue;
    }

    public void setConsultationVenue(String consultationVenue) {
        this.consultationVenue = consultationVenue;
    }

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    public Date getSummaryTime() {
        return summaryTime;
    }

    public void setSummaryTime(Date summaryTime) {
        this.summaryTime = summaryTime;
    }

    public String getSummaryUserId() {
        return summaryUserId;
    }

    public void setSummaryUserId(String summaryUserId) {
        this.summaryUserId = summaryUserId;
    }

    public List<String> getImages() {
        return images;
    }

    public void setImages(List<String> images) {
        this.images = images;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public List<ConsultationDoctorBO> getConsultationDoctorList() {
        return consultationDoctorList;
    }

    public void setConsultationDoctorList(List<ConsultationDoctorBO> consultationDoctorList) {
        this.consultationDoctorList = consultationDoctorList;
    }

    public String getApplyType() {
        return applyType;
    }

    public void setApplyType(String applyType) {
        this.applyType = applyType;
    }

    public List<HisConsultationAdviceBO> getHisConsultationAdviceList() {
        return hisConsultationAdviceList;
    }

    public void setHisConsultationAdviceList(List<HisConsultationAdviceBO> hisConsultationAdviceList) {
        this.hisConsultationAdviceList = hisConsultationAdviceList;
    }

}
