package com.xxh.cloud.healthy.mdt.api.constant;

public class ConsultationConstant {
    
    /**
     * 会诊信息整体状态
     */
    public enum ConsultationStatus {

        INVITE("invite", "发起会诊"), // 由海泰同步过来进行会诊操作
        START("start", "开始会诊"),
        DONE("done", "会诊结束"),
        CANCEL("cancel", "会诊取消"),
        EXPIRE("expire", "会诊过期"),

        ;

        private String code;
        private String msg;

        private ConsultationStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
    /**
     * 会诊医生类型
     */
    public enum DoctorType {

        APPOINT("appoint", "指定"),
        ALTERNATE("alternate", "候补"),

        ;

        private String code;
        private String msg;

        private DoctorType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

    /**
     * 会诊医生是否参与会诊及参与会诊状态
     */
    public enum DoctorStatus {

        // INITIATION("initiation", "发起会诊"), // 若发起人不属于会诊医生则为该状态（如会诊秘书），若属于会诊医生则为其他状态
        // ALTERNATE("alternate", "备选状态"), // 备选人员的状态，当备选医生对应的医生拒绝邀请的时候选择备选医生并更新状态为TODO
        TODO("todo", "待处理邀请"), // 三种处理方式：参加、拒绝、超时
        JOIN("join", "参加邀请"), // 只有参加邀请才能签到
        SIGN("sign", "会诊签到"), // 只有签到状态才能填写会诊意见
        ADVICE("advice", "会诊意见"),
        REFUSE("refuse", "会诊拒绝"),
        TIMEOUT("timeout", "会诊超时"), // 超时未处理自动设置的状态

        
        FINISH("finish", "完成会诊"), // 普通会诊的医生状态
        ;

        private String code;
        private String msg;

        private DoctorStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
    /**
     * 会诊类型
     */
    public enum ConsultationType {

        ORDINARY("0", "普通会诊"),
        MDT("1", "MDT会诊"),
        Nursing("2", "护理会诊"),

        ;

        private String code;
        private String msg;

        private ConsultationType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
    /**
     * 会诊目标类型
     */
    public enum ConsultationTargetType {

        Error("-2", "解析错误"),
        Invalid("-1", "无效目标"),
        NONE("0", "无目标"),
        Change_Dept("1", "转科"),
        Follow_Up("2", "随访"),
        Therapy_Change_Dept("3", "治疗后转科"),

        ;

        private String code;
        private String msg;

        private ConsultationTargetType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
    /**
     * 会诊目标子类型
     */
    public enum ConsultationTargetSubType {

        // 转科
        Change_Now("1-1", "立即转科"),
        Change_Inpatient("1-2", "出院再入院转科"),
        Change_Visit("1-3", "出院后再就诊"),

        ;

        private String code;
        private String msg;

        private ConsultationTargetSubType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
    /**
     * 会诊目标类型
     */
    public enum ConsultationTargetStatus {

        DOING("doing", "目标进行中"),
        DONE("done", "目标完成"),

        ;

        private String code;
        private String msg;

        private ConsultationTargetStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
    
}
