package com.xxh.cloud.healthy.mdt.api.constant;

public class ConsultationLaunchApplyConstant {
    
    /**
     * 会诊信息整体状态
     */
    public enum ApplyStatus {

        TODO("todo", "保存申请"),   // 只保存不进行其他操作

        START("start", "发起会诊提醒"),   // 给目标医生进行发起会诊提醒
        START_EXPIRE("start_expire", "申请过期"), // 申请会诊过期（已申请发起会诊但未发起会诊）

        DOING("doing", "会诊进行中"),   // 目标医生已发起会诊，但未完成会诊
        EXPIRE("expire", "会诊过期"), // 会诊过期（已发起会诊但未完成）

        DONE("done", "会诊完成"),     // 完成会诊（已有会诊结论）

        CANCEL("cancel", "申请取消"), // 对还未完成/未过期的会诊进行取消操作

        TIMEOUT_UNDOING("timeout_undoing", "超时未发起"),
        TIMEOUT_UNDONE("timeout_undone", "超时未完成"),

        ;

        private String code;
        private String msg;

        private ApplyStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }

    /**
     * 发起会诊申请日志类型
     */
    public enum ApplyLogType {

        NEW_SEND("new_send", "初次发送"),

        RESEND("resend", "重发"),

        ;

        private String code;
        private String msg;

        private ApplyLogType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }

    /**
     * 会诊申请类型
     */
    public enum Type {

        Ordinary("ordinary", "普通会诊申请"),

        Task("task", "自动会诊申请"),

        ;

        private String code;
        private String msg;

        private Type(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }

    /**
     * 申诉类型
     */
    public enum ExamineType {

        CANCEL("cancel", "取消会诊"),

        ;

        private String code;
        private String msg;

        private ExamineType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }

    /**
     * 申诉状态
     */
    public enum ExamineState {

        INIT("init", "发起申诉"),
        PASS("pass", "已通过"),
        REFUSE("refuse", "已拒绝"),

        ;

        private String code;
        private String msg;

        private ExamineState(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }

    }
}
