package com.xxh.cloud.healthy.mdt.framework.modules.analysis;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

// 会诊结论目标解析(模板解析)
@Slf4j
@Component
public class HAnalysisTempHelper {

//    public static String isFollowUp = "我科随访";
//    public static String zk1 = "建议48小时内转科治疗";
//    public static String zk2 = "完善相关检查、检验后转科治疗";
//    public static String zk3 = "放疗或化疗疗程结束后转科治疗";
//    public static String zk4 = "立即转科";


    // 获取会诊结论目标解析数据
    public static HAnalysisDataModel getAnalysisData(String content, List<String> isFollowUp, List<String> isChangeDept) {
        HAnalysisDataModel dataModel = new HAnalysisDataModel();

        try {
            getFollowUpInfo(content, dataModel, isFollowUp);
            getChangeDept(content, dataModel, isChangeDept);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return dataModel;
    }

    private static void getFollowUpInfo(String content, HAnalysisDataModel dataModel, List<String> isFollowUp) {
        if (contentKeyWord(content, isFollowUp)) {
            dataModel.setIsFollowUp("Y");
            int st = content.lastIndexOf("我科随访");
            String k = content.substring(st, st + 10);
            String[] kList = k.split(" ");
            if (kList.length == 3) {
                dataModel.setFollowUpDate(kList[1]);
                dataModel.setFollowUpDateUnit(kList[2].substring(0, 1));
            }
        } else {
            dataModel.setIsFollowUp("N");
        }
    }

    private static void getChangeDept(String content, HAnalysisDataModel dataModel, List<String> isChangeDept) {
        if (contentKeyWord(content, isChangeDept)) {
            dataModel.setIsChangeDept("Y");
        } else {
            dataModel.setIsChangeDept("N");
        }
    }

    private static boolean contentKeyWord(String content, List<String> keyWords) {
        for (String str : keyWords) {
            if (content.lastIndexOf(str) >= 0) {
                return true;
            }
        }
        return false;
    }

    public static void main(String[] args) {
//        HAnalysisDataModel model = getAnalysisData("转我科行腹腔镜下胆囊切除术，我科随访， 1 周随访一次。建议48小时内转科治疗，转入科室：急诊医学科东区");
//        System.out.println(JSONObject.toJSONString(model));
    }


}


