package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * MDT会诊意见信息表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_advice_info")
public class ConsultationAdviceInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊ID
     */
     @ApiModelProperty(value = "会诊ID")
      private String consultationId;

    /**
     * 会诊医生ID
     */
     @ApiModelProperty(value = "会诊医生ID")
      private String doctorId;

    /**
     * 意见内容
     */
     @ApiModelProperty(value = "意见内容")
      private String advice;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
