package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * MDT会诊医生信息表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_doctor_info")
public class ConsultationDoctorInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊ID
     */
     @ApiModelProperty(value = "会诊ID")
      private String consultationId;

    /**
     * 会诊科室编号
     */
     @ApiModelProperty(value = "会诊科室编号")
      private String deptCode;

    /**
     * 会诊科室名称
     */
     @ApiModelProperty(value = "会诊科室名称")
      private String deptName;

    /**
     * 会诊医生ID
     */
     @ApiModelProperty(value = "会诊医生ID")
      private String doctorId;

    /**
     * 会诊医生名称
     */
     @ApiModelProperty(value = "会诊医生名称")
      private String doctorName;

    /**
     * 会诊医生职责编号
     */
     @ApiModelProperty(value = "会诊医生职责编号")
      private String dutyCode;

    /**
     * 会诊医生职责名称
     */
     @ApiModelProperty(value = "会诊医生职责名称")
      private String dutyName;

    /**
     * 人员分类[指定/替补]
     */
     @ApiModelProperty(value = "人员分类[指定/替补]")
      private String doctorType;

    /**
     * 替补的医生ID
     */
     @ApiModelProperty(value = "替补的医生ID")
      private String transferDoctorId;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 描述
     */
     @ApiModelProperty(value = "描述")
      private String remark;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opTime;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
