package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * MDT会诊信息表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_info")
public class ConsultationInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊单名称
     */
     @ApiModelProperty(value = "会诊单名称")
      private String name;

    /**
     * 申请单详细内容
     */
     @ApiModelProperty(value = "申请单详细内容")
      private String remark;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inpatientId;

    /**
     * 门诊号
     */
     @ApiModelProperty(value = "门诊号")
      private String visitId;

    /**
     * 相关疾病ID
     */
     @ApiModelProperty(value = "相关疾病ID")
      private String diseaseId;

    /**
     * 申请时间
     */
     @ApiModelProperty(value = "申请时间")
      private Date applyTime;

    /**
     * 申请负责医生ID
     */
     @ApiModelProperty(value = "申请医生ID")
      private String applyDoctorId;

    /**
     * 申请医生姓名
     */
     @ApiModelProperty(value = "申请医生姓名")
      private String applyDoctorName;

    /**
     * 申请科室编号
     */
     @ApiModelProperty(value = "申请科室编号")
      private String applyDeptId;

    /**
     * 申请科室名称
     */
     @ApiModelProperty(value = "申请科室名称")
      private String applyDeptName;

    /**
     * 提交时间
     */
     @ApiModelProperty(value = "提交时间")
      private Date submitTime;

    /**
     * 提交医生ID
     */
     @ApiModelProperty(value = "提交医生ID")
      private String submitDoctorId;

    /**
     * 提交医生姓名
     */
     @ApiModelProperty(value = "提交医生姓名")
      private String submitDoctorName;

    /**
     * 所在科室ID
     */
     @ApiModelProperty(value = "所在科室ID")
      private String submitDeptId;

    /**
     * 所在科室名称
     */
     @ApiModelProperty(value = "所在科室名称")
      private String submitDeptName;

    /**
     * 所在护士站[病房]ID
     */
     @ApiModelProperty(value = "所在护士站[病房]ID")
      private String wardCode;

    /**
     * 所在护士站[病房]名称
     */
     @ApiModelProperty(value = "所在护士站[病房]名称")
      private String wardName;

    /**
     * 过期时间
     */
     @ApiModelProperty(value = "过期时间")
      private Date overdueTime;

    /**
     * 会诊时间
     */
     @ApiModelProperty(value = "会诊时间")
      private Date consultationTime;

    /**
     * 会诊地点
     */
     @ApiModelProperty(value = "会诊地点")
      private String consultationVenue;

    /**
     * 总结内容
     */
     @ApiModelProperty(value = "总结内容")
      private String summary;

    /**
     * 总结时间
     */
     @ApiModelProperty(value = "总结时间")
      private Date summaryTime;

    /**
     * 总结人
     */
     @ApiModelProperty(value = "总结人")
      private String summaryUserId;

    /**
     * 会诊图片列表
     */
     @ApiModelProperty(value = "会诊图片列表")
      private String images;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 会诊类型
     */
     @ApiModelProperty(value = "会诊类型")
      private String applyType;

}
