package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 发起会诊申请转科统计信息表
 */
@Data
@TableName("mdt_consultation_launch_apply_change_stat_info")
public class ConsultationLaunchApplyChangeStatInfo {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 日期
     */
     @ApiModelProperty(value = "日期")
      private String dataTime;

    /**
     * 科室编号
     */
     @ApiModelProperty(value = "科室编号")
      private String deptId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;

    /**
     * 已完成会诊数量
     */
     @ApiModelProperty(value = "已完成会诊数量")
      private Integer finishNum;

    /**
     * 会诊转科数量
     */
     @ApiModelProperty(value = "会诊转科数量")
      private Integer changeNum;

    /**
     * 会诊立即转科数量
     */
     @ApiModelProperty(value = "会诊立即转科数量")
      private Integer changeNowNum;

    /**
     * 出院后转科入院数量
     */
     @ApiModelProperty(value = "出院后转科入院数量")
      private Integer outChangeNum;

    /**
     * 治疗后转科数量
     */
     @ApiModelProperty(value = "治疗后转科数量")
      private Integer therapyChangeNum;

    /**
     * 实际转科数量
     */
     @ApiModelProperty(value = "实际转科数量")
      private Integer realChangeNum;

    /**
     * 数据更新时间
     */
     @ApiModelProperty(value = "数据更新时间")
      private Date dataUpdateDate;

}
