package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 发起会诊申请信息表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_launch_apply_info")
public class ConsultationLaunchApplyInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊类型
     */
     @ApiModelProperty(value = "会诊类型")
      private String consultationType;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inpatientId;

    /**
     * 门诊号
     */
     @ApiModelProperty(value = "门诊号")
      private String visitId;

    /**
     * 相关疾病ID
     */
     @ApiModelProperty(value = "相关疾病ID")
      private String diseaseId;

    /**
     * 申请负责医生ID
     */
     @ApiModelProperty(value = "申请医生ID")
      private String applyDoctorId;

    /**
     * 发起会诊医生ID
     */
     @ApiModelProperty(value = "发起会诊医生ID")
      private String launchDoctorId;

    /**
     * 申请发起会诊内容
     */
     @ApiModelProperty(value = "申请发起会诊内容")
      private String content;

    /**
     * 实际发起申请会诊提醒的时间
     */
     @ApiModelProperty(value = "实际发起申请会诊提醒的时间")
      private Date applyTime;

    /**
     * 实际发起的会诊id
     */
     @ApiModelProperty(value = "实际发起的会诊id")
      private String consultationId;

    /**
     * 实际发起会诊的时间
     */
     @ApiModelProperty(value = "实际发起会诊的时间")
      private Date submitTime;

    /**
     * 实际会诊完成的时间
     */
     @ApiModelProperty(value = "实际会诊完成的时间")
      private Date finishTime;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 管理id
     */
     @ApiModelProperty(value = "管理id（对应DoctorManagePatientInfo）")
      private String manageId;

    /**
     * 申请类型[ConsultationLaunchApplyConstant.Type]
     */
     @ApiModelProperty(value = "申请类型[ConsultationLaunchApplyConstant.Type]")
      private String type;

    /**
     * 会诊标签id
     */
     @ApiModelProperty(value = "会诊标签id")
      private String consultationLabelId;

    /**
     * 重发标识
     */
    @ApiModelProperty(value = "重发标识")
    private String resendFlg;

    /**
     * 重发次数
     */
    @ApiModelProperty(value = "重发次数")
    private Integer resendCount;

    /**
     * 重发时间
     */
    @ApiModelProperty(value = "重发时间")
    private Date resendDate;

    /**
     * 重发操作人
     */
    @ApiModelProperty(value = "重发操作人")
    private String resendOpUserId;

    /**
     * 参加会诊部门
     */
    @ApiModelProperty(value = "参加会诊部门")
    private String joinDept;

    /**
     * ht任务状态
     */
    @ApiModelProperty(value = "ht任务状态")
    private String htTaskState;

    /**
     * ht任务返回
     */
    @ApiModelProperty(value = "ht任务返回")
    private String htTaskResult;

    /**
     * 住院信息日志
     */
    @ApiModelProperty(value = "住院信息日志")
    private String inpatientRecordLog;

    /**
     * 扩展字段1
     */
    @ApiModelProperty(value = "扩展字段1")
    private String extend1;

    /**
     * 扩展字段2
     */
    @ApiModelProperty(value = "扩展字段2")
    private String extend2;

    /**
     * 扩展字段3
     */
    @ApiModelProperty(value = "扩展字段3")
    private String extend3;

    @ApiModelProperty(value = "申诉类型")
    private String examineType;

    @ApiModelProperty(value = "申诉状态")
    private String examineState;

    @ApiModelProperty(value = "申诉描述")
    private String examineDescribe;

    @ApiModelProperty(value = "申诉描述")
    private Date examineDate;

    @ApiModelProperty(value = "审批内容")
    private String examineAuditInfo;

    @ApiModelProperty(value = "审批人")
    private String examineAuditUser;

    @ApiModelProperty(value = "审批时间")
    private Date examineAuditDate;
}
