package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 会诊申请超时统计表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_launch_apply_timeout_stat")
public class ConsultationLaunchApplyTimeoutStat extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 统计日期
     */
     @ApiModelProperty(value = "统计日期")
      private String statDate;

    /**
     * 会诊申请总数
     */
     @ApiModelProperty(value = "会诊申请总数")
      private Integer applyTotal;

    /**
     * 超过48小时未发起
     */
     @ApiModelProperty(value = "超过48小时未发起")
      private Integer undoing;

    /**
     * 发起后24小时未完成
     */
     @ApiModelProperty(value = "发起后24小时未完成")
      private Integer undone;

    /**
     * 24小时内完成
     */
    @ApiModelProperty(value = "24小时内完成")
    private Integer done;

    @ApiModelProperty(value = "超过48小时发起未完成")
    private Integer undone48;

    @ApiModelProperty(value = "未完成统计日期 48小时前")
    private String statDate48;

    @ApiModelProperty(value = "数量 48小时前")
    private Integer applyTotal48;

    @ApiModelProperty(value = "48小时提醒会诊数量")
    private Integer resendCount48;
}
