package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 会诊消息通知记录表
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("mdt_consultation_notify_info")
public class ConsultationNotifyInfo extends BaseEntity {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊申请id
     */
     @ApiModelProperty(value = "会诊申请id")
      private String applyId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 会诊病种id
     */
     @ApiModelProperty(value = "会诊病种id")
      private String diseaseId;

    /**
     * 会诊标签id
     */
    @ApiModelProperty(value = "会诊标签id")
    private String consultationLabelId;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 通知内容
     */
    @ApiModelProperty(value = "通知内容")
    private String notifyInfo;

    /**
     * 记录分类(发起/参与)
     */
    @ApiModelProperty(value = "记录分类")
    private String notifyType;

    /**
     * 实际发起的会诊id
     */
    @ApiModelProperty(value = "实际发起的会诊id")
    private String consultationId;

    /**
     * 通知状态
     */
    @ApiModelProperty(value = "通知状态")
    private String notifyStatus;

    /**
     * 会诊状态
     */
    @ApiModelProperty(value = "会诊状态")
    private String consultationStatus;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
