package com.xxh.cloud.healthy.mdt.framework.modules.base.entity;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * MDT会诊签到信息表
 */
@Data
@TableName("mdt_consultation_sign_info")
public class ConsultationSignInfo {
    
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 会诊ID
     */
     @ApiModelProperty(value = "会诊ID")
      private String consultationId;

    /**
     * 会诊医生ID
     */
     @ApiModelProperty(value = "会诊医生ID")
      private String doctorId;

    /**
     * 签到时间
     */
     @ApiModelProperty(value = "签到时间")
      private Date signTime;

    /**
     * 签到方式
     */
     @ApiModelProperty(value = "签到方式")
      private String signWay;

    /**
     * 签到位置-经度
     */
     @ApiModelProperty(value = "签到位置-经度")
      private String signLongitude;

    /**
     * 签到位置-纬度
     */
     @ApiModelProperty(value = "签到位置-纬度")
      private String signLatitude;

    /**
     * 签到IP
     */
     @ApiModelProperty(value = "签到IP")
      private String signIp;

}
