package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import java.util.Date;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class ConsultationDTO extends BaseEntity {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 会诊单名称
     */
    @ApiModelProperty(value = "会诊单名称")
    private String name;

    /**
     * 申请单详细内容
     */
    @ApiModelProperty(value = "申请单详细内容")
    private String remark;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 住院号
     */
    @ApiModelProperty(value = "住院号")
    private String inpatientId;

    /**
     * 门诊号
     */
    @ApiModelProperty(value = "门诊号")
    private String visitId;

    /**
     * 相关疾病ID
     */
    @ApiModelProperty(value = "相关疾病ID")
    private String diseaseId;

    /**
     * 申请时间
     */
    @ApiModelProperty(value = "申请时间")
    private Date applyTime;

    /**
     * 申请负责医生ID
     */
    @ApiModelProperty(value = "申请医生ID")
    private String applyDoctorId;

    /**
     * 申请医生姓名
     */
    @ApiModelProperty(value = "申请医生姓名")
    private String applyDoctorName;

    /**
     * 申请科室编号
     */
    @ApiModelProperty(value = "申请科室编号")
    private String applyDeptId;

    /**
     * 申请科室名称
     */
    @ApiModelProperty(value = "申请科室名称")
    private String applyDeptName;

    /**
     * 提交时间
     */
    @ApiModelProperty(value = "提交时间")
    private Date submitTime;

    /**
     * 提交医生ID
     */
    @ApiModelProperty(value = "提交医生ID")
    private String submitDoctorId;

    /**
     * 提交医生姓名
     */
    @ApiModelProperty(value = "提交医生姓名")
    private String submitDoctorName;

    /**
     * 所在科室ID
     */
    @ApiModelProperty(value = "所在科室ID")
    private String submitDeptId;

    /**
     * 所在科室名称
     */
    @ApiModelProperty(value = "所在科室名称")
    private String submitDeptName;

    /**
     * 所在护士站[病房]ID
     */
    @ApiModelProperty(value = "所在护士站[病房]ID")
    private String wardCode;

    /**
     * 所在护士站[病房]名称
     */
    @ApiModelProperty(value = "所在护士站[病房]名称")
    private String wardName;

    /**
     * 过期时间
     */
    @ApiModelProperty(value = "过期时间")
    private Date overdueTime;

    /**
     * 会诊时间
     */
    @ApiModelProperty(value = "会诊时间")
    private Date consultationTime;

    /**
     * 会诊地点
     */
    @ApiModelProperty(value = "会诊地点")
    private String consultationVenue;

    /**
     * 总结内容
     */
    @ApiModelProperty(value = "总结内容")
    private String summary;

    /**
     * 总结时间
     */
    @ApiModelProperty(value = "总结时间")
    private Date summaryTime;

    /**
     * 总结人
     */
    @ApiModelProperty(value = "总结人")
    private String summaryUserId;

    /**
     * 会诊图片
     */
    @ApiModelProperty(value = "会诊图片")
    private String images;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 会诊类型
     */
    @ApiModelProperty(value = "会诊类型")
    private String applyType;



    /**
     * 参加人的医生ID
     */
    @ApiModelProperty(value = "参加人的医生ID")
    private String joinDoctorId;

    /**
     * 参加人的人员分类[指定/替补]
     */
    @ApiModelProperty(value = "参加人的人员分类[指定/替补]")
    private String joinDoctorType;

    /**
     * 参加人替补的医生ID
     */
    @ApiModelProperty(value = "参加人替补的医生ID")
    private String transferDoctorId;

    /**
     * 参加状态
     */
    @ApiModelProperty(value = "参加状态")
    private String joinStatus;

    /**
     * 会诊医生职责编号
     */
    @ApiModelProperty(value = "会诊医生职责编号")
    private String dutyCode;

    /**
     * 会诊医生职责名称
     */
    @ApiModelProperty(value = "会诊医生职责名称")
    private String dutyName;

    /**
     * 会诊医生科室
     */
    @ApiModelProperty(value = "会诊医生科室")
    private String joinDeptCode;

}
