package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import java.util.Date;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class ConsultationDoctorUpdateDTO {

    @ApiModelProperty(value = "会诊医生数据id", required = true)
    @NotEmpty(message = "会诊医生数据id[id]不能为空")
    private String id;

    /**
     * 会诊科室编号
     */
    @ApiModelProperty(value = "会诊科室编号")
    private String deptCode;

    /**
     * 会诊科室名称
     */
    @ApiModelProperty(value = "会诊科室名称")
    private String deptName;

    /**
     * 会诊医生ID
     */
    @ApiModelProperty(value = "会诊医生ID", required = true)
    @NotEmpty(message = "会诊医生ID[doctorId]不能为空")
    private String doctorId;

    /**
     * 会诊医生名称
     */
    @ApiModelProperty(value = "会诊医生名称")
    private String doctorName;

    /**
     * 会诊医生职责编号
     */
    @ApiModelProperty(value = "会诊医生职责编号")
    private String dutyCode;

    /**
     * 会诊医生职责名称
     */
    @ApiModelProperty(value = "会诊医生职责名称")
    private String dutyName;

    /**
     * 人员分类[指定/替补]
     */
    @ApiModelProperty(value = "人员分类[指定/替补]")
    private String doctorType;

    /**
     * 替补的医生ID
     */
    @ApiModelProperty(value = "替补的医生ID")
    private String transferDoctorId;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 描述
     */
    @ApiModelProperty(value = "描述")
    private String remark;

    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    private Date opTime;

    /**
     * 申请负责医生ID
     */
    @ApiModelProperty(value = "申请医生ID")
    private String summaryUserId;

}
