package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 发起会诊申请信息表
 */
@Getter
@Setter
public class ConsultationLaunchApplyQueryDTO extends BasePageDTO {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 会诊类型
     */
    @ApiModelProperty(value = "会诊类型")
    private String consultationType;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inpatientId;

     @ApiModelProperty(value = "住院号列表")
      private List<String> inpatientIds;

    /**
     * 门诊号
     */
     @ApiModelProperty(value = "门诊号")
      private String visitId;

     @ApiModelProperty(value = "门诊号列表")
      private List<String> visitIds;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "患者编号列表")
    private List<String> patientIds;

    @ApiModelProperty(value = "患者名称")
    private String patientName;

    /**
     * 申请负责医生ID
     */
    @ApiModelProperty(value = "申请医生ID")
    private String applyDoctorId;

    /**
     * 发起会诊医生ID
     */
    @ApiModelProperty(value = "发起会诊医生ID")
    private String launchDoctorId;

    @ApiModelProperty(value = "发起部门ID")
    private String launchDept;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    @ApiModelProperty(value = "状态列表")
    private List<String> statuses;

    /**
     * 申请开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    /**
     * 申请结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    /**
     * 发起开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date applyStartDate;

    /**
     * 发起结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date applyEndDate;

    /**
     * 发起开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date submitStartDate;

    /**
     * 发起结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date submitEndDate;

    /**
     * 管理id
     */
    @ApiModelProperty(value = "管理id")
    private String manageId;

    /**
     * 管理id列表
     */
    @ApiModelProperty(value = "管理id列表")
    private List<String> manageIds;

    /**
     * 申请类型[ConsultationLaunchApplyConstant.Type]
     */
    @ApiModelProperty(value = "申请类型[ConsultationLaunchApplyConstant.Type]")
    private String type;

    @ApiModelProperty(value = "管理端查询标记[YN]")
    private String manageFlag;

    
    @ApiModelProperty(value = "自定义状态[1.未发起会诊申请、2.已发起会诊申请、3.已完成会诊、4.未完成会诊]")
    private String custStatus;

    @ApiModelProperty(value = "重发标识")
    private String resendFlg;

    @ApiModelProperty(value = "部门组")
    private String deptRelationId;

    @ApiModelProperty(value = "申诉类型")
    private String examineType;

    @ApiModelProperty(value = "申诉状态")
    private String examineState;
}
