package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 发起会诊申请信息表
 */
@Getter
@Setter
public class ConsultationLaunchApplyUpdateDTO {
    
    /**
     * id
     */
     @ApiModelProperty(value = "id", required = true)
     @NotEmpty(message = "id不能为空")
      private String id;

    /**
     * 会诊类型
     */
     @ApiModelProperty(value = "会诊类型")
      private String consultationType;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inpatientId;

    /**
     * 门诊号
     */
     @ApiModelProperty(value = "门诊号")
      private String visitId;

    /**
     * 相关疾病ID
     */
     @ApiModelProperty(value = "相关疾病ID")
      private String diseaseId;

    /**
     * 申请负责医生ID
     */
     @ApiModelProperty(value = "申请医生ID")
      private String applyDoctorId;

    /**
     * 发起会诊医生ID
     */
     @ApiModelProperty(value = "发起会诊医生ID")
      private String launchDoctorId;

    /**
     * 申请发起会诊内容
     */
     @ApiModelProperty(value = "申请发起会诊内容")
      private String content;

}
