package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class ConsultationSignQueryDTO {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 会诊ID
     */
    @ApiModelProperty(value = "会诊ID", required = true)
    @NotEmpty(message = "会诊ID[consultationId]不能为空")
    private String consultationId;

    /**
     * 会诊医生ID
     */
    @ApiModelProperty(value = "会诊医生ID")
    private String doctorId;

    /**
     * 会诊医生ID列表
     */
    @ApiModelProperty(value = "会诊医生ID列表")
    private List<String> doctorIds;

    /**
     * 签到时间
     */
    @ApiModelProperty(value = "签到时间")
    private Date signTime;

    /**
     * 签到方式
     */
    @ApiModelProperty(value = "签到方式")
    private String signWay;

}
