package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class HisConsultationAdviceQueryDTO extends BasePageDTO {
    
    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 会诊ID
     */
     @ApiModelProperty(value = "会诊ID")
      private String consultationId;

    /**
     * 会诊ID列表
     */
    @ApiModelProperty(value = "会诊ID列表")
    private List<String> consultationIds;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inpatientId;

    /**
     * 门诊号
     */
     @ApiModelProperty(value = "门诊号")
      private String visitId;

    /**
     * 被会诊科室编号
     */
     @ApiModelProperty(value = "被会诊科室编号")
      private String mdtDeptCode;

    /**
     * 被会诊科室名称
     */
     @ApiModelProperty(value = "被会诊科室名称")
      private String mdtDeptName;

    /**
     * 科室编号
     */
     @ApiModelProperty(value = "科室编号")
      private String deptCode;

    /**
     * 科室名称
     */
     @ApiModelProperty(value = "科室名称")
      private String deptName;

    /**
     * 护士站编号
     */
     @ApiModelProperty(value = "护士站编号")
      private String wardCode;

    /**
     * 护士站名称
     */
     @ApiModelProperty(value = "护士站名称")
      private String wardName;

    /**
     * 提交医生ID
     */
     @ApiModelProperty(value = "提交医生ID")
      private String submitDoctorId;

    /**
     * 提交医生名称
     */
     @ApiModelProperty(value = "提交医生名称")
      private String submitDoctorName;

    /**
     * 提交时间
     */
     @ApiModelProperty(value = "提交时间")
      private Date submitTime;

    /**
     * 状态[1 已会诊 0 未会诊]
     */
     @ApiModelProperty(value = "状态[1 已会诊 0 未会诊]")
      private String status;

      @ApiModelProperty(value = "开始时间")
      private Date startDate;
  
      @ApiModelProperty(value = "结束时间")
      private Date endDate;
  
    /**
     * 会诊目标类型
     */
    @ApiModelProperty(value = "会诊目标类型[ConsultationConstant.ConsultationTargetType]")
    private String targetType;

    /**
     * 会诊目标类型
     */
    @ApiModelProperty(value = "会诊目标类型[ConsultationConstant.ConsultationTargetStatus]")
    private String targetStatus;



    
    /**
     * 会诊类型
     */
    @ApiModelProperty(value = "会诊类型")
    private String applyType;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

}
