package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo;

import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationLaunchApplyTimeoutStat;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.math.BigDecimal;
import java.math.RoundingMode;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class ConsultationApplyTimeOutStat {

    @ApiModelProperty(value = "统计日期")
    private String statDate;

    @ApiModelProperty(value = "当日发起会诊数量")
    private Integer applyTotal;

    @ApiModelProperty(value = "48小时未发起")
    private Integer undoing;

    @ApiModelProperty(value = "发起后24小时未完成")
    private Integer undone;

    @ApiModelProperty(value = "24小时内完成")
    private Integer done;

    @ApiModelProperty(value = "未完成统计日期")
    private String statDate48;

    @ApiModelProperty(value = "超过48小时发起未完成")
    private Integer undone48;

    @ApiModelProperty(value = "数量 48小时前")
    private Integer applyTotal48;

    @ApiModelProperty(value = "48小时提醒会诊数量")
    private Integer resendCount48;

    @ApiModelProperty(value = "48小时完成会诊率 %")
    private BigDecimal completionRate;


    public ConsultationApplyTimeOutStat(ConsultationLaunchApplyTimeoutStat stat) {
        this.statDate = stat.getStatDate();
        this.applyTotal = stat.getApplyTotal();
        this.undoing = stat.getUndoing();
        this.undone = stat.getUndone();
        this.done = stat.getDone();
        this.statDate48 = stat.getStatDate48();
        this.undone48 = stat.getUndone48();
        this.applyTotal48 = stat.getApplyTotal48();
        this.resendCount48 = stat.getResendCount48();
        if (applyTotal48 != null) { // 计算会诊完成率
            if (applyTotal48 > 0) {
                BigDecimal completedCount = BigDecimal.valueOf(applyTotal48).subtract(BigDecimal.valueOf(undoing)).subtract(BigDecimal.valueOf(undone48));
                this.completionRate = completedCount.multiply(BigDecimal.valueOf(100)).divide(BigDecimal.valueOf(applyTotal48), 2, RoundingMode.HALF_UP);
            }
        }
    }
}
