package com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 发起会诊申请转科统计信息表
 */
@Getter
@Setter
public class ConsultationLaunchApplyChangeStatDetailVO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "科室编号")
    private String deptId;

    @ApiModelProperty(value = "科室名称")
    private String deptName;

    @ApiModelProperty(value = "病种ID")
    private String diseaseId;

    @ApiModelProperty(value = "会诊id")
    private String consultationId;

    @ApiModelProperty(value = "目标类型")
    private String targetType;

    @ApiModelProperty(value = "目标子类型")
    private String targetSubType;

    @ApiModelProperty(value = "目标状态")
    private String targetStatus;

    @ApiModelProperty(value = "病种名称")
    private String diseaseName;

    @ApiModelProperty(value = "提醒发起会诊时间")
    private Date applyTime;

    /////////// 会诊信息 //////////

    @ApiModelProperty(value = "会诊信息")
    private ConsultationVO consultationInfo;

    @ApiModelProperty(value = "会诊单名称")
    private String name;

    @ApiModelProperty(value = "申请单详细内容")
    private String remark;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "住院号")
    private String inpatientId;

    @ApiModelProperty(value = "门诊号")
    private String visitId;

    // @ApiModelProperty(value = "相关疾病ID")
    // private String diseaseId;

    // @ApiModelProperty(value = "申请时间")
    // private Date applyTime;

    @ApiModelProperty(value = "申请医生ID")
    private String applyDoctorId;

    @ApiModelProperty(value = "申请医生姓名")
    private String applyDoctorName;

    @ApiModelProperty(value = "申请科室编号")
    private String applyDeptId;

    @ApiModelProperty(value = "申请科室名称")
    private String applyDeptName;

    // @ApiModelProperty(value = "提交时间")
    // private Date submitTime;

    @ApiModelProperty(value = "提交医生ID")
    private String submitDoctorId;

    @ApiModelProperty(value = "提交医生姓名")
    private String submitDoctorName;

    @ApiModelProperty(value = "所在科室ID")
    private String submitDeptId;

    @ApiModelProperty(value = "所在科室名称")
    private String submitDeptName;

    @ApiModelProperty(value = "所在护士站[病房]ID")
    private String wardCode;

    @ApiModelProperty(value = "所在护士站[病房]名称")
    private String wardName;

    @ApiModelProperty(value = "过期时间")
    private Date overdueTime;

    @ApiModelProperty(value = "会诊时间")
    private Date consultationTime;

    @ApiModelProperty(value = "会诊地点")
    private String consultationVenue;

    @ApiModelProperty(value = "总结内容")
    private String summary;

    @ApiModelProperty(value = "总结时间")
    private Date summaryTime;

    @ApiModelProperty(value = "总结人")
    private String summaryUserId;

    @ApiModelProperty(value = "会诊图片列表")
    private List<String> images;

    @ApiModelProperty(value = "状态")
    private String status;

    @ApiModelProperty(value = "会诊类型")
    private String applyType;

    private List<ConsultationDoctorVO> consultationDoctorList;

    private List<HisConsultationAdviceVO> hisConsultationAdviceList;

    @ApiModelProperty(value = "参加人的医生ID")
    private String joinDoctorId;

    @ApiModelProperty(value = "参加人的人员分类[指定/替补]")
    private String joinDoctorType;

    @ApiModelProperty(value = "参加人替补的医生ID")
    private String transferDoctorId;

    @ApiModelProperty(value = "参加状态")
    private String joinStatus;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "患者电话")
    private String patientPhone;

    @ApiModelProperty(value = "患者性别")
    private String patientSex;

    @ApiModelProperty(value = "患者年龄")
    private String patientAge;

}
