package com.xxh.cloud.healthy.mdt.framework.modules.biz.helper;

import java.util.Map;
import java.util.stream.Collectors;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationDoctorBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.HisConsultationAdviceBO;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.*;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

public class ConsultationHelper {

    // public static String getConsultationId(){
    //     return StrUtil.format("MC{}", IdUtil.getSnowflake(5,6).nextIdStr());
    // }

    public static String getConsultationDoctorId(){
        return StrUtil.format("MCD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getConsultationSignId(){
        return StrUtil.format("MCS{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getConsultationAdviceId(){
        return StrUtil.format("MCA{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    // public static String getHisConsultationAdviceId(){
    //     return StrUtil.format("HMCA{}", IdUtil.getSnowflake(5,7).nextIdStr());
    // }

    public static String getConsultationLaunchApplyId(){
        return StrUtil.format("CLA{}", IdUtil.getSnowflake(5,8).nextIdStr());
    }

    public static String getConsultationNotifyId(){
        return StrUtil.format("CN{}", IdUtil.getSnowflake(5,9).nextIdStr());
    }

    public static ConsultationVO getConsultationVO(ConsultationInfo entity) {
        if (null == entity) {
            return null;
        }
        ConsultationVO vo = new ConsultationVO();
        vo.setId(entity.getId());
        vo.setName(entity.getName());
        vo.setRemark(entity.getRemark());
        vo.setPatientId(entity.getPatientId());
        vo.setInpatientId(entity.getInpatientId());
        vo.setVisitId(entity.getVisitId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setApplyTime(entity.getApplyTime());
        vo.setApplyDoctorId(entity.getApplyDoctorId());
        vo.setApplyDoctorName(entity.getApplyDoctorName());
        vo.setApplyDeptId(entity.getApplyDeptId());
        vo.setApplyDeptName(entity.getApplyDeptName());
        vo.setSubmitTime(entity.getSubmitTime());
        vo.setSubmitDoctorId(entity.getSubmitDoctorId());
        vo.setSubmitDoctorName(entity.getSubmitDoctorName());
        vo.setSubmitDeptId(entity.getSubmitDeptId());
        vo.setSubmitDeptName(entity.getSubmitDeptName());
        vo.setWardCode(entity.getWardCode());
        vo.setWardName(entity.getWardName());

        vo.setOverdueTime(entity.getOverdueTime());
        vo.setConsultationTime(entity.getConsultationTime());
        vo.setConsultationVenue(entity.getConsultationVenue());
        vo.setSummary(entity.getSummary());
        vo.setSummaryTime(entity.getSummaryTime());
        vo.setSummaryUserId(entity.getSummaryUserId());
        vo.setStatus(entity.getStatus());
        if (StrUtil.isNotBlank(entity.getImages())) {
            vo.setImages(StrJoinSplitUtils.split2List(entity.getImages()));
        }
        
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());

        vo.setApplyType(entity.getApplyType());

        return vo;
    }

    public static ConsultationVO getConsultationVO(ConsultationDTO entity) {
        if (null == entity) {
            return null;
        }
        ConsultationVO vo = new ConsultationVO();
        vo.setId(entity.getId());
        vo.setName(entity.getName());
        vo.setRemark(entity.getRemark());
        vo.setPatientId(entity.getPatientId());
        vo.setInpatientId(entity.getInpatientId());
        vo.setVisitId(entity.getVisitId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setApplyTime(entity.getApplyTime());
        vo.setApplyDoctorId(entity.getApplyDoctorId());
        vo.setApplyDoctorName(entity.getApplyDoctorName());
        vo.setApplyDeptId(entity.getApplyDeptId());
        vo.setApplyDeptName(entity.getApplyDeptName());
        vo.setSubmitTime(entity.getSubmitTime());
        vo.setSubmitDoctorId(entity.getSubmitDoctorId());
        vo.setSubmitDoctorName(entity.getSubmitDoctorName());
        vo.setSubmitDeptId(entity.getSubmitDeptId());
        vo.setSubmitDeptName(entity.getSubmitDeptName());
        vo.setWardCode(entity.getWardCode());
        vo.setWardName(entity.getWardName());

        vo.setOverdueTime(entity.getOverdueTime());
        vo.setConsultationTime(entity.getConsultationTime());
        vo.setConsultationVenue(entity.getConsultationVenue());
        vo.setRemark(entity.getRemark());
        vo.setSummary(entity.getSummary());
        vo.setSummaryTime(entity.getSummaryTime());
        vo.setSummaryUserId(entity.getSummaryUserId());
        vo.setStatus(entity.getStatus());
        if (StrUtil.isNotBlank(entity.getImages())) {
            vo.setImages(StrJoinSplitUtils.split2List(entity.getImages()));
        }

        vo.setJoinDoctorId(entity.getJoinDoctorId());
        vo.setJoinDoctorType(entity.getJoinDoctorType());
        vo.setJoinStatus(entity.getJoinStatus());
        vo.setTransferDoctorId(entity.getTransferDoctorId());

        vo.setApplyType(entity.getApplyType());
        
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static ConsultationDoctorVO getConsultationDoctorVO(ConsultationDoctorInfo entity) {
        if (null == entity) {
            return null;
        }
        ConsultationDoctorVO vo = new ConsultationDoctorVO();
        vo.setId(entity.getId());
        vo.setConsultationId(entity.getConsultationId());
        vo.setDeptCode(entity.getDeptCode());
        vo.setDeptName(entity.getDeptName());
        vo.setDoctorId(entity.getDoctorId());
        vo.setDoctorName(entity.getDoctorName());
        vo.setDutyCode(entity.getDutyCode());
        vo.setDutyName(entity.getDutyName());
        vo.setDoctorType(entity.getDoctorType());
        vo.setDoctorId(entity.getDoctorId());
        vo.setTransferDoctorId(entity.getTransferDoctorId());
        vo.setStatus(entity.getStatus());
        vo.setRemark(entity.getRemark());
        vo.setOpTime(entity.getOpTime());
        
        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static ConsultationSignVO getConsultationSignVO(ConsultationSignInfo entity) {
        if (null == entity) {
            return null;
        }
        ConsultationSignVO vo = new ConsultationSignVO();
        vo.setId(entity.getId());
        vo.setConsultationId(entity.getConsultationId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setSignTime(entity.getSignTime());
        vo.setSignWay(entity.getSignWay());
        vo.setSignLatitude(entity.getSignLatitude());
        vo.setSignLongitude(entity.getSignLongitude());
        vo.setSignIp(entity.getSignIp());
        return vo;
    }

    public static ConsultationAdviceVO getConsultationAdviceVO(ConsultationAdviceInfo entity) {
        if (null == entity) {
            return null;
        }
        ConsultationAdviceVO vo = new ConsultationAdviceVO();
        vo.setId(entity.getId());
        vo.setConsultationId(entity.getConsultationId());
        vo.setDoctorId(entity.getDoctorId());
        vo.setAdvice(entity.getAdvice());

        vo.setCreateDate(entity.getCreateDate());
        vo.setCreator(entity.getCreator());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.setUpdater(entity.getUpdater());
        return vo;
    }

    public static HisConsultationAdviceVO getHisConsultationAdviceVO(HisConsultationAdviceInfo entity) {
        if (null == entity) {
            return null;
        }
        HisConsultationAdviceVO vo = new HisConsultationAdviceVO();
        vo.setId(entity.getId());
        vo.setConsultationId(entity.getConsultationId());
        vo.setInpatientId(entity.getInpatientId());
        vo.setVisitId(entity.getVisitId());
        vo.setMdtDeptCode(entity.getMdtDeptCode());
        vo.setMdtDeptName(entity.getMdtDeptName());
        vo.setDeptCode(entity.getDeptCode());
        vo.setDeptName(entity.getDeptName());
        vo.setWardCode(entity.getWardCode());
        vo.setWardName(entity.getWardName());
        vo.setSubmitContent(entity.getSubmitContent());
        vo.setSubmitXmlContent(entity.getSubmitXmlContent());
        vo.setSubmitDoctorId(entity.getSubmitDoctorId());
        vo.setSubmitDoctorName(entity.getSubmitDoctorName());
        vo.setSubmitTime(entity.getSubmitTime());
        vo.setStatus(entity.getStatus());
        vo.setFollowup(entity.getFollowup());

        vo.setTargetType(entity.getTargetType());
        vo.setTargetSubType(entity.getTargetSubType());
        vo.setTarget(entity.getTarget());
        vo.setTargetFinishTime(entity.getTargetFinishTime());

        return vo;
    }

    public static ConsultationBO getConsultationBO(ConsultationVO vo) {
        if (null == vo) {
            return null;
        }
        ConsultationBO bo = new ConsultationBO();
        bo.setId(vo.getId());
        bo.setName(vo.getName());
        bo.setRemark(vo.getRemark());
        bo.setPatientId(vo.getPatientId());
        bo.setInpatientId(vo.getInpatientId());
        bo.setVisitId(vo.getVisitId());
        bo.setDiseaseId(vo.getDiseaseId());
        bo.setApplyTime(vo.getApplyTime());
        bo.setApplyDoctorId(vo.getApplyDoctorId());
        bo.setApplyDoctorName(vo.getApplyDoctorName());
        bo.setApplyDeptId(vo.getApplyDeptId());
        bo.setApplyDeptName(vo.getApplyDeptName());
        bo.setSubmitTime(vo.getSubmitTime());
        bo.setSubmitDoctorId(vo.getSubmitDoctorId());
        bo.setSubmitDoctorName(vo.getSubmitDoctorName());
        bo.setSubmitDeptId(vo.getSubmitDeptId());
        bo.setSubmitDeptName(vo.getSubmitDeptName());
        bo.setWardCode(vo.getWardCode());
        bo.setWardName(vo.getWardName());

        bo.setOverdueTime(vo.getOverdueTime());
        bo.setConsultationTime(vo.getConsultationTime());
        bo.setConsultationVenue(vo.getConsultationVenue());
        bo.setSummary(vo.getSummary());
        bo.setSummaryTime(vo.getSummaryTime());
        bo.setSummaryUserId(vo.getSummaryUserId());
        bo.setStatus(vo.getStatus());
        bo.setImages(vo.getImages());

        bo.setApplyType(vo.getApplyType());
        
        if (CollectionUtil.isNotEmpty(vo.getConsultationDoctorList())) {
            bo.setConsultationDoctorList(vo.getConsultationDoctorList().stream().map(ConsultationHelper::getConsultationDoctorBO).collect(Collectors.toList()));
        }
        
        if (CollectionUtil.isNotEmpty(vo.getHisConsultationAdviceList())) {
            bo.setHisConsultationAdviceList(vo.getHisConsultationAdviceList().stream().map(ConsultationHelper::getHisConsultationAdviceBO).collect(Collectors.toList()));
        }

        return bo;
    }

    public static ConsultationDoctorBO getConsultationDoctorBO(ConsultationDoctorVO vo) {
        if (null == vo) {
            return null;
        }
        ConsultationDoctorBO bo = new ConsultationDoctorBO();
        bo.setId(vo.getId());
        bo.setConsultationId(vo.getConsultationId());
        bo.setDeptCode(vo.getDeptCode());
        bo.setDeptName(vo.getDeptName());
        bo.setDoctorId(vo.getDoctorId());
        bo.setDoctorName(vo.getDoctorName());
        bo.setDutyCode(vo.getDutyCode());
        bo.setDutyName(vo.getDutyName());
        bo.setDoctorType(vo.getDoctorType());
        bo.setDoctorId(vo.getDoctorId());
        bo.setTransferDoctorId(vo.getTransferDoctorId());
        bo.setStatus(vo.getStatus());
        bo.setRemark(vo.getRemark());
        bo.setOpTime(vo.getOpTime());
        
        return bo;
    }

    public static HisConsultationAdviceBO getHisConsultationAdviceBO(HisConsultationAdviceVO vo) {
        if (null == vo) {
            return null;
        }
        HisConsultationAdviceBO bo = new HisConsultationAdviceBO();
        bo.setId(vo.getId());
        bo.setConsultationId(vo.getConsultationId());
        bo.setInpatientId(vo.getInpatientId());
        bo.setVisitId(vo.getVisitId());
        bo.setMdtDeptCode(vo.getMdtDeptCode());
        bo.setMdtDeptName(vo.getMdtDeptName());
        bo.setDeptCode(vo.getDeptCode());
        bo.setDeptName(vo.getDeptName());
        bo.setWardCode(vo.getWardCode());
        bo.setWardName(vo.getWardName());
        bo.setSubmitDoctorId(vo.getSubmitDoctorId());
        bo.setSubmitDoctorName(vo.getSubmitDoctorName());
        bo.setSubmitContent(vo.getSubmitContent());
        bo.setSubmitXmlContent(vo.getSubmitXmlContent());
        bo.setSubmitTime(vo.getSubmitTime());
        bo.setStatus(vo.getStatus());
        bo.setFollowup(vo.getFollowup());

        bo.setTargetType(vo.getTargetType());
        bo.setTargetSubType(vo.getTargetSubType());
        bo.setTarget(vo.getTarget());
        bo.setTargetFinishTime(vo.getTargetFinishTime());
        
        return bo;
    }

    public static ConsultationLaunchApplyVO getConsultationLaunchApplyVO(ConsultationLaunchApplyInfo entity) {
        if (null == entity) {
            return null;
        }
        ConsultationLaunchApplyVO vo = new ConsultationLaunchApplyVO();
        vo.setId(entity.getId());
        vo.setConsultationType(entity.getConsultationType());
        vo.setPatientId(entity.getPatientId());
        vo.setInpatientId(entity.getInpatientId());
        vo.setVisitId(entity.getVisitId());
        vo.setDiseaseId(entity.getDiseaseId());
        vo.setApplyDoctorId(entity.getApplyDoctorId());
        vo.setLaunchDoctorId(entity.getLaunchDoctorId());
        vo.setContent(entity.getContent());
        vo.setStatus(entity.getStatus());
        vo.setConsultationId(entity.getConsultationId());
        vo.setApplyTime(entity.getApplyTime());
        vo.setSubmitTime(entity.getSubmitTime());
        vo.setFinishTime(entity.getFinishTime());
        vo.setType(entity.getType());
        vo.setConsultationLabelId(entity.getConsultationLabelId());
        vo.setResendFlg(entity.getResendFlg());
        vo.setResendCount(entity.getResendCount());
        vo.setResendDate(entity.getResendDate());

        vo.setCreator(entity.getCreator());
        vo.setCreateDate(entity.getCreateDate());
        vo.setUpdater(entity.getUpdater());
        vo.setUpdateDate(entity.getUpdateDate());
        vo.resendEnable();         // 设定是否需要重发
        if (StrUtil.isNotEmpty(entity.getJoinDept())) {
            vo.setJoinDept(StrJoinSplitUtils.split2List(entity.getJoinDept()));
        }
        vo.setExamineType(entity.getExamineType());
        vo.setExamineState(entity.getExamineState());
        vo.setExamineDescribe(entity.getExamineDescribe());
        vo.setExamineDate(entity.getExamineDate());
        vo.setExamineAuditInfo(entity.getExamineAuditInfo());
        vo.setExamineAuditUser(entity.getExamineAuditUser());
        vo.setExamineAuditDate(entity.getExamineAuditDate());
        return vo;
    }

    public static ConsultationLaunchApplyLogVO getConsultationLaunchApplyLogVO(ConsultationLaunchApplyLog entity, Map<String, AdminUserBO> userMap) {
        ConsultationLaunchApplyLogVO vo = new ConsultationLaunchApplyLogVO();
        BeanUtil.copyProperties(entity, vo);
        if (MapUtil.isNotEmpty(userMap) && userMap.containsKey(vo.getOpUserId())) {
            AdminUserBO adminUserBO = userMap.get(vo.getOpUserId());
            vo.setOpUserName(adminUserBO.getRealName());
        }
        return vo;
    }
    
    public static ConsultationLaunchApplyStatVO getConsultationLaunchApplyStatVO(ConsultationLaunchApplyStatInfo entity) {
        ConsultationLaunchApplyStatVO vo = new ConsultationLaunchApplyStatVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }
    
    public static ConsultationLaunchApplyChangeStatVO getConsultationLaunchApplyChangeStatVO(ConsultationLaunchApplyChangeStatInfo entity) {
        ConsultationLaunchApplyChangeStatVO vo = new ConsultationLaunchApplyChangeStatVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }
}
