package com.xxh.cloud.healthy.mdt.framework.modules.biz.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationDoctorBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.HisConsultationAdviceBO;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.*;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;
import java.util.Map;
import java.util.stream.Collectors;

public class ConsultationNotifyConvert {

    public static ConsultationNotifyVO getConsultationNotifyVO(ConsultationNotifyInfo entity,
                                                               Map<String, PatientClientBO> patientMap,
                                                               Map<String, ConsultationLaunchApplyInfo> applyMap,
                                                               Map<String, AdminUserBO> applyDoctorMap,
                                                               Map<String, DeptBO> deptMap) {
        ConsultationNotifyVO vo = new ConsultationNotifyVO();
        BeanUtil.copyProperties(entity, vo);
        if (MapUtil.isNotEmpty(patientMap) && patientMap.containsKey(vo.getPatientId())) {
            PatientClientBO patient = patientMap.get(vo.getPatientId());
            vo.setPatientName(patient.getPatientName());
            vo.setPatientGender(patient.getPatientGenderStandard());
            vo.setPatientAge(patient.getAge());
        }
        if (MapUtil.isNotEmpty(applyMap) && applyMap.containsKey(vo.getApplyId())) {
            ConsultationLaunchApplyInfo applyInfo = applyMap.get(vo.getApplyId());
            vo.setApplyDoctorId(applyInfo.getApplyDoctorId());
            vo.setResendFlg(applyInfo.getResendFlg());
            vo.setResendDate(applyInfo.getResendDate());
            vo.setExamineType(applyInfo.getExamineType());
            vo.setExamineState(applyInfo.getExamineState());
            vo.setExamineDescribe(applyInfo.getExamineDescribe());
            vo.setExamineDate(applyInfo.getExamineDate());
            vo.setExamineAuditInfo(applyInfo.getExamineAuditInfo());
            vo.setExamineAuditUser(applyInfo.getExamineAuditUser());
            vo.setExamineAuditDate(applyInfo.getExamineAuditDate());
        }
        if (MapUtil.isNotEmpty(applyDoctorMap) && applyDoctorMap.containsKey(vo.getApplyDoctorId())) {
            AdminUserBO applyDoctor = applyDoctorMap.get(vo.getApplyDoctorId());
            vo.setApplyDoctorName(applyDoctor.getRealName());
            vo.setApplyDeptId(applyDoctor.getDeptId());
        }
        if (MapUtil.isNotEmpty(deptMap) && deptMap.containsKey(vo.getApplyDeptId())) {
            DeptBO applyDept = deptMap.get(vo.getApplyDeptId());
            vo.setApplyDeptName(applyDept.getName());
        }
        return vo;
    }
}
