package com.xxh.cloud.healthy.mdt.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyChangeStatDetailVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyChangeStatVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyStatVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationStatusStatDeptVO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationLaunchApplyChangeStatInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationLaunchApplyInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.HisConsultationAdviceInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDTO;

public interface ConsultationMapper {
    
    // @Select(" SELECT a.*, b.doctor_id AS joinDoctorId, b.doctor_type AS joinDoctorType, b.transfer_doctor_id AS transferDoctorId, b.status AS joinStatus " + 
    @Select(" SELECT DISTINCT a.* " + 
            " FROM mdt_consultation_info a " +
            " INNER JOIN mdt_consultation_doctor_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    IPage<ConsultationDTO> page(Page<ConsultationInfo> page, @Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    // @Select(" SELECT a.*, b.doctor_id AS joinDoctorId, b.doctor_type AS joinDoctorType, b.transfer_doctor_id AS transferDoctorId, b.status AS joinStatus " + 
    @Select(" SELECT DISTINCT a.* " + 
            " FROM mdt_consultation_info a " +
            " INNER JOIN mdt_consultation_doctor_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    ConsultationDTO detail(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    @Select(" SELECT a.* " + 
            " FROM mdt_consultation_info a " +
            " LEFT JOIN mdt_his_consultation_advice_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    IPage<ConsultationInfo> hisConsultationAdvicePage(Page<ConsultationInfo> page, @Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    @Select(" SELECT a.* " + 
            " FROM mdt_consultation_info a " +
            " LEFT JOIN mdt_his_consultation_advice_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    List<ConsultationInfo> hisConsultationAdviceList(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    @Select(" SELECT a.*, b.doctor_id AS joinDoctorId, b.doctor_type AS joinDoctorType, b.transfer_doctor_id AS transferDoctorId, b.status AS joinStatus, b.duty_code AS dutyCode, b.duty_name AS dutyName, b.dept_code AS joinDeptCode " + 
            " FROM mdt_consultation_info a " +
            " INNER JOIN mdt_consultation_doctor_info b ON a.id = b.consultation_id " +
            " ${ew.customSqlSegment} ")
    List<ConsultationDTO> expireDoctorList(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    /**
     * 获取一个替补学科医生
     */
    @Select(" SELECT a.id AS doctorId, a.real_name AS doctorName, a.dept_id AS deptId, b.name AS deptName, a.subject_code AS subjectCode, a.subject_role AS subjectRole " + 
            " FROM sys_user a " +
            " LEFT JOIN sys_dept b ON a.dept_id = b.id " + 
            " ${ew.customSqlSegment} ")
    Map<String, String> subjectDoctor(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    @Select(" SELECT a.id AS doctorId, a.real_name AS doctorName, a.dept_id AS deptId, b.name AS deptName, a.subject_code AS subjectCode, a.subject_role AS subjectRole " + 
            " FROM sys_user a " +
            " LEFT JOIN sys_dept b ON a.dept_id = b.id " + 
            " ${ew.customSqlSegment} ")
    List<Map<String, String>> subjectDoctorList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    

    // 统计状态数量
    @Select(" SELECT a.status, COUNT(1) count " + 
            " FROM ( " +
            "   SELECT DISTINCT a.id, a.status " +
            "   FROM mdt_consultation_info a " +
            "   INNER JOIN mdt_consultation_doctor_info b ON a.id = b.consultation_id " +
            "   ${ew.customSqlSegment} " +
            " ) a " +
            " GROUP BY a.status ")
    List<Map<String, Object>> statusCountStatistic(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    
    // 聚合统计mdt数量
    @Select(" SELECT a.name, COUNT(1) count " + 
            " FROM mdt_consultation_info a " +
            " ${ew.customSqlSegment} " +
            " GROUP BY a.name ")
    IPage<Map<String, Object>> statisticCountByGroup(Page<ConsultationInfo> page, @Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    // 查询参加会诊的医生信息
    @Select(" SELECT a.name, b.doctor_name doctorName " + 
            " FROM mdt_consultation_info a " +
            " INNER JOIN mdt_consultation_doctor_info b ON a.id = b.consultation_id " +
            " INNER JOIN mdt_consultation_advice_info c ON a.id = c.consultation_id AND b.doctor_id = c.doctor_id " +
            " ${ew.customSqlSegment} ")
    List<Map<String, Object>> statisticDoctorList(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);
    
    /**
     * 最新mdt信息
     */
    @Select(" SELECT * " + 
        " FROM mdt_consultation_info " + 
        " WHERE (patient_id, apply_time) IN ( " + 
        "   SELECT a.patient_id , MAX(a.apply_time) " + 
        "   FROM mdt_consultation_info a " + 
        "   ${ew.customSqlSegment} " + 
        "   GROUP BY a.patient_id " + 
        " ) ")
    List<ConsultationInfo> lastSimpleList(@Param(Constants.WRAPPER) Wrapper<ConsultationInfo> wrapper);

    @Select("  SELECT a.patient_id as patientId, a.label_id as labelId, b.disease_ids diseaseIds, b.name as labelName, b.consultation_subject_name consultationSubjectName, b.consultation_remark as consultationRemark, " +
            "  b.consultation_dept_ids as consultationDeptIds " +
            "  FROM h_patient_label_info a " +
            "  INNER JOIN s_md_standard_label_info b ON a.label_id = b.id  " +
            "  ${ew.customSqlSegment} ")
    List<Map<String, String>> patientLabelList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);


    // 查询部门
    @Select(" SELECT id " +
            " FROM sys_dept " +
            " ${ew.customSqlSegment} ")
    List<String> getHisDeptIds(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 标准标签信息表
    @Select("  SELECT * FROM s_md_standard_label_info  " +
            "  ${ew.customSqlSegment} ")
    List<Map<String, String>> standardLabelList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    @Select(" SELECT a.* " + 
            " FROM mdt_his_consultation_advice_info a " +
            " INNER JOIN mdt_consultation_info b ON a.consultation_id = b.id " +
            " ${ew.customSqlSegment} ")
    List<HisConsultationAdviceInfo> analysisHisConsultationAdviceList(@Param(Constants.WRAPPER) Wrapper<HisConsultationAdviceInfo> wrapper);
    
    // 查询参加会诊的医生信息
    @Select(" SELECT b.dept_id AS deptId, a.dept_id AS relationDeptId " + 
            " FROM dept_relation a " +
            " INNER JOIN dept_relation b ON a.group_id = b.group_id " +
            " ${ew.customSqlSegment} ")
    List<Map<String, String>> relationDeptList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    @Select(" SELECT a.* " + 
            " FROM mdt_his_consultation_advice_info a " +
            " INNER JOIN mdt_consultation_info b ON a.consultation_id = b.id " +
            " INNER JOIN hd_task_patient_info c ON b.patient_id = c.patient_id " +
            " ${ew.customSqlSegment} ")
    IPage<HisConsultationAdviceInfo> queryHisConsultationAdvicePage(Page<ConsultationInfo> page, @Param(Constants.WRAPPER) Wrapper<HisConsultationAdviceInfo> wrapper);

    // 查询参加会诊的医生信息
    @Select(" select t1.id from sys_user t1 inner join dept_relation t2 on t1.dept_id = t2.dept_id " +
            " ${ew.customSqlSegment} ")
    List<String> doctorIdsByRelationDept(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 查询参加会诊的医生信息
    @Select("select t3.group_id, t3.group_name, count(*) as total, count(case WHEN t1.`status` = 'timeout_undoing' THEN 1 END ) as undoing, count(case WHEN t1.`status` = 'timeout_undone' THEN 1 END ) as undone  " +
            " from mdt_consultation_launch_apply_info t1 " +
            " inner join sys_user t2 on t1.apply_doctor_id = t2.id " +
            " inner join dept_relation t3 on t2.dept_id = t3.dept_id " +
            " ${ew.customSqlSegment} " +
            "group by group_id, group_name ")
    List<ConsultationStatusStatDeptVO> groupByRelationDept(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    // 会诊申请状态统计
    @Select("SELECT COUNT(IF(status = 'start', '1', NULL)) startNum, " + 
            " COUNT(IF(status = 'start_expire', '1', NULL)) startExpireNum, " + 
            " COUNT(IF(status = 'doing', '1', NULL)) doingNum, " + 
            " COUNT(IF(status = 'expire', '1', NULL)) expireNum, " + 
            " COUNT(IF(status = 'done', '1', NULL)) doneNum, " +
            " COUNT(IF(status = 'cancel', '1', NULL)) cancelNum,  " +
            " COUNT(IF(status = 'timeout_undoing', '1', NULL)) timeoutUndoingNum, " +
            " COUNT(IF(status = 'timeout_undone', '1', NULL)) timeoutUndoneNum,  " +
            " COUNT(IF(status = 'done', '1', NULL)) doneNum,  " +
            " COUNT(IF(submit_time IS NULL AND finish_time IS NULL, '1', NULL)) realNotSubmitNum,  " +
            " COUNT(IF(submit_time IS NOT NULL AND finish_time IS NULL, '1', NULL)) realNotFinishNum,  " +
            " COUNT(IF(submit_time IS NOT NULL AND finish_time IS NOT NULL, '1', NULL)) realFinishNum  " +
            " FROM mdt_consultation_launch_apply_info " +
            " ${ew.customSqlSegment} ")
    ConsultationLaunchApplyStatisticVO consultationApplyStatusStatistic(@Param(Constants.WRAPPER) Wrapper<ConsultationLaunchApplyInfo> wrapper);

    // 会诊申请统计 // TODO 一个会诊可能对应多个会诊结论
    @Select("SELECT b.dept_id," + 
            " COUNT(1) startNum, " + 
            " COUNT(IF(a.submit_time IS NULL AND a.finish_time IS NULL, '1', NULL)) notApplyNum, " + 
            " COUNT(IF(a.submit_time IS NOT NULL, '1', NULL)) applyNum, " + 
            " COUNT(IF(a.submit_time IS NOT NULL AND a.finish_time IS NOT NULL, '1', NULL)) finishNum, " + 
            " COUNT(IF(a.examine_state = 'pass', '1', NULL)) examineNum, " +
            " COUNT(IF(c.target_type IS NOT NULL AND c.target_type = '1', '1', NULL)) changeNum,  " +
            " COUNT(IF(c.target_type IS NOT NULL AND c.target_type = '1' AND c.target_sub_type = '1-1', '1', NULL)) changeNowNum,  " +
            " COUNT(IF(c.target_type IS NOT NULL AND c.target_type = '1' AND c.target_sub_type = '1-2', '1', NULL)) outChangeNum,  " +
            " COUNT(IF(c.target_type IS NOT NULL AND c.target_type = '1' AND c.target_status = 'done', '1', NULL)) realChangeNum " +
            " FROM mdt_consultation_launch_apply_info a  " +
            " INNER JOIN sys_user b ON a.launch_doctor_id = b.id  " +
            " LEFT JOIN mdt_his_consultation_advice_info c ON a.consultation_id = c.consultation_id  " +
            " ${ew.customSqlSegment} ")
    List<ConsultationLaunchApplyStatVO> consultationApplyStatistic(@Param(Constants.WRAPPER) Wrapper<ConsultationLaunchApplyInfo> wrapper);

    // 会诊转科统计
    @Select("SELECT b.mdt_dept_code deptId, a.disease_id, " + 
            " COUNT(1) finishNum, " + 
            " COUNT(IF(b.target_type IS NOT NULL AND b.target_type = '1', '1', NULL)) changeNum, " + 
            " COUNT(IF(b.target_type IS NOT NULL AND b.target_type = '1' AND b.target_sub_type = '1-1', '1', NULL)) changeNowNum,  " +
            " COUNT(IF(b.target_type IS NOT NULL AND b.target_type = '1' AND b.target_sub_type = '1-2', '1', NULL)) outChangeNum,  " +
            " COUNT(IF(b.target_type IS NOT NULL AND b.target_type = '1' AND b.target_status = 'done', '1', NULL)) realChangeNum  " + 
            " FROM mdt_consultation_launch_apply_info a  " +
            " INNER JOIN mdt_his_consultation_advice_info b ON a.consultation_id = b.consultation_id  " +
            " ${ew.customSqlSegment} ")
    List<ConsultationLaunchApplyChangeStatVO> consultationChangeStatistic(@Param(Constants.WRAPPER) Wrapper<ConsultationLaunchApplyInfo> wrapper);

    @Select("SELECT a.id, a.disease_id, a.consultation_id, a.apply_time, b.mdt_dept_code deptId, b.target_type, b.target_sub_type, b.target_status " +
            " FROM mdt_consultation_launch_apply_info a  " +
            " INNER JOIN mdt_his_consultation_advice_info b ON a.consultation_id = b.consultation_id  " +
            " ${ew.customSqlSegment} ")
    IPage<ConsultationLaunchApplyChangeStatDetailVO> consultationChangeStatisticPage(Page<ConsultationLaunchApplyChangeStatInfo> page, @Param(Constants.WRAPPER) Wrapper<ConsultationLaunchApplyChangeStatInfo> wrapper);

}
