package com.xxh.cloud.healthy.mdt.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAdviceDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAdviceQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorUpdateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationFinishDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSummaryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationGetDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationJoinOrRefuseDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationManageCountStatisticQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSignDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSignQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationStartOrCancelDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationUpdateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.HisConsultationAdviceQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.HisConsultationSyncDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationAdviceVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationManageCountStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationDoctorVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationSignVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationStatusCountStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationVO;

public interface ConsultationBizService {
    
    void add(ConsultationAddDTO params);

    // 初始化会诊信息
    void addBatch(List<ConsultationAddDTO> params);
    
    // 修改会诊信息
    void update(ConsultationUpdateDTO params);

    ConsultationDoctorVO addDoctorAndSendMsg(ConsultationDoctorAddDTO params);

    // 修改会诊医生信息
    void updateDoctor(ConsultationDoctorUpdateDTO params);




    // 医生查询自己发起的或参加的会诊列表
    PageData<ConsultationVO> page(ConsultationQueryDTO params);
    
    // 查看会诊详情，加入的会诊可参加或拒绝，发起的会诊可开始或取消
    ConsultationVO detail(ConsultationGetDTO params);


    // 医生查询自己发起的或参加的会诊列表
    PageData<ConsultationVO> simplePage(ConsultationQueryDTO params);
    
    // 患者mdt会诊信息列表
    List<ConsultationVO> simpleList(ConsultationQueryDTO params);
    
    // 查看会诊详情，加入的会诊可参加或拒绝，发起的会诊可开始或取消
    ConsultationVO simpleDetail(ConsultationGetDTO params);

    // 最新的患者mdt会诊信息
    List<ConsultationVO> lastSimpleList(ConsultationQueryDTO params);
    






    // 会诊动态：发起、加入、拒绝、候补等医生的参会动态，参会医生操作
    List<ConsultationDoctorVO> trendsList(ConsultationDoctorQueryDTO params);


    // 会诊签到查询
    List<ConsultationSignVO> signList(ConsultationSignQueryDTO params);


    // 会诊意见，参会医生操作
    ConsultationAdviceVO ownerAdviceDetail(ConsultationAdviceQueryDTO params);


    // 会诊意见，发起人操作
    List<ConsultationAdviceVO> adviceList(ConsultationAdviceQueryDTO params);

    // 会诊意见，发起人操作
    ConsultationAdviceVO adviceDetail(ConsultationAdviceQueryDTO params);








    // 加入会诊，参会医生操作
    void join(ConsultationJoinOrRefuseDTO params);

    // 拒绝会诊，参会医生操作，通知候补医生
    void refuse(ConsultationJoinOrRefuseDTO params);

    // 拒绝会诊并指定会诊医生，参会医生操作，指定候补医生
    void refuseAndAppoint(ConsultationJoinOrRefuseDTO params);




    // 会诊签到，发起人操作
    void sign(ConsultationSignDTO params);
    
    // 取消会诊签到，发起人操作
    void unsign(ConsultationSignDTO params);
    



    // 开始会诊，发起人操作
    void start(ConsultationStartOrCancelDTO params);

    // 取消会诊，发起人操作
    void cancel(ConsultationStartOrCancelDTO params);




    // 会诊意见，参会医生操作，包括发起人
    void advice(ConsultationAdviceDTO params);




    // 会诊总结，发起人操作
    void summary(ConsultationSummaryDTO params);

    // 会诊结案，发起人操作
    void finish(ConsultationFinishDTO params);



    
    // 统计状态数量
    List<ConsultationStatusCountStatisticVO> statusCountStatistic(String doctorId);

    // mdt会诊数量统计
    PageData<ConsultationManageCountStatisticVO> statisticCountByGroup(ConsultationManageCountStatisticQueryDTO params);

    // mdt会诊医生统计
    PageData<ConsultationManageCountStatisticVO> statisticDoctorByGroup(ConsultationManageCountStatisticQueryDTO params);

    // 同步并保存海泰会诊
    void syncConsultation(HisConsultationSyncDTO params);
    

    
    // 海泰会诊意见列表
    PageData<ConsultationVO> pageFull(HisConsultationAdviceQueryDTO params);

}
