package com.xxh.cloud.healthy.mdt.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorAlternateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorGetDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorUpdateStatusDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationDoctorVO;

public interface ConsultationDoctorBizService {

    ConsultationDoctorVO add(ConsultationDoctorAddDTO params);

    // 批量添加会诊医生，主要用于初始化所有会诊的医生
    void addBatch(List<ConsultationDoctorAddDTO> params);
    
    // 更新会诊医生状态，确定会诊医生是否参加/拒绝，若拒绝则提醒备选人员并更新备选人员为待处理状态
    void update(ConsultationDoctorUpdateStatusDTO params);

    // 更新会诊医生状态，确定会诊医生是否参加/拒绝，若拒绝则提醒备选人员并更新备选人员为待处理状态
    void updateBatch(List<ConsultationDoctorUpdateStatusDTO> params);

    // 会诊人员查询所有本次会诊医生信息及状态
    List<ConsultationDoctorVO> list(ConsultationDoctorQueryDTO params);
    
    // 详情
    ConsultationDoctorVO detail(ConsultationDoctorGetDTO params);
    
    // 候补人员
    ConsultationDoctorVO alternate(ConsultationDoctorAlternateDTO params);
    
    // 指定候补人员
    ConsultationDoctorVO appointAlternate(ConsultationDoctorAlternateDTO params);

    // 会诊医生动态
    List<ConsultationDoctorVO> trendsList(ConsultationDoctorQueryDTO params);

}
