package com.xxh.cloud.healthy.mdt.framework.modules.biz.service;

import java.util.List;
import java.util.Map;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationApplyTimeOutStat;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationLaunchApplyVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationStatusStatDeptVO;

public interface ConsultationLaunchApplyBizService {

    // 会诊申请列表
    PageData<ConsultationLaunchApplyVO> page(ConsultationLaunchApplyQueryDTO params);
    
    // 会诊申请列表
    ConsultationLaunchApplyStatisticVO statistic(ConsultationLaunchApplyQueryDTO params);
    
    // 会诊申请列表
    List<ConsultationLaunchApplyVO> list(ConsultationLaunchApplyQueryDTO params);
    
    // 会诊申请列表
    List<ConsultationLaunchApplyVO> simpleList(ConsultationLaunchApplyQueryDTO params);
    
    // 会诊申请详情
    ConsultationLaunchApplyVO detail(ConsultationLaunchApplyGetDTO params);
    
    // 保存会诊申请
    ConsultationLaunchApplyVO add(ConsultationLaunchApplyAddDTO params);

    // 更新会诊申请
    void update(ConsultationLaunchApplyUpdateDTO params);

    // 更新会诊申请
    void batchUpdateStatus(List<ConsultationLaunchApplyUpdateStatusDTO> params);

    // 发起会诊申请
    void launch(ConsultationLaunchApplyGetDTO params);

    // 保存并发起会诊申请
    void saveAndLaunch(ConsultationLaunchApplyAddDTO params);

    // 重新发起发起会诊申请
    void resendLaunch(ConsultationLaunchApplyGetDTO params);

    // 查询48小时未发起
    List<ConsultationLaunchApplyVO> listUndoing48H(String searchDate);

    // 查询48小时未完成
    List<ConsultationLaunchApplyVO> listUndone48H(String searchDate);

    // 查询发起后24小时未完成
    List<ConsultationLaunchApplyVO> listUndone24H(String searchDate);

    // 单日的统计明细,按照部门组
    List<ConsultationStatusStatDeptVO> statByDeptRelation(String searchDate);

    // 查询48小时的会诊申请
    List<ConsultationLaunchApplyVO> listApply48H(ConsultationLaunchApplyListDTO params);

    // 查询会诊超时信息
    List<ConsultationApplyTimeOutStat> searchTimeoutStat(Integer days);

    // 发起申诉
    void createExamine(ConsultationApplyExamineCreateDTO params);

    // 审批申诉
    void auditExamine(ConsultationApplyExamineAuditDTO params);
}
