package com.xxh.cloud.healthy.mdt.framework.modules.biz.service.impl;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import cn.hutool.core.lang.Validator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.pushtask.client.api.constant.PushTaskConstant;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationType;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationDoctorInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.ConsultationInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.HisConsultationAdviceInfo;
import com.xxh.cloud.healthy.mdt.framework.modules.base.service.ConsultationDoctorInfoService;
import com.xxh.cloud.healthy.mdt.framework.modules.base.service.ConsultationInfoService;
import com.xxh.cloud.healthy.mdt.framework.modules.base.service.HisConsultationAdviceInfoService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAdviceAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAdviceDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationAdviceQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorAlternateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorGetDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorUpdateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationDoctorUpdateStatusDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationFinishDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSummaryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationGetDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationJoinOrRefuseDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationManageCountStatisticQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSignAddDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSignDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationSignQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationStartOrCancelDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.ConsultationUpdateDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.HisConsultationAdviceQueryDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.HisConsultationSyncDTO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationAdviceVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationDoctorVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationManageCountStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationSignVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationStatusCountStatisticVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.ConsultationVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.HisConsultationAdviceVO;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.helper.ConsultationHelper;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.mapper.ConsultationMapper;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationAdviceBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationDoctorBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.ConsultationSignBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.HisConsultationAdviceBizService;
import com.xxh.cloud.healthy.mdt.third.bean.MdtSyncDataResp;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApply;
import com.xxh.cloud.healthy.mdt.third.utils.MdtApplyHttpUtil;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.metadata.client.api.StandardDiseaseClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class ConsultationBizServiceImpl implements ConsultationBizService {

    @Autowired
    private ConsultationInfoService consultationInfoService;
    @Autowired
    private ConsultationMapper consultationMapper;
    @Autowired
    private ConsultationDoctorBizService consultationDoctorBizService;
    @Autowired
    private ConsultationSignBizService consultationSignBizService;
    @Autowired
    private ConsultationAdviceBizService consultationAdviceBizService;
    @Autowired
    private PatientClientService patientClientService;
    @Autowired
    private StandardDiseaseClientService standardDiseaseClientService;
    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;
    @Autowired
    private ConsultationDoctorInfoService consultationDoctorInfoService;
    @Autowired
    private HisConsultationAdviceBizService hisConsultationAdviceBizService;
    @Autowired
    private HisConsultationAdviceInfoService hisConsultationAdviceInfoService;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ConsultationAddDTO params) {
        ValidatorUtils.validateEntity(params);

        ConsultationInfo entity = new ConsultationInfo();
        // entity.setId(ConsultationHelper.getConsultationId());
        entity.setId(params.getId());
        entity.setName(params.getName());
        entity.setRemark(params.getRemark());
        entity.setPatientId(params.getPatientId());
        entity.setInpatientId(params.getInpatientId());
        entity.setVisitId(params.getVisitId());
        entity.setDiseaseId(params.getDiseaseId());
        entity.setApplyTime(params.getApplyTime());
        entity.setApplyDoctorId(params.getApplyDoctorId());
        entity.setApplyDoctorName(params.getApplyDoctorName());
        entity.setApplyDeptId(params.getApplyDeptId());
        entity.setApplyDeptName(params.getApplyDeptName());
        entity.setSubmitTime(params.getSubmitTime());
        entity.setSubmitDoctorId(params.getSubmitDoctorId());
        entity.setSubmitDoctorName(params.getSubmitDoctorName());
        entity.setSubmitDeptId(params.getSubmitDeptId());
        entity.setSubmitDeptName(params.getSubmitDeptName());
        entity.setWardCode(params.getWardCode());
        entity.setWardName(params.getWardName());

        entity.setOverdueTime(params.getOverdueTime());
        entity.setConsultationTime(params.getConsultationTime());
        entity.setConsultationVenue(params.getConsultationVenue());
        entity.setSummary(params.getSummary());
        entity.setSummaryTime(params.getSummaryTime());
        entity.setSummaryUserId(params.getSummaryUserId());
        entity.setStatus(params.getStatus());
        entity.setRowsStatus(YN.YES.getCode());

        consultationInfoService.save(entity);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void addBatch(List<ConsultationAddDTO> params) {
        log.info("批量保存mdt会诊信息 >>>>> {}", JSON.toJSONString(params));
        if (CollectionUtil.isEmpty(params)) {
            return;
        }

        List<String> ids = new ArrayList<>();
        params.forEach(i -> {
            // ValidatorUtils.validateEntity(params);
            ids.add(i.getId());
        });

        // 查询是否存在会诊信息，存在的会诊过滤掉
        List<ConsultationInfo> existList = consultationInfoService.listByIds(ids);
        Map<String, ConsultationInfo> existMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(existList)) {
            existList.forEach(i -> existMap.put(i.getId(), i));
        }

        List<ConsultationInfo> entityList = new ArrayList<>();
        List<ConsultationInfo> updateList = new ArrayList<>();
        params.forEach(i -> {
            if (StrUtil.isBlank(i.getPatientId())) {
                return;
            }

            ConsultationInfo exist = existMap.get(i.getId());
            if (null != exist) {
                if ((StrUtil.isBlank(exist.getRemark()) || !Validator.hasChinese(exist.getRemark())) && StrUtil.isNotBlank(i.getRemark()) ) { // 不存在中文，认为是无效的记录
                    exist.setRemark(i.getRemark());
                    updateList.add(exist);
                }
                return;
            }

            ConsultationInfo entity = new ConsultationInfo();
            // entity.setId(ConsultationHelper.getConsultationId());
            entity.setId(i.getId());
            entity.setName(i.getName());
            entity.setRemark(i.getRemark());
            entity.setPatientId(i.getPatientId());
            entity.setInpatientId(i.getInpatientId());
            entity.setVisitId(i.getVisitId());
            entity.setDiseaseId(i.getDiseaseId());
            entity.setApplyTime(i.getApplyTime());
            entity.setApplyDoctorId(i.getApplyDoctorId());
            entity.setApplyDoctorName(i.getApplyDoctorName());
            entity.setApplyDeptId(i.getApplyDeptId());
            entity.setApplyDeptName(i.getApplyDeptName());
            entity.setSubmitTime(i.getSubmitTime());
            entity.setSubmitDoctorId(i.getSubmitDoctorId());
            entity.setSubmitDoctorName(i.getSubmitDoctorName());
            entity.setSubmitDeptId(i.getSubmitDeptId());
            entity.setSubmitDeptName(i.getSubmitDeptName());
            entity.setWardCode(i.getWardCode());
            entity.setWardName(i.getWardName());
    
            entity.setOverdueTime(i.getOverdueTime());
            entity.setConsultationTime(i.getConsultationTime());
            entity.setConsultationVenue(i.getConsultationVenue());
            entity.setRemark(i.getRemark());
            entity.setSummary(i.getSummary());
            entity.setSummaryTime(i.getSummaryTime());
            entity.setSummaryUserId(i.getSummaryUserId());
            entity.setStatus(i.getStatus());
            entity.setRowsStatus(YN.YES.getCode());

            entity.setApplyType(i.getApplyType());

            entityList.add(entity);
        });
        
        if (CollectionUtil.isNotEmpty(entityList)) {
            consultationInfoService.saveBatch(entityList);
        }
        if (CollectionUtil.isNotEmpty(updateList)) {
            consultationInfoService.updateBatchById(updateList);
        }
    }

    @Override
    public void update(ConsultationUpdateDTO params) {
        ValidatorUtils.validateEntity(params);

        ConsultationInfo entity = consultationInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            return;
        }
        // 会诊发起人才能修改
        if (!entity.getSummaryUserId().equals(params.getSummaryUserId())) {
            throw new BusinessException("权限不足");
        }

        entity.setId(params.getId());
        entity.setName(params.getName());
        entity.setPatientId(params.getPatientId());
        entity.setInpatientId(params.getInpatientId());
        entity.setVisitId(params.getVisitId());
        entity.setDiseaseId(params.getDiseaseId());
        entity.setApplyTime(params.getApplyTime());
        entity.setApplyDoctorId(params.getApplyDoctorId());
        entity.setApplyDoctorName(params.getApplyDoctorName());
        entity.setApplyDeptId(params.getApplyDeptId());
        entity.setApplyDeptName(params.getApplyDeptName());
        entity.setSubmitTime(params.getSubmitTime());
        entity.setSubmitDoctorId(params.getSubmitDoctorId());
        entity.setSubmitDoctorName(params.getSubmitDoctorName());
        entity.setSubmitDeptId(params.getSubmitDeptId());
        entity.setSubmitDeptName(params.getSubmitDeptName());
        entity.setWardCode(params.getWardCode());
        entity.setWardName(params.getWardName());
        entity.setOverdueTime(params.getOverdueTime());
        entity.setConsultationTime(params.getConsultationTime());
        entity.setConsultationVenue(params.getConsultationVenue());
        entity.setStatus(params.getStatus());

        entity.setApplyType(params.getApplyType());

        consultationInfoService.save(entity);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ConsultationDoctorVO addDoctorAndSendMsg(ConsultationDoctorAddDTO params) {
        // 保存会诊医生
        ConsultationDoctorVO consultationDoctor = consultationDoctorBizService.add(params);
        if (null == consultationDoctor) {
            throw new BusinessException("该医生已参加会诊");
        }

        // 保存到提醒
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        // TODO 暂时没有时间地点
        // List<ConsultationDoctorVO> doctorList = consultationVO.getConsultationDoctorList();
        // String title = StrUtil.format("【MDT会诊】拟{}，在{}举行{}，邀您参加，并准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getConsultationTime(), consultationVO.getConsultationVenue(), consultationVO.getName());
        // String content = StrUtil.format("拟{}，在{}举行{}，邀您参加，并准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getConsultationTime(), consultationVO.getConsultationVenue(), consultationVO.getName());
        // String title = StrUtil.format("【MDT会诊】邀您参加{}，请准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getName());
        // String content = StrUtil.format("邀您参加{}，请准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getName());
        // String title = StrUtil.isNotBlank(mdtTitle) ? StrUtil.format(mdtTitle, consultationVO.getName()) : consultationVO.getName();
        // String content = StrUtil.isNotBlank(mdtContent) ? StrUtil.format(mdtContent, consultationVO.getName()) : consultationVO.getName();

        Map<String, String> contentMap = new HashMap<>();
        contentMap.put("name", consultationVO.getName());
        contentMap.put("applyDeptName", consultationVO.getApplyDeptName());
        contentMap.put("applyDoctorName", consultationVO.getApplyDoctorName());

        DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
        remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
        remindDoctor.setDoctorId(consultationDoctor.getDoctorId());
        remindDoctor.setBizId(consultationDoctor.getConsultationId());
        remindDoctor.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
        remindDoctor.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
        remindDoctor.setTitle(consultationVO.getName());
        remindDoctor.setContent(JSON.toJSONString(contentMap));
        remindDoctor.setRemark("消息提醒");
        remindDoctor.setPushDate(DateUtil.date());
        remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        remindDoctor.setRowsStatus(YN.YES.getCode());
        
        doctorRemindInfoService.save(remindDoctor);

        return consultationDoctor;
    }

    @Override
    public void updateDoctor(ConsultationDoctorUpdateDTO params) {
        ValidatorUtils.validateEntity(params);

        ConsultationDoctorInfo entity = consultationDoctorInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            return;
        }

        ConsultationInfo consultation = consultationInfoService.getById(params.getId());
        if (null == consultation || YN.NO.getCode().equals(consultation.getRowsStatus())) {
            return;
        }
        // 会诊发起人才能修改
        if (!consultation.getSummaryUserId().equals(params.getSummaryUserId())) {
            throw new BusinessException("权限不足");
        }

        entity.setId(params.getId());
        entity.setDeptCode(params.getDeptCode());
        entity.setDeptName(params.getDeptName());
        entity.setDoctorId(params.getDoctorId());
        entity.setDoctorName(params.getDoctorName());
        entity.setDutyCode(params.getDutyCode());
        entity.setDutyName(params.getDutyName());
        entity.setDoctorType(params.getDoctorType());
        entity.setTransferDoctorId(params.getTransferDoctorId());
        entity.setStatus(params.getStatus());
        entity.setRemark(params.getRemark());

        consultationDoctorInfoService.save(entity);
    }

    @Override
    public PageData<ConsultationVO> page(ConsultationQueryDTO params) {
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> patientIds = new ArrayList<>();
        // 若按照患者名称筛选则先查询患者信息
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        // 查询会诊信息：区分本人发起的会诊和本人参加的会诊
        IPage<ConsultationDTO> page = consultationMapper.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<ConsultationInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .eq("b.rows_status", YN.YES.getCode())
                .notIn(StrUtil.isNotBlank(params.getDoctorId()), "b.status", ConsultationConstant.DoctorStatus.REFUSE.getCode(), ConsultationConstant.DoctorStatus.TIMEOUT.getCode()) // 拒绝或超时的会诊医生不能再看到该会诊
                // .eq(StrUtil.isNotBlank(params.getDoctorId()), "b.doctor_id", params.getDoctorId())
                .and(StrUtil.isNotBlank(params.getDoctorId()), i -> {
                    i.eq("b.doctor_id", params.getDoctorId()).or().eq("a.summary_user_id", params.getDoctorId());
                })
                .in(CollectionUtil.isNotEmpty(patientIds), "a.patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getStatus()), "a.status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getJoinStatus()), "b.status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "a.disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getApplyType()), "a.apply_type", params.getApplyType())
                .orderByDesc("a.apply_time")
        );

        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        // 查询患者与病种信息
        List<String> ids = new ArrayList<>();
        List<String> diseaseIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            ids.add(i.getId());
            patientIds.add(i.getPatientId());

            if (StrUtil.isNotBlank(i.getDiseaseId())) {
                diseaseIds.add(i.getDiseaseId());
            }
        });

        // 会诊医生
        Map<String, ConsultationDoctorVO> ownerConsultationMap = new HashMap<>(); // 本人的会诊信息
        Map<String, List<ConsultationDoctorVO>> consultationDoctorMap = new HashMap<>();
        ConsultationDoctorQueryDTO consultationDoctorQueryDTO = new ConsultationDoctorQueryDTO();
        consultationDoctorQueryDTO.setConsultationIds(ids);
        List<ConsultationDoctorVO> consultationDoctorList = consultationDoctorBizService.list(consultationDoctorQueryDTO);
        if (CollectionUtil.isNotEmpty(consultationDoctorList)) {
            consultationDoctorList.forEach(i -> {
                if (i.getDoctorId().equals(params.getDoctorId())) {
                    ownerConsultationMap.put(i.getConsultationId(), i);
                }

                List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(i.getConsultationId());
                if (null == doctorList) {
                    doctorList = new ArrayList<>();
                    consultationDoctorMap.put(i.getConsultationId(), doctorList);
                }
                doctorList.add(i);
            });
        }

        // 患者
        if (CollectionUtil.isEmpty(patientMap)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
        }
        
        // 病种
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
        diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
    
        PageData<ConsultationVO> data = new PageConverter<ConsultationDTO, ConsultationVO>() {
            @Override
            public ConsultationVO converter(ConsultationDTO entity) {
                ConsultationVO vo = ConsultationHelper.getConsultationVO(entity);

                // 本人会诊信息
                ConsultationDoctorVO ownerConsultation = ownerConsultationMap.get(vo.getId());
                if (null != ownerConsultation) {
                    vo.setJoinDoctorId(ownerConsultation.getDoctorId());
                    vo.setJoinDoctorType(ownerConsultation.getDoctorType());
                    vo.setJoinStatus(ownerConsultation.getStatus());
                    vo.setTransferDoctorId(ownerConsultation.getTransferDoctorId());
                }

                List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(vo.getId());
                vo.setConsultationDoctorList(doctorList);

                PatientClientBO patient = patientMap.get(vo.getPatientId());
                if (null != patient) {
                    vo.setPatientName(patient.getPatientName());
                    vo.setPatientSex(patient.getPatientGenderStandard());
                    vo.setPatientAge(patient.getAge());
                }

                if (null != vo.getDiseaseId()) {                    
                    StandardDiseaseBO disease = diseaseMap.get(vo.getDiseaseId());
                    if (null != disease) {
                        vo.setDiseaseName(disease.getName());
                    }
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }
    
    @Override
    public ConsultationVO detail(ConsultationGetDTO params) {
        ValidatorUtils.validateEntity(params);

        ConsultationDTO entity = consultationMapper.detail(new QueryWrapper<ConsultationInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .eq("b.rows_status", YN.YES.getCode())
                .notIn(StrUtil.isNotBlank(params.getDoctorId()), "b.status", ConsultationConstant.DoctorStatus.REFUSE.getCode(), ConsultationConstant.DoctorStatus.TIMEOUT.getCode()) // 拒绝或超时的会诊医生不能再看到该会诊
                // .eq(StrUtil.isNotBlank(params.getDoctorId()), "b.doctor_id", params.getDoctorId())
                .and(StrUtil.isNotBlank(params.getDoctorId()), i -> {
                    i.eq("b.doctor_id", params.getDoctorId()).or().eq("a.summary_user_id", params.getDoctorId());
                })
                .eq(StrUtil.isNotBlank(params.getId()), "a.id", params.getId())
        );
        if (null == entity) {
            return null;
        }

        ConsultationVO vo = ConsultationHelper.getConsultationVO(entity);

        // 本人的会诊信息，发起者可能没有
        if (StrUtil.isNotBlank(params.getDoctorId())) {
            ConsultationDoctorGetDTO consultationDoctorGetDTO = new ConsultationDoctorGetDTO();
            consultationDoctorGetDTO.setConsultationId(entity.getId());
            consultationDoctorGetDTO.setDoctorId(params.getDoctorId());
            ConsultationDoctorVO consultationDoctorVO = consultationDoctorBizService.detail(consultationDoctorGetDTO);
            if (null != consultationDoctorVO) {
                vo.setJoinDoctorId(consultationDoctorVO.getDoctorId());
                vo.setJoinDoctorType(consultationDoctorVO.getDoctorType());
                vo.setJoinStatus(consultationDoctorVO.getStatus());
                vo.setTransferDoctorId(consultationDoctorVO.getTransferDoctorId());
            }
        }

        // 会诊医生
        ConsultationDoctorQueryDTO consultationDoctorQueryDTO = new ConsultationDoctorQueryDTO();
        consultationDoctorQueryDTO.setConsultationId(entity.getId());
        List<ConsultationDoctorVO> consultationDoctorList = consultationDoctorBizService.list(consultationDoctorQueryDTO);
        vo.setConsultationDoctorList(consultationDoctorList);

        // 患者
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientId(entity.getPatientId());
        PatientClientBO patient = patientClientService.getOneSimple(patientQueryDTO);
        if (null != patient) {
            vo.setPatientName(patient.getPatientName());
            vo.setPatientSex(patient.getPatientGenderStandard());
            vo.setPatientAge(patient.getAge());
        }

        // 病种
        if (StrUtil.isNotBlank(vo.getDiseaseId())) {
            StandardDiseaseBO disease = standardDiseaseClientService.getById(vo.getDiseaseId());
            if (null != disease) {
                vo.setDiseaseName(disease.getName());
            }
        }

        return vo;
    }

    @Override
    public PageData<ConsultationVO> simplePage(ConsultationQueryDTO params) {
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> patientIds = new ArrayList<>();
        // 若按照患者名称筛选则先查询患者信息
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        // 查询会诊信息：区分本人发起的会诊和本人参加的会诊
        IPage<ConsultationInfo> page = consultationInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(patientIds), "patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getConsultationName()), "name", params.getConsultationName())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getApplyType()), "apply_type", params.getApplyType())
                .orderByDesc("apply_time")
        );

        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, page.getTotal());
        }

        // 查询患者与病种信息
        List<String> ids = new ArrayList<>();
        List<String> diseaseIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            ids.add(i.getId());
            patientIds.add(i.getPatientId());

            if (StrUtil.isNotBlank(i.getDiseaseId())) {
                diseaseIds.add(i.getDiseaseId());
            }
        });

        // 会诊医生
        Map<String, List<ConsultationDoctorVO>> consultationDoctorMap = new HashMap<>();
        ConsultationDoctorQueryDTO consultationDoctorQueryDTO = new ConsultationDoctorQueryDTO();
        consultationDoctorQueryDTO.setConsultationIds(ids);
        List<ConsultationDoctorVO> consultationDoctorList = consultationDoctorBizService.list(consultationDoctorQueryDTO);
        if (CollectionUtil.isNotEmpty(consultationDoctorList)) {
            consultationDoctorList.forEach(i -> {
                List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(i.getConsultationId());
                if (null == doctorList) {
                    doctorList = new ArrayList<>();
                    consultationDoctorMap.put(i.getConsultationId(), doctorList);
                }
                doctorList.add(i);
            });
        }

        // 患者
        if (CollectionUtil.isEmpty(patientMap)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
        }
        
        // 病种
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
        diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
    
        PageData<ConsultationVO> data = new PageConverter<ConsultationInfo, ConsultationVO>() {
            @Override
            public ConsultationVO converter(ConsultationInfo entity) {
                ConsultationVO vo = ConsultationHelper.getConsultationVO(entity);

                List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(vo.getId());
                vo.setConsultationDoctorList(doctorList);

                PatientClientBO patient = patientMap.get(vo.getPatientId());
                if (null != patient) {
                    vo.setPatientName(patient.getPatientName());
                    vo.setPatientSex(patient.getPatientGenderStandard());
                    vo.setPatientAge(patient.getAge());
                }

                if (null != vo.getDiseaseId()) {                    
                    StandardDiseaseBO disease = diseaseMap.get(vo.getDiseaseId());
                    if (null != disease) {
                        vo.setDiseaseName(disease.getName());
                    }
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }
    
    @Override
    public List<ConsultationVO> simpleList(ConsultationQueryDTO params) {
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> patientIds = new ArrayList<>();
        // 若按照患者名称筛选则先查询患者信息
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new ArrayList<>(0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        } else if (CollUtil.isNotEmpty(params.getPatientIds())) {
            patientIds.addAll(params.getPatientIds());
        }

        List<ConsultationInfo> list = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getDiseaseId()), "disease_id", params.getDiseaseId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(patientIds), "patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getConsultationName()), "name", params.getConsultationName())
                .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
                .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getApplyType()), "apply_type", params.getApplyType())
                .orderByDesc("apply_time")
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        // 查询患者与病种信息
        List<String> ids = new ArrayList<>();
        List<String> diseaseIds = new ArrayList<>();
        list.forEach(i -> {
            ids.add(i.getId());
            patientIds.add(i.getPatientId());

            if (StrUtil.isNotBlank(i.getDiseaseId())) {
                diseaseIds.add(i.getDiseaseId());
            }
        });

        // 会诊结论
        Map<String, List<HisConsultationAdviceVO>> hisConsultationAdviceMap = new HashMap<>();
        HisConsultationAdviceQueryDTO hisConsultationAdviceQueryDTO = new HisConsultationAdviceQueryDTO();
        hisConsultationAdviceQueryDTO.setConsultationIds(ids);
        List<HisConsultationAdviceVO> hisConsultationAdviceList = hisConsultationAdviceBizService.list(hisConsultationAdviceQueryDTO);
        if (CollectionUtil.isNotEmpty(hisConsultationAdviceList)) {
            hisConsultationAdviceList.forEach(i -> {
                List<HisConsultationAdviceVO> adviceList = hisConsultationAdviceMap.get(i.getConsultationId());
                if (null == adviceList) {
                    adviceList = new ArrayList<>();
                    hisConsultationAdviceMap.put(i.getConsultationId(), adviceList);
                }
                adviceList.add(i);
            });
        }

        // 会诊医生
        Map<String, List<ConsultationDoctorVO>> consultationDoctorMap = new HashMap<>();
        ConsultationDoctorQueryDTO consultationDoctorQueryDTO = new ConsultationDoctorQueryDTO();
        consultationDoctorQueryDTO.setConsultationIds(ids);
        List<ConsultationDoctorVO> consultationDoctorList = consultationDoctorBizService.list(consultationDoctorQueryDTO);
        if (CollectionUtil.isNotEmpty(consultationDoctorList)) {
            consultationDoctorList.forEach(i -> {
                List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(i.getConsultationId());
                if (null == doctorList) {
                    doctorList = new ArrayList<>();
                    consultationDoctorMap.put(i.getConsultationId(), doctorList);
                }
                doctorList.add(i);
            });
        }

        // 患者
        if (CollectionUtil.isEmpty(patientMap)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
        }
        
        // 病种
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
        diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
    
        return list.stream().map(i -> {
            ConsultationVO vo = ConsultationHelper.getConsultationVO(i);

            List<ConsultationDoctorVO> doctorList = consultationDoctorMap.get(vo.getId());
            vo.setConsultationDoctorList(doctorList);

            List<HisConsultationAdviceVO> adviceList = hisConsultationAdviceMap.get(vo.getId());
            vo.setHisConsultationAdviceList(adviceList);

            PatientClientBO patient = patientMap.get(vo.getPatientId());
            if (null != patient) {
                vo.setPatientName(patient.getPatientName());
                vo.setPatientPhone(patient.getPhone());
                vo.setPatientSex(patient.getPatientGenderStandard());
                vo.setPatientAge(patient.getAge());
            }

            if (null != vo.getDiseaseId()) {                    
                StandardDiseaseBO disease = diseaseMap.get(vo.getDiseaseId());
                if (null != disease) {
                    vo.setDiseaseName(disease.getName());
                }
            }

            return vo;
        }).collect(Collectors.toList());
    }
    
    @Override
    public ConsultationVO simpleDetail(ConsultationGetDTO params) {
        ValidatorUtils.validateEntity(params);

        ConsultationInfo entity = consultationInfoService.getOne(new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
        );

        if (null == entity) {
            return null;
        }

        ConsultationVO vo = ConsultationHelper.getConsultationVO(entity);

        // 会诊医生
        ConsultationDoctorQueryDTO consultationDoctorQueryDTO = new ConsultationDoctorQueryDTO();
        consultationDoctorQueryDTO.setConsultationId(entity.getId());
        List<ConsultationDoctorVO> consultationDoctorList = consultationDoctorBizService.list(consultationDoctorQueryDTO);
        vo.setConsultationDoctorList(consultationDoctorList);

        // 患者
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientId(entity.getPatientId());
        PatientClientBO patient = patientClientService.getOneSimple(patientQueryDTO);
        if (null != patient) {
            vo.setPatientName(patient.getPatientName());
            vo.setPatientSex(patient.getPatientGenderStandard());
            vo.setPatientAge(patient.getAge());
        }

        // 病种
        if (StrUtil.isNotBlank(vo.getDiseaseId())) {
            StandardDiseaseBO disease = standardDiseaseClientService.getById(vo.getDiseaseId());
            if (null != disease) {
                vo.setDiseaseName(disease.getName());
            }
        }

        // 会诊结论
        HisConsultationAdviceQueryDTO hisConsultationAdviceQueryDTO = new HisConsultationAdviceQueryDTO();
        hisConsultationAdviceQueryDTO.setConsultationId(vo.getId());
        List<HisConsultationAdviceVO> hisConsultationAdviceList = hisConsultationAdviceBizService.list(hisConsultationAdviceQueryDTO);
        vo.setHisConsultationAdviceList(hisConsultationAdviceList);

        return vo;
    }

    @Override
    public List<ConsultationVO> lastSimpleList(ConsultationQueryDTO params) {
        List<ConsultationInfo> list = consultationMapper.lastSimpleList(new QueryWrapper<ConsultationInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getApplyType()), "a.apply_type", params.getApplyType())
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(ConsultationHelper::getConsultationVO).collect(Collectors.toList());
    }
    
    @Override
    public List<ConsultationDoctorVO> trendsList(ConsultationDoctorQueryDTO params) {
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);

        if (null == consultationVO) {
            return new ArrayList<>(0);
        }

        // 数据整理
        List<ConsultationDoctorVO> resultList = new ArrayList<>();
        
        // 会诊申请与总结
        this.getConsultationDoctorVO(resultList, consultationVO);



        Map<String, ConsultationDoctorVO> doctorMap = new HashMap<>();
        // 会诊医生
        params.setDoctorId(null); // 查所有
        List<ConsultationDoctorVO> doctorList = consultationDoctorBizService.trendsList(params);
        doctorList.forEach(i -> {
            doctorMap.put(i.getDoctorId(), i);

            resultList.add(getConsultationDoctorVO(i, ConsultationConstant.DoctorStatus.TODO.getCode(), i.getCreateDate())); // 邀请

            if (ConsultationConstant.DoctorStatus.JOIN.getCode().equals(i.getStatus()) 
                    || ConsultationConstant.DoctorStatus.SIGN.getCode().equals(i.getStatus()) 
                    || ConsultationConstant.DoctorStatus.ADVICE.getCode().equals(i.getStatus())) {
                resultList.add(getConsultationDoctorVO(i, ConsultationConstant.DoctorStatus.JOIN.getCode(), i.getOpTime())); // 参加
            }

            if (ConsultationConstant.DoctorStatus.REFUSE.getCode().equals(i.getStatus())) {
                resultList.add(getConsultationDoctorVO(i, ConsultationConstant.DoctorStatus.REFUSE.getCode(), i.getOpTime())); // 拒绝
            }

            if (ConsultationConstant.DoctorStatus.TIMEOUT.getCode().equals(i.getStatus())) {
                resultList.add(getConsultationDoctorVO(i, ConsultationConstant.DoctorStatus.TIMEOUT.getCode(), i.getOpTime())); // 超时
            }

        });

        // 会诊医生签到
        ConsultationSignQueryDTO signQuery = new ConsultationSignQueryDTO();
        signQuery.setConsultationId(params.getConsultationId());
        List<ConsultationSignVO> signList = consultationSignBizService.list(signQuery);
        signList.forEach(i -> {
            ConsultationDoctorVO doctor = doctorMap.get(i.getDoctorId());
            if (null != doctor) {
                resultList.add(getConsultationDoctorVO(doctor, ConsultationConstant.DoctorStatus.SIGN.getCode(), i.getSignTime())); // 签到
            }
        });

        // 会诊医生会诊意见
        ConsultationAdviceQueryDTO adviceQuery = new ConsultationAdviceQueryDTO();
        adviceQuery.setConsultationId(params.getConsultationId());
        List<ConsultationAdviceVO> adviceList = consultationAdviceBizService.list(adviceQuery);
        adviceList.forEach(i -> {
            ConsultationDoctorVO doctor = doctorMap.get(i.getDoctorId());
            if (null != doctor) {
                resultList.add(getConsultationDoctorVO(doctor, ConsultationConstant.DoctorStatus.ADVICE.getCode(), i.getUpdateDate())); // 意见
            }
        });

        Comparator<ConsultationDoctorVO> dateComparator = Comparator.comparing(ConsultationDoctorVO::getOpTime);
        resultList.sort(dateComparator.reversed());

        return resultList;
    }

    private void getConsultationDoctorVO(List<ConsultationDoctorVO> resultList, ConsultationVO consultationVO) {
        // 发起会诊
        // ConsultationDoctorVO apply = new ConsultationDoctorVO();
        // apply.setConsultationId(consultationVO.getId());
        // apply.setDeptCode(consultationVO.getApplyDeptId());
        // apply.setDeptName(consultationVO.getApplyDeptName());
        // apply.setDoctorId(consultationVO.getApplyDoctorId());
        // apply.setDoctorName(consultationVO.getApplyDoctorName());
        // apply.setRemark("发起会诊");

        // apply.setStatus(ConsultationConstant.ConsultationStatus.INVITE.getCode()); // 发起会诊
        // apply.setOpTime(consultationVO.getApplyTime());

        // resultList.add(apply);

        // 会诊总结
        if (ConsultationConstant.ConsultationStatus.START.getCode().equals(consultationVO.getStatus()) || ConsultationConstant.ConsultationStatus.DONE.getCode().equals(consultationVO.getStatus())) {
            if (null != consultationVO.getSummaryTime()) {
                ConsultationDoctorVO summary = new ConsultationDoctorVO();
                summary.setConsultationId(consultationVO.getId());
                summary.setDeptCode(consultationVO.getSubmitDeptId());
                summary.setDeptName(consultationVO.getSubmitDeptName());
                summary.setDoctorId(consultationVO.getSubmitDoctorId());
                summary.setDoctorName(consultationVO.getSubmitDoctorName());
                summary.setRemark("提交会诊总结");

                summary.setStatus("summary"); // 会诊总结
                summary.setOpTime(consultationVO.getSummaryTime());

                resultList.add(summary);
            }
        }
    }

    private ConsultationDoctorVO getConsultationDoctorVO(ConsultationDoctorVO consultationDoctorVO, String status, Date opTime) {
        ConsultationDoctorVO doctor = new ConsultationDoctorVO();
        doctor.setId(consultationDoctorVO.getId());
        doctor.setConsultationId(consultationDoctorVO.getConsultationId());
        doctor.setDeptCode(consultationDoctorVO.getDeptCode());
        doctor.setDeptName(consultationDoctorVO.getDeptName());
        doctor.setDoctorId(consultationDoctorVO.getDoctorId());
        doctor.setDoctorName(consultationDoctorVO.getDoctorName());
        doctor.setDutyCode(consultationDoctorVO.getDutyCode());
        doctor.setDutyName(consultationDoctorVO.getDutyName());
        doctor.setDoctorType(consultationDoctorVO.getDoctorType());
        doctor.setTransferDoctorId(consultationDoctorVO.getTransferDoctorId());
        doctor.setRemark(consultationDoctorVO.getRemark());

        doctor.setStatus(status);
        doctor.setOpTime(opTime);

        return doctor;
    }

    @Override
    public List<ConsultationSignVO> signList(ConsultationSignQueryDTO params) {
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);

        if (null == consultationVO) {
            return new ArrayList<>(0);
        }

        params.setDoctorId(null); // 查所有
        return consultationSignBizService.list(params);
    }

    @Override
    public ConsultationAdviceVO ownerAdviceDetail(ConsultationAdviceQueryDTO params) {
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);

        if (null == consultationVO) {
            return null;
        }
        List<ConsultationAdviceVO> list = consultationAdviceBizService.list(params);
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }

    @Override
    public List<ConsultationAdviceVO> adviceList(ConsultationAdviceQueryDTO params) {
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            return new ArrayList<>(0);
        }

        // 由页面控制
        // if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
        //     throw new BusinessException("权限不足");
        // }

        params.setDoctorId(null); // 查所有
        return consultationAdviceBizService.list(params);
    }

    @Override
    public ConsultationAdviceVO adviceDetail(ConsultationAdviceQueryDTO params) {
        if (StrUtil.isBlank(params.getId())) {
            return null;
        }
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            return null;
        }

        // 由页面控制
        // if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
        //     throw new BusinessException("权限不足");
        // }

        params.setDoctorId(null);
        return consultationAdviceBizService.detail(params);
    }

    @Override
    public void join(ConsultationJoinOrRefuseDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能参加");
        }

        // 加入会诊
        ConsultationDoctorUpdateStatusDTO consultationDoctorUpdateStatusDTO = new ConsultationDoctorUpdateStatusDTO();
        consultationDoctorUpdateStatusDTO.setConsultationId(consultationVO.getId());
        consultationDoctorUpdateStatusDTO.setDoctorId(consultationVO.getJoinDoctorId());
        consultationDoctorUpdateStatusDTO.setStatus(ConsultationConstant.DoctorStatus.JOIN.getCode());
        consultationDoctorBizService.update(consultationDoctorUpdateStatusDTO);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void refuse(ConsultationJoinOrRefuseDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能拒绝");
        }

        // 拒绝会诊
        ConsultationDoctorAlternateDTO consultationDoctorAlternateDTO = new ConsultationDoctorAlternateDTO();
        consultationDoctorAlternateDTO.setConsultationId(params.getId());
        consultationDoctorAlternateDTO.setDoctorId(params.getDoctorId());
        ConsultationDoctorVO alternateDoctor = consultationDoctorBizService.alternate(consultationDoctorAlternateDTO);

        // TODO 提醒发起人有会诊医生拒绝参加会诊
        // DoctorRemindInfo remindApplyDoctor = new DoctorRemindInfo();
        // remindApplyDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
        // remindApplyDoctor.setDoctorId(doctorId);
        // remindApplyDoctor.setBizOneType("consultation"); // 会诊
        // remindApplyDoctor.setBizId(consultation.getId());
        // remindApplyDoctor.setTitle(consultation.getName());
        // remindApplyDoctor.setContent(consultation.getName());
        // remindApplyDoctor.setRemark("企业微信消息提醒");
        // remindApplyDoctor.setPushDate(DateUtil.date());
        // remindApplyDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        // remindApplyDoctor.setRowsStatus(YN.YES.getCode());
        // addRemindList.add(remindApplyDoctor);

        // 推送企业微信消息通知候补医生
        if (null != alternateDoctor) {
            // TODO 暂时没有时间地点
            // List<ConsultationDoctorVO> doctorList = consultationVO.getConsultationDoctorList();
            // String title = StrUtil.format("【MDT会诊】拟{}，在{}举行{}，邀您参加，并准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getConsultationTime(), consultationVO.getConsultationVenue(), consultationVO.getName());
            // String content = StrUtil.format("拟{}，在{}举行{}，邀您参加，并准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getConsultationTime(), consultationVO.getConsultationVenue(), consultationVO.getName());
            // String title = StrUtil.format("【MDT会诊】邀您参加{}，请准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getName());
            // String content = StrUtil.format("邀您参加{}，请准备相应的病历。如不能参加请安排科室其他人员参加，谢谢！", consultationVO.getName());
            // String title = StrUtil.isNotBlank(mdtTitle) ? StrUtil.format(mdtTitle, consultationVO.getName()) : consultationVO.getName();
            // String content = StrUtil.isNotBlank(mdtContent) ? StrUtil.format(mdtContent, consultationVO.getName()) : consultationVO.getName();
    
            Map<String, String> contentMap = new HashMap<>();
            contentMap.put("name", consultationVO.getName());
            contentMap.put("applyDeptName", consultationVO.getApplyDeptName());
            contentMap.put("applyDoctorName", consultationVO.getApplyDoctorName());
    
            DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
            remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
            remindDoctor.setDoctorId(alternateDoctor.getDoctorId());
            remindDoctor.setBizId(alternateDoctor.getConsultationId());
            remindDoctor.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setTitle(consultationVO.getName());
            remindDoctor.setContent(JSON.toJSONString(contentMap));
            remindDoctor.setRemark("消息提醒");
            remindDoctor.setPushDate(DateUtil.date());
            remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            remindDoctor.setRowsStatus(YN.YES.getCode());
            
            doctorRemindInfoService.save(remindDoctor);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void refuseAndAppoint(ConsultationJoinOrRefuseDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能拒绝");
        }

        // 指定医生是否满足参加或拒绝该会诊   TODO 是否拒绝后还能重新参加
        ConsultationGetDTO consultationGetDTO2 = new ConsultationGetDTO();
        consultationGetDTO2.setId(params.getId());
        consultationGetDTO2.setDoctorId(params.getAppointDoctorId());
        ConsultationVO consultationVO2 = this.detail(consultationGetDTO2);
        if (null != consultationVO2) {
            throw new BusinessException("指定会诊医生已参加过该会诊");
        }


        // 拒绝会诊
        ConsultationDoctorAlternateDTO consultationDoctorAlternateDTO = new ConsultationDoctorAlternateDTO();
        consultationDoctorAlternateDTO.setConsultationId(params.getId());
        consultationDoctorAlternateDTO.setDoctorId(params.getDoctorId());
        consultationDoctorAlternateDTO.setAppointDoctorId(params.getAppointDoctorId());
        ConsultationDoctorVO alternateDoctor = consultationDoctorBizService.appointAlternate(consultationDoctorAlternateDTO);

        // TODO 提醒发起人有会诊医生拒绝参加会诊
        // DoctorRemindInfo remindApplyDoctor = new DoctorRemindInfo();
        // remindApplyDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
        // remindApplyDoctor.setDoctorId(doctorId);
        // remindApplyDoctor.setBizOneType("consultation"); // 会诊
        // remindApplyDoctor.setBizId(consultation.getId());
        // remindApplyDoctor.setTitle(consultation.getName());
        // remindApplyDoctor.setContent(consultation.getName());
        // remindApplyDoctor.setRemark("企业微信消息提醒");
        // remindApplyDoctor.setPushDate(DateUtil.date());
        // remindApplyDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        // remindApplyDoctor.setRowsStatus(YN.YES.getCode());
        // addRemindList.add(remindApplyDoctor);

        // 推送企业微信消息通知候补医生
        if (null != alternateDoctor) {
            String title = StrUtil.format("邀您参加MDT会诊:{}", consultationVO.getName());
            String content = StrUtil.format("邀您参加MDT会诊:{}", consultationVO.getName());

            DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
            remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
            remindDoctor.setDoctorId(alternateDoctor.getDoctorId());
            remindDoctor.setBizId(alternateDoctor.getConsultationId());
            remindDoctor.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setTitle(title);
            remindDoctor.setContent(content); // TODO FIXME: 使用html或markdown进行消息的配置
            remindDoctor.setRemark("消息提醒");
            remindDoctor.setPushDate(DateUtil.date());
            remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            remindDoctor.setRowsStatus(YN.YES.getCode());
            
            doctorRemindInfoService.save(remindDoctor);
        }
    }

    @Override
    public void sign(ConsultationSignDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getSignDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能签到");
        }

        // 签到
        ConsultationSignAddDTO consultationSignAddDTO = new ConsultationSignAddDTO();
        consultationSignAddDTO.setConsultationId(params.getConsultationId());
        consultationSignAddDTO.setDoctorId(params.getSignDoctorId());
        consultationSignAddDTO.setSignWay(params.getSignWay());
        consultationSignAddDTO.setSignLatitude(params.getSignLatitude());
        consultationSignAddDTO.setSignLongitude(params.getSignLongitude());
        consultationSignAddDTO.setSignIp(params.getSignIp());
        consultationSignBizService.add(consultationSignAddDTO);
    }

    @Override
    public void unsign(ConsultationSignDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getSignDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能签到");
        }

        // 签到
        ConsultationSignAddDTO consultationSignAddDTO = new ConsultationSignAddDTO();
        consultationSignAddDTO.setConsultationId(params.getConsultationId());
        consultationSignAddDTO.setDoctorId(params.getSignDoctorId());
        consultationSignAddDTO.setSignWay(params.getSignWay());
        consultationSignAddDTO.setSignLatitude(params.getSignLatitude());
        consultationSignAddDTO.setSignLongitude(params.getSignLongitude());
        consultationSignAddDTO.setSignIp(params.getSignIp());
        consultationSignBizService.add(consultationSignAddDTO);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void start(ConsultationStartOrCancelDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能开始");
        }

        // 会诊签到
        if (CollectionUtil.isNotEmpty(params.getSignDoctorList())) {
            List<ConsultationSignAddDTO> signList = new ArrayList<>(); // 签到
            List<ConsultationDoctorUpdateStatusDTO> doctorSignList = new ArrayList<>(); // 签到状态
            params.getSignDoctorList().forEach(i -> {
                // 签到
                ConsultationSignAddDTO consultationSignAddDTO = new ConsultationSignAddDTO();
                consultationSignAddDTO.setConsultationId(params.getId());
                consultationSignAddDTO.setDoctorId(i);
                signList.add(consultationSignAddDTO);

                // 更新会诊医生签到状态
                ConsultationDoctorUpdateStatusDTO consultationDoctorUpdateStatusDTO = new ConsultationDoctorUpdateStatusDTO();
                consultationDoctorUpdateStatusDTO.setConsultationId(consultationVO.getId());
                consultationDoctorUpdateStatusDTO.setDoctorId(i);
                consultationDoctorUpdateStatusDTO.setStatus(ConsultationConstant.DoctorStatus.SIGN.getCode());

                doctorSignList.add(consultationDoctorUpdateStatusDTO);
            });
            consultationSignBizService.addBatch(signList);
            // 更新签到状态
            consultationDoctorBizService.updateBatch(doctorSignList);
        }

        // 开始会诊
        consultationInfoService.update(new UpdateWrapper<ConsultationInfo>()
            .set("status", ConsultationConstant.ConsultationStatus.START.getCode())
            .set(CollectionUtil.isNotEmpty(params.getImageList()), "images", StrJoinSplitUtils.join(params.getImageList()))
            .eq("id", consultationVO.getId())
        );

    }

    @Override
    public void cancel(ConsultationStartOrCancelDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (!ConsultationConstant.ConsultationStatus.INVITE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非发起状态不能取消");
        }

        // 取消会诊
        consultationInfoService.update(new UpdateWrapper<ConsultationInfo>()
            .set("status", ConsultationConstant.ConsultationStatus.CANCEL.getCode())
            .eq("id", consultationVO.getId())
        );
    }

    @Override
    public void advice(ConsultationAdviceDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getConsultationId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!ConsultationConstant.ConsultationStatus.START.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非开始状态不能提交会诊意见");
        }

        // 会诊意见
        ConsultationAdviceAddDTO consultationAdviceAddDTO = new ConsultationAdviceAddDTO();
        consultationAdviceAddDTO.setConsultationId(params.getConsultationId());
        consultationAdviceAddDTO.setDoctorId(params.getDoctorId());
        consultationAdviceAddDTO.setAdvice(params.getAdvice());
        consultationAdviceBizService.add(consultationAdviceAddDTO);
    }

    @Override
    public void summary(ConsultationSummaryDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (ConsultationConstant.ConsultationStatus.DONE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊已结束");
        }
        if (!ConsultationConstant.ConsultationStatus.START.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非开始状态不能结束");
        }

        // 完成会诊
        consultationInfoService.update(new UpdateWrapper<ConsultationInfo>()
            .set("summary", params.getSummary())
            .set("summary_user_id", params.getDoctorId())
            .set("summary_time", DateUtil.date())
            .eq("id", consultationVO.getId())
        );
    }

    @Override
    public void finish(ConsultationFinishDTO params) {
        ValidatorUtils.validateEntity(params);
        // 验证
        ConsultationGetDTO consultationGetDTO = new ConsultationGetDTO();
        consultationGetDTO.setId(params.getId());
        consultationGetDTO.setDoctorId(params.getDoctorId());
        ConsultationVO consultationVO = this.detail(consultationGetDTO);
        if (null == consultationVO) {
            throw new BusinessException("未查询到会诊信息");
        }

        if (!consultationVO.getSummaryUserId().equals(params.getDoctorId())) {
            throw new BusinessException("权限不足");
        }
        if (ConsultationConstant.ConsultationStatus.DONE.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊已结束");
        }
        if (!ConsultationConstant.ConsultationStatus.START.getCode().equals(consultationVO.getStatus())) {
            throw new BusinessException("该会诊非开始状态不能结束");
        }

        // 完成会诊
        consultationInfoService.update(new UpdateWrapper<ConsultationInfo>()
            .set("status", ConsultationConstant.ConsultationStatus.DONE.getCode())
            .eq("id", consultationVO.getId())
        );
    }

    @Override
    public List<ConsultationStatusCountStatisticVO> statusCountStatistic(String doctorId) {
        
        List<Map<String, Object>> listMap = consultationMapper.statusCountStatistic(new QueryWrapper<ConsultationInfo>()
            .eq("a.rows_status", YN.YES.getCode())
            .eq("b.rows_status", YN.YES.getCode())
            .notIn("b.status", ConsultationConstant.DoctorStatus.REFUSE.getCode(), ConsultationConstant.DoctorStatus.TIMEOUT.getCode()) // 拒绝或超时的会诊医生不能再看到该会诊
            .and(i -> {
                i.eq("b.doctor_id", doctorId).or().eq("a.summary_user_id", doctorId);
            })
            .eq("a.apply_type", ConsultationType.MDT.getCode())
        );

        if (CollectionUtil.isEmpty(listMap)) {
            return new ArrayList<>(0);
        }

        List<ConsultationStatusCountStatisticVO> list = new ArrayList<>();
        listMap.forEach(i -> {
            String status = i.get("status").toString();
            Long count = (Long) i.get("count");

            ConsultationStatusCountStatisticVO vo = new ConsultationStatusCountStatisticVO();
            vo.setStatus(status);
            vo.setCount(count);

            list.add(vo);
        });

        return list;
    }

    @Override
    public PageData<ConsultationManageCountStatisticVO> statisticCountByGroup(ConsultationManageCountStatisticQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        IPage<Map<String, Object>> page = consultationMapper.statisticCountByGroup(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<ConsultationInfo>()
            .eq("rows_status", YN.YES.getCode())
            .like(StrUtil.isNotBlank(params.getConsultationName()), "name", params.getConsultationName())
            .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
            .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
            .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
            .isNotNull("name")
            .ne("name", "")
            .eq("apply_type", ConsultationType.MDT.getCode())
        );
        
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, page.getTotal());
        }

        List<ConsultationManageCountStatisticVO> list = new ArrayList<>();
        page.getRecords().forEach(i -> {
            String name = i.get("name").toString();
            Long count = (Long) i.get("count");

            ConsultationManageCountStatisticVO vo = new ConsultationManageCountStatisticVO();
            vo.setConsultationName(name);
            vo.setCount(count);

            list.add(vo);
        });

        return new PageData<>(list, page.getTotal(), page.getSize(), page.getPages());
    }

    @Override
    public PageData<ConsultationManageCountStatisticVO> statisticDoctorByGroup(ConsultationManageCountStatisticQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        IPage<Map<String, Object>> page = consultationMapper.statisticCountByGroup(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<ConsultationInfo>()
            .eq("rows_status", YN.YES.getCode())
            .like(StrUtil.isNotBlank(params.getConsultationName()), "name", params.getConsultationName())
            .ge(null != params.getStartDate(), "apply_time", params.getStartDate())
            .lt(null != params.getEndDate(), "apply_time", params.getEndDate())
            .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
            .isNotNull("name")
            .ne("name", "")
            .eq("apply_type", ConsultationType.MDT.getCode())
        );
        
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, page.getTotal());
        }

        List<ConsultationManageCountStatisticVO> list = new ArrayList<>();
        page.getRecords().forEach(i -> {
            String name = i.get("name").toString();
            Long count = (Long) i.get("count");

            ConsultationManageCountStatisticVO vo = new ConsultationManageCountStatisticVO();
            vo.setConsultationName(name);
            vo.setCount(count);

            list.add(vo);
        });

        // 根据会诊名称查询会诊id，再根据会诊id查询会诊医生
        if (CollectionUtil.isNotEmpty(list)) {
            List<String> consultationNameList = new ArrayList<>();
            list.forEach(i -> consultationNameList.add(i.getConsultationName()));

            List<Map<String, Object>> consultationList = consultationMapper.statisticDoctorList(new QueryWrapper<ConsultationInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .eq("b.rows_status", YN.YES.getCode())
                .in("a.name", consultationNameList)
            );

            if (CollectionUtil.isNotEmpty(consultationList)) {
                Map<String, Set<String>> consultationMap = new HashMap<>();

                consultationList.forEach(i -> {
                    String consultationName = i.get("name").toString();
                    String doctorName = i.get("doctorName").toString();

                    Set<String> cl = consultationMap.get(consultationName);
                    if (null == cl) {
                        cl = new HashSet<>();
                        consultationMap.put(consultationName, cl);
                    }
                    cl.add(doctorName);
                });

                list.forEach(i -> i.setDoctorList(consultationMap.get(i.getConsultationName())));
            }
        }

        return new PageData<>(list, page.getTotal(), page.getSize(), page.getPages());
    }

    @Override
    public void syncConsultation(HisConsultationSyncDTO params) {
        ValidatorUtils.validateEntity(params);

        String startTime = DateUtil.format(params.getStartDate(), "yyyy-MM-dd HH:mm:ss");
        String endTime = DateUtil.format(params.getEndDate(), "yyyy-MM-dd HH:mm:ss");

        MdtSyncDataResp<SlifeMdtApply> applyResp = MdtApplyHttpUtil.getData(startTime, endTime);
        if (null == applyResp || YN.NO.getCode().equals(applyResp.getStatus())) {
            return;
        }
        List<SlifeMdtApply> applyList = applyResp.getData();
        
        if (CollectionUtil.isNotEmpty(applyList)) {
            List<ConsultationAddDTO> addList = new ArrayList<>();
            List<ConsultationDoctorAddDTO> addDoctorList = new ArrayList<>();
            for(SlifeMdtApply i : applyList) {
                 // 会诊单类型 1 mdt 会诊 0常规会诊
                 if (StrUtil.isNotBlank(params.getApplyType()) && !params.getApplyType().equals(String.valueOf(i.getApplyType()))) {
                    continue;
                }

                ConsultationAddDTO addDTO = new ConsultationAddDTO();
                addDTO.setApplyType(String.valueOf(i.getApplyType()));
                addDTO.setId(i.getApplyId());
                addDTO.setName(i.getMdtTemplateName());
                addDTO.setPatientId(i.getPid());
                addDTO.setInpatientId(i.getIpid());
                addDTO.setVisitId(i.getPid());
                addDTO.setApplyTime(i.getApplyTime());
                addDTO.setApplyDoctorId(i.getApplyDocCode());
                addDTO.setApplyDoctorName(i.getApplyDocName());
                addDTO.setApplyDeptId(i.getApplyDeptCode());
                addDTO.setApplyDeptName(i.getApplyDeptName());
                addDTO.setSubmitTime(i.getSubmitTime());
                addDTO.setSubmitDoctorId(i.getSubmitDocCode());
                addDTO.setSubmitDoctorName(i.getSubmitDocName());
                addDTO.setSubmitDeptId(i.getDeptCode());
                addDTO.setSubmitDeptName(i.getDeptName());
                addDTO.setWardCode(i.getWardCode());
                addDTO.setWardName(i.getWardCode());

                // addDTO.setFindTime(); // 发现时间
                // addDTO.setOverdueTime(); // 过期时间
                addDTO.setConsultationTime(i.getApplyTime());
                // addDTO.setConsultationVenue(); // 会诊地点
                
                addDTO.setSummaryUserId(i.getApplyDocCode()); // 默认的主持人
                // addDTO.setSummaryTime(i.getSubmitTime());

                // 由本系统控制是否完成
                addDTO.setStatus(ConsultationConstant.ConsultationStatus.INVITE.getCode());

                // 会诊内容
                addDTO.setRemark(i.getApplyContent());

                // 普通会诊数据处理
                if (ConsultationType.ORDINARY.getCode().equals(addDTO.getApplyType())) {
                    addDTO.setStatus(ConsultationConstant.ConsultationStatus.DONE.getCode());
                }

                // 保存会诊医生信息
                if (CollectionUtil.isNotEmpty(i.getDocList())) {
                    i.getDocList().forEach(j -> {
                        ConsultationDoctorAddDTO doctor = new ConsultationDoctorAddDTO();
                        doctor.setConsultationId(i.getApplyId());
                        doctor.setDeptCode(j.getDeptCode());
                        doctor.setDeptName(j.getDeptName());
                        doctor.setDoctorId(j.getDocCode());
                        doctor.setDoctorName(j.getDocName());
                        doctor.setDutyCode(j.getDocDuty());
                        doctor.setDutyName(j.getDocDutyName());
                        doctor.setDoctorType(ConsultationConstant.DoctorType.APPOINT.getCode());
                        // doctor.setRemark();
                        doctor.setOpTime(DateUtil.date());

                        // 参加会诊的状态：
                        doctor.setStatus(ConsultationConstant.DoctorStatus.TODO.getCode());
                        
                        if ("director".equals(doctor.getDutyCode())) {
                            addDTO.setSummaryUserId(doctor.getDoctorId()); // 若是主任则该主任为主持人
                            doctor.setStatus(ConsultationConstant.DoctorStatus.JOIN.getCode()); // 直接加入会诊
                        }

                        // 普通会诊数据处理
                        if (ConsultationType.ORDINARY.getCode().equals(addDTO.getApplyType())) {
                            doctor.setStatus(ConsultationConstant.DoctorStatus.FINISH.getCode());
                        }

                        addDoctorList.add(doctor);
                    });
                }

                addList.add(addDTO);
            }

            if (CollectionUtil.isEmpty(addList)) {
                return;
            }

            // 保存会诊信息
            this.addBatch(addList);

            // 保存会诊医生信息
            consultationDoctorBizService.addBatch(addDoctorList);
        }
    }

    @Override
    public PageData<ConsultationVO> pageFull(HisConsultationAdviceQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        IPage<HisConsultationAdviceInfo> page = consultationMapper.queryHisConsultationAdvicePage(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<HisConsultationAdviceInfo>()
            .eq(StrUtil.isNotBlank(params.getConsultationId()), "a.consultation_id", params.getConsultationId())
            .in(CollectionUtil.isNotEmpty(params.getConsultationIds()), "a.consultation_id", params.getConsultationIds())
            .eq(StrUtil.isNotBlank(params.getInpatientId()), "a.inpatient_id", params.getInpatientId())
            .eq(StrUtil.isNotBlank(params.getVisitId()), "a.visit_id", params.getVisitId())
            .eq(StrUtil.isNotBlank(params.getMdtDeptCode()), "a.mdt_dept_code", params.getMdtDeptCode())
            .like(StrUtil.isNotBlank(params.getMdtDeptName()), "a.mdt_dept_name", params.getMdtDeptName())
            .eq(StrUtil.isNotBlank(params.getDeptCode()), "a.dept_code", params.getDeptCode())
            .like(StrUtil.isNotBlank(params.getDeptName()), "a.dept_name", params.getDeptName())
            .eq(StrUtil.isNotBlank(params.getWardCode()), "a.ward_code", params.getWardCode())
            .like(StrUtil.isNotBlank(params.getWardName()), "a.ward_name", params.getWardName())
            .eq(StrUtil.isNotBlank(params.getSubmitDoctorId()), "a.submit_doctor_id", params.getSubmitDoctorId())
            .like(StrUtil.isNotBlank(params.getSubmitDoctorName()), "a.submit_doctor_name", params.getSubmitDoctorName())
            .eq(StrUtil.isNotBlank(params.getStatus()), "a.status", params.getStatus())
            .ge(null != params.getStartDate(), "a.submit_time", params.getStartDate())
            .lt(null != params.getEndDate(), "a.submit_time", params.getEndDate())
            .eq(StrUtil.isNotBlank(params.getTargetType()), "a.target_type", params.getTargetType())
            .eq(StrUtil.isNotBlank(params.getTargetStatus()), "a.target_status", params.getTargetStatus())

            .eq(StrUtil.isNotBlank(params.getApplyType()), "b.apply_type", params.getApplyType())
            .like(StrUtil.isNotBlank(params.getPatientName()), "c.patient_name", params.getPatientName())
        );

        if (null == page || CollUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        List<String> consultationIds = new ArrayList<>();
        page.getRecords().forEach(i -> consultationIds.add(i.getConsultationId()));

        ConsultationQueryDTO consultationQueryDTO = new ConsultationQueryDTO();
        consultationQueryDTO.setIds(consultationIds);
        List<ConsultationVO> consultationVOs = this.simpleList(consultationQueryDTO);

        return new PageData<>(consultationVOs, page.getTotal(), page.getSize(), page.getPages());
    }

}
