package com.xxh.cloud.healthy.mdt.framework.modules.cache.impl;

import cn.hutool.core.util.IdUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import com.xxh.cloud.healthy.mdt.framework.modules.cache.ConsultationLaunchApplyCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ConsultationLaunchApplyCacheServiceImpl implements ConsultationLaunchApplyCacheService {

    @Autowired
    private RedisUtils redisUtils;


    @Override
    public String getUrlKey() {
        String key = IdUtil.fastSimpleUUID();
        redisUtils.set(key, key, 72 * 3600);
        return key;
    }

    @Override
    public void checkUrlKey(String key) {
        if (!redisUtils.hasKey(key)) {
            throw new BusinessException(BusinessBaseErrorEnum.Not_Permission_Error);
        }
    }
}
