package com.xxh.cloud.healthy.mdt.framework.modules.task.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.xxh.cloud.basic.client.api.ParamsClientService;
import com.xxh.cloud.basic.framework.modules.base.entity.dto.DictDataListDTO;
import com.xxh.cloud.basic.framework.modules.base.entity.vos.DictDataVO;
import com.xxh.cloud.basic.framework.modules.base.service.DictDataService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.common.constant.PushWayEnum;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.basic.pushtask.client.api.constant.PushTaskConstant;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientChangeClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DataDwdPatientQueryClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientLastDataQueryDTO;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationTargetStatus;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationTargetSubType;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationTargetType;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationType;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationLaunchApplyConstant;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationNotifyConstant;
import com.xxh.cloud.healthy.mdt.framework.modules.analysis.HAnalysisDataModel;
import com.xxh.cloud.healthy.mdt.framework.modules.analysis.HAnalysisTempHelper;
import com.xxh.cloud.healthy.mdt.framework.modules.async.ConsultationAsyncBizService;
import com.xxh.cloud.healthy.mdt.framework.modules.base.entity.*;
import com.xxh.cloud.healthy.mdt.framework.modules.base.service.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.bean.vo.*;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.helper.ConsultationHelper;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.mapper.ConsultationMapper;
import com.xxh.cloud.healthy.mdt.framework.modules.biz.service.*;
import com.xxh.cloud.healthy.mdt.framework.modules.sync.bean.MdtSyncModelBO;
import com.xxh.cloud.healthy.mdt.framework.modules.sync.mapper.MdtSyncQueryMapper;
import com.xxh.cloud.healthy.mdt.framework.modules.task.service.ConsultationBizTaskHandlerService;
import com.xxh.cloud.healthy.mdt.framework.modules.task.service.ConsultationBizTaskService;
import com.xxh.cloud.healthy.mdt.third.bean.MdtSyncDataResp;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApply;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApplyDetail;
import com.xxh.cloud.healthy.mdt.third.utils.MdtApplyHttpUtil;
import com.xxh.cloud.healthy.mdt.third.utils.MdtDetailHttpUtil;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@Service
public class ConsultationBizTaskServiceImpl implements ConsultationBizTaskService {

    @Autowired
    private HisConsultationAdviceBizService hisConsultationAdviceBizService;
    @Autowired
    private ConsultationInfoService consultationInfoService;
    @Autowired
    private MdtSyncQueryMapper mdtSyncQueryMapper;
    @Autowired
    private ConsultationBizTaskHandlerService consultationBizTaskHandlerService;
    @Autowired
    private ConsultationMapper consultationMapper;
    @Autowired
    private ConsultationDoctorInfoService consultationDoctorInfoService;
    @Autowired
    private ConsultationDoctorBizService consultationDoctorBizService;
    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;
    @Autowired
    private ConsultationLaunchApplyBizService consultationLaunchApplyBizService;
    @Autowired
    private HisConsultationAdviceInfoService hisConsultationAdviceInfoService;
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private ConsultationLaunchApplyInfoService consultationLaunchApplyInfoService;
    @Autowired
    private ConsultationNotifyInfoBizService consultationNotifyInfoBizService;
    @Autowired
    private ConsultationBizService consultationBizService;
    @Autowired
    private ConsultationNotifyInfoService consultationNotifyInfoService;
    @Autowired
    private ConsultationLaunchApplyStatBizService consultationLaunchApplyStatBizService;
    @Autowired
    private ConsultationLaunchApplyChangeStatBizService consultationLaunchApplyChangeStatBizService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private DictDataService dictDataService;
    @Autowired
    private ParamsClientService paramsClientService;
    @Autowired
    private ConsultationAsyncBizService consultationAsyncBizService;

    private String MDT_Apply = "MDT_Apply";

    // mdt医生未接受超时时间
    @Value("${xx.mdt.mdtDoctorTimeout:5}")
    private Integer mdtDoctorTimeout;

    @Override
    public void consultationExpireTask() {
        // 查询过期的会诊数据
        List<ConsultationInfo> list = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq("status", ConsultationConstant.ConsultationStatus.INVITE.getCode())
                .lt("overdue_time", DateUtil.date())
        );

        // 处理过期的会诊数据
        if (CollectionUtil.isNotEmpty(list)) {
            list.forEach(i -> i.setStatus(ConsultationConstant.ConsultationStatus.EXPIRE.getCode()));
            consultationInfoService.updateBatchById(list);
        }
    }

    @Override
    public void syncHisConsultationApplyTask() {
        // 查询同步标记，根据同步标记同步海泰数据
        MdtSyncModelBO mdtSyncModelBO = mdtSyncQueryMapper.getMdtSyncFlag(new QueryWrapper<MdtSyncModelBO>()
            .eq("code", MDT_Apply)
        );

        if (null == mdtSyncModelBO) {
            mdtSyncModelBO = new MdtSyncModelBO();
            mdtSyncModelBO.setCode(MDT_Apply);
            mdtSyncModelBO.setName("会诊数据");
            mdtSyncModelBO.setSyncFlag(DateUtil.offsetDay(DateUtil.date(), -2).toString("yyyy-MM-dd HH:mm:ss"));
            mdtSyncModelBO.setMaxMin(5);
            mdtSyncQueryMapper.insertMdtSyncFlag(mdtSyncModelBO);
        }

        if (StrUtil.isBlank(mdtSyncModelBO.getSyncFlag()) || mdtSyncModelBO.getMaxMin() < 0) {
            throw new BusinessException("同步标记配置异常");
        }

        // 处理边界时间
        String now = DateUtil.now();
        String startTime = mdtSyncModelBO.getSyncFlag();
        // 若开始时间大于当前时间则停止同步
        if (now.compareTo(startTime) < 0) {
            return;
        }
        String endTime = DateUtil.offsetMinute(DateUtil.parseDateTime(mdtSyncModelBO.getSyncFlag()), mdtSyncModelBO.getMaxMin()).toString();
        // 若结束时间大于当前时间则停止同步
        if (now.compareTo(endTime) < 0) {
            return;
        }

        // 调用同步海泰数据方法，并保存数据
        log.info("查询海泰mdt会诊数据参数>>>>>> : startTime={} endTime={}", startTime, endTime);
        MdtSyncDataResp<SlifeMdtApply> applyResp = MdtApplyHttpUtil.getData(startTime, endTime);
        if (null == applyResp || YN.NO.getCode().equals(applyResp.getStatus())) {
            
            // 更新同步标记
            // log.info("更新同步标记时间 >>>>>> endTime={}", endTime);
            // mdtSyncQueryMapper.updateMdtSyncFlag(endTime, MDT_Apply);

            return;
        }
        log.info("查询海泰mdt会诊数据返回数据<<<<<< : applyResp={}", applyResp.getData().size());
        
        List<SlifeMdtApply> applyList = applyResp.getData();

        List<ConsultationAddDTO> addList = new ArrayList<>();
        if (CollectionUtil.isNotEmpty(applyList)) {
            // List<String> visitIds = new ArrayList<>();
            // List<String> inpatientIds = new ArrayList<>();
            for(SlifeMdtApply i : applyList) {
                log.info("mdt会诊信息 >>>>>> SlifeMdtApply={}", JSON.toJSONString(i));

                // 会诊单类型 1 mdt 会诊 0其他会诊
                // if (i.getApplyType() != 1) {
                //     continue;
                // }

                ConsultationAddDTO addDTO = new ConsultationAddDTO();
                addDTO.setApplyType(String.valueOf(i.getApplyType()));
                addDTO.setId(i.getApplyId());
                addDTO.setName(i.getMdtTemplateName());
                addDTO.setPatientId(i.getPid());
                addDTO.setInpatientId(i.getIpid());
                addDTO.setVisitId(i.getPid());
                addDTO.setApplyTime(i.getApplyTime());
                addDTO.setApplyDoctorId(i.getApplyDocCode());
                addDTO.setApplyDoctorName(i.getApplyDocName());
                addDTO.setApplyDeptId(i.getApplyDeptCode());
                addDTO.setApplyDeptName(i.getApplyDeptName());
                addDTO.setSubmitTime(i.getSubmitTime());
                addDTO.setSubmitDoctorId(i.getSubmitDocCode());
                addDTO.setSubmitDoctorName(i.getSubmitDocName());
                addDTO.setSubmitDeptId(i.getDeptCode());
                addDTO.setSubmitDeptName(i.getDeptName());
                addDTO.setWardCode(i.getWardCode());
                addDTO.setWardName(i.getWardCode());

                // addDTO.setFindTime(); // 发现时间
                // addDTO.setOverdueTime(); // 过期时间
                addDTO.setConsultationTime(i.getApplyTime());
                // addDTO.setConsultationVenue(); // 会诊地点

                addDTO.setSummaryUserId(i.getApplyDocCode()); // 默认的主持人
                // addDTO.setSummaryTime(i.getSubmitTime());

                // 由本系统控制是否完成
                addDTO.setStatus(ConsultationConstant.ConsultationStatus.INVITE.getCode());

                // 会诊内容
                addDTO.setRemark(i.getApplyContent());

                // 普通会诊数据处理
                if (ConsultationType.ORDINARY.getCode().equals(addDTO.getApplyType())) {
                    addDTO.setStatus(ConsultationConstant.ConsultationStatus.DONE.getCode());
                }

                // 保存会诊医生信息
                if (CollectionUtil.isNotEmpty(i.getDocList())) {
                    List<ConsultationDoctorAddDTO> doctorList = new ArrayList<>();
                    i.getDocList().forEach(j -> {
                        
                        // 5.0会诊数据可能没有医生编号（指定科室，让科室内医生自己接单会诊），这种数据暂不处理
                        if (StrUtil.isBlank(j.getDocCode())) {
                            return;
                        }

                        ConsultationDoctorAddDTO doctor = new ConsultationDoctorAddDTO();
                        doctor.setConsultationId(i.getApplyId());
                        doctor.setDeptCode(j.getDeptCode());
                        doctor.setDeptName(j.getDeptName());
                        doctor.setDoctorId(j.getDocCode());
                        doctor.setDoctorName(j.getDocName());
                        doctor.setDutyCode(j.getDocDuty());
                        doctor.setDutyName(j.getDocDutyName());
                        doctor.setDoctorType(ConsultationConstant.DoctorType.APPOINT.getCode());
                        // doctor.setRemark();
                        doctor.setOpTime(DateUtil.date());

                        // 参加会诊的状态：
                        doctor.setStatus(ConsultationConstant.DoctorStatus.TODO.getCode());

                        if ("director".equals(doctor.getDutyCode())) {
                            addDTO.setSummaryUserId(doctor.getDoctorId()); // 若是主任则该主任为主持人
                            doctor.setStatus(ConsultationConstant.DoctorStatus.JOIN.getCode()); // 直接加入会诊
                        }

                        // 普通会诊数据处理
                        if (ConsultationType.ORDINARY.getCode().equals(addDTO.getApplyType())) {
                            doctor.setStatus(ConsultationConstant.DoctorStatus.FINISH.getCode());
                        }

                        doctorList.add(doctor);
                    });

                    addDTO.setDoctorList(doctorList);
                }

                // 保存会诊时会诊医生不能为空
                if (CollUtil.isNotEmpty(addDTO.getDoctorList())) {
                    addList.add(addDTO);
                }

                // visitIds.add(i.getPid());
                // inpatientIds.add(i.getIpid());
            }

            // dwd根据门诊/住院号查询患者信息
            // Map<String, String> visitMap = consultationDwdBizService.mapPatientIdByVisitId(visitIds);
            // Map<String, String> inpatientMap = consultationDwdBizService.mapPatientIdByInpatientId(inpatientIds);

            // if (CollectionUtil.isNotEmpty(addList)) {
            //     Iterator<ConsultationAddDTO> it = addList.iterator();
            //     while (it.hasNext()) {
            //         ConsultationAddDTO next = it.next();
            //         String visitPatientId = visitMap.get(next.getVisitId());
            //         String inpatientPatientId = inpatientMap.get(next.getInpatientId());
                    
            //         if (StrUtil.isNotBlank(visitPatientId)) {
            //             next.setPatientId(visitPatientId);
            //         } else if (StrUtil.isNotBlank(inpatientPatientId)) {
            //             next.setPatientId(inpatientPatientId);
            //         } else {
            //             it.remove();
            //         }
            //     }
            // }
        }

        log.info("添加会诊信息 >>>>>> addList={}, addDoctorList={}, endTime={}", JSON.toJSONString(addList), endTime);
        consultationBizTaskHandlerService.saveConsultationAndDoctorAndSendMsg(addList, endTime);
    }

    /**
     * 同步数据，在一段时间范围同步多次
     */
    @Override
    public void syncHisConsultationResultTask(Date startTime, Date endTime) {
        // Date now = DateUtil.date();
        // // 同步未同步过的或2天内同步过的数据
        // List<ConsultationInfo> list = consultationMapper.hisConsultationAdviceList(new QueryWrapper<ConsultationInfo>()
        //     .eq("a.rows_status", YN.YES.getCode())
        //     .eq("a.status", now)
        //     .ge("a.create_date", DateUtil.offsetDay(now, -1))
        //     .and(i -> i.isNull("b.id").or().le("DATE_ADD(a.create_date, INTERVAL 1 DAY)", DateUtil.offsetDay(DateUtil.date(), -2)))
        //     .last(" limit 1000 ")
        // );
        // FIXME 根据时间戳同步会诊结论
        // 同步两天内的数据，漏掉的可以通过接口补刀
        List<ConsultationInfo> list = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
            .eq("rows_status", YN.YES.getCode())
            .ge("create_date", startTime)
            .le("create_date", endTime)
            // .last(" limit 1000 ")
        );
        if (CollectionUtil.isEmpty(list)) {
            return;
        }

        List<String> ids = list.stream().map(ConsultationInfo::getId).collect(Collectors.toList());

        // 同步海泰会诊结论
        log.info("查询海泰mdt会诊结论数据参数>>>>>> : ids={}", ids);
        MdtSyncDataResp<SlifeMdtApplyDetail> resultResp = MdtDetailHttpUtil.getData(null, null, ids);
        log.info("查询海泰mdt会诊结论数据返回数据<<<<<< : resultResp={}", JSON.toJSONString(resultResp));
        List<SlifeMdtApplyDetail> detailList = resultResp.getData();
        if (CollectionUtil.isEmpty(detailList)) {
            return;
        }

        List<HisConsultationAdviceAddDTO> addList = new ArrayList<>();
        detailList.forEach(i -> {
            HisConsultationAdviceAddDTO addDTO = new HisConsultationAdviceAddDTO();
            addDTO.setId(i.getApplyDetailId());
            addDTO.setConsultationId(i.getApplyId());
            addDTO.setInpatientId(i.getIpid());
            addDTO.setVisitId(i.getPid());
            addDTO.setMdtDeptCode(i.getMdtDeptCode());
            addDTO.setMdtDeptName(i.getMdtDeptName());
            addDTO.setDeptCode(i.getDeptCode());
            addDTO.setDeptName(i.getDeptName());
            addDTO.setWardCode(i.getWardCode());
            addDTO.setWardName(i.getWardName());
            addDTO.setSubmitDoctorId(i.getSubmitDocCode());
            addDTO.setSubmitDoctorName(i.getSubmitDocName());
            addDTO.setSubmitTime(i.getSubmitTime());
            addDTO.setStatus(i.getStatus() + "");
            
            addDTO.setSubmitContent(i.getMdtContent());
            addDTO.setSubmitXmlContent(i.getXmlContent());
            if (StrUtil.isBlank(i.getMdtContent()) && StrUtil.isNotBlank(i.getXmlContent())) {
                addDTO.setSubmitContent(i.getXmlContent());
            }

            // 随访时间
            if (null != i.getVisitObject()) {
                addDTO.setFollowup(i.getVisitObject().getVisitNum() + i.getVisitObject().getVisitUnit());
            }

            addList.add(addDTO);
        });

        // 保存
        hisConsultationAdviceBizService.addBatch(addList);
    }

    @Override
    public void syncHisConsultationResultByTimeTask(String startTime, String endTime) {
        // 同步海泰会诊结论
        log.info("查询海泰mdt会诊结论数据参数>>>>>> : startTime={} endTime={}", startTime, endTime);
        MdtSyncDataResp<SlifeMdtApplyDetail> resultResp = MdtDetailHttpUtil.getData(startTime, endTime, null);
        log.info("查询海泰mdt会诊结论数据返回数据<<<<<< : resultResp={}", JSON.toJSONString(resultResp));
        List<SlifeMdtApplyDetail> detailList = resultResp.getData();
        if (CollectionUtil.isEmpty(detailList)) {
            return;
        }

        List<HisConsultationAdviceAddDTO> addList = new ArrayList<>();
        detailList.forEach(i -> {
            HisConsultationAdviceAddDTO addDTO = new HisConsultationAdviceAddDTO();
            addDTO.setId(i.getApplyDetailId());
            addDTO.setConsultationId(i.getApplyId());
            addDTO.setInpatientId(i.getIpid());
            addDTO.setVisitId(i.getPid());
            addDTO.setMdtDeptCode(i.getMdtDeptCode());
            addDTO.setMdtDeptName(i.getMdtDeptName());
            addDTO.setDeptCode(i.getDeptCode());
            addDTO.setDeptName(i.getDeptName());
            addDTO.setWardCode(i.getWardCode());
            addDTO.setWardName(i.getWardName());
            addDTO.setSubmitDoctorId(i.getSubmitDocCode());
            addDTO.setSubmitDoctorName(i.getSubmitDocName());
            addDTO.setSubmitTime(i.getSubmitTime());
            addDTO.setStatus(i.getStatus() + "");
            
            addDTO.setSubmitContent(i.getMdtContent());
            addDTO.setSubmitXmlContent(i.getXmlContent());
            if (StrUtil.isBlank(i.getMdtContent()) && StrUtil.isNotBlank(i.getXmlContent())) {
                addDTO.setSubmitContent(i.getXmlContent());
            }

            // 随访时间
            if (null != i.getVisitObject()) {
                addDTO.setFollowup(i.getVisitObject().getVisitNum() + i.getVisitObject().getVisitUnit());
            }

            addList.add(addDTO);
        });

        // 保存
        hisConsultationAdviceBizService.addBatch(addList);
    }

    @Override
    public void mdtDoctorJoinRemindTask(String startTime, String endTime) {
        if (null == startTime) {
            return;
        }
        Date start = DateUtil.parseDateTime(startTime);
        Date end = DateUtil.date();
        if (null != endTime) {
            end = DateUtil.parseDateTime(endTime);
        }
        // 查询会诊及医生信息
        ConsultationQueryDTO queryDTO = new ConsultationQueryDTO();
        queryDTO.setApplyType(ConsultationType.MDT.getCode());
        queryDTO.setStartDate(start);
        queryDTO.setEndDate(end);
        List<ConsultationVO> consultationList = consultationBizService.simpleList(queryDTO);

        if (CollUtil.isEmpty(consultationList)) {
            return;
        }
        // 生成提醒信息
        List<DoctorRemindInfo> doctorRemindInfos = new ArrayList<>();
        DateTime pushDate = DateUtil.date();
        consultationList.forEach(i -> {
            if (CollectionUtil.isEmpty(i.getConsultationDoctorList())) {
                return;
            }

            i.getConsultationDoctorList().forEach(j -> {
                // 保存到医生提醒
                // TODO 根据数据的完整性来进行提醒，若数据不完整，可以通过手动编辑再触发提醒
                DoctorRemindInfo remindInfo = this.getDoctorRemindInfo(i, j, pushDate);
                if (null != remindInfo) {
                    doctorRemindInfos.add(remindInfo);
                }
            });
        });

        // 保存需要的提醒
        saveDoctorRemindInfoList(doctorRemindInfos);
    }

    /**
     * 提醒 
     * 用于企业微信、短信推送
     */
    private DoctorRemindInfo getDoctorRemindInfo(ConsultationVO consultation, ConsultationDoctorVO consultationDoctor, DateTime pushDate) {
        if (null == consultation || StrUtil.isBlank(consultation.getName())) {
            return null;
        }
        
        Map<String, String> contentMap = new HashMap<>();
        contentMap.put("name", consultation.getName());
        contentMap.put("applyDeptName", consultation.getApplyDeptName());
        contentMap.put("applyDoctorName", consultation.getApplyDoctorName());

        DoctorRemindInfo doctorRemindInfo = new DoctorRemindInfo();
        doctorRemindInfo.setId(DoctorPushTaskHelper.getDoctorRemindId());
        doctorRemindInfo.setDoctorId(consultationDoctor.getDoctorId());
        doctorRemindInfo.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
        doctorRemindInfo.setBizId(consultationDoctor.getConsultationId());
        doctorRemindInfo.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
        doctorRemindInfo.setTitle(consultation.getName());
        doctorRemindInfo.setContent(JSON.toJSONString(contentMap));
        doctorRemindInfo.setRemark("消息提醒");
        doctorRemindInfo.setPushDate(pushDate);
        doctorRemindInfo.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindInfo.setRowsStatus(YN.YES.getCode());
        doctorRemindInfo.setPushChannel(PushWayEnum.PCW_WX_WORK.getCode());

        return doctorRemindInfo;
    }

    /**
     * 提醒 
     * 用于企业微信、短信推送
     */
    private void saveDoctorRemindInfoList(List<DoctorRemindInfo> remindList) {
        if (CollUtil.isEmpty(remindList)) {
            return;
        }

        List<String> consultationIds = new ArrayList<>();
        List<String> doctorIds = new ArrayList<>();
        remindList.forEach(i -> {
            consultationIds.add(i.getBizId());
            doctorIds.add(i.getDoctorId());
        });
        
        Map<String, DoctorRemindInfo> existMap = new HashMap<>();
        List<DoctorRemindInfo> existList = doctorRemindInfoService.list(new QueryWrapper<DoctorRemindInfo>()
                .eq("biz_one_type", PushTaskConstant.OpType.MDT.getCode())
                .in("doctor_id", doctorIds)
                .in("biz_id", consultationIds)
        );
        if (CollUtil.isNotEmpty(existList)) {
            existList.forEach(i -> existMap.put(i.getBizId() + "-" + i.getDoctorId(), i));
        }

        
        List<DoctorRemindInfo> saveList = new ArrayList<>();
        remindList.forEach(i -> {
            DoctorRemindInfo exist = existMap.get(i.getBizId() + "-" + i.getDoctorId());
            if (null == exist) {
                saveList.add(i);
            }
        });

        doctorRemindInfoService.saveBatch(saveList);
    }

    /**
     * 过期未参加会诊的医生，设置为过期，从对应学科寻找替补医生并通知
     */
    @Override
    public void consultationJoinTaskJobHandler(int timeout) {
        String overdueTime = DateUtil.offsetMinute(DateUtil.date(), -timeout).toString("yyyy-MM-dd HH:mm:ss");
        // 查询超时未接收医生信息
        List<ConsultationDTO> expireDoctorList = consultationMapper.expireDoctorList(new QueryWrapper<ConsultationInfo>()
            .eq("b.status", ConsultationConstant.DoctorStatus.TODO.getCode())
            .lt("b.op_time", overdueTime) // 过期
        );

        if (CollectionUtil.isEmpty(expireDoctorList)) {
            return;
        }

        // 查询有超时医生的会诊对应的所有医生，用于在从学科中获取医生时排除这些医生
        Set<String> consultationIds = new HashSet<>();
        expireDoctorList.forEach(i -> consultationIds.add(i.getId()));
        List<ConsultationDoctorInfo> consultationList = consultationDoctorInfoService.list(new QueryWrapper<ConsultationDoctorInfo>()
            .in("consultation_id", consultationIds)
        );
        if (CollectionUtil.isEmpty(consultationList)) {
            return;
        }

        Map<String, Set<String>> excludeDoctorIdMap = new HashMap<>();
        consultationList.forEach(i -> {
            Set<String> doctorIds = excludeDoctorIdMap.get(i.getConsultationId());
            if (null == doctorIds) {
                doctorIds = new HashSet<>();
                excludeDoctorIdMap.put(i.getConsultationId(), doctorIds);
            }
            doctorIds.add(i.getDoctorId());
        });



        // 超时则从超时的医生对应的学科中获取医生并对其推送会诊信息
        List<String> overTimeDoctorList = new ArrayList<>(); // 超时的会诊医生更新状态
        List<ConsultationDoctorAddDTO> addDoctorList = new ArrayList<>(); // 保存会诊医生
        List<DoctorRemindInfo> addRemindList = new ArrayList<>(); // 保存提醒，用于推送企业微信信息
        for (ConsultationDTO consultation : expireDoctorList) {

            Set<String> excludeDoctorIds = excludeDoctorIdMap.get(consultation.getId());

            // 根据学科（dutyCode）查询sys_user表获取可以替补的医生，需要排除已经在该会诊的医生，一个医生可以同时参加多个会诊
            Map<String, String> doctorMap = consultationMapper.subjectDoctor(new QueryWrapper<Void>()
                .eq("a.rows_status", YN.YES.getCode())
                // .eq("dept_code", consultation.getJoinDeptCode())
                .eq("a.subject_code", consultation.getDutyCode())
                .notIn("a.id", excludeDoctorIds)
                .orderByDesc("a.subject_order")
                .last(" limit 1 ")
            );

            // 把超时的医生状态更改为超时
            overTimeDoctorList.add(consultation.getId() + "-" + consultation.getJoinDoctorId());
 
            if (CollectionUtil.isEmpty(doctorMap)) {
                continue;
            }

            String doctorId = doctorMap.get("doctorId");
            String doctorName = doctorMap.get("doctorName");
            String deptId = doctorMap.get("deptId");
            String deptName = doctorMap.get("deptName");
    
            // 把新加入会诊的医生添加到排除出列表，防止接下来的查询替补还能查到
            excludeDoctorIds.add(doctorId);
            
            // 保存到会诊医生表（注意记录替补的医生）
            ConsultationDoctorAddDTO consultationDoctorAddDTO = new ConsultationDoctorAddDTO();
            consultationDoctorAddDTO.setConsultationId(consultation.getId());
            consultationDoctorAddDTO.setDeptCode(deptId);
            consultationDoctorAddDTO.setDeptName(deptName);
            consultationDoctorAddDTO.setDoctorId(doctorId);
            consultationDoctorAddDTO.setDoctorName(doctorName);
            consultationDoctorAddDTO.setDutyCode(consultation.getDutyCode());
            consultationDoctorAddDTO.setDutyName(consultation.getDutyName());
            consultationDoctorAddDTO.setDoctorType(ConsultationConstant.DoctorType.ALTERNATE.getCode());
            consultationDoctorAddDTO.setStatus(ConsultationConstant.DoctorStatus.TODO.getCode());
            if (ConsultationConstant.DoctorType.APPOINT.getCode().equals(consultation.getJoinDoctorType())) {
                consultationDoctorAddDTO.setTransferDoctorId(consultation.getJoinDoctorId());
            } else {
                consultationDoctorAddDTO.setTransferDoctorId(consultation.getTransferDoctorId());
            }
            addDoctorList.add(consultationDoctorAddDTO);


            // 保存到提醒用于企业微信发送消息：1.提醒替补人员  2.提醒会议发起人
            // 提醒替补人员参加会诊
            
            String title = StrUtil.format("邀您参加MDT会诊:{}", consultation.getName());
            String content = StrUtil.format("邀您参加MDT会诊:{}", consultation.getName());

            DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
            remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
            remindDoctor.setDoctorId(doctorId);
            remindDoctor.setBizId(consultation.getId());
            remindDoctor.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 会诊
            remindDoctor.setTitle(title);
            remindDoctor.setContent(content);
            remindDoctor.setRemark("消息提醒"); // TODO FIXME: 使用html或markdown进行消息的配置
            remindDoctor.setPushDate(DateUtil.date());
            remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            remindDoctor.setRowsStatus(YN.YES.getCode());
            addRemindList.add(remindDoctor);

            // TODO 提醒发起人有会诊医生超时未参加会诊
            // DoctorRemindInfo remindApplyDoctor = new DoctorRemindInfo();
            // remindApplyDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
            // remindApplyDoctor.setDoctorId(doctorId);
            // remindApplyDoctor.setBizOneType("consultation"); // 会诊
            // remindApplyDoctor.setBizId(consultation.getId());
            // remindApplyDoctor.setTitle(consultation.getName());
            // remindApplyDoctor.setContent(consultation.getName());
            // remindApplyDoctor.setRemark("企业微信消息提醒");
            // remindApplyDoctor.setPushDate(DateUtil.date());
            // remindApplyDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            // remindApplyDoctor.setRowsStatus(YN.YES.getCode());
            // addRemindList.add(remindApplyDoctor);
        }

        // 更新超时医生
        if (CollectionUtil.isNotEmpty(overTimeDoctorList)) {
            consultationDoctorInfoService.update(new UpdateWrapper<ConsultationDoctorInfo>()
                .set("status", ConsultationConstant.DoctorStatus.TIMEOUT.getCode())
                .in("CONCAT(consultation_id, '-', doctor_id)", overTimeDoctorList)
            );
        }

        // 添加替补会诊医生
        if (CollectionUtil.isNotEmpty(addDoctorList)) {
            consultationDoctorBizService.addBatch(addDoctorList);
        }

        // 发送企业微信提醒会诊信息
        if (CollectionUtil.isNotEmpty(addRemindList)) {
            doctorRemindInfoService.saveBatch(addRemindList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void consultationLaunchApplyTask(int timeout, Date startDate, Date endDate) {
        Date now = DateUtil.date();
        Date expireDate = DateUtil.offsetDay(DateUtil.offsetHour(now, -timeout), -1);  // 由于调用的服务的结束时间会默认增加一天，所以这边先减去一天
        
        // 处理过期的数据
        log.info("处理过期的数据");
        ConsultationLaunchApplyQueryDTO expireLaunchApplyQueryDTO = new ConsultationLaunchApplyQueryDTO();
        expireLaunchApplyQueryDTO.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.START.getCode());
        expireLaunchApplyQueryDTO.setEndDate(expireDate);
        List<ConsultationLaunchApplyVO> expireApplyList = consultationLaunchApplyBizService.list(expireLaunchApplyQueryDTO);
        if (CollUtil.isNotEmpty(expireApplyList)) {
            List<ConsultationLaunchApplyUpdateStatusDTO> list = new ArrayList<>();
            expireApplyList.forEach(i -> {
                ConsultationLaunchApplyUpdateStatusDTO update = new ConsultationLaunchApplyUpdateStatusDTO();
                update.setId(i.getId());
                update.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.START_EXPIRE.getCode());

                list.add(update);
            });
            consultationLaunchApplyBizService.batchUpdateStatus(list);
        }

        // 查询指定时间内所有发起会诊申请数据 
        // 同步10天内的会诊申请
        log.info("查询指定时间内所有发起会诊申请数据");
        List<String> statuses = new ArrayList<>();
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.START.getCode());
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.START_EXPIRE.getCode());  // 过期的也要同步（过期后才发起会诊）
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.TIMEOUT_UNDOING.getCode());  // 过期的也要同步（过期后才发起会诊）
        ConsultationLaunchApplyQueryDTO launchApplyQueryDTO = new ConsultationLaunchApplyQueryDTO();
        launchApplyQueryDTO.setStatuses(statuses);
        // launchApplyQueryDTO.setStartDate(DateUtil.offsetDay(now, -syncTime));
        launchApplyQueryDTO.setStartDate(startDate);
        launchApplyQueryDTO.setEndDate(endDate);
        List<ConsultationLaunchApplyVO> applyList = consultationLaunchApplyBizService.list(launchApplyQueryDTO);
        if (CollUtil.isEmpty(applyList)) {
            return;
        }

        List<String> patientIds = new ArrayList<>();
        applyList.forEach(i -> patientIds.add(i.getPatientId()));
        // 查询指定时间内患者会诊数据
        log.info("查询指定时间内患者会诊数据");
        List<ConsultationInfo> consultationList = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("patient_id", patientIds)
                // .ge("apply_time", DateUtil.offsetDay(now, -syncTime))
                .ge("apply_time", startDate)
                .lt(null != endDate, "apply_time", endDate)
        );
        if (CollUtil.isEmpty(consultationList)) {
            return;
        }

        log.info("查询会诊医生信息");
        Map<String, List<ConsultationDoctorInfo>> consultationDoctorMap = new HashMap<>();
        List<String> consultationIds = new ArrayList<>();
        consultationList.forEach(i -> consultationIds.add(i.getId()));
        if (CollUtil.isNotEmpty(consultationIds)) {
            List<ConsultationDoctorInfo> consultationDoctorList = consultationDoctorInfoService.list(new QueryWrapper<ConsultationDoctorInfo>()
                .in("consultation_id", consultationIds)
            );

            if (CollUtil.isNotEmpty(consultationDoctorList)) {
                consultationDoctorList.forEach(i -> {
                    List<ConsultationDoctorInfo> list = consultationDoctorMap.get(i.getConsultationId());
                    if (null == list) {
                        list = new ArrayList<>();
                        consultationDoctorMap.put(i.getConsultationId(), list);
                    }
                    list.add(i);
                });
            }
        }

        log.info("整理患者会诊map");
        Map<String, List<ConsultationInfo>> consultationMap = new HashMap<>();
        consultationList.forEach(i -> {
            List<ConsultationInfo> list = consultationMap.get(i.getPatientId());
            if (null == list) {
                list = new ArrayList<>();
                consultationMap.put(i.getPatientId(), list);
            }
            list.add(i);
        });

        log.info("更新会诊申请");
        List<ConsultationLaunchApplyVO> updateApplyList = new ArrayList<>();
        applyList.forEach(i -> {
            log.info("会诊申请信息： {}", JSON.toJSONString(i));
            if (StrUtil.isNotBlank(i.getConsultationId())) { // 已有关联会诊则跳过
                return;
            }
            List<ConsultationInfo> list = consultationMap.get(i.getPatientId());
            if (CollUtil.isEmpty(list)) {
                return;
            }
            ConsultationInfo consultationInfo = null;

            if (ConsultationLaunchApplyConstant.Type.Task.getCode().equals(i.getType())) {
                LabelBO label = i.getConsultationLabelInfo();
                log.info("随访标签信息： {}", JSON.toJSONString(label));
                if (null == label || CollUtil.isEmpty(label.getConsultationDeptIds())) {
                    return;
                }
                for (ConsultationInfo j : list) {
                    log.info("会诊信息： {}", JSON.toJSONString(j));
                    List<ConsultationDoctorInfo> consultationDoctorList = consultationDoctorMap.get(j.getId());
                    if (CollUtil.isEmpty(consultationDoctorList)) {
                        continue;
                    }
                    for (ConsultationDoctorInfo doctor : consultationDoctorList) {
                        // if (i.getApplyTime().before(j.getApplyTime()) && i.getLaunchDoctorId().equals(j.getApplyDoctorId()) && label.getConsultationDeptIds().contains(doctor.getDeptCode())) {
                        //     consultationInfo = j;
                        // }
                        // 自动会诊只需要判断住院号和会诊医生科室，不需要判断床位医生是否是实际的会诊发起人
                        if (i.getInpatientId().equals(j.getInpatientId()) && label.getConsultationDeptIds().contains(doctor.getDeptCode())) {
                            consultationInfo = j;
                        }
                    }
                }
            } else {
                // TODO 注意匹配功能待完善，有可能申请会诊的病种/科室与实际会诊病种/科室不匹配，也就是说患者有多个会诊，如何确定哪一个会诊是实际需要匹配上的会诊
                for (ConsultationInfo j : list) {
                    if (i.getApplyTime().before(j.getApplyTime()) && i.getLaunchDoctorId().equals(j.getApplyDoctorId())) {
                        consultationInfo = j;
                    }
                }
            }
            
            if (null != consultationInfo) {
                i.setConsultationId(consultationInfo.getId());
                // 1.开始状态的申请更新为会诊进行中；2.跑历史的数据状态可能已经过期，但会诊发起相对于申请确实没过期所以也更新为进行中
                if (ConsultationLaunchApplyConstant.ApplyStatus.START.getCode().equals(i.getStatus()) || !DateUtil.offsetHour(i.getApplyTime(), timeout).before(consultationInfo.getApplyTime())) {
                    i.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.DOING.getCode());
                }
                i.setSubmitTime(consultationInfo.getApplyTime());
                updateApplyList.add(i);
            }
        });

        log.info("保存会诊申请");
        if (CollUtil.isNotEmpty(updateApplyList)) {
            // 更新申请状态
            List<ConsultationLaunchApplyUpdateStatusDTO> list = new ArrayList<>();
            updateApplyList.forEach(i -> {
                ConsultationLaunchApplyUpdateStatusDTO update = new ConsultationLaunchApplyUpdateStatusDTO();
                update.setId(i.getId());
                update.setConsultationId(i.getConsultationId());
                update.setSubmitTime(i.getSubmitTime());
                update.setStatus(i.getStatus());

                list.add(update);
            });
            
            consultationLaunchApplyBizService.batchUpdateStatus(list);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void consultationLaunchApplyResultTask(int timeout, Date startDate, Date endDate) {
        Date now = DateUtil.date();
        Date expireDate = DateUtil.offsetDay(DateUtil.offsetHour(now, -timeout), -1);  // 由于调用的服务的结束时间会默认增加一天，所以这边先减去一天
        
        // 处理过期的数据
        ConsultationLaunchApplyQueryDTO expireLaunchApplyQueryDTO = new ConsultationLaunchApplyQueryDTO();
        expireLaunchApplyQueryDTO.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.DOING.getCode());
        expireLaunchApplyQueryDTO.setEndDate(expireDate);
        List<ConsultationLaunchApplyVO> expireApplyList = consultationLaunchApplyBizService.list(expireLaunchApplyQueryDTO);
        if (CollUtil.isNotEmpty(expireApplyList)) {
            List<ConsultationLaunchApplyUpdateStatusDTO> list = new ArrayList<>();
            expireApplyList.forEach(i -> {
                ConsultationLaunchApplyUpdateStatusDTO update = new ConsultationLaunchApplyUpdateStatusDTO();
                update.setId(i.getId());
                update.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.EXPIRE.getCode());

                list.add(update);
            });
            consultationLaunchApplyBizService.batchUpdateStatus(list);
        }

        // 查询指定时间内所有发起会诊申请数据
        // 同步10天内的会诊申请
        List<String> statuses = new ArrayList<>();
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.START_EXPIRE.getCode()); // 过期的也要同步(若已关联会诊)
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.TIMEOUT_UNDOING.getCode()); // 过期的也要同步(若已关联会诊)
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.DOING.getCode());
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.EXPIRE.getCode()); // 过期的也要同步
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.TIMEOUT_UNDONE.getCode()); // 过期的也要同步
        statuses.add(ConsultationLaunchApplyConstant.ApplyStatus.CANCEL.getCode()); // 申诉通过后会设置为取消状态，但有实际的会诊也要
        ConsultationLaunchApplyQueryDTO launchApplyQueryDTO = new ConsultationLaunchApplyQueryDTO();
        launchApplyQueryDTO.setStatuses(statuses);
        // launchApplyQueryDTO.setStartDate(DateUtil.offsetDay(now, -syncTime));
        launchApplyQueryDTO.setStartDate(startDate);
        launchApplyQueryDTO.setEndDate(endDate);
        List<ConsultationLaunchApplyVO> applyList = consultationLaunchApplyBizService.list(launchApplyQueryDTO);
        if (CollUtil.isEmpty(applyList)) {
            return;
        }

        List<String> consultationIds = new ArrayList<>();
        applyList.forEach(i -> {
            if (StrUtil.isNotBlank(i.getConsultationId())) {
                consultationIds.add(i.getConsultationId());
            }
        });
        // 查询指定时间内患者会诊数据
        List<HisConsultationAdviceInfo> hisConsultationAdviceList = hisConsultationAdviceInfoService.list(new QueryWrapper<HisConsultationAdviceInfo>()
                .in("consultation_id", consultationIds)
        );
        if (CollUtil.isEmpty(hisConsultationAdviceList)) {
            return;
        }
        Map<String, HisConsultationAdviceInfo> hisConsultationAdviceMap = new HashMap<>();
        hisConsultationAdviceList.forEach(i -> {
            hisConsultationAdviceMap.put(i.getConsultationId(), i);
        });

        List<ConsultationLaunchApplyVO> updateApplyList = new ArrayList<>();
        applyList.forEach(i -> {
            if (StrUtil.isBlank(i.getConsultationId())) {
                return;
            }
            HisConsultationAdviceInfo hisAdvice = hisConsultationAdviceMap.get(i.getConsultationId());
            if (null != hisAdvice) {
                Date submitDate = hisAdvice.getSubmitTime();
                // 1.进行状态的申请更新为会诊完成；2.跑历史的数据状态可能已经过期，但会诊结论提交相对于申请确实没过期所以也更新为完成
                if (ConsultationLaunchApplyConstant.ApplyStatus.DOING.getCode().equals(i.getStatus()) || (null != submitDate && !DateUtil.offsetHour(i.getApplyTime(), timeout).before(submitDate))) {
                    i.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.DONE.getCode());
                }
                i.setFinishTime(submitDate);
                if (null == submitDate) {
                    i.setFinishTime(i.getSubmitTime()); // 会诊结论没有提交时间则赋值为会诊发起时间
                }
                updateApplyList.add(i);
            }
        });

        if (CollUtil.isNotEmpty(updateApplyList)) {
            List<ConsultationLaunchApplyUpdateStatusDTO> list = new ArrayList<>();
            updateApplyList.forEach(i -> {
                ConsultationLaunchApplyUpdateStatusDTO update = new ConsultationLaunchApplyUpdateStatusDTO();
                update.setId(i.getId());
                update.setFinishTime(i.getFinishTime());
                update.setStatus(i.getStatus());

                list.add(update);
            });
            
            consultationLaunchApplyBizService.batchUpdateStatus(list);
        }
    }

    @Override
    public void labelConsultationLaunchApplyResultTask(Date startTime, Date endTime) {
        // 1. 查询指定时间的会诊标签患者
        log.info("1. 查询指定时间的会诊标签患者");
        List<Map<String, String>> patientMap = consultationMapper.patientLabelList(new QueryWrapper<Void>()
            .eq("b.consultation_remind_status", YN.YES.getCode())
            .ge("a.data_dt", startTime)
            .le("a.data_dt", endTime)
        );

        if (CollUtil.isEmpty(patientMap)) {
            return;
        }

        List<String> patientIds = new ArrayList<>();
        patientMap.forEach(i -> {
            patientIds.add(i.get("patientId"));
        });

        // 2. 根据患者最新住院记录提醒管床医生发起会诊
        // 直接查询住院但未出院的患者，不需要限制时间（有可能患者数据上住院没出院但实际出院（可能是没缴费没办理出院手续私自出院））
        log.info("2. 根据患者最新住院但未出院记录提醒管床医生发起会诊");
        PatientLastDataQueryDTO patientLastDataQueryDTO = new PatientLastDataQueryDTO();
        patientLastDataQueryDTO.setStartDate(DateUtil.offsetDay(startTime, -30));
        patientLastDataQueryDTO.setPatientIds(patientIds);
        Map<String, PatientInpatientRecordClientBO> inpatientRecordsMap = dwdDataPatientClientService.mapPatientInpatientLastDateAndNotOut(patientLastDataQueryDTO);
        if (CollUtil.isEmpty(inpatientRecordsMap)) {
            return;
        }

        Map<String, PatientInpatientRecordClientBO> inpatientRecordMap = new HashMap<>(); // 整理后的住院记录
        List<String> inpatientIds = new ArrayList<>();
        inpatientRecordsMap.forEach((k, v) -> {
            if (!YN.YES.getCode().equals(v.getIsOut())) { // 补刀：没有出院信息有可能没有及时同步到，可以通过住院变更信息来进行一次是否出院验证
                inpatientRecordMap.put(k, v);
                inpatientIds.add(v.getVisitId());
            }
        });

        if (CollUtil.isEmpty(inpatientIds)) {
            return;
        }

        // 3. 查询是否已经有会诊申请，有则跳过
        // log.info("3. 查询是否已经有会诊申请，有则跳过");
        // ConsultationLaunchApplyQueryDTO launchApplyQueryDTO = new ConsultationLaunchApplyQueryDTO();
        // launchApplyQueryDTO.setInpatientIds(inpatientIds);
        // List<ConsultationLaunchApplyVO> launchApplyVOs = consultationLaunchApplyBizService.simpleList(launchApplyQueryDTO);
        // if (CollUtil.isNotEmpty(launchApplyVOs)) {
        //     launchApplyVOs.forEach(i -> {
        //         if(inpatientRecordMap.containsKey(i.getPatientId())) {
        //             inpatientRecordMap.remove(i.getPatientId());
        //         }
        //     });
        // }

        // TODO zs20240909 验证会诊是否已经有生成
        // 查询指定时间内患者会诊数据
        log.info("查询指定时间内患者会诊数据");
        Map<String, List<ConsultationInfo>> consultationMap = new HashMap<>(); // key:住院号  value:会诊列表
        Map<String, List<ConsultationDoctorInfo>> consultationDoctorMap = new HashMap<>(); // key：会诊id  value：会诊医生列表
        List<ConsultationInfo> consultationList = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
                .eq("rows_status", YN.YES.getCode())
                .in("inpatient_id", inpatientIds)
        );
        if (CollUtil.isNotEmpty(consultationList)) {
            log.info("查询会诊医生信息");
            List<String> consultationIds = new ArrayList<>();
            consultationList.forEach(i -> {
                List<ConsultationInfo> list = consultationMap.get(i.getInpatientId());
                if (null == list) {
                    list = new ArrayList<>();
                    consultationMap.put(i.getInpatientId(), list);
                }
                list.add(i);

                consultationIds.add(i.getId());
            });

            if (CollUtil.isNotEmpty(consultationIds)) {
                List<ConsultationDoctorInfo> consultationDoctorList = consultationDoctorInfoService.list(new QueryWrapper<ConsultationDoctorInfo>()
                    .in("consultation_id", consultationIds)
                );

                if (CollUtil.isNotEmpty(consultationDoctorList)) {
                    consultationDoctorList.forEach(i -> {
                        List<ConsultationDoctorInfo> list = consultationDoctorMap.get(i.getConsultationId());
                        if (null == list) {
                            list = new ArrayList<>();
                            consultationDoctorMap.put(i.getConsultationId(), list);
                        }
                        list.add(i);
                    });
                }
            }
        }

        
        // 4. 生成会诊提醒数据
        log.info("4. 生成会诊提醒数据");
        List<ConsultationLaunchApplyInfo> entityList = new ArrayList<>();
        patientMap.forEach(i -> {
            PatientInpatientRecordClientBO inpatientRecord = inpatientRecordMap.get(i.get("patientId"));
            if (null == inpatientRecord || StrUtil.isBlank(inpatientRecord.getDoctorCode())) {
                return;
            }

            List<String> applyDeptIds = StrJoinSplitUtils.split2List(i.get("consultationDeptIds"));
            
            // 住院科室（管床医生科室）在标签设置的科室中则不生成提醒
            String inpatientDeptCode = inpatientRecord.getAdmitDepartmentCodeStandard();
            if (StrUtil.isNotBlank(inpatientDeptCode) && CollUtil.isNotEmpty(applyDeptIds) && applyDeptIds.contains(inpatientDeptCode)) {
                return;
            }

            ConsultationInfo consultation = null;
            // 判断要生成的提醒是否已经发起过会诊
            List<ConsultationInfo> consultations = consultationMap.get(inpatientRecord.getInPatientNo());
            if (CollUtil.isNotEmpty(consultations)) {
                for (ConsultationInfo j : consultations) {
                    log.info("会诊信息： {}", JSON.toJSONString(j));
                    List<ConsultationDoctorInfo> consultationDoctorList = consultationDoctorMap.get(j.getId());
                    if (CollUtil.isEmpty(consultationDoctorList)) {
                        continue;
                    }
                    for (ConsultationDoctorInfo doctor : consultationDoctorList) {
                        if (applyDeptIds.contains(doctor.getDeptCode())) {
                            consultation = j;
                        }
                    }
                }
            }

            // 校验同病种的标签
            if (this.repeatApply(entityList, inpatientRecord.getPatientId(), inpatientRecord.getVisitId(), i.get("labelId"), applyDeptIds)) {
                // 发起过相同病种的会诊
                return;
            }

            ConsultationLaunchApplyInfo entity = new ConsultationLaunchApplyInfo();
            entity.setId(ConsultationHelper.getConsultationLaunchApplyId());

            entity.setType(ConsultationLaunchApplyConstant.Type.Task.getCode());
            entity.setConsultationType(ConsultationConstant.ConsultationType.ORDINARY.getCode());
            entity.setPatientId(inpatientRecord.getPatientId());
            entity.setInpatientId(inpatientRecord.getVisitId());
            entity.setVisitId(inpatientRecord.getVisitId());
            entity.setApplyDoctorId(inpatientRecord.getDoctorCode());
            entity.setLaunchDoctorId(inpatientRecord.getDoctorCode());
            entity.setConsultationLabelId(i.get("labelId"));
            entity.setInpatientRecordLog(JSON.toJSONString(inpatientRecord));

            if (i.containsKey("consultationDeptIds") && null != i.get("consultationDeptIds")) {
                entity.setJoinDept(i.get("consultationDeptIds"));
            }

            // entity.setDiseaseId(inpatientRecord.getDiagnosisCodeStandard());
            String diseaseIds = i.get("diseaseIds");
            if (StrUtil.isNotBlank(diseaseIds)) {
                entity.setDiseaseId(StrJoinSplitUtils.split2List(diseaseIds).get(0));
            }

            // String consultationSubjectName = i.get("consultationSubjectName");
            // entity.setContent(StrUtil.format("请邀请{}医生参加针对住院患者{}的会诊，{}", StrUtil.isBlank(consultationSubjectName) ? "相关" : consultationSubjectName, inpatientRecord.getPatientName(), i.get("consultationRemark")));
            entity.setContent(i.get("consultationRemark"));
            entity.setApplyTime(DateUtil.date());
            // entity.setManageId(null); // 数据非由运营助理管理患者而来（即先加入管理再进行会诊提醒）
            entity.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.START.getCode());
            entity.setRowsStatus(YN.YES.getCode());

            if (null != consultation) {
                entity.setConsultationId(consultation.getId());
                entity.setSubmitTime(consultation.getSubmitTime());
                entity.setStatus(ConsultationLaunchApplyConstant.ApplyStatus.DOING.getCode());
            }

            entityList.add(entity);
        });

        // 5. 发起会诊并提醒
        log.info("5. 发起会诊并提醒");
        if (CollUtil.isNotEmpty(entityList)) {

            log.info("6. 保存会诊申请信息");
            consultationLaunchApplyInfoService.saveBatch(entityList);
            // 发送会诊消息通知
            consultationNotifyInfoBizService.addNotify(entityList);

            List<DoctorRemindInfo> remindList = new ArrayList<>();
            entityList.forEach(i -> {
                PatientInpatientRecordClientBO inpatientRecord = inpatientRecordMap.get(i.getPatientId());

                Map<String, String> contentMap = new HashMap<>();
                contentMap.put("applyDeptName", inpatientRecord.getAdmitDepartmentNameStandard());
                contentMap.put("applyDoctorName", inpatientRecord.getDoctorName());
                contentMap.put("patientName", inpatientRecord.getPatientName());
                contentMap.put("content", i.getContent());
                
                DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
                remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
                remindDoctor.setDoctorId(i.getLaunchDoctorId());
                remindDoctor.setBizId(i.getId());
                remindDoctor.setBizOneType(PushTaskConstant.OpType.ApplyMDT.getCode()); // 会诊
                remindDoctor.setBizTwoType(PushTaskConstant.OpType.ApplyMDT.getCode()); // 会诊
                remindDoctor.setTitle("发起会诊消息提醒");
                remindDoctor.setContent(JSON.toJSONString(contentMap));
                remindDoctor.setRemark("发起会诊消息提醒"); // TODO FIXME: 使用html或markdown进行消息的配置
                remindDoctor.setPushDate(DateUtil.date());
                remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
                remindDoctor.setRowsStatus(YN.YES.getCode());

                remindList.add(remindDoctor);
                // 发送参加会诊通知
//                consultationNotifyInfoBizService.addDoctorRemind(i.getId(), inpatientRecord.getAdmitDepartmentNameStandard(), inpatientRecord.getDoctorName(), inpatientRecord.getPatientName());
                joinDoctorRemind(i.getId(), inpatientRecord, remindList);
            });

            log.info("7. 保存会诊消息提醒");
            doctorRemindInfoService.saveBatch(remindList);
        }
    }


    // 校验同一患者，住院号，同一种病种的标签发起过会诊，
    // 相同标签的校验
    /**
     * @param entityList  要insert的数据
     * @param patientId   患者id
     * @param visitId 就诊记录号
     * @param applyDeptIds 参加会诊的部门ids
     *
     */
    private boolean repeatApply(List<ConsultationLaunchApplyInfo> entityList,
                                String patientId, String visitId, String applyConsultationLabelId, List<String> applyDeptIds){
        // 标签已经发布过会诊
        long count = consultationLaunchApplyInfoService.count(new QueryWrapper<ConsultationLaunchApplyInfo>()
                .eq("patient_id", patientId)
                .eq("visit_id", visitId)
                .eq("consultation_label_id", applyConsultationLabelId));
        if (count > 0) {
            // 标签发布过会诊
            return true;
        }
        Set<String> consultationLabelIds = new HashSet<>();
        // 校验是否已存在同种标签
        List<ConsultationLaunchApplyInfo> applyInfoList = consultationLaunchApplyInfoService.list(new QueryWrapper<ConsultationLaunchApplyInfo>()
                .eq("patient_id", patientId)
                .eq("visit_id", visitId)

        );
        if (CollUtil.isNotEmpty(applyInfoList)) {
            applyInfoList.forEach(item->{
                if (StrUtil.isNotEmpty(item.getConsultationLabelId())) {
                    consultationLabelIds.add(item.getConsultationLabelId());
                }
            });
        }
        if (CollUtil.isNotEmpty(entityList)) {
            entityList.forEach(entity->{
                if (patientId.equals(entity.getPatientId())
                        && visitId.equals(entity.getVisitId())
                        && StrUtil.isNotEmpty(entity.getConsultationLabelId())) {
                    consultationLabelIds.add(entity.getConsultationLabelId());
                }
            });
        }
        if (CollUtil.isEmpty(consultationLabelIds)) {
            // 没有同病种的标签
            return false;
        }

        List<Map<String, String>> patientMapList = consultationMapper.standardLabelList(new QueryWrapper<Void>()
                .in("id", consultationLabelIds)
        );
        for (Map<String, String> patientMap : patientMapList) {
            List<String> deptIds = StrJoinSplitUtils.split2List(patientMap.get("consultation_dept_ids"));
            List<String> intersection = applyDeptIds.stream().filter(deptIds::contains).collect(Collectors.toList());
            if (CollUtil.isNotEmpty(intersection)) {
                String consultationLabelId = patientMap.get("id");
                List<ConsultationLaunchApplyInfo> applyInfoList2 = consultationLaunchApplyInfoService.list(new QueryWrapper<ConsultationLaunchApplyInfo>()
                        .eq("patient_id", patientId)
                        .eq("visit_id", visitId)
                        .eq("consultation_label_id",consultationLabelId)
                );
                applyInfoList2.forEach(apply->{
                    apply.setExtend1(StrUtil.isEmpty(apply.getExtend1()) ?
                            applyConsultationLabelId : apply.getExtend1() + "," + applyConsultationLabelId);
                });
                consultationLaunchApplyInfoService.updateBatchById(applyInfoList2);
                // 部门存在交集，校验为同病种
                return true;
            }
        }
        return false;
    }

    private void joinDoctorRemind(String applyId, PatientInpatientRecordClientBO inpatientRecord, List<DoctorRemindInfo> remindList) {
        // 添加参与医生的发送任务,只添加了参与会诊的发送,发起会诊的发送在launch()种已经添加
        List<ConsultationNotifyInfo> notifyInfos = consultationNotifyInfoService.list(new QueryWrapper<ConsultationNotifyInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq("apply_id", applyId)
                .eq("notify_type", ConsultationNotifyConstant.NotifyType.JOIN.getCode())
        );

        if (CollUtil.isEmpty(notifyInfos)) {
            return;
        }
        for (ConsultationNotifyInfo notify : notifyInfos) {
            Map<String, String> contentMap = new HashMap<>();
            contentMap.put("applyDeptName", inpatientRecord.getAdmitDepartmentNameStandard());
            contentMap.put("applyDoctorName", inpatientRecord.getDoctorName());
            contentMap.put("patientName", inpatientRecord.getPatientName());
            contentMap.put("content", notify.getNotifyInfo());

            DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
            remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
            remindDoctor.setDoctorId(notify.getDoctorId());
            remindDoctor.setBizId(notify.getApplyId());
            remindDoctor.setBizOneType(PushTaskConstant.OpType.JoinMDT.getCode()); // 会诊
            remindDoctor.setBizTwoType(PushTaskConstant.OpType.JoinMDT.getCode()); // 会诊
            remindDoctor.setTitle("发现目标患者");
            remindDoctor.setContent(com.alibaba.fastjson2.JSON.toJSONString(contentMap));
            remindDoctor.setRemark("发现目标患者");
            remindDoctor.setPushDate(DateUtil.date());
            remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            remindDoctor.setRowsStatus(YN.YES.getCode());
            remindList.add(remindDoctor);
        }

    }

    @Override
    public void consultationAdviceTargetTask(Date startTime, Date endTime) {
        // 查询会诊结论列表
        List<HisConsultationAdviceInfo> consultationAdviceList = consultationMapper.analysisHisConsultationAdviceList(new QueryWrapper<HisConsultationAdviceInfo>()
            .ge(null != startTime, "a.submit_time", startTime)
            .lt(null != endTime, "a.submit_time", endTime)
            .isNull("a.target_type")
            .eq("b.apply_type", ConsultationConstant.ConsultationType.ORDINARY.getCode())
        );

        if (CollUtil.isEmpty(consultationAdviceList)) {
            return;
        }
        // 从字典中获取随访和转科的关键字
        DictDataListDTO dictDataListDTO = new DictDataListDTO();
        List<String> dictList = new ArrayList<>();
        dictList.add("is_follow_up");
        dictList.add("is_change_dept");
        dictDataListDTO.setDictTypeIds(dictList);
        List<DictDataVO> dictDataList = dictDataService.list(dictDataListDTO);
        List<String> isFollowUp = new ArrayList<>();
        List<String> isChangeDept = new ArrayList<>();
        for (DictDataVO vo : dictDataList) {
            if (vo.getDictTypeId().equals("is_follow_up")) {
                isFollowUp.add(vo.getDictLabel());
            } else if (vo.getDictTypeId().equals("is_change_dept")) {
                isChangeDept.add(vo.getDictLabel());
            }
        }
        // TODO 根据会诊结论调用会诊目标解析接口获取会诊目标（注意重试）
        // HealthyFrontendConfig healthyFrontendConfig = paramsClientService.getParamConfig("HEALTHY_FRONTEND", new HealthyFrontendConfig());
        consultationAdviceList.forEach(i -> {
            // consultationAsyncBizService.asyncAnalysisData(healthyFrontendConfig.getHost(), i);

            HisConsultationAdviceInfo hisConsultationAdviceInfo = new HisConsultationAdviceInfo();
            hisConsultationAdviceInfo.setId(i.getId());
            hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.NONE.getCode());

            try {
                // 调用ai解析会诊建议
                // HAnalysisDataModel sendResult = HAnalysisApiHelper.getAnalysisData(i.getSubmitContent());
                // 根据关键字解析(新模板)
                // 查询字典，我科随访
                // 复诊关键字
                HAnalysisDataModel sendResult = HAnalysisTempHelper.getAnalysisData(i.getSubmitContent(), isFollowUp, isChangeDept);
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e1) {
                    e1.printStackTrace();
                }

                // if (StrUtil.isNotBlank(result)) {
                //     Result<AnalysisDataModel> sendResult = JSONObject.parseObject(result, new TypeReference<Result<AnalysisDataModel>>(){});
                //     hisConsultationAdviceInfo.setTarget(sendResult.getMsg());
                //     if (0 != sendResult.getCode()) {
                //         hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Error.getCode());
                //     }
                    
                //     AnalysisDataModel analysisDataModel = sendResult.getData();
                //     if (null != analysisDataModel) {
                //         if (YN.YES.getCode().equals(analysisDataModel.getIsFollowUp())) {
                //             hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Follow_Up.getCode());
                //             hisConsultationAdviceInfo.setTargetStatus(ConsultationTargetStatus.DOING.getCode());
                //         } else if (YN.YES.getCode().equals(analysisDataModel.getIsChangeDept())) {
                //             hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Change_Dept.getCode());
                //             hisConsultationAdviceInfo.setTargetStatus(ConsultationTargetStatus.DOING.getCode());
                //         } else {
                //             hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.NONE.getCode());
                //         }
                //         hisConsultationAdviceInfo.setTarget(analysisDataModel.getSourceData());
                //     }
                // }

                if (null != sendResult) {
                    if (YN.YES.getCode().equals(sendResult.getIsChangeDept())) {
                        hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Change_Dept.getCode());
                        hisConsultationAdviceInfo.setTargetStatus(ConsultationTargetStatus.DOING.getCode());
                    } else if (YN.YES.getCode().equals(sendResult.getIsFollowUp())) {
                        hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Follow_Up.getCode());
                        hisConsultationAdviceInfo.setTargetStatus(ConsultationTargetStatus.DOING.getCode());
                    } else {
                        hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.NONE.getCode());
                    }
                    // hisConsultationAdviceInfo.setTarget(sendResult.getSourceData());
                    hisConsultationAdviceInfo.setTarget(JSON.toJSONString(sendResult));
                }
            } catch (Exception e) {
                log.error("解析会诊结论目标失败: message={}", e.getMessage());
                e.printStackTrace();
                hisConsultationAdviceInfo.setTarget(ConsultationTargetType.Error.getMsg());
                hisConsultationAdviceInfo.setTargetType(ConsultationTargetType.Error.getCode());
            }

            hisConsultationAdviceInfoService.updateById(hisConsultationAdviceInfo);
            
        });
    }

    // private static String loopPostHttp(String url, String body, Integer loopNum) {
    //     Map<String, String> mapContent = new HashMap<>();
    //     mapContent.put("content", body);
    //     try {
    //         String result = HttpRequest.post(url)
    //             .body(JSON.toJSONString(mapContent))
    //             .execute().body();
    
    //         log.info("发送结果：{}", result);
    //         return result;
    //     } catch (Exception e) {
    //         log.info("POST调用异常: {} ", url);
    //         e.printStackTrace();
            
    //         // 最多循环3次
    //         if (loopNum < 3) {
    //             // 先暂停
    //             log.info("休眠5000ms");
    //             try {
    //                 Thread.sleep(5000);
    //             } catch (InterruptedException e1) {
    //                 e1.printStackTrace();
    //             }
    //             // 出现异常再次调用
    //             return loopPostHttp(url, body, loopNum + 1);
    //         }
    //     }

    //     return null;
    // }

    @Override
    public void consultationAdviceTargetFinishTask(Date startTime, Date endTime) {
        // 查询有会诊目标（只针对转科目标）的会诊
        List<HisConsultationAdviceInfo> consultationAdviceList = hisConsultationAdviceInfoService.list(new QueryWrapper<HisConsultationAdviceInfo>()
            .ge(null != startTime, "submit_time", startTime)
            .lt(null != endTime, "submit_time", endTime)
            .eq("target_type", ConsultationTargetType.Change_Dept.getCode())
            // .eq("target_status", ConsultationTargetStatus.DOING.getCode())
        );
        if (CollUtil.isEmpty(consultationAdviceList)) {
            return;
        }

        List<String> consultationDoctorDeptIds = new ArrayList<>();
        List<String> consultationIds = new ArrayList<>();
        consultationAdviceList.forEach(i -> {
            consultationIds.add(i.getConsultationId());
            consultationDoctorDeptIds.add(i.getMdtDeptCode());
        });

        List<ConsultationInfo> consultationList = consultationInfoService.list(new QueryWrapper<ConsultationInfo>()
            .in("id", consultationIds)
        );
        if (CollUtil.isEmpty(consultationList)) {
            return;
        }
        
        // List<String> patientIds = new ArrayList<>();
        Map<String, String> consultationPatientMap = new HashMap<>(); // key: consultationId  value: patientId
        consultationList.forEach(i -> {
            consultationPatientMap.put(i.getId(), i.getPatientId());
            // patientIds.add(i.getPatientId());
        });

        // 根据会诊目标确定目标完成需要的逻辑
        // 1.转科：判断患者是否到该科室就诊
        List<Map<String, String>> relationDeptList = consultationMapper.relationDeptList(new QueryWrapper<Void>()
            .in("b.dept_id", consultationDoctorDeptIds)
        );

        Map<String, List<String>> relationDeptMap = new HashMap<>();
        if (CollUtil.isNotEmpty(relationDeptList)) {
            relationDeptList.forEach(i -> {
                String deptId = i.get("deptId");
                String relationDeptId = i.get("relationDeptId");

                List<String> l = relationDeptMap.get(deptId);
                if (null == l) {
                    l = new ArrayList<>();
                    relationDeptMap.put(deptId, l);
                }
                l.add(relationDeptId);
            });
        }

        Map<String, Date> changeNowDataMap = new HashMap<>();
        Map<String, Date> changeInpatientDataMap = new HashMap<>();
        Map<String, Date> changeVisitDataMap = new HashMap<>();

        consultationAdviceList.forEach(advice -> {
            log.info("advice>>>>>>>>> {}", JSON.toJSONString(advice));
            List<String> relationDeptIds = relationDeptMap.get(advice.getMdtDeptCode());

            if (CollUtil.isEmpty(relationDeptIds)) {
                return;
            }

            String patientId = consultationPatientMap.get(advice.getConsultationId());
            if (StrUtil.isBlank(patientId)) {
                return;
            }

            // 查询dwd层结论提交时间之后的一段时间（10天）内会诊患者与目标科室的就诊/住院信息/转科信息，若能查到则表明目标完成
            DataDwdPatientQueryClientDTO dataDwdPatientQueryClientDTO = new DataDwdPatientQueryClientDTO();
            dataDwdPatientQueryClientDTO.setPatientId(consultationPatientMap.get(advice.getConsultationId()));
            dataDwdPatientQueryClientDTO.setDeptIds(relationDeptIds);
            dataDwdPatientQueryClientDTO.setStartDate(advice.getSubmitTime());
            dataDwdPatientQueryClientDTO.setEndDate(DateUtil.offsetDay(advice.getSubmitTime(), 10));

            log.info("dataDwdPatientQueryClientDTO>>>>>>>>> {}", JSON.toJSONString(dataDwdPatientQueryClientDTO));
            
            // 转科
            List<PatientInpatientChangeClientBO> inpatientChangeList = dwdDataPatientClientService.patientInHospitalChangeList(dataDwdPatientQueryClientDTO);
            if (CollUtil.isNotEmpty(inpatientChangeList)) {
                // TODO
                inpatientChangeList.forEach(i -> {
                    Date visitDate = changeNowDataMap.get(advice.getConsultationId());
                    if (null != i.getChangeTime() ) {
                        Date changeTime = DateUtil.parseDateTime(i.getChangeTime());
                        if (null == visitDate || visitDate.after(changeTime)) {
                            changeNowDataMap.put(advice.getConsultationId(), changeTime);
                        }
                    }
                });
            }

            // 住院
            List<PatientInpatientRecordClientBO> inpatientList = dwdDataPatientClientService.patientInHospitalList(dataDwdPatientQueryClientDTO);
            if (CollUtil.isNotEmpty(inpatientList)) {
                // TODO
                inpatientList.forEach(i -> {
                    Date visitDate = changeInpatientDataMap.get(advice.getConsultationId());
                    if (null == visitDate || visitDate.after(i.getInpatientDate())) {
                        changeInpatientDataMap.put(advice.getConsultationId(), i.getInpatientDate());
                    }
                });
            }

            // 就诊
            List<PatientVisitRecordClientBO> visitList = dwdDataPatientClientService.patientVisitList(dataDwdPatientQueryClientDTO);
            if (CollUtil.isNotEmpty(visitList)) {
                // TODO
                visitList.forEach(i -> {
                    Date visitDate = changeVisitDataMap.get(advice.getConsultationId());
                    if (null == visitDate || visitDate.after(i.getVisitDate())) {
                        changeVisitDataMap.put(advice.getConsultationId(), i.getVisitDate());
                    }
                });
            }

        });

        // 更新
        List<HisConsultationAdviceInfo> updateList = new ArrayList<>();
        consultationAdviceList.forEach(i -> {
            if (changeNowDataMap.containsKey(i.getConsultationId())) {
                HisConsultationAdviceInfo advice = new HisConsultationAdviceInfo();
                advice.setId(i.getId());
                advice.setTargetSubType(ConsultationTargetSubType.Change_Now.getCode());
                advice.setTargetStatus(ConsultationTargetStatus.DONE.getCode());
                advice.setTargetFinishTime(changeNowDataMap.get(i.getConsultationId()));
                updateList.add(advice);
            } else if (changeInpatientDataMap.containsKey(i.getConsultationId())) {
                HisConsultationAdviceInfo advice = new HisConsultationAdviceInfo();
                advice.setId(i.getId());
                advice.setTargetSubType(ConsultationTargetSubType.Change_Inpatient.getCode());
                advice.setTargetStatus(ConsultationTargetStatus.DONE.getCode());
                advice.setTargetFinishTime(changeInpatientDataMap.get(i.getConsultationId()));
                updateList.add(advice);
            } else if (changeVisitDataMap.containsKey(i.getConsultationId())) {
                HisConsultationAdviceInfo advice = new HisConsultationAdviceInfo();
                advice.setId(i.getId());
                advice.setTargetSubType(ConsultationTargetSubType.Change_Visit.getCode());
                advice.setTargetStatus(ConsultationTargetStatus.DONE.getCode());
                advice.setTargetFinishTime(changeVisitDataMap.get(i.getConsultationId()));
                updateList.add(advice);
            }
        });

        if (CollUtil.isNotEmpty(updateList)) {
            hisConsultationAdviceInfoService.updateBatchById(updateList);
        }
    }

    @Override
    public void consultationStatTask(Date startDate, Date endDate) {
        DateTime now = DateUtil.parseDate(DateUtil.date().toDateStr());
        if (null == startDate) {
            startDate = now;
        }
        if (null == endDate || endDate.after(now)) {
            endDate = now;
        }
        
        while (!startDate.after(endDate)) {
            List<ConsultationLaunchApplyStatVO> statList = consultationMapper.consultationApplyStatistic(new QueryWrapper<ConsultationLaunchApplyInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .ne("a.status", ConsultationLaunchApplyConstant.ApplyStatus.TODO.getCode())
                .ge("a.apply_time", startDate)
                .lt("a.apply_time", DateUtil.offsetDay(startDate, 1))
                .groupBy("b.dept_id")
            );

            if (CollUtil.isNotEmpty(statList)) {
                List<ConsultationLaunchApplyStatSaveDTO> saveList = new ArrayList<>();
                
                String dataTime = DateUtil.formatDate(startDate);
                statList.forEach(i -> {
                    ConsultationLaunchApplyStatSaveDTO save = new ConsultationLaunchApplyStatSaveDTO();
                    save.setDataTime(dataTime);
                    save.setDeptId(i.getDeptId());
                    save.setStartNum(i.getStartNum());
                    save.setApplyNum(i.getApplyNum());
                    save.setNotApplyNum(i.getNotApplyNum());
                    save.setExamineNum(i.getExamineNum());
                    save.setFinishNum(i.getFinishNum());
                    save.setChangeNum(i.getChangeNum());
                    save.setChangeNowNum(i.getChangeNowNum());
                    save.setOutChangeNum(i.getOutChangeNum());
                    save.setTherapyChangeNum(i.getTherapyChangeNum());
                    save.setRealChangeNum(i.getRealChangeNum());
                    
                    saveList.add(save);
                });
                
                if (CollUtil.isNotEmpty(saveList)) {
                    consultationLaunchApplyStatBizService.saveBatch(saveList);
                }
            }
            
            startDate = DateUtil.offsetDay(startDate, 1);
        }
    }

    @Override
    public void consultationChangeStatTask(Date startDate, Date endDate) {
        DateTime now = DateUtil.parseDate(DateUtil.date().toDateStr());
        if (null == startDate) {
            startDate = now;
        }
        if (null == endDate || endDate.after(now)) {
            endDate = now;
        }
        
        while (!startDate.after(endDate)) {

            List<ConsultationLaunchApplyChangeStatVO> statList = consultationMapper.consultationChangeStatistic(new QueryWrapper<ConsultationLaunchApplyInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .ne("a.status", ConsultationLaunchApplyConstant.ApplyStatus.TODO.getCode())
                .ge("a.apply_time", startDate)
                .lt("a.apply_time", DateUtil.offsetDay(startDate, 1))
                .groupBy("b.mdt_dept_code", "a.disease_id")
            );

            if (CollUtil.isNotEmpty(statList)) {
                List<ConsultationLaunchApplyChangeStatSaveDTO> saveList = new ArrayList<>();
                
                String dataTime = DateUtil.formatDate(startDate);
                statList.forEach(i -> {
                    ConsultationLaunchApplyChangeStatSaveDTO save = new ConsultationLaunchApplyChangeStatSaveDTO();
                    save.setDataTime(dataTime);
                    save.setDeptId(i.getDeptId());
                    save.setDiseaseId(i.getDiseaseId());
                    save.setFinishNum(i.getFinishNum());
                    save.setChangeNum(i.getChangeNum());
                    save.setChangeNowNum(i.getChangeNowNum());
                    save.setOutChangeNum(i.getOutChangeNum());
                    save.setTherapyChangeNum(i.getTherapyChangeNum());
                    save.setRealChangeNum(i.getRealChangeNum());
                    
                    saveList.add(save);
                });
                
                if (CollUtil.isNotEmpty(saveList)) {
                    consultationLaunchApplyChangeStatBizService.saveBatch(saveList);
                }
            }
            
            startDate = DateUtil.offsetDay(startDate, 1);
        }
    }
}
