package com.xxh.cloud.healthy.mdt.third.utils;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.mdt.third.bean.MdtApiResp;
import com.xxh.cloud.healthy.mdt.third.bean.MdtSyncDataResp;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApply;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApplyExtras;
import com.xxh.cloud.healthy.mdt.third.constant.MdtThirdUrls;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MdtApplyHttpUtil {

    public static MdtSyncDataResp<SlifeMdtApply> getData(String start, String end){
        MdtThirdUrls urls=new MdtThirdUrls();
        MdtApiResp result=null;
        try {
            result=MdtApplyHttpUtil.getHttpApi(urls.get_MDT_Apply_Url(),start,end);
        }catch (Exception e){
            e.printStackTrace();
        }

        MdtSyncDataResp<SlifeMdtApply> data=new MdtSyncDataResp<SlifeMdtApply>();
        if(result.getCode()==200){
            data.setStatus(YN.YES.getCode());
            data.setType(result.getType());
            data.setMsg(result.getMessage());
            if(StrUtil.isNotEmpty(result.getResult())){
                List<SlifeMdtApply> applyList = JSON.parseArray(result.getResult(), SlifeMdtApply.class);

                // if (StrUtil.isNotBlank(result.getExtras())) {
                //     List<SlifeMdtApplyExtras> extraList = JSON.parseArray(result.getExtras(), SlifeMdtApplyExtras.class);
                //     applyList.forEach(i -> {
                //         extraList.forEach(j -> {
                //             if (j.getMdtTemplateName().equals(i.getMdtTemplateName()) && "director".equals(j.getDocDuty())) {
                //                 i.setSummaryUserId(j.getDocCode());
                //             }
                //         });
                //     });
                // }

                data.setData(applyList);
            }
        }else {
            data.setStatus(YN.NO.getCode());
            data.setType(result.getType());
            data.setMsg(result.getMessage());
        }
        return data;
    }



    public static MdtApiResp getHttpApi(String url, String start, String end){
        Map<String,String> params=new HashMap<>();
        params.put("starttime",start);
        params.put("endtime",end);

        String result=null;
        try {
            result= HttpUtil.post(url, JSON.toJSONString(params),1000*120);
        }catch (Exception e){
            e.printStackTrace();
            return new MdtApiResp(-1,"API",e.getMessage());
        }

        if(StrUtil.isEmpty(result)){
            return new MdtApiResp(-1,"API","调用接口错误!");
        }

        JSONObject jsonObject = JSON.parseObject(result);
        int code = jsonObject.getIntValue("code");
        String type = jsonObject.getString("type");
        String message = jsonObject.getString("message");
        String content= jsonObject.getString("result");
        // String extras= jsonObject.getString("extras");
        // return new MdtApiResp(code,type,message,content,extras);
        return new MdtApiResp(code,type,message,content);
    }

}
