package com.xxh.cloud.healthy.mdt.third.utils;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.healthy.mdt.third.bean.MdtApiResp;
import com.xxh.cloud.healthy.mdt.third.bean.MdtSyncDataResp;
import com.xxh.cloud.healthy.mdt.third.bean.SlifeMdtApplyDetail;
import com.xxh.cloud.healthy.mdt.third.constant.MdtThirdUrls;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MdtDetailHttpUtil {

    public static MdtSyncDataResp<SlifeMdtApplyDetail> getData(String start, String end ,List<String> applyIds){
        MdtThirdUrls urls=new MdtThirdUrls();
        MdtApiResp result=null;
        try {
            result=MdtDetailHttpUtil.getHttpApi(urls.get_MDT_Detail_Url(),start,end,applyIds);
        }catch (Exception e){
            e.printStackTrace();
        }


        MdtSyncDataResp<SlifeMdtApplyDetail> data=new MdtSyncDataResp<SlifeMdtApplyDetail>();
        if(result.getCode()==200){
            data.setStatus(YN.YES.getCode());
            data.setType(result.getType());
            data.setMsg(result.getMessage());
            if(StrUtil.isNotEmpty(result.getResult())){
                data.setData(JSON.parseArray(result.getResult(), SlifeMdtApplyDetail.class));
            }
        }else {
            data.setStatus(YN.NO.getCode());
            data.setType(result.getType());
            data.setMsg(result.getMessage());
        }
        return data;
    }


    private static MdtApiResp getHttpApi(String url, String start, String end ,List<String> applyIds){
        Map<String,Object> params=new HashMap<>();
        if(StrUtil.isNotEmpty(start)){
            params.put("starttime",start);
        }
        if(StrUtil.isNotEmpty(end)){
            params.put("endtime",end);
        }
        if(CollUtil.isNotEmpty(applyIds)){
            params.put("ids",applyIds);
        }

        String result=null;
        try {
            result= HttpUtil.post(url, JSON.toJSONString(params),1000*120);
        }catch (Exception e){
            e.printStackTrace();
            return new MdtApiResp(-1,"API",e.getMessage());
        }

        if(StrUtil.isEmpty(result)){
            return new MdtApiResp(-1,"API","调用接口错误!");
        }

        JSONObject jsonObject = JSON.parseObject(result);
        int code = jsonObject.getIntValue("code");
        String type = jsonObject.getString("type");
        String message = jsonObject.getString("message");
        String content= jsonObject.getString("result");
        return new MdtApiResp(code,type,message,content);
    }


//    public static void main(String[] args) {
//        List<String> applyIds=new ArrayList<>();
//        applyIds.add("1");
//        applyIds.add("2");
//        applyIds.add("3");
//
//        Map<String,Object> params=new HashMap<>();
//        params.put("ids",applyIds);
//
//        System.out.println(JSON.toJSONString(params));
//    }




}
