package com.xxh.cloud.healthy.mdt.third.utils;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.healthy.mdt.third.bean.WecomSendTextcardReq;
import com.xxh.cloud.healthy.mdt.third.bean.WecomSendTextcardResp;
import com.xxh.cloud.healthy.mdt.third.constant.MdtThirdUrls;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class MdtSendTextCardHttpUtil {

    // 调用OA推送消息
    public static WecomSendTextcardResp send(WecomSendTextcardReq req){
        MdtThirdUrls urls=new MdtThirdUrls();
        String bodyJson = JSONObject.toJSONString(req);
        log.info(StrUtil.format("推送OA地址:{}", urls.get_WECOM_SEND_TEXTCARD()));
        log.info(StrUtil.format("推送OA参数:{}", bodyJson));
        String result = HttpRequest.post(urls.get_WECOM_SEND_TEXTCARD())
                .body(bodyJson)
                .execute().body();
        log.info(StrUtil.format("推送OA返回:{}", result));
        try {
            return JSONObject.parseObject(result, WecomSendTextcardResp.class);
        } catch (Exception e) {
            e.printStackTrace();
            return new WecomSendTextcardResp();
        }
    }

}
