package com.xxh.cloud.healthy.push.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 微信推送日志表
 * </p>
 *
 * @author anros
 * @since 2023-09-21
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("hp_push_weixin_log")
public class PushWeixinLog extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 用户分类
     */
    @ApiModelProperty(value = "用户分类")
    private String userType;

    /**
     * 用户ID
     */
    @ApiModelProperty(value = "用户ID")
    private String userId;

    /**
     * 微信用户ID
     */
    @ApiModelProperty(value = "微信用户ID")
    private String openId;

    /**
     * 微信主体编号
     */
    @ApiModelProperty(value = "微信主体编号")
    private String wxAppId;

    /**
     * 关联业务一级分类
     */
    @ApiModelProperty(value = "关联业务一级分类")
    private String bizOneType;

    /**
     * 关联业务二级分类
     */
    @ApiModelProperty(value = "关联业务二级分类")
    private String bizTwoType;

    /**
     * 关联业务ID
     */
    @ApiModelProperty(value = "关联业务ID")
    private String bizId;

    /**
     * 模板ID
     */
    @ApiModelProperty(value = "模板ID")
    private String tempId;

    /**
     * 提醒ID
     */
    @ApiModelProperty(value = "提醒ID")
    private String remindId;

    /**
     * 推送状态
     */
    @ApiModelProperty(value = "推送状态")
    private String sendStatus;

    /**
     * 推送结果
     */
    @ApiModelProperty(value = "推送结果")
    private String sendResult;

    /**
     * 第一推送时间
     */
    @ApiModelProperty(value = "第一推送时间")
    private Date firstSendDt;

    /**
     * 最后推送时间
     */
    @ApiModelProperty(value = "最后推送时间")
    private Date lastSendDt;

    /**
     * 推送次数
     */
    @ApiModelProperty(value = "推送次数")
    private Integer sendNum;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

    /**
     * 推送错误码
     */
    @ApiModelProperty(value = "推送错误码")
    private String errorCode;

    /**
     * 推送错误信息
     */
    @ApiModelProperty(value = "推送错误信息")
    private String errorMsg;

}
