package com.xxh.cloud.healthy.push.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 微信二维码信息表
 * </p>
 *
 * @author wing
 * @since 2023-12-08
 */
@Data
@TableName("hd_wechat_qrcode_data_info")
public class WechatQRCodeDataInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 场景类型
     */
    @ApiModelProperty(value = "场景类型[WeixinQRCodeConstant.SceneType]")
    private String sceneType;

    @ApiModelProperty(value = "用户id")
    private String userId;

    /**
     * 拥有者类型
     * WeixinQRCodeConstant.OwnerType
     */
    @ApiModelProperty(value = "拥有者类型[WeixinQRCodeConstant.OwnerType]")
    private String ownerType;

    /**
     * 拥有者code
     */
    @ApiModelProperty(value = "拥有者code")
    private String ownerCode;

    /**
     * 拥有者名字
     */
    @ApiModelProperty(value = "拥有者名字")
    private String ownerName;

    /**
     * 场景值
     */
    @ApiModelProperty(value = "微信场景值")
    private String scene;

    /**
     * 二维码类型
     */
    @ApiModelProperty(value = "二维码类型")
    private String qrType;

    /**
     * 过期时间(秒)
     */
    @ApiModelProperty(value = "过期时间(秒)")
    private Integer expireSeconds;

    /**
     * 过期时间
     */
    @ApiModelProperty(value = "过期时间")
    private Date expireDate;

    /**
     * 换取微信二维码ticket
     */
    @ApiModelProperty(value = "换取微信二维码ticket")
    private String ticket;

    /**
     * 自定义二维码的url
     */
    @ApiModelProperty(value = "自定义二维码的url")
    private String url;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createDate;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

}
