package com.xxh.cloud.healthy.push.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 海鹚数据
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("hl_weixin_user_patient_bind_info")
public class WeixinUserPatientBindInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    @ApiModelProperty(value = "微信用户ID")
    private String wxUserId;

    @ApiModelProperty(value = "微信openid")
    private String wxOpenId;

    @ApiModelProperty(value = "微信unionid")
    private String wxUnionId;

    @ApiModelProperty(value = "生日")
    private String birthday;

    @ApiModelProperty(value = "就诊人Id")
    private String patientId;

    @ApiModelProperty(value = "就诊人姓名")
    private String patientName;

    @ApiModelProperty(value = "联系电话")
    private String patientMobile;

    @ApiModelProperty(value = "就诊人证件号")
    private String idNo;

    @ApiModelProperty(value = "就诊人证件类型 1:二代身份证 2:港澳居民身份证 3:台湾居民身份证 4:护照")
    private String idType;

    // @ApiModelProperty(value = "就诊人证件类型名称")
    // private String idTypeName;

    @ApiModelProperty(value = "就诊人门诊id")
    private String patHisNo;

    @ApiModelProperty(value = "医院卡号id")
    private String patCardNo;

    @ApiModelProperty(value = "医院卡号类型 21:院内就诊卡 22:市民卡 23:医保卡")
    private String patCardType;

    @ApiModelProperty(value = "医院卡号类型名称")
    private String patCardTypeName;

    @ApiModelProperty(value = "默认就诊人 0-否 1-是")
    private String isDefault;

    @ApiModelProperty(value = "默认就诊人 F:女，M:男")
    private String patientSex;

    @ApiModelProperty(value = "与本人关系")
    private String relationName;

    @ApiModelProperty(value = "与本人关系 1:本人 2:配偶 3:父母 4:子女 5:他人")
    private String relationType;

    @ApiModelProperty(value = "患者类型 0:成人 1:儿童 2:妇女 3:老人")
    private String patientType;

    @ApiModelProperty(value = "患者类型名称")
    private String patientTypeName;

    @ApiModelProperty(value = "电子健康卡标识 0:无需绑定 1:需要升级 2:已有健康卡")
    private String healthCardFlag;

    @ApiModelProperty(value = "扩展字段保存的值 json格式")
    private String extFields;
}
