package com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class SendWeixinDTO {

    @ApiModelProperty(value = "微信配置id")
    private String paramId;

    @ApiModelProperty(value = "模板ID")
    private String tempId;

    @ApiModelProperty(value = "推送配置[具体推送方式的配置]")
    @NotEmpty(message = "推送消息内容[msgMap]不能为空")
    private ServPushConfigModel pushConfig;

    @ApiModelProperty(value = "openid", required = true)
    @NotEmpty(message = "openid不能为空")
    private String openid;

    @ApiModelProperty(value = "推送消息日志", required = true)
    @NotNull(message = "推送消息日志[logInfo]不能为空")
    private PushWeixinLogAddDTO logInfo;

    @ApiModelProperty(value = "推送的用户类型")
    private String userType;

    @ApiModelProperty(value = "媒体Id")
    private String mediaId;

    @ApiModelProperty(value = "媒体类型")
    private String mediaType;

    @ApiModelProperty(value = "提醒Id")
    private String remindId;

    @ApiModelProperty(value = "加密数据")
    private String secureData;

}
