package com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class WechatQRCodeCreateDTO {

    /**
     * 场景类型
     */
    @ApiModelProperty(value = "场景类型[WeixinQRCodeConstant.SceneType]")
    private String sceneType;

    @ApiModelProperty(value = "用户id")
    private String userId;

    @ApiModelProperty(value = "拥有者类型[WeixinQRCodeConstant.OwnerType]", required = true)
    @NotEmpty(message = "拥有者类型[ownerType]不能为空")
    private String ownerType;

    @ApiModelProperty(value = "拥有者code", required = true)
    @NotEmpty(message = "拥有者code[ownerCode]不能为空")
    private String ownerCode;

    @ApiModelProperty(value = "拥有者名字")
    private String ownerName;

    @ApiModelProperty(value = "二维码类型[WeixinQRCodeConstant.QrcodeType]", required = true)
    @NotEmpty(message = "二维码类型不能为空")
    private String qrType;

    @ApiModelProperty(value = "过期时间(秒), 最长30天(2592000秒)")
    private Integer expireSeconds;

}
