package com.xxh.cloud.healthy.push.framework.modules.biz.constant;

public enum WechatErrorCodeEnum {
    
    FM1("-1", "系统繁忙，此时请开发者稍候再试"),
    SUCCESS("0", "请求成功"),
    F40001("40001", "获取 access_token 时 AppSecret 错误，或者 access_token 无效。请开发者认真比对 AppSecret 的正确性，或查看是否正在为恰当的公众号调用接口"),
    F40002("40003", "不合法的 OpenID ，请开发者确认 OpenID （该用户）是否已关注公众号，或是否是其他公众号的 OpenID"),
    F40003("40002", "不合法的凭证类型"),
    F40004("40004", "不合法的媒体文件类型"),
    F40005("40005", "不合法的文件类型"),
    F40006("40006", "不合法的文件大小"),
    F40007("40007", "不合法的媒体文件 id"),
    F40008("40008", "不合法的消息类型"),
    F40009("40009", "不合法的图片文件大小"),
    F40010("40010", "不合法的语音文件大小"),
    F40011("40011", "不合法的视频文件大小"),
    F40012("40012", "不合法的缩略图文件大小"),
    F40013("40013", "不合法的 AppID ，请开发者检查 AppID 的正确性，避免异常字符，注意大小写"),
    F40014("40014", "不合法的 access_token ，请开发者认真比对 access_token 的有效性（如是否过期），或查看是否正在为恰当的公众号调用接口"),
    F40015("40015", "不合法的菜单类型"),
    F40016("40016", "不合法的按钮个数"),
    F40017("40017", "不合法的按钮类型"),
    F40018("40018", "不合法的按钮名字长度"),
    F40019("40019", "不合法的按钮 KEY 长度"),
    F40020("40020", "不合法的按钮 URL 长度"),
    F40021("40021", "不合法的菜单版本号"),
    F40022("40022", "不合法的子菜单级数"),
    F40023("40023", "不合法的子菜单按钮个数"),
    F40024("40024", "不合法的子菜单按钮类型"),
    F40025("40025", "不合法的子菜单按钮名字长度"),
    F40026("40026", "不合法的子菜单按钮 KEY 长度"),
    F40027("40027", "不合法的子菜单按钮 URL 长度"),
    F40028("40028", "不合法的自定义菜单使用用户"),
    F40029("40029", "无效的 oauth_code"),
    F40030("40030", "不合法的 refresh_token"),
    F40031("40031", "不合法的 openid 列表"),
    F40032("40032", "不合法的 openid 列表长度"),
    F40033("40033", "不合法的请求字符，不能包含 \\uxxxx 格式的字符"),
    F40035("40035", "不合法的参数"),
    F40038("40038", "不合法的请求格式"),
    F40039("40039", "不合法的 URL 长度"),
    F40048("40048", "无效的url"),
    F40050("40050", "不合法的分组 id"),
    F40051("40051", "分组名字不合法"),
    F40060("40060", "删除单篇图文时，指定的 article_idx 不合法"),
    F40117("40117", "分组名字不合法"),
    F40118("40118", "media_id 大小不合法"),
    F40119("40119", "button 类型错误"),
    F40120("40120", "子 button 类型错误"),
    F40121("40121", "不合法的 media_id 类型"),
    F40125("40125", "无效的appsecret"),
    F40132("40132", "微信号不合法"),
    F40137("40137", "不支持的图片格式"),
    F40155("40155", "请勿添加其他公众号的主页链接"),
    F40163("40163", "oauth_code已使用"),
    F40227("40227", "标题为空"),
    F41001("41001", "缺少 access_token 参数"),
    F41002("41002", "缺少 appid 参数"),
    F41003("41003", "缺少 refresh_token 参数"),
    F41004("41004", "缺少 secret 参数"),
    F41005("41005", "缺少多媒体文件数据"),
    F41006("41006", "缺少 media_id 参数"),
    F41007("41007", "缺少子菜单数据"),
    F41008("41008", "缺少 oauth code"),
    F41009("41009", "缺少 openid"),
    F42001("42001", "access_token 超时，请检查 access_token 的有效期，请参考基础支持 - 获取 access_token 中，对 access_token 的详细机制说明"),
    F42002("42002", "refresh_token 超时"),
    F42003("42003", "oauth_code 超时"),
    F42007("42007", "用户修改微信密码， accesstoken 和 refreshtoken 失效，需要重新授权"),
    F42010("42010", "相同 media_id 群发过快，请重试"),
    F43001("43001", "需要 GET 请求"),
    F43002("43002", "需要 POST 请求"),
    F43003("43003", "需要 HTTPS 请求"),
    F43004("43004", "需要接收者关注"),
    F43005("43005", "需要好友关系"),
    F43019("43019", "需要将接收者从黑名单中移除"),
    F43116("43116", "该模板因滥用被滥用过多，已被限制下发"),
    F44001("44001", "多媒体文件为空"),
    F44002("44002", "POST 的数据包为空"),
    F44003("44003", "图文消息内容为空"),
    F44004("44004", "文本消息内容为空"),
    F44008("44008", "音频内容审核失败"),
    F44009("44009", "图文中的音频内容审核失败"),
    F45001("45001", "多媒体文件大小超过限制"),
    F45002("45002", "消息内容超过限制"),
    F45003("45003", "标题字段超过限制"),
    F45004("45004", "描述字段超过限制"),
    F45005("45005", "链接字段超过限制"),
    F45006("45006", "图片链接字段超过限制"),
    F45007("45007", "语音播放时间超过限制"),
    F45008("45008", "图文消息超过限制"),
    F45009("45009", "接口调用超过限制"),
    F45010("45010", "创建菜单个数超过限制"),
    F45011("45011", "API 调用太频繁，请稍候再试"),
    F45015("45015", "回复时间超过限制"),
    F45016("45016", "系统分组，不允许修改"),
    F45017("45017", "分组名字过长"),
    F45018("45018", "分组数量超过上限"),
    F45047("45047", "客服接口下行条数超过上限"),
    F45064("45064", "创建菜单包含未关联的小程序"),
    F45065("45065", "相同 clientmsgid 已存在群发记录，返回数据中带有已存在的群发任务的 msgid"),
    F45066("45066", "相同 clientmsgid 重试速度过快，请间隔1分钟重试"),
    F45067("45067", "clientmsgid 长度超过限制"),
    F45110("45110", "作者字数超出限制"),
    F46001("46001", "不存在媒体数据"),
    F46002("46002", "不存在的菜单版本"),
    F46003("46003", "不存在的菜单数据"),
    F46004("46004", "不存在的用户"),
    F47001("47001", "解析 JSON/XML 内容错误"),
    F47003("47003", "参数值不符合限制要求，详情可参考参数值内容限制说明"),
    F48001("48001", "api 功能未授权，请确认公众号已获得该接口，可以在公众平台官网 - 开发者中心页中查看接口权限"),
    F48002("48002", "粉丝拒收消息（粉丝在公众号选项中，关闭了 “ 接收消息 ” ）"),
    F48004("48004", "api 接口被封禁，请登录 mp.weixin.qq.com 查看详情"),
    F48005("48005", "api 禁止删除被自动回复和自定义菜单引用的素材"),
    F48006("48006", "api 禁止清零调用次数，因为清零次数达到上限"),
    F48008("48008", "没有该类型消息的发送权限"),
    F48021("48021", "自动保存的草稿无法预览/发送，请先手动保存草稿"),
    F50001("50001", "用户未授权该 api"),
    F50002("50002", "用户受限，可能是违规后接口被封禁"),
    F50005("50005", "用户未关注公众号"),
    F53500("53500", "发布功能被封禁"),
    F53501("53501", "频繁请求发布"),
    F53502("53502", "Publish ID 无效"),
    F53600("53600", "Article ID 无效"),
    F61451("61451", "参数错误 (invalid parameter)"),
    F61452("61452", "无效客服账号 (invalid kf_account)"),
    F61453("61453", "客服账号已存在 (kf_account exsited)"),
    F61454("61454", "客服账号名长度超过限制 ( 仅允许 10 个英文字符，不包括 @ 及 @ 后的公众号的微信号 )(invalid   kf_acount length)"),
    F61455("61455", "客服账号名包含非法字符 ( 仅允许英文 + 数字 )(illegal character in     kf_account)"),
    F61456("61456", "客服账号个数超过限制 (10 个客服账号 )(kf_account count exceeded)"),
    F61457("61457", "无效头像文件类型 (invalid   file type)"),
    F61450("61450", "系统错误 (system error)"),
    F61500("61500", "日期格式错误"),
    F63001("63001", "部分参数为空"),
    F63002("63002", "无效的签名"),
    F65301("65301", "不存在此 menuid 对应的个性化菜单"),
    F65302("65302", "没有相应的用户"),
    F65303("65303", "没有默认菜单，不能创建个性化菜单"),
    F65304("65304", "MatchRule 信息为空"),
    F65305("65305", "个性化菜单数量受限"),
    F65306("65306", "不支持个性化菜单的账号"),
    F65307("65307", "个性化菜单信息为空"),
    F65308("65308", "包含没有响应类型的 button"),
    F65309("65309", "个性化菜单开关处于关闭状态"),
    F65310("65310", "填写了省份或城市信息，国家信息不能为空"),
    F65311("65311", "填写了城市信息，省份信息不能为空"),
    F65312("65312", "不合法的国家信息"),
    F65313("65313", "不合法的省份信息"),
    F65314("65314", "不合法的城市信息"),
    F65316("65316", "该公众号的菜单设置了过多的域名外跳（最多跳转到 3 个域名的链接）"),
    F65317("65317", "不合法的 URL"),
    F87009("87009", "无效的签名"),
    F9001001("9001001", "POST 数据参数不合法"),
    F9001002("9001002", "远端服务不可用"),
    F9001003("9001003", "Ticket 不合法"),
    F9001004("9001004", "获取摇周边用户信息失败"),
    F9001005("9001005", "获取商户信息失败"),
    F9001006("9001006", "获取 OpenID 失败"),
    F9001007("9001007", "上传文件缺失"),
    F9001008("9001008", "上传素材的文件类型不合法"),
    F9001009("9001009", "上传素材的文件尺寸不合法"),
    F9001010("9001010", "上传失败"),
    F9001020("9001020", "账号不合法"),
    F9001021("9001021", "已有设备激活率低于 50% ，不能新增设备"),
    F9001022("9001022", "设备申请数不合法，必须为大于 0 的数字"),
    F9001023("9001023", "已存在审核中的设备 ID 申请"),
    F9001024("9001024", "一次查询设备 ID 数量不能超过 50"),
    F9001025("9001025", "设备 ID 不合法"),
    F9001026("9001026", "页面 ID 不合法"),
    F9001027("9001027", "页面参数不合法"),
    F9001028("9001028", "一次删除页面 ID 数量不能超过 10"),
    F9001029("9001029", "页面已应用在设备中，请先解除应用关系再删除"),
    F9001030("9001030", "一次查询页面 ID 数量不能超过 50"),
    F9001031("9001031", "时间区间不合法"),
    F9001032("9001032", "保存设备与页面的绑定关系参数错误"),
    F9001033("9001033", "门店 ID 不合法"),
    F9001034("9001034", "设备备注信息过长"),
    F9001035("9001035", "设备申请参数不合法"),
    F9001036("9001036", "查询起始值 begin 不合法"),

    ;

    private String code;
        private String msg;
        private WechatErrorCodeEnum(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
}
