package com.xxh.cloud.healthy.push.framework.modules.biz.constant;

public class WeixinQRCodeConstant {
    
    // 二维码场景类型
    public enum SceneType {
        Default("default", "默认场景信息"),

        Pre("pre", "诊前场景码"),
        During("during","诊中场景码"),
        InHospital("inHospital","住院场景码"),
        Doctor("doctor", "医生名片场景码"),
        Dept("dept", "科室场景码"),

        Guide("guide", "指引单场景"),
        
        Diagnosis_Treatment_Team("diagnosis_treatment_team", "诊疗组"),
        Nursing_Station("nursing_station", "护理站"),

        Nurse("nurse", "护士"),

        Assistant("assistant", "运营助理"),
        
        Exam_Center("exam_center", "体检中心"),
        
        ;

        private String code;
        private String msg;
        private SceneType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }
    
    // 二维码拥有者类型
    public enum OwnerType {
        Nurse("nurse", "护士"),
        Doctor("doctor","医生"),
        Dept("dept","科室"),
        Machine("machine","机器"),
        Aide("aide", "护工"),
        Assistant("assistant", "运营助理"),

        Guide("guide", "指引单"),
        
        Exam_Center("exam_center", "体检中心"),
        
        ;

        private String code;
        private String msg;
        private OwnerType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

    // 二维码类型
    // 永久二维码最多10万个
    // 临时二维码最长时间为30天（即2592000秒）
    public enum QrcodeType {
        QR_Temporary("qr_temporary", "QR_SCENE", "临时的整型参数值二维码"),
        QR_Permanent("qr_permanent", "QR_LIMIT_SCENE", "永久的整型参数值二维码"),
        QR_Str_Temporary("qr_str_temporary", "QR_STR_SCENE", "临时的字符串参数值二维码"),
        QR_Str_Permanent("qr_str_permanent", "QR_LIMIT_STR_SCENE", "永久的字符串参数值二维码"),

        ;

        private String code;
        private String wxcode;
        private String msg;
        private QrcodeType(String code, String wxcode, String msg) {
            this.code = code;
            this.wxcode = wxcode;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getWxcode() {
            return wxcode;
        }
        public void setWxcode(String wxcode) {
            this.wxcode = wxcode;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

}
