package com.xxh.cloud.healthy.push.framework.modules.biz.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.xxh.cloud.healthy.push.framework.modules.base.entity.HisPromotionInfo;

public interface PromotionBizMapper {
    
    /**
     * 删除所有同步的互联网推广码信息
     */
    @Delete(" TRUNCATE TABLE hd_his_promotion_info ")
    void removeAllPromotionInfo();
    
    // 保存同步
    @Insert({
        "<script>",
        "INSERT INTO hd_his_promotion_info (id, extend_type, extend_name, extend_code, remark, enable) VALUES ",
        "<foreach collection='dataList' item='item' index='index' separator=','>",
        "(#{item.id}, #{item.extendType}, #{item.extendName}, #{item.extendCode}, #{item.remark}, #{item.enable})",
        "</foreach>",
        "</script>"
    })
    Integer savePromotionInfo(@Param("dataList") List<HisPromotionInfo> dataList);

    /**
     * 查询没有微信二维码的互联网医院推广码信息
     */
    @Select(" SELECT a.* FROM hd_his_promotion_info a " + 
        " LEFT JOIN ( " + 
        "   SELECT owner_code FROM hd_wechat_qrcode_data_info GROUP BY owner_code " + 
        " ) b ON a.extend_code = b.owner_code " + 
        " WHERE a.enable = '1' AND b.owner_code IS NULL "
    )
    List<HisPromotionInfo> listPromotionInfo();
    
}
