package com.xxh.cloud.healthy.push.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.customer.client.api.bean.bos.CustomerUserBO;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataGetDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataQueryDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataUpdateDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeUserQueryDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatScanQRCodeDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.vos.WechatQRCodeDataVO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.vos.WechatScanQRCodeDayVO;

public interface WechatQRCodeDataBizService {
    
    // 医生患者关注数据保存
    void save(WechatQRCodeDataAddDTO params);

    PageData<WechatQRCodeDataVO> page(WechatQRCodeDataQueryDTO params);

    List<WechatQRCodeDataVO> list(WechatQRCodeDataQueryDTO params);

    WechatQRCodeDataVO detail(WechatQRCodeDataGetDTO params);

    WechatQRCodeDataVO simpleDetail(WechatQRCodeDataGetDTO params);

    WechatQRCodeDataVO update(WechatQRCodeDataUpdateDTO params);

    void del(WechatQRCodeDataGetDTO params);

    // 统计用户数量
    // 统计扫描二维码注册用户列表
    PageData<CustomerUserBO> registerUserPage(WechatQRCodeUserQueryDTO params);
    // 统计扫描二维码绑定家属用户列表
    PageData<CustomerUserBO> bindFamilyUserPage(WechatQRCodeUserQueryDTO params);

    // 按日统计每个二维码扫码数量
    List<WechatScanQRCodeDayVO> listByQrcodeIdAndDay(WechatScanQRCodeDTO params);

}
