package com.xxh.cloud.healthy.push.framework.modules.biz.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.PatientSubscribeDataLog;
import com.xxh.cloud.healthy.push.framework.modules.base.service.PatientSubscribeDataLogService;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PatientSubscribeDataLogAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.helper.PushWechatHelper;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PatientSubscribeDataBizService;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class PatientSubscribeDataBizServiceImpl implements PatientSubscribeDataBizService {
    
    @Autowired
    private PatientSubscribeDataLogService patientSubscribeDataLogService;
    
    @Override
    public void saveLog(PatientSubscribeDataLogAddDTO params) {
        log.info("保存关注日志>>>>>> {}", JSON.toJSONString(params));
        ValidatorUtils.validateEntity(params);

        PatientSubscribeDataLog entity = new PatientSubscribeDataLog();

        entity.setId(PushWechatHelper.getPatientSubscribeDataLogId());
        entity.setQrcodeId(params.getQrcodeId());
        entity.setEvent(params.getEvent());
        entity.setOpenId(params.getOpenId());
        entity.setCreateDate(params.getCreateDate());

        patientSubscribeDataLogService.save(entity);
    }
    
}
