package com.xxh.cloud.healthy.push.framework.modules.biz.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.PushWeixinLog;
import com.xxh.cloud.healthy.push.framework.modules.base.service.PushWeixinLogService;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PushWeixinLogQueryDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.vos.PushWeixinLogVO;
import com.xxh.cloud.healthy.push.framework.modules.biz.helper.PushWechatHelper;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PushWeixinQueryBizService;

import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class PushWeixinQueryBizServiceImpl implements PushWeixinQueryBizService {

    @Autowired
    private PushWeixinLogService pushWeixinLogService;

    @Override
    public PageData<PushWeixinLogVO> query(PushWeixinLogQueryDTO params) {
        log.info("PushWeixinQueryBizServiceImpl:query:params:>>>>>> {}", JSON.toJSONString(params));
        IPage<PushWeixinLog> entityPage = pushWeixinLogService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PushWeixinLog>()
                .eq(StrUtil.isNotBlank(params.getUserType()), "user_type", params.getUserType())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .eq(StrUtil.isNotBlank(params.getOpenId()), "open_id", params.getOpenId())
                .eq(StrUtil.isNotBlank(params.getWxAppId()), "wx_app_id", params.getWxAppId())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .eq(StrUtil.isNotBlank(params.getBizTwoType()), "biz_two_type", params.getBizTwoType())
                .eq(StrUtil.isNotBlank(params.getBizId()), "biz_id", params.getBizId())
                .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
                .eq("rows_status", YN.YES.getCode())
                .orderByDesc("first_send_dt")
        );
        
        PageData<PushWeixinLogVO> data = new PageConverter<PushWeixinLog, PushWeixinLogVO>() {
            @Override
            public PushWeixinLogVO converter(PushWeixinLog entity) {
                return PushWechatHelper.getPushWeixinLogVO(entity);
            }
        }.getPageData(entityPage);
        return data;
    }
}
