package com.xxh.cloud.healthy.push.framework.modules.biz.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.company.cloud.sdk.weixin.common.utils.XmlUtils;
import com.company.cloud.sdk.weixin.mp.enums.WxMsgEventType;
import com.company.cloud.sdk.weixin.mp.enums.WxMsgType;
import com.company.cloud.sdk.weixin.mp.model.QRcodeWithParamsResp;
import com.company.cloud.sdk.weixin.mp.model.msgmanage.ReceiveEventFullModel;
import com.company.cloud.sdk.weixin.mp.model.msgmanage.ReplyMsgTextModel;
import com.xxh.cloud.basic.client.api.ParamsClientService;
import com.xxh.cloud.customer.client.api.bean.dto.CustomerUserLoginThirdClientDTO;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.BasePageDTO;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.WeixinUserPatientBindInfo;
import com.xxh.cloud.healthy.push.framework.modules.async.WeixinAsyncBizService;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.HisPromotionInfo;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.HisPromotionLog;
import com.xxh.cloud.healthy.push.framework.modules.base.entity.WeixinUserInfo;
import com.xxh.cloud.healthy.push.framework.modules.base.service.HisPromotionInfoService;
import com.xxh.cloud.healthy.push.framework.modules.base.service.HisPromotionLogService;
import com.xxh.cloud.healthy.push.framework.modules.base.service.WeixinUserInfoService;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PatientSubscribeDataLogAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeCreateDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WechatQRCodeDataGetDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.WeixinUserSyncDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.vos.WechatQRCodeDataVO;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.WeixinQRCodeConstant;
import com.xxh.cloud.healthy.push.framework.modules.biz.helper.PushWechatHelper;
import com.xxh.cloud.healthy.push.framework.modules.biz.mapper.WechatMapper;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PatientSubscribeDataBizService;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.WechatQRCodeDataBizService;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.WeixinBizService;
import com.xxh.cloud.third.framework.modules.thirdWX.dto.WxQrCodeDTO;
import com.xxh.cloud.third.framework.modules.thirdWX.service.ThirdWeixinQrCodeService;
import com.xxh.cloud.user.client.api.HisDataClientService;
import com.xxh.cloud.user.client.api.bean.bos.HisSchemeUrlBO;
import com.xxh.cloud.user.client.api.bean.dto.HisDeptQueryClientDTO;
import com.xxh.cloud.user.client.api.bean.dto.HisDoctorQueryClientDTO;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class WeixinBizServiceImpl implements WeixinBizService {

    @Autowired
    private ParamsClientService paramsClientService;
    @Autowired
    private PatientSubscribeDataBizService patientSubscribeDataBizService;
    @Autowired
    private WechatQRCodeDataBizService wechatQRCodeDataBizService;
    @Autowired
    private WechatMapper wechatMapper;
    @Autowired
    private WeixinUserInfoService wechatUserInfoService;
    @Autowired
    private ThirdWeixinQrCodeService thirdWeixinQrCodeService;
    @Autowired
    private WeixinAsyncBizService weixinAsyncBizService;
    @Autowired
    private HisDataClientService hisDataClientService;
    // @Autowired
    // private ThirdHisService thirdHisService;
    @Autowired
    private HisPromotionLogService hisPromotionLogService;
    @Autowired
    private HisPromotionInfoService hisPromotionInfoService;

    // @Transactional(rollbackFor = Exception.class)
    // @Override
    // public QRcodeWithParamsResp createQRCode(WechatQRCodeCreateDTO params) {
    //     ValidatorUtils.validateEntity(params);
        
    //     HealthyFrontendConfig healthyFrontend = paramsClientService.getParamConfig("HEALTHY_FRONTEND", new HealthyFrontendConfig());
    //     log.info("获取请求目标域名数据<<<<<< {}", JSON.toJSONString(healthyFrontend));

    //     Map<String, String> wxQrcodePath = paramsClientService.getParamConfig("WX_QRCODE_PATH", new HashMap<String, String>());
    //     log.info("获取请求目标接口地址<<<<<< {}", JSON.toJSONString(wxQrcodePath));
    //     String qrcodeUrl = wxQrcodePath.get("path");

    //     // 微信二维码信息id
    //     String qrCodeDataInfoId = PushWechatHelper.getQRCodeDataInfoId();

    //     String scene = params.getSceneType() + "_" + qrCodeDataInfoId; // 场景类型 + 平台二维码id，加上类型用于直接区分场景，主要是海鹚区分
    //     Map<String, String> sceneStr = new HashMap<>();
    //     sceneStr.put("scene_str", scene); // 可以通过此值中的二维码id查询到二维码信息

    //     Map<String, Object> sceneMap = new HashMap<>();
    //     sceneMap.put("scene", sceneStr);
        
    //     Map<String, Object> qrcodeMap = new HashMap<>();
    //     qrcodeMap.put("action_info", sceneMap);

    //     String wxQrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Permanent.getWxcode(); // 微信二维码参数；默认永久二维码
    //     String qrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Permanent.getCode(); // 本地二维码类型数据；默认永久二维码
    //     if (WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getCode().equals(params.getQrType()) || WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getWxcode().equals(params.getQrType())) {
    //         if (null == params.getExpireSeconds() || params.getExpireSeconds() < 0 || params.getExpireSeconds() > 2592000) { // 过期时间最大2592000秒
    //             throw new BusinessException("临时二维码过期时间参数异常");
    //         }
    //         qrcodeMap.put("expire_seconds", params.getExpireSeconds());

    //         wxQrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getWxcode(); // 临时二维码
    //         qrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getCode();
    //     }
    //     qrcodeMap.put("action_name", wxQrType);
    //     params.setQrType(qrType);

    //     String qrcodeParams = JSON.toJSONString(qrcodeMap);

        

    //     log.info("获取二维码参数>>>>>> {}", qrcodeParams);
    //     String result = HttpRequest.post(healthyFrontend.getHost() + qrcodeUrl).body(qrcodeParams).execute().body();
    //     log.info("获取二维码数据<<<<<< {}", result);

    //     QRcodeWithParamsResp resp = JSONObject.parseObject(result, QRcodeWithParamsResp.class);

    //     // 记录二维码信息
    //     WechatQRCodeDataAddDTO wechatQRCodeDataAddDTO = new WechatQRCodeDataAddDTO();
    //     wechatQRCodeDataAddDTO.setId(qrCodeDataInfoId);
    //     wechatQRCodeDataAddDTO.setSceneType(params.getSceneType());
    //     wechatQRCodeDataAddDTO.setUserId(params.getUserId());
    //     wechatQRCodeDataAddDTO.setOwnerType(params.getOwnerType());
    //     wechatQRCodeDataAddDTO.setOwnerCode(params.getOwnerCode());
    //     wechatQRCodeDataAddDTO.setOwnerName(params.getOwnerName());
    //     wechatQRCodeDataAddDTO.setScene(scene);
    //     wechatQRCodeDataAddDTO.setQrType(params.getQrType());
    //     wechatQRCodeDataAddDTO.setExpireSeconds(params.getExpireSeconds());
    //     wechatQRCodeDataAddDTO.setTicket(resp.getTicket());
    //     wechatQRCodeDataAddDTO.setUrl(resp.getUrl());
    //     wechatQRCodeDataBizService.save(wechatQRCodeDataAddDTO);

    //     return resp;
    // }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public QRcodeWithParamsResp createQRCode(WechatQRCodeCreateDTO params) {
        ValidatorUtils.validateEntity(params);
        
        // 微信二维码信息id
        String qrCodeDataInfoId = PushWechatHelper.getQRCodeDataInfoId();

        String scene = params.getSceneType() + "_" + qrCodeDataInfoId; // 场景类型 + 平台二维码id，加上类型用于直接区分场景，主要是海鹚区分
        Map<String, String> sceneStr = new HashMap<>();
        sceneStr.put("scene_str", scene); // 可以通过此值中的二维码id查询到二维码信息

        Map<String, Object> sceneMap = new HashMap<>();
        sceneMap.put("scene", sceneStr);

        Map<String, Object> qrcodeMap = new HashMap<>();
        qrcodeMap.put("action_info", sceneMap);

        String wxQrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Permanent.getWxcode(); // 微信二维码参数；默认永久二维码
        String qrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Permanent.getCode(); // 本地二维码类型数据；默认永久二维码
        if (WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getCode().equals(params.getQrType()) || WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getWxcode().equals(params.getQrType())) {
            if (null == params.getExpireSeconds() || params.getExpireSeconds() < 0 || params.getExpireSeconds() > 2592000) { // 过期时间最大2592000秒
                throw new BusinessException("临时二维码过期时间参数异常");
            }
            qrcodeMap.put("expire_seconds", params.getExpireSeconds());

            wxQrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getWxcode(); // 临时二维码
            qrType = WeixinQRCodeConstant.QrcodeType.QR_Str_Temporary.getCode();
        }
        qrcodeMap.put("action_name", wxQrType);

        WxQrCodeDTO wxQrCodeDTO = new WxQrCodeDTO();
        wxQrCodeDTO.setParamsId("WX_MP_3");
        wxQrCodeDTO.setQrcodeParams(JSON.toJSONString(qrcodeMap));
        QRcodeWithParamsResp resp = thirdWeixinQrCodeService.createQRCode(wxQrCodeDTO);

        // 记录二维码信息
        WechatQRCodeDataAddDTO wechatQRCodeDataAddDTO = new WechatQRCodeDataAddDTO();
        wechatQRCodeDataAddDTO.setId(qrCodeDataInfoId);
        wechatQRCodeDataAddDTO.setSceneType(params.getSceneType());
        wechatQRCodeDataAddDTO.setUserId(params.getUserId());
        wechatQRCodeDataAddDTO.setOwnerType(params.getOwnerType());
        wechatQRCodeDataAddDTO.setOwnerCode(params.getOwnerCode());
        wechatQRCodeDataAddDTO.setOwnerName(params.getOwnerName());
        wechatQRCodeDataAddDTO.setScene(scene);
        wechatQRCodeDataAddDTO.setQrType(qrType);
        wechatQRCodeDataAddDTO.setExpireSeconds(params.getExpireSeconds());
        wechatQRCodeDataAddDTO.setTicket(resp.getTicket());
        wechatQRCodeDataAddDTO.setUrl(resp.getUrl());
        wechatQRCodeDataBizService.save(wechatQRCodeDataAddDTO);

        return resp;
    }

    @Override
    public String passiveMsg(ReceiveEventFullModel params) {
        log.info("接收用户事件消息 >>>>>> event={}", JSON.toJSONString(params));
        String resp = null;
        // 根据回复消息内容确定推送的消息
        String event = params.getEvent();
        if (WxMsgEventType.SUBSCRIBE.getType().equals(event)) { // 订阅事件/未关注用户扫描带参数二维码事件
            log.info("用户订阅事件>>>>>>");
            // 扫带参数的二维码的订阅的 eventKey 是以 qrscene_ 开头，需要去除 qrscene_
            if (StrUtil.isNotBlank(params.getEventKey())) {
                params.setEventKey(params.getEventKey().substring(8));
            }

            // zs20240708 为订阅用户注册账号
            try {
                CustomerUserLoginThirdClientDTO register = new CustomerUserLoginThirdClientDTO();
                register.setParamsId("WX_MP_3");
                register.setOpenId(params.getFromUserName());
                weixinAsyncBizService.registerCustom(register);
            } catch (Exception e) {
                log.error("扫码关注异步注册用户失败: openid={}; message={}", params.getFromUserName(), e.getMessage());
                e.printStackTrace();
            }

            resp = this.textEvent(params);
        } else if (WxMsgEventType.UNSUBSCRIBE.getType().equals(event)) { // 取消订阅事件
            log.info("用户取消订阅事件>>>>>>");
            // TODO FIXME
        } else if (WxMsgEventType.SCAN.getType().equals(event)) { // 已关注用户扫描带参数二维码事件
            log.info("已关注用户扫描带参数二维码事件>>>>>>");
            
            // zs20240708 为订阅用户注册账号
            try {
                CustomerUserLoginThirdClientDTO register = new CustomerUserLoginThirdClientDTO();
                register.setParamsId("WX_MP_3");
                register.setOpenId(params.getFromUserName());
                weixinAsyncBizService.registerCustom(register);
            } catch (Exception e) {
                log.error("扫码关注异步注册用户失败: openid={}; message={}", params.getFromUserName(), e.getMessage());
                e.printStackTrace();
            }

            resp = this.textEvent(params);
        }
        log.info("返回数据>>>>>> resp={}", resp);

        return resp;
    }

    // 文本事件
    private String textEvent(ReceiveEventFullModel receiveEventFullModel) {
        // 推送文本消息
        ReplyMsgTextModel replyMsgTextModel = new ReplyMsgTextModel();
        replyMsgTextModel.setMsgType(WxMsgType.TEXT.getType());
        replyMsgTextModel.setFromUserName(receiveEventFullModel.getToUserName());
        replyMsgTextModel.setToUserName(receiveEventFullModel.getFromUserName());
        replyMsgTextModel.setCreateTime(System.currentTimeMillis() / 1000);

        // 查询消息配置
        Map<String, String> wxReplyMsg = paramsClientService.getParamConfig("WX_REPLY_MSG", new HashMap<String, String>());
        log.info("获取请求回复信息数据<<<<<< {}", JSON.toJSONString(wxReplyMsg));
        
        String replyMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.Default.getCode());

        if (StrUtil.isNotBlank(receiveEventFullModel.getEventKey())) {
            replyMsg = textContent(receiveEventFullModel.getEventKey(), receiveEventFullModel.getFromUserName(), receiveEventFullModel.getEvent(), wxReplyMsg);   
        }

        replyMsgTextModel.setContent(replyMsg.replace("#promotionCode", "")); // 去掉占位符

        // 推送数据转xml
        return XmlUtils.convertToXml(replyMsgTextModel);
    }

    // 回复消息
    private String textContent(String sceneid, String openid, String event, Map<String, String> wxReplyMsg) {
        String replyMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.Default.getCode());

        // 查询二维码信息
        String[] sceneStr = sceneid.split("_");
        
        // zs20240731 不需要从二维码中获取场景类型，二维码id获取的二维码信息中可以获取场景类型
        // String sceneType = ""; // sceneStr[0]; // 场景类型：WeixinQRCodeConstant.SceneType
        // 为解决场景参数中加下划线的问题
        // for (int i = 0; i < sceneStr.length - 1; i++) {
        //     if (StrUtil.isBlank(sceneType)) {
        //         sceneType = sceneStr[i];
        //         continue;
        //     }
        //     sceneType += sceneStr[i];
        // }
        String qrcodeId = sceneStr[sceneStr.length - 1]; // 场景二维码id
        
        // 保存日志
        PatientSubscribeDataLogAddDTO patientSubscribeDataLogAddDTO = new PatientSubscribeDataLogAddDTO();
        patientSubscribeDataLogAddDTO.setEvent(event);
        patientSubscribeDataLogAddDTO.setOpenId(openid);
        patientSubscribeDataLogAddDTO.setCreateDate(DateUtil.date());
        patientSubscribeDataLogAddDTO.setQrcodeId(qrcodeId);

        // 保存互联网推广日志
        HisPromotionLog hisPromotionLog = new HisPromotionLog();
        hisPromotionLog.setId(PushWechatHelper.getHisPromotionLogId());
        hisPromotionLog.setQrcodeId(qrcodeId);
        hisPromotionLog.setOpenId(openid);
        hisPromotionLog.setOpDate(DateUtil.date());
        hisPromotionLog.setStatus(YN.NO.getCode());

        String promotionCode = ""; // 互联网医院推广码code

        WechatQRCodeDataGetDTO wechatQRCodeDataGetDTO = new WechatQRCodeDataGetDTO();
        wechatQRCodeDataGetDTO.setId(qrcodeId);
        WechatQRCodeDataVO wechatQRCodeDataVO = wechatQRCodeDataBizService.detail(wechatQRCodeDataGetDTO);
        if (null != wechatQRCodeDataVO) {
            
            hisPromotionLog.setOwnerType(wechatQRCodeDataVO.getOwnerType());
            hisPromotionLog.setOwnerCode(wechatQRCodeDataVO.getOwnerCode());
            hisPromotionLog.setOwnerName(wechatQRCodeDataVO.getOwnerName());

            // 获取二维码对应的推广码
            // 调用互联网医院推广码
            // HisPromotionCodeDTO promotionCodeDTO = new HisPromotionCodeDTO();
            // promotionCodeDTO.setPromotionCodeType("3");
            // if (WeixinQRCodeConstant.OwnerType.Doctor.getCode().equals(wechatQRCodeDataVO.getOwnerType()) 
            //         || WeixinQRCodeConstant.OwnerType.Assistant.getCode().equals(wechatQRCodeDataVO.getOwnerType())
            //         || WeixinQRCodeConstant.OwnerType.Nurse.getCode().equals(wechatQRCodeDataVO.getOwnerType())
            //         || WeixinQRCodeConstant.OwnerType.Aide.getCode().equals(wechatQRCodeDataVO.getOwnerType())) {
            //     promotionCodeDTO.setPromotionCodeType("1");
            // } else if (WeixinQRCodeConstant.OwnerType.Dept.getCode().equals(wechatQRCodeDataVO.getOwnerType())
            //         || WeixinQRCodeConstant.OwnerType.Exam_Center.getCode().equals(wechatQRCodeDataVO.getOwnerType())) {
            //     promotionCodeDTO.setPromotionCodeType("2");
            // }
            // promotionCodeDTO.setPromotionCode(wechatQRCodeDataVO.getOwnerCode());
            // HisPromotionCodeModel hisPromotionCodeModel = thirdHisService.getAndSavePromotionCodeUrl(promotionCodeDTO);
            // if (null != hisPromotionCodeModel && StrUtil.isNotBlank(hisPromotionCodeModel.getPromotionCodeId()) && !"0".equals(hisPromotionCodeModel.getPromotionCodeId()) && StrUtil.isNotBlank(hisPromotionCodeModel.getPromotionCode())) {
            //     hisPromotionLog.setStatus(YN.YES.getCode());
            //     promotionCode = hisPromotionCodeModel.getPromotionCodeId();
            // }
            HisPromotionInfo hisPromotionInfo = hisPromotionInfoService.getOne(new QueryWrapper<HisPromotionInfo>()
                    .eq("enable", "1")
                    .eq("extend_code", wechatQRCodeDataVO.getOwnerCode())
            );
            if (null != hisPromotionInfo) {
                promotionCode = hisPromotionInfo.getId();
            }
            
            // 整理回复的消息
            String preMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.Pre.getCode());
            String duringMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.During.getCode());
            String inHospitalMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.InHospital.getCode());
            String doctorMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.Doctor.getCode());
            String deptMsg = wxReplyMsg.get(WeixinQRCodeConstant.SceneType.Dept.getCode());

            if (WeixinQRCodeConstant.SceneType.Pre.getCode().equals(wechatQRCodeDataVO.getSceneType()) && StrUtil.isNotBlank(preMsg)) {
                replyMsg = msgStr(preMsg, wechatQRCodeDataVO.getOwnerName(), qrcodeId);
            } else if (WeixinQRCodeConstant.SceneType.During.getCode().equals(wechatQRCodeDataVO.getSceneType()) && StrUtil.isNotBlank(duringMsg)) {
                replyMsg = msgStr(duringMsg, wechatQRCodeDataVO.getOwnerName(), qrcodeId);
            } else if (WeixinQRCodeConstant.SceneType.InHospital.getCode().equals(wechatQRCodeDataVO.getSceneType()) && StrUtil.isNotBlank(inHospitalMsg)) {
                replyMsg = msgStr(inHospitalMsg, wechatQRCodeDataVO.getOwnerName(), qrcodeId);
            } else if (WeixinQRCodeConstant.SceneType.Doctor.getCode().equals(wechatQRCodeDataVO.getSceneType()) && StrUtil.isNotBlank(doctorMsg)) {
                HisDoctorQueryClientDTO hisDoctorQueryClientDTO = new HisDoctorQueryClientDTO();
                hisDoctorQueryClientDTO.setHisDoctorId(wechatQRCodeDataVO.getOwnerCode());
                HisSchemeUrlBO schemeUrl = hisDataClientService.getDoctorSchemaUrl(hisDoctorQueryClientDTO);
                replyMsg = doctorMsg + schemeUrl.getSchemeUrl();
            } else if (WeixinQRCodeConstant.SceneType.Dept.getCode().equals(wechatQRCodeDataVO.getSceneType()) && StrUtil.isNotBlank(deptMsg)) {
                HisDeptQueryClientDTO hisDeptQueryClientDTO = new HisDeptQueryClientDTO();
                hisDeptQueryClientDTO.setHisDeptId(wechatQRCodeDataVO.getOwnerCode());
                HisSchemeUrlBO schemeUrl = hisDataClientService.getDeptSchemaUrl(hisDeptQueryClientDTO);
                replyMsg = deptMsg + schemeUrl.getSchemeUrl();
            }
        }

        // 保存日志
        patientSubscribeDataBizService.saveLog(patientSubscribeDataLogAddDTO);
        hisPromotionLogService.save(hisPromotionLog);

        // 互联网医院推广码跳转小程序参数
        if (StrUtil.isNotBlank(promotionCode)) {
            replyMsg = replyMsg.replace("#promotionCode", "?actionType=78&promotionCode=" + promotionCode);
        }

        return replyMsg;
    }

    private String msgStr(String replyContent, String name, String id) {
        return replyContent.replace("#name", null == name ? "" : name).replace("#qrcode", null == id ? "" : id);
    }

    @Override
    public void saveWechatUserInfoBatch(List<WeixinUserInfo> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }
        Date now = DateUtil.date();
        params.forEach(i -> {
            i.setId(PushWechatHelper.getWeixinUserInfoId());
            i.setCreateDate(now);
            i.setUpdateDate(now);
        });
        // 保存微信用户信息
        wechatMapper.saveWechatUserInfoBatch(params);
    }

    @Override
    public List<WeixinUserInfo> queryWechatUserInfo(BasePageDTO page) {
        IPage<WeixinUserInfo> data = wechatUserInfoService.page(new Page<>(page.getPage(), page.getRows()), new QueryWrapper<WeixinUserInfo>()
            .and(i -> i.isNull("is_sync").or().eq("is_sync", "").or().eq("is_sync", YN.NO.getCode()))
            .orderByAsc("id")
        );
        return data.getRecords();
    }

    @Deprecated
    // @Async // 异步保存可能导致查询出问题
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveUserInfoBatch(List<WeixinUserPatientBindInfo> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }
        List<String> weixinUserInfoIds = new ArrayList<>();
        Date now = DateUtil.date();
        for (WeixinUserPatientBindInfo entity : params) {
            entity.setId(PushWechatHelper.getWeixinUserPatientBindInfoId());
            entity.setCreateDate(now);
            entity.setUpdateDate(now);
            weixinUserInfoIds.add(entity.getWxUserId());
        }

        // 保存用户信息
        wechatMapper.saveUserInfoBatch(params);
        // 更新同步状态
        wechatUserInfoService.update(new UpdateWrapper<WeixinUserInfo>()
            .set("is_sync", YN.YES.getCode())
            .in("id", weixinUserInfoIds)
        );

    }

    // @Async // 异步保存可能导致查询出问题
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveUserInfoBatch2(WeixinUserSyncDTO params) {
        Date now = DateUtil.date();
        // 保存用户信息
        List<WeixinUserPatientBindInfo> saveList = params.getSaveList();
        if (CollUtil.isNotEmpty(saveList)) {
            for (WeixinUserPatientBindInfo entity : saveList) {
                entity.setId(PushWechatHelper.getWeixinUserPatientBindInfoId());
                entity.setCreateDate(now);
                entity.setUpdateDate(now);
            }
            wechatMapper.saveUserInfoBatch(saveList);
        }

        // 更新同步状态
        List<String> updateList = params.getUpdateList();
        if (CollUtil.isNotEmpty(updateList)) {
            wechatUserInfoService.update(new UpdateWrapper<WeixinUserInfo>()
                .set("is_sync", YN.YES.getCode())
                .set("update_date", now)
                .in("id", updateList)
            );
        }

    }

}
