package com.xxh.cloud.healthy.scale.application.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.scale.framework.modules.config.biz.ScaleConfigBizService;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleConfigInfoGetDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleConfigInfoQueryDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.service.ScaleConfigInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("/app/healthy/scale/config")
@Api(tags = "应用端,量表管理")
public class ScaleConfigAppController {


    @Autowired
    private ScaleConfigBizService scaleConfigBizService;


    @PostMapping("/query")
    @ApiOperation(value = "查询量表", response = ScaleConfigVO.class)
    public Result<PageData<ScaleConfigVO>> query(@RequestBody ScaleConfigInfoQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        params.setStatus(YN.YES.getCode());
        PageData<ScaleConfigVO> data= scaleConfigBizService.query(params);
        return new Result<PageData<ScaleConfigVO>>().ok(data);
    }


    @PostMapping("/info")
    @ApiOperation(value = "获取量表", response = ScaleConfigVO.class)
    public Result<ScaleConfigVO> info(@RequestBody ScaleConfigInfoGetDTO params) {
        ValidatorUtils.validateEntity(params);
        ScaleConfigVO data=  scaleConfigBizService.infoFullById(params.getId());
        return new Result<ScaleConfigVO>().ok(data);
    }



}
