package com.xxh.cloud.healthy.scale.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.scale.framework.modules.cache.helper.ScaleCacheKeyHelper;
import com.xxh.cloud.healthy.scale.framework.modules.cache.service.ScaleConfigCacheService;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleItemConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.helper.ScaleConfigConvert;
import com.xxh.cloud.healthy.scale.framework.modules.config.service.ScaleConfigInfoService;
import com.xxh.cloud.healthy.scale.framework.modules.config.service.ScaleItemConfigInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class ScaleConfigCacheServiceImpl  extends BasicCacheServiceImpl<ScaleConfigVO> implements ScaleConfigCacheService {


    @Autowired
    private ScaleConfigInfoService scaleConfigInfoService;
    @Autowired
    private ScaleItemConfigInfoService scaleItemConfigInfoService;

    @Override
    public String getCacheKey(String id) {
        return ScaleCacheKeyHelper.getScaleConfigKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return ScaleCacheKeyHelper.getScaleConfigMainKey();
    }

    @Override
    public Class<ScaleConfigVO> getJsonClazz() {
        return ScaleConfigVO.class;
    }

    @Override
    public String getId(ScaleConfigVO scaleConfigVO) {
        return scaleConfigVO.getId();
    }

    @Override
    public ScaleConfigVO getById2DB(String id) {

        if(StrUtil.isEmpty(id)){
            return null;
        }
//        ScaleConfigInfo entity= scaleConfigInfoService.getById(id);
//        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
//            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
//        }
//        List<ScaleItemConfigInfo> items= scaleItemConfigInfoService.list(
//                new QueryWrapper<ScaleItemConfigInfo>()
//                        .eq("scale_config_id",entity.getId())
//                        .eq("rows_status",YN.YES.getCode())
//                        .orderByDesc("orders")
//        );
//        return ScaleConfigConvert.getScaleConfigVO_Full(entity,items);


        ScaleConfigInfo entity= scaleConfigInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        List<ScaleItemConfigInfo> items= scaleItemConfigInfoService.list(
                new QueryWrapper<ScaleItemConfigInfo>()
                        .eq("scale_config_id",entity.getId())
                        .eq("rows_status",YN.YES.getCode())
                        .orderByDesc("orders")
        );
        return ScaleConfigConvert.getScaleConfigVO_Full(entity,items);
    }

    @Override
    public List<ScaleConfigVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<ScaleConfigInfo> list= scaleConfigInfoService.list(
                new QueryWrapper<ScaleConfigInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );
        if(CollUtil.isEmpty(list)){
            return null;
        }

        List<String> scids=new ArrayList<>();
        list.forEach(item->{
            scids.add(item.getId());
        });

        List<ScaleItemConfigInfo> items= scaleItemConfigInfoService.list(
                new QueryWrapper<ScaleItemConfigInfo>()
                        .in("scale_config_id",scids)
                        .eq("rows_status",YN.YES.getCode())
                        .orderByDesc("orders")
        );
        List<ScaleConfigVO> data=new ArrayList<>();
        list.forEach(item->{
            data.add(ScaleConfigConvert.getScaleConfigVO_Full(item,items));
        });
        return data;
    }


}
