package com.xxh.cloud.healthy.scale.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.healthy.scale.framework.modules.cache.helper.ScaleCacheKeyHelper;
import com.xxh.cloud.healthy.scale.framework.modules.cache.service.ScaleConfigCategoryCacheService;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleConfigCategoryInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleConfigCategoryTreeDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigCategoryVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.helper.ScaleConfigCategoryHelper;
import com.xxh.cloud.healthy.scale.framework.modules.config.service.ScaleConfigCategoryInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Service
public class ScaleConfigCategoryCacheServiceImpl   extends BasicCacheServiceImpl<ScaleConfigCategoryVO>  implements ScaleConfigCategoryCacheService {

    @Autowired
    private ScaleConfigCategoryInfoService scaleConfigCategoryInfoService;

    @Override
    public String getCacheKey(String id) {
        return ScaleCacheKeyHelper.getScaleConfigCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return ScaleCacheKeyHelper.getScaleConfigCategoryMainKey();
    }

    @Override
    public Class<ScaleConfigCategoryVO> getJsonClazz() {
        return ScaleConfigCategoryVO.class;
    }

    @Override
    public String getId(ScaleConfigCategoryVO scaleConfigCategoryVO) {
        return scaleConfigCategoryVO.getId();
    }

    @Override
    public ScaleConfigCategoryVO getById2DB(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        ScaleConfigCategoryInfo entity= scaleConfigCategoryInfoService.getById(id);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            return null;
        }
        return ScaleConfigCategoryHelper.getScaleConfigCategoryVO(entity);
    }

    @Override
    public List<ScaleConfigCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        List<ScaleConfigCategoryVO> data=new ArrayList<>();
        List<ScaleConfigCategoryInfo> list= scaleConfigCategoryInfoService.list(
                new QueryWrapper<ScaleConfigCategoryInfo>()
                        .eq("rows_status", YN.YES.getCode())
                        .in("id",ids)
        );
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.add(ScaleConfigCategoryHelper.getScaleConfigCategoryVO(item));
            });
        }
        return data;
    }
}
