package com.xxh.cloud.healthy.scale.framework.modules.client.convert;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;

import java.util.stream.Collectors;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleResultConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleResultConfigVO;

public class ScaleConfigClientConvert {


    public static PageScaleConfigBO getPageScaleConfigBO(IPage<ScaleConfigInfo> pageData){
        PageScaleConfigBO data=new PageScaleConfigBO();
        data.setTotal(pageData.getTotal());
        data.setPages(pageData.getPages());
        data.setSize(pageData.getSize());
        data.setCurrent(pageData.getCurrent());
        pageData.getRecords().forEach(item->{
            data.addRecord(getScaleConfigBO(item));
        });
        return data;
    }

    public static ScaleConfigBO getScaleConfigBO(ScaleConfigInfo entity){
        ScaleConfigBO data=new ScaleConfigBO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        if(StrUtil.isNotEmpty(entity.getResultConfig())){
            data.setResultConfig(JSON.parseArray(entity.getResultConfig(), ScaleResultConfigBO.class));
        }
        return data;
    }

    public static ScaleConfigBO getScaleConfigBO(ScaleConfigVO entity){
        ScaleConfigBO data=new ScaleConfigBO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        if (CollUtil.isNotEmpty(entity.getResultConfig())) {
            data.setResultConfig(entity.getResultConfig().stream().map(ScaleConfigClientConvert::getScaleResultConfigBO).collect(Collectors.toList()));
        }
        return data;
    }

    public static ScaleResultConfigBO getScaleResultConfigBO(ScaleResultConfigVO entity){
        ScaleResultConfigBO data=new ScaleResultConfigBO();
        data.setCode(entity.getCode());
        data.setName(entity.getName());
        data.setType(entity.getType());
        data.setUnit(entity.getUnit());
        return data;
    }

    

}
