package com.xxh.cloud.healthy.scale.framework.modules.client.convert;

import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleItemConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleItemConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleItemConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.enums.ScaleConfigItemTypeEnum;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleItemConfigContentDateVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleItemConfigContentInputVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleItemConfigContentListVO;

import java.util.Map;

public class ScaleItemConfigConvert {


    public static PageScaleItemConfigBO getPageScaleItemConfigBO(IPage<ScaleItemConfigInfo> pageData, Map<String, ScaleConfigVO> scaleConfigMap){
        PageScaleItemConfigBO data=new PageScaleItemConfigBO();
        data.setTotal(pageData.getTotal());
        data.setPages(pageData.getPages());
        data.setSize(pageData.getSize());
        data.setCurrent(pageData.getCurrent());







        pageData.getRecords().forEach(item->{
            data.addRecord(getScaleItemConfigBO(item,scaleConfigMap));
        });
        return data;
    }


    public static ScaleItemConfigBO getScaleItemConfigBO(ScaleItemConfigInfo entity,Map<String, ScaleConfigVO> scaleConfigMap){
        ScaleItemConfigBO data=new ScaleItemConfigBO();
        data.setId(entity.getId());
        data.setTitle(entity.getTitle());
        data.setType(entity.getType());
        data.setScaleConfigId(entity.getScaleConfigId());

        //todo:
        if(ScaleConfigItemTypeEnum.SCI_Input.getCode().equals(entity.getType())){
            ScaleItemConfigContentInputVO contentConfig= JSON.parseObject(entity.getContent(), ScaleItemConfigContentInputVO.class);
            data.setDataType(contentConfig.getT());
        }else if(ScaleConfigItemTypeEnum.SCI_Date.getCode().equals(entity.getType())){
            ScaleItemConfigContentDateVO contentConfig = JSON.parseObject(entity.getContent(), ScaleItemConfigContentDateVO.class);
        } else {
            ScaleItemConfigContentListVO contentConfig =   JSON.parseObject(entity.getContent(), ScaleItemConfigContentListVO.class);
            data.setDictType(contentConfig.getDictType());
        }

        if(MapUtil.isNotEmpty(scaleConfigMap) && StrUtil.isNotEmpty(entity.getScaleConfigId())){
            ScaleConfigVO scaleConfigVO=scaleConfigMap.get(entity.getScaleConfigId());
            if(scaleConfigVO!=null){
                data.setScaleConfigName(scaleConfigVO.getName());
            }
        }

        return data;
    }


}
