package com.xxh.cloud.healthy.scale.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.ScaleConfigClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.dto.ScaleConfigClientQueryPageDTO;
import com.xxh.cloud.healthy.scale.framework.modules.client.convert.ScaleConfigClientConvert;
import com.xxh.cloud.healthy.scale.framework.modules.config.biz.ScaleConfigBizService;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleConfigInfoQueryDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ScaleConfigClientServiceImpl implements ScaleConfigClientService {

    @Autowired
    private ScaleConfigBizService scaleConfigBizService;

    @Override
    public PageScaleConfigBO query(ScaleConfigClientQueryPageDTO params) {
        ValidatorUtils.validateEntity(params);
        ScaleConfigInfoQueryDTO queryParams=new ScaleConfigInfoQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setName(params.getName());
        queryParams.setCategoryId(params.getCategoryId());
        //queryParams.setStatus(YN.YES.getCode());
        queryParams.setId(params.getId());
        queryParams.setIds(params.getIds());
        queryParams.setResultConfigNullFlag("Y");
        IPage<ScaleConfigInfo> pageData = scaleConfigBizService.queryScaleConfig(queryParams);
        if(pageData==null || CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }
        return ScaleConfigClientConvert.getPageScaleConfigBO(pageData);
    }

    @Override
    public ScaleConfigBO getFullById(String id) {
        ScaleConfigVO vo = scaleConfigBizService.infoFullById(id);
        return ScaleConfigClientConvert.getScaleConfigBO(vo);
    }


}
