package com.xxh.cloud.healthy.scale.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.scale.framework.modules.cache.service.ScaleConfigCacheService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.ScaleItemConfigClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleItemConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.dto.ScaleItemConfigClientQueryPageDTO;
import com.xxh.cloud.healthy.scale.framework.modules.client.convert.ScaleItemConfigConvert;
import com.xxh.cloud.healthy.scale.framework.modules.config.biz.ScaleConfigBizService;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos.ScaleItemConfigInfo;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleConfigInfoQueryDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto.ScaleItemConfigQueryDTO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleConfigVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@Service
public class ScaleItemConfigClientServiceImpl implements ScaleItemConfigClientService {


    @Autowired
    private ScaleConfigBizService scaleConfigBizService;

    @Autowired
    private ScaleConfigCacheService scaleConfigCacheService;



    @Override
    public PageScaleItemConfigBO query(ScaleItemConfigClientQueryPageDTO params) {
        ValidatorUtils.validateEntity(params);
        ScaleItemConfigQueryDTO queryParams=new ScaleItemConfigQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setId(params.getId());
        queryParams.setIds(params.getIds());
        queryParams.setScaleConfigId(params.getScaleConfigId());
        queryParams.setKeywords(params.getKeywords());
        IPage<ScaleItemConfigInfo> pageData= scaleConfigBizService.queryScaleItemConfig(queryParams);
        if(pageData==null || CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }

        Set<String> scaleConfigIds=new HashSet<>();
        pageData.getRecords().forEach(item->{
            scaleConfigIds.add(item.getScaleConfigId());
        });

        Map<String, ScaleConfigVO> scaleConfigMap= scaleConfigCacheService.getMapByIds(scaleConfigIds);

        return ScaleItemConfigConvert.getPageScaleItemConfigBO(pageData,scaleConfigMap);
    }




}
