package com.xxh.cloud.healthy.scale.framework.modules.config.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 量表配置信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_scale_config_info")
public class ScaleConfigInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 分类ID
     */
     @ApiModelProperty(value = "分类ID")
      private String categoryId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseIds;


    /**
     * 类别
     */
     @ApiModelProperty(value = "类别")
      private String type;

    /**
     * 图标
     */
     @ApiModelProperty(value = "图标")
      private String icon;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 状态
     */
     @ApiModelProperty(value = "状态")
      private String status;

    /**
     * 顺序
     */
     @ApiModelProperty(value = "顺序")
      private Integer orders;

    /**
     * 父ID
     */
     @ApiModelProperty(value = "父ID")
      private String parentId;

    /**
     * 结果计算脚本
     */
     @ApiModelProperty(value = "结果计算脚本")
      private String resultScriptContent;

    /**
     * 数据来源
     */
     @ApiModelProperty(value = "数据来源")
      private String source;


    /**
     * 项目编号
     */
    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    /**
     * 版本号
     */
    @ApiModelProperty(value = "版本号")
    private String versionCode;


    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;


    @ApiModelProperty(value = "结果配置")
    private String resultConfig;




}
