package com.xxh.cloud.healthy.scale.framework.modules.config.entity.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.constant.Constant;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.enums.ScaleConfigTypeEnum;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleResultConfigVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class ScaleConfigInfoSaveDTO {


    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "名称",required = true)
    @NotEmpty(message = "名称不能为空")
    private String name;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;


    @ApiModelProperty(value = "类别(ScaleConfigTypeEnum)",required = true)
    @NotEmpty(message = "类别不能为空")
    private String type= ScaleConfigTypeEnum.Scale_Info.getCode();


    @ApiModelProperty(value = "图标")
    private String icon;


    @ApiModelProperty(value = "备注")
    private String remark;



    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "父ID")
    private String parentId= Constant.RootParentNodeId;


    @ApiModelProperty(value = "结果计算脚本")
    private String resultScriptContent;


    @ApiModelProperty(value = "结果配置")
    private List<ScaleResultConfigVO> resultConfig;


    @ApiModelProperty(value = "数据来源")
    private String source;









}
