package com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos;

import cn.hutool.core.collection.CollUtil;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

@Getter
@Setter
public class ScaleConfigVO {



    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;


    @ApiModelProperty(value = "病种ID")
    private List<String> diseaseIds;



    @ApiModelProperty(value = "类别")
    private String type;


    @ApiModelProperty(value = "图标")
    private String icon;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "父ID")
    private String parentId;


    @ApiModelProperty(value = "结果计算脚本")
    private String resultScriptContent;


    @ApiModelProperty(value = "数据来源")
    private String source;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;



    @ApiModelProperty(value = "结果配置")
    private List<ScaleResultConfigVO> resultConfig;


    //=============================
    @ApiModelProperty(value = "明细")
    private List<ScaleItemConfigVO> items;


    @ApiModelProperty(value = "分类名称")
    private String categoryName;


    @ApiModelProperty(value = "病种")
    private List<Map<String,String>> diseaseList;


    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;

    @ApiModelProperty(value = "创建用户昵称")
    private String creatorNickName;

    @ApiModelProperty(value = "修改用户昵称")
    private String updaterNickName;

    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;


    public Map<String,ScaleItemConfigVO> getItemMap(){
        Map<String,ScaleItemConfigVO> data=new HashMap<>();
        if(CollUtil.isEmpty(this.items)){
            return data;
        }
        this.items.forEach(item->{
            data.put(item.getId(),item);
        });
        return data;
    }

    public void addItem(ScaleItemConfigVO item){
        if(this.items==null){
            this.items=new ArrayList<>();
        }
        if(item!=null){
            this.items.add(item);
        }
    }

    public void addDisease(String id,String name){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }

        Map<String,String> entity=new HashMap<>();
        entity.put("id",id);
        entity.put("name",name);
        this.diseaseList.add(entity);
    }

}
