package com.xxh.cloud.healthy.scale.framework.modules.result.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者疾病评估表
 * </p>
 *
 * @author anros
 * @since 2024-04-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_disease_evaluation_info")
public class DiseaseEvaluationInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 客户用户ID
     */
     @ApiModelProperty(value = "客户用户ID")
      private String custUserId;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 评估Id
     */
     @ApiModelProperty(value = "评估Id")
      private String evaluationId;

    /**
     * 评估名称
     */
     @ApiModelProperty(value = "评估名称")
      private String evaluationName;

    /**
     * 评估结果
     */
     @ApiModelProperty(value = "评估结果")
      private String resultValue;

    /**
     * 评估时间
     */
     @ApiModelProperty(value = "评估时间")
      private String evaluationTime;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;




}
