package com.xxh.cloud.healthy.scale.framework.modules.result.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 量表评估结果表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_scale_result_info")
public class ScaleResultInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;


    @ApiModelProperty(value = "客户用户ID")
    private String custUserId;


    @ApiModelProperty(value = "患者ID")
    private String patientId;


    @ApiModelProperty(value = "量表Id")
    private String scaleConfigId;


    @ApiModelProperty(value = "量表名称")
    private String scaleConfigName;

    @ApiModelProperty(value = "量表分类")
    private String scaleConfigType;

    @ApiModelProperty(value = "任务ID")
    private String taskId;


    @ApiModelProperty(value = "量表结果")
    private String scaleResult;


    @ApiModelProperty(value = "量表结果配置")
    private String scaleResultConfig;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "开始评估时间")
    private Date startEvaluationDate;


    @ApiModelProperty(value = "截止评估时间")
    private Date endEvaluationDate;


    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
