package com.xxh.cloud.healthy.scale.framework.modules.result.entity.vos;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleResultConfigVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Getter
@Setter
public class ScaleResultVO {


    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "客户用户ID")
    private String custUserId;

    @ApiModelProperty(value = "患者ID")
    private String patientId;


    @ApiModelProperty(value = "量表Id")
    private String scaleConfigId;

    @ApiModelProperty(value = "量表名称")
    private String scaleConfigName;


    @ApiModelProperty(value = "任务ID")
    private String taskId;

    @ApiModelProperty(value = "结果配置")
    private List<ScaleResultConfigVO> scaleResultConfig;



    @ApiModelProperty(value = "量表结果")
    private Map<String,Object> scaleResult;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "开始评估时间")
    private Date startEvaluationDate;


    @ApiModelProperty(value = "截止评估时间")
    private Date endEvaluationDate;



    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;


    //=====================================
    @ApiModelProperty(value = "明细")
    private List<ScaleItemResultVO> items;

    @ApiModelProperty(value = "客户用户ID")
    private String custUserName;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "患者性别")
    private String patientGenderStandard;

    @ApiModelProperty(value = "患者年龄")
    private String patientAge;



    public void addItem(ScaleItemResultVO item){
        if(this.items==null){
            this.items=new ArrayList<>();
        }
        if(item!=null){
            this.items.add(item);
        }
    }




}
