package com.xxh.cloud.healthy.scale.framework.modules.result.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleItemConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.config.entity.vos.ScaleResultConfigVO;
import com.xxh.cloud.healthy.scale.framework.modules.result.entity.dos.ScaleItemResultInfo;
import com.xxh.cloud.healthy.scale.framework.modules.result.entity.dos.ScaleResultInfo;
import com.xxh.cloud.healthy.scale.framework.modules.result.entity.vos.ScaleItemResultVO;
import com.xxh.cloud.healthy.scale.framework.modules.result.entity.vos.ScaleResultVO;
import com.xxh.cloud.healthy.third.client.modules.api.entity.bos.HealthyUserBO;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;
import java.util.Map;

public class ScaleResultConvert {

    public static ScaleResultVO getScaleResultVO(ScaleResultInfo entity,
                                                 Map<String, HealthyUserBO> userMap,
                                                 Map<String, PatientClientBO> patientMap){
        ScaleResultVO data=new ScaleResultVO();
        BeanUtil.copyProperties(entity,data,"scaleResult","scaleResultConfig");

        if(StrUtil.isNotEmpty(entity.getScaleResult())){
            data.setScaleResult(JSON.parseObject(entity.getScaleResult(),Map.class));
        }

        if(StrUtil.isNotEmpty(entity.getScaleResultConfig())){
            data.setScaleResultConfig(JSON.parseArray(entity.getScaleResultConfig(), ScaleResultConfigVO.class));
        }

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCustUserId())){
                HealthyUserBO user= userMap.get(data.getCustUserId());
                if(user!=null){

                }
            }
            if(StrUtil.isNotEmpty(data.getCreator())){
                HealthyUserBO user= userMap.get(data.getCreator());
                if(user!=null){

                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                HealthyUserBO user=userMap.get(data.getUpdater());
                if(user!=null){

                }
            }
        }
        if (MapUtil.isNotEmpty(patientMap) && patientMap.containsKey(entity.getPatientId())) {
            PatientClientBO patientClientBO = patientMap.get(entity.getPatientId());
            data.setPatientName(patientClientBO.getPatientName());
            data.setPatientGenderStandard(patientClientBO.getPatientGenderStandard());
            data.setPatientAge(patientClientBO.getAge());
        }
        return data;
    }


    public static ScaleResultVO getScaleResultVO_Full(ScaleResultInfo entity, List<ScaleItemResultInfo> items, Map<String, HealthyUserBO> userMap,
                                                      Map<String, PatientClientBO> patientMap){
        ScaleResultVO data=getScaleResultVO(entity,userMap,patientMap);
        if(CollUtil.isNotEmpty(items)){
            items.forEach(item->{
                data.addItem(getScaleItemResultVO(item));
            });
        }
        return data;
    }


    public static ScaleItemResultVO getScaleItemResultVO(ScaleItemResultInfo entity){
        ScaleItemResultVO data=new ScaleItemResultVO();
        BeanUtil.copyProperties(entity,data,"scaleItemConfig");
        if(StrUtil.isNotEmpty(entity.getScaleItemConfig())){
            data.setScaleItemConfig(JSON.parseObject(entity.getScaleItemConfig(), ScaleItemConfigVO.class));
        }
        return data;
    }



}
