package com.xxh.cloud.healthy.serve.label.client.api;

import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelHistoryBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.dto.LabelQueryDTO;

import java.util.List;
import java.util.Map;

public interface PatientLabelQueryClientService {

    /**
     * 获取患者当前标签列表
     * */
    public List<PatientLabelBO> getListByPatientId(String patientId);

    /**
     * 获取多个患者当前标签列表
     * */
    public Map<String,List<PatientLabelBO>> getListByPatientIds(List<String> patientIds);

    /**
     * 获取患者当前标签列表
     * */
    public List<PatientLabelBO> queryList(LabelQueryDTO params);


    /**
     * 获取患者历史标签列表
     * */
    public List<PatientLabelHistoryBO> getHistoryListByPatientId(String patientId);

    /**
     * 获取多个患者历史标签列表
     * */
    public Map<String,List<PatientLabelHistoryBO>> getHistoryListByPatientIds(List<String> patientIds);

    /**
     * 通过标签id获取患者历史标签列表
     * */
    public List<PatientLabelHistoryBO> getHistoryListByLabelIds(List<String> labelIds);

    /**
     * 获取历史标签列表
     * */
    public List<PatientLabelHistoryBO> queryHistory(LabelQueryDTO params);

}
