package com.xxh.cloud.healthy.serve.label.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者标签信息表
 * </p>
 *
 * @author anros
 * @since 2023-09-05
 */
@Data
@TableName("h_patient_label_info")
public class PatientLabelInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 标签ID
     */
    @ApiModelProperty(value = "标签ID")
    private String labelId;

    /**
     * 是否有效期
     */
    @ApiModelProperty(value = "是否有效期")
    private String isValidity;

    @ApiModelProperty(value = "有效期天数")
    private Integer validityNum;

    /**
     * 有效期
     */
    @ApiModelProperty(value = "有效期")
    private String validityValue;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "来源分类")
    private String sourceType;

    @ApiModelProperty(value = "来源关联ID")
    private String sourceRelId;

    @ApiModelProperty(value = "来源关联TwoID")
    private String sourceRelTwoId;

    @ApiModelProperty(value = "患者数据时间")
    private Date dataDt;

    /**
     * 创建者
     */
    @ApiModelProperty(value = "创建者")
    private String creator;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createDate;


    // zs20231124
    @ApiModelProperty(value = "扩展字段1")
    private String extend1;

    @ApiModelProperty(value = "扩展字段2")
    private String extend2;

    @ApiModelProperty(value = "扩展字段3")
    private String extend3;

    @ApiModelProperty(value = "扩展字段4 (推送病种负责人 YN)")
    private String extend4;



}
