package com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorManagePatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorBehaviorDataCountBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorPatientRemarkBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

// zs:2023-09-19
@Getter
@Setter
public class PatientLabelHistoryVO {

    @ApiModelProperty(value = "患者编号")
    private String id;
    
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "标签ID")
    private String labelId;

    @ApiModelProperty(value = "是否有效期")
    private String isValidity;

    @ApiModelProperty(value = "有效期天数")
    private Integer validityNum;

    @ApiModelProperty(value = "有效期")
    private String validityValue;

    @ApiModelProperty(value = "操作动作分类")
    private String opType;

    @ApiModelProperty(value = "操作者")
    private String opUser;

    @ApiModelProperty(value = "操作时间")
    private Date opDate;

    // zs20230920
    @ApiModelProperty(value = "来源分类")
    private String sourceType;

    @ApiModelProperty(value = "来源关联ID")
    private String sourceRelId;

    @ApiModelProperty(value = "来源关联TwoID")
    private String sourceRelTwoId;

    @ApiModelProperty(value = "患者数据时间")
    private Date dataDt;

    // zs20231124
    @ApiModelProperty(value = "扩展字段1")
    private String extend1;

    @ApiModelProperty(value = "扩展字段2")
    private String extend2;

    @ApiModelProperty(value = "扩展字段3")
    private String extend3;

    @ApiModelProperty(value = "扩展字段4")
    private String extend4;


    @ApiModelProperty(value = "标签信息")
    private LabelBO labelInfo;


    @ApiModelProperty(value = "患者信息")
    private PatientClientBO patientInfo;

    @ApiModelProperty(value = "患者最新数据信息")
    private DataDwsPatientDataLastDateBO patientDataLastDateInfo;

    @ApiModelProperty(value = "医生行为信息")
    private List<DoctorBehaviorDataCountBO> doctorBehaviorDataCountList;

    @ApiModelProperty(value = "医生备注信息")
    private List<DoctorPatientRemarkBO> doctorPatientRemarkList;

    @ApiModelProperty(value = "医生最新备注信息")
    private DoctorPatientRemarkBO doctorPatientRemarkLast;

    @ApiModelProperty(value = "患者最新mdt会诊信息")
    private ConsultationBO mdtConsultationInfo;

    @ApiModelProperty(value = "患者最新就诊信息")
    private PatientVisitRecordClientBO visitInfo;

    @ApiModelProperty(value = "患者最新住院信息")
    private PatientInpatientRecordClientBO inpatientInfo;

    @ApiModelProperty(value = "患者最新出院信息")
    private PatientDischargeRecordClientBO outpatientInfo;

    @ApiModelProperty(value = "标签信息")
    private LabelBO labelBO;

    @ApiModelProperty(value = "是否关注")
    private String followStatus;

    @ApiModelProperty(value = "管理患者信息（排除/加入管理）")
    private DoctorManagePatientBO managePatientInfo;

    @ApiModelProperty(value = "是否加入个案")
    private String crmStatus;

    @ApiModelProperty(value = "个案关系状态")
    private String crmRelStatus;

}
