package com.xxh.cloud.healthy.serve.label.framework.modules.biz.helper;

import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelCategoryBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelHistoryBO;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelHistoryInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelHistoryVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelVO;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

// zs:2023-09-18
public class PatientLabelHelper {

    /**
     * PatientLabelId
     * */
    public static String getPatientLabelId(){

        return StrUtil.format("PL{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getLabelPatientDataId(){

        return StrUtil.format("LPD{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    /**
     * PatientLabelHistoryId
     * */
    public static String getPatientLabelHistoryId(){
        return StrUtil.format("PLH{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static PatientLabelVO getPatientLabelVO(PatientLabelInfo entity) {
        PatientLabelVO vo = new PatientLabelVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static PatientLabelHistoryVO getPatientLabelHistoryVO(PatientLabelHistoryInfo entity) {
        PatientLabelHistoryVO vo = new PatientLabelHistoryVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static PatientLabelBO getPatientLabelBO(PatientLabelVO entity) {
        PatientLabelBO vo = new PatientLabelBO();
        BeanUtil.copyProperties(entity, vo);

        LabelBO labelBO = entity.getLabelBO();
        if (null != labelBO) {
            vo.setLabelName(labelBO.getName());
            vo.setCategoryId(labelBO.getCategoryId());
            vo.setDiseaseIds(labelBO.getDiseaseIds());
            vo.setStatDimensionType(labelBO.getStatDimensionType());
            vo.setDiseaseList(labelBO.getDiseaseList());
            vo.setBizType(labelBO.getBizType());
            
            LabelCategoryBO labelCategoryBO = labelBO.getLabelCategoryInfo();
            if (null != labelCategoryBO) {
                vo.setLabelCategoryName(labelCategoryBO.getName());
            }
        }

        PatientClientBO patientBO = entity.getPatientInfo();
        if (null != patientBO) {
            vo.setPatientName(patientBO.getPatientName());
            vo.setPatientGenderStandard(patientBO.getPatientGenderStandard());
            vo.setBirthday(patientBO.getBirthday());
            vo.setPhone(patientBO.getPhone());
            vo.setAge(patientBO.getAge());
            vo.setDeathStatus(patientBO.getDeathStatus());
            vo.setDeathTime(patientBO.getDeathTime());
        }

        return vo;
    }

    public static PatientLabelHistoryBO getPatientLabelHistoryBO(PatientLabelHistoryVO entity) {
        PatientLabelHistoryBO vo = new PatientLabelHistoryBO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

}
