package com.xxh.cloud.healthy.serve.label.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientDiseaseVO;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 20231023
 */
public interface PatientLabelExpireMapper {
    
    /** 查询患者标签相关的病种 */
    // 生产环境数据量大无法使用
    @Select("select pl.patient_id, lb.disease_ids, dis.id as disease_id, dept.id as dept_id from s_md_standard_label_info lb " +
            "INNER JOIN h_patient_label_info pl on lb.id = pl.label_id " +
            "INNER JOIN s_md_standard_disease_info dis on lb.disease_ids like CONCAT('%,', dis.id ,',%') " +
            "INNER JOIN sys_dept dept on dept.disease_ids like CONCAT('%,', dis.id ,',%') ${ew.customSqlSegment} ")
    List<PatientDiseaseVO> queryPatientDept(@Param(Constants.WRAPPER) Wrapper<String> wrapper);

    /** 查询标签id */
    @Select("select id from s_md_standard_label_info ${ew.customSqlSegment} ")
    List<String> queryStandardLabel(@Param(Constants.WRAPPER) Wrapper<String> wrapper);

    /** 查询用户现有标签关联的 */
    @Select(" select dl.dept_id from h_patient_label_info pl inner join hd_task_dept_label_relation_info dl on pl.label_id = dl.label_id" +
            " ${ew.customSqlSegment} ")
    List<String> queryDeptByPatientLabel(@Param(Constants.WRAPPER) Wrapper<String> wrapper);

    @InterceptorIgnore(blockAttack = "true")
    @Delete("delete from hd_task_dept_label_relation_info")
    int deleteDeptLabelRelationAll();

    @InterceptorIgnore(blockAttack = "true")
    @Delete("delete from hd_task_dept_patient_relation_info ${ew.customSqlSegment}")
    int deleteDeptPatientRelationAll(@Param(Constants.WRAPPER) Wrapper<String> wrapper);

//    /** 病种相关的部门 */
//    @Select("select id from sys_dept ${ew.customSqlSegment} ")
//    List<String > queryDeptDisease(@Param(Constants.WRAPPER) Wrapper<String> wrapper);



}