package com.xxh.cloud.healthy.serve.label.framework.modules.biz.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelHistoryInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.LabelPatientDataAddBatchDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.LabelPatientDataHistogramVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.LabelPatientDataVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelInfoVO;

import java.util.List;

import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelSimpleVO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

public interface PatientLabelMapper {
    
    @Select("  SELECT label_id AS labelId, COUNT(1) patientNum " + 
            "  FROM ( " +
            "    SELECT DISTINCT a.patient_id, a.label_id " +
            "    FROM h_patient_label_info a " +
            "    INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id  " +
            "  ) c " +
            "  GROUP BY label_id ")
    List<LabelPatientDataAddBatchDTO> labelPatientCount();
    
    @Select("  SELECT c.label_id labelId, c.date date, COUNT(1) patientNum " + 
            "  FROM ( " +
            "    SELECT DISTINCT a.patient_id, a.label_id, DATE_FORMAT(a.data_dt, '%Y-%m-%d') date " +
            "    FROM h_patient_label_info a " +
            "    INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id  " +
            "    ${ew.customSqlSegment} " + 
            "  ) c " + 
            "  GROUP BY c.label_id, c.date ")
    List<LabelPatientDataHistogramVO> queryPatientLabelList(@Param(Constants.WRAPPER) Wrapper<PatientLabelInfo> wrapper);

    // @Select("  SELECT DISTINCT a.patient_id, a.label_id " + 
    //         "  FROM h_patient_label_history_info a " +
    //         "  INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id  " +
    //         "  ${ew.customSqlSegment} ")
    // IPage<PatientLabelHistoryInfo> queryPatientHistoryLabel(Page<PatientLabelInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientLabelHistoryInfo> wrapper);
    @Select("  SELECT a.patient_id, a.label_id, MAX(a.data_dt) dataDt, MAX(a.op_date) opDate " + 
            "  FROM h_patient_label_history_info a " +
            "  INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id  " +
            "  ${ew.customSqlSegment} " +
            "  GROUP BY a.patient_id, a.label_id ")
    IPage<PatientLabelHistoryInfo> queryPatientHistoryLabel(Page<PatientLabelInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientLabelHistoryInfo> wrapper);

    @Select("  SELECT c.label_id labelId, c.date date, COUNT(1) patientNum " + 
            "  FROM ( " +
            "    SELECT DISTINCT a.patient_id, a.label_id, DATE_FORMAT(a.op_date, '%Y-%m-%d') date " +
            "    FROM h_patient_label_history_info a " +
            "    INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id  " +
            "    ${ew.customSqlSegment} " + 
            "  ) c " + 
            "  GROUP BY c.label_id, c.date ")
    List<LabelPatientDataHistogramVO> queryPatientHistoryLabelList(@Param(Constants.WRAPPER) Wrapper<PatientLabelHistoryInfo> wrapper);

    @Select("  SELECT a.id, a.patient_id AS patientId, a.label_id AS labelId, a.remark, a.create_date AS createDate, a.source_type AS sourceType, a.source_rel_id AS sourceRelId, " + 
            "  a.source_rel_two_id AS sourceRelTwoId, a.data_dt AS dataDt, a.extend1, a.extend2, a.extend3, a.extend4, b.patient_name AS patientName, " + 
            "  b.patient_gender_standard AS patientGenderStandard, b.id_card_no AS idCardNo, b.birthday, b.phone, b.data_update_date AS dataUpdateDate   " +
            "  FROM h_patient_label_info a " +
            "  INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id " +
            "  ${ew.customSqlSegment} ")
    IPage<PatientLabelInfoVO>  patientPageByLabel(Page<PatientLabelInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientLabelInfo> wrapper);

    @Select("  SELECT a.id, a.patient_id AS patientId, a.label_id AS labelId, a.op_date AS createDate, a.source_type AS sourceType, a.source_rel_id AS sourceRelId, " + 
            "  a.source_rel_two_id AS sourceRelTwoId, a.data_dt AS dataDt, a.extend1, a.extend2, a.extend3, a.extend4, b.patient_name AS patientName, " + 
            "  b.patient_gender_standard AS patientGenderStandard, b.id_card_no AS idCardNo, b.birthday, b.phone, b.data_update_date AS dataUpdateDate   " +
            "  FROM h_patient_label_history_info a " +
            "  INNER JOIN hd_task_patient_info b ON a.patient_id = b.patient_id " +
            "  ${ew.customSqlSegment} ")
    IPage<PatientLabelInfoVO>  patientPageByHistoryLabel(Page<PatientLabelInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientLabelInfo> wrapper);




    // 活动
    
    // 聚合活动标签统计其患者数量
    @Select("  SELECT a.label_id labelId, COUNT(1) patientNum " + 
            "  FROM h_patient_label_history_info a " +
            "  INNER JOIN s_md_standard_label_info b ON a.label_id = b.id  " +
            "  ${ew.customSqlSegment} " +
            "  GROUP BY b.id ")
    IPage<LabelPatientDataVO> queryHistoryLabelPatientCount(Page<PatientLabelHistoryInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientLabelHistoryInfo> wrapper);


    // 查询需要发送给病种负责人的患者标签
    @Select(" select p.id, p.patient_id, pa.patient_name, p.label_id, l.name as label_name, l.label_manager, l.label_remind_status, l.remark as labelRemark, l.disease_ids, l.label_assistant, l.label_dept_manager " +
            " from h_patient_label_info p inner join s_md_standard_label_info l on p.label_id = l.id " +
            " inner join hd_task_patient_info pa on p.patient_id = pa.patient_id " +
            " ${ew.customSqlSegment} ")
    List<PatientLabelSimpleVO> selectPatientLabel(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);


}