package com.xxh.cloud.healthy.serve.label.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelAddBatchDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelAddDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelDelDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelDirectRemoveDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelRemoveDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelSaveDTO;

public interface PatientLabelBizService {

    /**
     * 添加患者标签，标签批量，有效期一致
     * */
    public void addLabel(PatientLabelAddDTO params);

    /**
     * 批量添加患者标签，标签与有效期匹配
     * */
    public void addBatchLabel(PatientLabelAddBatchDTO params);

    /**
     * 移除患者标签
     * */
    public void removeBatchLabel(PatientLabelRemoveDTO params);

    // zs20231101
    // 批量为患者添加标签
    public void saveLabelBatch(List<PatientLabelSaveDTO> params);
    // 批量为患者删除标签
    public void delLabelBatch(List<PatientLabelDelDTO> params);

    // 通过id移除患者标签
    public void removeBatchLabelByIds(List<String> ids);

    // 保存历史标签
    public void saveHistoryLabelBatch(List<PatientLabelSaveDTO> params);


    
    // 202312141624 物理删除用户当前标签
    void directDelNowPatientLabelBatch(PatientLabelDirectRemoveDTO params);

    // 202312141624 物理删除用户历史标签
    void directDelHistoryPatientLabelBatch(PatientLabelDirectRemoveDTO params);

}
