package com.xxh.cloud.healthy.serve.label.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.LabelPatientDataHistogramDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientByLabelQueryParam;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelQueryParam;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.LabelPatientDataHistogramVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelHistoryVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelVO;

// zs:2023-09-18
public interface PatientLabelQueryService {

    //// 当前标签

    PageData<PatientLabelVO> page(PatientLabelQueryParam params);

    List<PatientLabelVO> list(PatientLabelQueryParam params);

    // 查询患者身上的标签
    PageData<LabelBO> labelPageByPatient(PatientLabelQueryParam params);

    // 查询标签上的患者
    PageData<PatientLabelVO> patientPageByLabel(PatientByLabelQueryParam params);



    /// 历史标签
    
    List<PatientLabelHistoryVO> historyList(PatientLabelQueryParam params);
    
    PageData<PatientLabelHistoryVO> historyPage(PatientLabelQueryParam params);


    // 查询患者身上的历史标签
    PageData<LabelBO> historyLabelPageByPatient(PatientLabelQueryParam params);
    
    List<PatientLabelHistoryVO> historyLabelPageByPatientList(PatientLabelQueryParam params);

    // 查询标签上的历史患者
    PageData<PatientClientBO> historyPatientPageByLabel(PatientLabelQueryParam params);

    // 查询标签上的患者
    PageData<PatientLabelHistoryVO> patientPageByHistoryLabel(PatientByLabelQueryParam params);


    // 按时间统计标签用户数量
    List<LabelPatientDataHistogramVO> historyHistogramList(LabelPatientDataHistogramDTO params);

}
