package com.xxh.cloud.healthy.serve.label.framework.modules.biz.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientRecordDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientRecordVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.mapper.DwdPatientReportMapper;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.service.DwdPatientRecordBizService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Slf4j
@Service
public class DwdPatientRecordBizServiceImpl implements DwdPatientRecordBizService {
    
    @Autowired
    private DwdPatientReportMapper dwdPatientReportMapper;

    @Override
    public List<PatientRecordVO> selectPatientReport(PatientRecordDTO params) {
        List<PatientRecordVO> list = dwdPatientReportMapper.selectPatientReport(new QueryWrapper<PatientRecordVO>()
                .eq(StrUtil.isNotEmpty(params.getPatientId()),"patient_id", params.getPatientId())
                .ge(null != params.getStartDate(), "record_date", params.getStartDate())
                .lt(null != params.getEndDate(), "record_date", params.getEndDate())
                .orderByDesc("record_date")
        );
        return list;
    }

}
