package com.xxh.cloud.healthy.serve.label.framework.modules.biz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.basic.label.client.api.LabelClientService;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.healthy.basic.label.client.api.bean.dto.LabelQueryPageDTO;
import com.xxh.cloud.healthy.crm.client.api.PatientDoctorRelationClientService;
import com.xxh.cloud.healthy.crm.client.api.bean.bo.PatientDoctorRelationBO;
import com.xxh.cloud.healthy.crm.client.api.bean.dto.PatientDoctorRelQueryClientDTO;
import com.xxh.cloud.healthy.data.client.api.DoctorFollowPatientClientService;
import com.xxh.cloud.healthy.data.client.api.DoctorManagePatientClientService;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DataDwsPatientDataLastDateBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorDwdPatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorFollowPatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.DoctorManagePatientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DoctorFollowPatientListClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.DoctorManagePatientQueryClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientLastDataQueryDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.doctor.crm.client.api.DoctorBehaviorClientService;
import com.xxh.cloud.healthy.doctor.crm.client.api.DoctorPatientRemarkClientService;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorBehaviorDataCountBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.bo.DoctorPatientRemarkBO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.dto.DoctorBehaviorDataCountQueryClientDTO;
import com.xxh.cloud.healthy.doctor.crm.client.api.bean.dto.DoctorPatientRemarkQueryClientDTO;
import com.xxh.cloud.healthy.doctor.crm.client.api.constant.DoctorBehaviorConstant;
import com.xxh.cloud.healthy.doctor.crm.client.api.constant.DoctorRemarkConstant;
import com.xxh.cloud.healthy.mdt.api.ConsultationClientService;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelHistoryInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.entity.PatientLabelInfo;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.service.PatientLabelHistoryInfoService;
import com.xxh.cloud.healthy.serve.label.framework.modules.base.service.PatientLabelInfoService;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.LabelPatientDataHistogramDTO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientByLabelQueryParam;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.dto.PatientLabelQueryParam;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.LabelPatientDataHistogramVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelHistoryVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelInfoVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.bean.vos.PatientLabelVO;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.helper.PatientLabelHelper;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.mapper.PatientLabelMapper;
import com.xxh.cloud.healthy.serve.label.framework.modules.biz.service.PatientLabelQueryService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class PatientLabelQueryServiceImpl implements PatientLabelQueryService {

    @Autowired
    private PatientLabelInfoService patientLabelInfoService;
    @Autowired
    private PatientLabelHistoryInfoService patientLabelHistoryInfoService;
    @Autowired
    private LabelClientService labelClientService;
    @Autowired
    private PatientClientService patientClientService;
    @Autowired
    private PatientLabelMapper patientLabelMapper;
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private DoctorBehaviorClientService doctorBehaviorClientService;
    @Autowired
    private DoctorPatientRemarkClientService doctorPatientRemarkClientService;
    @Autowired
    private ConsultationClientService consultationClientService;
    @Autowired
    private DoctorFollowPatientClientService doctorFollowPatientClientService;
    @Autowired
    private DoctorManagePatientClientService doctorManagePatientClientService;
    @Autowired
    private PatientDoctorRelationClientService patientDoctorRelationClientService;

    @Override
    public PageData<PatientLabelVO> page(PatientLabelQueryParam params) {
        IPage<PatientLabelInfo> page = patientLabelInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelInfo>()
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .orderByDesc("create_date")
        );

        PageData<PatientLabelVO> data = new PageConverter<PatientLabelInfo, PatientLabelVO>() {
            @Override
            public PatientLabelVO converter(PatientLabelInfo entity) {
                return PatientLabelHelper.getPatientLabelVO(entity);
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<PatientLabelVO> list(PatientLabelQueryParam params) {
        List<PatientLabelInfo> list = patientLabelInfoService.list(new QueryWrapper<PatientLabelInfo>()
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getLabelIds()), "label_id", params.getLabelIds())
            .lt(null != params.getIsExpire() && params.getIsExpire(), "validity_value", DateUtil.date().toString())
            .in(CollectionUtil.isNotEmpty(params.getQueryParams()), "CONCAT(patient_id, '-', label_id, '-', source_type)", params.getQueryParams())
            .orderByDesc("create_date")
            .last(" limit 1000 ")
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(PatientLabelHelper::getPatientLabelVO).collect(Collectors.toList());
    }

    @Override
    public PageData<LabelBO> labelPageByPatient(PatientLabelQueryParam params) {
        // 查询所有用户所有
        PageData<PatientLabelVO> page = this.page(params);
        if (CollectionUtil.isEmpty(page.getList())) {
            return new PageData<>(null, 0);
        }

        // 查询标签详情
        List<String> labelIds = new ArrayList<>();
        page.getList().forEach(i -> labelIds.add(i.getLabelId()));
        LabelQueryPageDTO labelQueryPageDTO = new LabelQueryPageDTO();
        labelQueryPageDTO.setIds(labelIds);
        labelQueryPageDTO.setBizType(params.getBizType());
        labelQueryPageDTO.setBizTypes(params.getBizTypes());
        labelQueryPageDTO.setStatDimensionType(params.getStatDimensionType());
        labelQueryPageDTO.setStatDimensionTypes(params.getStatDimensionTypes());
        labelQueryPageDTO.setDiseaseId(params.getDiseaseId());
        labelQueryPageDTO.setDiseaseIds(params.getDiseaseIds());
        labelQueryPageDTO.setDiseaseQueryMode(params.getDiseaseQueryMode());
        labelQueryPageDTO.setBizTwoType(params.getBizTwoType());
        labelQueryPageDTO.setBizTwoTypes(params.getBizTwoTypes());
        labelQueryPageDTO.setBizThreeType(params.getBizThreeType());
        labelQueryPageDTO.setBizThreeTypes(params.getBizThreeTypes());
        labelQueryPageDTO.setIsPortrait(params.getIsPortrait());
        List<LabelBO> labelBOs = labelClientService.queryList(labelQueryPageDTO);
        return new PageData<>(labelBOs, page.getTotal(), page.getSize(), page.getPages());
    }
    
    @Override
    public PageData<PatientLabelVO> patientPageByLabel(PatientByLabelQueryParam params) {
        // if (StrUtil.isBlank(params.getLabelId()) || StrUtil.isBlank(params.getDoctorId())) {
        //     return new PageData<>(null, 0);
        // }
        //如果标签id为空则直接返回空
        //如果标签id不为空，但是医生id为空也不行
        //必须同时写标签id和医生id
        if ((StrUtil.isBlank(params.getLabelId()) && CollectionUtil.isEmpty(params.getLabelIds())) || StrUtil.isBlank(params.getDoctorId())) {
            return new PageData<>(null, 0);
        }

        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        // TODO 可以根据科室筛选患者最新数据
        // TODO 1.根据科室名称模糊查询所有科室；2.根据科室查询患者最新数据信息；3.整理出患者id列表进行接下来的查询

        IPage<PatientLabelInfoVO> page = patientLabelMapper.patientPageByLabel(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelInfo>()
            .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "a.label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getLabelIds()), "a.label_id", params.getLabelIds())
            .like(StrUtil.isNotBlank(params.getPatientName()), "b.patient_name", params.getPatientName())
            .eq(StrUtil.isNotBlank(params.getPatientGender()), "b.patient_gender_standard", params.getPatientGender())
            .ge(null != params.getStartDate(), "a.data_dt", params.getStartDate())
            .lt(null != params.getEndDate(), "a.data_dt", params.getEndDate())
            .orderByDesc("a.data_dt")
        );

        if (page == null || CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        //患者id
        List<String> patientIds = new ArrayList<>();
        //标签id
        List<String> labelIds = new ArrayList<>();
        //id
        Set<String> patientLabelIds = new HashSet<>();
        page.getRecords().forEach(i -> {
            patientIds.add(i.getPatientId());
            labelIds.add(i.getLabelId());
            patientLabelIds.add(i.getId());
        });

        // 标签
        Map<String, LabelBO> labelMap = labelClientService.getLabelMapByIds(labelIds);
        
        // 查询患者最新数据变化信息
        Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap = dwdDataPatientClientService.mapPatientDataLastDateInfo(patientIds);

        // 查询医生操作数据
        Map<String, List<DoctorBehaviorDataCountBO>> behaviorDataMap = new HashMap<>();

        DoctorBehaviorDataCountQueryClientDTO behaviorCount = new DoctorBehaviorDataCountQueryClientDTO();
        behaviorCount.setDoctorId(params.getDoctorId());
        behaviorCount.setRelOneType(DoctorBehaviorConstant.RelOneType.Label_Patient.getCode());
        behaviorCount.setRelOneIds(patientIds);
        behaviorCount.setRelTwoType(DoctorBehaviorConstant.RelTwoType.Label.getCode());
        behaviorCount.setRelTwoId(params.getLabelId());
        List<DoctorBehaviorDataCountBO> behaviorDataCountList = doctorBehaviorClientService.getBehaviorDataCount(behaviorCount);
        behaviorDataCountList.forEach(i -> {
            List<DoctorBehaviorDataCountBO> bos = behaviorDataMap.get(i.getDoctorId() + "-" + i.getRelOneId());
            if (null == bos) {
                bos = new ArrayList<>();
                behaviorDataMap.put(i.getDoctorId() + "-" + i.getRelOneId(), bos);
            }
            bos.add(i);
        });

        // 查询医生最后备注数据
        Map<String, List<DoctorPatientRemarkBO>> remarkMap = new HashMap<>();
        DoctorPatientRemarkQueryClientDTO remarkQueryClientDTO = new DoctorPatientRemarkQueryClientDTO();
        remarkQueryClientDTO.setDoctorId(params.getDoctorId());
        remarkQueryClientDTO.setPatientId(params.getPatientId());
        remarkQueryClientDTO.setRelOneType(DoctorRemarkConstant.RelOneType.Label_Patient.getCode());
        remarkQueryClientDTO.setRelOneId(params.getLabelId());
        List<DoctorPatientRemarkBO> remarkList = doctorPatientRemarkClientService.list(remarkQueryClientDTO);
        remarkList.forEach(i -> {
            List<DoctorPatientRemarkBO> bos = remarkMap.get(i.getDoctorId() + "-" + i.getPatientId());
            if (null == bos) {
                bos = new ArrayList<>();
                remarkMap.put(i.getDoctorId() + "-" + i.getPatientId(), bos);
            }
            bos.add(i);
        });

        // 查询患者最新mdt会诊信息
        Map<String, ConsultationBO> mdtMap = consultationClientService.lastMdtSimpleMap(patientIds);

        // 查询患者最新就诊数据
        Map<String, PatientVisitRecordClientBO> visitMap = dwdDataPatientClientService.mapPatientVisitLastDateInfo(patientIds);

        // 查询患者最新住院数据
        PatientLastDataQueryDTO patientLastDataQueryDTO = new PatientLastDataQueryDTO();
        patientLastDataQueryDTO.setPatientIds(patientIds);
        Map<String, PatientInpatientRecordClientBO> inPatientMap = dwdDataPatientClientService.mapPatientInpatientLastDateInfo(patientLastDataQueryDTO);

        // 查询患者最新出院数据
        Map<String, PatientDischargeRecordClientBO> outPatientMap = dwdDataPatientClientService.mapPatientOutpatientLastDateInfo(patientIds);

        // 患者是否去世
        Map<String, DoctorDwdPatientBO> patientClientBOMap = new HashMap<>();
        List<DoctorDwdPatientBO> patientClientBOList = dwdDataPatientClientService.queryPatientList(patientIds);
        if (CollectionUtil.isNotEmpty(patientClientBOList)) {
            patientClientBOList.forEach(i -> patientClientBOMap.put(i.getPatientId(), i));
        }

        // 是否关注患者
        Map<String, String> followMap = new HashMap<>();
        DoctorFollowPatientListClientDTO followDTO = new DoctorFollowPatientListClientDTO();
        followDTO.setDoctorId(params.getDoctorId());
        followDTO.setPatientIds(patientIds);
        List<DoctorFollowPatientBO> followList = doctorFollowPatientClientService.simpleList(followDTO);
        if (CollUtil.isNotEmpty(followList)) {
            followList.forEach(i -> followMap.put(i.getPatientId(), i.getStatus()));
        }

        // 是否排除/加入管理
        Map<String, DoctorManagePatientBO> doctorManagePatientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            DoctorManagePatientQueryClientDTO doctorManagePatientQueryClientDTO = new DoctorManagePatientQueryClientDTO();
            doctorManagePatientQueryClientDTO.setDoctorId(params.getDoctorId());
            doctorManagePatientQueryClientDTO.setPatientIds(patientIds);
            List<DoctorManagePatientBO> doctorManagePatientList = doctorManagePatientClientService.simpleList(doctorManagePatientQueryClientDTO);
            if (CollUtil.isNotEmpty(doctorManagePatientList)) {
                doctorManagePatientList.forEach(i -> doctorManagePatientMap.put(i.getPatientId() + "-" + i.getLabelId(), i));
            }
        }

        // 个案管理
        Map<String, PatientDoctorRelationBO> crmMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientDoctorRelQueryClientDTO patientDoctorRelQueryClientDTO = new PatientDoctorRelQueryClientDTO();
            patientDoctorRelQueryClientDTO.setDoctorId(params.getDoctorId());
            patientDoctorRelQueryClientDTO.setSourceType("patient_label"); // PatientDoctorRelationSourceTypeEnum.PDRS_PatientLabel
            patientDoctorRelQueryClientDTO.setSourceObjIds(patientLabelIds);
            List<PatientDoctorRelationBO> crmList = patientDoctorRelationClientService.queryPatientDoctorRelList(patientDoctorRelQueryClientDTO);
            if (CollUtil.isNotEmpty(crmList)) {
                crmList.forEach(i ->{
                    if (!crmMap.containsKey(i.getPatientId())) {
                        crmMap.put(i.getPatientId(), i);
                    }});
            }
        }

        PageData<PatientLabelVO> data = new PageConverter<PatientLabelInfoVO, PatientLabelVO>() {
            @Override
            public PatientLabelVO converter(PatientLabelInfoVO entity) {
                PatientLabelVO patientLabelVO = new PatientLabelVO();
                BeanUtil.copyProperties(entity, patientLabelVO);

                PatientClientBO patientClientBO = new PatientClientBO();
                BeanUtil.copyProperties(entity, patientClientBO);
                patientClientBO.setAge(getAge(entity.getIdCardNo(), entity.getBirthday()));

                // 患者是否去世
                patientClientBO.setDeathStatus(YN.YES.getCode());
                DoctorDwdPatientBO dwdPatient = patientClientBOMap.get(entity.getPatientId());
                if (null != dwdPatient && YN.NO.getCode().equals(dwdPatient.getDeathStatus())) {
                    patientClientBO.setDeathStatus(dwdPatient.getDeathStatus());
                    patientClientBO.setDeathTime(dwdPatient.getDeathTime());
                    if (StrUtil.isNotBlank(dwdPatient.getDeathTime())) {
                        if (dwdPatient.getDeathTime().length() == 12) {
                            patientClientBO.setDeathTime(DateUtil.parse(dwdPatient.getDeathTime(), "yyyyMMddHHmm").toString());
                        }
                        if (dwdPatient.getDeathTime().length() == 14) {
                            patientClientBO.setDeathTime(DateUtil.parse(dwdPatient.getDeathTime(), "yyyyMMddHHmmss").toString());
                        }
                    }
                }

                patientLabelVO.setPatientInfo(patientClientBO);

                patientLabelVO.setPatientDataLastDateInfo(patientDataLastDateMap.get(entity.getPatientId()));

                patientLabelVO.setDoctorBehaviorDataCountList(behaviorDataMap.get(params.getDoctorId() + "-" + patientLabelVO.getPatientId()));

                List<DoctorPatientRemarkBO> remarks = remarkMap.get(params.getDoctorId() + "-" + patientLabelVO.getPatientId());
                if (CollectionUtil.isNotEmpty(remarks)) {
                    patientLabelVO.setDoctorPatientRemarkList(remarks);
                    patientLabelVO.setDoctorPatientRemarkLast(remarks.get(0));
                }

                // 最新MDT
                patientLabelVO.setMdtConsultationInfo(mdtMap.get(entity.getPatientId()));

                // 最新就诊
                patientLabelVO.setVisitInfo(visitMap.get(entity.getPatientId()));

                // 最新住院
                patientLabelVO.setInpatientInfo(inPatientMap.get(entity.getPatientId()));

                // 最新出院
                // patientLabelVO.setOutpatientInfo(outPatientMap.get(entity.getPatientId()));
                PatientDischargeRecordClientBO patientDischargeRecordClientBO = outPatientMap.get(entity.getPatientId());
                if (null != patientDischargeRecordClientBO) {
                    patientDischargeRecordClientBO.setContent(null);
                    patientDischargeRecordClientBO.setDiagnosisRaw(null);
                    patientLabelVO.setOutpatientInfo(patientDischargeRecordClientBO);
                }

                // 标签信息
                patientLabelVO.setLabelBO(labelMap.get(entity.getLabelId()));

                // 是否医生关注该患者
                patientLabelVO.setFollowStatus(followMap.get(entity.getPatientId()));

                // 管理患者信息（排除/加入管理）
                patientLabelVO.setManagePatientInfo(doctorManagePatientMap.get(entity.getPatientId() + "-" + entity.getLabelId()));

                // 个案
                patientLabelVO.setCrmStatus(YN.NO.getCode());
                if (crmMap.containsKey(patientLabelVO.getPatientId())) {
                    PatientDoctorRelationBO crm = crmMap.get(patientLabelVO.getPatientId());
                    patientLabelVO.setCrmStatus(YN.YES.getCode());
                    patientLabelVO.setCrmRelStatus(crm.getState());
                } else {
                    patientLabelVO.setCrmStatus(YN.NO.getCode());
                }

                return patientLabelVO;
            }
        }.getPageData(page);
        return data;
    }

    private String getAge(String idcard, String birthday) {
        String age = null;
        if (StrUtil.isNotBlank(birthday)) {
            try {
                age = String.valueOf(DateUtil.betweenYear(DateUtil.parseDate(birthday), DateUtil.date(), false));
            } catch (Exception e) {
                log.info("解析出生年月转年龄错误");
                e.printStackTrace();
            }
            // 0岁的用月来表示年龄
            if (StrUtil.isNotBlank(age) && "0".equals(age)) {
                age = String.valueOf(DateUtil.betweenMonth(DateUtil.parseDate(birthday), DateUtil.date(), false) + 1) + "个月";
            }
        }
        if (null == age && StrUtil.isNotBlank(idcard)) {
            try {
                age = String.valueOf(IdcardUtil.getAgeByIdCard(idcard));
            } catch (Exception e) {
                log.info("解析身份证号转年龄错误");
                e.printStackTrace();
            }
            // 0岁的用月来表示年龄
            if (StrUtil.isNotBlank(age) && "0".equals(age)) {
                age = String.valueOf(DateUtil.betweenMonth(IdcardUtil.getBirthDate(idcard), DateUtil.date(), false) + 1) + "个月";
            }
        }
        
        return age;
    }

    @Override
    public List<PatientLabelHistoryVO> historyList(PatientLabelQueryParam params) {
        List<PatientLabelHistoryInfo> list = patientLabelHistoryInfoService.list(new QueryWrapper<PatientLabelHistoryInfo>()
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getLabelIds()), "label_id", params.getLabelIds())
            // .and(CollectionUtil.isNotEmpty(params.getDiseaseIds()), i -> {
            //     params.getDiseaseIds().forEach(item -> {
            //         i.or().like("disease_ids", "," +item + ",");
            //     });
            // })
            .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
            .in(CollectionUtil.isNotEmpty(params.getQueryParams()), "CONCAT(patient_id, '-', label_id, '-', source_type, '-', source_rel_id, '-', data_dt)", params.getQueryParams())
            .ge(null != params.getStartDate(), "data_dt", params.getStartDate())
            .lt(null != params.getEndDate(), "data_dt", params.getEndDate())
            .orderByDesc("op_date")
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(PatientLabelHelper::getPatientLabelHistoryVO).collect(Collectors.toList());
    }

    @Override
    public PageData<PatientLabelHistoryVO> historyPage(PatientLabelQueryParam params) {
        IPage<PatientLabelHistoryInfo> page = patientLabelHistoryInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelHistoryInfo>()
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .orderByDesc("op_date")
        );

        PageData<PatientLabelHistoryVO> data = new PageConverter<PatientLabelHistoryInfo, PatientLabelHistoryVO>() {
            @Override
            public PatientLabelHistoryVO converter(PatientLabelHistoryInfo entity) {
                return PatientLabelHelper.getPatientLabelHistoryVO(entity);
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public PageData<LabelBO> historyLabelPageByPatient(PatientLabelQueryParam params) {
        // 查询所有用户所有
        IPage<PatientLabelHistoryInfo> page = patientLabelMapper.queryPatientHistoryLabel(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelHistoryInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "a.label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
        );
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        // 查询标签详情
        List<String> labelIds = new ArrayList<>();
        page.getRecords().forEach(i -> labelIds.add(i.getLabelId()));
        LabelQueryPageDTO labelQueryPageDTO = new LabelQueryPageDTO();
        labelQueryPageDTO.setIds(labelIds);
        labelQueryPageDTO.setBizType(params.getBizType());
        labelQueryPageDTO.setBizTypes(params.getBizTypes());
        labelQueryPageDTO.setStatDimensionType(params.getStatDimensionType());
        labelQueryPageDTO.setStatDimensionTypes(params.getStatDimensionTypes());
        labelQueryPageDTO.setDiseaseId(params.getDiseaseId());
        labelQueryPageDTO.setDiseaseIds(params.getDiseaseIds());
        labelQueryPageDTO.setDiseaseQueryMode(params.getDiseaseQueryMode());
        labelQueryPageDTO.setBizTwoType(params.getBizTwoType());
        labelQueryPageDTO.setBizTwoTypes(params.getBizTwoTypes());
        labelQueryPageDTO.setBizThreeType(params.getBizThreeType());
        labelQueryPageDTO.setBizThreeTypes(params.getBizThreeTypes());
        List<LabelBO> labelBOs = labelClientService.queryList(labelQueryPageDTO);
        return new PageData<>(labelBOs, page.getTotal(), page.getSize(), page.getPages());
    }

    @Override
    public List<PatientLabelHistoryVO> historyLabelPageByPatientList(PatientLabelQueryParam params) {
        // 查询所有用户所有
        List<PatientLabelHistoryInfo> list = patientLabelHistoryInfoService.list(new QueryWrapper<PatientLabelHistoryInfo>()
            .eq("op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getLabelIds()), "label_id", params.getLabelIds())
            .eq(null != params.getDataDt(), "data_dt", params.getDataDt())
            .last(" limit 1000 ")
        );
        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        // 查询标签详情
        Map<String, LabelBO> labelMap = new HashMap<>();
        List<String> labelIds = new ArrayList<>();
        list.forEach(i -> labelIds.add(i.getLabelId()));
        if (CollectionUtil.isNotEmpty(labelIds)) {
            LabelQueryPageDTO labelQueryPageDTO = new LabelQueryPageDTO();
            labelQueryPageDTO.setIds(labelIds);
            labelQueryPageDTO.setBizType(params.getBizType());
            labelQueryPageDTO.setBizTypes(params.getBizTypes());
            labelQueryPageDTO.setStatDimensionType(params.getStatDimensionType());
            labelQueryPageDTO.setStatDimensionTypes(params.getStatDimensionTypes());
            labelQueryPageDTO.setDiseaseId(params.getDiseaseId());
            labelQueryPageDTO.setDiseaseIds(params.getDiseaseIds());
            labelQueryPageDTO.setDiseaseQueryMode(params.getDiseaseQueryMode());
            labelQueryPageDTO.setBizTwoType(params.getBizTwoType());
            labelQueryPageDTO.setBizTwoTypes(params.getBizTwoTypes());
            labelQueryPageDTO.setBizThreeType(params.getBizThreeType());
            labelQueryPageDTO.setBizThreeTypes(params.getBizThreeTypes());
            List<LabelBO> labelBOs = labelClientService.queryList(labelQueryPageDTO);
            if (CollectionUtil.isNotEmpty(labelBOs)) {
                labelBOs.forEach(i -> labelMap.put(i.getId(), i));
            }
        }

        return list.stream().map(i -> {
            PatientLabelHistoryVO vo = PatientLabelHelper.getPatientLabelHistoryVO(i);
            vo.setLabelInfo(labelMap.get(vo.getLabelId()));
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public PageData<PatientClientBO> historyPatientPageByLabel(PatientLabelQueryParam params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        // 查询所有用户所有
        IPage<PatientLabelHistoryInfo> page = patientLabelMapper.queryPatientHistoryLabel(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelHistoryInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "a.label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
            .ge(null != params.getStartDate(), "a.op_date", params.getStartDate())
            .lt(null != params.getEndDate(), "a.op_date", params.getEndDate())
        );
        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        // 查询患者详情
        List<String> patientIds = new ArrayList<>();
        page.getRecords().forEach(i -> patientIds.add(i.getPatientId()));
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientIds(patientIds);
        List<PatientClientBO> patientBOs = patientClientService.simpleList(patientQueryDTO);
        return new PageData<>(patientBOs, page.getTotal(), page.getSize(), page.getPages());
    }

    @Override
    public PageData<PatientLabelHistoryVO> patientPageByHistoryLabel(PatientByLabelQueryParam params) {
        // if (StrUtil.isBlank(params.getLabelId()) || StrUtil.isBlank(params.getDoctorId())) {
        //     return new PageData<>(null, 0);
        // }
        if ((StrUtil.isBlank(params.getLabelId()) && CollectionUtil.isEmpty(params.getLabelIds())) || StrUtil.isBlank(params.getDoctorId())) {
            return new PageData<>(null, 0);
        }

        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        // TODO 可以根据科室筛选患者最新数据
        // TODO 1.根据科室名称模糊查询所有科室；2.根据科室查询患者最新数据信息；3.整理出患者id列表进行接下来的查询

        IPage<PatientLabelInfoVO> page = patientLabelMapper.patientPageByHistoryLabel(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientLabelInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "a.label_id", params.getLabelId())
            .in(CollectionUtil.isNotEmpty(params.getLabelIds()), "a.label_id", params.getLabelIds())
            .like(StrUtil.isNotBlank(params.getPatientName()), "b.patient_name", params.getPatientName())
            .eq(StrUtil.isNotBlank(params.getPatientGender()), "b.patient_gender_standard", params.getPatientGender())
            .ge(null != params.getStartDate(), "a.data_dt", params.getStartDate())
            .lt(null != params.getEndDate(), "a.data_dt", params.getEndDate())
            .orderByDesc("a.data_dt")
        );

        if (page == null || CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        List<String> patientIds = new ArrayList<>();
        List<String> labelIds = new ArrayList<>();
        Set<String> patientLabelIds = new HashSet<>();
        page.getRecords().forEach(i -> {
            patientIds.add(i.getPatientId());
            labelIds.add(i.getLabelId());
            patientLabelIds.add(i.getId());
        });

        // 标签
        Map<String, LabelBO> labelMap = labelClientService.getLabelMapByIds(labelIds);
        
        // 查询患者最新数据变化信息
        Map<String, DataDwsPatientDataLastDateBO> patientDataLastDateMap = dwdDataPatientClientService.mapPatientDataLastDateInfo(patientIds);

        // 查询医生操作数据
        Map<String, List<DoctorBehaviorDataCountBO>> behaviorDataMap = new HashMap<>();

        DoctorBehaviorDataCountQueryClientDTO behaviorCount = new DoctorBehaviorDataCountQueryClientDTO();
        behaviorCount.setDoctorId(params.getDoctorId());
        behaviorCount.setRelOneType(DoctorBehaviorConstant.RelOneType.Label_Patient.getCode());
        behaviorCount.setRelOneIds(patientIds);
        behaviorCount.setRelTwoType(DoctorBehaviorConstant.RelTwoType.Label.getCode());
        behaviorCount.setRelTwoId(params.getLabelId());
        List<DoctorBehaviorDataCountBO> behaviorDataCountList = doctorBehaviorClientService.getBehaviorDataCount(behaviorCount);
        behaviorDataCountList.forEach(i -> {
            List<DoctorBehaviorDataCountBO> bos = behaviorDataMap.get(i.getDoctorId() + "-" + i.getRelOneId());
            if (null == bos) {
                bos = new ArrayList<>();
                behaviorDataMap.put(i.getDoctorId() + "-" + i.getRelOneId(), bos);
            }
            bos.add(i);
        });

        // 查询医生最后备注数据
        Map<String, List<DoctorPatientRemarkBO>> remarkMap = new HashMap<>();
        DoctorPatientRemarkQueryClientDTO remarkQueryClientDTO = new DoctorPatientRemarkQueryClientDTO();
        remarkQueryClientDTO.setDoctorId(params.getDoctorId());
        remarkQueryClientDTO.setPatientId(params.getPatientId());
        remarkQueryClientDTO.setRelOneType(DoctorRemarkConstant.RelOneType.Label_Patient.getCode());
        remarkQueryClientDTO.setRelOneId(params.getLabelId());
        List<DoctorPatientRemarkBO> remarkList = doctorPatientRemarkClientService.list(remarkQueryClientDTO);
        remarkList.forEach(i -> {
            List<DoctorPatientRemarkBO> bos = remarkMap.get(i.getDoctorId() + "-" + i.getPatientId());
            if (null == bos) {
                bos = new ArrayList<>();
                remarkMap.put(i.getDoctorId() + "-" + i.getPatientId(), bos);
            }
            bos.add(i);
        });

        // 查询患者最新mdt会诊信息
        Map<String, ConsultationBO> mdtMap = consultationClientService.lastMdtSimpleMap(patientIds);

        // 查询患者最新就诊数据
        Map<String, PatientVisitRecordClientBO> visitMap = dwdDataPatientClientService.mapPatientVisitLastDateInfo(patientIds);

        // 查询患者最新住院数据
        PatientLastDataQueryDTO patientLastDataQueryDTO = new PatientLastDataQueryDTO();
        patientLastDataQueryDTO.setPatientIds(patientIds);
        Map<String, PatientInpatientRecordClientBO> inPatientMap = dwdDataPatientClientService.mapPatientInpatientLastDateInfo(patientLastDataQueryDTO);

        // 查询患者最新出院数据
        Map<String, PatientDischargeRecordClientBO> outPatientMap = dwdDataPatientClientService.mapPatientOutpatientLastDateInfo(patientIds);

        // 患者是否去世
        Map<String, DoctorDwdPatientBO> patientClientBOMap = new HashMap<>();
        List<DoctorDwdPatientBO> patientClientBOList = dwdDataPatientClientService.queryPatientList(patientIds);
        if (CollectionUtil.isNotEmpty(patientClientBOList)) {
            patientClientBOList.forEach(i -> patientClientBOMap.put(i.getPatientId(), i));
        }

        // 是否关注患者
        Map<String, String> followMap = new HashMap<>();
        DoctorFollowPatientListClientDTO followDTO = new DoctorFollowPatientListClientDTO();
        followDTO.setDoctorId(params.getDoctorId());
        followDTO.setPatientIds(patientIds);
        List<DoctorFollowPatientBO> followList = doctorFollowPatientClientService.simpleList(followDTO);
        if (CollUtil.isNotEmpty(followList)) {
            followList.forEach(i -> followMap.put(i.getPatientId(), i.getStatus()));
        }

        // 是否排除/加入管理
        Map<String, DoctorManagePatientBO> doctorManagePatientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            DoctorManagePatientQueryClientDTO doctorManagePatientQueryClientDTO = new DoctorManagePatientQueryClientDTO();
            doctorManagePatientQueryClientDTO.setDoctorId(params.getDoctorId());
            doctorManagePatientQueryClientDTO.setPatientIds(patientIds);
            List<DoctorManagePatientBO> doctorManagePatientList = doctorManagePatientClientService.simpleList(doctorManagePatientQueryClientDTO);
            if (CollUtil.isNotEmpty(doctorManagePatientList)) {
                doctorManagePatientList.forEach(i -> doctorManagePatientMap.put(i.getPatientId() + "-" + i.getLabelId(), i));
            }
        }

        // 个案管理
        Map<String, PatientDoctorRelationBO> crmMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientDoctorRelQueryClientDTO patientDoctorRelQueryClientDTO = new PatientDoctorRelQueryClientDTO();
            patientDoctorRelQueryClientDTO.setDoctorId(params.getDoctorId());
            patientDoctorRelQueryClientDTO.setSourceType("patient_label"); // PatientDoctorRelationSourceTypeEnum.PDRS_PatientLabel
            patientDoctorRelQueryClientDTO.setSourceObjIds(patientLabelIds);
            List<PatientDoctorRelationBO> crmList = patientDoctorRelationClientService.queryPatientDoctorRelList(patientDoctorRelQueryClientDTO);
            if (CollUtil.isNotEmpty(crmList)) {
                crmList.forEach(i ->{
                    if (!crmMap.containsKey(i.getPatientId())) {
                        crmMap.put(i.getPatientId(), i);
                    }});
            }
        }

        PageData<PatientLabelHistoryVO> data = new PageConverter<PatientLabelInfoVO, PatientLabelHistoryVO>() {
            @Override
            public PatientLabelHistoryVO converter(PatientLabelInfoVO entity) {
                PatientLabelHistoryVO patientLabelVO = new PatientLabelHistoryVO();
                BeanUtil.copyProperties(entity, patientLabelVO);

                PatientClientBO patientClientBO = new PatientClientBO();
                BeanUtil.copyProperties(entity, patientClientBO);
                patientClientBO.setAge(getAge(entity.getIdCardNo(), entity.getBirthday()));

                // 患者是否去世
                patientClientBO.setDeathStatus(YN.YES.getCode());
                DoctorDwdPatientBO dwdPatient = patientClientBOMap.get(entity.getPatientId());
                if (null != dwdPatient && YN.NO.getCode().equals(dwdPatient.getDeathStatus())) {
                    patientClientBO.setDeathStatus(dwdPatient.getDeathStatus());
                    patientClientBO.setDeathTime(dwdPatient.getDeathTime());
                    if (StrUtil.isNotBlank(dwdPatient.getDeathTime())) {
                        if (dwdPatient.getDeathTime().length() == 12) {
                            patientClientBO.setDeathTime(DateUtil.parse(dwdPatient.getDeathTime(), "yyyyMMddHHmm").toString());
                        }
                        if (dwdPatient.getDeathTime().length() == 14) {
                            patientClientBO.setDeathTime(DateUtil.parse(dwdPatient.getDeathTime(), "yyyyMMddHHmmss").toString());
                        }
                    }
                }

                patientLabelVO.setPatientInfo(patientClientBO);

                patientLabelVO.setPatientDataLastDateInfo(patientDataLastDateMap.get(entity.getPatientId()));

                patientLabelVO.setDoctorBehaviorDataCountList(behaviorDataMap.get(params.getDoctorId() + "-" + patientLabelVO.getPatientId()));

                List<DoctorPatientRemarkBO> remarks = remarkMap.get(params.getDoctorId() + "-" + patientLabelVO.getPatientId());
                if (CollectionUtil.isNotEmpty(remarks)) {
                    patientLabelVO.setDoctorPatientRemarkList(remarks);
                    patientLabelVO.setDoctorPatientRemarkLast(remarks.get(0));
                }

                // 最新MDT
                patientLabelVO.setMdtConsultationInfo(mdtMap.get(entity.getPatientId()));

                // 最新就诊
                patientLabelVO.setVisitInfo(visitMap.get(entity.getPatientId()));

                // 最新住院
                patientLabelVO.setInpatientInfo(inPatientMap.get(entity.getPatientId()));

                // 最新出院
                // patientLabelVO.setOutpatientInfo(outPatientMap.get(entity.getPatientId()));
                PatientDischargeRecordClientBO patientDischargeRecordClientBO = outPatientMap.get(entity.getPatientId());
                if (null != patientDischargeRecordClientBO) {
                    patientDischargeRecordClientBO.setContent(null);
                    patientDischargeRecordClientBO.setDiagnosisRaw(null);
                    patientLabelVO.setOutpatientInfo(patientDischargeRecordClientBO);
                }

                // 标签信息
                patientLabelVO.setLabelBO(labelMap.get(entity.getLabelId()));

                // 是否医生关注该患者
                patientLabelVO.setFollowStatus(followMap.get(entity.getPatientId()));

                // 管理患者信息（排除/加入管理）
                patientLabelVO.setManagePatientInfo(doctorManagePatientMap.get(entity.getPatientId() + "-" + entity.getLabelId()));

                // 个案
                patientLabelVO.setCrmStatus(YN.NO.getCode());
                if (crmMap.containsKey(patientLabelVO.getPatientId())) {
                    PatientDoctorRelationBO crm = crmMap.get(patientLabelVO.getPatientId());
                    patientLabelVO.setCrmStatus(YN.YES.getCode());
                    patientLabelVO.setCrmRelStatus(crm.getState());
                } else {
                    patientLabelVO.setCrmStatus(YN.NO.getCode());
                }

                return patientLabelVO;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<LabelPatientDataHistogramVO> historyHistogramList(LabelPatientDataHistogramDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        // 查询所有用户所有
        List<LabelPatientDataHistogramVO> list = patientLabelMapper.queryPatientHistoryLabelList(new QueryWrapper<PatientLabelHistoryInfo>()
            .eq("a.op_type", OpTypeEnum.Create.getCode())
            .eq(StrUtil.isNotBlank(params.getLabelId()), "a.label_id", params.getLabelId())
            .ge(null != params.getStartDate(), "a.op_date", params.getStartDate())
            .lt(null != params.getEndDate(), "a.op_date", params.getEndDate())
        );
        return list;
    }

}
