package com.xxh.cloud.healthy.serve.label.framework.modules.task.schedule;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.serve.label.framework.modules.task.service.PatientLabelExpireBizService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

/**
 * 标签过期任务
 */
@Slf4j
@Component
public class PatientLabelExpireTask {

    @Autowired
    private PatientLabelExpireBizService patientLabelExpireBizService;

    // 每小时整执行一次
    @XxlJob("deptLabelRespectJobHandler")
    public void deptLabelRespectJobHandler() throws Exception {

        log.info("科室标签关系表维护开始 >>>>>> ");
        XxlJobHelper.log("科室标签关系表维护开始 >>>>>> ");

        patientLabelExpireBizService.deptLabelRespect();

        XxlJobHelper.log("科室标签关系表维护结束 <<<<<< ");
        log.info("科室标签关系表维护结束 <<<<<< ");
    }

    // 每小时的20分执行一次  // 不能跟上面的科室标签关系维护定时任务的触发时间相近，否则在清空科室标签时执行此任务会导致科室患者绑定数据解绑
    @XxlJob("patientLabelExpireJobHandler")
    public void patientLabelExpireJobHandler() throws Exception {

        log.info("患者标签过期任务开始 >>>>>> ");
        XxlJobHelper.log("患者标签过期任务开始 >>>>>> ");

        patientLabelExpireBizService.patientLabelExpire();

        XxlJobHelper.log("患者标签过期任务结束 <<<<<< ");
        log.info("患者标签过期任务结束 <<<<<< ");
    }

    // 每小时的40分执行一次
    @XxlJob("deptPatientJobHandler")
    public void deptPatientJobHandler() throws Exception {

        log.info("部门患者绑定任务开始 >>>>>> ");
        XxlJobHelper.log("部门患者绑定任务开始 >>>>>> ");

        patientLabelExpireBizService.deptPatientRespectByLabel();

        XxlJobHelper.log("部门患者绑定任务结束 <<<<<< ");
        log.info("部门患者绑定任务结束 <<<<<< ");
    }

}
