package com.xxh.cloud.healthy.serve.label.framework.modules.task.schedule;

import cn.hutool.core.util.StrUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.xxh.cloud.healthy.serve.label.framework.modules.task.service.PatientLabelTaskBizService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Component
public class PatientLabelTask {

    @Autowired
    private PatientLabelTaskBizService patientLabelTaskBizService;

    @XxlJob("labelPatientCountJobHandler")
    public void labelPatientCountJobHandler() throws Exception {
        log.info("统计标签患者数量开始 >>>>>> ");
        XxlJobHelper.log("统计标签患者数量开始 >>>>>> ");

        patientLabelTaskBizService.labelPatientCountTaskExe();

        XxlJobHelper.log("统计标签患者数量结束 <<<<<< ");
        log.info("统计标签患者数量结束 <<<<<< ");
    }

    @XxlJob("remindPatientLabel")
    public void remindPatientLabel() throws Exception {
        log.info("提醒标签病种负责人开始 >>>>>> ");
        XxlJobHelper.log("提醒标签病种负责人开始 >>>>>> ");
        String jobParam = XxlJobHelper.getJobParam();
        int hours;
        if (StrUtil.isNotEmpty(jobParam)) {
            hours = Integer.parseInt(jobParam);
        } else {
            hours = 1;
        }
        patientLabelTaskBizService.remindPatientLabel(hours);

        XxlJobHelper.log("提醒标签病种负责人结束 <<<<<< ");
        log.info("提醒标签病种负责人结束 <<<<<< ");
    }

}
