package com.xxh.cloud.healthy.serve.pushServe.client.api;

import java.util.List;

import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientPushServeClientBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientPushServeDateClientBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientRemindBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientScheduleBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientPushServeAddClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientPushServeDateQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientPushServeQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientPushServeRemoveClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientRemindAddClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientRemindQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientScheduleAddClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientScheduleCreateClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientScheduleQueryClientDTO;

public interface PatientPushServeClientService {

    PatientPushServeClientBO add(PatientPushServeAddClientDTO params);

    void remove(PatientPushServeRemoveClientDTO params);

    PatientScheduleBO getPatientScheduleBO(String scheduleId);

    List<PatientScheduleBO> patientScheduleBOList(PatientScheduleQueryClientDTO params);

    PatientRemindBO getPatientRemindBO(String remindId);

    List<PatientRemindBO> patientRemindBOList(PatientRemindQueryClientDTO params);

    // zs202311191203: 提供给用户授权绑定患者时生成该用户的日程
    void createSchedule(PatientScheduleCreateClientDTO params);

    // zs20231119 更新日程状态
    PatientScheduleBO updatePatientScheduleStatus(String scheduleId, String status);

    // 获取推送服务列表
    List<PatientPushServeClientBO> getPatientPushServeList(PatientPushServeQueryClientDTO params);

    // 服务日期
    List<PatientPushServeDateClientBO> pushServeDateList(PatientPushServeDateQueryClientDTO params);



    // 生成患者日程
    void addPatientScheduleBatch(List<PatientScheduleAddClientDTO> params);

    // 生成患者提醒
    List<PatientRemindBO> addPatientRemindBatch(List<PatientRemindAddClientDTO> params);
}
