package com.xxh.cloud.healthy.serve.pushServe.client.api.constant;

public class PatientPushServeConstant {
    
    // 患者推送服务发送状态
    public enum PushServeSendStatus {
        Todo("1","待发送"),
        Doing("2", "进行中"),
        Done("3","结束"),
        DEL("4", "删除"),

        ;

        private String code;
        private String msg;
        private PushServeSendStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

    // 提醒表状态
    // 患者推送服务第三方推送状态
    public enum RemindPushStatus {
        Todo("1","待发送"),
        Success("2", "成功"),
        Fail("3","失败"),
        Invalid("4","无效"), // 由于参数问题永远无法发送
        NotFollow("5", "未关注"),
        Doing("6", "发送中"),
        Expire("7", "过期未发送"),

        BlackList("8", "被拉黑"), // 在黑名单中无法发送

        Abnormal("9", "异常"), // 异常推送的提醒
        ;

        private String code;
        private String msg;
        private RemindPushStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

    // 患者推送服务日程状态
    public enum ScheduleStatus {
        TODO("todo","待查看"),
        DONE("done","已查看"), // 只能由todo过来，最终状态
        Invalid("invalid", "失效"), // 用户失去患者授权，只能由todo过来，也能变为todo（重新授权后）
        Del("del","删除"), // 服务被删除，由todo过来，最终状态

        ;

        private String code;
        private String msg;
        private ScheduleStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

}
