package com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者推送服务信息表
 * </p>
 *
 * @author anros
 * @since 2023-09-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_patient_push_serve_info")
public class PatientPushServeInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 推送服务快照ID
     */
    @ApiModelProperty(value = "推送服务快照ID")
    private String snapshotId;

    /**
     * 推送服务ID
     */
    @ApiModelProperty(value = "推送服务ID")
    private String pushServeId;

    /**
     * 推送服务名称
     */
    @ApiModelProperty(value = "推送服务名称")
    private String pushServeName;

    /**
     * 推送服务内部名称
     */
    @ApiModelProperty(value = "推送服务内部名称")
    private String pushServeTitle;


    @ApiModelProperty(value = "推送服务内容分类")
    private String pushContentType;

    @ApiModelProperty(value = "推送服务内容ID")
    private String pushContentId;


    /**
     * 基准发送时间内容
     */
    @ApiModelProperty(value = "基准发送时间内容")
    private String benchmarkDateValue;

    /**
     * 发送时间列表
     */
    @ApiModelProperty(value = "发送时间列表")
    private String sendDateList;

    /**
     * 已发送时间列表
     */
    @ApiModelProperty(value = "已发送时间列表")
    private String sendDateListYes;

    /**
     * 未发送时间列表
     */
    @ApiModelProperty(value = "未发送时间列表")
    private String sendDateListNo;

    /**
     * 发送状态
     */
    @ApiModelProperty(value = "发送状态")
    private String sendStatus;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

    /**
     * 提醒方式
     */
    @ApiModelProperty(value = "提醒方式")
    private String remindWay;

    /**
     * 关联业务分类
     */
    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    /**
     * 关联一级业务ID
     */
    @ApiModelProperty(value = "关联一级业务ID")
    private String relOneId;

    /**
     * 关联二级业务ID
     */
    @ApiModelProperty(value = "关联二级业务ID")
    private String relTwoId;

}
