package com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者提醒信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_patient_remind_info")
public class PatientRemindInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userId;

    /**
     * 业务一级分类
     */
     @ApiModelProperty(value = "业务一级分类")
      private String bizOneType;

    /**
     * 业务二级分类
     */
     @ApiModelProperty(value = "业务二级分类")
      private String bizTwoType;

    /**
     * 执行业务ID
     */
     @ApiModelProperty(value = "执行业务ID")
      private String bizId;

    /**
     * 提醒标题
     */
     @ApiModelProperty(value = "提醒标题")
      private String title;

    /**
     * 提醒内容配置
     */
     @ApiModelProperty(value = "提醒内容配置")
      private String content;

    /**
     * 推送渠道
     */
     @ApiModelProperty(value = "推送渠道[PushWayEnum]")
      private String pushChannel;

    /**
     * 推送模板ID
     */
     @ApiModelProperty(value = "推送模板ID")
      private String pushTempId;

    /**
     * 推送状态
     */
     @ApiModelProperty(value = "推送状态")
      private String pushStatus;

    /**
     * 推送时间
     */
     @ApiModelProperty(value = "推送时间")
      private Date pushDate;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

     @ApiModelProperty(value = "提醒推送配置")
      private String pushConfig;

     @ApiModelProperty(value = "推送目标服务账号信息[openid、phone等]")
      private String pushAccount;

     @ApiModelProperty(value = "第三方错误码")
      private String errorCode;

     @ApiModelProperty(value = "第三方错误信息")
      private String errorMsg;

    //  @ApiModelProperty(value = "对应日程id")
    //   private String scheduleId;

}
