package com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者复诊信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_patient_return_visit_info")
public class PatientReturnVisitInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 就诊类型
     */
    @ApiModelProperty(value = "就诊类型")
    private String visitType;

    /**
     * 门诊号
     */
    @ApiModelProperty(value = "门诊号/住院号")
    private String visitId;

    /**
     * 复诊来源类型
     */
    @ApiModelProperty(value = "复诊来源类型")
    private String sourceType;

    /**
     * 复诊来源id
     */
    @ApiModelProperty(value = "复诊来源id")
    private String sourceId;

    /**
     * 复诊来源科室
     */
    @ApiModelProperty(value = "复诊来源科室")
    private String sourceDeptId;

    /**
     * 复诊来源时间
     */
    @ApiModelProperty(value = "复诊来源时间")
    private String sourceTime;

    /**
     * 复诊科室组
     */
    @ApiModelProperty(value = "复诊科室组")
    private String deptIds;

    /**
     * 实际复诊科室
     */
    @ApiModelProperty(value = "实际复诊科室")
    private String deptId;

    /**
     * 复诊内容
     */
    @ApiModelProperty(value = "复诊内容")
    private String content;

    /**
     * 设定复诊开始时间
     */
    @ApiModelProperty(value = "设定复诊开始时间")
    private Date visitStartTime;

    /**
     * 设定复诊结束时间
     */
    @ApiModelProperty(value = "设定复诊结束时间")
    private Date visitEndTime;

    /**
     * 实际复诊时间
     */
    @ApiModelProperty(value = "实际复诊时间")
    private Date realTime;

    /**
     * 复诊状态
     */
    @ApiModelProperty(value = "复诊状态")
    private String status;

    /**
     * 操作类型
     */
    @ApiModelProperty(value = "操作类型")
    private String opType;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

}
