package com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者日程信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_patient_schedule_info")
public class PatientScheduleInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userId;

    /**
     * 业务一级分类
     */
     @ApiModelProperty(value = "业务一级分类")
      private String bizOneType;

    /**
     * 业务二级分类
     */
     @ApiModelProperty(value = "业务二级分类")
      private String bizTwoType;

    /**
     * 执行业务ID
     */
     @ApiModelProperty(value = "执行业务ID")
      private String bizId;

    /**
     * 日程时间
     */
     @ApiModelProperty(value = "日程时间")
      private Date scheduleDate;

    /**
     * 日程标题
     */
     @ApiModelProperty(value = "日程标题")
      private String title;

    /**
     * 日程内容
     */
     @ApiModelProperty(value = "日程内容")
      private String content;

    /**
     * 日程状态
     */
     @ApiModelProperty(value = "日程状态")
      private String status;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

    /**
     * 日程类型[RemindWayEnum]
     */
     @ApiModelProperty(value = "日程类型[RemindWayEnum]")
      private String scheduleType;

    /**
     * 关联一级对象分类
     */
     @ApiModelProperty(value = "关联一级对象分类")
      private String relOneType;

    /**
     * 关联一级对象ID
     */
     @ApiModelProperty(value = "关联一级对象ID")
      private String relOneId;

    /**
     * 关联二级对象分类
     */
     @ApiModelProperty(value = "关联二级对象分类")
      private String relTwoType;

    /**
     * 关联二级对象ID
     */
     @ApiModelProperty(value = "关联二级对象ID")
      private String relTwoId;

}
