package com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者服务测试数据表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_patient_serve_test")
public class PatientServeTest extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userIds;

    /**
     * 服务id
     */
     @ApiModelProperty(value = "服务id")
      private String pushServeId;

    /**
     * 服务时间
     */
     @ApiModelProperty(value = "服务时间")
      private Date pushDate;

    /**
     * 标题
     */
     @ApiModelProperty(value = "标题")
      private String title;

    /**
     * 内容
     */
     @ApiModelProperty(value = "内容")
      private String content;

    /**
     * 类型[RemindWayEnum]
     */
     @ApiModelProperty(value = "类型[RemindWayEnum]")
      private String pushType;

    /**
     * 关联业务分类
     */
    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    /**
     * 关联一级业务ID
     */
    @ApiModelProperty(value = "关联一级业务ID")
    private String relOneId;

    /**
     * 关联二级业务ID
     */
    @ApiModelProperty(value = "关联二级业务ID")
    private String relTwoId;

}
