package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class PatientPushServeAddDTO {

    @ApiModelProperty(value = "患者编号", required = true)
    @NotEmpty(message = "患者编号[patientId]不能为空")
    private String patientId;

    @ApiModelProperty(value = "推送服务ID")
    private String pushServeId;

    @ApiModelProperty(value = "推送服务IDs")
    private List<String> pushServeIds;

    @ApiModelProperty(value = "基准发送时间列表")
    private Map<String, Date> benchmarkDateMap;

    @ApiModelProperty(value = "基准发送时间")
    private String benchmarkDateValue;

    @ApiModelProperty(value = "操作者")
    private String opUser;

    /**
     * 关联业务分类
     */
    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    /**
     * 关联一级业务ID
     */
    @ApiModelProperty(value = "关联一级业务ID")
    private String relOneId;

    /**
     * 关联二级业务ID
     */
    @ApiModelProperty(value = "关联二级业务ID")
    private String relTwoId;

}
