package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto;

import java.util.Date;

import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientRemindAddDTO {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "用户ID")
    private String userId;

    /**
     * 业务一级分类
     */
    @ApiModelProperty(value = "业务一级分类[ObjectTypeEnum.OT_OneType_PatientPushServe]")
    private String bizOneType;

    /**
     * 业务二级分类
     */
    @ApiModelProperty(value = "业务二级分类")
    private String bizTwoType;

    /**
     * 执行业务ID
     */
    @ApiModelProperty(value = "执行业务ID[patientPushServeId]")
    private String bizId;

    /**
     * 提醒标题
     */
    @ApiModelProperty(value = "提醒标题")
    private String title;

    /**
     * 提醒内容配置
     */
    @ApiModelProperty(value = "提醒内容配置")
    private String content;

    /**
     * 推送渠道
     */
    @ApiModelProperty(value = "推送渠道[PushWayEnum]")
    private String pushChannel;

    /**
     * 推送模板ID
     */
    @ApiModelProperty(value = "推送模板ID")
    private String pushTempId;

    @ApiModelProperty(value = "推送配置[具体推送方式的配置]")
    private ServPushConfigModel pushConfig;

    /**
     * 推送状态
     */
    @ApiModelProperty(value = "推送状态")
    private String pushStatus;

    /**
     * 推送时间
     */
    @ApiModelProperty(value = "推送时间")
    private Date pushDate;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "推送目标服务账号信息[openid、phone等]")
    private String pushAccount;

}
