package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientScheduleQueryDTO extends BasePageDTO {

    /**
     * 部门Id
     */
     @ApiModelProperty(value = "部门Id")
      private String deptId;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 患者编号列表
     */
     @ApiModelProperty(value = "患者编号列表")
      private List<String> patientIds;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userId;

    /**
     * 用户ID列表
     */
     @ApiModelProperty(value = "用户ID列表")
      private List<String> userIds;

    /**
     * 业务一级分类
     */
     @ApiModelProperty(value = "业务一级分类[ObjectTypeEnum.OT_OneType_PatientPushServe]")
      private String bizOneType;

    /**
     * 业务二级分类
     */
     @ApiModelProperty(value = "业务二级分类")
      private String bizTwoType;

    /**
     * 执行业务ID
     */
     @ApiModelProperty(value = "执行业务ID[patientPushServeId]")
      private String bizId;

     @ApiModelProperty(value = "执行业务ID列表[patientPushServeId]")
      private List<String> bizIds;

    /**
     * 日程标题
     */
     @ApiModelProperty(value = "日程标题")
      private String title;

    /**
     * 日程状态
     */
     @ApiModelProperty(value = "日程状态")
      private String status;

    /**
     * 查询开始日期
     */
     @ApiModelProperty(value = "查询开始日期")
      private String startDate;

    /**
     * 查询结束日期
     */
     @ApiModelProperty(value = "查询结束日期")
      private String endDate;

    // zs20231021
     @ApiModelProperty(value = "日程类型[RemindWayEnum]")
      private String scheduleType;
     @ApiModelProperty(value = "日程类型列表[RemindWayEnum]")
      private List<String> scheduleTypes;

    @ApiModelProperty(value = "查询格式[bizId-scheduleDate]")
    private List<String> bizIdAndScheduleDate;
    
    @ApiModelProperty(value = "查询参数格式[biz_id-user_id-push_date]")
    private List<String> querParams;

}
