package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;

import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;

import io.swagger.annotations.ApiModelProperty;

// 服务数据统计
@Getter
@Setter
public class PatientPushServiceDataVO {

    // 服务信息
    @ApiModelProperty(value = "推送服务id")
    private String pushServiceId;
    @ApiModelProperty(value = "推送人员分类")
    private String pushTarget;
    @ApiModelProperty(value = "推送服务名称")
    private String pushServiceName;
    @ApiModelProperty(value = "推送服务标题")
    private String pushServiceTitle;

    // 服务推送信息
    @ApiModelProperty(value = "患者推送服务id")
    private String patientPushServiceId;
    @ApiModelProperty(value = "推送时间")
    private Date pushDate;

    //患者信息
    @ApiModelProperty(value = "患者编号")
    private String patientId;
    @ApiModelProperty(value = "患者姓名")
    private String patientName;
    @ApiModelProperty(value = "患者性别(标准)")
    private String patientGenderStandard;
    @ApiModelProperty(value = "患者生日")
    private String patientBirthday;
    @ApiModelProperty(value = "患者电话号码")
    private String patientPhone;
    @ApiModelProperty(value = "患者年龄")
    private String patientAge;

    // 提醒信息
    @ApiModelProperty(value = "服务推送状态（只要提醒推送家属有成功的就设置为成功）")
    private String pushServiceStatus;
    @ApiModelProperty(value = "服务推送状态码（微信推送消息状态码）")
    private String pushServiceErrorCode;
    @ApiModelProperty(value = "服务推送错误信息（微信推送消息错误信息，若没有需要推送的家属则直接设置为“无家属信息”）")
    private String pushServiceErrorMsg;

    // 推送成功失败
    @ApiModelProperty(value = "推送成功次数")
    private Integer pushSuccessCount;
    @ApiModelProperty(value = "推送失败次数")
    private Integer pushFailCount;

    @ApiModelProperty(value = "第一次发送时间")
    private Date firstSendDate;
    @ApiModelProperty(value = "最近发送时间")
    private Date lastSendDate;


    // 行为信息
    @ApiModelProperty(value = "阅读时间")
    private String readDate;
    @ApiModelProperty(value = "是否阅读")
    private String read;
    @ApiModelProperty(value = "是否感兴趣")
    private String interested;


    @ApiModelProperty(value = "服务配置")
    private PushServeConfigBO pushServeConfig;

}
