package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientScheduleVO {

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userId;

    /**
     * 业务一级分类
     */
     @ApiModelProperty(value = "业务一级分类[ObjectTypeEnum.OT_OneType_PatientPushServe]")
      private String bizOneType;

    /**
     * 业务二级分类
     */
     @ApiModelProperty(value = "业务二级分类")
      private String bizTwoType;

    /**
     * 执行业务ID
     */
     @ApiModelProperty(value = "执行业务ID[patientPushServeId]")
      private String bizId;

    /**
     * 日程时间
     */
    @ApiModelProperty(value = "日程时间")
    private Date scheduleDate;

    /**
     * 日程标题
     */
     @ApiModelProperty(value = "日程标题")
      private String title;

    /**
     * 日程内容
     */
     @ApiModelProperty(value = "日程内容")
      private String content;

    /**
     * 日程状态
     */
     @ApiModelProperty(value = "日程状态")
      private String status;

    /**
     * 日程类型[RemindWayEnum]
     */
     @ApiModelProperty(value = "日程类型[RemindWayEnum]")
      private String scheduleType;

    @ApiModelProperty(value = "患者推送服务信息")
    private PatientPushServeHistoryVO patientPushServeVO;

    @ApiModelProperty(value = "患者家属关系")
    private String relationName;

    // zs20231106
    @ApiModelProperty(value = "数据来源")
    private String sourceData;

}
