package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.helper;

import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.behavior.client.api.constant.BehaviorSourceTypeConstant;
import com.xxh.cloud.healthy.behavior.client.api.util.BehaviorSecureUtil;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientPushServeClientBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientPushServeDateClientBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientRemindBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientReturnVisitBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientScheduleBO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeConfigSnapshotInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeDateInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeHistoryInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientRemindInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientReturnVisitInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientScheduleInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeDateVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeHistoryVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientReturnVisitVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientScheduleVO;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

// zs:2023-09-19
public class PatientPushServeHelper {

    public static String getPatientPushServeId(){
        return StrUtil.format("PPS{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientPushServeHistoryId(){
        return StrUtil.format("PPSH{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static String getPatientPushServeConfigSnapshotId(){
        return StrUtil.format("PPSCS{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientScheduleId(){
        return StrUtil.format("PS{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static String getPatientRemindId(){
        return StrUtil.format("PR{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static String getPatientPushServeDateId(){
        return StrUtil.format("PPSD{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static String getPatientReturnVisitInfoId(){
        return StrUtil.format("PRVI{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    // 发送时间等信息处理
    public static PatientPushServeVO getPatientPushServeVO(PatientPushServeInfo entity) {
        PatientPushServeVO vo = new PatientPushServeVO();
        BeanUtil.copyProperties(entity, vo, "pushServeConfig", "sendDateList", "sendDateListYes", "sendDateListNo");

        if (StrUtil.isNotBlank(entity.getSendDateList())) {
            vo.setSendDateList(StrJoinSplitUtils.split2List(entity.getSendDateList()));
        }
        if (StrUtil.isNotBlank(entity.getSendDateListYes())) {
            vo.setSendDateListYes(StrJoinSplitUtils.split2List(entity.getSendDateListYes()));
        }
        if (StrUtil.isNotBlank(entity.getSendDateListNo())) {
            vo.setSendDateListNo(StrJoinSplitUtils.split2List(entity.getSendDateListNo()));
        }
        return vo;
    }

    // 发送时间等信息处理
    public static PatientPushServeHistoryVO getPatientPushServeHistoryVO(PatientPushServeHistoryInfo entity) {
        PatientPushServeHistoryVO vo = new PatientPushServeHistoryVO();
        BeanUtil.copyProperties(entity, vo, "pushServeConfig", "sendDateList", "sendDateListYes", "sendDateListNo");

        if (StrUtil.isNotBlank(entity.getSendDateList())) {
            vo.setSendDateList(StrJoinSplitUtils.split2List(entity.getSendDateList()));
        }
        if (StrUtil.isNotBlank(entity.getSendDateListYes())) {
            vo.setSendDateListYes(StrJoinSplitUtils.split2List(entity.getSendDateListYes()));
        }
        if (StrUtil.isNotBlank(entity.getSendDateListNo())) {
            vo.setSendDateListNo(StrJoinSplitUtils.split2List(entity.getSendDateListNo()));
        }
        return vo;
    }

    // 推送服务快照转对象
    public static PatientPushServeConfigSnapshotVO getPatientPushServeConfigSnapshotVO(PatientPushServeConfigSnapshotInfo entity) {
        if (null == entity) {
            return null;
        }
        PatientPushServeConfigSnapshotVO vo = new PatientPushServeConfigSnapshotVO();
        BeanUtil.copyProperties(entity, vo, "pushServeConfig");

        if (StrUtil.isNotBlank(entity.getPushServeConfig())) {
            PushServeConfigBO bo = JSONObject.parseObject(entity.getPushServeConfig(), PushServeConfigBO.class);
            vo.setPushServeConfig(bo);
        }
        return vo;
    }

    public static PatientRemindVO getPatientRemindVO(PatientRemindInfo entity) {
        if (null == entity) {
            return null;
        }
        PatientRemindVO vo = new PatientRemindVO();
        BeanUtil.copyProperties(entity, vo, "pushConfig");
        if (null != entity.getPushConfig()) {
            vo.setPushConfig(JSONObject.parseObject(entity.getPushConfig(), ServPushConfigModel.class));
        }
        return vo;
    }

    public static PatientPushServeDateVO getPatientPushServeDateVO(PatientPushServeDateInfo entity) {
        if (null == entity) {
            return null;
        }
        PatientPushServeDateVO vo = new PatientPushServeDateVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static PatientScheduleVO getPatientScheduleVO(PatientScheduleInfo entity) {
        if (null == entity) {
            return null;
        }
        PatientScheduleVO vo = new PatientScheduleVO();
        BeanUtil.copyProperties(entity, vo);

        vo.setSourceData(BehaviorSecureUtil.mergeSourceData(BehaviorSourceTypeConstant.SourceOneTypeEnum.Schedule.getCode(), vo.getId()));
        return vo;
    }

    public static PatientPushServeClientBO getPatientPushServeClientBO(PatientPushServeVO vo) {
        if (null == vo) {
            return null;
        }
        PatientPushServeClientBO bo = new PatientPushServeClientBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

    public static PatientPushServeClientBO getPatientPushServeClientBO(PatientPushServeHistoryVO vo) {
        if (null == vo) {
            return null;
        }
        PatientPushServeClientBO bo = new PatientPushServeClientBO();
        bo.setId(vo.getPatientPushServeId());
        bo.setPatientId(vo.getPatientId());
        bo.setPushContentId(vo.getPushContentId());
        bo.setBenchmarkDateValue(vo.getBenchmarkDateValue());
        bo.setPushContentType(vo.getPushContentType());
        bo.setPushServeConfig(vo.getPushServeConfig());
        bo.setPushServeId(vo.getPushServeId());
        bo.setPushServeName(vo.getPushServeName());
        bo.setPushServeTitle(vo.getPushServeTitle());
        bo.setRemindWay(vo.getRemindWay());
        bo.setSendDateList(vo.getSendDateList());
        bo.setSendDateListNo(vo.getSendDateListNo());
        bo.setSendStatus(vo.getSendStatus());
        bo.setSnapshotId(vo.getSnapshotId());
        // bo.setSendDate(vo.getsenddate);
        bo.setCreateDate(vo.getOpDate());
        return bo;
    }

    public static PatientScheduleBO getPatientScheduleBO(PatientScheduleVO vo) {
        if (null == vo) {
            return null;
        }
        PatientScheduleBO bo = new PatientScheduleBO();
        BeanUtil.copyProperties(vo, bo);
        if (null != vo.getPatientPushServeVO()) {
            bo.setPatientPushServeBO(getPatientPushServeClientBO(vo.getPatientPushServeVO()));
        }
        return bo;
    }

    public static PatientRemindBO getPatientRemindBO(PatientRemindVO vo) {
        if (null == vo) {
            return null;
        }
        PatientRemindBO bo = new PatientRemindBO();
        BeanUtil.copyProperties(vo, bo);
        if (null != vo.getPatientPushServeVO()) {
            bo.setPatientPushServeBO(getPatientPushServeClientBO(vo.getPatientPushServeVO()));
        }
        return bo;
    }

    public static PatientPushServeDateClientBO getPatientPushServeDateClientBO(PatientPushServeDateVO vo) {
        if (null == vo) {
            return null;
        }
        PatientPushServeDateClientBO bo = new PatientPushServeDateClientBO();
        bo.setId(vo.getId());
        bo.setPatientId(vo.getPatientId());
        bo.setPatientPushServeId(vo.getPatientPushServeId());
        bo.setSendDate(vo.getSendDate());
        return bo;
    }

    public static PatientReturnVisitVO getPatientReturnVisitVO(PatientReturnVisitInfo entity) {
        if (null == entity) {
            return null;
        }
        PatientReturnVisitVO vo = new PatientReturnVisitVO();
        vo.setId(entity.getId());
        vo.setPatientId(entity.getPatientId());
        vo.setVisitType(entity.getVisitType());
        vo.setVisitId(entity.getVisitId());
        vo.setSourceType(entity.getSourceType());
        vo.setSourceId(entity.getSourceId());
        vo.setSourceDeptId(entity.getSourceDeptId());
        vo.setSourceTime(entity.getSourceTime());
        if (StrUtil.isNotBlank(entity.getDeptIds())) {
            vo.setDeptIds(StrJoinSplitUtils.split2List(entity.getDeptIds()));
        }
        vo.setDeptId(entity.getDeptId());
        vo.setContent(entity.getContent());
        vo.setVisitStartTime(entity.getVisitStartTime());
        vo.setVisitEndTime(entity.getVisitEndTime());
        vo.setRealTime(entity.getRealTime());
        vo.setStatus(entity.getStatus());
        vo.setOpType(entity.getOpType());
        return vo;
    }

    public static PatientReturnVisitBO getPatientReturnVisitBO(PatientReturnVisitVO vo) {
        if (null == vo) {
            return null;
        }
        PatientReturnVisitBO bo = new PatientReturnVisitBO();
        bo.setId(vo.getId());
        bo.setPatientId(vo.getPatientId());
        bo.setVisitType(vo.getVisitType());
        bo.setVisitId(vo.getVisitId());
        bo.setSourceType(vo.getSourceType());
        bo.setSourceId(vo.getSourceId());
        bo.setSourceDeptId(vo.getSourceDeptId());
        bo.setSourceTime(vo.getSourceTime());
        bo.setDeptIds(vo.getDeptIds());
        bo.setDeptId(vo.getDeptId());
        bo.setContent(vo.getContent());
        bo.setVisitStartTime(vo.getVisitStartTime());
        bo.setVisitEndTime(vo.getVisitEndTime());
        bo.setRealTime(vo.getRealTime());
        bo.setStatus(vo.getStatus());
        bo.setOpType(vo.getOpType());
        return bo;
    }

}
