package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeDateInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientScheduleInfo;

public interface PatientPushServeMapper {

    // @Select(" SELECT DISTINCT a.id " + 
    //         " FROM h_patient_push_serve_history_info a " + 
    //         " LEFT JOIN h_patient_schedule_info b ON a.patient_push_serve_id = b.biz_id " + 
    //         " WHERE a.op_type = '1' AND b.id IS NULL " +
    //         " ORDER BY a.id ASC " +
    //         " LIMIT #{limit} ")
    // List<String> patientPushServeHistoryList(@Param("limit") Integer limit);
    @Select(" SELECT a.id " + 
            " FROM h_patient_push_serve_history_info a " + 
            " LEFT JOIN ( " + 
            "   SELECT biz_id FROM h_patient_schedule_info GROUP BY biz_id " + 
            " ) b ON a.patient_push_serve_id = b.biz_id" + 
            " WHERE a.op_type = '1' AND b.biz_id IS NULL " +
            " ORDER BY a.id ASC " +
            " LIMIT #{limit} ")
    List<String> patientPushServeHistoryList(@Param("limit") Integer limit);
    
    @Select(" SELECT COUNT(1) " + 
            " FROM cust_customer_family_member_info " + 
            " WHERE pat_his_no = #{patientId} ")
    Long isExistFamilyMember(@Param("patientId") String patientId);
    // @Select(" SELECT COUNT(1) " + 
    //         " FROM cust_customer_family_member_info " + 
    //         " WHERE main_person_id = #{patientId} ")
    // Long isExistFamilyMember(@Param("patientId") String patientId);
    
    @Insert({
        "<script>",
        "INSERT INTO cust_customer_family_member_info ( " + 
        "  id, user_id, member_relation, name, mobile, gender, pat_his_no, relation_name, status, rows_status, creator, create_date, updater, update_date, main_person_id " + 
        ") VALUES ",
        "(" + 
        "  #{id}, #{userId}, '本人', #{name}, #{mobile}, #{gender}, #{patHisNo}, " + 
        "  '本人', 'Y', 'Y', 'sys', NOW(), 'sys', NOW(), #{mainPersonId} " + 
        ")",
        "</script>"
    })
    Long saveFamilyMemberInfo(@Param("data") MemberFamilyBO data);
    
    
    /**
     * 查询用户阅读行为记录
     */
    @Select(" SELECT a.source_two_id sourceTwoId, MIN(a.operated_start_date) operatedDate " + 
                "      FROM hb_patient_behavior_info a " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY a.source_two_id ")
    List<Map<String, Object>> patientPushServiceBrowseMap(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    /**
     * 查询用户阅读行为记录
     */
    @Select(" SELECT a.source_two_id sourceTwoId, MIN(a.operated_start_date) operatedDate " + 
                "      FROM hb_patient_behavior_info a " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY a.source_two_id ")
    IPage<Map<String, Object>> patientPushServiceBrowseMapPage(Page<Void> page, @Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    /**
     * 查询用户阅读行为记录
     */
    @Select(" SELECT a.user_id userId, a.source_two_id sourceTwoId, MIN(a.operated_start_date) operatedDate " + 
                "      FROM hb_patient_behavior_info a " + 
                "      ${ew.customSqlSegment} " + 
                "      GROUP BY a.user_id, a.source_two_id ")
    List<Map<String, Object>> userBrowseMap(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    /**
     * 查询用户感兴趣行为记录
     */
    @Select("SELECT a.source_two_id sourceTwoId, a.user_id userId " + 
                "  FROM hb_patient_behavior_info a " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY a.user_id, a.source_two_id ") 
    List<Map<String, Object>> userInterestedMap(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    
    /**
     * 查询患者日程（聚合患者查询不分家属）
     */
    @Select("SELECT patient_id, biz_one_type, biz_two_type, biz_id, schedule_date, title, content, rel_one_type, rel_one_id, rel_two_type, rel_two_id " + 
                "  FROM h_patient_schedule_info " + 
                "  ${ew.customSqlSegment} " + 
                "  GROUP BY patient_id, biz_one_type, biz_two_type, biz_id, schedule_date, title, content, rel_one_type, rel_one_id, rel_two_type, rel_two_id " + 
                "  ORDER BY schedule_date ASC ") 
    IPage<PatientScheduleInfo> patientScheduleGroup(Page<PatientScheduleInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientScheduleInfo> wrapper);
    
    /**
     * 查询患者服务推送日期（用于动态生成患者的推送日程（非家属日程））
     */
    @Select("SELECT b.* " + 
                "  FROM h_patient_push_serve_history_info a " + 
                "  INNER JOIN h_patient_push_serve_date_info b ON a.patient_push_serve_id = b.patient_push_serve_id " + 
                "  ${ew.customSqlSegment} " + 
                "  ORDER BY b.send_date ASC ") 
    IPage<PatientPushServeDateInfo> patientSchedulePatientByServicePage(Page<PatientPushServeDateInfo> page, @Param(Constants.WRAPPER) Wrapper<PatientPushServeDateInfo> wrapper);
    
    /**
     * 查询没有日程的推送服务
     */
    @Select("SELECT a.patient_push_serve_id patientPushServeId " + 
                "  FROM h_patient_push_serve_history_info a " + 
                "  LEFT JOIN (SELECT biz_id FROM h_patient_schedule_info WHERE biz_one_type = 'patient_push_serve' GROUP BY biz_id ) b ON a.patient_push_serve_id = b.biz_id " + 
                "  ${ew.customSqlSegment} ") 
    List<String> listPatientPushServeWithoutSchedule(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    /**
     * 服务及提醒
     */
    @Select("SELECT a.id remindId, b.push_serve_id pushServeId " + 
                "  FROM h_patient_remind_info a " + 
                "  INNER JOIN h_patient_push_serve_history_info b ON b.op_type = '1' AND a.biz_id = b.patient_push_serve_id " + 
                "  ${ew.customSqlSegment} ") 
    List<Map<String, String>> pushServiceAndPatientPushServiceList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    /**
     * 下架服务
     */
    @Update(" UPDATE h_push_serve_config_info SET ${ew.sqlSet} ${ew.customSqlSegment} ")
    Integer pushServeOff(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
    @Select(" SELECT id, name FROM h_push_serve_config_info ${ew.customSqlSegment} ")
    List<Map<String, String>> pushServeNames(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);
    
}