package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteCallbackDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemoveDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeRemindRemoteVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientScheduleVO;

public interface PatientPushServeBizService {

    // 患者推送服务
    
    PatientPushServeVO add(PatientPushServeAddDTO params);

    
    // 本方法由患者推送服务定时任务调用
    void updateBatchSendDateList(List<PatientPushServeVO> params);

    void updateSendDateList(PatientPushServeUpdateDTO params);

    void remove(PatientPushServeRemoveDTO params);


    // 日程
    void addPatientScheduleBatch(List<PatientScheduleAddDTO> params);
    void updatePatientScheduleStatusBatch(List<PatientScheduleUpdateDTO> params);
    PatientScheduleVO updatePatientScheduleStatus(PatientScheduleUpdateDTO params);

    // 提醒
    List<PatientRemindVO> addPatientRemindBatch(List<PatientRemindAddDTO> params);
    void updatePatientRemindBatch(List<PatientRemindUpdateDTO> params);




    // 对外提供的第三方提醒消息接口业务，当本身无法发送提醒时用于其他服务调用数据发送
    List<PatientPushServeRemindRemoteVO> queryPatientRemindDataList(PatientPushServeRemindRemoteQueryDTO params);
    void patientRemindDataCallback(List<PatientPushServeRemindRemoteCallbackDTO> params);
}
