package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeConfigSnapshotQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeDateQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeHistoryQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleGetDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeDateVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeHistoryVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientScheduleVO;

public interface PatientPushServeQueryBizService {

    // 快照
    List<PatientPushServeConfigSnapshotVO> listServeConfigSnapshot(PatientPushServeConfigSnapshotQueryParam params);
    PatientPushServeConfigSnapshotVO getServeConfigSnapshotById(String id);


    // 推送服务
    List<PatientPushServeVO> pushServeList(PatientPushServeQueryParam params);
    PageData<PatientPushServeVO> pushServePage(PatientPushServeQueryParam params);
    PatientPushServeVO pushServeDetail(PatientPushServeQueryParam params);

    // 推送服务历史
    PageData<PatientPushServeHistoryVO> pushServeHistoryPage(PatientPushServeHistoryQueryParam params);
    List<PatientPushServeHistoryVO> pushServeHistoryList(PatientPushServeHistoryQueryParam params);
    PatientPushServeHistoryVO pushServeHistoryDetail(PatientPushServeHistoryQueryParam params);


    // 日程
    PageData<PatientScheduleVO> patientSchedulePage(PatientScheduleQueryDTO params);
    List<PatientScheduleVO> patientScheduleList(PatientScheduleQueryDTO params);
    PageData<PatientScheduleVO> patientSchedulePatientPage(PatientScheduleQueryDTO params);
    PageData<PatientScheduleVO> patientSchedulePatientByServicePage(PatientScheduleQueryDTO params);
    // zs20231021
    PatientScheduleVO patientScheduleDetail(PatientScheduleGetDTO params);


    // 提醒
    PageData<PatientRemindVO> pagePatientRemind(PatientRemindQueryDTO params);
    // 提醒
    List<PatientRemindVO> listPatientRemind(PatientRemindQueryDTO params);
    // 提醒
    PatientRemindVO getPatientRemind(PatientRemindQueryDTO params);


    // 服务日期
    List<PatientPushServeDateVO> pushServeDateList(PatientPushServeDateQueryParam params);
}
