package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.TypeReference;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.company.cloud.sdk.weixin.mp.model.msgmanage.SendTempMsgDataModel;
import com.company.cloud.sdk.weixin.mp.model.msgmanage.SendTempMsgMiniProgramModel;
import com.company.cloud.sdk.weixin.mp.model.msgmanage.SendTempMsgModel;
import com.xxh.cloud.customer.client.api.CustomerFamilyClientService;
import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;
import com.xxh.cloud.customer.client.api.bean.dto.MemberFamilyListClientDTO;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.basic.common.constant.BenchmarkDateEnum;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.basic.common.constant.PushServeTargetEnum;
import com.xxh.cloud.healthy.basic.common.constant.PushWayEnum;
import com.xxh.cloud.healthy.basic.common.constant.RemindEarlyDelayTypeEnum;
import com.xxh.cloud.healthy.basic.common.constant.UserTypeEnum;
import com.xxh.cloud.healthy.basic.pushserve.client.api.PushServeConfigClientService;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.behavior.client.api.constant.BehaviorSourceTypeConstant;
import com.xxh.cloud.healthy.behavior.client.api.util.BehaviorSecureUtil;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PushWeixinLogAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.config.WechatConfig;
import com.xxh.cloud.healthy.push.framework.modules.biz.config.WechatTemplateConfig;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.PushWeixinConstant;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.WechatErrorCodeEnum;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PushWeixinBizService;
import com.xxh.cloud.healthy.serve.pushServe.client.api.constant.PatientPushServeConstant;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeDateInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeHistoryInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientRemindInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientScheduleInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientServeTest;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeDateInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeHistoryInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientRemindInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientScheduleInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientServeTestService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeConfigSnapshotAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeHistoryQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteCallbackDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemoveDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleGetDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeHistoryVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeRemindRemoteVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientScheduleVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.helper.PatientPushServeHelper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeBizService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeConfigSnapshotBizService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeQueryBizService;
import com.xxh.cloud.log.bean.constant.ObjectTypeEnum;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * zs20230920
 */
@Slf4j
@Service
public class PatientPushServeBizServiceImpl implements PatientPushServeBizService {

    @Autowired
    private PushServeConfigClientService pushServeConfigClientService;
    @Autowired
    private PatientPushServeInfoService patientPushServeInfoService;
    @Autowired
    private PatientPushServeHistoryInfoService patientPushServeHistoryInfoService;
    @Autowired
    private PatientRemindInfoService patientRemindInfoService;
    @Autowired
    private PatientScheduleInfoService patientScheduleInfoService;
    @Autowired
    private PatientPushServeQueryBizService patientPushServeQueryBizService;
    @Autowired
    private PatientPushServeConfigSnapshotBizService patientPushServeConfigSnapshotBizService;
    @Autowired
    private PushWeixinBizService pushWeixinBizService;
    @Autowired
    private CustomerFamilyClientService customerFamilyClientService;
    @Autowired
    private PatientPushServeDateInfoService patientPushServeDateInfoService;
    @Autowired
    private PatientServeTestService patientServeTestService;
    
    @Autowired
    private WechatConfig wechatConfig;

    /**
     * zs20230921
     * 
     * zs20230922: 
     * 1.给患者新增推送服务时，当患者不存在该服务才能新增  zs20231030: 已存在服务也可新增
     * 2.新增推送服务时不要同步保存到历史表，只有在删除、终止、失效、完成等情况下保存历史  zs20231015 新增也需添加到历史
     * 3.先查询是否有快照，没有就新增快照，用于查询时直接查询快照信息，防止主表数据变更
     * 
     * zs20231020: 给患者绑定推送服务后，记录到日程表
     * 
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public PatientPushServeVO add(PatientPushServeAddDTO params) {
        log.info("PatientPushServeBizServiceImpl:add:params:>>>>>> patientId:{}, pushServe:{}, {}", params.getPatientId(), params.getPushServeId(), JSON.toJSONString(params));
        ValidatorUtils.validateEntity(params);

        if (StrUtil.isBlank(params.getPushServeId())) {
            return null;
        }

        // 查询服务推送配置
        PushServeConfigBO pushserveConfigBO = pushServeConfigClientService.getById(params.getPushServeId());
        if (null == pushserveConfigBO) {
            throw new BusinessException("未查询到推送服务配置");
        }
        if (!YN.YES.getCode().equals(pushserveConfigBO.getStatus())) {
            throw new BusinessException("该推送服务["+ params.getPushServeId() +"]配置已下架");
        }
        // 基准时间判断
        // if (BenchmarkDateEnum.DELAY.getCode().equals(pushserveConfigBO.getBenchmarkDate()) && StrUtil.isBlank(params.getBenchmarkDateValue())) {
        //     throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR, "基准发送时间内容不能为空");
        // }
        if (BenchmarkDateEnum.DELAY.getCode().equals(pushserveConfigBO.getBenchmarkDate())) {
            if (CollectionUtil.isEmpty(params.getBenchmarkDateMap())) {
                throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR, "基准发送时间内容不能为空");
            }
            Date benchmarkDateValue = params.getBenchmarkDateMap().get(pushserveConfigBO.getBenchmarkDateType()); // 配置的基准时间类型匹配传过来的时间map获取实际的基准时间
            if (null != benchmarkDateValue) {
                params.setBenchmarkDateValue(DateUtil.formatDateTime(benchmarkDateValue));
            }
            if (StrUtil.isBlank(params.getBenchmarkDateValue())) {
                throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR, "未获取到基准发送时间");
            }
        }

        DateTime now = DateUtil.date();

        // 处理提醒时间
        String sendDateList = null;
        // 根据服务配置的触发时间或基准时间进行校验
        if (BenchmarkDateEnum.NOW.getCode().equals(pushserveConfigBO.getBenchmarkDate())) {
            sendDateList = getDateStr(now.toString(), pushserveConfigBO);
        } else if (BenchmarkDateEnum.DELAY.getCode().equals(pushserveConfigBO.getBenchmarkDate())) {
            sendDateList = getDateStr(params.getBenchmarkDateValue(), pushserveConfigBO);
        }
        if (null == sendDateList) {
            return null;
        }

        // 同一个服务、同一个患者、同一天只推送一次
        List<String> dateList = StrJoinSplitUtils.split2List(sendDateList);
        List<PatientPushServeInfo> existList = patientPushServeInfoService.list(new QueryWrapper<PatientPushServeInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq("patient_id", params.getPatientId())
                .eq("push_serve_id", params.getPushServeId())
                .and(i -> {
                    dateList.forEach(j -> {
                        i.or().like("send_date_list", DateUtil.parseDate(j).toDateStr());
                    });
                })
        );
        if (CollectionUtil.isNotEmpty(existList)) {
            existList.forEach(i -> {
                List<String> sendDate = StrJoinSplitUtils.split2List(i.getSendDateList());
                Iterator<String> it = dateList.iterator();
                while (it.hasNext()) {
                    String next = it.next();
                    if (sendDate.contains(next)) {
                        it.remove();
                    }
                }
            });
        }
        if (CollectionUtil.isEmpty(dateList)) {
            return null;
        }
        sendDateList = StrJoinSplitUtils.join(dateList);

        // 测试服务处理
        if (YN.YES.getCode().equals(pushserveConfigBO.getExtend4())) {
            log.info("测试服务处理 >>>>>> ");
            this.saveTestServeData(params, pushserveConfigBO, sendDateList);
            log.info("测试服务处理 <<<<<< ");
            return null;
        }

        // 先查询是否有快照，没有则保存快照信息
        PatientPushServeConfigSnapshotVO snapshotVO = patientPushServeQueryBizService.getServeConfigSnapshotById(pushserveConfigBO.getSnapshotKey());
        if (null == snapshotVO) {
            PatientPushServeConfigSnapshotAddDTO snapshotAddDTO = new PatientPushServeConfigSnapshotAddDTO();
            snapshotAddDTO.setId(pushserveConfigBO.getSnapshotKey());
            snapshotAddDTO.setPushServeId(pushserveConfigBO.getId());
            snapshotAddDTO.setPushServeConfig(JSON.toJSONString(pushserveConfigBO));
            snapshotAddDTO.setOpUser(params.getOpUser());
            log.info("PatientPushServeBizServiceImpl:add:snapshotAddDTO:>>>>>> {}", JSON.toJSONString(snapshotAddDTO));
            patientPushServeConfigSnapshotBizService.add(snapshotAddDTO);
        }

        // 保存患者推送服务
        PatientPushServeInfo entity = new PatientPushServeInfo();
        entity.setId(PatientPushServeHelper.getPatientPushServeId());
        entity.setPatientId(params.getPatientId());
        entity.setBenchmarkDateValue(params.getBenchmarkDateValue());
        entity.setPushServeId(pushserveConfigBO.getId());
        entity.setSnapshotId(pushserveConfigBO.getSnapshotKey());
        entity.setPushServeName(pushserveConfigBO.getName());
        entity.setPushServeTitle(pushserveConfigBO.getTitle());
        entity.setPushContentId(pushserveConfigBO.getMediaId());
        entity.setPushContentType(pushserveConfigBO.getMediaType());

        // zs20231021
        entity.setRemindWay(pushserveConfigBO.getRemindWay());

        entity.setSendStatus(PatientPushServeConstant.PushServeSendStatus.Todo.getCode());
        entity.setRowsStatus(YN.YES.getCode());

        entity.setSendDateList(sendDateList);
        entity.setSendDateListNo(sendDateList);

        // zs202311241142 推送服务推送时间列表
        if (StrUtil.isNotBlank(sendDateList)) {
            List<PatientPushServeDateInfo> patientPushServeDateInfoList = new ArrayList<>();
            List<String> sendDates = StrJoinSplitUtils.split2List(sendDateList);
            sendDates.forEach(i -> {
                PatientPushServeDateInfo patientPushServeDateInfo = new PatientPushServeDateInfo();
                patientPushServeDateInfo.setId(PatientPushServeHelper.getPatientPushServeDateId());
                patientPushServeDateInfo.setPatientId(params.getPatientId());
                patientPushServeDateInfo.setPatientPushServeId(entity.getId());
                patientPushServeDateInfo.setSendDate(DateUtil.parseDateTime(i));
                patientPushServeDateInfoList.add(patientPushServeDateInfo);
            });
            if (CollectionUtil.isNotEmpty(patientPushServeDateInfoList)) {
                patientPushServeDateInfoService.saveBatch(patientPushServeDateInfoList);
            }
        }

        entity.setRelType(params.getRelType());
        entity.setRelOneId(params.getRelOneId());
        entity.setRelTwoId(params.getRelTwoId());

        log.info("PatientPushServeBizServiceImpl:add:entity:>>>>>> patientId:{}, pushServe:{}, {}", entity.getPatientId(), entity.getPushServeId(), JSON.toJSONString(entity));
        // TODO 只推日程需不需要只保存到历史表，直接提醒1次是否也直接保存到历史表
        patientPushServeInfoService.save(entity);

        // zs20231015 新增也要追加到历史记录
        PatientPushServeHistoryInfo history = new PatientPushServeHistoryInfo();
        history.setId(PatientPushServeHelper.getPatientPushServeHistoryId());
        history.setPatientPushServeId(entity.getId());
        history.setPatientId(entity.getPatientId());
        history.setSnapshotId(entity.getSnapshotId());
        history.setPushServeId(entity.getPushServeId());
        history.setPushServeName(entity.getPushServeName());
        history.setPushServeTitle(entity.getPushServeTitle());
        history.setBenchmarkDateValue(entity.getBenchmarkDateValue());
        history.setSendDateList(entity.getSendDateList());
        history.setSendDateListYes(entity.getSendDateListYes());
        history.setSendDateListNo(entity.getSendDateListNo());
        history.setSendStatus(entity.getSendStatus());
        history.setOpType(OpTypeEnum.Create.getCode());
        history.setOpUser(params.getOpUser());
        history.setOpDate(DateUtil.date());

        history.setRemindWay(pushserveConfigBO.getRemindWay());

        history.setPushContentType(entity.getPushContentType());
        history.setPushContentId(entity.getPushContentId());

        history.setRelType(entity.getRelType());
        history.setRelOneId(entity.getRelOneId());
        history.setRelTwoId(entity.getRelTwoId());

        log.info("PatientPushServeBizServiceImpl:add:history:>>>>>> patientId:{}, pushServe:{}, {}", entity.getPatientId(), entity.getPushServeId(), JSON.toJSONString(history));
        patientPushServeHistoryInfoService.save(history);

        // zs20231020 保存到日程
        // zs20231105 添加是否推送到患者本人逻辑
        if (StrUtil.isNotBlank(sendDateList)) {
            this.saveSchedule(entity, pushserveConfigBO);
        }

        return PatientPushServeHelper.getPatientPushServeVO(entity);
    }

    /**
     * zs20230920 获取服务推送时间
     * 
     * @param date yyyy-MM-dd HH:mm:ss 当前时间或基准时间，时分秒以给定的为准
     * @param pushserveConfigBO
     * @return
     */ 
    private String getDateStr(String date, PushServeConfigBO pushserveConfigBO) {
        log.info("PatientPushServeBizServiceImpl:getDateStr:date:>>>>>> {}", date);
        date = DateUtil.parse(date, "yyyy-MM-dd HH:mm").toString();
        String result = null;
        // 若给定时间则以给定的为准
        // if (BenchmarkDateEnum.DELAY.getCode().equals(pushserveConfigBO.getBenchmarkDate()) && StrUtil.isNotBlank(pushserveConfigBO.getRemindDayTime())) {
        // zs20231229 只要不是立即推送就可指定推送的时间
        if (!RemindEarlyDelayTypeEnum.Remind_Now.getCode().equals(pushserveConfigBO.getEarlyDelayType()) && StrUtil.isNotBlank(pushserveConfigBO.getRemindDayTime())) {
            String remindDayTime = date.split(" ")[0] + " " + pushserveConfigBO.getRemindDayTime(); // 注意：数据库记录的remindDayTime时间为时分，例如：10:30
            date = DateUtil.parse(remindDayTime, "yyyy-MM-dd HH:mm").toString();
        }

        if (RemindEarlyDelayTypeEnum.Remind_Early.getCode().equals(pushserveConfigBO.getEarlyDelayType())) {
            date = DateUtil.offsetDay(DateUtil.parse(date), - pushserveConfigBO.getEarlyDelayNum()).toString();
        } else if (RemindEarlyDelayTypeEnum.Remind_Delay.getCode().equals(pushserveConfigBO.getEarlyDelayType())) {
            date = DateUtil.offsetDay(DateUtil.parse(date), pushserveConfigBO.getEarlyDelayNum()).toString();
        } else if (RemindEarlyDelayTypeEnum.Remind_Now.getCode().equals(pushserveConfigBO.getEarlyDelayType())) {
            // 立即推送，无逻辑
        }

        // 是否循环
        if (YN.NO.getCode().equals(pushserveConfigBO.getLoopModel())) {
            result = dateStr(date, 0, 0);
        } else {
            result = dateStr(date, pushserveConfigBO.getLoopMaxNum(), pushserveConfigBO.getLoopInterval());
        }

        if (null == result) {
            throw new BusinessException("推送服务配置异常");
        }

        log.info("PatientPushServeBizServiceImpl:getDateStr:date:<<<<<< {}", result);
        return result;
    }

    /**
     * 
     * @param date  yyyy-MM-dd HH:mm:ss 实际开始时间
     * @param loopMaxNum 最大循环次数
     * @param loopInterval 循环间隔（天）
     * @return
     */
    private String dateStr(String date, Integer loopMaxNum, Integer loopInterval) {
        StringBuilder sb = new StringBuilder();
        sb.append(date);
        for (int i = 1; i <= loopMaxNum; i++) {
            DateTime dt = DateUtil.offsetDay(DateUtil.parse(date, "yyyy-MM-dd HH:mm"), loopInterval * i);
            sb.append(",");
            sb.append(dt.toString());
        }
        return sb.toString();
    }

    // 保存到测试
    private void saveTestServeData(PatientPushServeAddDTO params, PushServeConfigBO pushServeConfigBO, String sendDateList) {
        // 根据患者编号查询需要提醒的用户
        List<MemberFamilyBO> userList = this.getUserIdListByPatientId(params.getPatientId(), pushServeConfigBO.getPushTarget());

        List<PatientServeTest> patientServeTestList = new ArrayList<>();

        List<String> patientDate = StrJoinSplitUtils.split2List(sendDateList);
        patientDate.forEach(i -> {
            Map<String, String> userMap = new HashMap<>();
            if (CollUtil.isNotEmpty(userList)) {
                userList.forEach(user -> {
                    userMap.put(user.getId(), user.getRelationName());
                });
            }

            PatientServeTest patientServeTest = new PatientServeTest();
            patientServeTest.setId(PatientPushServeHelper.getPatientScheduleId());
            patientServeTest.setPatientId(params.getPatientId());
            patientServeTest.setUserIds(JSON.toJSONString(userMap));
            patientServeTest.setPushServeId(pushServeConfigBO.getId());
            patientServeTest.setPushDate(DateUtil.parseDateTime(i));
            patientServeTest.setTitle(pushServeConfigBO.getTitle());
            patientServeTest.setContent(pushServeConfigBO.getMediaId());
            patientServeTest.setPushType(pushServeConfigBO.getRemindWay());

            patientServeTest.setRelType(params.getRelType());
            patientServeTest.setRelOneId(params.getRelOneId());
            patientServeTest.setRelTwoId(params.getRelTwoId());

            patientServeTestList.add(patientServeTest);
        });
        
        // save
        patientServeTestService.saveBatch(patientServeTestList);
    }

    /**
     * 20231105
     * 保存到日程
     * 
     * @param entity
     * @param content
     * @param remindWay
     * @param isRemindPatient 是否推送到患者本人（例如癌症，不能推送到本人）
     */
    private void saveSchedule(PatientPushServeInfo entity, PushServeConfigBO pushServeConfigBO) {
        // TODO 根据患者编号查询需要日程提醒的用户
        List<MemberFamilyBO> userList = this.getUserIdListByPatientId(entity.getPatientId(), pushServeConfigBO.getPushTarget());
        if (CollectionUtil.isEmpty(userList)) {
            // throw new BusinessException("未查询到患者对应的用户数据");
            return;
        }

        List<PatientScheduleAddDTO> patientScheduleAddDTOs = new ArrayList<>();
        List<String> patientScheduleDate = StrJoinSplitUtils.split2List(entity.getSendDateList());
        patientScheduleDate.forEach(i -> {
            userList.forEach(user -> {
                PatientScheduleAddDTO patientScheduleAddDTO = new PatientScheduleAddDTO();
                patientScheduleAddDTO.setScheduleDate(i);
                patientScheduleAddDTO.setPatientId(entity.getPatientId());
                patientScheduleAddDTO.setUserId(user.getUserId());
                patientScheduleAddDTO.setBizId(entity.getId());
                patientScheduleAddDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
                // patientScheduleInfo.setBizTwoType(null);
                patientScheduleAddDTO.setTitle(entity.getPushServeTitle());
                patientScheduleAddDTO.setContent(pushServeConfigBO.getMediaId()); // mediaId为推送消息的id，这个id可以使消息跳转到具体的消息页
                patientScheduleAddDTO.setStatus(PatientPushServeConstant.ScheduleStatus.TODO.getCode());

                // zs20231021
                patientScheduleAddDTO.setScheduleType(pushServeConfigBO.getRemindWay());

                patientScheduleAddDTOs.add(patientScheduleAddDTO);
            });
        });
        this.addPatientScheduleBatch(patientScheduleAddDTOs);
        
    }

    /**
     * 
     * @param patientId
     * @param pushTarget  判断推送目标选择推送用户
     * @return
     */
    private List<MemberFamilyBO> getUserIdListByPatientId(String patientId, String pushTarget) {
        // 1:本人 2:配偶 3:父母 4:子女 5:他人

        MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
        memberFamilyListClientDTO.setPatHisNo(patientId); // zs20231115 家属表中patientId来自海鹚和本平台的patientId不一致，一致的是patHisNos（就诊人门诊id）
        // memberFamilyListClientDTO.setMainPersonId(patientId); // zs20240318
        // memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
        List<MemberFamilyBO> memberFamilyBOs = customerFamilyClientService.listByUser(memberFamilyListClientDTO);

        List<MemberFamilyBO> memberFamilyList = new ArrayList<>();

        // TODO zs20240627 只有一个家属（即患者），直接推送
        List<String> familyIds = new ArrayList<>(); // 更新一个家属的人为本人

        if (memberFamilyBOs.size() == 1) {
            MemberFamilyBO family = memberFamilyBOs.get(0);
            memberFamilyList.add(family);

            if (StrUtil.isEmpty(family.getRelationType()) || !YN.YES.getCode().equals(family.getIsAuth())) {
                familyIds.add(family.getId());
            }
        } else {
            memberFamilyBOs.forEach(i -> {
                if (!YN.YES.getCode().equals(i.getIsAuth())) {
                    return;
                }
                // 推送本人，如是家属则跳过
                if (PushServeTargetEnum.Self.getCode().equals(pushTarget) && !"1".equals(i.getRelationType())) {
                    return;
                }
                // 推送家属，若是本人则跳过
                if (PushServeTargetEnum.Family.getCode().equals(pushTarget) && "1".equals(i.getRelationType())) {
                    return;
                }
                memberFamilyList.add(i);
            });
        }

        // 若没有查询到患者的家属信息则直接返回默认家属信息，用于记录推送
        // if (CollectionUtil.isEmpty(memberFamilyList)) {
        //     MemberFamilyBO memberFamilyBO = new MemberFamilyBO();
        //     if (PushServeTargetEnum.Self.getCode().equals(pushTarget)) {
        //         memberFamilyBO.setMemberRelation("1"); // 本人
        //     } else {
        //         memberFamilyBO.setMemberRelation("2"); // 默认配偶
        //     }
        //     memberFamilyList.add(memberFamilyBO);
        // }
        
        // 补刀：若家属只有一个人则更新为本人
        if (CollUtil.isNotEmpty(familyIds)) {
            customerFamilyClientService.updateSelfRelationByIds(familyIds);
        }

        return memberFamilyList;
    }

    /**
     * fix:zs20230923:
     * 1. 未完成的任务更新；完成的任务记录历史并删除
     * 2. 需要根据发送时间更新发送时间列表
     * 3. 也有未发送的时间但永远也不会再发送的数据（例如未触发但时间已过期），这需要另外的定时任务去处理这种数据
     * 4. 本方法由患者推送服务定时任务调用
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateBatchSendDateList(List<PatientPushServeVO> params) {
        List<PatientPushServeInfo> patientPushServeInfos = new ArrayList<>();
        List<PatientPushServeHistoryInfo> patientPushServeHistoryInfos = new ArrayList<>();
        List<String> delPatientPushServeIds = new ArrayList<>();

        // zs20231020 更新日程状态
        List<String> patientSchedules = new ArrayList<>();

        params.forEach(i -> {
            // 处理发送时间数据
            List<String> sendDateListYes = CollectionUtil.isEmpty(i.getSendDateListYes()) ? new ArrayList<>() : i.getSendDateListYes();
            List<String> sendDateListNo = CollectionUtil.isEmpty(i.getSendDateListNo()) ? new ArrayList<>() : i.getSendDateListNo();
            // 处理未发送时间，注意：不验证是否给定时间与当前时间匹配
            if (StrUtil.isNotBlank(i.getSendDate()) && sendDateListNo.contains(i.getSendDate())) {
                // zs20231020 更新日程状态
                patientSchedules.add(i.getId() + "-" + i.getSendDate());

                sendDateListNo.remove(i.getSendDate());
                // 处理已发送时间，把从未发送时间列表中移除的时间加入到已发送时间列表中
                sendDateListYes.add(i.getSendDate());

                log.info("PatientPushServeBizServiceImpl:updateSendDateList:sendDateListYes:>>>>>> {}", JSON.toJSONString(sendDateListYes));
                log.info("PatientPushServeBizServiceImpl:updateSendDateList:sendDateListNo:>>>>>> {}", JSON.toJSONString(sendDateListNo));

                PatientPushServeInfo patientPushServeInfo = new PatientPushServeInfo();
                patientPushServeInfo.setId(i.getId());
                patientPushServeInfo.setSendDateListYes(StrJoinSplitUtils.join(sendDateListYes));
                patientPushServeInfo.setSendDateListNo(StrJoinSplitUtils.join(sendDateListNo));
                // 判断是否执行完毕
                // 注意：也有未发送的时间但永远也不会再发送的数据（例如未触发但时间已过期），这需要另外的定时任务去处理这种数据
                String sendStatus = PatientPushServeConstant.PushServeSendStatus.Doing.getCode();
                if (CollectionUtil.isEmpty(sendDateListNo)) {
                    sendStatus = PatientPushServeConstant.PushServeSendStatus.Done.getCode();
                    patientPushServeInfo.setSendDateListNo("");
                }

                patientPushServeInfo.setSendStatus(sendStatus);

                if (PatientPushServeConstant.PushServeSendStatus.Doing.getCode().equals(sendStatus)) {
                    patientPushServeInfos.add(patientPushServeInfo);
                }

                // 进行中的任务更新；完成的任务删除并记录历史
                if (PatientPushServeConstant.PushServeSendStatus.Done.getCode().equals(sendStatus)) {
                    // 记录患者推送服务历史
                    PatientPushServeHistoryInfo history = new PatientPushServeHistoryInfo();
                    history.setId(PatientPushServeHelper.getPatientPushServeHistoryId());
                    history.setPatientPushServeId(i.getId());
                    history.setPatientId(i.getPatientId());
                    history.setSnapshotId(i.getSnapshotId());
                    history.setPushServeId(i.getPushServeId());
                    history.setPushServeName(i.getPushServeName());
                    history.setPushServeTitle(i.getPushServeTitle());
                    history.setBenchmarkDateValue(i.getBenchmarkDateValue());
                    history.setSendDateList(StrJoinSplitUtils.join(i.getSendDateList()));
                    history.setSendDateListYes(patientPushServeInfo.getSendDateListYes());
                    history.setSendDateListNo(patientPushServeInfo.getSendDateListNo());
                    history.setSendStatus(patientPushServeInfo.getSendStatus());
                    history.setOpType(OpTypeEnum.Finish.getCode());
                    history.setOpUser("system");
                    history.setOpDate(DateUtil.date());
                    history.setRemindWay(i.getRemindWay());
                    
                    history.setPushContentType(i.getPushContentType());
                    history.setPushContentId(i.getPushContentId());

                    history.setRelType(i.getRelType());
                    history.setRelOneId(i.getRelOneId());
                    history.setRelTwoId(i.getRelTwoId());
        
                    log.info("PatientPushServeBizServiceImpl:updateSendDateList:history:>>>>>> {}", JSON.toJSONString(history));
                    patientPushServeHistoryInfos.add(history);

                    // 删除患者推送服务
                    delPatientPushServeIds.add(i.getId());
                }
            }
        });

        log.info("PatientPushServeBizServiceImpl:updateSendDateList:patientPushServeInfos:>>>>>> {}", JSON.toJSONString(patientPushServeInfos));
        // 更新患者推送服务
        patientPushServeInfoService.updateBatchById(patientPushServeInfos);
        // 记录历史并删除患者推送服务
        if (CollectionUtil.isNotEmpty(delPatientPushServeIds)) {
            // 记录患者推送服务历史
            patientPushServeHistoryInfoService.saveBatch(patientPushServeHistoryInfos);
            // 删除患者推送服务
            patientPushServeInfoService.removeBatchByIds(delPatientPushServeIds);
        }

        // zs20231020 更新日程状态
        // zs20231119 正常操作的服务，不更新日程状态，只有删除服务/患者取消用户授权等才更新未来未操作过的日程状态
        // if (CollectionUtil.isNotEmpty(patientSchedules)) {
        //     patientScheduleInfoService.update(new UpdateWrapper<PatientScheduleInfo>()
        //             .set("status", PatientPushServeConstant.ScheduleStatus.TODO.getCode())
        //             .in("CONCAT(biz_id, '-', schedule_date)", patientSchedules)
        //     );
        // }
    }

    /**
     * fix:zs20230923:
     * 1.未完成的任务更新；完成的任务记录历史并删除
     * 2.需要根据发送时间更新发送时间列表
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateSendDateList(PatientPushServeUpdateDTO params) {
        log.info("PatientPushServeBizServiceImpl:updateSendDateList:params:>>>>>> {}", JSON.toJSONString(params));
        ValidatorUtils.validateEntity(params);

        PatientPushServeInfo entity = patientPushServeInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        
        // 处理发送时间数据
        List<String> sendDateListYes = StrJoinSplitUtils.split2List(entity.getSendDateListYes());
        List<String> sendDateListNo = StrJoinSplitUtils.split2List(entity.getSendDateListNo());
        // 处理未发送时间，注意：不验证是否给定时间与当前时间匹配
        if (!sendDateListNo.contains(params.getSendDate())) {
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR);
        }
        sendDateListNo.remove(params.getSendDate());
        // 处理已发送时间，把从未发送时间列表中移除的时间加入到已发送时间列表中
        sendDateListYes.add(params.getSendDate());

        log.info("PatientPushServeBizServiceImpl:updateSendDateList:sendDateListYes:>>>>>> {}", JSON.toJSONString(sendDateListYes));
        log.info("PatientPushServeBizServiceImpl:updateSendDateList:sendDateListNo:>>>>>> {}", JSON.toJSONString(sendDateListNo));

        // 判断是否执行完毕
        String sendStatus = PatientPushServeConstant.PushServeSendStatus.Doing.getCode();
        if (CollectionUtil.isEmpty(sendDateListNo)) {
            sendStatus = PatientPushServeConstant.PushServeSendStatus.Done.getCode();
        }

        // 进行中的任务更新；完成的任务删除并记录历史
        if (PatientPushServeConstant.PushServeSendStatus.Done.getCode().equals(sendStatus)) {
            // 记录历史
            PatientPushServeHistoryInfo history = new PatientPushServeHistoryInfo();
            history.setId(PatientPushServeHelper.getPatientPushServeHistoryId());
            history.setPatientPushServeId(entity.getId());
            history.setPatientId(entity.getPatientId());
            history.setSnapshotId(entity.getSnapshotId());
            history.setPushServeId(entity.getPushServeId());
            history.setPushServeName(entity.getPushServeName());
            history.setPushServeTitle(entity.getPushServeTitle());
            history.setBenchmarkDateValue(entity.getBenchmarkDateValue());
            history.setSendDateList(entity.getSendDateList());
            history.setSendDateListYes(entity.getSendDateListYes());
            history.setSendDateListNo(entity.getSendDateListNo());
            history.setSendStatus(entity.getSendStatus());
            history.setOpType(OpTypeEnum.Finish.getCode());
            history.setOpUser(params.getOpUser());
            history.setOpDate(DateUtil.date());

            history.setPushContentType(entity.getPushContentType());
            history.setPushContentId(entity.getPushContentId());

            history.setRelType(entity.getRelType());
            history.setRelOneId(entity.getRelOneId());
            history.setRelTwoId(entity.getRelTwoId());

            log.info("PatientPushServeBizServiceImpl:updateSendDateList:history:>>>>>> {}", JSON.toJSONString(history));
            patientPushServeHistoryInfoService.save(history);

            // 删除推送任务
            patientPushServeInfoService.removeById(entity.getId());
        } else {
            // 更新已执行时间与未执行时间数据
            patientPushServeInfoService.update(new UpdateWrapper<PatientPushServeInfo>()
                    .set("send_status", sendStatus)
                    .set("send_date_list_yes", StrJoinSplitUtils.join(sendDateListYes))
                    .set("send_date_list_no", StrJoinSplitUtils.join(sendDateListNo))
                    .eq("id", params.getId())
            );
        }

        // zs20231020 更新日程状态
        // zs20231119 正常操作的服务，不更新日程状态，只有删除服务/患者取消用户授权等才更新未来未操作过的日程状态
        // patientScheduleInfoService.update(new UpdateWrapper<PatientScheduleInfo>()
        //         .set("status", YN.NO.getCode())
        //         .eq("biz_id", entity.getId())
        //         .eq("schedule_date", params.getSendDate())
        // );
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void remove(PatientPushServeRemoveDTO params) {
        log.info("PatientPushServeBizServiceImpl:remove:params:>>>>>> {}", JSON.toJSONString(params));
        if (StrUtil.isBlank(params.getId()) || CollectionUtil.isEmpty(params.getIds())) {
            throw new BusinessException(BusinessBaseErrorEnum.PARAMS_GET_ERROR, "参数不能为空");
        }

        List<PatientPushServeInfo> list = patientPushServeInfoService.list(new QueryWrapper<PatientPushServeInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
        );
        if (CollectionUtil.isEmpty(list)) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        List<String> ids = new ArrayList<>();
        
        // 记录日志
        List<PatientPushServeHistoryInfo> histories = new ArrayList<>();
        list.forEach(i -> {
            ids.add(i.getId());

            PatientPushServeHistoryInfo history = new PatientPushServeHistoryInfo();
            history.setId(PatientPushServeHelper.getPatientPushServeHistoryId());
            history.setPatientPushServeId(i.getId());
            history.setPatientId(i.getPatientId());
            history.setSnapshotId(i.getSnapshotId());
            history.setPushServeId(i.getPushServeId());
            history.setPushServeName(i.getPushServeName());
            history.setPushServeTitle(i.getPushServeTitle());
            history.setBenchmarkDateValue(i.getBenchmarkDateValue());
            history.setSendDateList(i.getSendDateList());
            history.setSendDateListYes(i.getSendDateListYes());
            history.setSendDateListNo(i.getSendDateListNo());
            history.setSendStatus(PatientPushServeConstant.PushServeSendStatus.DEL.getCode());
            history.setOpType(OpTypeEnum.DEL.getCode());
            history.setOpUser(params.getOpUser());
            history.setOpDate(DateUtil.date());

            history.setPushContentType(i.getPushContentType());
            history.setPushContentId(i.getPushContentId());

            history.setRelType(i.getRelType());
            history.setRelOneId(i.getRelOneId());
            history.setRelTwoId(i.getRelTwoId());

            log.info("PatientPushServeBizServiceImpl:remove:history:>>>>>> {}", JSON.toJSONString(history));
            histories.add(history);
        });
        // 保存到历史
        patientPushServeHistoryInfoService.saveBatch(histories);
        // 直接物理删除服务，并保存到历史
        patientPushServeInfoService.removeBatchByIds(ids);

        // zs20231020 更新日程状态  
        // zs20231105 不要改rows_status, 只改未来并且未操作的日程状态
        patientScheduleInfoService.update(new UpdateWrapper<PatientScheduleInfo>()
                .set("status", PatientPushServeConstant.ScheduleStatus.Del.getCode())
                .eq("status", PatientPushServeConstant.ScheduleStatus.TODO.getCode())
                .ge("schedule_date", DateUtil.now())
                .eq(StrUtil.isNotBlank(params.getId()), "biz_id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "biz_id", params.getIds())
        );
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void addPatientScheduleBatch(List<PatientScheduleAddDTO> params) {
        log.info("PatientPushServeBizServiceImpl:addPatientScheduleBatch:params:>>>>>> {}", JSON.toJSONString(params));
        if (CollectionUtil.isEmpty(params)) {
            return;
        }

        List<PatientScheduleInfo> entityList = new ArrayList<>();
        params.forEach(i -> {
            PatientScheduleInfo entity = new PatientScheduleInfo();
            entity.setId(PatientPushServeHelper.getPatientScheduleId());
            entity.setPatientId(i.getPatientId());
            entity.setUserId(i.getUserId());
            entity.setBizId(i.getBizId());
            entity.setBizOneType(i.getBizOneType());
            entity.setBizTwoType(i.getBizTwoType());
            entity.setScheduleDate(DateUtil.parseDateTime(i.getScheduleDate()));
            entity.setTitle(i.getTitle());
            entity.setContent(i.getContent());
            entity.setStatus(i.getStatus());
            entity.setRowsStatus(YN.YES.getCode());

            // zs20231021
            entity.setScheduleType(i.getScheduleType());

            log.info("PatientPushServeBizServiceImpl:addPatientScheduleBatch:entity:>>>>>> {}", JSON.toJSONString(entity));
            entityList.add(entity);
        });
        patientScheduleInfoService.saveBatch(entityList);
    }

    @Override
    public void updatePatientScheduleStatusBatch(List<PatientScheduleUpdateDTO> params) {
        log.info("PatientPushServeBizServiceImpl:updatePatientScheduleBatch:params:>>>>>> {}", JSON.toJSONString(params));
        if (CollectionUtil.isEmpty(params)) {
            return;
        }

        List<PatientScheduleInfo> entityList = new ArrayList<>();
        params.forEach(i -> {
            PatientScheduleInfo entity = new PatientScheduleInfo();
            entity.setId(i.getId());
            entity.setStatus(i.getStatus());

            entityList.add(entity);
        });
        patientScheduleInfoService.updateBatchById(entityList);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public PatientScheduleVO updatePatientScheduleStatus(PatientScheduleUpdateDTO params) {
        log.info("PatientPushServeBizServiceImpl:updatePatientScheduleStatus:params:>>>>>> {}", JSON.toJSONString(params));

        PatientScheduleGetDTO patientScheduleGetDTO = new PatientScheduleGetDTO();
        patientScheduleGetDTO.setId(params.getId());
        PatientScheduleVO vo = patientPushServeQueryBizService.patientScheduleDetail(patientScheduleGetDTO);

        if (null == vo) {
            return null;
        }

        if (!vo.getStatus().equals(params.getStatus())) {
            PatientScheduleInfo entity = new PatientScheduleInfo();
            entity.setId(params.getId());
            entity.setStatus(params.getStatus());
            patientScheduleInfoService.updateById(entity);
        }

        return vo;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public List<PatientRemindVO> addPatientRemindBatch(List<PatientRemindAddDTO> params) {
        if (CollectionUtil.isEmpty(params)) {
            return new ArrayList<>(0);
        }

        List<PatientRemindInfo> entityList = new ArrayList<>();
        params.forEach(i -> {
            PatientRemindInfo entity = new PatientRemindInfo();
            entity.setId(PatientPushServeHelper.getPatientRemindId());
            entity.setPatientId(i.getPatientId());
            entity.setBizId(i.getBizId());
            entity.setBizOneType(i.getBizOneType());
            entity.setBizTwoType(i.getBizTwoType());
            entity.setTitle(i.getTitle());
            entity.setContent(i.getContent());
            entity.setPushChannel(i.getPushChannel());
            entity.setPushTempId(i.getPushTempId());
            entity.setPushConfig(JSON.toJSONString(i.getPushConfig()));
            entity.setPushStatus(i.getPushStatus());
            entity.setPushDate(i.getPushDate());
            entity.setRemark(i.getRemark());
            entity.setRowsStatus(YN.YES.getCode());

            // zs20231105
            entity.setUserId(i.getUserId());
            entity.setPushAccount(i.getPushAccount());

            log.info("PatientPushServeBizServiceImpl:addPatientRemindBatch:entity:>>>>>> {}", JSON.toJSONString(entity));
            entityList.add(entity);
        });
        patientRemindInfoService.saveBatch(entityList);

        return entityList.stream().map(PatientPushServeHelper::getPatientRemindVO).collect(Collectors.toList());
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updatePatientRemindBatch(List<PatientRemindUpdateDTO> params) {
        if (CollectionUtil.isEmpty(params)) {
            return;
        }

        List<PatientRemindInfo> entityList = new ArrayList<>();
        params.forEach(i -> {
            PatientRemindInfo entity = new PatientRemindInfo();
            entity.setId(i.getId());
            entity.setPushStatus(i.getPushStatus());
            entity.setErrorCode(i.getErrorCode());
            entity.setErrorMsg(i.getErrorMsg());
            if (null != i.getPushConfig()) {
                entity.setPushConfig(JSON.toJSONString(i.getPushConfig()));
            }
            log.info("PatientPushServeBizServiceImpl:updatePatientRemindBatch:entity:>>>>>> {}", JSON.toJSONString(entity));
            entityList.add(entity);
        });
        patientRemindInfoService.updateBatchById(entityList);
    }


    @Override
    public List<PatientPushServeRemindRemoteVO> queryPatientRemindDataList(PatientPushServeRemindRemoteQueryDTO params) {
        log.info("获取推送的提醒信息 >>>>>> params={}", JSON.toJSONString(params));
        // 只获取待提醒信息的数据
        PatientRemindQueryDTO patientRemindQueryDTO = new PatientRemindQueryDTO();
        patientRemindQueryDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Todo.getCode());
        patientRemindQueryDTO.setPushChannel(params.getPushChannel());
        List<PatientRemindVO> patientRemindVOs = patientPushServeQueryBizService.listPatientRemind(patientRemindQueryDTO);
        if (CollectionUtil.isEmpty(patientRemindVOs)) {
            return new ArrayList<>();
        }

        List<String> patientPushServeIdList = patientRemindVOs.stream().map(PatientRemindVO::getBizId).collect(Collectors.toList());
        PatientPushServeHistoryQueryParam patientPushServeQueryParam = new PatientPushServeHistoryQueryParam();
        patientPushServeQueryParam.setPatientPushServeIds(patientPushServeIdList);
        patientPushServeQueryParam.setOpType(OpTypeEnum.Create.getCode());
        patientPushServeQueryParam.setRemindWay(params.getPushChannel());
        log.info("查询推送服务配置信息>>>>>> patientPushServeQueryParam={}", JSON.toJSONString(patientPushServeQueryParam));
        List<PatientPushServeHistoryVO> patientPushServeList = patientPushServeQueryBizService.pushServeHistoryList(patientPushServeQueryParam);
        if (CollectionUtil.isEmpty(patientPushServeList)) {
            return new ArrayList<>();
        }
        Map<String, PatientPushServeHistoryVO> patientPushServeMap = patientPushServeList.stream().collect(Collectors.toMap(PatientPushServeHistoryVO::getPatientPushServeId, i -> i));

        List<PatientRemindUpdateDTO> cannotSendRemindList = new ArrayList<>(); // 由于数据问题无法发送的更新状态
        List<PatientRemindUpdateDTO> notFollowRemindList = new ArrayList<>(); // 没有关注导致无法发送消息
        List<PatientRemindUpdateDTO> doingRemindList = new ArrayList<>(); // 更新待发送为发送中
        List<PatientPushServeRemindRemoteVO> list = new ArrayList<>();

        patientRemindVOs.forEach(i -> {
            log.info("1.患者推送服务>>>>>> i={}", JSON.toJSONString(i));

            PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
            patientRemindUpdateDTO.setId(i.getId());

            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && StrUtil.isBlank(i.getPushAccount())) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                notFollowRemindList.add(patientRemindUpdateDTO);
                return;
            }

            ServPushConfigModel pushConfig = i.getPushConfig();
            
            PatientPushServeHistoryVO patientPushServeVO = patientPushServeMap.get(i.getBizId());
            if (null == pushConfig || null == patientPushServeVO || null == patientPushServeVO.getPushServeConfig()) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Invalid.getCode());
                cannotSendRemindList.add(patientRemindUpdateDTO);
                return;
            }

            try {
                if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && StrUtil.isNotBlank(i.getPushAccount())) {
                    // 微信
                    WechatTemplateConfig wechatTemplateConfig = wechatConfig.getPatient();

                    SendTempMsgModel sendTempMsgModel = new SendTempMsgModel();
                    sendTempMsgModel.setTouser(i.getPushAccount());
                    sendTempMsgModel.setTemplate_id(StrUtil.isNotBlank(i.getPushTempId()) ? i.getPushTempId() : wechatTemplateConfig.getTemplateId());

                    if (StrUtil.isNotBlank(wechatTemplateConfig.getMiniAppid()) && StrUtil.isNotBlank(pushConfig.getUrl())) {
                        SendTempMsgMiniProgramModel sendTempMsgMiniProgramModel = new SendTempMsgMiniProgramModel();
                        sendTempMsgMiniProgramModel.setAppid(wechatTemplateConfig.getMiniAppid());
                        sendTempMsgMiniProgramModel.setPagepath(pushConfig.getUrl());
                        sendTempMsgModel.setMiniprogram(sendTempMsgMiniProgramModel);
                    } else if (StrUtil.isNotBlank(pushConfig.getUrl())) {
                        sendTempMsgModel.setUrl(pushConfig.getUrl());
                    }

                    Map<String, SendTempMsgDataModel> tempMsgMap = JSONObject.parseObject(this.msgStr(wechatTemplateConfig.getTemplate(), pushConfig), new TypeReference<Map<String, SendTempMsgDataModel>>() {});
                    sendTempMsgModel.setData(tempMsgMap);
                    
                    // 微信跳转url
                    if (StrUtil.isNotBlank(wechatTemplateConfig.getUrl()) && StrUtil.isBlank(wechatTemplateConfig.getMiniAppid())) {
                        String secureData = BehaviorSecureUtil.mergeSourceData(BehaviorSourceTypeConstant.SourceOneTypeEnum.Remind.getCode(), i.getId());
                        sendTempMsgModel.setUrl(this.urlStr(wechatTemplateConfig.getUrl(), patientPushServeVO.getPushServeConfig(), secureData));
                    }
                    
                    PatientPushServeRemindRemoteVO patientPushServeRemindRemoteVO = new PatientPushServeRemindRemoteVO();
                    patientPushServeRemindRemoteVO.setId(i.getId());
                    patientPushServeRemindRemoteVO.setPushChannel(PushWayEnum.PCW_WX.getCode());
                    patientPushServeRemindRemoteVO.setWechatMsg(sendTempMsgModel);
                    
                    log.info("2.患者微信推送服务<<<<<< {}", JSON.toJSONString(patientPushServeRemindRemoteVO));
                    list.add(patientPushServeRemindRemoteVO);
                } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                    // TODO 短信
                } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                    // TODO AI电话
                }

                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Doing.getCode());
                doingRemindList.add(patientRemindUpdateDTO);
            } catch (Exception e) {
                log.info("3.数据处理error>>>>>> {}", e.getMessage());
                e.printStackTrace();
            }
        });

        if (CollectionUtil.isNotEmpty(cannotSendRemindList)) {
            this.updatePatientRemindBatch(cannotSendRemindList);
        }
        if (CollectionUtil.isNotEmpty(doingRemindList)) {
            this.updatePatientRemindBatch(doingRemindList);
        }
        if (CollectionUtil.isNotEmpty(notFollowRemindList)) {
            this.updatePatientRemindBatch(notFollowRemindList);
        }

        return list;
    }

    // 消息模版
    private String msgStr(String templateStr, ServPushConfigModel model) {
        return templateStr.replace("#title", null == model.getTitle() ? "" : model.getTitle())
                        .replace("#content", null == model.getContent() ? "" : model.getContent())
                        .replace("#date", null == model.getDate() ? "" : model.getDate())
                        .replace("#url", null == model.getUrl() ? "" : model.getUrl())
                        .replace("#remark", null == model.getRemark() ? "" : model.getRemark())
                        .replace("#doctor", null == model.getDoctor() ? "" : model.getDoctor());
    }
    // 消息模版跳转地址
    private String urlStr(String templateStr, PushServeConfigBO pushServeConfigBO, String secureData) {
        return templateStr.replace("#id", null == pushServeConfigBO.getMediaId() ? "" : pushServeConfigBO.getMediaId())
                        .replace("#type", null == pushServeConfigBO.getMediaType() ? "" : pushServeConfigBO.getMediaType())
                        .replace("#key", secureData);
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void patientRemindDataCallback(List<PatientPushServeRemindRemoteCallbackDTO> params) {
        if (CollectionUtil.isEmpty(params)) {
            return;
        }
        // 查询提醒信息
        List<String> remindIds = params.stream().map(PatientPushServeRemindRemoteCallbackDTO::getId).collect(Collectors.toList());

        PatientRemindQueryDTO patientRemindQueryDTO = new PatientRemindQueryDTO();
        patientRemindQueryDTO.setIds(remindIds);
        List<PatientRemindVO> patientRemindVOs = patientPushServeQueryBizService.listPatientRemind(patientRemindQueryDTO);
        if (CollectionUtil.isEmpty(patientRemindVOs)) {
            return;
        }
        Map<String, PatientRemindVO> patientRemindMap = patientRemindVOs.stream().collect(Collectors.toMap(PatientRemindVO::getId, i -> i));
        
        WechatTemplateConfig wechatTemplateConfig = wechatConfig.getPatient();

        List<PatientRemindUpdateDTO> patientRemindUpdateDTOs = new ArrayList<>(); // 保存所有待更新的提醒
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志
        params.forEach(i -> {
            PatientRemindVO patientRemindVO = patientRemindMap.get(i.getId());
            if (null != patientRemindVO) {
                // 1.更新提醒
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setId(patientRemindVO.getId());
                patientRemindUpdateDTO.setErrorCode(i.getErrorCode());
                patientRemindUpdateDTO.setErrorMsg(i.getErrorMsg());
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Fail.getCode());
                if (WechatErrorCodeEnum.SUCCESS.getCode().equals(i.getErrorCode())) {
                    patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Success.getCode());
                } else if (WechatErrorCodeEnum.F43004.getCode().equals(i.getErrorCode())) {
                    patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                }
                patientRemindUpdateDTOs.add(patientRemindUpdateDTO);

                // 2.保存微信推送日志
                PushWeixinLogAddDTO pushWeixinLogAddDTO = new PushWeixinLogAddDTO();
                pushWeixinLogAddDTO.setUserType(UserTypeEnum.Patient.getCode());
                pushWeixinLogAddDTO.setUserId(patientRemindVO.getUserId());
                pushWeixinLogAddDTO.setOpenId(patientRemindVO.getPushAccount());
                pushWeixinLogAddDTO.setBizOneType(patientRemindVO.getBizOneType());
                pushWeixinLogAddDTO.setBizTwoType(patientRemindVO.getBizTwoType());
                pushWeixinLogAddDTO.setBizId(patientRemindVO.getBizId());
                pushWeixinLogAddDTO.setTempId(patientRemindVO.getPushTempId());
                pushWeixinLogAddDTO.setRemindId(patientRemindVO.getId());
                pushWeixinLogAddDTO.setRemark(patientRemindVO.getRemark());
                pushWeixinLogAddDTO.setWxAppId(wechatTemplateConfig.getAppid());
                pushWeixinLogAddDTO.setErrorCode(i.getErrorCode());
                pushWeixinLogAddDTO.setErrorMsg(i.getErrorMsg());
                pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Fail.getMsg());
                if (WechatErrorCodeEnum.SUCCESS.getCode().equals(i.getErrorCode())) {
                    pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                    pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Success.getMsg());
                } else if (WechatErrorCodeEnum.F43004.getCode().equals(i.getErrorCode())) {
                    pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                    pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.NotFollow.getMsg());
                }
                pushWeixinLogAddDTOs.add(pushWeixinLogAddDTO);
            }
        });

        // 更新提醒
        if (CollectionUtil.isNotEmpty(patientRemindUpdateDTOs)) {
            this.updatePatientRemindBatch(patientRemindUpdateDTOs);
        }
        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
    }

}
