package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeConfigSnapshotInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeConfigSnapshotInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeConfigSnapshotAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.helper.PatientPushServeHelper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeConfigSnapshotBizService;

import cn.hutool.core.date.DateUtil;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * zs20230919
 */
@Slf4j
@Service
public class PatientPushServeConfigSnapshotBizServiceImpl implements PatientPushServeConfigSnapshotBizService {

    @Autowired
    private PatientPushServeConfigSnapshotInfoService patientPushServeConfigSnapshotInfoService;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public PatientPushServeConfigSnapshotVO add(PatientPushServeConfigSnapshotAddDTO params) {
        log.info("PatientPushServeConfigSnapshotBizServiceImpl:add:params:>>>>>> {}", JSON.toJSONString(params));
        PatientPushServeConfigSnapshotInfo entity = patientPushServeConfigSnapshotInfoService.getOne(new QueryWrapper<PatientPushServeConfigSnapshotInfo>()
                .eq("id", params.getId())
                .eq("push_serve_id", params.getPushServeId())
        );
        if (null != entity) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_EXISTS);
        }

        entity = new PatientPushServeConfigSnapshotInfo();
        entity.setId(params.getId());
        entity.setPushServeId(params.getPushServeId());
        entity.setOpUser(params.getOpUser());
        entity.setOpDate(DateUtil.date());
        entity.setPushServeConfig(params.getPushServeConfig());
        log.info("PatientPushServeConfigSnapshotBizServiceImpl:add:entity:>>>>>> {}", JSON.toJSONString(entity));
        patientPushServeConfigSnapshotInfoService.save(entity);

        return PatientPushServeHelper.getPatientPushServeConfigSnapshotVO(entity);
    }

}
