package com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.customer.client.api.CustomerFamilyClientService;
import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;
import com.xxh.cloud.customer.client.api.bean.dto.MemberFamilyListClientDTO;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.constant.PatientPushServeConstant;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeConfigSnapshotInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeDateInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeHistoryInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientRemindInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientScheduleInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeConfigSnapshotInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeDateInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeHistoryInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientRemindInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientScheduleInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeConfigSnapshotQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeDateQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeHistoryQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleGetDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeDateVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeHistoryVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientScheduleVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.helper.PatientPushServeHelper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.mapper.PatientPushServeMapper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeQueryBizService;
import com.xxh.cloud.log.bean.constant.ObjectTypeEnum;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * zs20230920
 */
@Slf4j
@Service
public class PatientPushServeQueryBizServiceImpl implements PatientPushServeQueryBizService {
    
    @Autowired
    private PatientPushServeConfigSnapshotInfoService patientPushServeConfigSnapshotInfoService;
    @Autowired
    private PatientPushServeInfoService patientPushServeInfoService;
    @Autowired
    private PatientRemindInfoService patientRemindInfoService;
    @Autowired
    private PatientScheduleInfoService patientScheduleInfoService;
    @Autowired
    private PatientPushServeHistoryInfoService patientPushServeHistoryInfoService;
    @Autowired
    private CustomerFamilyClientService customerFamilyClientService;
    @Autowired
    private PatientPushServeDateInfoService patientPushServeDateInfoService;
    @Autowired
    private PatientPushServeMapper patientPushServeMapper;
    @Autowired
    private PatientClientService patientClientService;

    @Override
    public List<PatientPushServeConfigSnapshotVO> listServeConfigSnapshot(PatientPushServeConfigSnapshotQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:listServeConfigSnapshot:params:>>>>>> {}", JSON.toJSONString(params));
        List<PatientPushServeConfigSnapshotInfo> list = patientPushServeConfigSnapshotInfoService.list(new QueryWrapper<PatientPushServeConfigSnapshotInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .orderByDesc("op_date")
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(PatientPushServeHelper::getPatientPushServeConfigSnapshotVO).collect(Collectors.toList());
    }

    @Override
    public PatientPushServeConfigSnapshotVO getServeConfigSnapshotById(String id) {
        log.info("PatientPushServeQueryBizServiceImpl:getServeConfigSnapshot:params:>>>>>> {}", id);
        PatientPushServeConfigSnapshotInfo entity = patientPushServeConfigSnapshotInfoService.getById(id);
        if (null == entity) {
            return null;
        }
        return PatientPushServeHelper.getPatientPushServeConfigSnapshotVO(entity);
    }

    @Override
    public List<PatientPushServeVO> pushServeList(PatientPushServeQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServeList:params:>>>>>> {}", JSON.toJSONString(params));
        QueryWrapper<PatientPushServeInfo> queryWrapper = new QueryWrapper<PatientPushServeInfo>();

        queryWrapper.and(CollectionUtil.isNotEmpty(params.getSendDateList()), i -> {
            params.getSendDateList().forEach(sendDate -> {
                i.or().like("send_date_list_no", sendDate);
            });
        });

        queryWrapper.eq(StrUtil.isNotEmpty(params.getId()), "id", params.getId())
            .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
            .eq(StrUtil.isNotBlank(params.getPushServeName()), "push_serve_name", params.getPushServeName())
            .eq(StrUtil.isNotBlank(params.getPushServeTitle()), "push_serve_title", params.getPushServeTitle())
            .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
            .eq(StrUtil.isNotBlank(params.getRemindWay()), "remind_way", params.getRemindWay())
            .eq("rows_status", YN.YES.getCode())
            .orderByDesc("create_date")
            .last(null != params.getLimit(), " limit " + params.getLimit());

        List<PatientPushServeInfo> entityList = patientPushServeInfoService.list(queryWrapper);
        if (CollectionUtil.isEmpty(entityList)) {
            return new ArrayList<>(0);
        }

        Set<String> snapshotIds = new HashSet<>();
        entityList.forEach(i -> snapshotIds.add(i.getSnapshotId()));
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotQueryParam patientPushServeConfigSnapshotQueryParam = new PatientPushServeConfigSnapshotQueryParam();
        patientPushServeConfigSnapshotQueryParam.setIds(snapshotIds);
        List<PatientPushServeConfigSnapshotVO> patientPushServeConfigSnapshotVos = this.listServeConfigSnapshot(patientPushServeConfigSnapshotQueryParam);

        Map<String, PatientPushServeConfigSnapshotVO> configMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(patientPushServeConfigSnapshotVos)) {
            patientPushServeConfigSnapshotVos.forEach(i -> configMap.put(i.getId(), i));
        }

        return entityList.stream().map(i -> {
            PatientPushServeVO vo = PatientPushServeHelper.getPatientPushServeVO(i);
            PatientPushServeConfigSnapshotVO configVO = configMap.get(i.getSnapshotId());
            if (null != configVO) {
                vo.setPushServeConfig(configVO.getPushServeConfig());
            }
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public PageData<PatientPushServeVO> pushServePage(PatientPushServeQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServePage:params:>>>>>> {}", JSON.toJSONString(params));
        IPage<PatientPushServeInfo> entityPage = patientPushServeInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientPushServeInfo>()
                .eq(StrUtil.isNotEmpty(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
                .eq(StrUtil.isNotBlank(params.getPushServeName()), "push_serve_name", params.getPushServeName())
                .eq(StrUtil.isNotBlank(params.getPushServeTitle()), "push_serve_title", params.getPushServeTitle())
                .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
                .eq(StrUtil.isNotBlank(params.getRemindWay()), "remind_way", params.getRemindWay())
                .eq("rows_status", YN.YES.getCode())
                .orderByDesc("create_date")
        );
        
        Set<String> snapshotIds = new HashSet<>();
        entityPage.getRecords().forEach(i -> snapshotIds.add(i.getSnapshotId()));
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotQueryParam patientPushServeConfigSnapshotQueryParam = new PatientPushServeConfigSnapshotQueryParam();
        patientPushServeConfigSnapshotQueryParam.setIds(snapshotIds);
        List<PatientPushServeConfigSnapshotVO> patientPushServeConfigSnapshotVos = this.listServeConfigSnapshot(patientPushServeConfigSnapshotQueryParam);

        Map<String, PatientPushServeConfigSnapshotVO> configMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(patientPushServeConfigSnapshotVos)) {
            patientPushServeConfigSnapshotVos.forEach(i -> configMap.put(i.getId(), i));
        }

        PageData<PatientPushServeVO> data = new PageConverter<PatientPushServeInfo, PatientPushServeVO>() {
            @Override
            public PatientPushServeVO converter(PatientPushServeInfo entity) {
                PatientPushServeVO vo = PatientPushServeHelper.getPatientPushServeVO(entity);
                PatientPushServeConfigSnapshotVO configVO = configMap.get(entity.getSnapshotId());
                if (null != configVO) {
                    vo.setPushServeConfig(configVO.getPushServeConfig());
                }
                return vo;
            }
        }.getPageData(entityPage);
        return data;
    }

    @Override
    public PatientPushServeVO pushServeDetail(PatientPushServeQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServeDetail:params:>>>>>> {}", JSON.toJSONString(params));
        PatientPushServeInfo entity = patientPushServeInfoService.getOne(new QueryWrapper<PatientPushServeInfo>()
                .eq(StrUtil.isNotEmpty(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
                .eq(StrUtil.isNotBlank(params.getPushServeName()), "push_serve_name", params.getPushServeName())
                .eq(StrUtil.isNotBlank(params.getPushServeTitle()), "push_serve_title", params.getPushServeTitle())
                .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
                .eq(StrUtil.isNotBlank(params.getRemindWay()), "remind_way", params.getRemindWay())
                .eq("rows_status", YN.YES.getCode())
                .last(" limit 1 ")
        );
        if (null == entity) {
            return null;
        }
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotVO configVO = this.getServeConfigSnapshotById(entity.getSnapshotId());

        PatientPushServeVO vo = PatientPushServeHelper.getPatientPushServeVO(entity);
        vo.setPushServeConfig(configVO.getPushServeConfig());

        return vo;
    }

    @Override
    public PageData<PatientPushServeHistoryVO> pushServeHistoryPage(PatientPushServeHistoryQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServeHistoryPage:params:>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        IPage<PatientPushServeHistoryInfo> entityPage = patientPushServeHistoryInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientPushServeHistoryInfo>()
                .eq(StrUtil.isNotEmpty(params.getPatientPushServeId()), "patient_push_serve_id", params.getPatientPushServeId())
                .in(CollectionUtil.isNotEmpty(params.getPatientPushServeIds()), "patient_push_serve_id", params.getPatientPushServeIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
                .like(StrUtil.isNotBlank(params.getPushServeName()), "push_serve_name", params.getPushServeName())
                .eq(StrUtil.isNotBlank(params.getPushServeTitle()), "push_serve_title", params.getPushServeTitle())
                .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .ge(null != params.getStartDate(), "op_date", params.getStartDate())
                .lt(null != params.getEndDate(), "op_date", params.getEndDate())
                .inSql(StrUtil.isNotBlank(params.getPatientName()), "patient_id", 
                        StrUtil.format("SELECT patient_id FROM hd_task_patient_info WHERE patient_name LIKE '%{}%'", params.getPatientName())
                )
                .orderByDesc("op_date")
        );

        if (null == entityPage || CollUtil.isEmpty(entityPage.getRecords())) {
            return new PageData<>(null, 0);
        }
        
        Set<String> snapshotIds = new HashSet<>();
        entityPage.getRecords().forEach(i -> snapshotIds.add(i.getSnapshotId()));
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotQueryParam patientPushServeConfigSnapshotQueryParam = new PatientPushServeConfigSnapshotQueryParam();
        patientPushServeConfigSnapshotQueryParam.setIds(snapshotIds);
        List<PatientPushServeConfigSnapshotVO> patientPushServeConfigSnapshotVos = this.listServeConfigSnapshot(patientPushServeConfigSnapshotQueryParam);

        Map<String, PatientPushServeConfigSnapshotVO> configMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(patientPushServeConfigSnapshotVos)) {
            patientPushServeConfigSnapshotVos.forEach(i -> configMap.put(i.getId(), i));
        }

        PageData<PatientPushServeHistoryVO> data = new PageConverter<PatientPushServeHistoryInfo, PatientPushServeHistoryVO>() {
            @Override
            public PatientPushServeHistoryVO converter(PatientPushServeHistoryInfo entity) {
                PatientPushServeHistoryVO vo = PatientPushServeHelper.getPatientPushServeHistoryVO(entity);
                PatientPushServeConfigSnapshotVO configVO = configMap.get(entity.getSnapshotId());
                if (null != configVO) {
                    vo.setPushServeConfig(configVO.getPushServeConfig());
                }
                return vo;
            }
        }.getPageData(entityPage);
        return data;
    }

    @Override
    public List<PatientPushServeHistoryVO> pushServeHistoryList(PatientPushServeHistoryQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServeHistoryList(PatientPushServeQueryParam):>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        List<PatientPushServeHistoryInfo> entityList = patientPushServeHistoryInfoService.list(new QueryWrapper<PatientPushServeHistoryInfo>()
            .eq(StrUtil.isNotEmpty(params.getId()), "id", params.getId())
            .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
            .eq(StrUtil.isNotEmpty(params.getPatientPushServeId()), "patient_push_serve_id", params.getPatientPushServeId())
            .in(CollectionUtil.isNotEmpty(params.getPatientPushServeIds()), "patient_push_serve_id", params.getPatientPushServeIds())
            .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
            .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
            .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
            .in(CollectionUtil.isNotEmpty(params.getPushServeIds()), "push_serve_id", params.getPushServeIds())
            .eq(StrUtil.isNotBlank(params.getPushServeName()), "push_serve_name", params.getPushServeName())
            .eq(StrUtil.isNotBlank(params.getPushServeTitle()), "push_serve_title", params.getPushServeTitle())
            .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
            .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
            .ge(null != params.getStartDate(), "op_date", params.getStartDate())
            .lt(null != params.getEndDate(), "op_date", params.getEndDate())
            .orderByDesc("op_date"));
        if (CollectionUtil.isEmpty(entityList)) {
            return new ArrayList<>(0);
        }

        Set<String> snapshotIds = new HashSet<>();
        entityList.forEach(i -> snapshotIds.add(i.getSnapshotId()));
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotQueryParam patientPushServeConfigSnapshotQueryParam = new PatientPushServeConfigSnapshotQueryParam();
        patientPushServeConfigSnapshotQueryParam.setIds(snapshotIds);
        List<PatientPushServeConfigSnapshotVO> patientPushServeConfigSnapshotVos = this.listServeConfigSnapshot(patientPushServeConfigSnapshotQueryParam);

        Map<String, PatientPushServeConfigSnapshotVO> configMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(patientPushServeConfigSnapshotVos)) {
            patientPushServeConfigSnapshotVos.forEach(i -> configMap.put(i.getId(), i));
        }

        return entityList.stream().map(i -> {
            PatientPushServeHistoryVO vo = PatientPushServeHelper.getPatientPushServeHistoryVO(i);
            PatientPushServeConfigSnapshotVO configVO = configMap.get(i.getSnapshotId());
            if (null != configVO) {
                vo.setPushServeConfig(configVO.getPushServeConfig());
            }
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public PatientPushServeHistoryVO pushServeHistoryDetail(PatientPushServeHistoryQueryParam params) {
        log.info("PatientPushServeQueryBizServiceImpl:pushServeHistoryDetail:params:>>>>>> {}", JSON.toJSONString(params));
        PatientPushServeHistoryInfo entity = patientPushServeHistoryInfoService.getOne(new QueryWrapper<PatientPushServeHistoryInfo>()
                .eq(StrUtil.isNotEmpty(params.getPatientPushServeId()), "patient_push_serve_id", params.getPatientPushServeId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
                .eq(StrUtil.isNotBlank(params.getSendStatus()), "send_status", params.getSendStatus())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .last(" limit 1 ")
        );
        if (null == entity) {
            return null;
        }
        // 通过快照key查询快照信息
        PatientPushServeConfigSnapshotVO configVO = this.getServeConfigSnapshotById(entity.getSnapshotId());

        PatientPushServeHistoryVO vo = PatientPushServeHelper.getPatientPushServeHistoryVO(entity);
        vo.setPushServeConfig(configVO.getPushServeConfig());

        return vo;
    }

    @Override
    public PageData<PatientScheduleVO> patientSchedulePage(PatientScheduleQueryDTO params) {
        if (StrUtil.isNotBlank(params.getEndDate())) {
            String endDate = DateUtil.offsetDay(DateUtil.parse(params.getEndDate()), 1).toDateStr(); // 往后偏移一天
            params.setEndDate(endDate);
        }
        IPage<PatientScheduleInfo> page = patientScheduleInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientScheduleInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .in(CollectionUtil.isNotEmpty(params.getUserIds()), "user_id", params.getUserIds())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "schedule_date", params.getStartDate())
                .lt(StrUtil.isNotBlank(params.getEndDate()), "schedule_date", params.getEndDate())
                // zs20231021
                .eq(StrUtil.isNotEmpty(params.getScheduleType()), "schedule_type", params.getScheduleType())
                .in(CollectionUtil.isNotEmpty(params.getScheduleTypes()), "schedule_type", params.getScheduleTypes())
                .orderByAsc("schedule_date")
        );

        Map<String, PatientPushServeHistoryVO> patientPushServeMap = new HashMap<>();
        Map<String, MemberFamilyBO> memberFamilyMap = new HashMap<>(); // 查询家庭成员
        if (CollectionUtil.isNotEmpty(page.getRecords())) {
            List<String> patientPushServeIds = new ArrayList<>();
            List<String> patientIds = new ArrayList<>();
            page.getRecords().forEach(i -> {
                if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(i.getBizOneType())) { // 患者推送服务类型的日程才需要查询推送服务
                    patientPushServeIds.add(i.getBizId());
                }
                patientIds.add(i.getPatientId());
            });

            if (CollectionUtil.isNotEmpty(patientPushServeIds)) {
                PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
                patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIds);
                patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
                List<PatientPushServeHistoryVO> patientPushServeVOs = this.pushServeHistoryList(patientPushServeHistoryQueryParam);
                if (CollectionUtil.isNotEmpty(patientPushServeVOs)) {
                    patientPushServeVOs.forEach(i -> {
                        PatientPushServeHistoryVO bo = patientPushServeMap.get(i.getPatientPushServeId());
                        if (null == bo) {
                            patientPushServeMap.put(i.getPatientPushServeId(), i);
                        }
                    });
                }
            }

            // family
            if (CollectionUtil.isNotEmpty(patientIds)) {
                MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
                memberFamilyListClientDTO.setPatHisNos(patientIds); // zs20231115 家属表中patientId来自海鹚和本平台的patientId不一致，一致的是patHisNos（就诊人门诊id）
                memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
                List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
                if (CollectionUtil.isNotEmpty(memberFamilyList)) {
                    memberFamilyList.forEach(i -> memberFamilyMap.put(i.getPatHisNo() + "-" + i.getUserId(), i));
                }
            }
            // if (CollectionUtil.isNotEmpty(patientIds)) {
            //     MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
            //     memberFamilyListClientDTO.setMainPersonIds(patientIds);
            //     memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
            //     List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
            //     if (CollectionUtil.isNotEmpty(memberFamilyList)) {
            //         memberFamilyList.forEach(i -> memberFamilyMap.put(i.getMainPersonId() + "-" + i.getUserId(), i));
            //     }
            // }
        }

        PageData<PatientScheduleVO> data = new PageConverter<PatientScheduleInfo, PatientScheduleVO>() {
            @Override
            public PatientScheduleVO converter(PatientScheduleInfo entity) {
                PatientScheduleVO vo = PatientPushServeHelper.getPatientScheduleVO(entity);
                vo.setPatientPushServeVO(patientPushServeMap.get(entity.getBizId()));
                
                MemberFamilyBO member = memberFamilyMap.get(entity.getPatientId() + "-" + entity.getUserId());
                if (null != member) {
                    vo.setRelationName(member.getRelationName());
                }
                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<PatientScheduleVO> patientScheduleList(PatientScheduleQueryDTO params) {
        if (StrUtil.isNotBlank(params.getEndDate())) {
            String endDate = DateUtil.offsetDay(DateUtil.parse(params.getEndDate()), 1).toDateStr(); // 往后偏移一天
            params.setEndDate(endDate);
        }
        List<PatientScheduleInfo> list = patientScheduleInfoService.list(new QueryWrapper<PatientScheduleInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .in(CollectionUtil.isNotEmpty(params.getUserIds()), "user_id", params.getUserIds())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "schedule_date", params.getStartDate())
                .lt(StrUtil.isNotBlank(params.getEndDate()), "schedule_date", params.getEndDate())
                // zs20231021
                .eq(StrUtil.isNotEmpty(params.getScheduleType()), "schedule_type", params.getScheduleType())
                .in(CollectionUtil.isNotEmpty(params.getScheduleTypes()), "schedule_type", params.getScheduleTypes())
                .in(CollectionUtil.isNotEmpty(params.getBizIdAndScheduleDate()), "CONCAT(biz_id, '-', schedule_date)", params.getBizIdAndScheduleDate())
                .in(CollectionUtil.isNotEmpty(params.getQuerParams()), "CONCAT(biz_id, '-', user_id, '-', schedule_date)", params.getQuerParams())
                .orderByAsc("schedule_date")
        );

        Map<String, PatientPushServeHistoryVO> patientPushServeMap = new HashMap<>();
        Map<String, MemberFamilyBO> memberFamilyMap = new HashMap<>(); // 查询家庭成员
        if (CollectionUtil.isNotEmpty(list)) {
            List<String> patientPushServeIds = new ArrayList<>();
            List<String> patientIds = new ArrayList<>();
            list.forEach(i -> {
                if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(i.getBizOneType())) { // 患者推送服务类型的日程才需要查询推送服务
                    patientPushServeIds.add(i.getBizId());
                }
                patientIds.add(i.getPatientId());
            });

            if (CollectionUtil.isNotEmpty(patientPushServeIds)) {
                PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
                patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIds);
                patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
                List<PatientPushServeHistoryVO> patientPushServeVOs = this.pushServeHistoryList(patientPushServeHistoryQueryParam);
                if (CollectionUtil.isNotEmpty(patientPushServeVOs)) {
                    patientPushServeVOs.forEach(i -> {
                        PatientPushServeHistoryVO bo = patientPushServeMap.get(i.getPatientPushServeId());
                        if (null == bo) {
                            patientPushServeMap.put(i.getPatientPushServeId(), i);
                        }
                    });
                }
            }

            // family
            if (CollectionUtil.isNotEmpty(patientIds)) {
                if (CollectionUtil.isNotEmpty(patientIds)) {
                    MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
                    memberFamilyListClientDTO.setPatHisNos(patientIds); // zs20231115 家属表中patientId来自海鹚和本平台的patientId不一致，一致的是patHisNos（就诊人门诊id）
                    memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
                    List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
                    if (CollectionUtil.isNotEmpty(memberFamilyList)) {
                        memberFamilyList.forEach(i -> memberFamilyMap.put(i.getPatHisNo() + "-" + i.getUserId(), i));
                    }
                }
            }
            // if (CollectionUtil.isNotEmpty(patientIds)) {
            //     if (CollectionUtil.isNotEmpty(patientIds)) {
            //         MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
            //         memberFamilyListClientDTO.setMainPersonIds(patientIds);
            //         memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
            //         List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
            //         if (CollectionUtil.isNotEmpty(memberFamilyList)) {
            //             memberFamilyList.forEach(i -> memberFamilyMap.put(i.getMainPersonId() + "-" + i.getUserId(), i));
            //         }
            //     }
            // }
        }

        return list.stream().map(i -> {
            PatientScheduleVO vo = PatientPushServeHelper.getPatientScheduleVO(i);
            vo.setPatientPushServeVO(patientPushServeMap.get(i.getBizId()));

            MemberFamilyBO member = memberFamilyMap.get(i.getPatientId() + "-" + i.getUserId());
            if (null != member) {
                vo.setRelationName(member.getRelationName());
            }
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public PageData<PatientScheduleVO> patientSchedulePatientPage(PatientScheduleQueryDTO params) {
        if (StrUtil.isNotBlank(params.getEndDate())) {
            String endDate = DateUtil.offsetDay(DateUtil.parse(params.getEndDate()), 1).toDateStr(); // 往后偏移一天
            params.setEndDate(endDate);
        }
        IPage<PatientScheduleInfo> page = patientPushServeMapper.patientScheduleGroup(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientScheduleInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .in(CollectionUtil.isNotEmpty(params.getUserIds()), "user_id", params.getUserIds())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "schedule_date", params.getStartDate())
                .lt(StrUtil.isNotBlank(params.getEndDate()), "schedule_date", params.getEndDate())
                // zs20231021
                .eq(StrUtil.isNotEmpty(params.getScheduleType()), "schedule_type", params.getScheduleType())
                .in(CollectionUtil.isNotEmpty(params.getScheduleTypes()), "schedule_type", params.getScheduleTypes())
        );

        Map<String, PatientPushServeHistoryVO> patientPushServeMap = new HashMap<>();
        Map<String, MemberFamilyBO> memberFamilyMap = new HashMap<>(); // 查询家庭成员
        if (CollectionUtil.isNotEmpty(page.getRecords())) {
            List<String> patientPushServeIds = new ArrayList<>();
            List<String> patientIds = new ArrayList<>();
            page.getRecords().forEach(i -> {
                if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(i.getBizOneType())) { // 患者推送服务类型的日程才需要查询推送服务
                    patientPushServeIds.add(i.getBizId());
                }
                patientIds.add(i.getPatientId());
            });

            if (CollectionUtil.isNotEmpty(patientPushServeIds)) {
                PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
                patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIds);
                patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
                List<PatientPushServeHistoryVO> patientPushServeVOs = this.pushServeHistoryList(patientPushServeHistoryQueryParam);
                if (CollectionUtil.isNotEmpty(patientPushServeVOs)) {
                    patientPushServeVOs.forEach(i -> {
                        PatientPushServeHistoryVO bo = patientPushServeMap.get(i.getPatientPushServeId());
                        if (null == bo) {
                            patientPushServeMap.put(i.getPatientPushServeId(), i);
                        }
                    });
                }
            }

            // family
            if (CollectionUtil.isNotEmpty(patientIds)) {
                MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
                memberFamilyListClientDTO.setPatHisNos(patientIds); // zs20231115 家属表中patientId来自海鹚和本平台的patientId不一致，一致的是patHisNos（就诊人门诊id）
                memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
                List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
                if (CollectionUtil.isNotEmpty(memberFamilyList)) {
                    memberFamilyList.forEach(i -> memberFamilyMap.put(i.getPatHisNo() + "-" + i.getUserId(), i));
                }
            }
            // if (CollectionUtil.isNotEmpty(patientIds)) {
            //     MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
            //     memberFamilyListClientDTO.setMainPersonIds(patientIds);
            //     memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
            //     List<MemberFamilyBO> memberFamilyList = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
            //     if (CollectionUtil.isNotEmpty(memberFamilyList)) {
            //         memberFamilyList.forEach(i -> memberFamilyMap.put(i.getMainPersonId() + "-" + i.getUserId(), i));
            //     }
            // }
        }

        PageData<PatientScheduleVO> data = new PageConverter<PatientScheduleInfo, PatientScheduleVO>() {
            @Override
            public PatientScheduleVO converter(PatientScheduleInfo entity) {
                PatientScheduleVO vo = PatientPushServeHelper.getPatientScheduleVO(entity);
                vo.setPatientPushServeVO(patientPushServeMap.get(entity.getBizId()));
                
                MemberFamilyBO member = memberFamilyMap.get(entity.getPatientId() + "-" + entity.getUserId());
                if (null != member) {
                    vo.setRelationName(member.getRelationName());
                }
                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public PageData<PatientScheduleVO> patientSchedulePatientByServicePage(PatientScheduleQueryDTO params) {
        if (StrUtil.isNotBlank(params.getEndDate())) {
            String endDate = DateUtil.offsetDay(DateUtil.parse(params.getEndDate()), 1).toDateStr(); // 往后偏移一天
            params.setEndDate(endDate);
        }
        IPage<PatientPushServeDateInfo> serviceDatePage = patientPushServeMapper.patientSchedulePatientByServicePage(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientPushServeDateInfo>()
                .eq("a.op_type", OpTypeEnum.Create.getCode())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "a.patient_id", params.getPatientIds())
                .ge(null != params.getStartDate(), "b.send_date", params.getStartDate())
                .lt(null != params.getEndDate(), "b.send_date", params.getEndDate())
                .eq(StrUtil.isNotEmpty(params.getScheduleType()), "a.remind_way", params.getScheduleType())
                .in(CollectionUtil.isNotEmpty(params.getScheduleTypes()), "a.remind_way", params.getScheduleTypes())
        );

        Map<String, PatientPushServeHistoryVO> patientPushServeMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(serviceDatePage.getRecords())) {
            List<String> patientPushServeIds = new ArrayList<>();
            List<String> patientIds = new ArrayList<>();
            serviceDatePage.getRecords().forEach(i -> {
                patientPushServeIds.add(i.getPatientPushServeId());
                patientIds.add(i.getPatientId());
            });

            if (CollectionUtil.isNotEmpty(patientPushServeIds)) {
                PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
                patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIds);
                patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
                List<PatientPushServeHistoryVO> patientPushServeVOs = this.pushServeHistoryList(patientPushServeHistoryQueryParam);
                if (CollectionUtil.isNotEmpty(patientPushServeVOs)) {
                    patientPushServeVOs.forEach(i -> {
                        PatientPushServeHistoryVO bo = patientPushServeMap.get(i.getPatientPushServeId());
                        if (null == bo) {
                            patientPushServeMap.put(i.getPatientPushServeId(), i);
                        }
                    });
                }
            }
        }

        PageData<PatientScheduleVO> data = new PageConverter<PatientPushServeDateInfo, PatientScheduleVO>() {
            @Override
            public PatientScheduleVO converter(PatientPushServeDateInfo entity) {
                
                PatientScheduleVO schedule = new PatientScheduleVO();
                schedule.setPatientId(entity.getPatientId());
                schedule.setUserId(entity.getPatientId());
                schedule.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
                schedule.setBizId(entity.getPatientPushServeId());
                schedule.setScheduleDate(entity.getSendDate());
                schedule.setStatus(PatientPushServeConstant.ScheduleStatus.TODO.getCode());
                
                PatientPushServeHistoryVO historyService = patientPushServeMap.get(entity.getPatientPushServeId());
                if (null != historyService) {
                    schedule.setTitle(historyService.getPushServeTitle());

                    PushServeConfigBO serviceConfig = historyService.getPushServeConfig();
                    if (null != serviceConfig) {
                        schedule.setContent(serviceConfig.getMediaId());
                        schedule.setScheduleType(serviceConfig.getRemindWay());
                    }
                }

                schedule.setPatientPushServeVO(historyService);

                return schedule;
            }
        }.getPageData(serviceDatePage);
        return data;
    }

    // zs20231021
    @Override
    public PatientScheduleVO patientScheduleDetail(PatientScheduleGetDTO params) {
        PatientScheduleInfo entity = patientScheduleInfoService.getOne(new QueryWrapper<PatientScheduleInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .in(CollectionUtil.isNotEmpty(params.getUserIds()), "user_id", params.getUserIds())
                // zs20231021
                .eq(StrUtil.isNotEmpty(params.getScheduleType()), "schedule_type", params.getScheduleType())
                .in(CollectionUtil.isNotEmpty(params.getScheduleTypes()), "schedule_type", params.getScheduleTypes())
                .last(" limit 1 ")
        );

        if (null == entity) {
            return null;
        }

        PatientScheduleVO vo = PatientPushServeHelper.getPatientScheduleVO(entity);

        // 查询推送服务历史
        if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(entity.getBizOneType())) {
            PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
            patientPushServeHistoryQueryParam.setPatientPushServeId(entity.getBizId());
            patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
            PatientPushServeHistoryVO patientPushServeVO = this.pushServeHistoryDetail(patientPushServeHistoryQueryParam);

            vo.setPatientPushServeVO(patientPushServeVO);
        }
        return vo;
    }

    @Override
    public PageData<PatientRemindVO> pagePatientRemind(PatientRemindQueryDTO params) {
        IPage<PatientRemindInfo> page = patientRemindInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<PatientRemindInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getPushStatus()), "push_status", params.getPushStatus())
                .eq(StrUtil.isNotBlank(params.getPushChannel()), "push_channel", params.getPushChannel())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .eq(StrUtil.isNotBlank(params.getBizId()), "biz_id", params.getBizId())
                .in(CollectionUtil.isNotEmpty(params.getBizIds()), "biz_id", params.getBizIds())
                .in(CollectionUtil.isNotEmpty(params.getBizIdAndPushDate()), "CONCAT(biz_id, '-', push_date)", params.getBizIdAndPushDate())
                .in(CollectionUtil.isNotEmpty(params.getQuerParams()), "CONCAT(biz_id, '-', user_id, '-', push_date)", params.getQuerParams())
                .ge(null != params.getStartDate(), "push_date", params.getStartDate())
                .lt(null != params.getEndDate(), "push_date", params.getEndDate())
                .orderByDesc("push_date")
                .last(null != params.getLimit(), " limit " + params.getLimit()) // 查询指定数量的提醒记录，防止数据量太大
        );

        if (null == page || CollUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        List<PatientRemindInfo> patientRemindInfos = page.getRecords();

        Set<String> patientIds = new HashSet<>();
        patientRemindInfos.forEach(i -> patientIds.add(i.getPatientId()));

        // 患者信息
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(new ArrayList<>(patientIds));
            List<PatientClientBO> patients = patientClientService.simpleList(patientQueryDTO);
            if (CollUtil.isNotEmpty(patients)) {
                patients.forEach(i -> patientMap.put(i.getPatientId(), i));
            }
        }

        PageData<PatientRemindVO> data = new PageConverter<PatientRemindInfo, PatientRemindVO>() {
            @Override
            public PatientRemindVO converter(PatientRemindInfo entity) {
                PatientRemindVO vo = PatientPushServeHelper.getPatientRemindVO(entity);
                vo.setPatientInfo(patientMap.get(entity.getPatientId()));
                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<PatientRemindVO> listPatientRemind(PatientRemindQueryDTO params) {
        List<PatientRemindInfo> patientRemindInfos = patientRemindInfoService.list(new QueryWrapper<PatientRemindInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getPushStatus()), "push_status", params.getPushStatus())
                .eq(StrUtil.isNotBlank(params.getPushChannel()), "push_channel", params.getPushChannel())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .eq(StrUtil.isNotBlank(params.getBizId()), "biz_id", params.getBizId())
                .in(CollectionUtil.isNotEmpty(params.getBizIds()), "biz_id", params.getBizIds())
                .in(CollectionUtil.isNotEmpty(params.getBizIdAndPushDate()), "CONCAT(biz_id, '-', push_date)", params.getBizIdAndPushDate())
                .in(CollectionUtil.isNotEmpty(params.getQuerParams()), "CONCAT(biz_id, '-', user_id, '-', push_date)", params.getQuerParams())
                .ge(null != params.getStartDate(), "push_date", params.getStartDate())
                .lt(null != params.getEndDate(), "push_date", params.getEndDate())
                .orderByDesc("push_date")
                .last(null != params.getLimit(), " limit " + params.getLimit()) // 查询指定数量的提醒记录，防止数据量太大
        );

        if (CollUtil.isEmpty(patientRemindInfos)) {
            return new ArrayList<>(0);
        }

        Set<String> patientIds = new HashSet<>();
        patientRemindInfos.forEach(i -> patientIds.add(i.getPatientId()));

        // 患者信息
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(new ArrayList<>(patientIds));
            List<PatientClientBO> patients = patientClientService.simpleList(patientQueryDTO);
            if (CollUtil.isNotEmpty(patients)) {
                patients.forEach(i -> patientMap.put(i.getPatientId(), i));
            }
        }

        return patientRemindInfos.stream().map(i -> {
            PatientRemindVO vo = PatientPushServeHelper.getPatientRemindVO(i);
            vo.setPatientInfo(patientMap.get(i.getPatientId()));
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public PatientRemindVO getPatientRemind(PatientRemindQueryDTO params) {
        PatientRemindInfo entity = patientRemindInfoService.getOne(new QueryWrapper<PatientRemindInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
        );
        if (null == entity) {
            return null;
        }

        PatientRemindVO vo = PatientPushServeHelper.getPatientRemindVO(entity);

        // 查询推送服务历史
        if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(entity.getBizOneType())) {
            PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
            patientPushServeHistoryQueryParam.setPatientPushServeId(entity.getBizId());
            patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
            PatientPushServeHistoryVO patientPushServeVO = this.pushServeHistoryDetail(patientPushServeHistoryQueryParam);

            vo.setPatientPushServeVO(patientPushServeVO);
        }

        // 患者信息
        if (StrUtil.isNotBlank(vo.getPatientId())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientId(vo.getPatientId());
            vo.setPatientInfo(patientClientService.getOneSimple(patientQueryDTO));
        }
        return vo;
    }

    @Override
    public List<PatientPushServeDateVO> pushServeDateList(PatientPushServeDateQueryParam params) {
        List<PatientPushServeDateInfo> list = patientPushServeDateInfoService.list(new QueryWrapper<PatientPushServeDateInfo>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getPatientPushServeId()), "patient_push_serve_id", params.getPatientPushServeId())
                .in(CollectionUtil.isNotEmpty(params.getPatientPushServeIds()), "patient_push_serve_id", params.getPatientPushServeIds())
                .ge(null != params.getStartDate(), "send_date", params.getStartDate())
                .lt(null != params.getEndDate(), "send_date", params.getEndDate()));

        return list.stream().map(PatientPushServeHelper::getPatientPushServeDateVO).collect(Collectors.toList());
    }

}
