package com.xxh.cloud.healthy.serve.pushServe.framework.modules.client.service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.serve.pushServe.client.api.PatientReturnVisitClientService;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientReturnVisitBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientReturnVisitAddClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientReturnVisitQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientReturnVisitUpdateClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientReturnVisitAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientReturnVisitQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientReturnVisitUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientReturnVisitVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.helper.PatientPushServeHelper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientReturnVisitBizService;

import cn.hutool.core.collection.CollUtil;

@Service
public class PatientReturnVisitClientServiceImpl implements PatientReturnVisitClientService {

    @Autowired
    private PatientReturnVisitBizService patientReturnVisitBizService;

    @Override
    public void saveBatch(List<PatientReturnVisitAddClientDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }

        List<PatientReturnVisitAddDTO> list = new ArrayList<>();
        params.forEach(i -> {
            PatientReturnVisitAddDTO entity = new PatientReturnVisitAddDTO();
            entity.setPatientId(i.getPatientId());
            entity.setVisitType(i.getVisitType());
            entity.setVisitId(i.getVisitId());
            entity.setSourceType(i.getSourceType());
            entity.setSourceId(i.getSourceId());
            entity.setSourceDeptId(i.getSourceDeptId());
            entity.setSourceTime(i.getSourceTime());
            entity.setDeptIds(i.getDeptIds());
            entity.setDeptId(i.getDeptId());
            entity.setContent(i.getContent());
            entity.setVisitStartTime(i.getVisitStartTime());
            entity.setVisitEndTime(i.getVisitEndTime());
            entity.setRealTime(i.getRealTime());
            entity.setStatus(i.getStatus());
            entity.setOpType(i.getOpType());

            list.add(entity);
        });

        patientReturnVisitBizService.saveBatch(list);
    }

    @Override
    public List<PatientReturnVisitBO> list(PatientReturnVisitQueryClientDTO params) {
        
        PatientReturnVisitQueryDTO patientReturnVisitQueryDTO = new PatientReturnVisitQueryDTO();
        patientReturnVisitQueryDTO.setId(params.getId());
        patientReturnVisitQueryDTO.setPatientId(params.getPatientId());
        patientReturnVisitQueryDTO.setVisitType(params.getVisitType());
        patientReturnVisitQueryDTO.setVisitId(params.getVisitId());
        patientReturnVisitQueryDTO.setSourceType(params.getSourceType());
        patientReturnVisitQueryDTO.setSourceId(params.getSourceId());
        patientReturnVisitQueryDTO.setSourceIds(params.getSourceIds());
        patientReturnVisitQueryDTO.setSourceDeptId(params.getSourceDeptId());
        patientReturnVisitQueryDTO.setSourceTime(params.getSourceTime());
        patientReturnVisitQueryDTO.setDeptId(params.getDeptId());
        patientReturnVisitQueryDTO.setContent(params.getContent());
        patientReturnVisitQueryDTO.setVisitStartTime(params.getVisitStartTime());
        patientReturnVisitQueryDTO.setVisitEndTime(params.getVisitEndTime());
        patientReturnVisitQueryDTO.setStatus(params.getStatus());

        List<PatientReturnVisitVO> list = patientReturnVisitBizService.list(patientReturnVisitQueryDTO);

        return list.stream().map(PatientPushServeHelper::getPatientReturnVisitBO).collect(Collectors.toList());
    }

    @Override
    public void updateBatch(List<PatientReturnVisitUpdateClientDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }

        List<PatientReturnVisitUpdateDTO> list = new ArrayList<>();
        params.forEach(i -> {
            PatientReturnVisitUpdateDTO entity = new PatientReturnVisitUpdateDTO();
            entity.setId(i.getId());
            entity.setVisitStartTime(i.getVisitStartTime());
            entity.setStatus(i.getStatus());

            list.add(entity);
        });

        patientReturnVisitBizService.updateBatch(list);
    }
    
}
