package com.xxh.cloud.healthy.serve.pushServe.framework.modules.task.service;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;

/**
 * zs20230921
 * 定时任务推送患者服务
 */
public interface PatientPushServeTaskService {

    /**
     * 查询患者推送服务并进行推送前处理
     * @param cycle 分钟，任务执行周期，用于查询当前周期内的数据
     */
    void pushServeTask(Integer cycle);

    /**
     * 给患者推送服务提醒前处理
     * 
     * @param pushServeList 数据来源可能是缓存/MQ等，由其他服务获取并传递过来
     */
    void pushServeTaskDeal(List<PatientPushServeVO> pushServeList);

    /**
     * 给患者推送服务提醒
     */
    void pushServeTaskExecute();

    /**
     * 给患者推送提醒
     */
    void remindTaskExecute();

    /**
     * 扫描dwd当天的患者检查检验报告并发送提醒
     */
    void pushExamineAndLaboratoryReportTaskExecute();

    /**
     * 扫描dwd患者用药信息并发送日程
     */
    void pushRecipeMedicineTaskExecute();

    void patientPushServeScheduleJob(Date startDate, Date endDate);

    /**
     * 给患者推送用药提醒
     */
    void recipeMedicineRemindTaskExecute();

}
