package com.xxh.cloud.healthy.serve.pushServe.framework.modules.task.service.impl;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.TypeReference;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.xxh.cloud.basic.client.api.ParamsClientService;
import com.xxh.cloud.basic.client.api.VisitVerificationClientService;
import com.xxh.cloud.basic.client.api.bean.bos.VisitVerificationBO;
import com.xxh.cloud.basic.framework.modules.constant.BasicVisitConstant;
import com.xxh.cloud.customer.client.api.CustomerFamilyClientService;
import com.xxh.cloud.customer.client.api.CustomerThirdClientService;
import com.xxh.cloud.customer.client.api.bean.bos.MemberFamilyBO;
import com.xxh.cloud.customer.client.api.bean.bos.SendTempResultBO;
import com.xxh.cloud.customer.client.api.bean.dto.MemberFamilyListClientDTO;
import com.xxh.cloud.customer.client.api.bean.dto.SendTempClientDTO;
import com.xxh.cloud.customer.client.api.bean.dto.ThirdUserUpdateClientDTO;
import com.xxh.cloud.dw.healthy.data.client.api.constant.DwdConstant;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.healthy.basic.common.bean.ServPushConfigModel;
import com.xxh.cloud.healthy.basic.common.constant.OpTypeEnum;
import com.xxh.cloud.healthy.basic.common.constant.PushServeTargetEnum;
import com.xxh.cloud.healthy.basic.common.constant.PushWayEnum;
import com.xxh.cloud.healthy.basic.common.constant.RemindWayEnum;
import com.xxh.cloud.healthy.basic.common.constant.UserTypeEnum;
import com.xxh.cloud.healthy.basic.pushserve.client.api.PushServeConfigClientService;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.ServPushConfigBO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.dto.PushServeConfigClientQueryDTO;
import com.xxh.cloud.healthy.behavior.client.api.constant.BehaviorSourceTypeConstant;
import com.xxh.cloud.healthy.behavior.client.api.util.BehaviorSecureUtil;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientExamineReportClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientLaboratoryReportClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientRecipeMedicineClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientExamineAndLaboratoryReportClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientRecipeMedicineClientDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PushWeixinLogAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.config.WechatConfig;
import com.xxh.cloud.healthy.push.framework.modules.biz.config.WechatTemplateConfig;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.PushWeixinConstant;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.WechatErrorCodeEnum;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PushWeixinBizService;
import com.xxh.cloud.healthy.serve.pushServe.client.api.constant.PatientPushServeConstant;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.entity.PatientPushServeDateInfo;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.base.service.PatientPushServeDateInfoService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeHistoryQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushSyncFlagModel;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindUpdateDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientScheduleAddDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeHistoryVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.mapper.PatientPushServeMapper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.mapper.PatientPushSyncFlagMapper;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeBizService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeQueryBizService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.task.service.PatientPushServeTaskHandlerService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.task.service.PatientPushServeTaskService;
import com.xxh.cloud.log.bean.constant.ObjectTypeEnum;
import com.xxh.cloud.log.bean.dto.TriggerTaskLogBatchGenDTO;
import com.xxh.cloud.log.bean.dto.TriggerTaskLogBatchItem;
import com.xxh.cloud.log.utils.TriggerTaskLogUtils;
import com.xxh.cloud.user.client.api.AdminUserThirdClientService;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

/**
 * zs20230922
 */
@Slf4j
@Service
public class PatientPushServeTaskServiceImpl implements PatientPushServeTaskService {

    private static final String template_CY = "V8lRfeDdXClTbMnDDw_lPWRXq8HoPGnie_vh_zk-2cs"; // 患者出院通知
    private static final String template_YZ = "7Jgx_ay6u7JzFcveJ0lq9W5e2NsOgcRkYcAAXjAmVO4"; // 诊后医嘱已生成通知
    private static final String template_BG = "div8ZOg568mLzAEVT9EaoXHPqQytYbLUjT8jmbjOHJY"; // 检查检验报告通知
    private static final String template_WZ = "NItS0rWuxbhE47eTQp0hqB2ALwse0_nVbTL3jx2S1Ks"; // 完诊通知
    private static final String template_GH = "t6paNLWcXnAzJsQaoqyFblZpNoBYczdoIe6kwWWNAUY"; // 挂号成功通知
    private static final String template_ZYYY = "a7jXg139rVwDwLF0P7hvcRWDGluxQuUCiu4lmcBZkIM"; // 住院预约结果通知

    @Autowired
    private PatientPushServeBizService patientPushServeBizService;
    @Autowired
    private PatientPushServeQueryBizService patientPushServeQueryBizService;
    @Autowired
    private CustomerFamilyClientService customerFamilyClientService;
    @Autowired
    private CustomerThirdClientService customerThirdClientService;
    @Autowired
    private PushWeixinBizService pushWeixinBizService;
    @Autowired
    private WechatConfig wechatConfig;
    @Autowired
    private ParamsClientService paramsClientService; // 从数据库中获取信息配置
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private PatientPushSyncFlagMapper patientPushSyncFlagMapper;
    @Autowired
    private PatientPushServeTaskHandlerService patientPushServeTaskHandlerService;
    @Autowired
    private VisitVerificationClientService visitVerificationClientService;
    @Autowired
    private PushServeConfigClientService pushServeConfigClientService;
    @Autowired
    private PatientPushServeMapper patientPushServeMapper;
    @Autowired
    private PatientPushServeDateInfoService patientPushServeDateInfoService;
    @Autowired
    private AdminUserThirdClientService adminUserThirdClientService;

    @Value("${pushServeCheck.timeDuring:1}")
    private Integer timeDuring;
    @Value("${pushServeCheck.checkNum:50}")
    private Integer checkNum; 
    @Value("${pushServeCheck.userIds:UE1727971226594447360}")
    private List<String> checkUserIds;

    /**
     * zs20230925
     * 1.注意：任务执行时间一定要比推送周期短，保证当前执行推送时最多推送一条，否则可能一下推送多条没有实际意义
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void pushServeTask(Integer cycle) {
        if (null == cycle || cycle <= 0) {
            cycle = Integer.valueOf(5);
        }
        // 处理需要触发的时间
        List<String> sendDateList = new ArrayList<>();

        LocalDateTime now = LocalDateTime.now();
        for (int i = -5 ; i <= cycle + 5; i++) { // 因为任务运行时间不准确，所以前后多处理一些时间
            String sendDate = DateUtil.format(now.minusMinutes(i), "yyyy-MM-dd HH:mm") + ":00";
            sendDateList.add(sendDate);
        }
        log.info("PatientPushServeTaskServiceImpl.pushServeTask:sendDateList:>>>>>> {}", JSON.toJSONString(sendDateList));

        // 查询患者推送服务数据 
        // 20231105 要查询可用状态的推送服务
        // 存在的推送服务都是可用的，结束或删除的都会物理删除并记录到历史表
        PatientPushServeQueryParam patientPushServeQueryParam = new PatientPushServeQueryParam();
        patientPushServeQueryParam.setSendDateList(sendDateList);
        // patientPushServeQueryParam.setLimit(1000); // 不能限制数据数量，不然当下次执行的时候可能未查到的数据过期查不到无法推送
        List<PatientPushServeVO> patientPushServeVOs = patientPushServeQueryBizService.pushServeList(patientPushServeQueryParam);

        if (CollectionUtil.isEmpty(patientPushServeVOs)) {
            return;
        }

        // 处理数据的执行时间
        patientPushServeVOs.forEach(i -> {
            log.info("PatientPushServeTaskServiceImpl.pushServeTask:i:>>>>>> {}", JSON.toJSONString(i));
            List<String> sendDates = i.getSendDateListNo().stream().filter(j -> sendDateList.contains(j)).collect(Collectors.toList());
            if (CollectionUtil.isNotEmpty(sendDates)) {
                i.setSendDate(sendDates.get(0)); // 注意：任务执行时间一定要比推送周期短，保证当前执行推送时最多推送一条，否则可能一下推送多条没有实际意义
            }
        });

        // 调用pushServeTaskDeal()处理
        this.pushServeTaskDeal(patientPushServeVOs);
    }

    /**
     * zs20230922
     * 
     * @param pushServeList 默认此参数都是需要推送的服务，不需要额外验证数据的有效性
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void pushServeTaskDeal(List<PatientPushServeVO> pushServeList) {
        log.info("PatientPushServeTaskServiceImpl.pushServeTaskDeal:pushServeList:>>>>>> {}", JSON.toJSONString(pushServeList));
        if (CollectionUtil.isEmpty(pushServeList)) {
            return;
        }

        // 服务配置信息
        List<String> pushServeIds = new ArrayList<>();
        List<String> patientIds = new ArrayList<>();
        pushServeList.forEach(i -> {
            pushServeIds.add(i.getPushServeId());
            patientIds.add(i.getPatientId());
        });
        PushServeConfigClientQueryDTO pushServeConfigParams = new PushServeConfigClientQueryDTO();
        pushServeConfigParams.setIds(pushServeIds);
        List<PushServeConfigBO> pushServeConfigList = pushServeConfigClientService.list(pushServeConfigParams);
        Map<String, PushServeConfigBO> pushServeConfigMap = new HashMap<>();
        if (CollUtil.isNotEmpty(pushServeConfigList)) {
            pushServeConfigList.forEach(i -> pushServeConfigMap.put(i.getId(), i));
        }

        // 家属信息
        Map<String, List<MemberFamilyBO>> userMap = this.getUserListByPatientId(patientIds);

        List<PatientRemindAddDTO> patientRemindAddDTOs = new ArrayList<>();
        TriggerTaskLogBatchGenDTO triggerTaskLogBatchGenDTO = new TriggerTaskLogBatchGenDTO();

        List<String> familyIds = new ArrayList<>(); // 更新一个家属的人为本人

        pushServeList.forEach(i -> {
            log.info("PatientPushServeTaskServiceImpl.pushServeTaskDeal:i:>>>>>> {}", JSON.toJSONString(i));
            // 没有家属不生成提醒
            List<MemberFamilyBO> userList = userMap.get(i.getPatientId());
            if (CollectionUtil.isEmpty(userList)) {
                return;
            }

            PushServeConfigBO config = i.getPushServeConfig();

            // 保存到执行日志
            TriggerTaskLogBatchItem triggerTaskLogBatchItem = getTriggerTaskLogBatchItem(i);
            triggerTaskLogBatchGenDTO.addItem(triggerTaskLogBatchItem);

            // 保存到提醒
            if (null != config && YN.YES.getCode().equals(config.getStatus()) && null != config.getPushConfig() && (RemindWayEnum.Remind.getCode().equals(config.getRemindWay()) || RemindWayEnum.ALL.getCode().equals(config.getRemindWay()))) {
                // TODO zs20240810 只有一个家属（即患者），直接推送
                if (userList.size() == 1) {
                    MemberFamilyBO family = userList.get(0);
                    if (StrUtil.isEmpty(family.getRelationType()) || !YN.YES.getCode().equals(family.getIsAuth())) {
                        familyIds.add(family.getId());
                    }
                    patientRemindAddDTOs.add(this.getPatientRemindAddDTO(i, family, pushServeConfigMap.get(i.getPushServeId())));
                } else {
                    userList.forEach(user -> {
                        log.info("保存提醒>>>>>> user={}", JSON.toJSONString(user));
                        // 是否有权限
                        if (YN.NO.getCode().equals(user.getIsAuth())) {
                            return;
                        }
                        // 判断推送目标选择推送用户
                        String pushTarget = config.getPushTarget();
                        // 推送本人，如是家属则跳过
                        if (PushServeTargetEnum.Self.getCode().equals(pushTarget) && !"1".equals(user.getRelationType())) {
                            return;
                        }
                        // 推送家属，若是本人则跳过
                        if (PushServeTargetEnum.Family.getCode().equals(pushTarget) && "1".equals(user.getRelationType())) {
                            return;
                        }

                        patientRemindAddDTOs.add(this.getPatientRemindAddDTO(i, user, pushServeConfigMap.get(i.getPushServeId())));
                    });
                }
            }
        });

        // 更新患者推送服务的发送时间列表
        patientPushServeBizService.updateBatchSendDateList(pushServeList);
        // 保存执行日志
        TriggerTaskLogUtils.addBatch(triggerTaskLogBatchGenDTO);
        // 保存提醒
        if (CollectionUtil.isNotEmpty(patientRemindAddDTOs)) {
            patientPushServeBizService.addPatientRemindBatch(patientRemindAddDTOs);
        }

        // 补刀：若家属只有一个人则更新为本人
        if (CollUtil.isNotEmpty(familyIds)) {
            customerFamilyClientService.updateSelfRelationByIds(familyIds);
        }
    }

    // 根据配置判断是否只推送本人/只推送家属/本人家属都推送
    private Map<String, List<MemberFamilyBO>> getUserListByPatientId(List<String> patientIds) {
        // 整理用户列表
        // List<String> patientIds = new ArrayList<>();
        // pushServeList.forEach(i -> {
        //     patientIds.add(i.getPatientId());
        // });

        if (CollUtil.isEmpty(patientIds)) {
            return new HashMap<>();
        }
        
        MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
        memberFamilyListClientDTO.setPatHisNos(patientIds); // zs20231115 家属表中patientId来自海鹚和本平台的patientId不一致，一致的是patHisNos（就诊人门诊id）
        // memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
        log.info("查询家属信息>>>>>> {}", JSON.toJSONString(memberFamilyListClientDTO));
        List<MemberFamilyBO> memberFamilyBOs = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
        log.info("查询家属信息<<<<<< {}", JSON.toJSONString(memberFamilyBOs));
        Map<String, List<MemberFamilyBO>> map = new HashMap<>();
        if (CollectionUtil.isNotEmpty(memberFamilyBOs)) {
            memberFamilyBOs.forEach(i -> {
                List<MemberFamilyBO> list = map.get(i.getPatHisNo());
                if (null == list) {
                    list = new ArrayList<>();
                    map.put(i.getPatHisNo(), list);
                }
                list.add(i);
            });
        }
        // MemberFamilyListClientDTO memberFamilyListClientDTO = new MemberFamilyListClientDTO();
        // memberFamilyListClientDTO.setMainPersonIds(patientIds);
        // memberFamilyListClientDTO.setIsAuth(YN.YES.getCode());
        // log.info("查询家属信息>>>>>> {}", JSON.toJSONString(memberFamilyListClientDTO));
        // List<MemberFamilyBO> memberFamilyBOs = customerFamilyClientService.listByUser(memberFamilyListClientDTO);
        // log.info("查询家属信息<<<<<< {}", JSON.toJSONString(memberFamilyBOs));
        // Map<String, List<MemberFamilyBO>> map = new HashMap<>();
        // if (CollectionUtil.isNotEmpty(memberFamilyBOs)) {
        //     memberFamilyBOs.forEach(i -> {
        //         List<MemberFamilyBO> list = map.get(i.getMainPersonId());
        //         if (null == list) {
        //             list = new ArrayList<>();
        //             map.put(i.getMainPersonId(), list);
        //         }
        //         list.add(i);
        //     });
        // }
        
        return map;
    }

    /**
     * 执行日志
     * @param patientScheduleInfo
     * @param pushDate 推送时间
     * @return
     */
    private TriggerTaskLogBatchItem getTriggerTaskLogBatchItem(PatientPushServeVO patientPushServeVO) {
        TriggerTaskLogBatchItem triggerTaskLogBatchItem = new TriggerTaskLogBatchItem();
        triggerTaskLogBatchItem.setOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
        // triggerTaskLogBatchItem.setTwoType(null);
        triggerTaskLogBatchItem.setBizId(patientPushServeVO.getId());
        triggerTaskLogBatchItem.setOpUser("system");
        triggerTaskLogBatchItem.setRemark("患者推送服务");
        triggerTaskLogBatchItem.setStatus(YN.YES.getCode());
        triggerTaskLogBatchItem.setOpDate(DateUtil.parseDateTime(patientPushServeVO.getSendDate()));

        return triggerTaskLogBatchItem;
    }

    /**
     * 提醒
     * @param patientPushServeVO
     * @param pushDate 推送时间
     * @return
     */
    private PatientRemindAddDTO getPatientRemindAddDTO(PatientPushServeVO patientPushServeVO, MemberFamilyBO user, PushServeConfigBO sourceConfig) {
        PushServeConfigBO config = patientPushServeVO.getPushServeConfig();
        
        PatientRemindAddDTO patientRemindAddDTO = new PatientRemindAddDTO();
        patientRemindAddDTO.setPatientId(patientPushServeVO.getPatientId());
        patientRemindAddDTO.setUserId(user.getUserId()); // TODO FIXME 获取用户信息
        patientRemindAddDTO.setBizId(patientPushServeVO.getId());
        patientRemindAddDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
        // patientRemindAddDTO.setBizTwoType(null);
        patientRemindAddDTO.setTitle(patientPushServeVO.getPushServeTitle());
        patientRemindAddDTO.setContent(config.getMediaId());
        patientRemindAddDTO.setRemark("微信提醒");
        patientRemindAddDTO.setPushChannel(config.getPushWay());

        // TODO FIXME
        if (PushWayEnum.PCW_WX.getCode().equals(config.getPushWay())) {
            patientRemindAddDTO.setPushAccount(user.getUserOpenId());
        } else if (PushWayEnum.PCW_SMS.getCode().equals(config.getPushWay())) {
            // patientRemindAddDTO.setPushAccount(user.get("sms"));
        } else if (PushWayEnum.PCW_AITel.getCode().equals(config.getPushWay())) {
            // patientRemindAddDTO.setPushAccount(user.get("aitel"));
        }
        
        ServPushConfigBO pushConfig = config.getPushConfig();
        if (null != pushConfig) {
            patientRemindAddDTO.setPushTempId(pushConfig.getTemplateId());

            ServPushConfigModel pushConfigModel = new ServPushConfigModel();
            pushConfigModel.setTemplateId(pushConfig.getTemplateId());
            pushConfigModel.setTitle(pushConfig.getTitle());
            pushConfigModel.setContent(pushConfig.getContent());
            pushConfigModel.setDate(pushConfig.getDate());
            pushConfigModel.setUrl(pushConfig.getUrl());
            pushConfigModel.setRemark(pushConfig.getRemark());
            pushConfigModel.setDoctor(pushConfig.getDoctor());

            pushConfigModel.setValue1(pushConfig.getValue1());
            pushConfigModel.setValue2(pushConfig.getValue2());
            pushConfigModel.setValue3(pushConfig.getValue3());
            pushConfigModel.setValue4(pushConfig.getValue4());
            pushConfigModel.setValue5(pushConfig.getValue5());

            // 补刀使用，直接使用当前的服务配置
            if (null != sourceConfig && null != sourceConfig.getPushConfig()) {
                pushConfigModel.setValue1(sourceConfig.getPushConfig().getValue1());
                pushConfigModel.setValue2(sourceConfig.getPushConfig().getValue2());
                pushConfigModel.setValue3(sourceConfig.getPushConfig().getValue3());
                pushConfigModel.setValue4(sourceConfig.getPushConfig().getValue4());
                pushConfigModel.setValue5(sourceConfig.getPushConfig().getValue5());
            }

            patientRemindAddDTO.setPushConfig(pushConfigModel);
        }

        patientRemindAddDTO.setPushDate(DateUtil.parseDateTime(patientPushServeVO.getSendDate()));
        patientRemindAddDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Todo.getCode());

        return patientRemindAddDTO;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void pushServeTaskExecute() {
        // 获取提醒信息
        PatientRemindQueryDTO patientRemindQueryDTO = new PatientRemindQueryDTO();
        patientRemindQueryDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
        patientRemindQueryDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Todo.getCode());
        List<PatientRemindVO> patientRemindVOs = patientPushServeQueryBizService.listPatientRemind(patientRemindQueryDTO);
        if (CollectionUtil.isEmpty(patientRemindVOs)) {
            return;
        }
        List<String> patientPushServeIdList = patientRemindVOs.stream().map(PatientRemindVO::getBizId).collect(Collectors.toList());
        
        // 有可能推送服务已经没有了，所以从历史任务中查询
        PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
        patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
        patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIdList);
        List<PatientPushServeHistoryVO> patientPushServeList = patientPushServeQueryBizService.pushServeHistoryList(patientPushServeHistoryQueryParam);

        if (CollectionUtil.isEmpty(patientPushServeList)) {
            return;
        }
        Map<String, PatientPushServeHistoryVO> patientPushServeMap = patientPushServeList.stream().collect(Collectors.toMap(PatientPushServeHistoryVO::getPatientPushServeId, i -> i));

        List<PatientRemindUpdateDTO> cannotSendRemindList = new ArrayList<>(); // 由于数据问题无法发送的更新状态
        List<PatientRemindUpdateDTO> notFollowRemindList = new ArrayList<>(); // 没有关注导致无法发送消息
        List<PatientRemindUpdateDTO> updateRemindList = new ArrayList<>(); // 保存所有待更新的提醒
        List<PatientRemindUpdateDTO> updateRemindExpireList = new ArrayList<>(); // 超过2天未发送的提醒进行标记

        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志
        // List<ThirdUserUpdateClientDTO> thirdUserUpdateClientDTOs = new ArrayList<>(); // TODO 更新家庭第三方用户信息表的关注状态

        DateTime now = DateUtil.date();
        patientRemindVOs.forEach(i -> {
            log.info("1.患者推送服务>>>>>> {}", JSON.toJSONString(i));

            PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
            patientRemindUpdateDTO.setId(i.getId());

            // 超过2天更新为过期
            if (DateUtil.offsetDay(now, -2).after(i.getPushDate())) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Expire.getCode());
                updateRemindExpireList.add(patientRemindUpdateDTO);
                return;
            }

            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && StrUtil.isBlank(i.getPushAccount())) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                notFollowRemindList.add(patientRemindUpdateDTO);
                return;
            }

            ServPushConfigModel pushConfig = i.getPushConfig();
            
            PatientPushServeHistoryVO patientPushServeVO = patientPushServeMap.get(i.getBizId());
            if (null == pushConfig || null == patientPushServeVO || null == patientPushServeVO.getPushServeConfig()) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Invalid.getCode());
                cannotSendRemindList.add(patientRemindUpdateDTO);
                return;
            }

            try {
                if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && StrUtil.isNotBlank(i.getPushAccount())) {
                    // 微信
                    WechatTemplateConfig wechatTemplateConfig = wechatConfig.getPatient();
                    // WechatTemplateConfig wechatTemplateConfig = paramsClientService.getParamConfig("WX_TEMP_MSG_PATIENT", new WechatTemplateConfig()); // TODO 从服务器中获取消息模板信息（待测试）

                    SendTempClientDTO sendTempClientDTO = new SendTempClientDTO();
                    sendTempClientDTO.setOpenid(i.getPushAccount());
                    sendTempClientDTO.setTemplateId(StrUtil.isNotBlank(wechatTemplateConfig.getTemplateId()) ? wechatTemplateConfig.getTemplateId() : i.getPushTempId());

                    Map<String, String> tempMsgMap = JSONObject.parseObject(this.msgStr(wechatTemplateConfig.getTemplate(), pushConfig), new TypeReference<Map<String, String>>() {});
                    sendTempClientDTO.setTempData(tempMsgMap);
                    
                    // 微信跳转url
                    if (StrUtil.isNotBlank(wechatTemplateConfig.getUrl()) && ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(i.getBizOneType())) {
                        String secureData = BehaviorSecureUtil.mergeSourceData(BehaviorSourceTypeConstant.SourceOneTypeEnum.Remind.getCode(), i.getId());
                        sendTempClientDTO.setUrl(this.urlStr(wechatTemplateConfig.getUrl(), patientPushServeVO.getPushServeConfig(), patientPushServeVO.getPatientId(), secureData));
                    } else if ("examine_report".equals(i.getBizOneType()) || "laboratory_report".equals(i.getBizOneType())) {
                        // TODO 跳转检查检验报告url
                    }
                    
                    // TODO 发送微信模版消息 FIXME: 批量发送
                    log.info("2.患者微信推送服务>>>>>> sendTempClientDTO={}", JSON.toJSONString(sendTempClientDTO));
                    SendTempResultBO sendTempResultBO = customerThirdClientService.getSendTempResult(sendTempClientDTO);
                    log.info("3.患者微信推送服务<<<<<< sendTempClientDTO={}", JSON.toJSONString(sendTempResultBO));
                    // 更新家属第三方关注状态
                    ThirdUserUpdateClientDTO thirdUserUpdateClientDTO = new ThirdUserUpdateClientDTO();
                    thirdUserUpdateClientDTO.setOpenId(sendTempClientDTO.getOpenid());
                    thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                    }
                    log.info("4.更新患者微信推送状态>>>>>> thirdUserUpdateClientDTO={}", JSON.toJSONString(thirdUserUpdateClientDTO));
                    customerThirdClientService.updateThirdUser(thirdUserUpdateClientDTO);
                    
                    // 更新提醒信息
                    patientRemindUpdateDTO.setErrorCode(sendTempResultBO.getErrcode() + "");
                    patientRemindUpdateDTO.setErrorMsg(sendTempResultBO.getErrmsg());
                    patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Fail.getCode());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                    }
                    updateRemindList.add(patientRemindUpdateDTO);

                    // 保存微信推送日志
                    PushWeixinLogAddDTO pushWeixinLogAddDTO = new PushWeixinLogAddDTO();
                    pushWeixinLogAddDTO.setUserType(UserTypeEnum.Patient.getCode());
                    pushWeixinLogAddDTO.setUserId(i.getUserId());
                    pushWeixinLogAddDTO.setOpenId(i.getPushAccount());
                    pushWeixinLogAddDTO.setBizOneType(i.getBizOneType());
                    pushWeixinLogAddDTO.setBizTwoType(i.getBizTwoType());
                    pushWeixinLogAddDTO.setBizId(i.getBizId());
                    pushWeixinLogAddDTO.setTempId(i.getPushTempId());
                    pushWeixinLogAddDTO.setRemindId(i.getId());
                    pushWeixinLogAddDTO.setRemark(i.getRemark());
                    pushWeixinLogAddDTO.setWxAppId(wechatTemplateConfig.getAppid());
                    pushWeixinLogAddDTO.setErrorCode(sendTempResultBO.getErrcode() + "");
                    pushWeixinLogAddDTO.setErrorMsg(sendTempResultBO.getErrmsg());
                    pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                    pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Fail.getMsg());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Success.getMsg());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.NotFollow.getMsg());
                    }
                    pushWeixinLogAddDTOs.add(pushWeixinLogAddDTO);

                    // FIXME
                } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                    // TODO 短信
                } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                    // TODO AI电话
                }

            } catch (Exception e) {
                log.info("3.数据处理error>>>>>> {}", e.getMessage());
                e.printStackTrace();
            }
        });

        // 保存状态
        if (CollectionUtil.isNotEmpty(cannotSendRemindList)) {
            patientPushServeBizService.updatePatientRemindBatch(cannotSendRemindList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindList);
        }
        if (CollectionUtil.isNotEmpty(notFollowRemindList)) {
            patientPushServeBizService.updatePatientRemindBatch(notFollowRemindList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindExpireList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindExpireList);
        }

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
    }

    // 消息模版
    private String msgStr(String templateStr, ServPushConfigModel model) {
        return templateStr.replace("#title", null == model.getTitle() ? "" : model.getTitle())
                        .replace("#content", null == model.getContent() ? "" : model.getContent())
                        .replace("#date", null == model.getDate() ? "" : model.getDate())
                        .replace("#url", null == model.getUrl() ? "" : model.getUrl())
                        .replace("#remark", null == model.getRemark() ? "" : model.getRemark())
                        .replace("#doctor", null == model.getDoctor() ? "" : model.getDoctor());
    }
    // 消息模版跳转地址
    private String urlStr(String templateStr, PushServeConfigBO pushServeConfigBO, String patientId, String secureData) {
        return templateStr.replace("#id", null == pushServeConfigBO.getMediaId() ? "" : pushServeConfigBO.getMediaId())
                        .replace("#type", null == pushServeConfigBO.getMediaType() ? "" : pushServeConfigBO.getMediaType())
                        .replace("#patientid", null == patientId ? "" : patientId)
                        .replace("#serviceid", null == pushServeConfigBO.getId() ? "" : pushServeConfigBO.getId())
                        .replace("#key", secureData);
    }

    @Override
    public void pushExamineAndLaboratoryReportTaskExecute() {
        // 获取同步标记
        PatientPushSyncFlagModel syncFlag = patientPushSyncFlagMapper.getSyncFlag(new QueryWrapper<PatientPushSyncFlagModel>()
            .eq("code", "Examine_Laboratory_Report_Remind")
        );

        if (null == syncFlag) {
            syncFlag = new PatientPushSyncFlagModel();
            syncFlag.setCode("Examine_Laboratory_Report_Remind");
            syncFlag.setName("检查检验报告");
            syncFlag.setSyncFlag(DateUtil.offsetMinute(DateUtil.date(), -5).toString("yyyy-MM-dd HH:mm:ss"));
            syncFlag.setMaxMin(5);
            patientPushSyncFlagMapper.insertSyncFlag(syncFlag);
        }

        if (StrUtil.isBlank(syncFlag.getSyncFlag()) || syncFlag.getMaxMin() < 0) {
            throw new BusinessException("同步标记配置异常");
        }

        // 处理边界时间
        String now = DateUtil.now();
        String startTime = syncFlag.getSyncFlag();
        // 若开始时间大于当前时间则停止同步
        if (now.compareTo(startTime) < 0) {
            return;
        }
        String endTime = DateUtil.offsetMinute(DateUtil.parseDateTime(syncFlag.getSyncFlag()), syncFlag.getMaxMin()).toString();
        // 若结束时间大于当前时间则停止同步
        if (now.compareTo(endTime) < 0) {
            return;
        }

        // 查询当天未推送的检查检验报告
        PatientExamineAndLaboratoryReportClientDTO examineAndLaboratoryReportParams = new PatientExamineAndLaboratoryReportClientDTO();
        examineAndLaboratoryReportParams.setStartDate(startTime);
        examineAndLaboratoryReportParams.setEndDate(endTime);
        List<PatientExamineReportClientBO> examineReportList = dwdDataPatientClientService.listExamineReportInfo(examineAndLaboratoryReportParams);
        List<PatientLaboratoryReportClientBO> laboraatoryReportList = dwdDataPatientClientService.listLaboratoryReportInfo(examineAndLaboratoryReportParams);

        // 保存检查检验报告到日程和提醒表中
        patientPushServeTaskHandlerService.saveExamineAndLaboratoryReportRemind(examineReportList, laboraatoryReportList, endTime);

    }

    @Override
    public void pushRecipeMedicineTaskExecute() {
        // 获取同步标记
        PatientPushSyncFlagModel syncFlag = patientPushSyncFlagMapper.getSyncFlag(new QueryWrapper<PatientPushSyncFlagModel>()
            .eq("code", "Recipe_Medicine_Remind")
        );

        if (null == syncFlag) {
            syncFlag = new PatientPushSyncFlagModel();
            syncFlag.setCode("Recipe_Medicine_Remind");
            syncFlag.setName("医嘱用药提醒");
            syncFlag.setSyncFlag(DateUtil.offsetMinute(DateUtil.date(), -5).toString("yyyy-MM-dd HH:mm:ss"));
            syncFlag.setMaxMin(5);
            patientPushSyncFlagMapper.insertSyncFlag(syncFlag);
        }

        if (StrUtil.isBlank(syncFlag.getSyncFlag()) || syncFlag.getMaxMin() < 0) {
            throw new BusinessException("同步标记配置异常");
        }

        // 处理边界时间
        String now = DateUtil.now();
        String startTime = syncFlag.getSyncFlag();
        // 若开始时间大于当前时间则停止同步
        if (now.compareTo(startTime) < 0) {
            return;
        }
        String endTime = DateUtil.offsetMinute(DateUtil.parseDateTime(syncFlag.getSyncFlag()), syncFlag.getMaxMin()).toString();
        // 若结束时间大于当前时间则停止同步
        if (now.compareTo(endTime) < 0) {
            return;
        }

        // 查询未推送的医嘱用药
        PatientRecipeMedicineClientDTO patientRecipeMedicineParams = new PatientRecipeMedicineClientDTO();
        patientRecipeMedicineParams.setStartDate(startTime);
        patientRecipeMedicineParams.setEndDate(endTime);

        List<String> scenes = new ArrayList<>();
        scenes.add(DwdConstant.DataSceneEnum.MZ.getCode());
        scenes.add(DwdConstant.DataSceneEnum.JZ.getCode());
        patientRecipeMedicineParams.setScenes(scenes);

        List<PatientRecipeMedicineClientBO> recipeMedicineList = dwdDataPatientClientService.listRecipeMedicineInfo(patientRecipeMedicineParams);

        // 保存医嘱用药到日程中
        patientPushServeTaskHandlerService.saveRecipeMedicineSchedule(recipeMedicineList, endTime);

    }

    // 查询出在黑名单中的患者
    private Set<String> getInvalidPatientIds(List<String> patientIds) {
        Set<String> invalidPatientIds = new HashSet<>();
        // VisitVerificationSearchDTO visitVerificationSearchDTO = new VisitVerificationSearchDTO(BasicVisitConstant.VisitType.PATIENT.getCode(), patientIds);
        Map<String, List<VisitVerificationBO>> verificationMap = visitVerificationClientService.getVisitVerificationByPatient(patientIds);
        if (CollUtil.isNotEmpty(verificationMap)) {
            verificationMap.forEach((k, v) -> {
                for (VisitVerificationBO bo : v) {
                    if (BasicVisitConstant.VerType.BLACK_LIST.getCode().equals(bo.getVerType())) {
                        invalidPatientIds.add(k);
                        break;
                    }
                }
            });
        }
        log.info("黑名单 <<<<<< {}", JSON.toJSONString(invalidPatientIds));
        return invalidPatientIds;
    }

    // zs20241009 推送服务前先聚合查询每个服务最近一小时的提醒是否超过指定数量（默认50），超过则不提醒并下架该服务，通知服务管理人员
    private void checkPushServiceRemind() {
        DateTime now = DateUtil.date();

        Date startDate = DateUtil.offsetMinute(now, -timeDuring);
        Date endDate = DateUtil.offsetMinute(now, 10);
        List<Map<String, String>> list = patientPushServeMapper.pushServiceAndPatientPushServiceList(new QueryWrapper<Void>()
            .ge("a.push_date", startDate)
            .le("a.push_date", endDate)
        );

        if (CollUtil.isEmpty(list)) {
            return;
        }

        Map<String, List<String>> map = new HashMap<>();
        list.forEach(i -> {
            List<String> l = map.get(i.get("pushServeId"));
            if (null == l) {
                l = new ArrayList<>();
                map.put(i.get("pushServeId"), l);
            }
            l.add(i.get("remindId"));
        });

        log.info("整理出每个服务对应多少提醒 >>>>>> {}", JSON.toJSONString(map));

        if (CollUtil.isEmpty(map)) {
            return;
        }

        Map<String, List<String>> remindWarringMap = new HashMap<>();
        map.forEach((k, v) -> {
            if (v.size() > checkNum) {
                remindWarringMap.put(k, v);
            }
        });

        log.info("整理出超过限制的服务及提醒 >>>>>> {}", JSON.toJSONString(remindWarringMap));

        if (CollUtil.isEmpty(remindWarringMap)) {
            return;
        }

        // 下架异常服务、提醒异常服务
        List<String> pushServeIds = new ArrayList<>(); // 需要下架和提醒的服务
        List<String> remindIds = new ArrayList<>(); // 需要更改状态的提醒

        remindWarringMap.forEach((k, v) -> {
            if (v.size() > checkNum) {
                pushServeIds.add(k);
                remindIds.addAll(v);
            }
        });

        log.info("服务下架并通知相关人员 >>>>>> {}", JSON.toJSONString(pushServeIds));

        // 下架服务
        if (CollUtil.isNotEmpty(pushServeIds)) {
            patientPushServeMapper.pushServeOff(new UpdateWrapper<Void>()
                .set("status", YN.NO.getCode())
                .in("id", pushServeIds)
            );

            List<Map<String, String>> pushServeNames = patientPushServeMapper.pushServeNames(new QueryWrapper<Void>()
                .in("id", pushServeIds)
            );

            pushServeNames.forEach(i -> {
                String msgTemp = "推送服务大量推送异常：服务编号[{}]，服务名称[{}]，[{}]分钟内推送[{}]条数据";
                String msgContent = StrUtil.format(msgTemp, i.get("id"), i.get("name"), (timeDuring + 10), remindWarringMap.get(i.get("id")).size());

                if (CollUtil.isNotEmpty(checkUserIds)) {
                    checkUserIds.forEach(userId -> {
                        log.info("发送短信 >>>>>> {}", msgContent);
                        adminUserThirdClientService.sendHisSMSMsg(userId, msgContent);
                    });
                }
            });
        }

        log.info("超过限制的服务提醒更改状态 >>>>>> {}", JSON.toJSONString(remindIds));

        // 失效提醒
        if (CollUtil.isNotEmpty(remindIds)) {
            List<PatientRemindUpdateDTO> updateRemindList = new ArrayList<>();
            remindIds.forEach(i -> {
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Abnormal.getCode());
                patientRemindUpdateDTO.setId(i);
                updateRemindList.add(patientRemindUpdateDTO);
            });

            if (CollUtil.isNotEmpty(updateRemindList)) {
                log.info("updateRemindList >>>>>> {}", JSON.toJSONString(updateRemindList));
        
                patientPushServeBizService.updatePatientRemindBatch(updateRemindList);
            }
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void remindTaskExecute() {
        DateTime now = DateUtil.date();

        // zs20241009 推送服务前先聚合查询每个服务最近一小时的提醒是否超过指定数量（默认50），超过则不提醒并下架该服务，通知服务管理人员
        log.info("验证推送提醒是否异常开始 >>>>>>>>");
        checkPushServiceRemind();
        log.info("验证推送提醒是否异常结束 <<<<<<<");

        // 获取提醒信息
        PatientRemindQueryDTO patientRemindQueryDTO = new PatientRemindQueryDTO();
        patientRemindQueryDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
        patientRemindQueryDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Todo.getCode());
        // patientRemindQueryDTO.setStartDate(DateUtil.offsetMinute(now, -10));  // 查询十分钟左右的提醒，注意设置定时任务的循环触发时间不大于该时间
        patientRemindQueryDTO.setEndDate(DateUtil.offsetMinute(now, 10)); // 查询最多超前10分钟的提醒
        patientRemindQueryDTO.setLimit(1000);
        List<PatientRemindVO> patientRemindVOs = patientPushServeQueryBizService.listPatientRemind(patientRemindQueryDTO);
        if (CollectionUtil.isEmpty(patientRemindVOs)) {
            return;
        }

        log.info("提醒信息 >>>>>> {}", JSON.toJSONString(patientRemindVOs));

        List<PatientRemindVO> pushServeRemindList = new ArrayList<>();
        List<PatientRemindVO> recipeMedicineRemindList = new ArrayList<>();
        
        List<PatientRemindUpdateDTO> updateRemindExpireList = new ArrayList<>(); // 超过2天未发送的提醒进行标记

        List<PatientRemindUpdateDTO> updateRemindBlackList = new ArrayList<>(); // 黑名单
        
        List<String> patientIds = new ArrayList<>();
        patientRemindVOs.forEach(i ->patientIds.add(i.getPatientId()));
        // 黑名单患者
        Set<String> invalidPatientIds = getInvalidPatientIds(patientIds);
        
        patientRemindVOs.forEach(remind -> {
            // 黑名单
            if (invalidPatientIds.contains(remind.getPatientId())) {
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setId(remind.getId());
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.BlackList.getCode());
                patientRemindUpdateDTO.setErrorCode("-1");
                patientRemindUpdateDTO.setErrorMsg(PatientPushServeConstant.RemindPushStatus.BlackList.getMsg());
                updateRemindBlackList.add(patientRemindUpdateDTO);
                return;
            }

            // TODO zs20240907 限制的查询时间，该代码不会执行
            // 超过2天更新为过期
            if (DateUtil.offsetDay(now, -2).after(remind.getPushDate())) {
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setId(remind.getId());
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Expire.getCode());
                updateRemindExpireList.add(patientRemindUpdateDTO);
                return;
            }

            // 提醒类型
            if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(remind.getBizOneType())) {
                log.info("1.患者推送服务>>>>>> {}", JSON.toJSONString(remind));
                pushServeRemindList.add(remind);
            }
            if ("recipe_medicine".equals(remind.getBizOneType())) {
                log.info("1.患者用药服务>>>>>> {}", JSON.toJSONString(remind));
                recipeMedicineRemindList.add(remind);
            }
        });

        // List<PatientRemindUpdateDTO> cannotSendRemindList = new ArrayList<>(); // 由于数据问题无法发送的更新状态
        // List<PatientRemindUpdateDTO> notFollowRemindList = new ArrayList<>(); // 没有关注导致无法发送消息
        List<PatientRemindUpdateDTO> updateRemindList = new ArrayList<>(); // 保存所有待更新的提醒

        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志
        // List<ThirdUserUpdateClientDTO> thirdUserUpdateClientDTOs = new ArrayList<>(); // TODO 更新家庭第三方用户信息表的关注状态

        // 患者推送服务提醒
        this.pushServeRemind(pushServeRemindList, updateRemindList, pushWeixinLogAddDTOs);

        // 保存状态
        if (CollectionUtil.isNotEmpty(updateRemindList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindExpireList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindExpireList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindBlackList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindBlackList);
        }

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
    }

    private void pushServeRemind(List<PatientRemindVO> pushServeRemindList, List<PatientRemindUpdateDTO> updateRemindList, List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs) {
        if (CollectionUtil.isEmpty(pushServeRemindList)) {
            return;
        }

        List<String> patientPushServeIdList = pushServeRemindList.stream().map(PatientRemindVO::getBizId).collect(Collectors.toList());

        // 有可能推送服务已经没有了，所以从历史任务中查询
        PatientPushServeHistoryQueryParam patientPushServeHistoryQueryParam = new PatientPushServeHistoryQueryParam();
        patientPushServeHistoryQueryParam.setOpType(OpTypeEnum.Create.getCode());
        patientPushServeHistoryQueryParam.setPatientPushServeIds(patientPushServeIdList);
        List<PatientPushServeHistoryVO> patientPushServeList = patientPushServeQueryBizService.pushServeHistoryList(patientPushServeHistoryQueryParam);

        if (CollectionUtil.isEmpty(patientPushServeList)) {
            return;
        }
        Map<String, PatientPushServeHistoryVO> patientPushServeMap = patientPushServeList.stream().collect(Collectors.toMap(PatientPushServeHistoryVO::getPatientPushServeId, i -> i));

        pushServeRemindList.forEach(i -> {
            log.info("1.患者推送服务>>>>>> {}", JSON.toJSONString(i));

            String patientName = "";
            String patientPhone = "";
            PatientClientBO patient = i.getPatientInfo();
            if (null != patient) {
                patientName = patient.getPatientName();
                patientPhone = patient.getPhone();
            }
            
            PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
            patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Fail.getCode());
            patientRemindUpdateDTO.setId(i.getId());
            updateRemindList.add(patientRemindUpdateDTO);

            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && StrUtil.isBlank(i.getPushAccount())) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                // patientRemindUpdateDTO.setErrorCode("");
                patientRemindUpdateDTO.setErrorMsg("未关注或未获取到患者openid");
                return;
            }

            ServPushConfigModel pushConfig = i.getPushConfig();
            PatientPushServeHistoryVO patientPushServeVO = patientPushServeMap.get(i.getBizId());
            if (null == pushConfig || null == patientPushServeVO || null == patientPushServeVO.getPushServeConfig()) {
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Invalid.getCode());
                return;
            }
            PushServeConfigBO pushServeConfig = patientPushServeVO.getPushServeConfig();
            if (!YN.YES.getCode().equals(pushServeConfig.getStatus())) { // 服务下架则不生成提醒
                return;
            }

            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel())) {
                // 保存微信推送日志
                PushWeixinLogAddDTO pushWeixinLogAddDTO = new PushWeixinLogAddDTO();
                pushWeixinLogAddDTO.setUserType(UserTypeEnum.Patient.getCode());
                pushWeixinLogAddDTO.setUserId(i.getUserId());
                pushWeixinLogAddDTO.setOpenId(i.getPushAccount());
                pushWeixinLogAddDTO.setBizOneType(i.getBizOneType());
                pushWeixinLogAddDTO.setBizTwoType(i.getBizTwoType());
                pushWeixinLogAddDTO.setBizId(i.getBizId());
                pushWeixinLogAddDTO.setTempId(i.getPushTempId());
                pushWeixinLogAddDTO.setRemindId(i.getId());
                pushWeixinLogAddDTO.setRemark(i.getRemark());
                pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Fail.getMsg());

                pushWeixinLogAddDTOs.add(pushWeixinLogAddDTO);

                try {
                    // 微信配置
                    WechatTemplateConfig wechatTemplateConfig = wechatConfig.getPatient();

                    // 查询微信消息模板
                    String templateId = wechatTemplateConfig.getTemplateId();
                    String template = wechatTemplateConfig.getTemplate();
                    String templateUrl = wechatTemplateConfig.getUrl();
                    
                    SendTempClientDTO sendTempClientDTO = new SendTempClientDTO();
                    sendTempClientDTO.setOpenid(i.getPushAccount());

                    String pushDate = DateUtil.now();
                    if (null != i.getPushDate()) {
                        pushDate = DateUtil.formatDateTime(i.getPushDate());
                    }

                    String tempContent = this.templateMsgStr(template, patientName, pushConfig.getTitle(), pushConfig.getContent(), pushDate, pushConfig.getRemark(), pushConfig.getDoctor());

                    if (StrUtil.isNotBlank(pushConfig.getTemplateId())) {
                        WechatTemplateConfig wechatTemplate = paramsClientService.getParamConfig(pushConfig.getTemplateId(), new WechatTemplateConfig()); // 从服务器中获取消息模板信息（待测试）
                        templateId = wechatTemplate.getTemplateId();
                        template = wechatTemplate.getTemplate();
                        log.info("消息模板配置 <<<<<< {}", JSON.toJSON(wechatTemplate));

                        if (template_BG.equals(templateId)) {
                            tempContent = this.bgTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        } else if (template_CY.equals(templateId)) {
                            tempContent = this.cyTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        } else if (template_GH.equals(templateId)) {
                            tempContent = this.ghTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        } else if (template_WZ.equals(templateId)) {
                            tempContent = this.wzTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        } else if (template_YZ.equals(templateId)) {
                            tempContent = this.yzTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        } else if (template_ZYYY.equals(templateId)) {
                            tempContent = this.zyyyTemplateMsgStr(template, pushConfig, patientName, patientPhone, pushDate);
                        }
                    }
                    sendTempClientDTO.setTemplateId(templateId);
                    log.info("消息模板内容 <<<<<< {}", tempContent);
                    Map<String, String> tempMsgMap = JSONObject.parseObject(tempContent, new TypeReference<Map<String, String>>() {});
                    sendTempClientDTO.setTempData(tempMsgMap);
                    
                    // 微信跳转url
                    String secureData = BehaviorSecureUtil.mergeSourceData(BehaviorSourceTypeConstant.SourceOneTypeEnum.Remind.getCode(), i.getId());
                    sendTempClientDTO.setUrl(this.templateUrlStr(templateUrl, pushServeConfig.getMediaId(), pushServeConfig.getMediaType(), patientPushServeVO.getPatientId(), secureData));
                    
                    // TODO 发送微信模版消息 FIXME: 批量发送
                    log.info("2.患者微信推送服务>>>>>> sendTempClientDTO={}", JSON.toJSONString(sendTempClientDTO));
                    // SendTempResultBO sendTempResultBO = customerThirdClientService.getSendTempResult(sendTempClientDTO);
                    SendTempResultBO sendTempResultBO = loopSendWxTemp(sendTempClientDTO, 0);
                    log.info("3.患者微信推送服务<<<<<< sendTempClientDTO={}", JSON.toJSONString(sendTempResultBO));
                    // 更新家属第三方关注状态
                    ThirdUserUpdateClientDTO thirdUserUpdateClientDTO = new ThirdUserUpdateClientDTO();
                    thirdUserUpdateClientDTO.setOpenId(sendTempClientDTO.getOpenid());
                    thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                    }
                    log.info("4.更新患者微信推送状态>>>>>> thirdUserUpdateClientDTO={}", JSON.toJSONString(thirdUserUpdateClientDTO));
                    customerThirdClientService.updateThirdUser(thirdUserUpdateClientDTO);
                    
                    // 更新提醒信息
                    patientRemindUpdateDTO.setErrorCode(sendTempResultBO.getErrcode() + "");
                    patientRemindUpdateDTO.setErrorMsg(sendTempResultBO.getErrmsg());
                    if (null != sendTempResultBO.getErrcode() && 0 != sendTempResultBO.getErrcode()) {
                        for (WechatErrorCodeEnum wxec : WechatErrorCodeEnum.values()) {
                            if (wxec.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                                patientRemindUpdateDTO.setErrorMsg(wxec.getMsg());
                            }
                        }
                    }

                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                    }
                    patientRemindUpdateDTO.setPushConfig(pushConfig);

                    pushWeixinLogAddDTO.setWxAppId(wechatTemplateConfig.getAppid());
                    pushWeixinLogAddDTO.setErrorCode(patientRemindUpdateDTO.getErrorCode());
                    pushWeixinLogAddDTO.setErrorMsg(patientRemindUpdateDTO.getErrorMsg());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Success.getMsg());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.NotFollow.getMsg());
                    }
                } catch (Exception e) {
                    log.info("3.数据处理error>>>>>> {}", e.getMessage());
                    e.printStackTrace();
                    patientRemindUpdateDTO.setErrorCode("-1");
                    patientRemindUpdateDTO.setErrorMsg(e.getMessage());
                    pushWeixinLogAddDTO.setErrorMsg(e.getMessage());
                }
            } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                // TODO 短信
            } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                // TODO AI电话
            }

        });
    }

    // 调用失败则暂停3秒重新请求，最多重调3次
    private SendTempResultBO loopSendWxTemp(SendTempClientDTO sendTempClientDTO, Integer loopNum) {
        try {
            return customerThirdClientService.getSendTempResult(sendTempClientDTO);
        } catch (Exception e) {
            log.info("微信模板消息发送异常: {} ", JSON.toJSONString(sendTempClientDTO));
            e.printStackTrace();
            
            // 最多循环3次
            if (loopNum < 3) {
                // 先暂停
                log.info("微信模板消息休眠3000ms");
                try {
                    Thread.sleep(3000);
                } catch (InterruptedException e1) {
                    e1.printStackTrace();
                }
                // 出现异常再次调用
                return loopSendWxTemp(sendTempClientDTO, loopNum + 1);
            }
            throw new BusinessException(e.getMessage());
        }
    }

    private void recipeMedicineRemind(List<PatientRemindVO> recipeMedicineRemindList, List<PatientRemindUpdateDTO> updateRemindList, List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs) {
        if (CollectionUtil.isEmpty(recipeMedicineRemindList)) {
            return;
        }
        
        recipeMedicineRemindList.forEach(i -> {
            log.info("1.患者用药推送服务>>>>>> {}", JSON.toJSONString(i));

            String patientName = "";
            PatientClientBO patient = i.getPatientInfo();
            if (null != patient) {
                patientName = patient.getPatientName();
            }
            
            PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
            patientRemindUpdateDTO.setId(i.getId());

            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel())) {
                // 保存微信推送日志
                PushWeixinLogAddDTO pushWeixinLogAddDTO = new PushWeixinLogAddDTO();
                pushWeixinLogAddDTO.setUserType(UserTypeEnum.Patient.getCode());
                pushWeixinLogAddDTO.setUserId(i.getUserId());
                pushWeixinLogAddDTO.setOpenId(i.getPushAccount());
                pushWeixinLogAddDTO.setBizOneType(i.getBizOneType());
                pushWeixinLogAddDTO.setBizTwoType(i.getBizTwoType());
                pushWeixinLogAddDTO.setBizId(i.getBizId());
                pushWeixinLogAddDTO.setTempId(i.getPushTempId());
                pushWeixinLogAddDTO.setRemindId(i.getId());
                pushWeixinLogAddDTO.setRemark(i.getRemark());
                pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Fail.getMsg());
                
                pushWeixinLogAddDTOs.add(pushWeixinLogAddDTO);

                try {
                    // 微信
                    WechatTemplateConfig wechatTemplateConfig = wechatConfig.getPatient();

                    SendTempClientDTO sendTempClientDTO = new SendTempClientDTO();
                    sendTempClientDTO.setOpenid(i.getPushAccount());
                    sendTempClientDTO.setTemplateId(StrUtil.isNotBlank(wechatTemplateConfig.getTemplateId()) ? wechatTemplateConfig.getTemplateId() : i.getPushTempId());

                    String pushDate = DateUtil.now();
                    if (null != i.getPushDate()) {
                        pushDate = DateUtil.formatDateTime(i.getPushDate());
                    }
                    Map<String, String> tempMsgMap = JSONObject.parseObject(this.templateMsgStr(wechatTemplateConfig.getTemplate(), patientName, i.getTitle(), null, pushDate, i.getRemark(), null), new TypeReference<Map<String, String>>() {});
                    sendTempClientDTO.setTempData(tempMsgMap);
                    
                    // 微信跳转url
                    String secureData = BehaviorSecureUtil.mergeSourceData(BehaviorSourceTypeConstant.SourceOneTypeEnum.Remind.getCode(), i.getId());
                    sendTempClientDTO.setUrl(this.templateUrlStr(wechatTemplateConfig.getUrl(), i.getId(), "recipe_medicine", i.getPatientId(), secureData));
                    
                    // 发送微信模版消息
                    log.info("2.患者微信用药推送服务>>>>>> sendTempClientDTO={}", JSON.toJSONString(sendTempClientDTO));
                    SendTempResultBO sendTempResultBO = customerThirdClientService.getSendTempResult(sendTempClientDTO);
                    log.info("3.患者微信用药推送服务<<<<<< sendTempClientDTO={}", JSON.toJSONString(sendTempResultBO));
                    // 更新家属第三方关注状态
                    ThirdUserUpdateClientDTO thirdUserUpdateClientDTO = new ThirdUserUpdateClientDTO();
                    thirdUserUpdateClientDTO.setOpenId(sendTempClientDTO.getOpenid());
                    thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Fail.getCode());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        thirdUserUpdateClientDTO.setThirdUserStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                    }
                    log.info("4.更新患者微信用药推送状态>>>>>> thirdUserUpdateClientDTO={}", JSON.toJSONString(thirdUserUpdateClientDTO));
                    customerThirdClientService.updateThirdUser(thirdUserUpdateClientDTO);
                    
                    // 更新提醒信息
                    patientRemindUpdateDTO.setErrorCode(sendTempResultBO.getErrcode() + "");
                    patientRemindUpdateDTO.setErrorMsg(sendTempResultBO.getErrmsg());
                    patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Fail.getCode());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Success.getCode());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.NotFollow.getCode());
                    }
                    updateRemindList.add(patientRemindUpdateDTO);

                    pushWeixinLogAddDTO.setWxAppId(wechatTemplateConfig.getAppid());
                    pushWeixinLogAddDTO.setErrorCode(sendTempResultBO.getErrcode() + "");
                    pushWeixinLogAddDTO.setErrorMsg(sendTempResultBO.getErrmsg());
                    if (WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.Success.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.Success.getMsg());
                    } else if (WechatErrorCodeEnum.F43004.getCode().equals(String.valueOf(sendTempResultBO.getErrcode()))) {
                        pushWeixinLogAddDTO.setSendStatus(PushWeixinConstant.WechatPushStatus.NotFollow.getCode());
                        pushWeixinLogAddDTO.setSendResult(PushWeixinConstant.WechatPushStatus.NotFollow.getMsg());
                    }
                } catch (Exception e) {
                    log.info("3.数据处理error>>>>>> {}", e.getMessage());
                    e.printStackTrace();
                    pushWeixinLogAddDTO.setErrorMsg(e.getMessage());
                }
            } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                // TODO 短信
            } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                // TODO AI电话
            }
        });
    }

    // 消息模版
    private String templateMsgStr(String templateStr, String patientName, String title, String content, String date, String remark, String doctor) {
        return templateStr.replace("#patientName", null == patientName ? "" : patientName)
                        .replace("#title", null == title ? "" : title)
                        .replace("#content", null == content ? "" : content)
                        .replace("#date", null == date ? "" : date)
                        .replace("#remark", null == remark ? "" : remark)
                        .replace("#doctor", null == doctor ? "" : doctor);
    }
    // 消息模版跳转地址
    private String templateUrlStr(String templateStr, String id, String type, String patientId, String secureData) {
        return templateStr.replace("#id", null == id ? "" : id)
                        .replace("#type", null == type ? "" : type)
                        .replace("#patientid", null == patientId ? "" : patientId)
                        .replace("#key", secureData);
    }
    
    // 患者出院通知
    // {"templateId":"V8lRfeDdXClTbMnDDw_lPWRXq8HoPGnie_vh_zk-2cs","template":{"thing2":"#patientName","phone_number3":"#patientPhone","time4":"#leaveTime","thing7":"#leaveDeptName","thing1":"#hospital"}}
    private String cyTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue2())) {
            config.setValue2("-");
        }
        if (StrUtil.isBlank(config.getValue4())) {
            config.setValue4("-");
        }
        if (StrUtil.isBlank(config.getValue5())) {
            config.setValue5("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#patientPhone", config.getValue2())
                        .replace("#leaveTime", config.getValue3())
                        .replace("#leaveDeptName", config.getValue4())
                        .replace("#hospital", config.getValue5());
    }
    
    // 诊后医嘱生成
    // {"templateId":"7Jgx_ay6u7JzFcveJ0lq9W5e2NsOgcRkYcAAXjAmVO4","template":{"thing1":"#patientName","time2":"#time","thing3":"#doctorName","thing4":"#deptName","thing5":"#hospital"}}
    private String yzTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue3())) {
            config.setValue3("-");
        }
        if (StrUtil.isBlank(config.getValue4())) {
            config.setValue4("-");
        }
        if (StrUtil.isBlank(config.getValue5())) {
            config.setValue5("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#time", config.getValue2())
                        .replace("#doctorName", config.getValue3())
                        .replace("#deptName", config.getValue4())
                        .replace("#hospital", config.getValue5());
    }

    // 检查检验报告通知
    // {"templateId":"div8ZOg568mLzAEVT9EaoXHPqQytYbLUjT8jmbjOHJY","template":{"thing1":"#patientName","thing2":"#projectName","time3":"#time","thing7":"#hospital"}}
    private String bgTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue2())) {
            config.setValue2("-");
        }
        if (StrUtil.isBlank(config.getValue4())) {
            config.setValue4("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#projectName", config.getValue2())
                        .replace("#time", config.getValue3())
                        .replace("#hospital", config.getValue4());
    }
    
    // 完诊通知
    // {"templateId":"NItS0rWuxbhE47eTQp0hqB2ALwse0_nVbTL3jx2S1Ks","template":{"thing1":"#patientName","thing4":"#projectName","time6":"#time","thing8":"#deptName"}}
    private String wzTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue2())) {
            config.setValue2("-");
        }
        if (StrUtil.isBlank(config.getValue4())) {
            config.setValue4("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#projectName", config.getValue2())
                        .replace("#time", config.getValue3())
                        .replace("#deptName", config.getValue4());
    }
    
    // 挂号成功通知
    // {"templateId":"t6paNLWcXnAzJsQaoqyFblZpNoBYczdoIe6kwWWNAUY","template":{"thing1":"#patientName","thing2":"#deptName","thing3":"#doctorName","thing8":"#time"}}
    private String ghTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue2())) {
            config.setValue2("-");
        }
        if (StrUtil.isBlank(config.getValue3())) {
            config.setValue3("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#deptName", config.getValue2())
                        .replace("#doctorName", config.getValue3())
                        .replace("#time", config.getValue4());
    }
    
    // 住院预约结果通知
    // {"templateId":"a7jXg139rVwDwLF0P7hvcRWDGluxQuUCiu4lmcBZkIM","template":{"thing1":"#patientName","character_string4":"#inpatientId","thing5":"#deptName","time2":"#time","thing3":"#bed"}}
    private String zyyyTemplateMsgStr(String templateStr, ServPushConfigModel config, String patientName, String patientPhone, String time) {
        if (StrUtil.isBlank(config.getValue1())) {
            config.setValue1("-");
        }
        if (StrUtil.isBlank(config.getValue2())) {
            config.setValue2("-");
        }
        if (StrUtil.isBlank(config.getValue3())) {
            config.setValue3("-");
        }
        if (StrUtil.isBlank(config.getValue5())) {
            config.setValue5("-");
        }
        
        // config的值也有占位符
        String configStrResult = JSON.toJSONString(config).replace("#name", StrUtil.isBlank(patientName) ? "-" : patientName)
                .replace("#phone", StrUtil.isBlank(patientPhone) ? "-" : patientPhone)
                .replace("#time", time);
        ServPushConfigModel configResult = JSONObject.parseObject(configStrResult, ServPushConfigModel.class);

        config.setValue1(configResult.getValue1());
        config.setValue2(configResult.getValue2());
        config.setValue3(configResult.getValue3());
        config.setValue4(configResult.getValue4());
        config.setValue5(configResult.getValue5());

        return templateStr.replace("#patientName", config.getValue1())
                        .replace("#inpatientId", config.getValue2())
                        .replace("#deptName", config.getValue3())
                        .replace("#time", config.getValue4())
                        .replace("#bed", config.getValue5());
    }

    @Override
    public void patientPushServeScheduleJob(Date startDate, Date endDate) {
        // 查询没有生成过日程的服务
        List<String> patientPushServeIds = patientPushServeMapper.listPatientPushServeWithoutSchedule(new QueryWrapper<Void>()
                .eq("a.op_type", OpTypeEnum.Create.getCode())
                .isNull("b.biz_id")
                .gt(null != startDate, "op_date", startDate)
                .le(null != endDate, "op_date", endDate)
        );
        if (CollUtil.isEmpty(patientPushServeIds)) {
            return;
        }

        PatientPushServeHistoryQueryParam historyQueryParam = new PatientPushServeHistoryQueryParam();
        historyQueryParam.setPatientPushServeIds(patientPushServeIds);
        historyQueryParam.setOpType(OpTypeEnum.Create.getCode());
        List<PatientPushServeHistoryVO> historyPushServeList = patientPushServeQueryBizService.pushServeHistoryList(historyQueryParam);
        if (CollUtil.isEmpty(historyPushServeList)) {
            return;
        }

        Map<String, PatientPushServeHistoryVO> historyPushServeMap = new HashMap<>();
        Set<String> patientIds = new HashSet<>();
        historyPushServeList.forEach(i -> {
            historyPushServeMap.put(i.getPatientPushServeId(), i);
            patientIds.add(i.getPatientId());
        });

        Map<String, List<PatientPushServeDateInfo>> serveDateMap = new HashMap<>();
        List<PatientPushServeDateInfo> serveDateList = patientPushServeDateInfoService.list(new QueryWrapper<PatientPushServeDateInfo>()
                .in("patient_push_serve_id", patientPushServeIds)
        );
        if (CollUtil.isNotEmpty(serveDateList)) {
            serveDateList.forEach(i -> {
                List<PatientPushServeDateInfo> l = serveDateMap.get(i.getPatientPushServeId());
                if (null == l) {
                    l = new ArrayList<>();
                    serveDateMap.put(i.getPatientPushServeId(), l);
                }
                l.add(i);
            });
        }

        // 家属信息
        Map<String, List<MemberFamilyBO>> userMap = this.getUserListByPatientId(new ArrayList<>(patientIds));

        List<PatientScheduleAddDTO> patientScheduleAddDTOs = new ArrayList<>();
        historyPushServeList.forEach(i -> {
            // 没有家属不生成提醒
            List<MemberFamilyBO> userList = userMap.get(i.getPatientId());
            if (CollectionUtil.isEmpty(userList)) {
                return;
            }

            PushServeConfigBO pushServeConfigBO = i.getPushServeConfig();

            List<PatientPushServeDateInfo> pushServeDateList = serveDateMap.get(i.getPatientPushServeId());
            if (CollUtil.isEmpty(pushServeDateList)) {
                return;
            }

            pushServeDateList.forEach(j -> {
                if (userList.size() == 1) {
                    MemberFamilyBO user = userList.get(0);

                    PatientScheduleAddDTO patientScheduleAddDTO = new PatientScheduleAddDTO();
                    patientScheduleAddDTO.setScheduleDate(DateUtil.formatDateTime(j.getSendDate()));
                    patientScheduleAddDTO.setPatientId(i.getPatientId());
                    patientScheduleAddDTO.setUserId(user.getUserId());
                    patientScheduleAddDTO.setBizId(i.getPatientPushServeId());
                    patientScheduleAddDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
                    patientScheduleAddDTO.setBizTwoType("job_task");
                    patientScheduleAddDTO.setTitle(i.getPushServeTitle());
                    patientScheduleAddDTO.setContent(pushServeConfigBO.getMediaId()); // mediaId为推送消息的id，这个id可以使消息跳转到具体的消息页
                    patientScheduleAddDTO.setStatus(PatientPushServeConstant.ScheduleStatus.TODO.getCode());
                    patientScheduleAddDTO.setScheduleType(pushServeConfigBO.getRemindWay());

                    patientScheduleAddDTOs.add(patientScheduleAddDTO);
                } else {
                    userList.forEach(user -> {
                        if (!YN.YES.getCode().equals(user.getIsAuth())) {
                            return;
                        }
                        // 推送本人，如是家属则跳过
                        if (PushServeTargetEnum.Self.getCode().equals(pushServeConfigBO.getPushTarget()) && !"1".equals(user.getRelationType())) {
                            return;
                        }
                        // 推送家属，若是本人则跳过
                        if (PushServeTargetEnum.Family.getCode().equals(pushServeConfigBO.getPushTarget()) && "1".equals(user.getRelationType())) {
                            return;
                        }

                        PatientScheduleAddDTO patientScheduleAddDTO = new PatientScheduleAddDTO();
                        patientScheduleAddDTO.setScheduleDate(DateUtil.formatDateTime(j.getSendDate()));
                        patientScheduleAddDTO.setPatientId(i.getPatientId());
                        patientScheduleAddDTO.setUserId(user.getUserId());
                        patientScheduleAddDTO.setBizId(i.getPatientPushServeId());
                        patientScheduleAddDTO.setBizOneType(ObjectTypeEnum.OT_OneType_PatientPushServe.getCode());
                        patientScheduleAddDTO.setBizTwoType("job_task");
                        patientScheduleAddDTO.setTitle(i.getPushServeTitle());
                        patientScheduleAddDTO.setContent(pushServeConfigBO.getMediaId()); // mediaId为推送消息的id，这个id可以使消息跳转到具体的消息页
                        patientScheduleAddDTO.setStatus(PatientPushServeConstant.ScheduleStatus.TODO.getCode());
                        patientScheduleAddDTO.setScheduleType(pushServeConfigBO.getRemindWay());
                        
                        patientScheduleAddDTOs.add(patientScheduleAddDTO);
                    });
                }
            });
        });

        // 保存日程
        if (CollectionUtil.isNotEmpty(patientScheduleAddDTOs)) {
            patientPushServeBizService.addPatientScheduleBatch(patientScheduleAddDTOs);
        }
    }

    @Override
    public void recipeMedicineRemindTaskExecute() {
        DateTime now = DateUtil.date();
        // 获取提醒信息
        PatientRemindQueryDTO patientRemindQueryDTO = new PatientRemindQueryDTO();
        patientRemindQueryDTO.setBizOneType("recipe_medicine");
        patientRemindQueryDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Todo.getCode());
        // patientRemindQueryDTO.setStartDate(DateUtil.offsetMinute(now, -10));  // 查询十分钟左右的提醒，注意设置定时任务的循环触发时间不大于该时间
        patientRemindQueryDTO.setEndDate(DateUtil.offsetMinute(now, 10)); // 查询最多超前10分钟的提醒
        patientRemindQueryDTO.setLimit(1000);
        List<PatientRemindVO> patientRemindVOs = patientPushServeQueryBizService.listPatientRemind(patientRemindQueryDTO);
        if (CollectionUtil.isEmpty(patientRemindVOs)) {
            return;
        }

        List<PatientRemindVO> pushServeRemindList = new ArrayList<>();
        List<PatientRemindVO> recipeMedicineRemindList = new ArrayList<>();
        
        List<PatientRemindUpdateDTO> updateRemindExpireList = new ArrayList<>(); // 超过2天未发送的提醒进行标记

        List<PatientRemindUpdateDTO> updateRemindBlackList = new ArrayList<>(); // 黑名单
        
        List<String> patientIds = new ArrayList<>();
        patientRemindVOs.forEach(i ->patientIds.add(i.getPatientId()));
        // 黑名单患者
        Set<String> invalidPatientIds = getInvalidPatientIds(patientIds);
        
        patientRemindVOs.forEach(remind -> {
            // 黑名单
            if (invalidPatientIds.contains(remind.getPatientId())) {
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setId(remind.getId());
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.BlackList.getCode());
                patientRemindUpdateDTO.setErrorCode("-1");
                patientRemindUpdateDTO.setErrorMsg(PatientPushServeConstant.RemindPushStatus.BlackList.getMsg());
                updateRemindBlackList.add(patientRemindUpdateDTO);
                return;
            }

            // TODO zs20240907 限制的查询时间，该代码不会执行
            // 超过2天更新为过期
            if (DateUtil.offsetDay(now, -2).after(remind.getPushDate())) {
                PatientRemindUpdateDTO patientRemindUpdateDTO = new PatientRemindUpdateDTO();
                patientRemindUpdateDTO.setId(remind.getId());
                patientRemindUpdateDTO.setPushStatus(PatientPushServeConstant.RemindPushStatus.Expire.getCode());
                updateRemindExpireList.add(patientRemindUpdateDTO);
                return;
            }

            // 提醒类型
            if (ObjectTypeEnum.OT_OneType_PatientPushServe.getCode().equals(remind.getBizOneType())) {
                log.info("1.患者推送服务>>>>>> {}", JSON.toJSONString(remind));
                pushServeRemindList.add(remind);
            }
            if ("recipe_medicine".equals(remind.getBizOneType())) {
                log.info("1.患者用药服务>>>>>> {}", JSON.toJSONString(remind));
                recipeMedicineRemindList.add(remind);
            }
        });

        // List<PatientRemindUpdateDTO> cannotSendRemindList = new ArrayList<>(); // 由于数据问题无法发送的更新状态
        // List<PatientRemindUpdateDTO> notFollowRemindList = new ArrayList<>(); // 没有关注导致无法发送消息
        List<PatientRemindUpdateDTO> updateRemindList = new ArrayList<>(); // 保存所有待更新的提醒

        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志
        // List<ThirdUserUpdateClientDTO> thirdUserUpdateClientDTOs = new ArrayList<>(); // TODO 更新家庭第三方用户信息表的关注状态

        // 患者用药推送提醒
        this.recipeMedicineRemind(recipeMedicineRemindList, updateRemindList, pushWeixinLogAddDTOs);

        // 保存状态
        if (CollectionUtil.isNotEmpty(updateRemindList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindExpireList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindExpireList);
        }
        if (CollectionUtil.isNotEmpty(updateRemindBlackList)) {
            patientPushServeBizService.updatePatientRemindBatch(updateRemindBlackList);
        }

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
    }
    
}
