package com.xxh.cloud.healthy.serve.pushTask.client.api.constant;

public class DoctorFollowUpConstant {

    // 随访类型
    public enum Type {

        Normal("normal", "普通随访"),
        CY("CY", "出院随访"),
        HZ("HZ", "会诊随访"),
        HZCY("HZCY", "会诊出院随访"),

        ;

        private String code;
        private String msg;
        private Type(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public String getMsg() {
            return msg;
        }
    }

    // 随访状态
    public enum Status {

        TODO("todo","待随访"),
        DOING("doing", "随访中"),
        DONE("done", "已随访"),
        CANCEL("cancel", "取消"),
        EXPIRE("expire", "过期"),


        ING("ing", "当天随访中"), // 不记录到数据库，在返回时判断并设置

        ;

        private String code;
        private String msg;
        private Status(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public String getMsg() {
            return msg;
        }
    }

    // 随访操作类型
    public enum OpType {

        MANUAL("manual","手动操作"),
        TASK("task", "定时任务操作"),

        ;

        private String code;
        private String msg;
        private OpType(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public String getMsg() {
            return msg;
        }
    }

}
