package com.xxh.cloud.healthy.serve.pushTask.client.api.constant;

public class DoctorTaskConstant {

    // 医生任务信息状态
    public enum DoctorTaskStatus {
        Create("1","创建"),
        Doing("2", "进行中"),
        Done("3","结束"),
        Cancel("4", "取消"),

        ;

        private String code;
        private String msg;
        private DoctorTaskStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public String getMsg() {
            return msg;
        }
    }

    // 医生任务信息状态
    public enum DoctorTaskExeStatus {
        TODO("todo", "待执行"), // zs20240117172323 用于展开查询每个医生的任务（一个任务可以由多个医生执行）
        Send("send","发送"),
        Ignore("ignore", "忽略"),

        ;

        private String code;
        private String msg;
        private DoctorTaskExeStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }
        public String getCode() {
            return code;
        }
        public String getMsg() {
            return msg;
        }
    }

    // 医生推送服务第三方推送状态
    public enum PushStatus {
        Todo("1","待发送"),
        Success("2", "成功"),
        Fail("3","失败"),
        Invalid("4","无效"), // 由于参数问题永远无法发送
        Expire("7", "过期未发送"),
        
        // ConsultationExist("8", "已发起会诊，忽略提醒"),

        ;

        private String code;
        private String msg;
        private PushStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

    // 医生任务统计状态
    public enum DoctorTaskStatisticStatus {
        All("all","全部"),
        Todo("todo","待处理"),
        Done("done", "已处理"),

        ;

        private String code;
        private String msg;
        private DoctorTaskStatisticStatus(String code, String msg) {
            this.code = code;
            this.msg = msg;
        }

        public String getCode() {
            return code;
        }
        public void setCode(String code) {
            this.code = code;
        }
        public String getMsg() {
            return msg;
        }
        public void setMsg(String msg) {
            this.msg = msg;
        }
    }

}
