package com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生随访表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_doctor_follow_up_info")
public class DoctorFollowUpInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 随访类型
     */
    @ApiModelProperty(value = "随访类型")
    private String type;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 门诊号
     */
    @ApiModelProperty(value = "门诊号/住院号")
    private String visitId;

    /**
     * 相关疾病ID
     */
    @ApiModelProperty(value = "相关疾病ID")
    private String diseaseId;

    /**
     * 随访医生ID
     */
    @ApiModelProperty(value = "随访医生ID")
    private String doctorId;

    /**
     * 随访内容
     */
    @ApiModelProperty(value = "随访内容")
    private String content;

    /**
     * 随访记录
     */
    @ApiModelProperty(value = "随访记录")
    private String remark;

    /**
     * 设定随访时间
     */
    @ApiModelProperty(value = "设定随访时间")
    private Date followTime;

    /**
     * 实际随访时间
     */
    @ApiModelProperty(value = "实际随访时间")
    private Date realTime;

    /**
     * 随访状态
     */
    @ApiModelProperty(value = "随访状态")
    private String status;

    /**
     * 操作类型
     */
    @ApiModelProperty(value = "操作类型")
    private String opType;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

    /**
     * 会诊id
     */
    @ApiModelProperty(value = "会诊id")
    private String consultationId;

    /**
     * 来源科室
     */
    @ApiModelProperty(value = "来源科室")
    private String sourceDeptId;

    /**
     * 来源时间
     */
    @ApiModelProperty(value = "来源时间")
    private Date sourceDate;

    /**
     * 关联个案id
     */
    @ApiModelProperty(value = "关联个案id")
    private String crmRelationId;
}
