package com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * N医生推送患者服务日志表
 * </p>
 *
 * @author anros
 * @since 2023-09-23
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_doctor_push_serve_log_info")
public class DoctorPushServeLogInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 部门ID
     */
     @ApiModelProperty(value = "部门ID")
      private String deptId;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 推送任务id
     */
     @ApiModelProperty(value = "推送任务id")
      private String pushTaskId;

    /**
     * 患者id
     */
     @ApiModelProperty(value = "患者id")
      private String patientId;

    /**
     * 推送服务id
     */
     @ApiModelProperty(value = "推送服务id")
      private String pushServeId;

    /**
     * 患者推送服务id
     */
     @ApiModelProperty(value = "患者推送服务id")
      private String patientPushServeId;

    /**
     * 推送类型
     */
     @ApiModelProperty(value = "推送类型[PushWayEnum]")
      private String type;

    /**
     * 推送状态
     */
     @ApiModelProperty(value = "推送状态[YN]")
      private String status;

}
