package com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生(运营助理)关系表，只用于随访
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_doctor_relation_info")
public class DoctorRelationInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 关联类型（医生科室/医生病种）
     */
     @ApiModelProperty(value = "关联类型")
      private String type;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 关联id（部门/病种）
     */
     @ApiModelProperty(value = "关联id")
      private String relationId;

    /**
     * 关联状态
     */
     @ApiModelProperty(value = "关联状态")
      private String status;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;

}
