package com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * N医生任务信息执行记录表
 * </p>
 *
 * @author anros
 * @since 2023-09-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_doctor_task_exe_info")
public class DoctorTaskExeInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 医生任务ID
     */
    @ApiModelProperty(value = "医生任务ID")
    private String doctorTaskId;

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    /**
     * 执行状态
     */
    @ApiModelProperty(value = "执行状态")
    private String status;

    /**
     * 执行备注
     */
    @ApiModelProperty(value = "执行备注")
    private String remark;

    /**
     * 执行动作参数
     */
    @ApiModelProperty(value = "执行动作参数")
    private String actionConfig;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
