package com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * N医生任务信息表
 * </p>
 *
 * @author anros
 * @since 2023-09-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_doctor_task_info")
public class DoctorTaskInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 任务ID
     */
    @ApiModelProperty(value = "任务ID")
    private String taskId;

    /**
     * 任务名称
     */
    @ApiModelProperty(value = "任务名称")
    private String taskName;

    /**
     * 任务类型
     */
    @ApiModelProperty(value = "任务类型")
    private String taskType;

    /**
     * 执行人列表
     */
    @ApiModelProperty(value = "执行人列表")
    private String doctorIds;

    /**
     * 已执行人列表
     */
    @ApiModelProperty(value = "已执行人列表")
    private String yesDoctorIds;

    /**
     * 未执行人列表
     */
    @ApiModelProperty(value = "未执行人列表")
    private String notDoctorIds;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 关联业务分类
     */
    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    /**
     * 关联一级业务ID(流程任务ID)
     */
    @ApiModelProperty(value = "关联一级业务ID(流程任务ID)")
    private String relOneId;

    /**
     * 关联二级业务ID(流程任务节点ID)
     */
    @ApiModelProperty(value = "关联二级业务ID(流程任务节点ID)")
    private String relTwoId;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 患者性别
     */
    @ApiModelProperty(value = "患者性别")
    private String patientSex;

    /**
     * 任务紧急等级
     */
    @ApiModelProperty(value = "任务紧急等级")
    private String urgentLevel;

}
