package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import java.util.Date;

import javax.validation.constraints.NotEmpty;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生随访表
 * </p>
 */
@Getter
@Setter
public class DoctorFollowUpAddDTO {

    /**
     * 随访类型
     */
    @ApiModelProperty(value = "随访类型")
    private String type;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号", required = true)
    @NotEmpty(message = "患者编号不能为空")
    private String patientId;

    /**
     * 门诊号/住院号
     */
    @ApiModelProperty(value = "门诊号/住院号")
    private String visitId;

    /**
     * 相关疾病ID
     */
    @ApiModelProperty(value = "相关疾病ID")
    private String diseaseId;

    /**
     * 随访医生ID
     */
    @ApiModelProperty(value = "随访医生ID")
    private String doctorId;

    /**
     * 随访内容
     */
    @ApiModelProperty(value = "随访内容")
    private String content;

    /**
     * 随访备注
     */
    @ApiModelProperty(value = "随访备注")
    private String remark;

    /**
     * 设定随访时间
     */
    @ApiModelProperty(value = "设定随访时间（天数）", required = true)
    // @NotNull(message = "设定随访时间不能为空")
    private Integer followTime;

    /**
     * 设定随访时间
     */
    @ApiModelProperty(value = "设定随访时间（具体时间）", required = true)
    // @NotNull(message = "设定随访时间不能为空")
    private Date followDate;

    /**
     * 操作类型
     */
    @ApiModelProperty(value = "操作类型")
    private String opType;

    /**
     * 会诊id
     */
    @ApiModelProperty(value = "会诊id")
    private String consultationId;

    /**
     * 来源科室
     */
    @ApiModelProperty(value = "来源科室")
    private String sourceDeptId;

    /**
     * 来源时间
     */
    @ApiModelProperty(value = "来源时间")
    private Date sourceDate;

    /**
     * 关联个案id
     */
    @ApiModelProperty(value = "关联个案id")
    private String crmRelationId;

}
