package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.BasePageDTO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生随访表
 * </p>
 */
@Getter
@Setter
public class DoctorFollowUpQueryDTO extends BasePageDTO {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;
    
    @ApiModelProperty(value = "ids")
    private List<String> ids;

    /**
     * 随访类型
     */
    @ApiModelProperty(value = "随访类型")
    private String type;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "患者编号列表")
    private List<String> patientIds;

    @ApiModelProperty(value = "患者名称")
    private String patientName;

    /**
     * 门诊号/住院号
     */
    @ApiModelProperty(value = "门诊号/住院号")
    private String visitId;

    /**
     * 随访医生ID
     */
    @ApiModelProperty(value = "随访医生ID")
    private String doctorId;

    /**
     * 随访状态
     */
    @ApiModelProperty(value = "随访状态")
    private String status;

    /**
     * 操作类型
     */
    @ApiModelProperty(value = "操作类型")
    private String opType;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    /**
     * 结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    /**
     * 是否是正常解析后的随访数据
     */
    @ApiModelProperty(value = "是否是正常解析后的随访数据")
    private String isNormal = YN.YES.getCode();

    /**
     * 是否会诊完成
     */
    @ApiModelProperty(value = "是否会诊完成")
    private String hzFinished; // = YN.YES.getCode();

    /**
     * 来源科室
     */
    @ApiModelProperty(value = "来源科室")
    private String sourceDeptId;

    /**
     * 来源科室名称
     */
    @ApiModelProperty(value = "来源科室名称")
    private String sourceDeptName;

    /**
     * 来源开始时间
     */
    @ApiModelProperty(value = "来源开始时间")
    private Date sourceStartDate;

    /**
     * 来源结束时间
     */
    @ApiModelProperty(value = "来源结束时间")
    private Date sourceEndDate;

}
