package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class DoctorPushServeAddDTO {

    @ApiModelProperty(value = "医生任务ID", required = true)
    @NotEmpty(message = "医生任务ID[doctorTaskId]不能为空")
    private String doctorTaskId;

    // @ApiModelProperty(value = "患者编号", required = true)
    // @NotEmpty(message = "患者编号[patientId]不能为空")
    // private String patientId;

    // // 注意：更改为从挂号时间/就诊时间/住院时间选取
    // // zs202311091435 医生推送是立即推送，所以如果配置是以基准时间推送那基准时间为当前时间
    // @ApiModelProperty(value = "基准发送时间内容")
    // private String benchmarkDateValue;

    @ApiModelProperty(value = "建议措施[PushWayEnum]", required = true)
    @NotEmpty(message = "建议措施[action]不能为空")
    private String action;

    @ApiModelProperty(value = "部门ID")
    private String deptId;
    
    @ApiModelProperty(value = "医生编号")
    private String doctorId;

    // zs20231030 医生任务执行记录
    @ApiModelProperty(value = "执行备注")
    private String remark;
    @ApiModelProperty(value = "执行动作参数")
    private String actionConfig;

}
