package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.List;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生(运营助理)关系表
 * </p>
 */
@Getter
@Setter
public class DoctorRelationAddBatchDTO {

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID", required = true)
     @NotEmpty(message = "医生ID不能为空")
      private String doctorId;

    /**
     * 部门id列表
     */
     @ApiModelProperty(value = "部门id列表")
      private List<String> deptIds;

    /**
     * 病种id列表
     */
     @ApiModelProperty(value = "病种id列表")
      private List<String> diseaseIds;

}
