package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorRemindQueryDTO extends BasePageDTO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "ids")
    private List<String> ids;

    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    @ApiModelProperty(value = "医生IDs")
    private List<String> doctorIds;

    /**
     * 业务一级分类
     */
    @ApiModelProperty(value = "业务一级分类")
    private String bizOneType;

    /**
     * 业务二级分类
     */
    @ApiModelProperty(value = "业务二级分类")
    private String bizTwoType;

    /**
     * 推送渠道
     */
    @ApiModelProperty(value = "推送渠道")
    private String pushChannel;

    /**
     * 推送状态
     */
    @ApiModelProperty(value = "推送状态")
    private String pushStatus;

    @ApiModelProperty(value = "紧急等级[RemindLevelEnum]")
    private String urgentLevel;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    /**
     * 结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    /**
     * 微信推送状态
     */
    @ApiModelProperty(value = "微信推送状态")
    private String wxworkStatus;

    /**
     * 短信推送状态
     */
    @ApiModelProperty(value = "短信推送状态")
    private String smsStatus;

}
