package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class DoctorScheduleUpdateDTO {

    /**
     * id
     */
    @ApiModelProperty(value = "id", required = true)
    @NotEmpty(message = "id不能为空")
    private String id;

    /**
     * 医生ID
     */
     @ApiModelProperty(value = "医生ID")
      private String doctorId;

    /**
     * 业务一级分类
     */
     @ApiModelProperty(value = "业务一级分类")
      private String bizOneType;

    /**
     * 业务二级分类
     */
     @ApiModelProperty(value = "业务二级分类")
      private String bizTwoType;

    /**
     * 执行业务ID
     */
     @ApiModelProperty(value = "执行业务ID")
      private String bizId;

    /**
     * 日程时间
     */
    @ApiModelProperty(value = "日程时间")
    private String date;

    /**
     * 日程标题
     */
     @ApiModelProperty(value = "日程标题")
      private String title;

    /**
     * 日程内容
     */
     @ApiModelProperty(value = "日程内容")
      private String content;

    /**
     * 日程状态
     */
     @ApiModelProperty(value = "日程状态")
      private String status;

      @ApiModelProperty(value = "紧急等级[RemindLevelEnum]")
      private String urgentLevel;
  
}
