package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class DoctorTaskQueryDTO extends BasePageDTO {

    @ApiModelProperty(value = "医生任务ID")
    private String doctorTaskId;

    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    @ApiModelProperty(value = "执行状态[DoctorTaskConstant.DoctorTaskStatus]")
    private String status;

    @ApiModelProperty(value = "任务名称")
    private String taskName;

    @ApiModelProperty(value = "任务类型")
    private String taskType;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    @ApiModelProperty(value = "任务紧急等级")
    private String urgentLevel;

    @ApiModelProperty(value = "查询是否完成的任务，不传查询所有")
    private Boolean isFinished;

    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    @ApiModelProperty(value = "操作类型[PushTaskConstant.OpType]")
    private String opType;

    @ApiModelProperty(value = "科室id")
    private String deptId;
    
    @ApiModelProperty(value = "执行状态[DoctorTaskConstant.DoctorTaskExeStatus]")
    private String exeStatus;

    @ApiModelProperty(value = "病种id")
    private String diseaseId;

    @ApiModelProperty(value = "病种ids")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "医生任务ID列表")
    private List<String> doctorTaskIds;

}
