package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos;

import java.util.Date;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientReturnVisitBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生随访表
 * </p>
 */
@Getter
@Setter
public class DoctorFollowUpVO extends BaseEntity {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 随访类型
     */
    @ApiModelProperty(value = "随访类型")
    private String type;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 门诊号/住院号
     */
    @ApiModelProperty(value = "门诊号/住院号")
    private String visitId;

    /**
     * 相关疾病ID
     */
    @ApiModelProperty(value = "相关疾病ID")
    private String diseaseId;

    /**
     * 随访医生ID
     */
    @ApiModelProperty(value = "随访医生ID")
    private String doctorId;

    /**
     * 随访内容
     */
    @ApiModelProperty(value = "随访内容")
    private String content;

    /**
     * 随访记录
     */
    @ApiModelProperty(value = "随访记录")
    private String remark;

    /**
     * 设定随访时间
     */
    @ApiModelProperty(value = "设定随访时间")
    private Date followTime;

    /**
     * 实际随访时间
     */
    @ApiModelProperty(value = "实际随访时间")
    private Date realTime;

    /**
     * 随访状态
     */
    @ApiModelProperty(value = "随访状态")
    private String status;

    /**
     * 操作类型
     */
    @ApiModelProperty(value = "操作类型")
    private String opType;

    /**
     * 会诊id(会诊时的随访记录会诊id)
     */
    @ApiModelProperty(value = "会诊id(会诊时的随访记录会诊id)")
    private String consultationId;

    /**
     * 来源科室
     */
    @ApiModelProperty(value = "来源科室")
    private String sourceDeptId;

    /**
     * 来源时间(来源数据的时间：出院时间/会诊结论提交时间等)
     */
    @ApiModelProperty(value = "来源时间")
    private Date sourceDate;

    /**
     * 来源科室信息
     */
    @ApiModelProperty(value = "来源科室信息")
    private DeptBO sourceDeptInfo;

    /**
     * 医生信息
     */
    @ApiModelProperty(value = "医生信息")
    private AdminUserBO doctorInfo;

    /**
     * 部门信息
     */
    @ApiModelProperty(value = "部门信息")
    private DeptBO deptInfo;

    /**
     * 患者信息
     */
    @ApiModelProperty(value = "患者信息")
    private PatientClientBO patientInfo;

    /**
     * 病种信息
     */
    @ApiModelProperty(value = "病种信息")
    private StandardDiseaseBO diseaseInfo;

    /**
     * 住院信息
     */
    @ApiModelProperty(value = "住院信息")
    private PatientInpatientRecordClientBO inpatientRecordInfo;

    /**
     * 会诊信息
     */
    @ApiModelProperty(value = "会诊信息")
    private ConsultationBO consultationInfo;

    @ApiModelProperty(value = "患者最新就诊信息")
    private PatientVisitRecordClientBO visitInfo;

    @ApiModelProperty(value = "患者最新住院信息")
    private PatientInpatientRecordClientBO inpatientInfo;

    @ApiModelProperty(value = "患者最新出院信息")
    private PatientDischargeRecordClientBO outpatientInfo;

    /**
     * 随访复诊信息
     */
    @ApiModelProperty(value = "患者复诊信息")
    private PatientReturnVisitBO returnVisitInfo;

    @ApiModelProperty(value = "是否加入个案")
    private String crmStatus;

}
