package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos;

import java.util.List;

import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生(运营助理)关系表
 * </p>
 */
@Getter
@Setter
public class DoctorRelationByDoctorVO {

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    /**
     * 部门id列表
     */
    @ApiModelProperty(value = "部门id列表")
    private List<String> deptIds;

    /**
     * 病种id列表
     */
    @ApiModelProperty(value = "病种id列表")
    private List<String> diseaseIds;

    /**
     * 医生信息
     */
    @ApiModelProperty(value = "医生信息")
    private AdminUserBO doctorInfo;

    /**
     * 部门信息
     */
    @ApiModelProperty(value = "部门信息")
    private List<DeptBO> deptInfoList;

    /**
     * 病种信息
     */
    @ApiModelProperty(value = "病种信息")
    private List<StandardDiseaseBO> diseaseInfoList;

}
