package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 医生(运营助理)关系表
 * </p>
 */
@Getter
@Setter
public class DoctorRelationVO extends BaseEntity {

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 关联类型（医生科室/医生病种）
     */
    @ApiModelProperty(value = "关联类型")
    private String type;

    /**
     * 医生ID
     */
    @ApiModelProperty(value = "医生ID")
    private String doctorId;

    /**
     * 关联id（部门/病种）
     */
    @ApiModelProperty(value = "关联id")
    private String relationId;

    /**
     * 关联状态
     */
    @ApiModelProperty(value = "关联状态")
    private String status;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 医生信息
     */
    @ApiModelProperty(value = "医生信息")
    private AdminUserBO doctorInfo;

    /**
     * 部门信息
     */
    @ApiModelProperty(value = "部门信息")
    private DeptBO deptInfo;

    /**
     * 病种信息
     */
    @ApiModelProperty(value = "病种信息")
    private StandardDiseaseBO diseaseInfo;

}
