package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.bos.PushTaskConfigBO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class ManageDoctorTaskVO {

    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 任务ID
     */
    @ApiModelProperty(value = "任务ID")
    private String taskId;

    /**
     * 任务名称
     */
    @ApiModelProperty(value = "任务名称")
    private String taskName;

    /**
     * 任务类型
     */
    @ApiModelProperty(value = "任务类型")
    private String taskType;

    /**
     * 执行人列表
     */
    @ApiModelProperty(value = "执行人列表")
    private List<String> doctorIds;

    /**
     * 已执行人列表
     */
    @ApiModelProperty(value = "已执行人列表")
    private List<String> yesDoctorIds;

    /**
     * 未执行人列表
     */
    @ApiModelProperty(value = "未执行人列表")
    private List<String> notDoctorIds;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 关联业务分类
     */
    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    /**
     * 关联一级业务ID(流程任务ID)
     */
    @ApiModelProperty(value = "关联一级业务ID(流程任务ID)")
    private String relOneId;

    /**
     * 关联二级业务ID(流程任务节点ID)
     */
    @ApiModelProperty(value = "关联二级业务ID(流程任务节点ID)")
    private String relTwoId;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 患者性别
     */
    @ApiModelProperty(value = "患者性别")
    private String patientSex;

    @ApiModelProperty(value = "患者年龄")
    private String patientAge;

    @ApiModelProperty(value = "患者手机")
    private String patientPhone;

    @ApiModelProperty(value = "患者生日")
    private String patientBirthday;

    @ApiModelProperty(value = "紧急等级")
    private String urgentLevel;

    @ApiModelProperty(value = "创建时间")
    private Date createDate;

    @ApiModelProperty(value = "推送任务配置信息")
    private PushTaskConfigBO pushTaskConfig;

    /**
     * 医生id
     * 用于把数据拍平查询（按医生查询任务）
     */
    @ApiModelProperty(value = "医生id")
    private String doctorId;

    @ApiModelProperty(value = "执行状态")
    private String exeStatus;

    @ApiModelProperty(value = "执行时间")
    private String exeDate;

    @ApiModelProperty(value = "医生信息")
    private String doctorName;

    /**
     * 病种信息
     */
    
}
