package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper;

import com.alibaba.fastjson2.JSONObject;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.common.bean.DoctorPushTaskConfigModel;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.bo.DoctorFollowUpBO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.bo.DoctorRelationBO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRelationInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorFollowUpInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorPushServeLogInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorScheduleInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskExeInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRelationVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorPushServeLogVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorScheduleVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskExeVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskVO;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

// zs:2023-09-20
public class DoctorPushTaskHelper {

    public static String getDoctorPushTaskId(){
        return StrUtil.format("DPT{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorPushTaskExeId(){
        return StrUtil.format("DPTE{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static String getDoctorRemindId(){
        return StrUtil.format("DPT{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorScheduleId(){
        return StrUtil.format("DPT{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorPushServeLogId(){
        return StrUtil.format("DPSL{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorFollowUpId(){
        return StrUtil.format("DFU{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getDoctorRelationId(){
        return StrUtil.format("DR{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    // 发送时间等信息处理
    public static DoctorTaskVO getDoctorTaskVO(DoctorTaskInfo entity) {
        if (null == entity) {
            return null;
        }
        DoctorTaskVO vo = new DoctorTaskVO();
        BeanUtil.copyProperties(entity, vo, "doctorIds", "yesDoctorIds", "notDoctorIds");

        if (StrUtil.isNotBlank(entity.getDoctorIds())) {
            vo.setDoctorIds(StrJoinSplitUtils.split2List(entity.getDoctorIds()));
        }
        if (StrUtil.isNotBlank(entity.getYesDoctorIds())) {
            vo.setYesDoctorIds(StrJoinSplitUtils.split2List(entity.getYesDoctorIds()));
        }
        if (StrUtil.isNotBlank(entity.getNotDoctorIds())) {
            vo.setNotDoctorIds(StrJoinSplitUtils.split2List(entity.getNotDoctorIds()));
        }
        return vo;
    }

    // 发送时间等信息处理
    public static DoctorTaskExeVO getDoctorTaskExeVO(DoctorTaskExeInfo entity) {
        if (null == entity) {
            return null;
        }

        DoctorTaskExeVO vo = new DoctorTaskExeVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorRemindVO getDoctorRemindVO(DoctorRemindInfo entity) {
        if (null == entity) {
            return null;
        }
        
        DoctorRemindVO vo = new DoctorRemindVO();
        BeanUtil.copyProperties(entity, vo, "pushConfig");
        if (null != entity.getPushConfig()) {
            vo.setPushConfig(JSONObject.parseObject(entity.getPushConfig(), DoctorPushTaskConfigModel.class));
        }
        return vo;
    }

    public static DoctorScheduleVO getDoctorScheduleVO(DoctorScheduleInfo entity) {
        if (null == entity) {
            return null;
        }
        
        DoctorScheduleVO vo = new DoctorScheduleVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorPushServeLogVO getDoctorPushServeLogVO(DoctorPushServeLogInfo entity) {
        if (null == entity) {
            return null;
        }
        
        DoctorPushServeLogVO vo = new DoctorPushServeLogVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorFollowUpVO getDoctorFollowUpVO(DoctorFollowUpInfo entity) {
        if (null == entity) {
            return null;
        }

        DoctorFollowUpVO vo = new DoctorFollowUpVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorFollowUpBO getDoctorFollowUpBO(DoctorFollowUpVO vo) {
        if (null == vo) {
            return null;
        }
        
        DoctorFollowUpBO bo = new DoctorFollowUpBO();
        BeanUtil.copyProperties(vo, bo);
        if (null != vo.getPatientInfo()) {
            bo.setPatientName(vo.getPatientInfo().getPatientName());
            bo.setPatientPhone(vo.getPatientInfo().getPhone());
            bo.setPatientGenderStandard(vo.getPatientInfo().getPatientGenderStandard());
            bo.setPatientAge(vo.getPatientInfo().getAge());
            bo.setPatientBirthday(vo.getPatientInfo().getBirthday());
            bo.setPatientDeathStatus(vo.getPatientInfo().getDeathStatus());
            bo.setPatientDeathTime(vo.getPatientInfo().getDeathTime());
        }

        return bo;
    }

    public static DoctorRelationVO getDoctorRelationVO(DoctorRelationInfo entity) {
        if (null == entity) {
            return null;
        }

        DoctorRelationVO vo = new DoctorRelationVO();
        BeanUtil.copyProperties(entity, vo);
        return vo;
    }

    public static DoctorRelationBO getDoctorRelationBO(DoctorRelationVO vo) {
        if (null == vo) {
            return null;
        }

        DoctorRelationBO bo = new DoctorRelationBO();
        BeanUtil.copyProperties(vo, bo);
        return bo;
    }

}
