package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.ConsultationApplyAdviceVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;

// 医生随访
public interface DoctorFollowUpQueryBizMapper {

    // 查询会诊随访信息
    @Select(" SELECT a.id " + 
            " FROM h_doctor_follow_up_info a " +
            " INNER JOIN mdt_his_consultation_advice_info b ON a.consultation_id = b.consultation_id " + 
            " ${ew.customSqlSegment} ")
    List<String> hzFollowUpList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 查询随访会诊
//     @Select(" SELECT a.consultation_id as consultationId, a.consultation_label_id as consultationLabelId " + 
//             " FROM mdt_consultation_launch_apply_info a " +
//             " INNER JOIN mdt_his_consultation_advice_info b ON a.consultation_id = b.consultation_id " + 
//             " ${ew.customSqlSegment} ")
//     List<Map<String, String>> followupHzList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

    // 查询随访会诊
    @Select(" SELECT a.patient_id as patientId, a.consultation_id as consultationId, a.consultation_label_id as consultationLabelId, a.visit_id as visitId, " + 
            "   b.followup, b.submit_content as submitContent, b.mdt_dept_code as mdtDeptCode, b.submit_time as submitTime " +
            " FROM mdt_consultation_launch_apply_info a " +
            " INNER JOIN mdt_his_consultation_advice_info b ON a.consultation_id = b.consultation_id " + 
            " INNER JOIN s_md_standard_label_info c ON a.consultation_label_id = c.id " + 
            " LEFT JOIN (SELECT consultation_id FROM h_doctor_follow_up_info WHERE rows_status = 'Y' GROUP BY consultation_id) d ON a.consultation_id = d.consultation_id " + 
            " ${ew.customSqlSegment} ")
    List<ConsultationApplyAdviceVO> followupHzList(@Param(Constants.WRAPPER) Wrapper<ConsultationApplyAdviceVO> wrapper);

    // 查询随访会诊
//     @Select(" SELECT b.patient_id as patientId, a.consultation_id as consultationId, a.inpatient_id as inpatientId, a.followup, a.submit_content as submitContent, " + 
//             "   a.mdt_dept_code as mdtDeptCode, a.submit_time as submitTime, c.consultation_label_id as consultationLabelId, c.consultation_follow_up_base_date_type as consultationFollowUpBaseDateType " +
//             " FROM mdt_his_consultation_advice_info a " +
//             " INNER JOIN mdt_consultation_info b ON a.consultation_id = b.id " +
//             " LEFT JOIN ( " + 
//             "   SELECT a.consultation_id, a.consultation_label_id, b.consultation_follow_up_base_date_type " + 
//             "   FROM mdt_consultation_launch_apply_info a " + 
//             "   INNER JOIN s_md_standard_label_info b ON a.consultation_label_id = b.id " + 
//             "   WHERE (a.type = 'task' AND a.consultation_id IS NOT NULL AND a.finish_time IS NOT NULL AND (b.consultation_follow_up_base_date_type IS NULL OR b.consultation_follow_up_base_date_type = 'HZ')) " + 
//             " ) c ON a.consultation_id = c.consultation_id " + 
//             " LEFT JOIN (SELECT consultation_id FROM h_doctor_follow_up_info GROUP BY consultation_id) d ON a.consultation_id = d.consultation_id " + 
//             " ${ew.customSqlSegment} ")
//     List<ConsultationApplyAdviceVO> consultationFollowupList(@Param(Constants.WRAPPER) Wrapper<ConsultationApplyAdviceVO> wrapper /**, @Param("ew2") Wrapper<ConsultationApplyAdviceVO> wrapper2**/);
    @Select(" SELECT b.patient_id as patientId, a.consultation_id as consultationId, a.inpatient_id as inpatientId, a.followup, a.submit_content as submitContent, " + 
            "   a.mdt_dept_code as mdtDeptCode, a.submit_time as submitTime, c.consultation_label_id as consultationLabelId, c.consultation_follow_up_base_date_type as consultationFollowUpBaseDateType " +
            " FROM mdt_his_consultation_advice_info a " +
            " INNER JOIN mdt_consultation_info b ON a.consultation_id = b.id " +
            " LEFT JOIN ( " + 
            "   SELECT a.consultation_id, a.consultation_label_id, IF(b.consultation_follow_up_base_date_type = 'CY', 'CY', 'HZ') as consultation_follow_up_base_date_type " + 
            "   FROM mdt_consultation_launch_apply_info a " + 
            "   INNER JOIN s_md_standard_label_info b ON a.consultation_label_id = b.id " + 
            "   WHERE (a.type = 'task' AND a.consultation_id IS NOT NULL AND a.finish_time IS NOT NULL) " + 
            " ) c ON a.consultation_id = c.consultation_id " + 
            " LEFT JOIN (SELECT consultation_id FROM h_doctor_follow_up_info WHERE rows_status = 'Y' GROUP BY consultation_id) d ON a.consultation_id = d.consultation_id " + 
            " ${ew.customSqlSegment} ")
    List<ConsultationApplyAdviceVO> consultationFollowupList(@Param(Constants.WRAPPER) Wrapper<ConsultationApplyAdviceVO> wrapper /**, @Param("ew2") Wrapper<ConsultationApplyAdviceVO> wrapper2**/);

    // 查询随访会诊
    @Select(" SELECT a.* " +
            " FROM h_doctor_follow_up_info a " +
            " LEFT JOIN h_patient_return_visit_info b ON b.source_type = 'follow_up' AND a.id = b.source_id " + 
            " ${ew.customSqlSegment} ")
    List<DoctorFollowUpVO> followupListWithoutReturnVisit(@Param(Constants.WRAPPER) Wrapper<DoctorFollowUpVO> wrapper);

    // 查询参加会诊的医生信息
    @Select(" SELECT b.dept_id AS deptId, a.dept_id AS relationDeptId " + 
            " FROM dept_relation a " +
            " INNER JOIN dept_relation b ON a.group_id = b.group_id " +
            " ${ew.customSqlSegment} ")
    List<Map<String, String>> relationDeptList(@Param(Constants.WRAPPER) Wrapper<Void> wrapper);

}