package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.mapper;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.ManageDoctorTaskVO;

import java.util.List;

public interface DoctorTaskQueryBizMapper {

    // 连表查询医生任务信息
    @Select(" SELECT a.*, b.doctor_id AS doctorId, b.status AS exeStatus, b.update_date exeDate " + 
            " FROM h_doctor_task_info a " +
            " INNER JOIN h_doctor_task_exe_info b ON a.id = b.doctor_task_id " + 
            " ${ew.customSqlSegment} ")
    IPage<ManageDoctorTaskVO> page(Page<DoctorTaskInfo> page, @Param(Constants.WRAPPER) Wrapper<DoctorTaskInfo> wrapper);

    // 连表查询医生任务信息
    @Select(" SELECT b.* " + 
            " FROM h_push_task_config_info a " +
            " INNER JOIN h_doctor_task_info b ON a.id = b.task_id " + 
            " ${ew.customSqlSegment} ")
    IPage<DoctorTaskInfo> pageDoctorTask(Page<DoctorTaskInfo> page, @Param(Constants.WRAPPER) Wrapper<DoctorTaskInfo> wrapper);


    @Select("SELECT id ,name ,type  FROM h_push_task_config_info ${ew.customSqlSegment}")
    public List<PushTaskConfigRO> getPushTaskConfigList(@Param(Constants.WRAPPER) Wrapper<PushTaskConfigRO> wrapper);


}