package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;

public interface DoctorFollowUpBizService {

    // 随访分页列表
    PageData<DoctorFollowUpVO> page(DoctorFollowUpQueryDTO params);
    
    // 随访列表
    List<DoctorFollowUpVO> list(DoctorFollowUpQueryDTO params);
    
    // 随访列表
    List<DoctorFollowUpVO> simpleList(DoctorFollowUpQueryDTO params);
    
    // 随访详情
    DoctorFollowUpVO detail(DoctorFollowUpGetDTO params);
    
    // 保存随访
    DoctorFollowUpVO add(DoctorFollowUpAddDTO params);

    // 保存随访
    List<DoctorFollowUpVO> addBatch(List<DoctorFollowUpAddDTO> params);

    // 更新随访
    void update(DoctorFollowUpUpdateDTO params);

    // 更新随访
    void batchUpdateStatus(List<DoctorFollowUpUpdateStatusDTO> params);

    // 发起随访日程及提醒
    void launch(DoctorFollowUpGetDTO params);

    // 发起随访日程及提醒
    void launchBatch(List<DoctorFollowUpGetDTO> params);

    // 保存并发起随访日程及提醒
    void saveAndLaunch(DoctorFollowUpAddDTO params);

    // 保存并发起随访日程及提醒
    void saveAndLaunchBatch(List<DoctorFollowUpAddDTO> params);

    // 随访
    void follow(DoctorFollowUpFollowDTO params);

    // 删除
    void del(DoctorFollowUpGetDTO params);

    // 随访超时
    void timeout();

    // 个案关联随访
    void crmRel(DoctorFollowCrmRelDTO params);
}
