package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service;

import java.util.List;

import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorPushServeLogGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorPushServeLogQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskExeGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskExeQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorPushServeLogVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindCountVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskCountVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskDateVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskExeVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.ManageDoctorTaskVO;

public interface DoctorTaskQueryBizService {

    // 查询任务
    // 分页查询任务
    PageData<DoctorTaskVO> query(DoctorTaskQueryDTO params);
    // 查询任务，按天聚合返回
    PageData<DoctorTaskDateVO> queryByDate(DoctorTaskQueryDTO params);

    PageData<DoctorTaskVO> queryByDisease(DoctorTaskQueryDTO params);
    
    List<DoctorTaskVO> list(DoctorTaskQueryDTO params);

    DoctorTaskVO getOne(DoctorTaskGetDTO params);
    // 详情
    DoctorTaskVO detail(DoctorTaskGetDTO params);
    // 我的任务：统计待处理任务/总任务的数量
    DoctorTaskCountVO getTaskCount(DoctorTaskQueryDTO params);

    // 提醒
    // 提醒列表
    List<DoctorRemindVO> listDoctorRemind(DoctorRemindQueryDTO params);
    // 智慧提醒：统计紧急/重要/普通程度的提醒数量
    DoctorRemindCountVO getRemindCountByUrgentLevel(DoctorRemindQueryDTO params);


    /**
     * 推送患者服务日志
     */
    PageData<DoctorPushServeLogVO> queryPushServe(DoctorPushServeLogQueryDTO params);

    DoctorPushServeLogVO pushServeDetail(DoctorPushServeLogGetDTO params);


    // 医生任务执行信息
    List<DoctorTaskExeVO> taskExeList(DoctorTaskExeQueryDTO params);
    
    DoctorTaskExeVO getOneTaskExe(DoctorTaskExeGetDTO params);
    
    // 按医生分页查询任务
    PageData<ManageDoctorTaskVO> queryByDoctor(DoctorTaskQueryDTO params);
}
