package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.common.constant.RemindLevelEnum;
import com.xxh.cloud.healthy.basic.pushtask.client.api.constant.PushTaskConstant;
import com.xxh.cloud.healthy.crm.client.api.PatientDoctorRelationClientService;
import com.xxh.cloud.healthy.crm.client.api.bean.bo.PatientDoctorRelationBO;
import com.xxh.cloud.healthy.crm.client.api.bean.dto.PatientDoctorRelQueryClientDTO;
import com.xxh.cloud.healthy.crm.client.api.bean.dto.PatientDoctorRelSearchClientDTO;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientDischargeRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientDataClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientLastDataQueryDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.mdt.api.ConsultationClientService;
import com.xxh.cloud.healthy.mdt.api.bean.bo.ConsultationBO;
import com.xxh.cloud.healthy.mdt.api.bean.dto.ConsultationQueryClientDTO;
import com.xxh.cloud.healthy.mdt.api.constant.ConsultationConstant.ConsultationType;
import com.xxh.cloud.healthy.serve.pushServe.client.api.PatientReturnVisitClientService;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.bo.PatientReturnVisitBO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.bean.dto.PatientReturnVisitQueryClientDTO;
import com.xxh.cloud.healthy.serve.pushServe.client.api.constant.PatientReturnVisitConstant;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorFollowUpConstant;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorRemindConstant;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorScheduleConstant;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorFollowUpInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorScheduleInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorFollowUpInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorScheduleInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.*;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.mapper.DoctorFollowUpQueryBizMapper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorFollowUpBizService;
import com.xxh.cloud.metadata.client.api.StandardDiseaseClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.DeptClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;
import com.xxh.cloud.user.client.api.bean.dto.DeptQueryDTO;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Slf4j
@Service
public class DoctorFollowUpBizServiceImpl implements DoctorFollowUpBizService {
    
    @Autowired
    private DoctorFollowUpInfoService doctorFollowUpInfoService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private PatientClientService patientClientService;
    @Autowired
    private StandardDiseaseClientService standardDiseaseClientService;
    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;
    @Autowired
    private DeptClientService deptClientService;
    @Autowired
    private DoctorScheduleInfoService doctorScheduleInfoService;
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private ConsultationClientService consultationClientService;
    @Autowired
    private PatientReturnVisitClientService patientReturnVisitClientService;
    @Autowired
    private PatientDoctorRelationClientService patientDoctorRelationClientService;

    @Override
    public PageData<DoctorFollowUpVO> page(DoctorFollowUpQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        // 查询会诊结束的随访数据
        // Set<String> consultationIds = new HashSet<>(); // 会诊id
        // if (DoctorFollowUpConstant.Type.HZ.getCode().equals(params.getType()) && YN.YES.getCode().equals(params.getHzFinished())) {
        //     // 查询有会诊结果的会诊信息
        //     List<String> ids = doctorFollowUpQueryBizMapper.hzFollowUpList(new QueryWrapper<Void>()
        //         .eq("a.type", DoctorFollowUpConstant.Type.HZ.getCode())
        //         .isNotNull("a.consultation_id")
        //     );
        //     if (CollUtil.isEmpty(ids)) {
        //         return new PageData<>(null, 0);
        //     }
        //     params.setIds(ids);
        // }

        // 若按照患者名称筛选则先查询患者信息
        List<String> patientIds = new ArrayList<>();
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                patientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }
        
        // 若按照来源科室名称筛选则先查询来源科室信息
        Set<String> sourceDeptIds = new HashSet<>(); // 来源科室信息
        Map<String, DeptBO> sourceDeptMap = new HashMap<>();
        if (StrUtil.isNotBlank(params.getSourceDeptName())) {
            DeptQueryDTO deptQueryDTO = new DeptQueryDTO();
            deptQueryDTO.setName(params.getSourceDeptName());
            List<DeptBO> deptList = deptClientService.getDeptList(deptQueryDTO);
            if (CollectionUtil.isEmpty(deptList)) {
                return new PageData<>(null, 0);
            }
            deptList.forEach(i -> {
                sourceDeptIds.add(i.getId());
                sourceDeptMap.put(i.getId(), i);
            });
        }

        QueryWrapper<DoctorFollowUpInfo> queryWrapper = new QueryWrapper<DoctorFollowUpInfo>();
        if (StrUtil.isNotBlank(params.getType())) {
            queryWrapper.eq("type", params.getType());
            if (DoctorFollowUpConstant.Type.Normal.getCode().equals(params.getType())) {
                queryWrapper.and(i -> i.isNull("type").or().eq("type", params.getType()));
            } // else if (DoctorFollowUpConstant.Type.HZ.getCode().equals(params.getType())) {
            //     queryWrapper.in("type", DoctorFollowUpConstant.Type.HZ.getCode(), DoctorFollowUpConstant.Type.HZCY.getCode());
            // }
        }
        
        IPage<DoctorFollowUpInfo> page = doctorFollowUpInfoService.page(new Page<>(params.getPage(), params.getRows()), queryWrapper
                .eq("rows_status", YN.YES.getCode())
                .isNotNull(StrUtil.isBlank(params.getIsNormal()) || !(YN.NO.getCode().equals(params.getIsNormal())), "follow_time")
                .isNull(StrUtil.isNotBlank(params.getIsNormal()) && YN.NO.getCode().equals(params.getIsNormal()), "follow_time")
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollUtil.isNotEmpty(patientIds), "patient_id", patientIds)
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .ge(null != params.getStartDate(), "follow_time", params.getStartDate())
                .lt(null != params.getEndDate(), "follow_time", params.getEndDate())
                .in(CollUtil.isNotEmpty(sourceDeptIds), "source_dept_id", sourceDeptIds)
                .ge(null != params.getSourceStartDate(), "source_date", params.getSourceStartDate())
                .lt(null != params.getSourceEndDate(), "source_date", params.getSourceEndDate())
                .orderByAsc("follow_time")
        );

        if (CollectionUtil.isEmpty(page.getRecords())) {
            return new PageData<>(null, 0);
        }

        Set<String> ids = new HashSet<>(); // 随访id列表
        Set<String> doctorIds = new HashSet<>();
//         Set<String> patientIds = new HashSet<>();
        Set<String> diseaseIds = new HashSet<>();
        Set<String> cyVisitIds = new HashSet<>(); // 出院住院号
        Set<String> consultationIds = new HashSet<>(); // 会诊id
        Set<String> deptIds = new HashSet<>(); // 科室信息
        page.getRecords().forEach(i -> {
            ids.add(i.getId());
            if (StrUtil.isNotBlank(i.getDoctorId())) {
                doctorIds.add(i.getDoctorId());
            }
            if (StrUtil.isNotBlank(i.getPatientId())) {
                patientIds.add(i.getPatientId());
            }
            if (StrUtil.isNotBlank(i.getDiseaseId())) {
                diseaseIds.add(i.getDiseaseId());
            }
            if (DoctorFollowUpConstant.Type.CY.getCode().equals(i.getType())) {
                cyVisitIds.add(i.getVisitId());
            }
            if (DoctorFollowUpConstant.Type.HZ.getCode().equals(i.getType())) {
                consultationIds.add(i.getConsultationId());
            }
            if (StrUtil.isNotBlank(i.getSourceDeptId()) && CollUtil.isEmpty(sourceDeptIds)) {
                deptIds.add(i.getSourceDeptId());
            }
        });
        
        // 随访医生
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        if (CollUtil.isNotEmpty(doctorIds)) {
            List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
            if (CollUtil.isNotEmpty(doctorList)) {
                doctorList.forEach(i -> {
                    doctorMap.put(i.getId(), i);
                    deptIds.add(i.getDeptId());
                });
                
            }
        }
        
        // 随访医生科室及来源科室信息
        Map<String, DeptBO> deptMap = new HashMap<>();
        if (CollUtil.isNotEmpty(deptIds)) {
            List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
            if (CollUtil.isNotEmpty(deptList)) {
                deptList.forEach(i -> deptMap.put(i.getId(), i));
            }
        }
        if (CollUtil.isNotEmpty(sourceDeptMap)) {
            deptMap.putAll(sourceDeptMap);
        }

        // 患者信息
        // Map<String, PatientClientBO> patientMap = new HashMap<>();
        if (CollUtil.isEmpty(patientMap) && CollUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(new ArrayList<>(patientIds));
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
            }
        }

        // 病种
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        if (CollUtil.isNotEmpty(diseaseIds)) {
            List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
            if (CollUtil.isNotEmpty(diseaseList)) {
                diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
            }
        }

        // 住院信息
        Map<String, PatientInpatientRecordClientBO> inpatientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(cyVisitIds)) {
            PatientDataClientDTO patientDataClientDTO = new PatientDataClientDTO();
            patientDataClientDTO.setVisitIds(new ArrayList<>(cyVisitIds));
            List<PatientInpatientRecordClientBO> inpatientList = dwdDataPatientClientService.listPatientInpatient(patientDataClientDTO);
            if (CollUtil.isNotEmpty(inpatientList)) {
                inpatientList.forEach(i -> inpatientMap.put(i.getVisitId(), i));
            }
        }

        // 会诊信息
        Map<String, ConsultationBO> consultationMap = new HashMap<>();
        if (CollUtil.isNotEmpty(consultationIds)) {
            ConsultationQueryClientDTO consultationQueryDTO = new ConsultationQueryClientDTO();
            consultationQueryDTO.setApplyType(ConsultationType.ORDINARY.getCode());
            consultationQueryDTO.setIds(new ArrayList<>(consultationIds));
            List<ConsultationBO> consultationList = consultationClientService.list(consultationQueryDTO);
            if (CollUtil.isNotEmpty(consultationList)) {
                consultationList.forEach(i -> consultationMap.put(i.getId(), i));
            }
        }
        // 个案信息
        Map<String, PatientDoctorRelationBO> crmMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientDoctorRelQueryClientDTO patientDoctorRelQueryClientDTO = new PatientDoctorRelQueryClientDTO();
            patientDoctorRelQueryClientDTO.setPatientIds(patientIds);
            patientDoctorRelQueryClientDTO.setStatus("normal");
            List<PatientDoctorRelationBO> crmList = patientDoctorRelationClientService.queryPatientDoctorRelList(patientDoctorRelQueryClientDTO);
            if (CollUtil.isNotEmpty(crmList)) {
                crmList.forEach(i ->{
                    if (!crmMap.containsKey(i.getPatientId())) {
                        crmMap.put(i.getPatientId(), i);
                    }});
            }
        }

        // 查询患者最新就诊数据
        Map<String, PatientVisitRecordClientBO> visitMap = dwdDataPatientClientService.mapPatientVisitLastDateInfo(patientIds);

        // 查询患者最新住院数据
        PatientLastDataQueryDTO patientLastDataQueryDTO = new PatientLastDataQueryDTO();
        patientLastDataQueryDTO.setPatientIds(patientIds);
        Map<String, PatientInpatientRecordClientBO> inPatientMap = dwdDataPatientClientService.mapPatientInpatientLastDateInfo(patientLastDataQueryDTO);

        // 查询患者最新出院数据
        Map<String, PatientDischargeRecordClientBO> outPatientMap = dwdDataPatientClientService.mapPatientOutpatientLastDateInfo(patientIds);

        // TODO 查询患者复诊数据
        Map<String, PatientReturnVisitBO> returnVisitMap = new HashMap<>(); // key: sourceId(随访id)
        PatientReturnVisitQueryClientDTO returnVisitQueryDTO = new PatientReturnVisitQueryClientDTO();
        returnVisitQueryDTO.setSourceType(PatientReturnVisitConstant.SourceType.Follow_Up.getCode());
        returnVisitQueryDTO.setSourceIds(new ArrayList<>(ids));
        List<PatientReturnVisitBO> returnVisitList = patientReturnVisitClientService.list(returnVisitQueryDTO);
        if (CollUtil.isNotEmpty(returnVisitList)) {
            returnVisitList.forEach(i -> returnVisitMap.put(i.getSourceId(), i));
        }

        PageData<DoctorFollowUpVO> data = new PageConverter<DoctorFollowUpInfo, DoctorFollowUpVO>() {
            @Override
            public DoctorFollowUpVO converter(DoctorFollowUpInfo entity) {
                DoctorFollowUpVO vo = DoctorPushTaskHelper.getDoctorFollowUpVO(entity);

                AdminUserBO applyDoctor = doctorMap.get(vo.getDoctorId());
                vo.setDoctorInfo(applyDoctor);
                if (StrUtil.isNotBlank(applyDoctor.getDeptId())) {
                    vo.setDeptInfo(deptMap.get(applyDoctor.getDeptId()));
                }

                vo.setPatientInfo(patientMap.get(vo.getPatientId()));
                vo.setDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));

                if (DoctorFollowUpConstant.Status.DOING.getCode().equals(vo.getStatus()) && DateUtil.date().toDateStr().compareTo(DateUtil.format(vo.getFollowTime(), "yyyy-MM-dd")) >= 0) {
                    vo.setStatus(DoctorFollowUpConstant.Status.ING.getCode());
                }

                if (DoctorFollowUpConstant.Type.CY.getCode().equals(vo.getType()) && StrUtil.isNotBlank(vo.getVisitId())) {
                    vo.setInpatientRecordInfo(inpatientMap.get(vo.getVisitId()));
                }

                if (DoctorFollowUpConstant.Type.HZ.getCode().equals(vo.getType()) && StrUtil.isNotBlank(vo.getConsultationId())) {
                    vo.setConsultationInfo(consultationMap.get(vo.getConsultationId()));
                }

                if (StrUtil.isNotBlank(vo.getSourceDeptId())) {
                    vo.setSourceDeptInfo(deptMap.get(vo.getSourceDeptId()));
                }

                // 最新就诊
                vo.setVisitInfo(visitMap.get(vo.getPatientId()));

                // 最新住院
                vo.setInpatientInfo(inPatientMap.get(vo.getPatientId()));

                // 最新出院
                PatientDischargeRecordClientBO patientDischargeRecordClientBO = outPatientMap.get(vo.getPatientId());
                if (null != patientDischargeRecordClientBO) {
                    patientDischargeRecordClientBO.setContent(null);
                    patientDischargeRecordClientBO.setDiagnosisRaw(null);
                    vo.setOutpatientInfo(patientDischargeRecordClientBO);
                }
                // 患者复诊信息
                vo.setReturnVisitInfo(returnVisitMap.get(vo.getId()));
                // 是否个案
                if (crmMap.containsKey(entity.getPatientId())) {
                    vo.setCrmStatus(YN.YES.getCode());
                } else {
                    vo.setCrmStatus(YN.NO.getCode());
                }
                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<DoctorFollowUpVO> list(DoctorFollowUpQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        List<DoctorFollowUpInfo> list = doctorFollowUpInfoService.list(new QueryWrapper<DoctorFollowUpInfo>()
                .eq("rows_status", YN.YES.getCode())
                .isNotNull(StrUtil.isBlank(params.getIsNormal()) || !(YN.NO.getCode().equals(params.getIsNormal())), "follow_time")
                .isNull(StrUtil.isNotBlank(params.getIsNormal()) && YN.NO.getCode().equals(params.getIsNormal()), "follow_time")
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .ge(null != params.getStartDate(), "follow_time", params.getStartDate())
                .lt(null != params.getEndDate(), "follow_time", params.getEndDate())
                .orderByAsc("follow_time")
        );

        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        Set<String> doctorIds = new HashSet<>();
        Set<String> patientIds = new HashSet<>();
        Set<String> diseaseIds = new HashSet<>();
        Set<String> deptIds = new HashSet<>();
        list.forEach(i -> {
            if (StrUtil.isNotBlank(i.getDoctorId())) {
                doctorIds.add(i.getDoctorId());
            }
            if (StrUtil.isNotBlank(i.getPatientId())) {
                patientIds.add(i.getPatientId());
            }
            if (StrUtil.isNotBlank(i.getDiseaseId())) {
                diseaseIds.add(i.getDiseaseId());
            }
            if (StrUtil.isNotBlank(i.getSourceDeptId())) {
                deptIds.add(i.getSourceDeptId());
            }
        });
        
        // 随访医生
        Map<String, AdminUserBO> doctorMap = new HashMap<>();
        if (CollUtil.isNotEmpty(doctorIds)) {
            List<AdminUserBO> doctorList = adminUserClientService.getUserListByIds(doctorIds);
            if (CollUtil.isNotEmpty(doctorList)) {
                doctorList.forEach(i -> {
                    doctorMap.put(i.getId(), i);
                    deptIds.add(i.getDeptId());
                });
                
            }
        }

        // 随访医生科室及来源科室信息
        Map<String, DeptBO> deptMap = new HashMap<>();
        if (CollUtil.isNotEmpty(deptIds)) {
            List<DeptBO> deptList = deptClientService.getDeptListByIds(deptIds);
            if (CollUtil.isNotEmpty(deptList)) {
                deptList.forEach(i -> deptMap.put(i.getId(), i));
            }
        }

        // 患者信息
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        if (CollUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(new ArrayList<>(patientIds));
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
            }
        }

        // 病种
        Map<String, StandardDiseaseBO> diseaseMap = new HashMap<>();
        if (CollUtil.isNotEmpty(diseaseIds)) {
            List<StandardDiseaseBO> diseaseList = standardDiseaseClientService.getList(diseaseIds);
            if (CollUtil.isNotEmpty(diseaseList)) {
                diseaseList.forEach(i -> diseaseMap.put(i.getId(), i));
            }
        }

        return list.stream().map(i -> {
            DoctorFollowUpVO vo = DoctorPushTaskHelper.getDoctorFollowUpVO(i);

            AdminUserBO applyDoctor = doctorMap.get(vo.getDoctorId());
            vo.setDoctorInfo(applyDoctor);
            if (StrUtil.isNotBlank(applyDoctor.getDeptId())) {
                vo.setDeptInfo(deptMap.get(applyDoctor.getDeptId()));
            }

            vo.setPatientInfo(patientMap.get(vo.getPatientId()));
            vo.setDiseaseInfo(diseaseMap.get(vo.getDiseaseId()));
            
            if (DoctorFollowUpConstant.Status.DOING.getCode().equals(vo.getStatus()) && DateUtil.date().toDateStr().compareTo(DateUtil.format(vo.getFollowTime(), "yyyy-MM-dd")) >= 0) {
                vo.setStatus(DoctorFollowUpConstant.Status.ING.getCode());
            }
            
            if (StrUtil.isNotBlank(vo.getSourceDeptId())) {
                vo.setSourceDeptInfo(deptMap.get(vo.getSourceDeptId()));
            }

            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public List<DoctorFollowUpVO> simpleList(DoctorFollowUpQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        List<DoctorFollowUpInfo> list = doctorFollowUpInfoService.list(new QueryWrapper<DoctorFollowUpInfo>()
                .eq("rows_status", YN.YES.getCode())
                .isNotNull(StrUtil.isBlank(params.getIsNormal()) || !(YN.NO.getCode().equals(params.getIsNormal())), "follow_time")
                .isNull(StrUtil.isNotBlank(params.getIsNormal()) && YN.NO.getCode().equals(params.getIsNormal()), "follow_time")
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .ge(null != params.getStartDate(), "follow_time", params.getStartDate())
                .lt(null != params.getEndDate(), "follow_time", params.getEndDate())
                .orderByDesc("update_date")
        );

        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(i -> {
            DoctorFollowUpVO vo = DoctorPushTaskHelper.getDoctorFollowUpVO(i);
            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public DoctorFollowUpVO detail(DoctorFollowUpGetDTO params) {
        ValidatorUtils.validateEntity(params);
        
        DoctorFollowUpInfo entity = doctorFollowUpInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            return null;
        }
        if (StrUtil.isNotBlank(params.getDoctorId()) && !entity.getDoctorId().equals(params.getDoctorId())) {
            return null;
        }
        
        DoctorFollowUpVO vo = DoctorPushTaskHelper.getDoctorFollowUpVO(entity);

        if (StrUtil.isNotBlank(vo.getDoctorId())) {
            AdminUserBO user = adminUserClientService.getUserById(vo.getDoctorId());
            vo.setDoctorInfo(user);
            if (null != user && StrUtil.isNotBlank(user.getDeptId())) {
                vo.setDeptInfo(deptClientService.getDeptById(user.getDeptId()));
            }
        }
        if (StrUtil.isNotBlank(vo.getPatientId())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientId(vo.getPatientId());
            vo.setPatientInfo(patientClientService.getOneSimple(patientQueryDTO));
        }
        if (StrUtil.isNotBlank(vo.getDiseaseId())) {
            vo.setDiseaseInfo(standardDiseaseClientService.getById(vo.getDiseaseId()));
        }
        if (StrUtil.isNotBlank(vo.getSourceDeptId())) {
            vo.setSourceDeptInfo(deptClientService.getDeptById(vo.getSourceDeptId()));
        }

        return vo;
    }

    @Override
    public DoctorFollowUpVO add(DoctorFollowUpAddDTO params) {
        ValidatorUtils.validateEntity(params);
        if (null == params.getFollowTime() && null == params.getFollowDate()) {
            throw new BusinessException("请指定随访时间");
        }

        // TODO 判断医生预计当天是否已经有该患者的随访，有则不操作
        // 可以有任意多个随访
        // DoctorFollowUpInfo entity = doctorFollowUpInfoService.getOne(new QueryWrapper<DoctorFollowUpInfo>()
        //     .eq("rows_status", YN.YES.getCode())
        //     .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
        //     .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
        //     .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
        // );
        // if (null != entity) {
        //     return null;
        // }
        
        DoctorFollowUpInfo entity = new DoctorFollowUpInfo();
        entity.setId(DoctorPushTaskHelper.getDoctorFollowUpId());

        entity.setType(params.getType());
        entity.setPatientId(params.getPatientId());
        entity.setVisitId(params.getVisitId());
        entity.setDiseaseId(params.getDiseaseId());
        entity.setDoctorId(params.getDoctorId());
        entity.setContent(params.getContent());
        entity.setRemark(params.getRemark());
        entity.setFollowTime(params.getFollowDate());
        if (null != params.getFollowTime()) {
            entity.setFollowTime(DateUtil.parseDateTime(DateUtil.offsetDay(DateUtil.date(), params.getFollowTime()).toDateStr() + " 08:30:00"));
        }
        entity.setStatus(DoctorFollowUpConstant.Status.TODO.getCode());
        entity.setOpType(params.getOpType());
        entity.setConsultationId(params.getConsultationId());
        entity.setSourceDeptId(params.getSourceDeptId());
        entity.setSourceDate(params.getSourceDate());
        entity.setRowsStatus(YN.YES.getCode());
        if (StrUtil.isNotEmpty(params.getCrmRelationId())) {
            entity.setCrmRelationId(params.getCrmRelationId());
        } else {
            setCrmRelationId(entity);
        }

        doctorFollowUpInfoService.save(entity);

        return DoctorPushTaskHelper.getDoctorFollowUpVO(entity);
    }

    @Override
    public List<DoctorFollowUpVO> addBatch(List<DoctorFollowUpAddDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return new ArrayList<>(0);
        }
        params.forEach(i -> {
            ValidatorUtils.validateEntity(params);
        });

        // 判断医生预计当天是否已经有该患者的随访，有则不操作
        Map<String, DoctorFollowUpInfo> entityMap = new HashMap<>();
        List<String> queryParams = new ArrayList<>();
        params.forEach(i -> queryParams.add(DoctorFollowUpConstant.OpType.TASK.getCode() + "-" + i.getType() + "-" + i.getDoctorId() + "-" + i.getVisitId()));
        List<DoctorFollowUpInfo> entityList = doctorFollowUpInfoService.list(new QueryWrapper<DoctorFollowUpInfo>()
            .eq("rows_status", YN.YES.getCode())
            .in("CONCAT(op_type, '-', type,'-',doctor_id,'-',visit_id)", queryParams)
        );
        if (CollUtil.isNotEmpty(entityList)) {
            entityList.forEach(i -> entityMap.put(i.getType() + "-" + i.getDoctorId() + "-" + i.getVisitId(), i));
        }

        List<DoctorFollowUpInfo> list = new ArrayList<>();
        params.forEach(i -> {
            // if (null == i.getFollowTime() && null == i.getFollowDate()) {
            //     return;
            // }

            DoctorFollowUpInfo entity = entityMap.get(i.getType() + "-" + i.getDoctorId() + "-" + i.getVisitId());
            if (null != entity) {
                return;
            }

            entity = new DoctorFollowUpInfo();
            entity.setId(DoctorPushTaskHelper.getDoctorFollowUpId());

            entity.setType(i.getType());
            entity.setPatientId(i.getPatientId());
            entity.setVisitId(i.getVisitId());
            entity.setDiseaseId(i.getDiseaseId());
            entity.setDoctorId(i.getDoctorId());
            entity.setContent(i.getContent());
            entity.setRemark(i.getRemark());

            entity.setFollowTime(i.getFollowDate());
            if (null != i.getFollowTime()) {
                entity.setFollowTime(DateUtil.parseDateTime(DateUtil.offsetDay(DateUtil.date(), i.getFollowTime()).toDateStr() + " 08:30:00"));
            }
            entity.setStatus(DoctorFollowUpConstant.Status.TODO.getCode());
            entity.setOpType(i.getOpType());
            entity.setConsultationId(i.getConsultationId());
            entity.setSourceDeptId(i.getSourceDeptId());
            entity.setSourceDate(i.getSourceDate());
            entity.setRowsStatus(YN.YES.getCode());
            if (StrUtil.isNotEmpty(i.getCrmRelationId())) {
                entity.setCrmRelationId(i.getCrmRelationId());
            } else {
                setCrmRelationId(entity);
            }
            list.add(entity);
        });
        
        if (CollUtil.isNotEmpty(list)) {
            doctorFollowUpInfoService.saveBatch(list);
            return list.stream().map(DoctorPushTaskHelper::getDoctorFollowUpVO).collect(Collectors.toList());
        }

        return new ArrayList<>(0);
    }

    @Override
    public void update(DoctorFollowUpUpdateDTO params) {
        ValidatorUtils.validateEntity(params);
        
        DoctorFollowUpInfo entity = doctorFollowUpInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            return;
        }
        if (StrUtil.isNotBlank(params.getDoctorId()) && !entity.getDoctorId().equals(params.getDoctorId())) {
            return;
        }

        // 保存随访信息
        entity.setType(params.getType());
        entity.setPatientId(params.getPatientId());
        entity.setVisitId(params.getVisitId());
        entity.setDiseaseId(params.getDiseaseId());
        entity.setDoctorId(params.getDoctorId());
        entity.setContent(params.getContent());
        entity.setRemark(params.getRemark());
        entity.setOpType(params.getOpType());

        if (null != params.getFollowTime()) {
            entity.setFollowTime(DateUtil.parseDateTime(DateUtil.offsetDay(DateUtil.date(), params.getFollowTime()).toDateStr() + " 08:30:00"));
        }

        doctorFollowUpInfoService.updateById(entity);
    }

    @Override
    public void batchUpdateStatus(List<DoctorFollowUpUpdateStatusDTO> params) {
        ValidatorUtils.validateEntity(params);
        if (CollUtil.isEmpty(params)) {
            return;
        }

        params.forEach(i -> ValidatorUtils.validateEntity(i));

        List<String> ids = new ArrayList<>();
        Map<String, DoctorFollowUpUpdateStatusDTO> paramsMap = new HashMap<>();
        params.forEach(i -> {
            ids.add(i.getId());
            paramsMap.put(i.getId(), i);
        });

        List<DoctorFollowUpInfo> entityList = doctorFollowUpInfoService.listByIds(ids);
        if (CollUtil.isEmpty(entityList)) {
            return;
        }

        List<DoctorFollowUpInfo> list = new ArrayList<>();
        entityList.forEach(i -> {
            if (YN.YES.getCode().equals(i.getRowsStatus())) {
                DoctorFollowUpUpdateStatusDTO param = paramsMap.get(i.getId());
                if (null != param) {
                    i.setStatus(param.getStatus());
                    list.add(i);
                }
            }
        });

        if (CollUtil.isNotEmpty(list)) {
            doctorFollowUpInfoService.updateBatchById(list);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void launch(DoctorFollowUpGetDTO params) {
        ValidatorUtils.validateEntity(params);
        
        // 查询申请
        DoctorFollowUpGetDTO getDTO = new DoctorFollowUpGetDTO();
        getDTO.setId(params.getId());
        getDTO.setDoctorId(params.getDoctorId());
        DoctorFollowUpVO vo = this.detail(getDTO);

        if (null == vo) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }

        if (DoctorFollowUpConstant.Status.DOING.getCode().equals(vo.getStatus())) {
            throw new BusinessException("正在执行");
        }

        if (DoctorFollowUpConstant.Status.DONE.getCode().equals(vo.getStatus())) {
            throw new BusinessException("已完成");
        }

        if (DoctorFollowUpConstant.Status.CANCEL.getCode().equals(vo.getStatus())) {
            throw new BusinessException("已取消");
        }

        if (DoctorFollowUpConstant.Status.EXPIRE.getCode().equals(vo.getStatus())) {
            throw new BusinessException("已过期");
        }

        // 更新状态
        if (DoctorFollowUpConstant.Status.TODO.getCode().equals(vo.getStatus())) {
            doctorFollowUpInfoService.update(new UpdateWrapper<DoctorFollowUpInfo>()
                    .set("status", DoctorFollowUpConstant.Status.DOING.getCode())
                    .eq("id", vo.getId())
            );
        }

        // 保存日程(保存到医生日程表中)
        DoctorScheduleInfo entity = new DoctorScheduleInfo();
        entity.setId(DoctorPushTaskHelper.getDoctorScheduleId());
        entity.setDoctorId(vo.getDoctorId());
        entity.setBizOneType(DoctorScheduleConstant.BizOneType.FollowUp.getCode());
        // entity.setBizTwoType(params.getBizTwoType());
        entity.setBizId(vo.getId());
        entity.setContent(vo.getContent());
        entity.setUrgentLevel(RemindLevelEnum.Remind_General.getCode());
        entity.setDate(vo.getFollowTime());

        entity.setTitle("随访消息日程");
        if (null != vo.getPatientInfo()) {
            entity.setTitle(vo.getPatientInfo().getPatientName() + "的随访提醒");
        }

        entity.setStatus(YN.YES.getCode());
        entity.setRowsStatus(YN.YES.getCode());
        doctorScheduleInfoService.save(entity);
        
        // 保存提醒(保存到医生提醒表中)
        Map<String, String> contentMap = new HashMap<>();
        contentMap.put("patientName", vo.getPatientInfo().getPatientName());
        contentMap.put("content", vo.getContent());

        DoctorRemindInfo remindDoctor = new DoctorRemindInfo();
        remindDoctor.setId(DoctorPushTaskHelper.getDoctorRemindId());
        remindDoctor.setDoctorId(vo.getDoctorId());
        remindDoctor.setBizId(vo.getId());
        remindDoctor.setBizOneType(DoctorRemindConstant.BizOneType.FollowUp.getCode());
        remindDoctor.setBizTwoType(DoctorRemindConstant.BizOneType.FollowUp.getCode());
        if (null != params.getBizTwoType()) {
            remindDoctor.setBizTwoType(params.getBizTwoType().getCode());
        }
        remindDoctor.setTitle("随访消息提醒");
        remindDoctor.setContent(JSON.toJSONString(contentMap));
        remindDoctor.setRemark("随访消息提醒"); // TODO FIXME: 使用html或markdown进行消息的配置
        remindDoctor.setPushDate(vo.getFollowTime());
        remindDoctor.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        remindDoctor.setRowsStatus(YN.YES.getCode());

        doctorRemindInfoService.save(remindDoctor);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void launchBatch(List<DoctorFollowUpGetDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }

        List<String> ids = new ArrayList<>();
        Map<String, DoctorRemindConstant.BizTwoType> followTypeMap = new HashMap<>();
        params.forEach(i -> {
            ValidatorUtils.validateEntity(i);
            ids.add(i.getId());
            followTypeMap.put(i.getId(), i.getBizTwoType());
        });
        
        // 查询申请
        DoctorFollowUpQueryDTO queryDTO = new DoctorFollowUpQueryDTO();
        queryDTO.setIds(ids);
        List<DoctorFollowUpVO> voList = this.list(queryDTO);

        List<DoctorScheduleInfo>  scheduleList = new ArrayList<>();
        List<DoctorRemindInfo>  remindList = new ArrayList<>();
        for (DoctorFollowUpVO vo : voList) {
            if (!DoctorFollowUpConstant.Status.TODO.getCode().equals(vo.getStatus())) {
                continue;
            }

            // 更新状态
            doctorFollowUpInfoService.update(new UpdateWrapper<DoctorFollowUpInfo>()
                .set("status", DoctorFollowUpConstant.Status.DOING.getCode())
                .eq("id", vo.getId())
            );

            // 保存日程(保存到医生日程表中)
            DoctorScheduleInfo schedule = new DoctorScheduleInfo();
            schedule.setId(DoctorPushTaskHelper.getDoctorScheduleId());
            schedule.setDoctorId(vo.getDoctorId());
            schedule.setBizOneType(DoctorScheduleConstant.BizOneType.FollowUp.getCode());
            // schedule.setBizTwoType(params.getBizTwoType());
            schedule.setBizId(vo.getId());
            schedule.setContent(vo.getContent());
            schedule.setUrgentLevel(RemindLevelEnum.Remind_General.getCode());
            schedule.setDate(vo.getFollowTime());

            schedule.setTitle("随访消息日程");
            if (null != vo.getPatientInfo()) {
                schedule.setTitle(vo.getPatientInfo().getPatientName() + "的随访提醒");
            }

            schedule.setStatus(YN.YES.getCode());
            schedule.setRowsStatus(YN.YES.getCode());
            // doctorScheduleInfoService.save(schedule);
            scheduleList.add(schedule);
            
            // 保存提醒(保存到医生提醒表中)
            Map<String, String> contentMap = new HashMap<>();
            contentMap.put("patientName", vo.getPatientInfo().getPatientName());
            contentMap.put("content", vo.getContent());

            DoctorRemindInfo remind = new DoctorRemindInfo();
            remind.setId(DoctorPushTaskHelper.getDoctorRemindId());
            remind.setDoctorId(vo.getDoctorId());
            remind.setBizId(vo.getId());
            remind.setBizOneType(PushTaskConstant.OpType.FollowUp.getCode());
            remind.setBizTwoType(PushTaskConstant.OpType.FollowUp.getCode());
            if (null != followTypeMap.get(vo.getId())) {
                remind.setBizTwoType(followTypeMap.get(vo.getId()).getCode());
            }
            remind.setTitle("随访消息提醒");
            remind.setContent(JSON.toJSONString(contentMap));
            remind.setRemark("随访消息提醒"); // TODO FIXME: 使用html或markdown进行消息的配置
            remind.setPushDate(vo.getFollowTime());
            remind.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
            remind.setRowsStatus(YN.YES.getCode());
            // doctorRemindInfoService.save(remind);
            remindList.add(remind);
        }

        if (CollUtil.isNotEmpty(scheduleList)) {
            doctorScheduleInfoService.saveBatch(scheduleList);
        }
        if (CollUtil.isNotEmpty(remindList)) {
            doctorRemindInfoService.saveBatch(remindList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveAndLaunch(DoctorFollowUpAddDTO params) {
        ValidatorUtils.validateEntity(params);
        
        // 保存随访
        DoctorFollowUpVO vo = this.add(params);

        // 发起随访提醒(保存到医生提醒表)
        DoctorFollowUpGetDTO getDTO = new DoctorFollowUpGetDTO();
        getDTO.setId(vo.getId());
        
        if (DoctorFollowUpConstant.Type.CY.getCode().equals(vo.getType())) {
            getDTO.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_CY);
        } else if (DoctorFollowUpConstant.Type.HZ.getCode().equals(vo.getType())) {
            getDTO.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_HZ);
        } else if (DoctorFollowUpConstant.Type.HZCY.getCode().equals(vo.getType())) {
            getDTO.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_HZCY);
        }

        this.launch(getDTO);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveAndLaunchBatch(List<DoctorFollowUpAddDTO> params) {
        ValidatorUtils.validateEntity(params);
        
        // 保存随访
        List<DoctorFollowUpVO> voList = this.addBatch(params);

        // 发起随访提醒(保存到医生提醒表)
        if (CollUtil.isNotEmpty(voList)) {
            List<DoctorFollowUpGetDTO> launchList = new ArrayList<>();
            voList.forEach(i -> {
                DoctorFollowUpGetDTO launch = new DoctorFollowUpGetDTO();
                launch.setId(i.getId());

                if (DoctorFollowUpConstant.Type.CY.getCode().equals(i.getType())) {
                    launch.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_CY);
                } else if (DoctorFollowUpConstant.Type.HZ.getCode().equals(i.getType())) {
                    launch.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_HZ);
                } else if (DoctorFollowUpConstant.Type.HZCY.getCode().equals(i.getType())) {
                    launch.setBizTwoType(DoctorRemindConstant.BizTwoType.FollowUp_HZCY);
                }

                launchList.add(launch);
            });
            this.launchBatch(launchList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void follow(DoctorFollowUpFollowDTO params) {
        ValidatorUtils.validateEntity(params);
        
        // 保存随访信息
        DoctorFollowUpInfo entity = new DoctorFollowUpInfo();
        entity.setId(params.getId());
        entity.setRemark(params.getRemark());
        entity.setRealTime(DateUtil.date());
        entity.setStatus(DoctorFollowUpConstant.Status.DONE.getCode());

        doctorFollowUpInfoService.updateById(entity);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void del(DoctorFollowUpGetDTO params) {
        ValidatorUtils.validateEntity(params);
        
        DoctorFollowUpInfo entity = doctorFollowUpInfoService.getById(params.getId());
        if (null == entity || YN.NO.getCode().equals(entity.getRowsStatus())) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        if (StrUtil.isNotBlank(params.getDoctorId()) && !entity.getDoctorId().equals(params.getDoctorId())) {
            throw new BusinessException(BusinessBaseErrorEnum.OpAuth_ERROR);
        }

        Date now = DateUtil.date();
        entity.setRowsStatus(YN.NO.getCode());
        entity.setUpdateDate(now);
        doctorFollowUpInfoService.updateById(entity);

        // 删除随访提醒
        doctorRemindInfoService.update(new UpdateWrapper<DoctorRemindInfo>()
            .set("rows_status", YN.NO.getCode())
            .set("update_date", now)
            .eq("rows_status", YN.YES.getCode())
            .eq("biz_one_type", PushTaskConstant.OpType.FollowUp.getCode())
            .eq("biz_id", params.getId())
        );
    }

    @Override
    public void timeout() {
        doctorFollowUpInfoService.update(new UpdateWrapper<DoctorFollowUpInfo>()
            .set("status", DoctorFollowUpConstant.Status.EXPIRE.getCode())
            .eq("status", DoctorFollowUpConstant.Status.DOING.getCode())
            .lt("follow_time", DateUtil.offsetDay(DateUtil.date(), -2))
        );
    }

    @Override
    public void crmRel(DoctorFollowCrmRelDTO params) {
        List<DoctorFollowUpInfo> list = doctorFollowUpInfoService.list(new QueryWrapper<DoctorFollowUpInfo>()
                .eq("patient_id", params.getPatientId())
                .eq("doctor_id", params.getDoctorId())
                .like("disease_id", params.getDiseaseId())
                .isNull("crm_relation_id"));
        if (CollUtil.isEmpty(list)) {
            return;
        }
        for (DoctorFollowUpInfo info : list) {
            info.setCrmRelationId(params.getCrmRelationId());
        }
        doctorFollowUpInfoService.updateBatchById(list);

    }

    // 关联个案
    private void setCrmRelationId(DoctorFollowUpInfo entity) {
        PatientDoctorRelSearchClientDTO clientDTO = new PatientDoctorRelSearchClientDTO();
        clientDTO.setPatientId(entity.getPatientId());
        clientDTO.setDoctorId(entity.getDoctorId());
        if ("CY".equals(entity.getType())) {
            clientDTO.setDiseaseIds(StrJoinSplitUtils.split2List(entity.getDiseaseId()));
        } else {
            clientDTO.setDiseaseId(entity.getDiseaseId());
        }
        List<String> list = patientDoctorRelationClientService.relationSearch(clientDTO);
        if (CollUtil.isNotEmpty(list)) {
            entity.setCrmRelationId(list.get(0));
        }
    }

}
