package com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.basic.common.constant.RemindLevelEnum;
import com.xxh.cloud.healthy.basic.pushserve.client.api.PushServeConfigClientService;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.bos.PushServeConfigBO;
import com.xxh.cloud.healthy.basic.pushserve.client.api.bean.dto.PushServeConfigClientQueryDTO;
import com.xxh.cloud.healthy.basic.pushtask.client.api.PushTaskConfigClientService;
import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.bos.PushTaskActionConfigBO;
import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.bos.PushTaskConfigBO;
import com.xxh.cloud.healthy.basic.pushtask.client.api.bean.dto.PushTaskConfigClientQueryDTO;
import com.xxh.cloud.healthy.data.client.api.PatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorPushServeLogInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskExeInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorPushServeLogInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorTaskExeInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorTaskInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorPushServeLogGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorPushServeLogQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskExeGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskExeQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorTaskQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorPushServeLogVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindCountVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskCountVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskDateVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskExeVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorTaskVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.ManageDoctorTaskVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.mapper.DoctorTaskQueryBizMapper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorTaskQueryBizService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.cache.service.DoctorTaskCacheService;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.DeptBizClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.*;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class DoctorTaskQueryBizServiceImpl implements DoctorTaskQueryBizService {

    @Autowired
    private DoctorTaskInfoService doctorTaskInfoService;
    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;
    @Autowired
    private DoctorTaskCacheService doctorTaskCacheService;
    @Autowired
    private PushTaskConfigClientService pushTaskConfigClientService;
    @Autowired
    private DoctorPushServeLogInfoService doctorPushServeLogInfoService;
    @Autowired
    private PushServeConfigClientService pushServeConfigClientService;
    // @Autowired
    // private DwdDataPatientClientService dwdDataPatientClientService;
    @Autowired
    private PatientClientService patientClientService;
    @Autowired
    private DoctorTaskExeInfoService doctorTaskExeInfoService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private DeptBizClientService deptBizClientService;
    @Autowired
    private DoctorTaskQueryBizMapper doctorTaskQueryBizMapper;

    @Override
    public PageData<DoctorTaskVO> query(DoctorTaskQueryDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:query:params:>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        // 按科室进行筛选
        List<String> doctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new PageData<>(null, 0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new PageData<>(null, 0);
            }
            adminUserBOList.forEach(i -> doctorIds.add(i.getId()));
        }

        // 按用户信息筛选
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> queryPatientIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                queryPatientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        IPage<DoctorTaskInfo> page = doctorTaskInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getDoctorTaskId()), "id", params.getDoctorTaskId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorTaskIds()), "id", params.getDoctorTaskIds())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "doctor_ids", params.getDoctorId())
                .like(StrUtil.isNotBlank(params.getTaskName()), "task_name", params.getTaskName())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(queryPatientIds), "patient_id", queryPatientIds)
                .eq(StrUtil.isNotBlank(params.getUrgentLevel()), "urgent_level", params.getUrgentLevel())
                .eq(StrUtil.isNotBlank(params.getTaskType()), "task_type", params.getTaskType())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .ge(null != params.getStartDate(), "create_date", params.getStartDate())
                .lt(null != params.getEndDate(), "create_date", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .eq("rows_status", YN.YES.getCode())
                .and(CollectionUtil.isNotEmpty(doctorIds), i -> {
                    doctorIds.forEach(j -> {
                        i.or().like("doctor_ids", j);
                    });
                })
                .inSql(StrUtil.isNotEmpty(params.getDiseaseId()), "task_id",
                        StrUtil.format("select id from h_push_task_config_info where disease_ids like '%{}%'", params.getDiseaseId()))
                .orderByDesc("create_date")
        );
        
        List<String> taskIds = new ArrayList<>();
        List<String> patientIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            taskIds.add(i.getTaskId());
            patientIds.add(i.getPatientId());
        });

        // 查询医生任务配置信息
        Map<String, PushTaskConfigBO> pushTaskConfigMap = pushTaskConfigClientService.getByIds(taskIds);

        // 查询医生执行信息
        DoctorTaskExeQueryDTO doctorTaskExeQueryDTO = new DoctorTaskExeQueryDTO();
        doctorTaskExeQueryDTO.setDoctorTaskIds(taskIds);
        List<DoctorTaskExeVO> doctorTaskExeVOs = this.taskExeList(doctorTaskExeQueryDTO);
        Map<String, List<DoctorTaskExeVO>> doctorTaskExeMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(doctorTaskExeVOs)) {
            doctorTaskExeVOs.forEach(i -> {
                List<DoctorTaskExeVO> exeList = doctorTaskExeMap.get(i.getDoctorTaskId());
                if (null == exeList) {
                    exeList = new ArrayList<>();
                    doctorTaskExeMap.put(i.getDoctorTaskId(), exeList);
                }
                exeList.add(i);
            });
        }
        
        // 患者信息
        if (CollectionUtil.isEmpty(patientMap) && CollectionUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> {
                    patientMap.put(i.getPatientId(), i);
                });
            }
        }

        PageData<DoctorTaskVO> data = new PageConverter<DoctorTaskInfo, DoctorTaskVO>() {
            @Override
            public DoctorTaskVO converter(DoctorTaskInfo entity) {
                DoctorTaskVO vo = DoctorPushTaskHelper.getDoctorTaskVO(entity);

                // 任务配置信息
                vo.setPushTaskConfig(pushTaskConfigMap.get(vo.getTaskId()));

                // 任务执行数据
                vo.setDoctorTaskExeList(doctorTaskExeMap.get(vo.getId()));

                // 患者信息
                PatientClientBO patient = patientMap.get(vo.getPatientId());
                if (null != patient) {
                    vo.setPatientName(patient.getPatientName());
                    vo.setPatientSex(patient.getPatientGenderStandard());
                    vo.setPatientAge(patient.getAge());
                    vo.setPatientBirthday(patient.getBirthday());
                    vo.setPatientPhone(patient.getPhone());
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public PageData<DoctorTaskDateVO> queryByDate(DoctorTaskQueryDTO params) {
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }

        Map<String, PatientClientBO> patientMap = new HashMap<>();
        // Map<String, DoctorDwdPatientBO> patientMap = new HashMap<>();
        List<String> queryPatientIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            // DwdDataPatientQueryClientDTO dwdDataPatientQueryClientDTO = new DwdDataPatientQueryClientDTO();
            // dwdDataPatientQueryClientDTO.setPatientName(params.getPatientName());
            // List<DoctorDwdPatientBO> patientList = dwdDataPatientClientService.queryPatientList(dwdDataPatientQueryClientDTO);
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                queryPatientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        IPage<DoctorTaskInfo> page = doctorTaskInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getDoctorTaskId()), "id", params.getDoctorTaskId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorTaskIds()), "id", params.getDoctorTaskIds())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "doctor_ids", params.getDoctorId())
                .like(StrUtil.isNotBlank(params.getTaskName()), "task_name", params.getTaskName())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(queryPatientIds), "patient_id", queryPatientIds)
                // .like(StrUtil.isNotBlank(params.getPatientName()), "patient_name", params.getPatientName())
                .eq(StrUtil.isNotBlank(params.getUrgentLevel()), "urgent_level", params.getUrgentLevel())
                .eq(StrUtil.isNotBlank(params.getTaskType()), "task_type", params.getTaskType())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .eq("rows_status", YN.YES.getCode())
                .ge(null != params.getStartDate(), "create_date", params.getStartDate())
                .lt(null != params.getEndDate(), "create_date", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .orderByDesc("create_date")
        );

        List<String> taskIds = new ArrayList<>();
        List<String> patientIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            taskIds.add(i.getTaskId());
            patientIds.add(i.getPatientId());
        });
        // 查询医生任务配置信息
        Map<String, PushTaskConfigBO> pushTaskConfigMap = pushTaskConfigClientService.getByIds(taskIds);

        // 查询医生执行信息
        DoctorTaskExeQueryDTO doctorTaskExeQueryDTO = new DoctorTaskExeQueryDTO();
        doctorTaskExeQueryDTO.setDoctorTaskIds(taskIds);
        List<DoctorTaskExeVO> doctorTaskExeVOs = this.taskExeList(doctorTaskExeQueryDTO);
        Map<String, DoctorTaskExeVO> doctorTaskExeMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(doctorTaskExeVOs)) {
            doctorTaskExeVOs.forEach(i -> {
                doctorTaskExeMap.put(i.getDoctorTaskId() + "-" + i.getDoctorId(), i);
            });
        }
        
        // 患者信息
        if (CollectionUtil.isEmpty(patientMap) && CollectionUtil.isNotEmpty(patientIds)) {
            // DwdDataPatientQueryClientDTO dwdDataPatientQueryClientDTO = new DwdDataPatientQueryClientDTO();
            // dwdDataPatientQueryClientDTO.setPatientIds(patientIds);
            // List<DoctorDwdPatientBO> patientList = dwdDataPatientClientService.queryPatientList(dwdDataPatientQueryClientDTO);
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> {
                    patientMap.put(i.getPatientId(), i);
                });
            }
        }

        // 按时间聚合查询结果
        log.info("按时间聚合查询结果 >>>>>>");
        Map<String, List<DoctorTaskVO>> map = new HashMap<>();
        page.getRecords().forEach(i -> {
            String key = DateUtil.date(i.getCreateDate()).toString("yyyy-MM-dd");
            List<DoctorTaskVO> list = map.get(key);
            if (null == list) {
                list = new ArrayList<>();
                map.put(key, list);
            }
            
            DoctorTaskVO doctorTaskVO = DoctorPushTaskHelper.getDoctorTaskVO(i);
            doctorTaskVO.setPushTaskConfig(pushTaskConfigMap.get(i.getTaskId()));
            doctorTaskVO.setDoctorTaskExe(doctorTaskExeMap.get(i.getId() + "" + params.getDoctorId()));

            // 患者信息
            PatientClientBO patient = patientMap.get(i.getPatientId());
            if (null != patient) {
                doctorTaskVO.setPatientName(patient.getPatientName());
                doctorTaskVO.setPatientSex(patient.getPatientGenderStandard());
                doctorTaskVO.setPatientAge(patient.getAge());
                doctorTaskVO.setPatientBirthday(patient.getBirthday());
                doctorTaskVO.setPatientPhone(patient.getPhone());
            }

            list.add(doctorTaskVO);
        });

        // 整理返回数据
        log.info("整理返回数据 >>>>>>");
        List<DoctorTaskDateVO> list = new ArrayList<>();
        // 无序循环
        map.forEach((k, v) -> {
            DoctorTaskDateVO vo = new DoctorTaskDateVO();
            vo.setDate(k);
            vo.setDoctorTaskVOs(v);
            list.add(vo);
        });

        // 排序
        log.info("排序 >>>>>>");
        Comparator<DoctorTaskDateVO> dateComparator = Comparator.comparing(DoctorTaskDateVO::getDate);
        list.sort(dateComparator.reversed());

        return new PageData<>(list, page.getTotal(), page.getSize(), page.getPages());
    }

    @Override
    public PageData<DoctorTaskVO> queryByDisease(DoctorTaskQueryDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:queryByDisease:params:>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        // 按科室进行筛选
        List<String> doctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new PageData<>(null, 0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new PageData<>(null, 0);
            }
            adminUserBOList.forEach(i -> doctorIds.add(i.getId()));
        }

        // 按用户信息筛选
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> queryPatientIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                queryPatientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        IPage<DoctorTaskInfo> page = doctorTaskQueryBizMapper.pageDoctorTask(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getDoctorTaskId()), "b.id", params.getDoctorTaskId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorTaskIds()), "b.id", params.getDoctorTaskIds())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "b.yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "b.not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "b.doctor_ids", params.getDoctorId())
                .like(StrUtil.isNotBlank(params.getTaskName()), "b.task_name", params.getTaskName())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "b.patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(queryPatientIds), "b.patient_id", queryPatientIds)
                .eq(StrUtil.isNotBlank(params.getUrgentLevel()), "b.urgent_level", params.getUrgentLevel())
                .eq(StrUtil.isNotBlank(params.getTaskType()), "b.task_type", params.getTaskType())
                .eq(StrUtil.isNotBlank(params.getStatus()), "b.status", params.getStatus())
                .ge(null != params.getStartDate(), "b.create_date", params.getStartDate())
                .lt(null != params.getEndDate(), "b.create_date", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getOpType()), "b.op_type", params.getOpType())
                .eq("b.rows_status", YN.YES.getCode())
                .and(CollectionUtil.isNotEmpty(doctorIds), i -> {
                    doctorIds.forEach(j -> {
                        i.or().like("b.doctor_ids", j);
                    });
                })
                .like(StrUtil.isNotBlank(params.getDiseaseId()), "a.disease_ids", "," + params.getDiseaseId() + ",")
                .and(CollectionUtil.isNotEmpty(params.getDiseaseIds()), i -> {
                    params.getDiseaseIds().forEach(j -> {
                        i.or().like("a.disease_ids", "," + j + ",");
                    });
                })
                .orderByDesc("b.create_date")
        );
        
        List<String> taskIds = new ArrayList<>();
        List<String> patientIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            taskIds.add(i.getTaskId());
            patientIds.add(i.getPatientId());
        });

        // 查询医生任务配置信息
        Map<String, PushTaskConfigBO> pushTaskConfigMap = pushTaskConfigClientService.getByIds(taskIds);

        // 查询医生执行信息
        DoctorTaskExeQueryDTO doctorTaskExeQueryDTO = new DoctorTaskExeQueryDTO();
        doctorTaskExeQueryDTO.setDoctorTaskIds(taskIds);
        List<DoctorTaskExeVO> doctorTaskExeVOs = this.taskExeList(doctorTaskExeQueryDTO);
        Map<String, List<DoctorTaskExeVO>> doctorTaskExeMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(doctorTaskExeVOs)) {
            doctorTaskExeVOs.forEach(i -> {
                List<DoctorTaskExeVO> exeList = doctorTaskExeMap.get(i.getDoctorTaskId());
                if (null == exeList) {
                    exeList = new ArrayList<>();
                    doctorTaskExeMap.put(i.getDoctorTaskId(), exeList);
                }
                exeList.add(i);
            });
        }
        
        // 患者信息
        if (CollectionUtil.isEmpty(patientMap) && CollectionUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> {
                    patientMap.put(i.getPatientId(), i);
                });
            }
        }

        PageData<DoctorTaskVO> data = new PageConverter<DoctorTaskInfo, DoctorTaskVO>() {
            @Override
            public DoctorTaskVO converter(DoctorTaskInfo entity) {
                DoctorTaskVO vo = DoctorPushTaskHelper.getDoctorTaskVO(entity);

                // 任务配置信息
                vo.setPushTaskConfig(pushTaskConfigMap.get(vo.getTaskId()));

                // 任务执行数据
                vo.setDoctorTaskExeList(doctorTaskExeMap.get(vo.getId()));

                // 患者信息
                PatientClientBO patient = patientMap.get(vo.getPatientId());
                if (null != patient) {
                    vo.setPatientName(patient.getPatientName());
                    vo.setPatientSex(patient.getPatientGenderStandard());
                    vo.setPatientAge(patient.getAge());
                    vo.setPatientBirthday(patient.getBirthday());
                    vo.setPatientPhone(patient.getPhone());
                }

                return vo;
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public List<DoctorTaskVO> list(DoctorTaskQueryDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:list:params:>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        // 按科室进行筛选
        List<String> doctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new ArrayList<>(0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new ArrayList<>(0);
            }
            adminUserBOList.forEach(i -> doctorIds.add(i.getId()));
        }

        // 按用户信息筛选
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> queryPatientIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new ArrayList<>(0);
            }
            patientList.forEach(i -> {
                queryPatientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        List<DoctorTaskInfo> list = doctorTaskInfoService.list(new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getDoctorTaskId()), "id", params.getDoctorTaskId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorTaskIds()), "id", params.getDoctorTaskIds())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "doctor_ids", params.getDoctorId())
                .like(StrUtil.isNotBlank(params.getTaskName()), "task_name", params.getTaskName())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(queryPatientIds), "patient_id", queryPatientIds)
                .eq(StrUtil.isNotBlank(params.getUrgentLevel()), "urgent_level", params.getUrgentLevel())
                .eq(StrUtil.isNotBlank(params.getTaskType()), "task_type", params.getTaskType())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .ge(null != params.getStartDate(), "create_date", params.getStartDate())
                .lt(null != params.getEndDate(), "create_date", params.getEndDate())
                .eq(StrUtil.isNotBlank(params.getOpType()), "op_type", params.getOpType())
                .eq("rows_status", YN.YES.getCode())
                .and(CollectionUtil.isNotEmpty(doctorIds), i -> {
                    doctorIds.forEach(j -> {
                        i.or().like("doctor_ids", j);
                    });
                })
                .orderByDesc("create_date")
        );

        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }
        
        List<String> taskIds = new ArrayList<>();
        List<String> patientIds = new ArrayList<>();
        list.forEach(i -> {
            taskIds.add(i.getTaskId());
            patientIds.add(i.getPatientId());
        });

        // 查询医生任务配置信息
        Map<String, PushTaskConfigBO> pushTaskConfigMap = pushTaskConfigClientService.getByIds(taskIds);

        // 查询医生执行信息
        DoctorTaskExeQueryDTO doctorTaskExeQueryDTO = new DoctorTaskExeQueryDTO();
        doctorTaskExeQueryDTO.setDoctorTaskIds(taskIds);
        List<DoctorTaskExeVO> doctorTaskExeVOs = this.taskExeList(doctorTaskExeQueryDTO);
        Map<String, List<DoctorTaskExeVO>> doctorTaskExeMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(doctorTaskExeVOs)) {
            doctorTaskExeVOs.forEach(i -> {
                List<DoctorTaskExeVO> exeList = doctorTaskExeMap.get(i.getDoctorTaskId());
                if (null == exeList) {
                    exeList = new ArrayList<>();
                    doctorTaskExeMap.put(i.getDoctorTaskId(), exeList);
                }
                exeList.add(i);
            });
        }
        
        // 患者信息
        if (CollectionUtil.isEmpty(patientMap) && CollectionUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> {
                    patientMap.put(i.getPatientId(), i);
                });
            }
        }

        return list.stream().map(i -> {
            DoctorTaskVO vo = DoctorPushTaskHelper.getDoctorTaskVO(i);

            // 任务配置信息
            vo.setPushTaskConfig(pushTaskConfigMap.get(vo.getTaskId()));

            // 任务执行数据
            vo.setDoctorTaskExeList(doctorTaskExeMap.get(vo.getId()));

            // 患者信息
            PatientClientBO patient = patientMap.get(vo.getPatientId());
            if (null != patient) {
                vo.setPatientName(patient.getPatientName());
                vo.setPatientSex(patient.getPatientGenderStandard());
                vo.setPatientAge(patient.getAge());
                vo.setPatientBirthday(patient.getBirthday());
                vo.setPatientPhone(patient.getPhone());
            }

            return vo;
        }).collect(Collectors.toList());
    }

    @Override
    public DoctorTaskVO getOne(DoctorTaskGetDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:getOne:params:>>>>>> {}", JSON.toJSONString(params));
        DoctorTaskInfo entity = doctorTaskInfoService.getOne(new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "doctor_ids", params.getDoctorId())
                .eq("rows_status", YN.YES.getCode())
        );
        if (null == entity) {
            return null;
        }

        DoctorTaskVO doctorTaskVO = DoctorPushTaskHelper.getDoctorTaskVO(entity);

        // 查询医生任务配置信息
        PushTaskConfigBO pushTaskConfig = pushTaskConfigClientService.getById(entity.getTaskId());
        // 查询患者推送任务信息
        if (null != pushTaskConfig) {
            List<PushTaskActionConfigBO> actionConfigBOs = pushTaskConfig.getActionList();
            if (CollectionUtil.isNotEmpty(actionConfigBOs)) {   
                List<String> pushIds = new ArrayList<>();
                actionConfigBOs.forEach(i -> {
                    Map<String,Object> dataMap = i.getDataConfig();
                    if (null != dataMap) {
                        Object pushId = dataMap.get("push_id");
                        if (null != pushId && StrUtil.isNotBlank(String.valueOf(pushId)) ) {
                            pushIds.add(String.valueOf(pushId));
                        }
                    }
                });
                if (CollectionUtil.isNotEmpty(pushIds)) {
                    PushServeConfigClientQueryDTO pushServeConfigClientQueryDTO = new PushServeConfigClientQueryDTO();
                    pushServeConfigClientQueryDTO.setIds(pushIds);
                    List<PushServeConfigBO> pushServeConfigBOs = pushServeConfigClientService.list(pushServeConfigClientQueryDTO);
                    if (CollectionUtil.isNotEmpty(pushServeConfigBOs)) {
                        Map<String, PushServeConfigBO> pushServeConfigMap = pushServeConfigBOs.stream().collect(Collectors.toMap(PushServeConfigBO::getId, i -> i));
                        actionConfigBOs.forEach(i -> {
                            Map<String,Object> dataMap = i.getDataConfig();
                            if (null != dataMap && null != dataMap.get("push_id")) {
                                dataMap.put("pushServeConfig", pushServeConfigMap.get(dataMap.get("push_id")));
                            }
                        });
                    }
                }
            }
        }
        doctorTaskVO.setPushTaskConfig(pushTaskConfig);
        return doctorTaskVO;
    }

    @Override
    public DoctorTaskVO detail(DoctorTaskGetDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:detail:params:>>>>>> {}", JSON.toJSONString(params));
        DoctorTaskInfo entity = doctorTaskInfoService.getOne(new QueryWrapper<DoctorTaskInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .like(null != params.getIsFinished() && params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "yes_doctor_ids", params.getDoctorId())
                .like(null != params.getIsFinished() && !params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "not_doctor_ids", params.getDoctorId())
                .like(null == params.getIsFinished() && StrUtil.isNotBlank(params.getDoctorId()), "doctor_ids", params.getDoctorId())
                .eq("rows_status", YN.YES.getCode())
        );
        if (null == entity) {
            return null;
        }

        DoctorTaskVO doctorTaskVO = DoctorPushTaskHelper.getDoctorTaskVO(entity);

        // dwd患者信息
        // DwdDataPatientGetClientDTO dwdDataPatientGetClientDTO = new DwdDataPatientGetClientDTO();
        // dwdDataPatientGetClientDTO.setPatientId(doctorTaskVO.getPatientId());
        // DoctorDwdPatientBO patient = dwdDataPatientClientService.getOnePatient(dwdDataPatientGetClientDTO);
        
        // 获取患者信息
        PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
        patientQueryDTO.setPatientId(doctorTaskVO.getPatientId());
        PatientClientBO patient = patientClientService.getOneSimple(patientQueryDTO);
        if (null != patient) {
            doctorTaskVO.setPatientAge(patient.getAge());
            doctorTaskVO.setPatientBirthday(patient.getBirthday());
            doctorTaskVO.setPatientName(patient.getPatientName());
            doctorTaskVO.setPatientPhone(patient.getPhone());
            doctorTaskVO.setPatientSex(patient.getPatientGenderStandard());
        }

        // 查询医生任务配置信息
        PushTaskConfigBO pushTaskConfig = pushTaskConfigClientService.getById(entity.getTaskId());
        // 查询患者推送任务信息
        if (null != pushTaskConfig) {
            List<PushTaskActionConfigBO> actionConfigBOs = pushTaskConfig.getActionList();
            if (CollectionUtil.isNotEmpty(actionConfigBOs)) {
                actionConfigBOs.removeIf(i -> null == i.getDataConfig()); // 移除动作中dataConfig为空的数据

                List<String> pushIds = new ArrayList<>();
                actionConfigBOs.forEach(i -> {
                    Map<String,Object> dataMap = i.getDataConfig();
                    if (null != dataMap && null != dataMap.get("push_id")) {
                        pushIds.add(String.valueOf(dataMap.get("push_id")));
                    }
                });
                if (CollectionUtil.isNotEmpty(pushIds)) {
                    PushServeConfigClientQueryDTO pushServeConfigClientQueryDTO = new PushServeConfigClientQueryDTO();
                    pushServeConfigClientQueryDTO.setIds(pushIds);
                    List<PushServeConfigBO> pushServeConfigBOs = pushServeConfigClientService.list(pushServeConfigClientQueryDTO);
                    if (CollectionUtil.isNotEmpty(pushServeConfigBOs)) {
                        Map<String, PushServeConfigBO> pushServeConfigMap = pushServeConfigBOs.stream().collect(Collectors.toMap(PushServeConfigBO::getId, i -> i));
                        actionConfigBOs.forEach(i -> {
                            Map<String,Object> dataMap = i.getDataConfig();
                            if (null != dataMap && null != dataMap.get("push_id")) {
                                dataMap.put("pushServeConfig", pushServeConfigMap.get(dataMap.get("push_id")));
                            }
                        });
                    }
                }
            }
        }
        doctorTaskVO.setPushTaskConfig(pushTaskConfig);
        return doctorTaskVO;
    }

    @Override
    public DoctorTaskCountVO getTaskCount(DoctorTaskQueryDTO params) {
        DoctorTaskCountVO doctorTaskCountVO = new DoctorTaskCountVO();

        // 总数
        Long total = doctorTaskCacheService.doctorTaskCount(params.getDoctorId(), DoctorTaskConstant.DoctorTaskStatisticStatus.All.getCode());
        doctorTaskCountVO.setTotal(total);

        // 待处理
        Long todoCount = doctorTaskCacheService.doctorTaskCount(params.getDoctorId(), DoctorTaskConstant.DoctorTaskStatisticStatus.Todo.getCode());
        doctorTaskCountVO.setTodo(todoCount);

        return doctorTaskCountVO;
    }

    @Override
    public List<DoctorRemindVO> listDoctorRemind(DoctorRemindQueryDTO params) {
        List<DoctorRemindInfo> doctorRemindInfos = doctorRemindInfoService.list(new QueryWrapper<DoctorRemindInfo>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getPushStatus()), "push_status", params.getPushStatus())
                .eq(StrUtil.isNotBlank(params.getPushChannel()), "push_channel", params.getPushChannel())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getBizOneType()), "biz_one_type", params.getBizOneType())
                .eq(StrUtil.isNotBlank(params.getBizTwoType()), "biz_two_type", params.getBizTwoType())
                .ge(null != params.getStartDate(), "push_date", params.getStartDate())
                .lt(null != params.getEndDate(), "push_date", params.getEndDate())
                .last(" limit 1000 ") // 查询指定数量的提醒记录，防止数据量太大
        );

        return doctorRemindInfos.stream().map(DoctorPushTaskHelper::getDoctorRemindVO).collect(Collectors.toList());
    }

    @Override
    public DoctorRemindCountVO getRemindCountByUrgentLevel(DoctorRemindQueryDTO params) {
        DoctorRemindCountVO doctorRemindCountVO = new DoctorRemindCountVO();
        // 紧急
        Long urgent = doctorTaskCacheService.doctorRemindUrgentCount(params.getDoctorId(), RemindLevelEnum.Remind_Urgent.getCode());
        doctorRemindCountVO.setUrgent(urgent);

        // 重要
        Long important = doctorTaskCacheService.doctorRemindUrgentCount(params.getDoctorId(), RemindLevelEnum.Remind_Important.getCode());
        doctorRemindCountVO.setImportant(important);

        // 普通
        Long general = doctorTaskCacheService.doctorRemindUrgentCount(params.getDoctorId(), RemindLevelEnum.Remind_General.getCode());
        doctorRemindCountVO.setGeneral(general);

        return doctorRemindCountVO;
    }

    @Override
    public PageData<DoctorPushServeLogVO> queryPushServe(DoctorPushServeLogQueryDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:queryPushServe:params:>>>>>> {}", JSON.toJSONString(params));
        IPage<DoctorPushServeLogInfo> page = doctorPushServeLogInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorPushServeLogInfo>()
                .eq(StrUtil.isNotBlank(params.getDeptId()), "dept_id", params.getDeptId())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getPushTaskId()), "push_task_id", params.getPushTaskId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getPushServeId()), "push_serve_id", params.getPushServeId())
                .eq(StrUtil.isNotBlank(params.getPatientPushServeId()), "patient_push_serve_id", params.getPatientPushServeId())
                .eq(StrUtil.isNotBlank(params.getType()), "type", params.getType())
                .eq(StrUtil.isNotBlank(params.getStatus()), "status", params.getStatus())
                .orderByDesc("create_date")
        );
        
        PageData<DoctorPushServeLogVO> data = new PageConverter<DoctorPushServeLogInfo, DoctorPushServeLogVO>() {
            @Override
            public DoctorPushServeLogVO converter(DoctorPushServeLogInfo entity) {
                return DoctorPushTaskHelper.getDoctorPushServeLogVO(entity);
            }
        }.getPageData(page);
        return data;
    }

    @Override
    public DoctorPushServeLogVO pushServeDetail(DoctorPushServeLogGetDTO params) {
        DoctorPushServeLogInfo entity = doctorPushServeLogInfoService.getOne(new QueryWrapper<DoctorPushServeLogInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getDeptId()), "dept_id", params.getDeptId())
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getPushTaskId()), "push_task_id", params.getPushTaskId())
                .last(" limit 1 ")
        );
        return DoctorPushTaskHelper.getDoctorPushServeLogVO(entity);
    }


    @Override
    public List<DoctorTaskExeVO> taskExeList(DoctorTaskExeQueryDTO params) {
        log.info("DoctorTaskExeBizServiceImpl:list:params:>>>>>> {}", JSON.toJSONString(params));

        List<DoctorTaskExeInfo> list = doctorTaskExeInfoService.list(new QueryWrapper<DoctorTaskExeInfo>()
                .eq(StrUtil.isNotBlank(params.getDoctorId()), "doctor_id", params.getDoctorId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorIds()), "doctor_id", params.getDoctorIds())
                .eq(StrUtil.isNotBlank(params.getDoctorTaskId()), "doctor_task_id", params.getDoctorTaskId())
                .in(CollectionUtil.isNotEmpty(params.getDoctorTaskIds()), "doctor_task_id", params.getDoctorTaskIds())
        );

        return list.stream().map(DoctorPushTaskHelper::getDoctorTaskExeVO).collect(Collectors.toList());
    }

    @Override
    public DoctorTaskExeVO getOneTaskExe(DoctorTaskExeGetDTO params) {
        log.info("DoctorTaskExeBizServiceImpl:getOne:params:>>>>>> {}", JSON.toJSONString(params));
        ValidatorUtils.validateEntity(params);

        DoctorTaskExeInfo entity = doctorTaskExeInfoService.getOne(new QueryWrapper<DoctorTaskExeInfo>()
                .eq("doctor_id", params.getDoctorId())
                .eq("doctor_task_id", params.getDoctorTaskId())
                .last(" limit 1 ")
        );

        return DoctorPushTaskHelper.getDoctorTaskExeVO(entity);
    }

    @Override
    public PageData<ManageDoctorTaskVO> queryByDoctor(DoctorTaskQueryDTO params) {
        log.info("DoctorTaskQueryBizServiceImpl:queryByDoctor:params:>>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(params.getEndDate(), 1));
        }
        
        // 按科室进行筛选
        List<String> queryDoctorIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDeptId())) {
            // 查询子科室
            List<DeptBO> deptBOs = deptBizClientService.getDeptTreeList(params.getDeptId());
            if (CollectionUtil.isEmpty(deptBOs)) {
                return new PageData<>(null, 0);
            }
            List<String> deptIds = new ArrayList<>();
            deptBOs.forEach(i -> deptIds.add(i.getId()));

            List<AdminUserBO> adminUserBOList = adminUserClientService.getUserListByDeptIds(deptIds);
            if (CollectionUtil.isEmpty(adminUserBOList)) {
                return new PageData<>(null, 0);
            }
            adminUserBOList.forEach(i -> queryDoctorIds.add(i.getId()));
        }

        // 按用户信息筛选
        Map<String, PatientClientBO> patientMap = new HashMap<>();
        List<String> queryPatientIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getPatientName())) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientName(params.getPatientName());
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isEmpty(patientList)) {
                return new PageData<>(null, 0);
            }
            patientList.forEach(i -> {
                queryPatientIds.add(i.getPatientId());
                patientMap.put(i.getPatientId(), i);
            });
        }

        // 按病种筛选
        Map<String, PushTaskConfigBO> pushTaskConfigMap = new HashMap<>();
        List<String> taskIds = new ArrayList<>();
        if (StrUtil.isNotBlank(params.getDiseaseId())) {
            PushTaskConfigClientQueryDTO pushTaskConfigClientQueryDTO = new PushTaskConfigClientQueryDTO();
            pushTaskConfigClientQueryDTO.setDiseaseId(params.getDiseaseId());
            Map<String, PushTaskConfigBO> configMap = pushTaskConfigClientService.getMap(pushTaskConfigClientQueryDTO);
            if (CollectionUtil.isEmpty(configMap)) {
                return new PageData<>(null, 0);
            }
            pushTaskConfigMap.putAll(configMap);

            pushTaskConfigMap.forEach((k, v) -> taskIds.add(k));
        }

        IPage<ManageDoctorTaskVO> page = doctorTaskQueryBizMapper.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DoctorTaskInfo>()
                .eq("a.rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "a.patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(queryPatientIds), "a.patient_id", queryPatientIds)
                .eq(StrUtil.isNotBlank(params.getStatus()), "a.status", params.getStatus())
                .ge(null != params.getStartDate(), "a.create_date", params.getStartDate())
                .lt(null != params.getEndDate(), "a.create_date", params.getEndDate())
                .in(CollectionUtil.isNotEmpty(queryDoctorIds), "b.doctor_id", queryDoctorIds)
                .eq(StrUtil.isNotBlank(params.getExeStatus()), "b.status", params.getExeStatus())
                .in(CollectionUtil.isNotEmpty(taskIds), "a.task_id", taskIds)
                .orderByDesc("a.create_date")
        );
        
        List<String> patientIds = new ArrayList<>();
        List<String> doctorIds = new ArrayList<>();
        page.getRecords().forEach(i -> {
            if (CollectionUtil.isEmpty(pushTaskConfigMap)) {
                taskIds.add(i.getTaskId());
            }
            patientIds.add(i.getPatientId());
            doctorIds.add(i.getDoctorId());
        });

        // 查询医生任务配置信息
        if (CollectionUtil.isEmpty(pushTaskConfigMap) && CollectionUtil.isNotEmpty(taskIds)) {
            Map<String, PushTaskConfigBO> configMap = pushTaskConfigClientService.getByIds(taskIds);
            pushTaskConfigMap.putAll(configMap);
        }

        // 患者信息
        if (CollectionUtil.isEmpty(patientMap) && CollectionUtil.isNotEmpty(patientIds)) {
            PatientQueryDTO patientQueryDTO = new PatientQueryDTO();
            patientQueryDTO.setPatientIds(patientIds);
            List<PatientClientBO> patientList = patientClientService.simpleList(patientQueryDTO);
            if (CollectionUtil.isNotEmpty(patientList)) {
                patientList.forEach(i -> patientMap.put(i.getPatientId(), i));
            }
        }

        Map<String, AdminUserBO> doctorMap = adminUserClientService.getUserMapByIds(doctorIds);

        page.getRecords().forEach(vo -> {
            // 任务配置信息
            vo.setPushTaskConfig(pushTaskConfigMap.get(vo.getTaskId()));
            // 患者信息
            PatientClientBO patient = patientMap.get(vo.getPatientId());
            if (null != patient) {
                vo.setPatientName(patient.getPatientName());
                vo.setPatientSex(patient.getPatientGenderStandard());
                vo.setPatientAge(patient.getAge());
                vo.setPatientBirthday(patient.getBirthday());
                vo.setPatientPhone(patient.getPhone());
            }

            AdminUserBO doctor = doctorMap.get(vo.getDoctorId());
            if (null != doctor) {
                vo.setDoctorName(doctor.getRealName());
            }
        });

        return new PageData<>(page.getRecords(), page.getTotal(), page.getSize(), page.getPages());
    }

}
