package com.xxh.cloud.healthy.serve.pushTask.framework.modules.cache.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorTaskInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorTaskInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.cache.helper.DoctorTaskCacheKeysHelper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.cache.service.DoctorTaskCacheService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * zs20230927
 */
@Service
public class DoctorTaskCacheServiceImpl implements DoctorTaskCacheService {

    @Autowired
    protected RedisUtils redisUtils;
    @Autowired
    private DoctorTaskInfoService doctorTaskInfoService;
    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;

    @Override
    public Long doctorTaskCount(String doctorId, String statisticStatus) {
        String key = DoctorTaskCacheKeysHelper.getDoctorTaskCountKey(doctorId, statisticStatus);

        Object obj = this.redisUtils.get(key);
        if (null != obj) {
            return Long.valueOf(obj.toString());
        }

        Long count = doctorTaskInfoService.count(new QueryWrapper<DoctorTaskInfo>()
            .eq("rows_status", YN.YES.getCode())
            .like("doctor_ids", doctorId)
            .like(DoctorTaskConstant.DoctorTaskStatisticStatus.Todo.getCode().equals(statisticStatus), "not_doctor_ids", doctorId)
        );
        
        redisUtils.set(key, count, 180); // 缓存3分钟

        return count;
    }

    @Override
    public Long doctorRemindUrgentCount(String doctorId, String urgent) {
        String key = DoctorTaskCacheKeysHelper.getDoctorRemindUrgentCountKey(doctorId, urgent);

        Object obj = this.redisUtils.get(key);
        if (null != obj) {
            return Long.valueOf(obj.toString());
        }

        Long urgentCount = doctorRemindInfoService.count(new QueryWrapper<DoctorRemindInfo>()
            .eq("rows_status", YN.YES.getCode())
            .eq("doctor_id", doctorId)
            .eq("urgent_level", urgent)
        );
        
        redisUtils.set(key, urgentCount, 180); // 缓存3分钟

        return urgentCount;
    }

}
