package com.xxh.cloud.healthy.serve.pushTask.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.healthy.serve.pushTask.client.api.DoctorFollwUpClientService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.bo.DoctorFollowUpBO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.DoctorFollowUpClientAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.DoctorFollowUpClientCrmRelDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorFollowCrmRelDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorFollowUpAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorFollowUpGetDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorFollowUpQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorFollowUpBizService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class DoctorFollwUpClientServiceImpl implements DoctorFollwUpClientService {

    @Autowired
    private DoctorFollowUpBizService doctorFollowUpBizService;

    @Override
    public List<DoctorFollowUpBO> listByIds(List<String> ids) {
        DoctorFollowUpQueryDTO queryDTO = new DoctorFollowUpQueryDTO();
        queryDTO.setIds(ids);
        List<DoctorFollowUpVO> list = doctorFollowUpBizService.list(queryDTO);
        if (CollUtil.isEmpty(list)) {
            return new ArrayList<>(0);
        }

        return list.stream().map(DoctorPushTaskHelper::getDoctorFollowUpBO).collect(Collectors.toList());
    }

    @Override
    public DoctorFollowUpBO getById(String id) {
        DoctorFollowUpGetDTO getDTO = new DoctorFollowUpGetDTO();
        getDTO.setId(id);
        DoctorFollowUpVO vo = doctorFollowUpBizService.detail(getDTO);
        if (null == vo) {
            return null;
        }
        return DoctorPushTaskHelper.getDoctorFollowUpBO(vo);
    }

    @Override
    public void add(DoctorFollowUpClientAddDTO params) {
        if (null == params) {
            return;
        }
        DoctorFollowUpAddDTO addDTO = new DoctorFollowUpAddDTO();
        addDTO.setType(params.getType());
        addDTO.setPatientId(params.getPatientId());
        addDTO.setVisitId(params.getVisitId());
        addDTO.setDiseaseId(params.getDiseaseId());
        addDTO.setDoctorId(params.getDoctorId());
        addDTO.setContent(params.getContent());
        addDTO.setRemark(params.getRemark());
        addDTO.setFollowTime(params.getFollowTime());
        addDTO.setFollowDate(params.getFollowDate());
        addDTO.setOpType(params.getOpType());
        addDTO.setConsultationId(params.getConsultationId());
        addDTO.setSourceDeptId(params.getSourceDeptId());
        addDTO.setSourceDate(params.getSourceDate());
        addDTO.setCrmRelationId(params.getCrmRelationId());

        doctorFollowUpBizService.add(addDTO);
    }

    @Override
    public void addBatch(List<DoctorFollowUpClientAddDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }
        List<DoctorFollowUpAddDTO> list = new ArrayList<>();
        params.forEach(i -> {
            DoctorFollowUpAddDTO addDTO = new DoctorFollowUpAddDTO();
            addDTO.setType(i.getType());
            addDTO.setPatientId(i.getPatientId());
            addDTO.setVisitId(i.getVisitId());
            addDTO.setDiseaseId(i.getDiseaseId());
            addDTO.setDoctorId(i.getDoctorId());
            addDTO.setContent(i.getContent());
            addDTO.setRemark(i.getRemark());
            addDTO.setFollowTime(i.getFollowTime());
            addDTO.setFollowDate(i.getFollowDate());
            addDTO.setOpType(i.getOpType());
            addDTO.setConsultationId(i.getConsultationId());
            addDTO.setSourceDeptId(i.getSourceDeptId());
            addDTO.setSourceDate(i.getSourceDate());

            list.add(addDTO);
        });

        if (CollUtil.isNotEmpty(list)) {
            doctorFollowUpBizService.addBatch(list);
        }
    }

    @Override
    public void relCrm(DoctorFollowUpClientCrmRelDTO params) {
        DoctorFollowCrmRelDTO crmRelDTO = new DoctorFollowCrmRelDTO();
        crmRelDTO.setCrmRelationId(params.getCrmRelationId());
        crmRelDTO.setPatientId(params.getPatientId());
        crmRelDTO.setDoctorId(params.getDoctorId());
        crmRelDTO.setDiseaseId(params.getDiseaseId());
        doctorFollowUpBizService.crmRel(crmRelDTO);
    }


}
