package com.xxh.cloud.healthy.serve.pushTask.framework.modules.client.service;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.serve.pushTask.client.api.DoctorRelationClientService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.bo.DoctorRelationBO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.DoctorRelationClientQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRelationQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRelationVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.helper.DoctorPushTaskHelper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorRelationBizService;

@Service
public class DoctorRelationClientServiceImpl implements DoctorRelationClientService {

    @Autowired
    private DoctorRelationBizService doctorRelationBizService;

    @Override
    public List<DoctorRelationBO> list(DoctorRelationClientQueryDTO params) {

        DoctorRelationQueryDTO doctorRelationQueryDTO = new DoctorRelationQueryDTO();
        doctorRelationQueryDTO.setId(params.getId());
        doctorRelationQueryDTO.setType(params.getType());
        doctorRelationQueryDTO.setDoctorId(params.getDoctorId());
        doctorRelationQueryDTO.setDoctorIds(params.getDoctorIds());
        doctorRelationQueryDTO.setRelationId(params.getRelationId());
        doctorRelationQueryDTO.setRelationIds(params.getRelationIds());
        doctorRelationQueryDTO.setStatus(params.getStatus());
        List<DoctorRelationVO> list = doctorRelationBizService.list(doctorRelationQueryDTO);

        return list.stream().map(DoctorPushTaskHelper::getDoctorRelationBO).collect(Collectors.toList());
    }
    
}
