package com.xxh.cloud.healthy.serve.pushTask.framework.modules.client.service;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.serve.pushTask.client.api.DoctorRemindClientService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.DoctorRemindClientAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRemindAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorRemindBizService;

import cn.hutool.core.collection.CollUtil;

@Service
public class DoctorRemindClientServiceImpl implements DoctorRemindClientService {
    
    @Autowired
    private DoctorRemindBizService doctorRemindBizService;

    @Override
    public void add(DoctorRemindClientAddDTO params) {
        DoctorRemindAddDTO doctorRemindAddDTO = new DoctorRemindAddDTO();
        doctorRemindAddDTO.setDoctorId(params.getDoctorId());
        doctorRemindAddDTO.setBizOneType(params.getBizOneType());
        doctorRemindAddDTO.setBizTwoType(params.getBizTwoType());
        doctorRemindAddDTO.setBizId(params.getBizId());
        doctorRemindAddDTO.setTitle(params.getTitle());
        doctorRemindAddDTO.setContent(params.getContent());
        doctorRemindAddDTO.setPushChannel(params.getPushChannel());
        doctorRemindAddDTO.setPushTempId(params.getPushTempId());
        doctorRemindAddDTO.setPushConfig(params.getPushConfig());
        doctorRemindAddDTO.setPushStatus(params.getPushStatus());
        doctorRemindAddDTO.setPushDate(params.getPushDate());
        doctorRemindAddDTO.setRemark(params.getRemark());
        doctorRemindAddDTO.setUrgentLevel(params.getUrgentLevel());
        doctorRemindBizService.add(doctorRemindAddDTO);
    }

    @Override
    public void addbatch(List<DoctorRemindClientAddDTO> params) {
        if (CollUtil.isEmpty(params)) {
            return;
        }

        List<DoctorRemindAddDTO> list = new ArrayList<>();
        params.forEach(i -> {
            DoctorRemindAddDTO doctorRemindAddDTO = new DoctorRemindAddDTO();
            doctorRemindAddDTO.setDoctorId(i.getDoctorId());
            doctorRemindAddDTO.setBizOneType(i.getBizOneType());
            doctorRemindAddDTO.setBizTwoType(i.getBizTwoType());
            doctorRemindAddDTO.setBizId(i.getBizId());
            doctorRemindAddDTO.setTitle(i.getTitle());
            doctorRemindAddDTO.setContent(i.getContent());
            doctorRemindAddDTO.setPushChannel(i.getPushChannel());
            doctorRemindAddDTO.setPushTempId(i.getPushTempId());
            doctorRemindAddDTO.setPushConfig(i.getPushConfig());
            doctorRemindAddDTO.setPushStatus(i.getPushStatus());
            doctorRemindAddDTO.setPushDate(i.getPushDate());
            doctorRemindAddDTO.setRemark(i.getRemark());
            doctorRemindAddDTO.setUrgentLevel(i.getUrgentLevel());

            list.add(doctorRemindAddDTO);
        });

        if (CollUtil.isNotEmpty(list)) {
            doctorRemindBizService.addBatch(list);
        }
    }

    
}
