package com.xxh.cloud.healthy.serve.pushTask.framework.modules.client.service;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.serve.pushTask.client.api.DoctorTaskClientService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.UserTaskInfoAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.UserTaskInfoRemoveDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.TaskDoctorInfoAddDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.TaskDoctorInfoCancelDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorTaskBizService;

import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class DoctorTaskClientServiceImpl implements DoctorTaskClientService {

    @Autowired
    private DoctorTaskBizService doctorTaskInfoService;

    @Override
    public void add(UserTaskInfoAddDTO params) {
        log.info("DoctorTaskClientServiceImpl.add:params:>>>>>> {}", JSON.toJSONString(params));
        TaskDoctorInfoAddDTO addDTO = new TaskDoctorInfoAddDTO();
        addDTO.setDoctorIds(params.getDoctorIds());
        addDTO.setTaskId(params.getTaskId());
        // addDTO.setTaskType(params.getTaskType());
        // addDTO.setTaskName(params.getTaskName());
        addDTO.setRelType(params.getRelType());
        addDTO.setRelOneId(params.getRelOneId());
        addDTO.setRelTwoId(params.getRelTwoId());

        addDTO.setPatientId(params.getPatientId());
        addDTO.setPatientName(params.getPatientName()); // TODO 本地需要根据patientId查询具体的患者信息
        addDTO.setPatientSex(params.getPatientSex());
        
        doctorTaskInfoService.addTask(addDTO);
    }

    @Override
    public void addBatch(List<UserTaskInfoAddDTO> params) {
        log.info("DoctorTaskClientServiceImpl.addBatch:params:>>>>>> {}", JSON.toJSONString(params));
        List<TaskDoctorInfoAddDTO> taskDoctorInfoAddDTOs = new ArrayList<>();
        params.forEach(i -> {
            TaskDoctorInfoAddDTO addDTO = new TaskDoctorInfoAddDTO();
            addDTO.setDoctorIds(i.getDoctorIds());
            addDTO.setTaskId(i.getTaskId());
            // addDTO.setTaskType(i.getTaskType());
            // addDTO.setTaskName(i.getTaskName());
            addDTO.setRelType(i.getRelType());
            addDTO.setRelOneId(i.getRelOneId());
            addDTO.setRelTwoId(i.getRelTwoId());

            addDTO.setPatientId(i.getPatientId());
            addDTO.setPatientName(i.getPatientName());
            addDTO.setPatientSex(i.getPatientSex());
        
            taskDoctorInfoAddDTOs.add(addDTO);
        });
        
        doctorTaskInfoService.addBatchTask(taskDoctorInfoAddDTOs);
    }

    @Override
    public void remove(UserTaskInfoRemoveDTO params) {
        log.info("DoctorTaskClientServiceImpl.remove:params:>>>>>> {}", JSON.toJSONString(params));
        TaskDoctorInfoCancelDTO removeDTO = new TaskDoctorInfoCancelDTO();
        removeDTO.setId(params.getId());
        removeDTO.setIds(params.getIds());

        doctorTaskInfoService.cancelTask(removeDTO);
    }


}
