package com.xxh.cloud.healthy.serve.pushTask.framework.modules.task.service.impl;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.alibaba.fastjson2.TypeReference;
import com.xxh.cloud.healthy.basic.common.constant.PushWayEnum;
import com.xxh.cloud.healthy.basic.common.constant.UserTypeEnum;
import com.xxh.cloud.healthy.basic.pushtask.client.api.constant.PushTaskConstant;
import com.xxh.cloud.healthy.data.client.api.DwdDataPatientClientService;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientInpatientRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.bo.PatientVisitRecordClientBO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientDataClientDTO;
import com.xxh.cloud.healthy.data.client.api.bean.dto.PatientLastDataQueryDTO;
import com.xxh.cloud.healthy.mdt.third.bean.WecomSendTextcardReq;
import com.xxh.cloud.healthy.mdt.third.bean.WecomSendTextcardResp;
import com.xxh.cloud.healthy.mdt.third.utils.MdtSendTextCardHttpUtil;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.bos.PushWeixinStatusBO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.PushWeixinLogAddDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.bean.dto.SendWeixinDTO;
import com.xxh.cloud.healthy.push.framework.modules.biz.constant.PushWeixinConstant;
import com.xxh.cloud.healthy.push.framework.modules.biz.service.PushWeixinBizService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorFollowUpConstant;
import com.xxh.cloud.healthy.serve.pushTask.client.api.constant.DoctorTaskConstant;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.entity.DoctorRemindInfo;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.base.service.DoctorRemindInfoService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorFollowUpQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.dto.DoctorRemindUpdateDTO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorFollowUpVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.bean.vos.DoctorRemindVO;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.mapper.DoctorConsultationQueryBizMapper;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorFollowUpBizService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorTaskBizService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.biz.service.DoctorTaskQueryBizService;
import com.xxh.cloud.healthy.serve.pushTask.framework.modules.task.service.DoctorTaskBizTaskService;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.AdminUserThirdClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * zs20230924
 */
@Slf4j
@Service
public class DoctorTaskBizTaskServiceImpl implements DoctorTaskBizTaskService {

    @Autowired
    private DoctorRemindInfoService doctorRemindInfoService;
    @Autowired
    private DoctorTaskQueryBizService doctorTaskQueryBizService;
    @Autowired
    private PushWeixinBizService pushWeixinBizService;
    @Autowired
    private AdminUserThirdClientService adminUserThirdClientService;
    @Autowired
    private AdminUserClientService adminUserClientService;
    @Autowired
    private DoctorTaskBizService doctorTaskBizService;
    @Autowired
    private DoctorConsultationQueryBizMapper doctorConsultationQueryBizMapper;
    @Autowired
    private DoctorFollowUpBizService doctorFollowUpBizService;
    @Autowired
    private DwdDataPatientClientService dwdDataPatientClientService;

    /**
     * mdt会诊
     */
    @Value("${xx.mdt.hissms.enable:false}")
    private Boolean hissms;
    @Value("${xx.mdt.wxwork.content:}")
    private String hissmsContent;

    @Value("${xx.mdt.wxwork.enable:false}")
    private Boolean wxwork;
    @Value("${xx.mdt.wxwork.title:}")
    private String wxworkTitle;
    @Value("${xx.mdt.wxwork.content:}")
    private String wxworkContent;
    @Value("${xx.mdt.wxwork.url:}")
    private String wxworkUrl;

    
    /**
     * 发起会诊申请
     */
    @Value("${xx.mdtApply.hissms.enable:false}")
    private Boolean mdtApplyHissms;
    @Value("${xx.mdtApply.hissms.content:}")
    private String mdtApplyHissmsContent;

    @Value("${xx.mdtApply.wxwork.enable:false}")
    private Boolean mdtApplyWxwork;
    @Value("${xx.mdtApply.wxwork.title:}")
    private String mdtApplyWxworkTitle;
    @Value("${xx.mdtApply.wxwork.content:}")
    private String mdtApplyWxworkContent;
    @Value("${xx.mdtApply.wxwork.url:}")
    private String mdtApplyWxworkUrl;

    /**
     * 随访提醒
     */
    @Value("${xx.followUp.hissms.enable:false}")
    private Boolean followUpHissms;
    @Value("${xx.followUp.wxwork.content:}")
    private String followUpHissmsContent;

    @Value("${xx.followUp.wxwork.enable:false}")
    private Boolean followUpWxwork;
    @Value("${xx.followUp.wxwork.title:}")
    private String followUpWxworkTitle;
    @Value("${xx.followUp.wxwork.content:}")
    private String followUpWxworkContent;
    @Value("${xx.followUp.wxwork.url:}")
    private String followUpWxworkUrl;

    /**
     * 关注用户就诊提醒
     */
    @Value("${xx.follow.hissms.enable:false}")
    private Boolean followHissms;
    @Value("${xx.follow.wxwork.content:}")
    private String followHissmsContent;

    @Value("${xx.follow.wxwork.enable:false}")
    private Boolean followWxwork;
    @Value("${xx.follow.wxwork.title:}")
    private String followWxworkTitle;
    @Value("${xx.follow.wxwork.content:}")
    private String followWxworkContent;
    @Value("${xx.follow.wxwork.url:}")
    private String followWxworkUrl;


    // 古老代码已没用
    @Deprecated
    @Override
    public void pushDoctorTaskExecute() {
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);

        // openid
        List<String> doctorIds2Openid = new ArrayList<>(); // 获取微信推送的用户的openid
        doctorRemindVOs.forEach(i -> {
            if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel())) {
                doctorIds2Openid.add(i.getDoctorId());
            } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                // TODO 短信
            } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                // TODO AI电话
            }
        });

        Map<String, String> wxOpenidMap = getWxOpenidList(doctorIds2Openid);

        List<DoctorRemindInfo> doctorRemindUpdateDTOs = new ArrayList<>(); // 保存所有待更新的提醒
        List<SendWeixinDTO> sendWeixinDTOs = new ArrayList<>(); // 微信推送待保存日志
        // 保存提醒
        if (CollectionUtil.isNotEmpty(doctorRemindVOs)) {
            doctorRemindVOs.forEach(i -> {
                log.info(">>>>>>患者推送服务>>>>>> {}", JSON.toJSONString(i));
                DoctorRemindInfo doctorRemindUpdateDTO = new DoctorRemindInfo();
                doctorRemindUpdateDTO.setId(i.getId());
                // doctorRemindUpdateDTO.setPushStatus(null); // 根据推送是否成功设置推送状态

                if (PushWayEnum.PCW_WX.getCode().equals(i.getPushChannel()) && CollectionUtil.isNotEmpty(wxOpenidMap)) {
                    String openid = wxOpenidMap.get(i.getDoctorId());
                    if (StrUtil.isNotBlank(openid)) {
                        // 微信
                        SendWeixinDTO sendWeixinDTO = new SendWeixinDTO();

                        // 保存微信消息日志
                        PushWeixinLogAddDTO pushWeixinLogAddDTO = new PushWeixinLogAddDTO();

                        pushWeixinLogAddDTO.setUserType(UserTypeEnum.Patient.getCode());
                        pushWeixinLogAddDTO.setUserId(i.getDoctorId());
                        pushWeixinLogAddDTO.setOpenId(openid);
                        pushWeixinLogAddDTO.setBizOneType(i.getBizOneType());
                        pushWeixinLogAddDTO.setBizTwoType(i.getBizTwoType());
                        pushWeixinLogAddDTO.setBizId(i.getBizId());
                        pushWeixinLogAddDTO.setTempId(i.getPushTempId());
                        pushWeixinLogAddDTO.setRemindId(i.getId());
                        pushWeixinLogAddDTO.setRemark(i.getRemark());

                        sendWeixinDTO.setOpenid(openid);
                        sendWeixinDTO.setTempId(i.getPushTempId());
                        // sendWeixinDTO.setPushConfig(i.getPushConfig());
                        sendWeixinDTO.setLogInfo(pushWeixinLogAddDTO);
                        sendWeixinDTO.setUserType(PushWeixinConstant.UserType.DOCTOR.getCode());
                    
                        sendWeixinDTOs.add(sendWeixinDTO);
                    }
                } else if (PushWayEnum.PCW_SMS.getCode().equals(i.getPushChannel())) {
                    // TODO 短信
                } else if (PushWayEnum.PCW_AITel.getCode().equals(i.getPushChannel())) {
                    // TODO AI电话
                }
            });
        }

        // 处理提醒状态
        if (CollectionUtil.isNotEmpty(sendWeixinDTOs)) {
            List<PushWeixinStatusBO> pushWeixinStatusBOs = pushWeixinBizService.sendBatchWechatTemplateMsg(sendWeixinDTOs);
            pushWeixinStatusBOs.forEach(i -> {
                DoctorRemindInfo doctorRemindInfo = new DoctorRemindInfo();
                doctorRemindInfo.setId(i.getRemindId());
                if (PushWeixinConstant.WechatPushStatus.Success.getCode().equals(i.getSendStatus())) {
                    doctorRemindInfo.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                } else if (PushWeixinConstant.WechatPushStatus.Fail.getCode().equals(i.getSendStatus())) {
                    doctorRemindInfo.setPushStatus(DoctorTaskConstant.PushStatus.Fail.getCode());
                } else if (PushWeixinConstant.WechatPushStatus.Invalid.getCode().equals(i.getSendStatus())) {
                    doctorRemindInfo.setPushStatus(DoctorTaskConstant.PushStatus.Invalid.getCode());
                }

                doctorRemindUpdateDTOs.add(doctorRemindInfo);
            });
        }

        // 更新提醒状态
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOs)) {
            doctorRemindInfoService.updateBatchById(doctorRemindUpdateDTOs);
        }
    }

    // FIXME: 获取openid
    public Map<String, String> getWxOpenidList(List<String> patientIds) {
        if (CollectionUtil.isEmpty(patientIds)) {
            return null;
        }

        // TODO 调用xx-user中方法
        // List<PatientIdAndOpenId> list = userService.listPatientIdAndOpenId(patientIds);

        // 组装成map
        // Map<String, String> map = list.stream().collect(Collectors.toMap(i -> i.getPatientId(), i -> i.getOpenId));
        Map<String, String> map = patientIds.stream().collect(Collectors.toMap(i -> i, i -> "oCU1Y6_HheLXW1IgsBone1wpsLlE"));

        return map;
    }

    @Override
    public void pushDoctorMDTExecute() {
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.MDT.getCode()); // 查询mdt提醒
        // doctorRemindQueryDTO.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 查询mdt提醒
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        DateTime now = DateUtil.date();
        doctorRemindVOs.forEach(i -> {
            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // 超过1天的提醒直接更新为过期
            if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
                return;
            }

            // DoctorPushTaskConfigModel pushConfig = i.getPushConfig();
            
            Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
            if (wxwork) {
                doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
                pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
                pushWxLog.setUserId(i.getDoctorId());
                pushWxLog.setBizOneType(i.getBizOneType());
                pushWxLog.setBizTwoType(i.getBizTwoType());
                pushWxLog.setBizId(i.getBizId());
                pushWxLog.setRemindId(i.getId());
                // pushWxLog.setTempId();
                // pushWxLog.setOpenId();
                // pushWxLog.setWxAppId();
                pushWxLog.setRemark("企业微信推送医生MDT会诊消息日志");
                pushWeixinLogAddDTOs.add(pushWxLog);

//                Map<String, String> msgMap = new HashMap<>();
//                msgMap.put("title", StrUtil.format(wxworkTitle, i.getTitle()));
//                msgMap.put("description", StrUtil.format(wxworkContent, contentMap.get("name"), contentMap.get("applyDeptName"), contentMap.get("applyDoctorName")));
//                if (PushTaskConstant.OpType.MDT.getCode().equals(i.getBizOneType()) && StrUtil.isNotBlank(wxworkUrl)) {
//                    msgMap.put("url", this.urlStr(wxworkUrl, i.getBizId()));
//                    msgMap.put("btntxt", "更多");
//                }
                try {
                    AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                    if (null != doctor) {
                        WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                        StrUtil.format(wxworkTitle, i.getTitle()),
                        StrUtil.format(wxworkContent, contentMap.get("name"), contentMap.get("applyDeptName"), contentMap.get("applyDoctorName")),
                        this.urlStr(wxworkUrl, i.getBizId()));
                        WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                        if ("200".equals(resp.getCode())) {
                            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                            pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                        } else {
                            // 记录报错内容
                            pushWxLog.setErrorCode(resp.getCode());
                            pushWxLog.setErrorMsg(resp.getMessage());
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    pushWxLog.setErrorMsg(e.getMessage());
                }
                pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
            }
            if (hissms) {
                doctorRemindUpdateDTO.setSmsStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                String msgContent = StrUtil.format(hissmsContent, contentMap.get("name"), contentMap.get("applyDeptName"), contentMap.get("applyDoctorName"));
                String status = this.sendHisSms(i.getDoctorId(), msgContent); 
                doctorRemindUpdateDTO.setSmsStatus(status);
            }

        });

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }

    // 消息模版跳转地址
    private String urlStr(String url, String id) {
        if (StrUtil.isBlank(id)) {
            return url;
        }
        return url.concat("?id=" + id);
    }

    // 发送企业微信 mj.li注释 调用OA系统发送企业微信
    @Deprecated
//    private String sendWxWork(String userId, Map<String, String> msgMap) {
//        try {
//            SendWxWorkClientDTO sendWxWorkClientDTO = new SendWxWorkClientDTO();
//            sendWxWorkClientDTO.setUserId(userId);
//
//            sendWxWorkClientDTO.setMsgcontent(msgMap);
//            sendWxWorkClientDTO.setMsgtype("textcard"); // TODO 或者发送为markdown消息
//
//            log.info("2.推送企业微信消息>>>>>> sendWxWorkClientDTO={}", JSON.toJSONString(sendWxWorkClientDTO));
//            SendWxWorkResultBO sendWxWorkResultBO = adminUserThirdClientService.sendWxWorkMsg(sendWxWorkClientDTO);
//            log.info("3.推送企业微信消息<<<<<< sendWxWorkResultBO={}", JSON.toJSONString(sendWxWorkResultBO));
//
//            if (null != sendWxWorkResultBO && WechatErrorCodeEnum.SUCCESS.getCode().equals(String.valueOf(sendWxWorkResultBO.getErrcode()))) {
//                return DoctorTaskConstant.PushStatus.Success.getCode();
//            }
//        } catch (Exception e) {
//            log.error("4.企业微信推送error>>>>>> {}", e.getMessage());
//            e.printStackTrace();
//        }
//        return DoctorTaskConstant.PushStatus.Fail.getCode();
//    }

    // 发送his短信
    private String sendHisSms(String userId, String msgContent) {
        // 发送短信
        try {
            log.info("2.发送his短信>>>>>> doctorId={}; notice={}", userId, msgContent);
            adminUserThirdClientService.sendHisSMSMsg(userId, msgContent);
            return DoctorTaskConstant.PushStatus.Success.getCode();
        } catch (Exception e) {
            log.error("3.发送his短信error>>>>>> {}", e.getMessage());
            e.printStackTrace();
        }
        return DoctorTaskConstant.PushStatus.Fail.getCode();
    }

    @Override
    public void pushDoctorConsultationLaunchApplyExecute() {
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.ApplyMDT.getCode()); // 查询发起会诊提醒
        // doctorRemindQueryDTO.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 查询发起会诊提醒
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        // List<String> consultationApplyIds = new ArrayList<>();
        // doctorRemindVOs.forEach(i -> {
        //     consultationApplyIds.add(i.getBizId());
        // });

        // // 判断是否已经发起过会诊
        // // 1. 查询会诊申请信息，判断会诊申请信息上是否有会诊id，有则说明已经发起会诊
        // // 2. 根据住院号查询会诊信息，判断会诊医生科室是否与会诊申请的会诊科室匹配，匹配则说明已经发起会诊
        // // 查询会诊申请
        // List<Map<String, String>> consultationApplyList = doctorConsultationQueryBizMapper.consultationApplyList(new QueryWrapper<Void>()
        //         .in("a.id", consultationApplyIds)
        // );

        // Set<String> existConsultationSet = new HashSet<>(); // 已经有会诊的会诊申请
        // List<String> inpatientIds = new ArrayList<>();
        // consultationApplyList.forEach(i -> {
        //     String inpatientId = i.get("inpatientId");
        //     if (StrUtil.isNotBlank(inpatientId)) {
        //         inpatientIds.add(inpatientId);
        //     }

        //     String consultationId = i.get("consultationId");
        //     if (StrUtil.isNotBlank(consultationId)) {
        //         existConsultationSet.add(i.get("id"));
        //     }
        // });

        // Map<String, Set<String>> consultationMap = new HashMap<>(); // key：住院号  value：会诊医生科室列表
        // // 查询会诊
        // if (CollUtil.isNotEmpty(inpatientIds)) {
        //     List<Map<String, String>> consultationList = doctorConsultationQueryBizMapper.consultationList(new QueryWrapper<Void>()
        //             .in("a.inpatient_id", inpatientIds)
        //     );
        //     if (CollUtil.isNotEmpty(consultationList)) {
        //         consultationList.forEach(i -> {
        //             Set<String> s = consultationMap.get(i.get("inpatientId"));
        //             if (null == s) {
        //                 s = new HashSet<>();
        //                 consultationMap.put(i.get("inpatientId"), s);
        //             }
        //             s.add(i.get("deptCode"));
        //         });
        //     }
        // }

        // // 处理会诊申请与会诊是否匹配（判断会诊医生科室是否与会诊申请的会诊科室匹配，匹配则说明已经发起会诊）
        // consultationApplyList.forEach(i -> {
        //     Set<String> s = consultationMap.get(i.get("inpatientId"));
        //     if (CollUtil.isEmpty(s)) {
        //         return;
        //     }

        //     String consultationDeptId = i.get("consultationDeptIds");
        //     if (StrUtil.isNotBlank(consultationDeptId)) {
        //         List<String> consultationDeptIds = StrJoinSplitUtils.split2List(consultationDeptId);
        //         consultationDeptIds.forEach(j -> {
        //             if (s.contains(j)) {
        //                 existConsultationSet.add(i.get("inpatientId"));
        //             }
        //         });
        //     }
        // });

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        DateTime now = DateUtil.date();
        doctorRemindVOs.forEach(i -> {
            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // // 说明已经存在会诊，忽略提醒，更新状态
            // if (existConsultationSet.contains(i.getBizId())) {
            //     doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.ConsultationExist.getCode());
            //     return;
            // }

            // 超过1天的提醒直接更新为过期
            if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
                return;
            }

            // DoctorPushTaskConfigModel pushConfig = i.getPushConfig();
            
            Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
            String content = contentMap.get("content");
            if (StrUtil.isBlank(content)) {
                content = "";
            } else {
                content = "，" + content;
            }

            if (mdtApplyWxwork) {
                doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
                pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
                pushWxLog.setUserId(i.getDoctorId());
                pushWxLog.setBizOneType(i.getBizOneType());
                pushWxLog.setBizTwoType(i.getBizTwoType());
                pushWxLog.setBizId(i.getBizId());
                pushWxLog.setRemindId(i.getId());
                // pushWxLog.setTempId();
                // pushWxLog.setOpenId();
                // pushWxLog.setWxAppId();
                pushWxLog.setRemark("企业微信推送发起会诊消息日志");
                pushWeixinLogAddDTOs.add(pushWxLog);

                try {
    //                Map<String, String> msgMap = new HashMap<>();
    //                msgMap.put("title", StrUtil.format(mdtApplyWxworkTitle, i.getTitle()));
    //                // msgMap.put("description", StrUtil.format(mdtApplyWxworkContent, contentMap.get("applyDeptName"), contentMap.get("applyDoctorName"), contentMap.get("patientName"), contentMap.get("content")));
    //                msgMap.put("description", StrUtil.format(mdtApplyWxworkContent, contentMap.get("patientName"), content));
    //                if (PushTaskConstant.OpType.ApplyMDT.getCode().equals(i.getBizOneType()) && StrUtil.isNotBlank(mdtApplyWxworkUrl)) {
    //                    msgMap.put("url", this.urlStr(mdtApplyWxworkUrl, i.getBizId()));
    //                    msgMap.put("btntxt", "更多");
    //                }
                    // String status = this.sendWxWork(i.getDoctorId(), msgMap);
                    AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                    if (null != doctor) {
                        WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                        StrUtil.format(mdtApplyWxworkTitle, i.getTitle()),
                        StrUtil.format(mdtApplyWxworkContent, contentMap.get("patientName"), content),
                        this.urlStr(mdtApplyWxworkUrl, i.getBizId()));
                        WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                        if ("200".equals(resp.getCode())) {
                            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                            pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                        } else {
                            // 记录报错内容
                            pushWxLog.setErrorCode(resp.getCode());
                            pushWxLog.setErrorMsg(resp.getMessage());
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    pushWxLog.setErrorMsg(e.getMessage());
                }
                pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
            }
            if (mdtApplyHissms) {
                doctorRemindUpdateDTO.setSmsStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                // String msgContent = StrUtil.format(mdtApplyHissmsContent, contentMap.get("applyDeptName"), contentMap.get("applyDoctorName"), contentMap.get("patientName"), contentMap.get("content"));
                String msgContent = StrUtil.format(mdtApplyHissmsContent, contentMap.get("patientName"), content);
                String status = this.sendHisSms(i.getDoctorId(), msgContent);
                doctorRemindUpdateDTO.setSmsStatus(status);
            }
        });

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }

    @Override
    public void pushDoctorConsultationJoinExecute() {
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.JoinMDT.getCode()); // 查询发起会诊提醒
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        DateTime now = DateUtil.date();
        doctorRemindVOs.forEach(i -> {
            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // 超过1天的提醒直接更新为过期
            if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
                return;
            }

            Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
            String content = contentMap.get("content");
            if (StrUtil.isBlank(content)) {
                content = "";
            } else {
                content = "，" + content;
            }

            if (mdtApplyWxwork) {
                doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
                pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
                pushWxLog.setUserId(i.getDoctorId());
                pushWxLog.setBizOneType(i.getBizOneType());
                pushWxLog.setBizTwoType(i.getBizTwoType());
                pushWxLog.setBizId(i.getBizId());
                pushWxLog.setRemindId(i.getId());
                // pushWxLog.setTempId();
                // pushWxLog.setOpenId();
                // pushWxLog.setWxAppId();
                pushWxLog.setRemark("企业微信推送参加会诊消息日志");
                pushWeixinLogAddDTOs.add(pushWxLog);

                try {
    //                Map<String, String> msgMap = new HashMap<>();
    //                msgMap.put("title", i.getTitle());
    //                msgMap.put("description", StrUtil.format("[发现目标患者][{}]患者{}{}", contentMap.get("applyDeptName"), contentMap.get("patientName"), content));
    //                if (PushTaskConstant.OpType.JoinMDT.getCode().equals(i.getBizOneType()) && StrUtil.isNotBlank(mdtApplyWxworkUrl)) {
    //                    msgMap.put("url", this.urlStr(mdtApplyWxworkUrl, i.getBizId()));
    //                    msgMap.put("btntxt", "更多");
    //                }
    //                String status = this.sendWxWork(i.getDoctorId(), msgMap);
                    AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                    if (null != doctor) {
                        WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                        i.getTitle(),
                        StrUtil.format("[发现目标患者][{}]患者{}{}", contentMap.get("applyDeptName"), contentMap.get("patientName"), content),
                        this.urlStr(mdtApplyWxworkUrl, i.getBizId()));
                        WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                        if ("200".equals(resp.getCode())) {
                            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                            pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                        } else {
                            // 记录报错内容
                            pushWxLog.setErrorCode(resp.getCode());
                            pushWxLog.setErrorMsg(resp.getMessage());
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    pushWxLog.setErrorMsg(e.getMessage());
                }
                pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
            }
            if (mdtApplyHissms) {
                doctorRemindUpdateDTO.setSmsStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                // String msgContent = StrUtil.format(mdtApplyHissmsContent, contentMap.get("applyDeptName"), contentMap.get("applyDoctorName"), contentMap.get("patientName"), contentMap.get("content"));
                String msgContent = StrUtil.format("[发现目标患者][{}]患者{}{}", contentMap.get("applyDeptName"), contentMap.get("patientName"), content);
                String status = this.sendHisSms(i.getDoctorId(), msgContent);
                doctorRemindUpdateDTO.setSmsStatus(status);
            }
        });
        
        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }

    @Override
    public void pushDoctorPatientLabelRemind() {
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.Found.getCode()); // 查询发现患者提醒
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        DateTime now = DateUtil.date();
        doctorRemindVOs.forEach(i -> {
            PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
            pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
            pushWxLog.setUserId(i.getDoctorId());
            pushWxLog.setBizOneType(i.getBizOneType());
            pushWxLog.setBizTwoType(i.getBizTwoType());
            pushWxLog.setBizId(i.getBizId());
            pushWxLog.setRemindId(i.getId());
            // pushWxLog.setTempId();
            // pushWxLog.setOpenId();
            // pushWxLog.setWxAppId();
            pushWxLog.setRemark("企业微信推送消息日志");
            pushWeixinLogAddDTOs.add(pushWxLog);

            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // 超过1天的提醒直接更新为过期
            if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
                return;
            }

            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());
            try {
                Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
                String msgContent = StrUtil.format("[发现目标患者]患者姓名-{},患者编号-{},诊断部门-{},诊断医生-{},电话-{},{}",
                        contentMap.get("patientName"), contentMap.get("patientId"),
                        contentMap.get("departmentName"), contentMap.get("doctorName"), contentMap.get("doctorPhone"),
                        contentMap.get("labelRemark"));

                // 推送企业微信
    //            Map<String, String> msgMap = new HashMap<>();
    //            msgMap.put("title", i.getTitle());
    //            msgMap.put("description", msgContent);
    //            msgMap.put("url", "https://slife.bydsfy.com/doctorwx/#/user");
    //            msgMap.put("btntxt", "更多");
    //            String status = this.sendWxWork(i.getDoctorId(), msgMap);

                AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                if (null != doctor) {
                    WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                    i.getTitle(),
                    msgContent,"https://slife.bydsfy.com/doctorwx/#/user");
                    WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                    if ("200".equals(resp.getCode())) {
                        doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                        pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                    } else {
                        // 记录报错内容
                        pushWxLog.setErrorCode(resp.getCode());
                        pushWxLog.setErrorMsg(resp.getMessage());
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
                pushWxLog.setErrorMsg(e.getMessage());
            }
            pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
        });

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }

    @Override
    public void doctorPushFollowUpJobHandler() {
        DateTime now = DateUtil.date();
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.FollowUp.getCode()); // 查询发起会诊提醒
        // doctorRemindQueryDTO.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 查询发起会诊提醒
        doctorRemindQueryDTO.setStartDate(DateUtil.offsetMinute(now, -10));  // 查询十分钟左右的提醒，注意设置定时任务的循环触发时间不大于该时间
        doctorRemindQueryDTO.setEndDate(now);
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        List<String> followupIds = new ArrayList<>();
        doctorRemindVOs.forEach(i -> followupIds.add(i.getBizId()));

        Map<String, DoctorFollowUpVO> followupMap = new HashMap<>();
        DoctorFollowUpQueryDTO followUpQueryDTO = new DoctorFollowUpQueryDTO();
        followUpQueryDTO.setIds(followupIds);
        List<DoctorFollowUpVO> followupList = doctorFollowUpBizService.list(followUpQueryDTO);
        if (CollUtil.isNotEmpty(followupList)) {
            followupList.forEach(i -> followupMap.put(i.getId(), i));
        }

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        doctorRemindVOs.forEach(i -> {
            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // 超过1天的提醒直接更新为过期
            // if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
            //     doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
            //     return;
            // }

            // 判断随访状态确定是否发送提醒及更新提醒状态
            DoctorFollowUpVO followup = followupMap.get(i.getBizId());
            if (null == followup) {
                return;
            }
            if (DoctorFollowUpConstant.Status.DONE.getCode().equals(followup.getStatus())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode()); // 完成随访更新为提醒成功
                return;
            } else if (DoctorFollowUpConstant.Status.CANCEL.getCode().equals(followup.getStatus())) {
                doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode()); // 取消随访更新为提醒成功
                return;
            }

            // TODO 判断该随访提醒来源时间到当前时间是否有在对应科室就诊/住院过，有则不提醒并更新为提醒成功
            if (StrUtil.isNotBlank(followup.getSourceDeptId())) {
                // 就诊
                PatientDataClientDTO lastVisitQuery = new PatientDataClientDTO();
                lastVisitQuery.setDeptId(followup.getSourceDeptId());
                lastVisitQuery.setPatientId(followup.getPatientId());
                lastVisitQuery.setStartDate(DateUtil.formatDate(followup.getSourceDate()));
                lastVisitQuery.setEndDate(DateUtil.formatDateTime(now));
                List<PatientVisitRecordClientBO> lastVisitList = dwdDataPatientClientService.listPatientVisitLastDateInfo(lastVisitQuery);
                if (CollUtil.isNotEmpty(lastVisitList)) {
                    doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode()); // 随访时间未到，患者已经到目标科室就诊过，则随访更新为提醒成功
                    return;
                }

                // 住院
                PatientLastDataQueryDTO lastInpatientQuery = new PatientLastDataQueryDTO();
                lastInpatientQuery.setDeptId(followup.getSourceDeptId());
                lastInpatientQuery.setPatientId(followup.getPatientId());
                lastInpatientQuery.setStartDate(followup.getSourceDate());
                lastInpatientQuery.setStartDate(now);
                List<PatientInpatientRecordClientBO> lastInpatientList = dwdDataPatientClientService.listPatientInpatientLastDateInfo(lastInpatientQuery);
                if (CollUtil.isNotEmpty(lastInpatientList)) {
                    doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode()); // 随访时间未到，患者已经到目标科室住院过，则随访更新为提醒成功
                    return;
                }
            }
            
            Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
            String content = contentMap.get("content");
            if (StrUtil.isEmpty(content)) {
                content = "";
            } else {
                content = content + ", ";
            }

            if (followUpWxwork) {
                doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
                pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
                pushWxLog.setUserId(i.getDoctorId());
                pushWxLog.setBizOneType(i.getBizOneType());
                pushWxLog.setBizTwoType(i.getBizTwoType());
                pushWxLog.setBizId(i.getBizId());
                pushWxLog.setRemindId(i.getId());
                // pushWxLog.setTempId();
                // pushWxLog.setOpenId();
                // pushWxLog.setWxAppId();
                pushWxLog.setRemark("企业微信推送随访消息日志");
                pushWeixinLogAddDTOs.add(pushWxLog);

                try {
    //                Map<String, String> msgMap = new HashMap<>();
    //                msgMap.put("title", StrUtil.format(followUpWxworkTitle, i.getTitle()));
    //                msgMap.put("description", StrUtil.format(followUpWxworkContent, contentMap.get("patientName"), content));
    //                if (PushTaskConstant.OpType.FollowUp.getCode().equals(i.getBizOneType()) && StrUtil.isNotBlank(followUpWxworkUrl)) {
    //                    msgMap.put("url", this.urlStr(followUpWxworkUrl, i.getBizId()));
    //                    msgMap.put("btntxt", "更多");
    //                }
    //                String status = this.sendWxWork(i.getDoctorId(), msgMap);
                    AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                    if (null != doctor) {
                        WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                        StrUtil.format(followUpWxworkTitle, i.getTitle()),
                        StrUtil.format(followUpWxworkContent, contentMap.get("patientName"), content),
                        this.urlStr(followUpWxworkUrl, i.getBizId()));
                        WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                        if ("200".equals(resp.getCode())) {
                            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                            pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                        } else {
                            // 记录报错内容
                            pushWxLog.setErrorCode(resp.getCode());
                            pushWxLog.setErrorMsg(resp.getMessage());
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    pushWxLog.setErrorMsg(e.getMessage());
                }
                pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
            }
            if (followUpHissms) {
                doctorRemindUpdateDTO.setSmsStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                String msgContent = StrUtil.format(followUpHissmsContent, contentMap.get("patientName"), content);
                String status = this.sendHisSms(i.getDoctorId(), msgContent);
                doctorRemindUpdateDTO.setSmsStatus(status);
            }
        });

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }
    
    @Override
    public void doctorPushFollowJobHandler() {
        DateTime now = DateUtil.date();
        // 获取提醒信息
        DoctorRemindQueryDTO doctorRemindQueryDTO = new DoctorRemindQueryDTO();
        doctorRemindQueryDTO.setPushStatus(DoctorTaskConstant.PushStatus.Todo.getCode());
        doctorRemindQueryDTO.setBizOneType(PushTaskConstant.OpType.Follow.getCode()); // 查询发起会诊提醒
        // doctorRemindQueryDTO.setBizTwoType(PushTaskConstant.OpType.MDT.getCode()); // 查询发起会诊提醒
        doctorRemindQueryDTO.setStartDate(DateUtil.offsetMinute(now, -10));  // 查询十分钟左右的提醒，注意设置定时任务的循环触发时间不大于该时间
        doctorRemindQueryDTO.setEndDate(now);
        List<DoctorRemindVO> doctorRemindVOs = doctorTaskQueryBizService.listDoctorRemind(doctorRemindQueryDTO);
        if (CollectionUtil.isEmpty(doctorRemindVOs)) {
            return;
        }

        // 处理需要保存或发送的数据
        List<DoctorRemindUpdateDTO> doctorRemindUpdateDTOList = new ArrayList<>();
        List<PushWeixinLogAddDTO> pushWeixinLogAddDTOs = new ArrayList<>(); // 微信推送待保存日志

        doctorRemindVOs.forEach(i -> {
            DoctorRemindUpdateDTO doctorRemindUpdateDTO = new DoctorRemindUpdateDTO();
            doctorRemindUpdateDTO.setId(i.getId());
            doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Success.getCode());
            doctorRemindUpdateDTOList.add(doctorRemindUpdateDTO);

            // 超过1天的提醒直接更新为过期
            // if (DateUtil.offsetDay(now, -1).after(i.getPushDate())) {
            //     doctorRemindUpdateDTO.setPushStatus(DoctorTaskConstant.PushStatus.Expire.getCode());
            //     return;
            // }

            Map<String, String> contentMap = JSONObject.parseObject(i.getContent(), new TypeReference<Map<String, String>>() {});
            if (followWxwork) {
                doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                PushWeixinLogAddDTO pushWxLog = new PushWeixinLogAddDTO();
                pushWxLog.setUserType(UserTypeEnum.Doctor.getCode());
                pushWxLog.setUserId(i.getDoctorId());
                pushWxLog.setBizOneType(i.getBizOneType());
                pushWxLog.setBizTwoType(i.getBizTwoType());
                pushWxLog.setBizId(i.getBizId());
                pushWxLog.setRemindId(i.getId());
                // pushWxLog.setTempId();
                // pushWxLog.setOpenId();
                // pushWxLog.setWxAppId();
                pushWxLog.setRemark("企业微信推送关注消息日志");
                pushWeixinLogAddDTOs.add(pushWxLog);
                
                try {
                    // Map<String, String> msgMap = new HashMap<>();
    //                msgMap.put("title", StrUtil.format(followWxworkTitle, i.getTitle()));
    //                msgMap.put("description", StrUtil.format(followWxworkContent, contentMap.get("patientName"), contentMap.get("content")));
    //                if (PushTaskConstant.OpType.Follow.getCode().equals(i.getBizOneType()) && StrUtil.isNotBlank(followWxworkUrl)) {
    //                    msgMap.put("url", this.urlStr(followWxworkUrl, i.getBizId()));
    //                    msgMap.put("btntxt", "更多");
    //                }
    //                String status = this.sendWxWork(i.getDoctorId(), msgMap);
                    AdminUserBO doctor = adminUserClientService.getUserById(i.getDoctorId());
                    if (null != doctor) {
                        WecomSendTextcardReq req = new WecomSendTextcardReq(doctor.getUserName(),
                        StrUtil.format(followWxworkTitle, i.getTitle()),
                        StrUtil.format(followWxworkContent, contentMap.get("patientName"), contentMap.get("content")),
                        this.urlStr(followWxworkUrl, i.getBizId()));
                        WecomSendTextcardResp resp = MdtSendTextCardHttpUtil.send(req);
                        if ("200".equals(resp.getCode())) {
                            doctorRemindUpdateDTO.setWxworkStatus(DoctorTaskConstant.PushStatus.Success.getCode());
                            pushWxLog.setErrorCode(DoctorTaskConstant.PushStatus.Success.getCode());
                        } else {
                            // 记录报错内容
                            pushWxLog.setErrorCode(resp.getCode());
                            pushWxLog.setErrorMsg(resp.getMessage());
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    pushWxLog.setErrorMsg(e.getMessage());
                }
                pushWxLog.setSendStatus(doctorRemindUpdateDTO.getWxworkStatus());
            }
            if (followHissms) {
                doctorRemindUpdateDTO.setSmsStatus(DoctorTaskConstant.PushStatus.Fail.getCode());

                String msgContent = StrUtil.format(followHissmsContent, contentMap.get("patientName"), contentMap.get("content"));
                String status = this.sendHisSms(i.getDoctorId(), msgContent);
                doctorRemindUpdateDTO.setSmsStatus(status);
            }
        });

        // 保存微信日志
        if (CollectionUtil.isNotEmpty(pushWeixinLogAddDTOs)) {
            pushWeixinBizService.addBatchLog(pushWeixinLogAddDTOs);
        }
        if (CollectionUtil.isNotEmpty(doctorRemindUpdateDTOList)) {
            doctorTaskBizService.updateRemindStatusBatch(doctorRemindUpdateDTOList);
        }
    }
    
    // 消息模版跳转地址
    // private String urlStr(String url, Map<String, String> urlParams) {
    //     if (CollectionUtil.isEmpty(urlParams)) {
    //         return url;
    //     }
    //     StringBuffer sb = new StringBuffer("?");
    //     urlParams.forEach((k, v) -> {
    //         sb.append(k);
    //         sb.append("=");
    //         sb.append(v);
    //         sb.append("&");
    //     });

    //     return url.concat(sb.substring(sb.length() - 1));
    // }
}
