package com.xxh.cloud.healthy.serve.risk.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 患者风险历史信息表
 * </p>
 *
 * @author anros
 * @since 2023-11-01
 */
@Data
@TableName("h_patient_risk_history_info")
public class PatientRiskHistoryInfo {

    private static final long serialVersionUID = 1L;


    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 风险ID
     */
     @ApiModelProperty(value = "风险ID")
      private String riskId;

    /**
     * 风险名称
     */
     @ApiModelProperty(value = "风险名称")
      private String riskName;

    /**
     * 风险病种ID
     */
     @ApiModelProperty(value = "风险病种ID")
      private String riskDiseaseIds;

    /**
     * 风险系统ID
     */
     @ApiModelProperty(value = "风险系统ID")
      private String riskSysId;

    /**
     * 风险类型
     */
     @ApiModelProperty(value = "风险类型")
      private String riskType;

    /**
     * 风险等级
     */
     @ApiModelProperty(value = "风险等级")
      private String riskLevel;

    /**
     * 风险关联分类
     */
     @ApiModelProperty(value = "风险关联分类")
      private String riskRelType;

    /**
     * 风险关联ID
     */
     @ApiModelProperty(value = "风险关联ID")
      private String riskRelId;

    /**
     * 来源分类
     */
     @ApiModelProperty(value = "来源分类")
      private String sourceType;

    /**
     * 来源关联ID
     */
     @ApiModelProperty(value = "来源关联ID")
      private String sourceRelId;

    /**
     * 患者数据时间
     */
     @ApiModelProperty(value = "患者数据时间")
      private Date dataDt;

    /**
     * 操作动作分类
     */
     @ApiModelProperty(value = "操作动作分类")
      private String opType;

    /**
     * 操作者
     */
     @ApiModelProperty(value = "操作者")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
