package com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import javax.validation.constraints.NotEmpty;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientRiskAddBatchDTO {

    @ApiModelProperty(value = "患者编号")
    @NotEmpty(message = "患者编号[patientId]不能为空")
    private String patientId;

    @ApiModelProperty(value = "风险ID列表")
    @NotEmpty(message = "风险ID列表[riskIds]不能为空")
    private List<String> riskIds;

    @ApiModelProperty(value = "来源分类")
    private String sourceType;

    @ApiModelProperty(value = "来源关联ID")
    private String sourceRelId;

    @ApiModelProperty(value = "患者数据时间")
    private Date dataDt;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "操作者")
    private String opUser;

}
