package com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseSystemBO;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientRiskVO{

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 风险ID
     */
     @ApiModelProperty(value = "风险ID")
      private String riskId;

    /**
     * 风险名称
     */
     @ApiModelProperty(value = "风险名称")
      private String riskName;

    /**
     * 风险病种ID
     */
     @ApiModelProperty(value = "风险病种ID")
      private List<String> riskDiseaseIds;

    /**
     * 风险系统ID
     */
     @ApiModelProperty(value = "风险系统ID")
      private String riskSysId;

    /**
     * 风险类型
     */
     @ApiModelProperty(value = "风险类型")
      private String riskType;

    /**
     * 风险等级
     */
     @ApiModelProperty(value = "风险等级")
      private String riskLevel;

    /**
     * 风险关联分类
     */
     @ApiModelProperty(value = "风险关联分类")
      private String riskRelType;

    /**
     * 风险关联ID
     */
     @ApiModelProperty(value = "风险关联ID")
      private String riskRelId;

    /**
     * 来源分类
     */
     @ApiModelProperty(value = "来源分类")
      private String sourceType;

    /**
     * 来源关联ID
     */
     @ApiModelProperty(value = "来源关联ID")
      private String sourceRelId;

    /**
     * 患者数据时间
     */
     @ApiModelProperty(value = "患者数据时间")
      private Date dataDt;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 创建者
     */
     @ApiModelProperty(value = "创建者")
      private String creator;

    /**
     * 创建时间
     */
     @ApiModelProperty(value = "创建时间")
      private Date createDate;

    /**
     * 风险病种列表
     */
     @ApiModelProperty(value = "风险病种列表")
      private List<StandardDiseaseBO> riskDiseaseList;

    /**
     * 风险系统
     */
     @ApiModelProperty(value = "风险系统")
      private StandardDiseaseSystemBO riskSys;


}
