package com.xxh.cloud.healthy.serve.risk.framework.modules.biz.helper;

import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.serve.risk.framework.modules.base.entity.PatientRiskHistoryInfo;
import com.xxh.cloud.healthy.serve.risk.framework.modules.base.entity.PatientRiskInfo;
import com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.vo.PatientRiskHistoryVO;
import com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.vo.PatientRiskVO;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;

public class PatientRiskHelper {

    public static String getPatientRiskInfoId(){
        return StrUtil.format("PR{}", IdUtil.getSnowflake(5,6).nextIdStr());
    }

    public static String getPatientRiskHistoryInfoId(){
        return StrUtil.format("PRH{}", IdUtil.getSnowflake(5,7).nextIdStr());
    }

    public static PatientRiskVO getPatientRiskVO(PatientRiskInfo entity) {
        PatientRiskVO vo = new PatientRiskVO();
        BeanUtil.copyProperties(entity, vo, "riskDiseaseIds");
        if (StrUtil.isNotBlank(entity.getRiskDiseaseIds())) {
            vo.setRiskDiseaseIds(StrJoinSplitUtils.split2List(entity.getRiskDiseaseIds()));
        }
        return vo;
    }

    public static PatientRiskHistoryVO getPatientRiskHistoryVO(PatientRiskHistoryInfo entity) {
        PatientRiskHistoryVO vo = new PatientRiskHistoryVO();
        BeanUtil.copyProperties(entity, vo, "riskDiseaseIds");
        if (StrUtil.isNotBlank(entity.getRiskDiseaseIds())) {
            vo.setRiskDiseaseIds(StrJoinSplitUtils.split2List(entity.getRiskDiseaseIds()));
        }
        return vo;
    }

}
