package com.xxh.cloud.healthy.serve.risk.framework.modules.client.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.healthy.serve.risk.client.api.PatientRiskClientService;
import com.xxh.cloud.healthy.serve.risk.client.api.bean.dto.PatientRiskAddClientDTO;
import com.xxh.cloud.healthy.serve.risk.client.api.bean.dto.PatientRiskRemoveClientDTO;
import com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.dto.PatientRiskAddBatchDTO;
import com.xxh.cloud.healthy.serve.risk.framework.modules.biz.bean.dto.PatientRiskDelBatchDTO;
import com.xxh.cloud.healthy.serve.risk.framework.modules.biz.service.PatientRiskBizService;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class PatientRiskClientServiceImpl implements PatientRiskClientService {

    @Autowired
    private PatientRiskBizService patientRiskBizService;

    @Override
    public void add(PatientRiskAddClientDTO params) {
        PatientRiskAddBatchDTO patientRiskAddBatchDTO = new PatientRiskAddBatchDTO();
        patientRiskAddBatchDTO.setPatientId(params.getPatientId());
        patientRiskAddBatchDTO.setRiskIds(params.getRiskIds());
        patientRiskAddBatchDTO.setRemark(params.getRemark());
        patientRiskAddBatchDTO.setOpUser(params.getOpUser());
        patientRiskAddBatchDTO.setSourceRelId(params.getSourceRelId());
        patientRiskAddBatchDTO.setSourceType(params.getSourceType());
        patientRiskAddBatchDTO.setDataDt(params.getDataDt());
        patientRiskBizService.addBatch(patientRiskAddBatchDTO);
    }

    @Override
    public void remove(PatientRiskRemoveClientDTO params) {
        PatientRiskDelBatchDTO patientRiskDelBatchDTO = new PatientRiskDelBatchDTO();
        patientRiskDelBatchDTO.setPatientId(params.getPatientId());
        patientRiskDelBatchDTO.setRiskIds(params.getRiskIds());
        patientRiskDelBatchDTO.setOpUser(params.getOpUser());
        patientRiskDelBatchDTO.setSourceRelId(params.getSourceRelId());
        patientRiskDelBatchDTO.setSourceType(params.getSourceType());
        patientRiskDelBatchDTO.setDataDt(params.getDataDt());
        patientRiskBizService.removeBatch(patientRiskDelBatchDTO);
    }

}
