package com.xxh.cloud.healthy.serv.framework.modules.userDisease.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 用户疾病日志信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_user_disease_log_info")
public class UserDiseaseLogInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 用户ID
     */
     @ApiModelProperty(value = "用户ID")
      private String userId;

    /**
     * 病种ID
     */
     @ApiModelProperty(value = "病种ID")
      private String diseaseId;


    /**
     * 操作关联业务分类
     */
     @ApiModelProperty(value = "操作关联业务分类")
      private String relIdType;

    /**
     * 操作关联业务ID
     */
     @ApiModelProperty(value = "操作关联业务ID")
      private String relId;

     @ApiModelProperty(value = "新增操作者")
      private String opUser;

     @ApiModelProperty(value = "新增操作时间")
      private Date opDate;

    @ApiModelProperty(value = "新增备注")
    private String remark;


    @ApiModelProperty(value = "移除操作者")
    private String removeOpUser;

    @ApiModelProperty(value = "移除操作时间")
    private Date removeOpDate;

    @ApiModelProperty(value = "移除备注")
    private String removeRemark;



}
