package com.xxh.cloud.healthy.serv.framework.modules.userService.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 用户服务日志表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_user_healthy_service_log_info")
public class UserHealthyServiceLogInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 客户用户ID
     */
     @ApiModelProperty(value = "客户用户ID")
      private String custUserId;

    /**
     * 服务ID
     */
     @ApiModelProperty(value = "服务ID")
      private String serviceId;

    /**
     * 来源分类(目标/标签)
     */
     @ApiModelProperty(value = "来源分类(目标/标签)")
      private String sourceType;

    /**
     * 来源ID
     */
     @ApiModelProperty(value = "来源ID")
      private String sourceId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String remark;

    /**
     * 操作关联业务分类
     */
     @ApiModelProperty(value = "操作关联业务分类")
      private String relIdType;

    /**
     * 操作关联业务ID
     */
     @ApiModelProperty(value = "操作关联业务ID")
      private String relId;

    /**
     * 操作动作分类
     */
     @ApiModelProperty(value = "操作动作分类")
      private String opType;

    /**
     * 操作者
     */
     @ApiModelProperty(value = "操作者")
      private String opUser;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
