package com.xxh.cloud.healthy.serv.framework.modules.userService.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 用户服务任务表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("h_user_healthy_service_task_info")
public class UserHealthyServiceTaskInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 客户用户ID
     */
     @ApiModelProperty(value = "客户用户ID")
      private String custUserId;

    /**
     * 客户用户服务ID
     */
     @ApiModelProperty(value = "客户用户服务ID")
      private String custUserServiceId;

    /**
     * 来源分类(目标/标签)
     */
     @ApiModelProperty(value = "来源分类(目标/标签)")
      private String sourceType;

    /**
     * 来源ID
     */
     @ApiModelProperty(value = "来源ID")
      private String sourceId;

    /**
     * 任务生成方式
     */
     @ApiModelProperty(value = "任务生成方式")
      private String generateWay;

    /**
     * 任务生成时间
     */
     @ApiModelProperty(value = "任务生成时间")
      private Date generateDt;

    /**
     * 任务生成人
     */
     @ApiModelProperty(value = "任务生成人")
      private String generateMan;

    /**
     * 任务生成备注
     */
     @ApiModelProperty(value = "任务生成备注")
      private String generateRemark;

    /**
     * 任务提醒用户是否能关闭
     */
     @ApiModelProperty(value = "任务提醒用户是否能关闭")
      private String isNeedNotify;

    /**
     * 任务提醒状态
     */
     @ApiModelProperty(value = "任务提醒状态")
      private String notifyStatus;

    /**
     * 任务提醒发送时间
     */
     @ApiModelProperty(value = "任务提醒发送时间")
      private Date notifySendDt;

    /**
     * 任务计划执行时间
     */
     @ApiModelProperty(value = "任务计划执行时间")
      private Date planExeDt;

    /**
     * 任务生成的执行时间
     */
     @ApiModelProperty(value = "任务生成的执行时间")
      private Date generateExeDt;

    /**
     * 任务执行状态
     */
     @ApiModelProperty(value = "任务执行状态")
      private String exeStatus;

    /**
     * 任务执行人
     */
     @ApiModelProperty(value = "任务执行人")
      private String exeMan;

    /**
     * 任务执行时间
     */
     @ApiModelProperty(value = "任务执行时间")
      private Date exeDt;

    /**
     * 任务执行备注
     */
     @ApiModelProperty(value = "任务执行备注")
      private String exeRemark;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;




}
