package com.xxh.cloud.healthy.service.com.manager.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteCallbackDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServeRemindRemoteQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientRemindQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeConfigSnapshotVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServeRemindRemoteVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientRemindVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeBizService;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServeQueryBizService;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.dev33.satoken.annotation.SaCheckPermission;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

@SaCheckLogin
@Log4j2
@RestController
@RequestMapping("/sys/healthy/patient/pushService/remind")
@Api(tags = "患者推送服务提醒")
public class PatientPushServeRemindManagerController {
    
    @Autowired
    private PatientPushServeBizService patientPushServeBizService;
    @Autowired
    private PatientPushServeQueryBizService patientPushServeQueryBizService;

    // @SaCheckPermission("sys:healthyserve:patientPushServe:page")
    // @PostMapping("/page")
    // @ApiOperation(value = "分页查询微信模版消息", response = PatientPushServeVO.class)
    // public Result<PageData<PatientPushServeVO>> pushServePage(@RequestBody PatientPushServeQueryParam params) {
    //     log.info("/sys/healthy/patient/pushService/remind/page >>> {}", JSON.toJSONString(params));
    //     PageData<PatientPushServeVO> data = patientPushServeQueryBizService.pushServePage(params);
    //     return new Result<PageData<PatientPushServeVO>>().ok(data);
    // }
    
    // @SaCheckPermission("sys:healthyserve:patientPushServe:detail")
    @PostMapping("/detail")
    @ApiOperation(value = "服务推送提醒详情", response = PatientRemindVO.class)
    public Result<PatientRemindVO> pushServePage(@RequestBody PatientRemindQueryDTO params) {
        log.info("/sys/healthy/patient/pushService/remind/detail >>> {}", JSON.toJSONString(params));
        PatientRemindVO data = patientPushServeQueryBizService.getPatientRemind(params);
        return new Result<PatientRemindVO>().ok(data);
    }
    
    // @SaCheckPermission("sys:healthyserve:patientPushServe:list")
    @PostMapping("/list")
    @ApiOperation(value = "微信模版消息列表", response = PatientPushServeRemindRemoteVO.class)
    public Result<List<PatientPushServeRemindRemoteVO>> pushServeList(@RequestBody PatientPushServeRemindRemoteQueryDTO params) {
        log.info("/sys/healthy/patient/pushService/remind/list >>> {}", JSON.toJSONString(params));
        List<PatientPushServeRemindRemoteVO> data = patientPushServeBizService.queryPatientRemindDataList(params);
        return new Result<List<PatientPushServeRemindRemoteVO>>().ok(data);
    }

    // @SaCheckPermission("sys:healthyserve:patientPushServeSnapshot:list")
    @PostMapping("/callback")
    @ApiOperation(value = "微信模版消息回调", response = PatientPushServeConfigSnapshotVO.class)
    public Result<String> callback(@RequestBody List<PatientPushServeRemindRemoteCallbackDTO> params) {
        log.info("/sys/healthy/patient/pushService/remind/callback >>> {}", JSON.toJSONString(params));
        patientPushServeBizService.patientRemindDataCallback(params);
        return new Result<String>().ok("ok");
    }

}
