package com.xxh.cloud.healthy.service.com.manager.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import com.xxh.cloud.framework.common.user.LoginUser;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServiceDataDetailQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientPushServiceDataQueryDTO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServiceDataDetailVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientPushServiceDataVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientPushServiceManageService;

import cn.dev33.satoken.annotation.SaCheckLogin;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

@SaCheckLogin
@Log4j2
@RestController
@RequestMapping("/sys/patient/pushserve")
@Api(tags = "运营端患者推送服务管理")
public class PatientPushServiceManageController {
    
    @Autowired
    private PatientPushServiceManageService patientPushServiceManageService;

    @PostMapping("/pushServicePage")
    @ApiOperation(value = "分页查询患者推送服务数据", response = PatientPushServiceDataVO.class)
    public Result<PageData<PatientPushServiceDataVO>> pushServicePage(@RequestBody PatientPushServiceDataQueryDTO params) {
        log.info("/sys/patient/pushserve/pushServicePage >>> {}", JSON.toJSONString(params));
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        PageData<PatientPushServiceDataVO> data = patientPushServiceManageService.pushServicePage(params);
        return new Result<PageData<PatientPushServiceDataVO>>().ok(data);
    }

    @PostMapping("/pushServiceDetailList")
    @ApiOperation(value = "查询患者推送服务数据详情", response = PatientPushServiceDataDetailVO.class)
    public Result<List<PatientPushServiceDataDetailVO>> pushServiceDetailList(@RequestBody PatientPushServiceDataDetailQueryDTO params) {
        log.info("/sys/patient/pushserve/pushServiceDetailList >>> {}", JSON.toJSONString(params));
        LoginUser user= AuthContextUtils.getCurrentLoginUser();
        List<PatientPushServiceDataDetailVO> data = patientPushServiceManageService.pushServiceDetailList(params);
        return new Result<List<PatientPushServiceDataDetailVO>>().ok(data);
    }
}
