package com.xxh.cloud.healthy.service.com.manager.controller;

import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.dto.PatientServeTestQueryParam;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.bean.vos.PatientServeTestVO;
import com.xxh.cloud.healthy.serve.pushServe.framework.modules.biz.service.PatientServeTestBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import com.xxh.cloud.framework.common.user.LoginUser;

import cn.dev33.satoken.annotation.SaCheckLogin;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

@SaCheckLogin
@Log4j2
@RestController
@RequestMapping("/sys/healthy/patient/serve/test")
@Api(tags = "测试服务管理")
public class PatientServeTestManagerController {
    
    @Autowired
    private PatientServeTestBizService patientServeTestBizService;
    
    // @SaCheckPermission("sys:healthyserve:pushTaskExe:add")
    @PostMapping("/query")
    @ApiOperation(value = "列表", response = PatientServeTestVO.class)
    public Result<PageData<PatientServeTestVO>> list(@RequestBody PatientServeTestQueryParam parmas) {
        log.info("/sys/healthy/patient/serve/test/query >>> {}", JSON.toJSONString(parmas));
        LoginUser user = AuthContextUtils.getCurrentLoginUser();

        if (!YN.YES.getCode().equals(user.getIsSuperAdmin())) {
            return new Result<PageData<PatientServeTestVO>>().success();
        }

        PageData<PatientServeTestVO> data = patientServeTestBizService.query(parmas);
        return new Result<PageData<PatientServeTestVO>>().ok(data);
    }

}
