package com.xxh.cloud.healthy.third.client.modules.local.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.customer.client.api.CustomerUserClientService;
import com.xxh.cloud.customer.client.api.bean.bos.CustomerUserBO;
import com.xxh.cloud.healthy.third.client.modules.api.HealthyThirdUserService;
import com.xxh.cloud.healthy.third.client.modules.api.entity.bos.HealthyUserBO;
import com.xxh.cloud.healthy.third.client.modules.local.utils.HealthyThirdUserUtil;
import com.xxh.cloud.user.client.api.AdminUserClientService;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;


@Service
public class HealthyThirdUserServiceImpl implements HealthyThirdUserService {


    @Autowired
    private CustomerUserClientService customerUserClientService;

    @Autowired
    private AdminUserClientService adminUserClientService;



    private HealthyUserBO getCustomerUserById(String id){
        CustomerUserBO user= customerUserClientService.getEntityBOById(id);
        return HealthyThirdUserUtil.getHealthyUserBO(user);
    }


    private List<HealthyUserBO> getCustomerUserByIds(Set<String> ids){
        List<HealthyUserBO> data=new ArrayList<>();
        if(CollUtil.isEmpty(ids)){
            return data;
        }
        List<CustomerUserBO> list= customerUserClientService.getEntityBOListByIds(ids);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            HealthyUserBO user=HealthyThirdUserUtil.getHealthyUserBO(item);
            if(user!=null){
                data.add(user);
            }
        });
        return data;
    }

    private HealthyUserBO getAdminUserById(String id){
        AdminUserBO user=  adminUserClientService.getUserById(id);
        return HealthyThirdUserUtil.getHealthyUserBO(user);
    }


    private List<HealthyUserBO> getAdminUserByIds(Set<String> ids){
        List<HealthyUserBO> data=new ArrayList<>();
        if(CollUtil.isEmpty(ids)){
            return data;
        }
        List<AdminUserBO> list= adminUserClientService.getUserListByIds(ids);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            HealthyUserBO user=HealthyThirdUserUtil.getHealthyUserBO(item);
            if(user!=null){
                data.add(user);
            }
        });
        return data;
    }


    @Override
    public HealthyUserBO getById(String id) {
        if(StrUtil.isEmpty(id)){
            return null;
        }
        if(id.startsWith("E")){
            this.getAdminUserById(id);
        }else if(id.startsWith("C")){
            this.getCustomerUserById(id);
        }
        return null;
    }

    @Override
    public List<HealthyUserBO> getListByIds(Collection<String> ids) {
        List<HealthyUserBO> data=new ArrayList<>();
        if(CollUtil.isEmpty(ids)){
            return data;
        }
        Set<String> adminUserIds=new HashSet<>();
        Set<String> customerUserIds=new HashSet<>();
        ids.forEach(id->{
            if(id.startsWith("E")){
                adminUserIds.add(id);
            }else if(id.startsWith("C")){
                customerUserIds.add(id);
            }
        });

        List<HealthyUserBO> adminUserList= this.getAdminUserByIds(adminUserIds);
        List<HealthyUserBO> customerList= this.getCustomerUserByIds(customerUserIds);

        if(CollUtil.isNotEmpty(adminUserList)){
            adminUserList.forEach(item->{
                data.add(item);
            });
        }

        if(CollUtil.isNotEmpty(customerList)){
            customerList.forEach(item->{
                data.add(item);
            });
        }
        return data;
    }

    @Override
    public Map<String, HealthyUserBO> getMapByIds(Collection<String> ids) {
        Map<String, HealthyUserBO> data=new HashMap<>();
        if(CollUtil.isEmpty(ids)){
            return data;
        }
        List<HealthyUserBO> list=this.getListByIds(ids);
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.put(item.getId(),item);
            });
        }
        return data;
    }


}
